# include "ParUsage.h"
# include "yyParUsage.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"

# define yyInline
# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

/* line 42 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */

  typedef tSet *pSet;

  static UEMode = xxError; 
  #define IsLVExprList(EL) EL->ExprList.LV
  #define IsSimpEl(S) S->Element.SE
  #define IsParAssigned(E) E->ElementalExpr.PAR

  /*#define EXCLUDE_REPORTED_CONFLICTS*/
  /*{{{  static bool IsDisjoint (tSet *Set1,tSet *Set2)*/
  static bool IsDisjoint (tSet *Set1,tSet *Set2)
  {
     register tSet *   rSet1   = Set1;
     register cardinal i       = rSet1->LastBitset + 1;
     register BITSET * s1      = rSet1->BitsetPtr;
     register BITSET * s2      = Set2->BitsetPtr;
     do {
        if (* s1 ++ & * s2 ++) return false;
     } while (-- i);
     return true;
  }
  /*}}}*/

  /*{{{  static void AllowNoValAbbrev(tSymbol this, tSymbol scope, tPosition P, tTree E)*/
  static void AllowNoValAbbrev(tSymbol this, tSymbol scope, tPosition P, tTree E)
  {
    tTree EL = CreateElementList(E);
   
    while (scope!=this)
      if (CheckForValAbbrev(this,SymbolKind(scope),EL))
      {
        Message("Variable has been VAL abbreviated",UEMode,P);
        return;
      }
      else if (CheckForAbbrev(this,SymbolKind(scope),EL))
      {
        Message("Variable has been abbreviated",UEMode,P);
        return;
      }
      else
        scope = Symbol(scope).Scope;
  }
  /*}}}*/
  /*{{{  static void AllowNoAbbrev(tSymbol this, tSymbol scope, tPosition P, tTree E)*/
  static void AllowNoAbbrev(tSymbol this, tSymbol scope, tPosition P, tTree E)
  {
    tTree EL = CreateElementList(E);
  
    while (scope!=this)
      if (CheckForAbbrev(this,SymbolKind(scope),EL))
      {
        Message("Variable has been abbreviated",UEMode,P);
        return;
      }
      else
        scope = Symbol(scope).Scope;
  }
  /*}}}*/
  /*{{{  void AllowNoAbbrevInProc(tSymbol proc,tSymbol scope, tParUsage U, tPosition P)*/
  void AllowNoAbbrevInProc(tSymbol proc,tSymbol scope, tParUsage U, tPosition P)
  {
    while (scope!=proc)
    {
      if (CheckForValAbbrevInProc(SymbolKind(scope),U))
      {
         Message("Procedure assigns to variables which have since been VAL abbreviated",UEMode,P);
         return;
      } else if (CheckForAbbrevInProc(SymbolKind(scope),U))
      {
         Message("Procedure uses variables which have since been abbreviated",UEMode,P);
         return;
      }
      else
        scope = Symbol(scope).Scope;
    }
  }
  /*}}}*/

  /*{{{  static void RemoveLocalSymbols(pSet S, int Depth)*/
  static void RemoveLocalSymbols(pSet S, int Depth)
  {
    int i;
    for (i=Minimum(S);i<=Maximum(S);i++)
      if (IsElement(i,S))
        if (Symbol(i).Depth>Depth)
           Exclude(S,i); 
  }    
  /*}}}*/

  /*{{{  static void ReportUsages(tParUsage ALL, tParUsage U, tPosition P)*/
  static void ReportUsages(tParUsage ALL, tParUsage U, tPosition P)
  {
    int i;
    tSet D;
    MakeSet(&D,SymSize+1);
    Assign(&D,&ALL->W);
    Intersection(&D,&U->W);
    for (i=Minimum(&D);i<=Maximum(&D);i++)
      if (IsElement(i,&D)) 
      {
        MessageI("\tWrite/Write Conflict on ",xxInformation,P,xxIdent,(char*)&Symbol(i).Id);
        #ifdef EXCLUDE_REPORTED_CONFLICTS 
        Exclude(&ALL->W,i);  Exclude(&U->W,i);
        #else
        Exclude(&ALL->R,i);  Exclude(&U->R,i);
        #endif
      }
    Assign(&D,&ALL->R);
    Intersection(&D,&U->W);
    for (i=Minimum(&D);i<=Maximum(&D);i++)
      if (IsElement(i,&D))
      {
         MessageI("\tWrite/Read Conflict on ",xxInformation,P,xxIdent,(char*)&Symbol(i).Id);
         #ifdef EXCLUDE_REPORTED_CONFLICTS 
         Exclude(&ALL->R,i); Exclude(&U->W,i); 
         #endif
      }
    Assign(&D,&ALL->W);
    Intersection(&D,&U->R);
    for (i=Minimum(&D);i<=Maximum(&D);i++)
      if (IsElement(i,&D)) 
      {
        MessageI("\tRead/Write Conflict on ",xxInformation,P,xxIdent,(char*)&Symbol(i).Id);
        #ifdef EXCLUDE_REPORTED_CONFLICTS 
        Exclude(&ALL->W,i);  Exclude(&U->R,i);
        #endif
      }
    ReleaseSet(&D);
  }
  /*}}}*/
  /*{{{  static void ReportRepUsages(tParUsage U, tPosition P)*/
  static void ReportRepUsages(tParUsage U, tPosition P)
  {
    int i;
    tSet D;
    MakeSet(&D,SymSize+1);
    Assign(&D,&U->R);
    Intersection(&D,&U->W);
    for (i=Minimum(&D);i<=Maximum(&D);i++)
      if (IsElement(i,&D))
      {
        MessageI("\tWrite/Read Conflict on ",xxInformation,P,xxIdent,(char*)&Symbol(i).Id);
        #ifdef EXCLUDE_REPORTED_CONFLICTS 
        Exclude(&U->R,i); Exclude(&U->W,i); 
        #endif
      }
    ReleaseSet(&D);
    for (i=Minimum(&U->W);i<=Maximum(&U->W);i++)
      if (IsElement(i,&U->W)) 
      {
        MessageI("\tWrite/Write Conflict on ",xxInformation,P,xxIdent,(char*)&Symbol(i).Id);
        #ifdef EXCLUDE_REPORTED_CONFLICTS 
        Exclude(&U->W,i); 
        #endif
      }
  }
  /*}}}*/


static void yyExit () { Exit (1); }

void (* ParUsage_Exit) () = yyExit;

extern FILE *yyf;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module ParUsage, routine %s failed\n", yyFunction);
 ParUsage_Exit ();
}

tParUsage CreateUsage ARGS((tPosition yyP1));
bool AddWriteUsage ARGS((tParUsage yyP3, tTree yyP2));
static bool SetWriteUsage ARGS((tParUsage yyP6, tSymbol yyP5, tTree yyP4));
bool AddReadUsage ARGS((tParUsage yyP8, tTree yyP7));
static bool SetReadUsage ARGS((tParUsage yyP11, tSymbol yyP10, tTree yyP9));
void AddInstanceLValues ARGS((tTree yyP13, tTree yyP12));
void AddLValues ARGS((tTree yyP16, bool yyP15, bool yyP14));
static tSymbol GetElementSymbol ARGS((tTree yyP17));
static tPosition GetElementPosition ARGS((tTree yyP18));
static int GetElementScope ARGS((tTree yyP19));
tParUsage DeleteUsage ARGS((tParUsage yyP20));
tParUsage CombineUsage ARGS((tParUsage yyP23, tParUsage yyP22, int yyP21));
tParUsage CombineFuncUsage ARGS((tParUsage yyP25, tTree yyP24));
tParUsage CheckUsage ARGS((tParUsage yyP29, tParUsage yyP28, tPosition yyP27, int yyP26));
tParUsage CheckRepUsage ARGS((tParUsage yyP34, tParUsage yyP33, tTree yyP32, tPosition yyP31, int yyP30));
bool CheckSimpleExpr ARGS((tTree yyP35));
void SimplifyLinExpr ARGS((pLinExpr yyP38, tTree yyP37, int yyP36));
void RangeCheckLinExpr ARGS((tTree yyP42, pLinExpr yyP41, pLinExpr yyP40, tTree yyP39));
void SubscriptCheckLinExpr ARGS((tTree yyP45, pLinExpr yyP44, tTree yyP43));
static bool CheckUnconstrained ARGS((tTree yyP46));
static tTree InsertAccess ARGS((tTree yyP50, tSymbol yyP49, tTree yyP48, pSet yyP47, bool * yyP51));
tTree CreateElementList ARGS((tTree yyP52));
static tTree AlignElement ARGS((tTree yyP54, tTree yyP53));
static bool IsElementSubset ARGS((tTree yyP56, tTree yyP55));
static tTree InsertElement ARGS((tTree yyP58, tTree yyP57, bool * yyP59));
static tTree MergeAccess ARGS((tTree yyP63, tTree yyP62, pSet yyP61, int yyP60));
static tTree MergeAccess2 ARGS((tTree yyP67, tTree yyP66, pSet yyP65, int yyP64));
static tTree CopyElementList ARGS((tTree yyP68));
static tTree MergeElementList ARGS((tTree yyP70, tTree yyP69));
static void UsageCheckAccess ARGS((tTree yyP74, pSet yyP73, tTree yyP72, pSet yyP71));
static bool CheckElement ARGS((tTree yyP76, tTree yyP75));
static bool CheckEachElement ARGS((tTree yyP78, tTree yyP77));
static bool CheckElementVsElement ARGS((tTree yyP80, tTree yyP79));
static void UsageCheckRepWRAccess ARGS((tTree yyP86, pSet yyP85, tTree yyP84, pSet yyP83, int yyP82, tSymbol yyP81));
static bool CheckRepWRElementList ARGS((tTree yyP89, tTree yyP88, tSymbol yyP87));
static void UsageCheckRepAccess ARGS((tTree yyP93, pSet yyP92, int yyP91, tSymbol yyP90));
static bool CheckRepElementList ARGS((tTree yyP95, tSymbol yyP94));
static bool CheckRepEachElement ARGS((tTree yyP98, tTree yyP97, tSymbol yyP96));
static bool CheckRepElementVsElement ARGS((tTree yyP101, tTree yyP100, tSymbol yyP99));
bool CheckForValAbbrev ARGS((tSymbol yyP104, tTree yyP103, tTree yyP102));
bool CheckForAbbrev ARGS((tSymbol yyP107, tTree yyP106, tTree yyP105));
bool CheckForValAbbrevInProc ARGS((tTree yyP109, tParUsage yyP108));
bool CheckForAbbrevInProc ARGS((tTree yyP111, tParUsage yyP110));
static bool CheckAccessForSymbol ARGS((tTree yyP113, tSymbol yyP112));
static bool CheckAccessForAlias ARGS((tTree yyP117, pSet yyP116, tTree yyP115, pSet yyP114));
static bool CheckAccessVsElementList ARGS((tTree yyP120, tSymbol yyP119, tTree yyP118));
static bool IsChanType ARGS((tTree yyP121));

tParUsage CreateUsage
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP1)
# else
(yyP1)
 register tPosition yyP1;
# endif
{
/* line 225 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 tParUsage U=(tParUsage)malloc(sizeof(tParUsageStruct)); 
/* line 226 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 227 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
if (U==NULL) Message("Malloc failure during usage checking",xxFatal,yyP1); 
/* line 228 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   MakeSet (& U -> W, SymSize + 1);
/* line 229 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   MakeSet (& U -> R, SymSize + 1);
/* line 230 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   U -> WAL = mNoAccess ();
/* line 231 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   U -> RAL = mNoAccess ();
/* line 232 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   U -> Pos = yyP1;
  }
   return U;

}

bool AddWriteUsage
# if defined __STDC__ | defined __cplusplus
(tParUsage yyP3, register tTree yyP2)
# else
(yyP3, yyP2)
 tParUsage yyP3;
 register tTree yyP2;
# endif
{
  if (yyP3 == NULL) {
/* line 236 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  if (Tree_IsType (yyP2, kElement)) {
/* line 237 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return SetWriteUsage (yyP3, GetElementSymbol (yyP2), yyP2);

  }
/* line 238 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

}

static bool SetWriteUsage
# if defined __STDC__ | defined __cplusplus
(tParUsage yyP6, tSymbol yyP5, register tTree yyP4)
# else
(yyP6, yyP5, yyP4)
 tParUsage yyP6;
 tSymbol yyP5;
 register tTree yyP4;
# endif
{
/* line 241 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 241 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP4 -> Element . U == xxInput))) goto yyL1;
  {
/* line 241 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP5, & yyP6 -> W)))) goto yyL1;
  }
  }
   return false;
yyL1:;

/* line 242 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 242 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP4 -> Element . U == xxOutput))) goto yyL2;
  {
/* line 242 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (Symbol (yyP5) . Out, & yyP6 -> W)))) goto yyL2;
  }
  }
   return false;
yyL2:;

/* line 243 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  bool yyV1;
  {
/* line 243 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP4 -> Element . U == xxInput))) goto yyL3;
  {
/* line 243 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP6 -> WAL = InsertAccess (yyP6 -> WAL, yyP5, yyP4, & yyP6 -> W, & yyV1);
  }
  }
  {
   return yyV1;
  }
 }
yyL3:;

/* line 244 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  bool yyV1;
  {
/* line 244 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP4 -> Element . U == xxOutput))) goto yyL4;
  {
/* line 244 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP6 -> WAL = InsertAccess (yyP6 -> WAL, Symbol (yyP5) . Out, yyP4, & yyP6 -> W, & yyV1);
  }
  }
  {
   return yyV1;
  }
 }
yyL4:;

/* line 245 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 245 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsChanType (SymbolType (yyP5))))) goto yyL5;
  {
/* line 245 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP5, & yyP6 -> W)))) goto yyL5;
  {
/* line 245 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AllowNoValAbbrev (yyP5, GetElementScope (yyP4), GetElementPosition (yyP4), yyP4);
  }
  }
  }
   return false;
yyL5:;

/* line 246 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  bool yyV1;
  {
/* line 246 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsChanType (SymbolType (yyP5))))) goto yyL6;
  {
/* line 246 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP6 -> WAL = InsertAccess (yyP6 -> WAL, yyP5, yyP4, & yyP6 -> W, & yyV1);
/* line 246 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AllowNoValAbbrev (yyP5, GetElementScope (yyP4), GetElementPosition (yyP4), yyP4);
  }
  }
  {
   return yyV1;
  }
 }
yyL6:;

/* line 247 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

}

bool AddReadUsage
# if defined __STDC__ | defined __cplusplus
(tParUsage yyP8, register tTree yyP7)
# else
(yyP8, yyP7)
 tParUsage yyP8;
 register tTree yyP7;
# endif
{
  if (yyP8 == NULL) {
/* line 251 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  if (Tree_IsType (yyP7, kElement)) {
/* line 252 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return SetReadUsage (yyP8, GetElementSymbol (yyP7), yyP7);

  }
/* line 253 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

}

static bool SetReadUsage
# if defined __STDC__ | defined __cplusplus
(tParUsage yyP11, tSymbol yyP10, register tTree yyP9)
# else
(yyP11, yyP10, yyP9)
 tParUsage yyP11;
 tSymbol yyP10;
 register tTree yyP9;
# endif
{
/* line 256 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 256 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP9 -> Element . U == xxInput))) goto yyL1;
  {
/* line 256 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP10, & yyP11 -> R)))) goto yyL1;
  }
  }
   return false;
yyL1:;

/* line 257 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 257 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP9 -> Element . U == xxOutput))) goto yyL2;
  {
/* line 257 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (Symbol (yyP10) . Out, & yyP11 -> R)))) goto yyL2;
  }
  }
   return false;
yyL2:;

/* line 258 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  bool yyV1;
  {
/* line 258 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP9 -> Element . U == xxInput))) goto yyL3;
  {
/* line 258 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP11 -> RAL = InsertAccess (yyP11 -> RAL, yyP10, yyP9, & yyP11 -> R, & yyV1);
  }
  }
  {
   return yyV1;
  }
 }
yyL3:;

/* line 259 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  bool yyV1;
  {
/* line 259 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP9 -> Element . U == xxOutput))) goto yyL4;
  {
/* line 259 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP11 -> RAL = InsertAccess (yyP11 -> RAL, Symbol (yyP10) . Out, yyP9, & yyP11 -> R, & yyV1);
  }
  }
  {
   return yyV1;
  }
 }
yyL4:;

/* line 260 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 260 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsChanType (SymbolType (yyP10))))) goto yyL5;
  {
/* line 260 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP10, & yyP11 -> R)))) goto yyL5;
  {
/* line 260 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AllowNoAbbrev (yyP10, GetElementScope (yyP9), GetElementPosition (yyP9), yyP9);
  }
  }
  }
   return false;
yyL5:;

/* line 261 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  bool yyV1;
  {
/* line 261 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsChanType (SymbolType (yyP10))))) goto yyL6;
  {
/* line 261 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP11 -> RAL = InsertAccess (yyP11 -> RAL, yyP10, yyP9, & yyP11 -> R, & yyV1);
/* line 261 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AllowNoAbbrev (yyP10, GetElementScope (yyP9), GetElementPosition (yyP9), yyP9);
  }
  }
  {
   return yyV1;
  }
 }
yyL6:;

/* line 262 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

}

void AddInstanceLValues
# if defined __STDC__ | defined __cplusplus
(register tTree yyP13, register tTree yyP12)
# else
(yyP13, yyP12)
 register tTree yyP13;
 register tTree yyP12;
# endif
{
  if (yyP13->Kind == kNoFormal) {
  if (yyP12->Kind == kNoExpr) {
/* line 266 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 266 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsLVExprList (yyP12) = false;
  }
   return;

  }
  }
  if (yyP13->Kind == kAFormal) {
  if (yyP13->AFormal.By->Kind == kByRef) {
  if (yyP12->Kind == kAnExpr) {
  if (yyP12->AnExpr.Expr->Kind == kElementalExpr) {
/* line 267 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 267 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsLVExprList (yyP12) = true;
/* line 267 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsParAssigned (yyP12->AnExpr.Expr) = true;
/* line 267 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AddInstanceLValues (yyP13->AFormal.Next, yyP12->AnExpr.Next);
  }
   return;

  }
  }
  }
  if (yyP13->AFormal.By->Kind == kByVal) {
  if (yyP12->Kind == kAnExpr) {
/* line 268 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 268 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsLVExprList (yyP12) = false;
/* line 268 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AddInstanceLValues (yyP13->AFormal.Next, yyP12->AnExpr.Next);
  }
   return;

  }
  }
  }
;
}

void AddLValues
# if defined __STDC__ | defined __cplusplus
(register tTree yyP16, register bool yyP15, register bool yyP14)
# else
(yyP16, yyP15, yyP14)
 register tTree yyP16;
 register bool yyP15;
 register bool yyP14;
# endif
{
  if (yyP16->Kind == kNoExpr) {
/* line 272 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 272 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsLVExprList (yyP16) = yyP15;
  }
   return;

  }
  if (yyP16->Kind == kAnExpr) {
  if (yyP16->AnExpr.Expr->Kind == kElementalExpr) {
/* line 273 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 273 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsLVExprList (yyP16) = yyP15;
/* line 273 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsParAssigned (yyP16->AnExpr.Expr) = yyP14;
/* line 273 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AddLValues (yyP16->AnExpr.Next, yyP15, yyP14);
  }
   return;

  }
/* line 274 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 274 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsLVExprList (yyP16) = yyP15;
/* line 274 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AddLValues (yyP16->AnExpr.Next, yyP15, yyP14);
  }
   return;

  }
;
}

static tSymbol GetElementSymbol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP17)
# else
(yyP17)
 register tTree yyP17;
# endif
{
  if (yyP17->Kind == kIdentifier) {
/* line 278 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return yyP17->Identifier.Sym;

  }
  if (yyP17->Kind == kSubscript) {
/* line 279 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return GetElementSymbol (yyP17->Subscript.Next);

  }
  if (yyP17->Kind == kRange) {
/* line 280 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return GetElementSymbol (yyP17->Range.Next);

  }
 yyAbort ("GetElementSymbol");
}

static tPosition GetElementPosition
# if defined __STDC__ | defined __cplusplus
(register tTree yyP18)
# else
(yyP18)
 register tTree yyP18;
# endif
{
  if (yyP18->Kind == kIdentifier) {
/* line 285 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return yyP18->Identifier.Pos;

  }
  if (yyP18->Kind == kSubscript) {
/* line 286 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return GetElementPosition (yyP18->Subscript.Next);

  }
  if (yyP18->Kind == kRange) {
/* line 287 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return GetElementPosition (yyP18->Range.Next);

  }
 yyAbort ("GetElementPosition");
}

static int GetElementScope
# if defined __STDC__ | defined __cplusplus
(register tTree yyP19)
# else
(yyP19)
 register tTree yyP19;
# endif
{
  if (yyP19->Kind == kIdentifier) {
/* line 292 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return yyP19 -> Identifier . Scope;

  }
  if (yyP19->Kind == kSubscript) {
/* line 293 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return GetElementScope (yyP19->Subscript.Next);

  }
  if (yyP19->Kind == kRange) {
/* line 294 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return GetElementScope (yyP19->Range.Next);

  }
 yyAbort ("GetElementScope");
}

tParUsage DeleteUsage
# if defined __STDC__ | defined __cplusplus
(tParUsage yyP20)
# else
(yyP20)
 tParUsage yyP20;
# endif
{
/* line 300 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return NoParUsage;

}

tParUsage CombineUsage
# if defined __STDC__ | defined __cplusplus
(tParUsage yyP23, tParUsage yyP22, register int yyP21)
# else
(yyP23, yyP22, yyP21)
 tParUsage yyP23;
 tParUsage yyP22;
 register int yyP21;
# endif
{
/* line 304 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 304 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   RemoveLocalSymbols (& yyP22 -> W, yyP21);
/* line 304 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   RemoveLocalSymbols (& yyP22 -> R, yyP21);
/* line 305 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Union (& yyP23 -> W, & yyP22 -> W);
/* line 305 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Union (& yyP23 -> R, & yyP22 -> R);
/* line 306 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP23 -> WAL = MergeAccess (yyP23 -> WAL, yyP22 -> WAL, & yyP23 -> W, yyP21);
/* line 307 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP23 -> RAL = MergeAccess (yyP23 -> RAL, yyP22 -> RAL, & yyP23 -> R, yyP21);
  }
   return yyP23;

}

tParUsage CombineFuncUsage
# if defined __STDC__ | defined __cplusplus
(tParUsage yyP25, register tTree yyP24)
# else
(yyP25, yyP24)
 tParUsage yyP25;
 register tTree yyP24;
# endif
{
  if (yyP24->Kind == kDefFunc) {
/* line 311 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return CombineUsage (yyP25, yyP24->DefFunc.Valof->Valof.ExprList -> ExprList . PUOut, yyP24->DefFunc.Valof -> Valof . VS);

  }
  if (yyP24->Kind == kDefIsFunc) {
/* line 312 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return CombineUsage (yyP25, yyP24->DefIsFunc.ExprList -> ExprList . PUOut, Symbol (yyP24->DefIsFunc.Sym) . Depth);

  }
/* line 313 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return yyP25;

}

tParUsage CheckUsage
# if defined __STDC__ | defined __cplusplus
(tParUsage yyP29, tParUsage yyP28, register tPosition yyP27, register int yyP26)
# else
(yyP29, yyP28, yyP27, yyP26)
 tParUsage yyP29;
 tParUsage yyP28;
 register tPosition yyP27;
 register int yyP26;
# endif
{
/* line 319 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 320 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP29 -> RAL, & yyP29 -> R, yyP28 -> WAL, & yyP28 -> W);
/* line 321 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP29 -> WAL, & yyP29 -> W, yyP28 -> WAL, & yyP28 -> W);
/* line 322 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP29 -> WAL, & yyP29 -> W, yyP28 -> RAL, & yyP28 -> R);
/* line 323 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsDisjoint (& yyP29 -> R, & yyP28 -> W)))) goto yyL1;
  {
/* line 324 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsDisjoint (& yyP29 -> W, & yyP28 -> W)))) goto yyL1;
  {
/* line 325 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsDisjoint (& yyP29 -> W, & yyP28 -> R)))) goto yyL1;
  }
  }
  }
   return CombineUsage (yyP29, yyP28, yyP26);
yyL1:;

/* line 339 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 340 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Message ("Usage violation within this construct", UEMode, yyP27);
/* line 341 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   ReportUsages (yyP29, yyP28, yyP27);
  }
   return CombineUsage (yyP29, yyP28, yyP26);

}

tParUsage CheckRepUsage
# if defined __STDC__ | defined __cplusplus
(tParUsage yyP34, tParUsage yyP33, register tTree yyP32, register tPosition yyP31, register int yyP30)
# else
(yyP34, yyP33, yyP32, yyP31, yyP30)
 tParUsage yyP34;
 tParUsage yyP33;
 register tTree yyP32;
 register tPosition yyP31;
 register int yyP30;
# endif
{
/* line 345 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 345 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsConstInt (yyP32->Replicator.For) && ValConstInt (yyP32->Replicator.For) == 1))) goto yyL1;
  }
   return CombineUsage (yyP34, yyP33, yyP30);
yyL1:;

/* line 346 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 358 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepAccess (yyP33 -> WAL, & yyP33 -> W, yyP30, yyP32->Replicator.Sym);
/* line 359 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepWRAccess (yyP33 -> WAL, & yyP33 -> W, yyP33 -> RAL, & yyP33 -> R, yyP30, yyP32->Replicator.Sym);
/* line 360 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   RemoveLocalSymbols (& yyP33 -> W, yyP30);
/* line 360 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsEmpty (& yyP33 -> W)))) goto yyL2;
  }
   return CombineUsage (yyP34, yyP33, yyP30);
yyL2:;

/* line 361 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 362 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Message ("Parallel use violation within replicated PAR", UEMode, yyP31);
/* line 363 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   ReportRepUsages (yyP33, yyP31);
  }
   return CombineUsage (yyP34, yyP33, yyP30);

}

bool CheckSimpleExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP35)
# else
(yyP35)
 register tTree yyP35;
# endif
{
/* line 368 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 368 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsConstInt (yyP35)))) goto yyL1;
  }
   return true;
yyL1:;

  if (yyP35->Kind == kElementalExpr) {
  if (yyP35->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 369 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 370 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP35->ElementalExpr.Elemental->Identifier.Sym), kReplicator)))) goto yyL2;
  {
/* line 371 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (SymbolKind (yyP35->ElementalExpr.Elemental->Identifier.Sym) -> Replicator . From))) goto yyL2;
  {
/* line 372 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (SymbolKind (yyP35->ElementalExpr.Elemental->Identifier.Sym) -> Replicator . For))) goto yyL2;
  }
  }
  }
   return true;
yyL2:;

/* line 373 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 374 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP35->ElementalExpr.Elemental->Identifier.Sym), kVal)))) goto yyL3;
  {
/* line 375 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (SymbolKind (yyP35->ElementalExpr.Elemental->Identifier.Sym) -> Val . Expr))) goto yyL3;
  }
  }
   return true;
yyL3:;

  }
  }
  if (yyP35->Kind == kBinary) {
  if (yyP35->Binary.Op->Kind == kMultiply) {
/* line 376 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 376 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsConstInt (yyP35->Binary.Lop)))) goto yyL4;
  {
/* line 376 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (yyP35->Binary.Rop))) goto yyL4;
  }
  }
   return true;
yyL4:;

/* line 377 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 377 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsConstInt (yyP35->Binary.Rop)))) goto yyL5;
  {
/* line 377 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (yyP35->Binary.Lop))) goto yyL5;
  }
  }
   return true;
yyL5:;

  }
  if (yyP35->Binary.Op->Kind == kAdd) {
/* line 378 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 378 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (yyP35->Binary.Lop))) goto yyL6;
  {
/* line 378 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (yyP35->Binary.Rop))) goto yyL6;
  }
  }
   return true;
yyL6:;

  }
  if (yyP35->Binary.Op->Kind == kSubtract) {
/* line 379 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 379 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (yyP35->Binary.Lop))) goto yyL7;
  {
/* line 379 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (yyP35->Binary.Rop))) goto yyL7;
  }
  }
   return true;
yyL7:;

  }
  }
  if (yyP35->Kind == kUnary) {
  if (yyP35->Unary.Op->Kind == kAdd) {
/* line 380 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 380 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (yyP35->Unary.Expr))) goto yyL8;
  }
   return true;
yyL8:;

  }
  if (yyP35->Unary.Op->Kind == kSubtract) {
/* line 381 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 381 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckSimpleExpr (yyP35->Unary.Expr))) goto yyL9;
  }
   return true;
yyL9:;

  }
  }
  return false;
}

void SimplifyLinExpr
# if defined __STDC__ | defined __cplusplus
(pLinExpr yyP38, register tTree yyP37, register int yyP36)
# else
(yyP38, yyP37, yyP36)
 pLinExpr yyP38;
 register tTree yyP37;
 register int yyP36;
# endif
{
/* line 386 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 386 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsConstInt (yyP37)))) goto yyL1;
  {
/* line 386 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AddLinExprConst (yyP38, yyP36 * ValConstInt (yyP37));
  }
  }
   return;
yyL1:;

  if (yyP37->Kind == kElementalExpr) {
  if (yyP37->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 387 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 387 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP37->ElementalExpr.Elemental->Identifier.Sym), kReplicator)))) goto yyL2;
  {
/* line 387 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   AddLinExprCoef (yyP38, yyP37->ElementalExpr.Elemental->Identifier.Sym, yyP36);
  }
  }
   return;
yyL2:;

/* line 388 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 388 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP37->ElementalExpr.Elemental->Identifier.Sym), kVal)))) goto yyL3;
  {
/* line 388 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   SimplifyLinExpr (yyP38, SymbolKind (yyP37->ElementalExpr.Elemental->Identifier.Sym) -> Val . Expr, yyP36);
  }
  }
   return;
yyL3:;

  }
  }
  if (yyP37->Kind == kBinary) {
  if (yyP37->Binary.Op->Kind == kMultiply) {
/* line 389 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 389 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsConstInt (yyP37->Binary.Lop)))) goto yyL4;
  {
/* line 389 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   SimplifyLinExpr (yyP38, yyP37->Binary.Rop, yyP36 * ValConstInt (yyP37->Binary.Lop));
  }
  }
   return;
yyL4:;

/* line 390 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 390 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsConstInt (yyP37->Binary.Rop)))) goto yyL5;
  {
/* line 390 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   SimplifyLinExpr (yyP38, yyP37->Binary.Lop, yyP36 * ValConstInt (yyP37->Binary.Rop));
  }
  }
   return;
yyL5:;

  }
  if (yyP37->Binary.Op->Kind == kAdd) {
/* line 391 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 391 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   SimplifyLinExpr (yyP38, yyP37->Binary.Lop, yyP36);
/* line 391 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   SimplifyLinExpr (yyP38, yyP37->Binary.Rop, yyP36);
  }
   return;

  }
  if (yyP37->Binary.Op->Kind == kSubtract) {
/* line 392 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 392 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   SimplifyLinExpr (yyP38, yyP37->Binary.Lop, yyP36);
/* line 392 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   SimplifyLinExpr (yyP38, yyP37->Binary.Rop, - yyP36);
  }
   return;

  }
  }
  if (yyP37->Kind == kUnary) {
  if (yyP37->Unary.Op->Kind == kAdd) {
/* line 393 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 393 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   SimplifyLinExpr (yyP38, yyP37->Unary.Expr, yyP36);
  }
   return;

  }
  if (yyP37->Unary.Op->Kind == kSubtract) {
/* line 394 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 394 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   SimplifyLinExpr (yyP38, yyP37->Unary.Expr, - yyP36);
  }
   return;

  }
  }
;
}

void RangeCheckLinExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP42, pLinExpr yyP41, pLinExpr yyP40, register tTree yyP39)
# else
(yyP42, yyP41, yyP40, yyP39)
 register tTree yyP42;
 pLinExpr yyP41;
 pLinExpr yyP40;
 register tTree yyP39;
# endif
{
/* line 399 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 400 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */

      if (!yyP41->Const)
        {
          if (TestLinExpr_Const(yyP41,kLess,0))
             Message("Array slice start potentially out of range",xxWarning,yyP42->Elemental.Pos);
           else if (yyP39->Array.SE && TestLinExpr_LinExpr(yyP41,kGreaterEqual,yyP39->Array.LE))
             Message("Array slice start potentially out of range",xxWarning,yyP42->Elemental.Pos);
           else
             DoLwrBndChk(yyP42)=false;
        }
        if (!yyP41->Const || !yyP40->Const)
        {
          if (yyP39->Array.SE && TestLinExprPlusLinExpr_LinExpr(yyP41,yyP40,kGreater,yyP39->Array.LE))
            Message("Array slice end potentially out of range",xxWarning,yyP42->Elemental.Pos);
          else
            DoUprBndChk(yyP42)=false;
        }
    
  }
   return;

;
}

void SubscriptCheckLinExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP45, pLinExpr yyP44, register tTree yyP43)
# else
(yyP45, yyP44, yyP43)
 register tTree yyP45;
 pLinExpr yyP44;
 register tTree yyP43;
# endif
{
/* line 421 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 422 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */

    if (TestLinExpr_Const(yyP44,kLess,0))
        Message("Array subscript potentially out of range",xxWarning,yyP45->Elemental.Pos);
      else if (yyP43->Array.SE && TestLinExpr_LinExpr(yyP44,kGreaterEqual,yyP43->Array.LE))
        Message("Array subscript potentially out of range",xxWarning,yyP45->Elemental.Pos);
      else
        DoBndChk(yyP45)=false;
  
  }
   return;

;
}

static bool CheckUnconstrained
# if defined __STDC__ | defined __cplusplus
(register tTree yyP46)
# else
(yyP46)
 register tTree yyP46;
# endif
{
  if (yyP46->Kind == kIdentifier) {
/* line 434 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  if (yyP46->Kind == kRange) {
/* line 435 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 435 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsSimpEl (yyP46)))) goto yyL2;
  {
/* line 435 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckUnconstrained (yyP46->Range.Next))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  if (yyP46->Kind == kSubscript) {
/* line 436 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 436 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsSimpEl (yyP46)))) goto yyL3;
  {
/* line 436 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckUnconstrained (yyP46->Subscript.Next))) goto yyL3;
  }
  }
   return true;
yyL3:;

  }
  return false;
}

static tTree InsertAccess
# if defined __STDC__ | defined __cplusplus
(register tTree yyP50, tSymbol yyP49, register tTree yyP48, pSet yyP47, register bool * yyP51)
# else
(yyP50, yyP49, yyP48, yyP47, yyP51)
 register tTree yyP50;
 tSymbol yyP49;
 register tTree yyP48;
 pSet yyP47;
 register bool * yyP51;
# endif
{
  if (yyP50->Kind == kNoAccess) {
/* line 440 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 440 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((CheckUnconstrained (yyP48)))) goto yyL1;
  {
/* line 441 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP47, yyP49);
  }
  }
   * yyP51 = true;
   return yyP50;
yyL1:;

/* line 443 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
   * yyP51 = true;
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAnAccess)
    yyV1->AnAccess.Next = yyP50;
    yyV1->AnAccess.Sym = yyP49;
    yyV1->AnAccess.ElementList = CreateElementList (yyP48);
   return yyV1;
  }
 }

  }
  if (yyP50->Kind == kAnAccess) {
/* line 445 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  bool yyV1;
  {
/* line 445 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP49 > yyP50->AnAccess.Sym))) goto yyL3;
  {
/* line 446 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP50->AnAccess.Next = InsertAccess (yyP50->AnAccess.Next, yyP49, yyP48, yyP47, & yyV1);
  }
  }
   * yyP51 = yyV1;
  {
   return yyP50;
  }
 }
yyL3:;

/* line 448 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 448 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP49 < yyP50->AnAccess.Sym))) goto yyL4;
  {
/* line 448 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckUnconstrained (yyP48))) goto yyL4;
  {
/* line 449 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP47, yyP49);
  }
  }
  }
   * yyP51 = true;
   return yyP50->AnAccess.Next;
yyL4:;

/* line 451 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  {
/* line 451 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP49 < yyP50->AnAccess.Sym))) goto yyL5;
  }
   * yyP51 = true;
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAnAccess)
    yyV1->AnAccess.Next = yyP50;
    yyV1->AnAccess.Sym = yyP49;
    yyV1->AnAccess.ElementList = CreateElementList (yyP48);
   return yyV1;
  }
 }
yyL5:;

/* line 453 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 453 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP49 == yyP50->AnAccess.Sym))) goto yyL6;
  {
/* line 453 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckUnconstrained (yyP48))) goto yyL6;
  {
/* line 454 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP47, yyP49);
  }
  }
  }
   * yyP51 = false;
   return yyP50->AnAccess.Next;
yyL6:;

/* line 456 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  bool yyV1;
  {
/* line 456 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP49 == yyP50->AnAccess.Sym))) goto yyL7;
  {
/* line 457 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP50->AnAccess.ElementList = InsertElement (yyP50->AnAccess.ElementList, AlignElement (yyP48, ElementType (yyP48)), & yyV1);
  }
  }
   * yyP51 = yyV1;
  {
   return yyP50;
  }
 }
yyL7:;

  }
 yyAbort ("InsertAccess");
}

tTree CreateElementList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP52)
# else
(yyP52)
 register tTree yyP52;
# endif
{
  if (yyP52->Kind == kIdentifier) {
/* line 462 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoElement)
   return yyV1;
  }
 }

  }
/* line 463 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAnElement)
   {register tTree yyW1;
    yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyW1,kNoElement)
    yyV1->AnElement.Next = yyW1;
   }
    yyV1->AnElement.Element = AlignElement (yyP52, ElementType (yyP52));
   return yyV1;
  }
 }

}

static tTree AlignElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP54, register tTree yyP53)
# else
(yyP54, yyP53)
 register tTree yyP54;
 register tTree yyP53;
# endif
{
/* line 468 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 tTree S; 
  if (yyP54->Kind == kSubscript) {
  if (yyP53->Kind == kArray) {
/* line 469 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 469 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   S = mSubscript (yyP54->Subscript.Pos, AlignElement (yyP54, yyP53->Array.Type), mUnBound (yyP54->Subscript.Pos));
/* line 469 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsSimpEl (S) = false;
  }
   return S;

  }
  }
  if (yyP54->Kind == kRange) {
  if (yyP53->Kind == kArray) {
  if (yyP53->Array.Type->Kind == kArray) {
/* line 470 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 470 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   S = mSubscript (yyP54->Range.Pos, AlignElement (yyP54, yyP53->Array.Type), mUnBound (yyP54->Range.Pos));
/* line 470 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   IsSimpEl (S) = false;
  }
   return S;

  }
  }
  }
/* line 471 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return yyP54;

}

static bool IsElementSubset
# if defined __STDC__ | defined __cplusplus
(register tTree yyP56, register tTree yyP55)
# else
(yyP56, yyP55)
 register tTree yyP56;
 register tTree yyP55;
# endif
{
  if (yyP56->Kind == kIdentifier) {
  if (yyP55->Kind == kIdentifier) {
/* line 476 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
/* line 478 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 479 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Message ("Internal parallel usage error", xxError, yyP56->Identifier.Pos);
  }
   return true;

  }
  if (yyP55->Kind == kIdentifier) {
/* line 478 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 479 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Message ("Internal parallel usage error", xxError, yyP55->Identifier.Pos);
  }
   return true;

  }
  if (Tree_IsType (yyP56, kElementAccess)) {
  if (Tree_IsType (yyP55, kElementAccess)) {
/* line 481 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 481 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsSimpEl (yyP55)))) goto yyL4;
  }
   return IsElementSubset (yyP56->ElementAccess.Next, yyP55->ElementAccess.Next);
yyL4:;

  }
  }
/* line 483 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 483 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsSimpEl (yyP56)))) goto yyL5;
  }
   return false;
yyL5:;

  if (yyP56->Kind == kSubscript) {
  if (yyP55->Kind == kSubscript) {
/* line 485 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 486 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((SameLinExpr (yyP56 -> Subscript . LE, yyP55 -> Subscript . LE)))) goto yyL6;
  }
   return IsElementSubset (yyP56->Subscript.Next, yyP55->Subscript.Next);
yyL6:;

  }
  }
  if (yyP56->Kind == kRange) {
  if (yyP55->Kind == kRange) {
/* line 488 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 489 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((SameLinExpr (yyP56 -> Range . FromLE, yyP55 -> Range . FromLE)))) goto yyL7;
  {
/* line 490 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((SameLinExpr (yyP56 -> Range . ForLE, yyP55 -> Range . ForLE)))) goto yyL7;
  }
  }
   return IsElementSubset (yyP56->Range.Next, yyP55->Range.Next);
yyL7:;

  }
  }
/* line 492 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;

}

static tTree InsertElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP58, register tTree yyP57, register bool * yyP59)
# else
(yyP58, yyP57, yyP59)
 register tTree yyP58;
 register tTree yyP57;
 register bool * yyP59;
# endif
{
  if (yyP58->Kind == kNoElement) {
/* line 497 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
   * yyP59 = true;
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAnElement)
    yyV1->AnElement.Next = yyP58;
    yyV1->AnElement.Element = yyP57;
   return yyV1;
  }
 }

  }
  if (yyP58->Kind == kAnElement) {
/* line 499 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 499 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElementSubset (yyP57, yyP58->AnElement.Element)))) goto yyL2;
  }
   * yyP59 = false;
   return yyP58;
yyL2:;

/* line 501 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  bool yyV1;
  {
/* line 502 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP58->AnElement.Next = InsertElement (yyP58->AnElement.Next, yyP57, & yyV1);
  }
   * yyP59 = yyV1;
  {
   return yyP58;
  }
 }

  }
 yyAbort ("InsertElement");
}

static tTree MergeAccess
# if defined __STDC__ | defined __cplusplus
(register tTree yyP63, register tTree yyP62, pSet yyP61, register int yyP60)
# else
(yyP63, yyP62, yyP61, yyP60)
 register tTree yyP63;
 register tTree yyP62;
 pSet yyP61;
 register int yyP60;
# endif
{
  if (yyP63->Kind == kNoAccess) {
  if (yyP62->Kind == kNoAccess) {
/* line 508 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return yyP63;

  }
  if (yyP62->Kind == kAnAccess) {
/* line 512 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  {
/* line 512 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((Symbol (yyP62->AnAccess.Sym) . Depth <= yyP60))) goto yyL3;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAnAccess)
    yyV1->AnAccess.Next = MergeAccess (yyP63, yyP62->AnAccess.Next, yyP61, yyP60);
    yyV1->AnAccess.Sym = yyP62->AnAccess.Sym;
    yyV1->AnAccess.ElementList = CopyElementList (yyP62->AnAccess.ElementList);
   return yyV1;
  }
 }
yyL3:;

  }
  }
  if (yyP63->Kind == kAnAccess) {
  if (yyP62->Kind == kNoAccess) {
/* line 510 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return yyP63;

  }
  }
  if (yyP62->Kind == kAnAccess) {
/* line 514 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 514 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((Symbol (yyP62->AnAccess.Sym) . Depth > yyP60))) goto yyL4;
  }
   return yyP63;
yyL4:;

  }
/* line 516 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return MergeAccess2 (yyP63, yyP62, yyP61, yyP60);

}

static tTree MergeAccess2
# if defined __STDC__ | defined __cplusplus
(register tTree yyP67, register tTree yyP66, pSet yyP65, register int yyP64)
# else
(yyP67, yyP66, yyP65, yyP64)
 register tTree yyP67;
 register tTree yyP66;
 pSet yyP65;
 register int yyP64;
# endif
{
  if (yyP67->Kind == kAnAccess) {
/* line 520 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 520 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP67->AnAccess.Sym, yyP65)))) goto yyL1;
  }
   return MergeAccess (yyP67->AnAccess.Next, yyP66, yyP65, yyP64);
yyL1:;

  if (yyP66->Kind == kAnAccess) {
/* line 524 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 524 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP67->AnAccess.Sym < yyP66->AnAccess.Sym))) goto yyL3;
  {
/* line 525 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP67->AnAccess.Next = MergeAccess (yyP67->AnAccess.Next, yyP66, yyP65, yyP64);
  }
  }
   return yyP67;
yyL3:;

/* line 527 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  {
/* line 527 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP66->AnAccess.Sym < yyP67->AnAccess.Sym))) goto yyL4;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAnAccess)
    yyV1->AnAccess.Next = MergeAccess (yyP67, yyP66->AnAccess.Next, yyP65, yyP64);
    yyV1->AnAccess.Sym = yyP66->AnAccess.Sym;
    yyV1->AnAccess.ElementList = yyP66->AnAccess.ElementList;
   return yyV1;
  }
 }
yyL4:;

/* line 529 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 529 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP66->AnAccess.Sym == yyP67->AnAccess.Sym))) goto yyL5;
  {
/* line 529 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   yyP67->AnAccess.ElementList = MergeElementList (yyP67->AnAccess.ElementList, yyP66->AnAccess.ElementList);
  }
  }
   return yyP67;
yyL5:;

  }
  }
  if (yyP66->Kind == kAnAccess) {
/* line 522 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 522 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP66->AnAccess.Sym, yyP65)))) goto yyL2;
  }
   return MergeAccess (yyP67, yyP66->AnAccess.Next, yyP65, yyP64);
yyL2:;

  }
 yyAbort ("MergeAccess2");
}

static tTree CopyElementList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP68)
# else
(yyP68)
 register tTree yyP68;
# endif
{
  if (yyP68->Kind == kNoElement) {
/* line 534 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoElement)
   return yyV1;
  }
 }

  }
  if (yyP68->Kind == kAnElement) {
/* line 535 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAnElement)
    yyV1->AnElement.Next = CopyElementList (yyP68->AnElement.Next);
    yyV1->AnElement.Element = yyP68->AnElement.Element;
   return yyV1;
  }
 }

  }
 yyAbort ("CopyElementList");
}

static tTree MergeElementList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP70, register tTree yyP69)
# else
(yyP70, yyP69)
 register tTree yyP70;
 register tTree yyP69;
# endif
{
  if (yyP69->Kind == kNoElement) {
/* line 539 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return yyP70;

  }
  if (yyP69->Kind == kAnElement) {
/* line 540 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
 {
  {
  bool yyV1;
   return MergeElementList (InsertElement (yyP70, yyP69->AnElement.Element, & yyV1), yyP69->AnElement.Next);
  }
 }

  }
 yyAbort ("MergeElementList");
}

static void UsageCheckAccess
# if defined __STDC__ | defined __cplusplus
(register tTree yyP74, pSet yyP73, register tTree yyP72, pSet yyP71)
# else
(yyP74, yyP73, yyP72, yyP71)
 register tTree yyP74;
 pSet yyP73;
 register tTree yyP72;
 pSet yyP71;
# endif
{
  if (yyP74->Kind == kNoAccess) {
  if (yyP72->Kind == kNoAccess) {
/* line 545 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return;

  }
  if (yyP72->Kind == kAnAccess) {
/* line 554 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 554 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsElement (yyP72->AnAccess.Sym, yyP73)))) goto yyL4;
  {
/* line 555 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74, yyP73, yyP72->AnAccess.Next, yyP71);
  }
  }
   return;
yyL4:;

/* line 557 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 558 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP71, yyP72->AnAccess.Sym);
/* line 559 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74, yyP73, yyP72->AnAccess.Next, yyP71);
  }
   return;

  }
  }
  if (yyP74->Kind == kAnAccess) {
  if (yyP72->Kind == kNoAccess) {
/* line 547 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 547 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsElement (yyP74->AnAccess.Sym, yyP71)))) goto yyL2;
  {
/* line 548 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74->AnAccess.Next, yyP73, yyP72, yyP71);
  }
  }
   return;
yyL2:;

/* line 550 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 551 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP73, yyP74->AnAccess.Sym);
/* line 552 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74->AnAccess.Next, yyP73, yyP72, yyP71);
  }
   return;

  }
  if (yyP72->Kind == kAnAccess) {
/* line 561 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 561 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP74->AnAccess.Sym < yyP72->AnAccess.Sym))) goto yyL6;
  {
/* line 561 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsElement (yyP74->AnAccess.Sym, yyP71)))) goto yyL6;
  {
/* line 562 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74->AnAccess.Next, yyP73, yyP72, yyP71);
  }
  }
  }
   return;
yyL6:;

/* line 564 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 564 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP74->AnAccess.Sym < yyP72->AnAccess.Sym))) goto yyL7;
  {
/* line 565 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP73, yyP74->AnAccess.Sym);
/* line 566 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74->AnAccess.Next, yyP73, yyP72, yyP71);
  }
  }
   return;
yyL7:;

/* line 568 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 568 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP74->AnAccess.Sym > yyP72->AnAccess.Sym))) goto yyL8;
  {
/* line 568 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsElement (yyP72->AnAccess.Sym, yyP73)))) goto yyL8;
  {
/* line 569 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74, yyP73, yyP72->AnAccess.Next, yyP71);
  }
  }
  }
   return;
yyL8:;

/* line 571 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 571 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP74->AnAccess.Sym > yyP72->AnAccess.Sym))) goto yyL9;
  {
/* line 572 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP71, yyP72->AnAccess.Sym);
/* line 573 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74, yyP73, yyP72->AnAccess.Next, yyP71);
  }
  }
   return;
yyL9:;

/* line 575 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 575 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP74->AnAccess.Sym == yyP72->AnAccess.Sym))) goto yyL10;
  {
/* line 576 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckElement (yyP74->AnAccess.ElementList, yyP72->AnAccess.ElementList))) goto yyL10;
  {
/* line 577 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74->AnAccess.Next, yyP73, yyP72->AnAccess.Next, yyP71);
  }
  }
  }
   return;
yyL10:;

/* line 579 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 579 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP74->AnAccess.Sym == yyP72->AnAccess.Sym))) goto yyL11;
  {
/* line 580 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP73, yyP74->AnAccess.Sym);
/* line 581 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP71, yyP72->AnAccess.Sym);
/* line 582 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckAccess (yyP74->AnAccess.Next, yyP73, yyP72->AnAccess.Next, yyP71);
  }
  }
   return;
yyL11:;

  }
  }
;
}

static bool CheckElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP76, register tTree yyP75)
# else
(yyP76, yyP75)
 register tTree yyP76;
 register tTree yyP75;
# endif
{
  if (yyP76->Kind == kNoElement) {
/* line 592 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  if (yyP76->Kind == kAnElement) {
/* line 594 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 594 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckEachElement (yyP76->AnElement.Element, yyP75))) goto yyL2;
  {
/* line 594 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckElement (yyP76->AnElement.Next, yyP75))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  return false;
}

static bool CheckEachElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP78, register tTree yyP77)
# else
(yyP78, yyP77)
 register tTree yyP78;
 register tTree yyP77;
# endif
{
  if (yyP77->Kind == kNoElement) {
/* line 602 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  if (yyP77->Kind == kAnElement) {
/* line 604 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 605 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckElementVsElement (yyP78, yyP77->AnElement.Element))) goto yyL2;
  {
/* line 606 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckEachElement (yyP78, yyP77->AnElement.Next))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  return false;
}

static bool CheckElementVsElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP80, register tTree yyP79)
# else
(yyP80, yyP79)
 register tTree yyP80;
 register tTree yyP79;
# endif
{
  if (yyP80->Kind == kIdentifier) {
  if (yyP79->Kind == kIdentifier) {
/* line 614 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;

  }
/* line 616 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 617 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Message ("Internal parallel usage error", xxError, yyP80->Identifier.Pos);
  }
   return false;

  }
  if (yyP79->Kind == kIdentifier) {
/* line 616 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 617 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Message ("Internal parallel usage error", xxError, yyP79->Identifier.Pos);
  }
   return false;

  }
  if (Tree_IsType (yyP80, kElementAccess)) {
  if (Tree_IsType (yyP79, kElementAccess)) {
/* line 619 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 619 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsSimpEl (yyP80)))) goto yyL4;
  }
   return CheckElementVsElement (yyP80->ElementAccess.Next, yyP79->ElementAccess.Next);
yyL4:;

/* line 621 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 621 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsSimpEl (yyP79)))) goto yyL5;
  }
   return CheckElementVsElement (yyP80->ElementAccess.Next, yyP79->ElementAccess.Next);
yyL5:;

  }
  }
  if (yyP80->Kind == kSubscript) {
  if (yyP79->Kind == kSubscript) {
/* line 623 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 623 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! TestLinExpr_LinExpr (yyP80 -> Subscript . LE, kEqual, yyP79 -> Subscript . LE)))) goto yyL6;
  }
   return true;
yyL6:;

  }
  if (yyP79->Kind == kRange) {
/* line 627 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 627 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! TestLinExprInRange (yyP80 -> Subscript . LE, yyP79 -> Range . FromLE, yyP79 -> Range . ForLE)))) goto yyL8;
  }
   return true;
yyL8:;

  }
  }
  if (yyP80->Kind == kRange) {
  if (yyP79->Kind == kSubscript) {
/* line 625 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 625 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! TestLinExprInRange (yyP79 -> Subscript . LE, yyP80 -> Range . FromLE, yyP80 -> Range . ForLE)))) goto yyL7;
  }
   return true;
yyL7:;

  }
  if (yyP79->Kind == kRange) {
/* line 629 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 629 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((TestLinExprPlusLinExpr_LinExpr (yyP80 -> Range . FromLE, yyP80 -> Range . ForLE, kLessEqual, yyP79 -> Range . FromLE)))) goto yyL9;
  }
   return true;
yyL9:;

/* line 631 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 631 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((TestLinExprPlusLinExpr_LinExpr (yyP79 -> Range . FromLE, yyP79 -> Range . ForLE, kLessEqual, yyP80 -> Range . FromLE)))) goto yyL10;
  }
   return true;
yyL10:;

  }
  }
  if (Tree_IsType (yyP80, kElementAccess)) {
  if (Tree_IsType (yyP79, kElementAccess)) {
/* line 633 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return CheckElementVsElement (yyP80->ElementAccess.Next, yyP79->ElementAccess.Next);

  }
  }
 yyAbort ("CheckElementVsElement");
}

static void UsageCheckRepWRAccess
# if defined __STDC__ | defined __cplusplus
(register tTree yyP86, pSet yyP85, register tTree yyP84, pSet yyP83, register int yyP82, tSymbol yyP81)
# else
(yyP86, yyP85, yyP84, yyP83, yyP82, yyP81)
 register tTree yyP86;
 pSet yyP85;
 register tTree yyP84;
 pSet yyP83;
 register int yyP82;
 tSymbol yyP81;
# endif
{
  if (yyP86->Kind == kNoAccess) {
/* line 639 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return;

  }
  if (yyP86->Kind == kAnAccess) {
/* line 641 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 641 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((Symbol (yyP86->AnAccess.Sym) . Depth > yyP82))) goto yyL2;
  }
   return;
yyL2:;

  if (yyP84->Kind == kNoAccess) {
/* line 643 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 643 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsElement (yyP86->AnAccess.Sym, yyP83)))) goto yyL3;
  {
/* line 644 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepWRAccess (yyP86->AnAccess.Next, yyP85, yyP84, yyP83, yyP82, yyP81);
  }
  }
   return;
yyL3:;

/* line 646 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 646 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP85, yyP86->AnAccess.Sym);
/* line 647 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepWRAccess (yyP86->AnAccess.Next, yyP85, yyP84, yyP83, yyP82, yyP81);
  }
   return;

  }
  if (yyP84->Kind == kAnAccess) {
/* line 649 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 649 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP86->AnAccess.Sym < yyP84->AnAccess.Sym))) goto yyL5;
  {
/* line 649 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsElement (yyP86->AnAccess.Sym, yyP83)))) goto yyL5;
  {
/* line 650 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepWRAccess (yyP86->AnAccess.Next, yyP85, yyP84, yyP83, yyP82, yyP81);
  }
  }
  }
   return;
yyL5:;

/* line 652 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 652 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP86->AnAccess.Sym < yyP84->AnAccess.Sym))) goto yyL6;
  {
/* line 653 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP85, yyP86->AnAccess.Sym);
/* line 654 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepWRAccess (yyP86->AnAccess.Next, yyP85, yyP84, yyP83, yyP82, yyP81);
  }
  }
   return;
yyL6:;

/* line 656 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 656 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP86->AnAccess.Sym > yyP84->AnAccess.Sym))) goto yyL7;
  {
/* line 656 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsElement (yyP86->AnAccess.Sym, yyP83)))) goto yyL7;
  {
/* line 657 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepWRAccess (yyP86, yyP85, yyP84->AnAccess.Next, yyP83, yyP82, yyP81);
  }
  }
  }
   return;
yyL7:;

/* line 659 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 659 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP86->AnAccess.Sym > yyP84->AnAccess.Sym))) goto yyL8;
  {
/* line 660 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP85, yyP86->AnAccess.Sym);
/* line 661 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepWRAccess (yyP86, yyP85, yyP84->AnAccess.Next, yyP83, yyP82, yyP81);
  }
  }
   return;
yyL8:;

/* line 663 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 663 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP86->AnAccess.Sym == yyP84->AnAccess.Sym))) goto yyL9;
  {
/* line 664 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckRepWRElementList (yyP86->AnAccess.ElementList, yyP84->AnAccess.ElementList, yyP81))) goto yyL9;
  {
/* line 665 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepWRAccess (yyP86->AnAccess.Next, yyP85, yyP84->AnAccess.Next, yyP83, yyP82, yyP81);
  }
  }
  }
   return;
yyL9:;

/* line 667 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 667 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP86->AnAccess.Sym == yyP84->AnAccess.Sym))) goto yyL10;
  {
/* line 668 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP85, yyP86->AnAccess.Sym);
/* line 669 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP83, yyP84->AnAccess.Sym);
/* line 670 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepWRAccess (yyP86->AnAccess.Next, yyP85, yyP84->AnAccess.Next, yyP83, yyP82, yyP81);
  }
  }
   return;
yyL10:;

  }
  }
;
}

static bool CheckRepWRElementList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP89, register tTree yyP88, tSymbol yyP87)
# else
(yyP89, yyP88, yyP87)
 register tTree yyP89;
 register tTree yyP88;
 tSymbol yyP87;
# endif
{
  if (yyP89->Kind == kAnElement) {
/* line 678 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 679 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckRepWRElementList (yyP89->AnElement.Next, yyP88, yyP87))) goto yyL1;
  {
/* line 680 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckRepEachElement (yyP89->AnElement.Element, yyP88, yyP87))) goto yyL1;
  }
  }
   return true;
yyL1:;

  }
  if (yyP89->Kind == kNoElement) {
/* line 682 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  return false;
}

static void UsageCheckRepAccess
# if defined __STDC__ | defined __cplusplus
(register tTree yyP93, pSet yyP92, register int yyP91, tSymbol yyP90)
# else
(yyP93, yyP92, yyP91, yyP90)
 register tTree yyP93;
 pSet yyP92;
 register int yyP91;
 tSymbol yyP90;
# endif
{
  if (yyP93->Kind == kNoAccess) {
/* line 687 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return;

  }
  if (yyP93->Kind == kAnAccess) {
/* line 688 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 688 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((Symbol (yyP93->AnAccess.Sym) . Depth <= yyP91))) goto yyL2;
  {
/* line 688 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckRepElementList (yyP93->AnAccess.ElementList, yyP90))) goto yyL2;
  {
/* line 688 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepAccess (yyP93->AnAccess.Next, yyP92, yyP91, yyP90);
  }
  }
  }
   return;
yyL2:;

/* line 689 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 689 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((Symbol (yyP93->AnAccess.Sym) . Depth <= yyP91))) goto yyL3;
  {
/* line 689 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Include (yyP92, yyP93->AnAccess.Sym);
/* line 689 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   UsageCheckRepAccess (yyP93->AnAccess.Next, yyP92, yyP91, yyP90);
  }
  }
   return;
yyL3:;

/* line 690 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return;

  }
;
}

static bool CheckRepElementList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP95, tSymbol yyP94)
# else
(yyP95, yyP94)
 register tTree yyP95;
 tSymbol yyP94;
# endif
{
  if (yyP95->Kind == kAnElement) {
/* line 695 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 696 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckRepElementList (yyP95->AnElement.Next, yyP94))) goto yyL1;
  {
/* line 697 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckRepEachElement (yyP95->AnElement.Element, yyP95, yyP94))) goto yyL1;
  }
  }
   return true;
yyL1:;

  }
  if (yyP95->Kind == kNoElement) {
/* line 699 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  return false;
}

static bool CheckRepEachElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP98, register tTree yyP97, tSymbol yyP96)
# else
(yyP98, yyP97, yyP96)
 register tTree yyP98;
 register tTree yyP97;
 tSymbol yyP96;
# endif
{
  if (yyP97->Kind == kNoElement) {
/* line 703 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  if (yyP97->Kind == kAnElement) {
/* line 704 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 705 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckRepElementVsElement (yyP98, yyP97->AnElement.Element, yyP96))) goto yyL2;
  {
/* line 706 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckRepEachElement (yyP98, yyP97->AnElement.Next, yyP96))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  return false;
}

static bool CheckRepElementVsElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP101, register tTree yyP100, tSymbol yyP99)
# else
(yyP101, yyP100, yyP99)
 register tTree yyP101;
 register tTree yyP100;
 tSymbol yyP99;
# endif
{
  if (yyP101->Kind == kIdentifier) {
  if (yyP100->Kind == kIdentifier) {
/* line 711 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;

  }
/* line 713 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 714 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Message ("Internal parallel usage error", xxError, yyP101->Identifier.Pos);
  }
   return false;

  }
  if (yyP100->Kind == kIdentifier) {
/* line 713 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 714 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   Message ("Internal parallel usage error", xxError, yyP100->Identifier.Pos);
  }
   return false;

  }
  if (Tree_IsType (yyP101, kElementAccess)) {
  if (Tree_IsType (yyP100, kElementAccess)) {
/* line 716 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 717 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsSimpEl (yyP101)))) goto yyL4;
  }
   return CheckRepElementVsElement (yyP101->ElementAccess.Next, yyP100->ElementAccess.Next, yyP99);
yyL4:;

/* line 719 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 720 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsSimpEl (yyP100)))) goto yyL5;
  }
   return CheckRepElementVsElement (yyP101->ElementAccess.Next, yyP100->ElementAccess.Next, yyP99);
yyL5:;

  }
  }
  if (yyP101->Kind == kSubscript) {
  if (yyP100->Kind == kSubscript) {
/* line 722 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 723 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((TestLinExprsDistinctWrtRep (yyP101 -> Subscript . LE, yyP100 -> Subscript . LE, yyP99)))) goto yyL6;
  }
   return true;
yyL6:;

  }
  if (yyP100->Kind == kRange) {
/* line 728 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 729 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((TestLinExprsDistinctWrtRepOverRange (yyP101 -> Subscript . LE, yyP100 -> Range . FromLE, yyP99, NULL, yyP100 -> Range . ForLE)))) goto yyL8;
  }
   return true;
yyL8:;

  }
  }
  if (yyP101->Kind == kRange) {
  if (yyP100->Kind == kSubscript) {
/* line 725 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 726 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((TestLinExprsDistinctWrtRepOverRange (yyP100 -> Subscript . LE, yyP101 -> Range . FromLE, yyP99, NULL, yyP101 -> Range . ForLE)))) goto yyL7;
  }
   return true;
yyL7:;

  }
  if (yyP100->Kind == kRange) {
/* line 731 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 732 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((TestLinExprsDistinctWrtRepOverRange (yyP101 -> Range . FromLE, yyP100 -> Range . FromLE, yyP99, yyP101 -> Range . ForLE, yyP100 -> Range . ForLE)))) goto yyL9;
  }
   return true;
yyL9:;

  }
  }
  if (Tree_IsType (yyP101, kElementAccess)) {
  if (Tree_IsType (yyP100, kElementAccess)) {
/* line 734 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return CheckRepElementVsElement (yyP101->ElementAccess.Next, yyP100->ElementAccess.Next, yyP99);

  }
  }
 yyAbort ("CheckRepElementVsElement");
}

bool CheckForValAbbrev
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP104, register tTree yyP103, register tTree yyP102)
# else
(yyP104, yyP103, yyP102)
 tSymbol yyP104;
 register tTree yyP103;
 register tTree yyP102;
# endif
{
  if (yyP103 == NULL) {
/* line 740 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;

  }
  if (Tree_IsType (yyP103, kAVal)) {
/* line 742 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 743 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP104, & yyP103->AVal.Expr -> Expr . PUOut -> R)))) goto yyL2;
  }
   return true;
yyL2:;

  if (yyP102->Kind == kNoElement) {
/* line 745 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return CheckAccessForSymbol (yyP103->AVal.Expr -> Expr . PUOut -> RAL, yyP104);

  }
/* line 747 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 748 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! CheckAccessVsElementList (yyP103->AVal.Expr -> Expr . PUOut -> RAL, yyP104, yyP102)))) goto yyL4;
  }
   return true;
yyL4:;

  }
/* line 750 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;

}

bool CheckForAbbrev
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP107, register tTree yyP106, register tTree yyP105)
# else
(yyP107, yyP106, yyP105)
 tSymbol yyP107;
 register tTree yyP106;
 register tTree yyP105;
# endif
{
  if (yyP106 == NULL) {
/* line 755 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;

  }
  if (yyP106->Kind == kIs) {
/* line 757 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 758 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP107, & yyP106->Is.Elemental -> Element . PUOut -> W)))) goto yyL2;
  }
   return true;
yyL2:;

  if (yyP105->Kind == kNoElement) {
/* line 760 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return CheckAccessForSymbol (yyP106->Is.Elemental -> Element . PUOut -> WAL, yyP107);

  }
/* line 762 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 763 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! CheckAccessVsElementList (yyP106->Is.Elemental -> Element . PUOut -> WAL, yyP107, yyP105)))) goto yyL6;
  }
   return true;
yyL6:;

  }
  if (yyP106->Kind == kRetypes) {
/* line 757 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 758 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP107, & yyP106->Retypes.Elemental -> Element . PUOut -> W)))) goto yyL3;
  }
   return true;
yyL3:;

  if (yyP105->Kind == kNoElement) {
/* line 760 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return CheckAccessForSymbol (yyP106->Retypes.Elemental -> Element . PUOut -> WAL, yyP107);

  }
/* line 762 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 763 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! CheckAccessVsElementList (yyP106->Retypes.Elemental -> Element . PUOut -> WAL, yyP107, yyP105)))) goto yyL7;
  }
   return true;
yyL7:;

  }
/* line 765 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;

}

bool CheckForValAbbrevInProc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP109, tParUsage yyP108)
# else
(yyP109, yyP108)
 register tTree yyP109;
 tParUsage yyP108;
# endif
{
  if (yyP109 == NULL) {
/* line 770 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 770 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;
  }

  }
  if (yyP108 == NULL) {
/* line 771 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 771 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;
  }

  }
  if (Tree_IsType (yyP109, kAVal)) {
/* line 772 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 773 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsDisjoint (& yyP109->AVal.Expr -> Expr . PUOut -> R, & yyP108 -> W)))) goto yyL3;
  }
   return true;
yyL3:;

/* line 775 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 776 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((CheckAccessForAlias (yyP109->AVal.Expr -> Expr . PUOut -> RAL, & yyP109->AVal.Expr -> Expr . PUOut -> R, yyP108 -> WAL, & yyP108 -> W)))) goto yyL4;
  }
   return true;
yyL4:;

  }
  return false;
}

bool CheckForAbbrevInProc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP111, tParUsage yyP110)
# else
(yyP111, yyP110)
 register tTree yyP111;
 tParUsage yyP110;
# endif
{
  if (yyP110 == NULL) {
/* line 781 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 782 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;
  }

  }
  if (yyP111 == NULL) {
/* line 781 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 782 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return false;
  }

  }
  if (yyP111->Kind == kIs) {
/* line 784 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 785 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsDisjoint (& yyP111->Is.Elemental -> Element . PUOut -> W, & yyP110 -> W)))) goto yyL3;
  }
   return true;
yyL3:;

/* line 787 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 788 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsDisjoint (& yyP111->Is.Elemental -> Element . PUOut -> W, & yyP110 -> R)))) goto yyL5;
  }
   return true;
yyL5:;

/* line 790 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 791 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((CheckAccessForAlias (yyP111->Is.Elemental -> Element . PUOut -> WAL, & yyP111->Is.Elemental -> Element . PUOut -> W, yyP110 -> WAL, & yyP110 -> W)))) goto yyL7;
  }
   return true;
yyL7:;

/* line 793 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 794 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((CheckAccessForAlias (yyP111->Is.Elemental -> Element . PUOut -> WAL, & yyP111->Is.Elemental -> Element . PUOut -> W, yyP110 -> RAL, & yyP110 -> R)))) goto yyL9;
  }
   return true;
yyL9:;

  }
  if (yyP111->Kind == kRetypes) {
/* line 784 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 785 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsDisjoint (& yyP111->Retypes.Elemental -> Element . PUOut -> W, & yyP110 -> W)))) goto yyL4;
  }
   return true;
yyL4:;

/* line 787 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 788 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! IsDisjoint (& yyP111->Retypes.Elemental -> Element . PUOut -> W, & yyP110 -> R)))) goto yyL6;
  }
   return true;
yyL6:;

/* line 790 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 791 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((CheckAccessForAlias (yyP111->Retypes.Elemental -> Element . PUOut -> WAL, & yyP111->Retypes.Elemental -> Element . PUOut -> W, yyP110 -> WAL, & yyP110 -> W)))) goto yyL8;
  }
   return true;
yyL8:;

/* line 793 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 794 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((CheckAccessForAlias (yyP111->Retypes.Elemental -> Element . PUOut -> WAL, & yyP111->Retypes.Elemental -> Element . PUOut -> W, yyP110 -> RAL, & yyP110 -> R)))) goto yyL10;
  }
   return true;
yyL10:;

  }
  return false;
}

static bool CheckAccessForSymbol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP113, tSymbol yyP112)
# else
(yyP113, yyP112)
 register tTree yyP113;
 tSymbol yyP112;
# endif
{
  if (yyP113->Kind == kAnAccess) {
/* line 799 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 800 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP113->AnAccess.Sym < yyP112))) goto yyL1;
  {
/* line 801 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckAccessForSymbol (yyP113->AnAccess.Next, yyP112))) goto yyL1;
  }
  }
   return true;
yyL1:;

/* line 803 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 804 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP113->AnAccess.Sym == yyP112))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

static bool CheckAccessForAlias
# if defined __STDC__ | defined __cplusplus
(register tTree yyP117, pSet yyP116, register tTree yyP115, pSet yyP114)
# else
(yyP117, yyP116, yyP115, yyP114)
 register tTree yyP117;
 pSet yyP116;
 register tTree yyP115;
 pSet yyP114;
# endif
{
  if (yyP117->Kind == kAnAccess) {
  if (yyP115->Kind == kNoAccess) {
/* line 809 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 810 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP117->AnAccess.Sym, yyP114)))) goto yyL1;
  }
   return true;
yyL1:;

/* line 812 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 813 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckAccessForAlias (yyP117->AnAccess.Next, yyP116, yyP115, yyP114))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (yyP115->Kind == kAnAccess) {
/* line 821 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 822 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP117->AnAccess.Sym < yyP115->AnAccess.Sym))) goto yyL5;
  {
/* line 823 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP117->AnAccess.Sym, yyP114)))) goto yyL5;
  }
  }
   return true;
yyL5:;

/* line 825 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 826 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP117->AnAccess.Sym < yyP115->AnAccess.Sym))) goto yyL6;
  {
/* line 827 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckAccessForAlias (yyP117->AnAccess.Next, yyP116, yyP115, yyP114))) goto yyL6;
  }
  }
   return true;
yyL6:;

/* line 829 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 830 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP117->AnAccess.Sym > yyP115->AnAccess.Sym))) goto yyL7;
  {
/* line 831 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP115->AnAccess.Sym, yyP116)))) goto yyL7;
  }
  }
   return true;
yyL7:;

/* line 833 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 834 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP117->AnAccess.Sym > yyP115->AnAccess.Sym))) goto yyL8;
  {
/* line 835 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckAccessForAlias (yyP117, yyP116, yyP115->AnAccess.Next, yyP114))) goto yyL8;
  }
  }
   return true;
yyL8:;

/* line 837 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 838 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP117->AnAccess.Sym == yyP115->AnAccess.Sym))) goto yyL9;
  {
/* line 839 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((! CheckElement (yyP117->AnAccess.ElementList, yyP115->AnAccess.ElementList)))) goto yyL9;
  {
/* line 840 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckAccessForAlias (yyP117->AnAccess.Next, yyP116, yyP115->AnAccess.Next, yyP114))) goto yyL9;
  }
  }
  }
   return true;
yyL9:;

/* line 842 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 843 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP117->AnAccess.Sym == yyP115->AnAccess.Sym))) goto yyL10;
  {
/* line 844 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckAccessForAlias (yyP117->AnAccess.Next, yyP116, yyP115->AnAccess.Next, yyP114))) goto yyL10;
  }
  }
   return true;
yyL10:;

  }
  }
  if (yyP117->Kind == kNoAccess) {
  if (yyP115->Kind == kAnAccess) {
/* line 815 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 816 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((IsElement (yyP115->AnAccess.Sym, yyP116)))) goto yyL3;
  }
   return true;
yyL3:;

/* line 818 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 819 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckAccessForAlias (yyP117, yyP116, yyP115->AnAccess.Next, yyP114))) goto yyL4;
  }
   return true;
yyL4:;

  }
  }
  return false;
}

static bool CheckAccessVsElementList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP120, tSymbol yyP119, register tTree yyP118)
# else
(yyP120, yyP119, yyP118)
 register tTree yyP120;
 tSymbol yyP119;
 register tTree yyP118;
# endif
{
  if (yyP120->Kind == kNoAccess) {
/* line 853 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  if (yyP120->Kind == kAnAccess) {
/* line 855 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 856 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP120->AnAccess.Sym > yyP119))) goto yyL2;
  }
   return true;
yyL2:;

/* line 858 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 859 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP120->AnAccess.Sym < yyP119))) goto yyL3;
  {
/* line 860 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckAccessVsElementList (yyP120->AnAccess.Next, yyP119, yyP118))) goto yyL3;
  }
  }
   return true;
yyL3:;

/* line 862 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 863 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! ((yyP120->AnAccess.Sym == yyP119))) goto yyL4;
  {
/* line 864 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (CheckElement (yyP118, yyP120->AnAccess.ElementList))) goto yyL4;
  }
  }
   return true;
yyL4:;

  }
  return false;
}

static bool IsChanType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP121)
# else
(yyP121)
 register tTree yyP121;
# endif
{
  if (yyP121->Kind == kArray) {
/* line 870 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
  {
/* line 870 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   if (! (IsChanType (yyP121->Array.Type))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP121->Kind == kChan) {
/* line 871 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */
   return true;

  }
  return false;
}

void BeginParUsage ()
{
/* line 218 "/home/ringwood/smw/occam/source/gmd/parusage.trafo" */

  if (IS_Mode(xxUsageWarnings)) UEMode=xxWarning;

}

void CloseParUsage ()
{
}
