# ifndef yyTypeChk
# define yyTypeChk

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef bool
# define bool char
# endif

# include "Tree.h"

/* line 114 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

  #define MOSTPOSINT32 ((tInt)((long)0x7FFFFFFFL))
  #define MOSTNEGINT32 ((tInt)((long)-0x80000000L))
  #define INT32MASK    ((tInt)((unsigned long)0xFFFFFFFFL))

  #define MOSTPOSINT16 ((tInt)((short)0x7FFF))
  #define MOSTNEGINT16 ((tInt)((short)0x8000))
  #define INT16MASK    ((tInt)((unsigned short)0xFFFF))

  #define MOSTPOSINT   (IS_Mode(xx16bitINT) ? MOSTPOSINT16 : MOSTPOSINT32)
  #define MOSTNEGINT   (IS_Mode(xx16bitINT) ? MOSTNEGINT16 : MOSTNEGINT32)
  #define INTMASK      (IS_Mode(xx16bitINT) ? INT16MASK : INT32MASK)

  #define BYTEMASK     ((tInt)0xff)
  #define BOOLMASK     ((tInt)0x01)

#ifdef SUPPORT_INT64
  #define MOSTPOSINT64 0x7FFFFFFFFFFFFFFFLL
  #define MOSTNEGINT64 -0x8000000000000000LL
  #define INT64MASK    0xFFFFFFFFFFFFFFFFLL
  #define RNGCHKINT32(v) (((v)>=MOSTNEGINT) && (v <= MOSTPOSINT))
#else
  #define MOSTPOSINT64 MOSTPOSINT32
  #define MOSTNEGINT64 MOSTNEGINT32
  #define INT64MASK    INT32MASK
  #define RNGCHKINT32(v) (true)
#endif

  void RetypeConst(int ss,tConstArray src, int ds, tConstArray dest);


extern void (* TypeChk_Exit) ();

extern void TypeFormals ARGS((tTree yyP1));
extern void TypeDecl ARGS((tTree yyP3, tTree yyP2));
extern tTree TypeAbbrev ARGS((tTree yyP6, tTree yyP5, tPosition yyP4));
extern tTree TypeSubscript ARGS((tTree yyP9, tTree yyP8, tPosition yyP7));
extern tTree TypeRange ARGS((tTree yyP13, tTree yyP12, tTree yyP11, tPosition yyP10));
extern tTree TypeBinary ARGS((tTree yyP17, tTree yyP16, tTree yyP15, tPosition yyP14));
extern tTree TypeUnary ARGS((tTree yyP20, tTree yyP19, tPosition yyP18));
extern tTree TypeExprList ARGS((tTree yyP22));
extern tTree TypeTable ARGS((tTree yyP24, tTree yyP23));
extern tTree StripTypeList ARGS((tTree yyP25));
extern void TypeCheckAssign ARGS((tTree yyP28, tTree yyP27, tPosition yyP26));
extern void TypeCheckResults ARGS((tTree yyP37, tTree yyP36, tPosition yyP35));
extern void TypeCheckParameters ARGS((tTree yyP41, tTree yyP40, tPosition yyP39, int yyP38));
extern void TypeCheckIfList ARGS((tTree yyP44));
extern void TypeCheckTimerInput ARGS((tTree yyP46, tPosition yyP45));
extern void TypeCheckInputProtocol ARGS((tTree yyP49, tTree yyP48, tPosition yyP47));
extern void TypeCheckOutputProtocol ARGS((tTree yyP54, tTree yyP53, tPosition yyP52));
extern void TypeCheckCaseInputs ARGS((tTree yyP57, tTree yyP56, tPosition yyP55));
extern void TypeCheckCaseList ARGS((tTree yyP69, tTree yyP68, bool yyP67));
extern void TypeCheckRetypes ARGS((tTree yyP72, tTree yyP71, tPosition yyP70));
extern bool CheckWritable ARGS((tTree yyP84));
extern bool CheckWritableExprList ARGS((tTree yyP85));
extern bool CheckForVals ARGS((tTree yyP86));
extern bool CheckValofScope ARGS((tTree yyP88, int yyP87));
extern bool CheckIsType ARGS((tTree yyP90, Tree_tKind yyP89));
extern bool IsChanOrTimerType ARGS((tTree yyP91));
extern bool IsTimerType ARGS((tTree yyP93));
extern bool IsChanType ARGS((tTree yyP92));
extern bool IsArrayType ARGS((tTree yyP94));
extern int CalcTypeSize ARGS((tTree yyP205));
extern bool CheckEvalBiOp ARGS((tTree yyP102, tTree yyP101));
extern bool CheckEvalUniOp ARGS((tTree yyP107, tTree yyP106, tTree yyP105));
extern tValue EvalBiExpr ARGS((tPosition yyP112, tTree yyP111, tValue yyP110, tTree yyP109, tValue yyP108));
extern tValue EvalUniExpr ARGS((tTree yyP135, tTree yyP134, tTree yyP133));
extern tTree ReduceElement ARGS((tTree yyP207, tTree yyP206));
extern tTree ReduceElemental ARGS((tTree yyP208));
extern bool CheckConstConvert ARGS((tTree yyP136));
extern tValue EvalConstConvert ARGS((tPosition yyP139, tTree yyP138, tTree yyP137));
extern tValue CheckConst ARGS((tPosition yyP143, tTree yyP142, tInt yyP141, bool yyP140));
extern bool CheckConstRoundTrunc ARGS((tTree yyP145, tTree yyP144));
extern tValue EvalConstRound ARGS((tPosition yyP153, tTree yyP152, tTree yyP151, tValue yyP150));
extern tValue EvalConstTrunc ARGS((tPosition yyP149, tTree yyP148, tTree yyP147, tValue yyP146));
extern bool CheckConstId ARGS((tTree yyP154));
extern tValue EvalConstId ARGS((tTree yyP155));
extern tTree MakeConstInt ARGS((int yyP196, tPosition yyP195));
extern bool CheckValidDeclType ARGS((tTree yyP100));
extern tValue EvalConstSubscript ARGS((tTree yyP168, int yyP167, tConstArray yyP166));
extern tInt EvalMostPos ARGS((tTree yyP164));
extern tInt EvalMostNeg ARGS((tTree yyP165));
extern tInt TestIntOVF ARGS((tPosition yyP158, tTree yyP157, tInt yyP156));
extern tInt SignExtendInt ARGS((tTree yyP160, tInt yyP159));
extern void UpdateElementalUsage ARGS((tTree yyP43, tUsage yyP42));
extern tConstArray ConstArrayFromString ARGS((tTree yyP170, tStringRef yyP169));
extern tConstArray ConstArrayFromExprList ARGS((tTree yyP172, tTree yyP171));
extern tConstArray ConstArrayFromDecl ARGS((tTree yyP174, tTree yyP173));
extern tConstArray SubscriptConstArray ARGS((tTree yyP183, tConstArray yyP182, int yyP181));
extern tConstArray RangeConstArray ARGS((tTree yyP180, tConstArray yyP179, int yyP178));
extern tValue ReadConstArray ARGS((tTree yyP185, tConstArray yyP184));
extern void WriteConstArray ARGS((tTree yyP188, tValue yyP187, tConstArray yyP186));
extern tTree ArrayPrimType ARGS((tTree yyP209));
extern void MarkNonAtomicIf ARGS((tTree IF));

extern void BeginTypeChk ();
extern void CloseTypeChk ();

# endif
