# include "Cout.h"
# include "yyCout.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"

# define yyInline
# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

/* line 48 "/home/ringwood/smw/occam/source/gmd/c.trafo" */

/*{{{  includes*/
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Scanner.h"
#include "Errors.h"
#include "DynArray.h"
#include "Symbol.h"
#include "Transform.h"
#include "Fopenenv.h"
#include "TypeChk.h"
/*}}}*/
/*{{{  statics*/
extern bool cgdebug;

static bool NL = false;
static tPosition POS= {0,0,NULL};
static indent = 0;
static char *outname;                  /* base name of generated file */
static tTree CurProc;
extern FILE* yyf;
static void yyAbort(char *);
extern void Code(tTree);

static int CurrentLabel;

static char M_MAIN[]="<<MAIN>>";             static int S_MAIN= sizeof(M_MAIN)-1; 
static char M_HEADER[]="<<HEADER>>";         static int S_HEADER= sizeof(M_HEADER)-1; 
static char M_CODE[]="<<CODE>>";             static int S_CODE= sizeof(M_CODE)-1;
static char M_NAME[]="<<NAME>>";             static int S_NAME= sizeof(M_NAME)-1;
static char M_PROTOTYPES[]="<<PROTOTYPES>>"; static int S_PROTOTYPES=sizeof(M_PROTOTYPES)-1;
static char M_SWITCHES[]="<<SWITCHES>>";     static int S_SWITCHES= sizeof(M_SWITCHES)-1; 
static char M_PARAMETERS[]="<<PARAMETERS>>"; static int S_PARAMETERS=sizeof(M_PARAMETERS)-1;
static char M_DEBUG[]="<<DEBUG>>";           static int S_DEBUG=sizeof(M_DEBUG)-1;
static char M_SERVERWS[]="<<SERVERWS>>";     static int S_SERVERWS=sizeof(M_SERVERWS)-1;

static char PRM[] = "Param";  /* base name of parameters to library units */
static char DIM[] = "_Dim";   /* hidden dimension extension */
static char CHK[] = "CHK";    /* name of checking macro */
static char RNGCHK[] = "RNGCHK";    /* name of checking macro */
static char RNGCHKLB[] = "RNGCHKLB";    /* name of checking macro */
static char RNGCHKUB[] = "RNGCHKUB";    /* name of checking macro */
static char ASSIGN[] = "ASSIGN";    /* name of array copying macro */
static char MSG_ASM[] = "MSG_ASM";
static char MSG_ARM[] = "MSG_ARM";
static char MSG_AIM[] = "MSG_AIM";
static char MSG_CITL[] = "MSG_CITL";
static char CHK_SWITCH[][20] = { "CHECK_CONVERSIONS","CHECK_INTERNALS","CHECK_ARRAYS","CHECK_RANGES" };
static char ERR_MODES[][20] = { "TERMINATE_ON_ERROR","CONTINUE_ON_ERROR","STOPP_ON_ERROR" };

static char M_SPOC_ISERVER[] = "spoc.iserver";
static int  S_SPOC_ISERVER   = sizeof(M_SPOC_ISERVER)-1;

eErrorModes ErrorMode = xxTerminateOnError;

/*}}}*/
/*{{{  static void ShowPosition()*/
#define SetPosition(P) POS=P
static void ShowPosition()  
{  
  if (IS_Mode(xxOccamLines))
  {  
    if (POS.File!=NULL)
    {
      if (IS_Mode(xxLinesAsComments))
      {
        fprintf(yyf,"/* line %3d \"",POS.Line);
        WriteString(yyf,POS.File);
        fprintf(yyf,"\"*/\n");
      }
      else
      {
        fprintf(yyf,"#line %3d \"",POS.Line);
        WriteString(yyf,POS.File);
        fprintf(yyf,"\"\n");
      }  
    }
  }
}
/*}}}*/
/*{{{  output control*/
#undef yyWrite
/*{{{  static void DoNL()*/
static void DoNL()
{
  if (NL==true) 
  { 
    int i; 
    ShowPosition();
    NL = false; 
    for(i=0;i<indent;i++) fputc(' ',yyf);
  }
}
/*}}}*/
static void Indent()     { if (!NL) fputc('\n',yyf); NL=true; indent+=2; }
static void Outdent()    { if (!NL) fputc('\n',yyf); NL=true; indent-=2; }
static void BigIndent()  { if (!NL) fputc('\n',yyf); NL=true; indent+=10;}
static void BigOutdent() { if (!NL) fputc('\n',yyf); NL=true; indent-=10;}
static void NewLine()    { if (!NL) fputc('\n',yyf); NL=true;}
static void BlankLine()  { NewLine(); fputc('\n',yyf); }
static void ResetIndent() { NL=false; indent=0; }

#define CONDWrite(b,s)   { if (b) yyWrite(s); }
#define COND(b,s)        { if (b) s; }

#define WriteInt(a)  {DoNL(); fprintf(yyf,"%d",(int)a);}

#define WriteReal(a) {DoNL(); fprintf(yyf,"%.*g",a.RNumber.p,a.RNumber.n);} 
#define WriteByte(a) {DoNL(); fprintf(yyf,"\'\\x%02x\'",(unsigned char)a);}
#define WriteBool(a) {DoNL(); fputs((a)?"true":"false",yyf);}
#define WriteStr(a)  {DoNL(); strlen(a); fputs(a,yyf);}
#define WriteChar(a)  {DoNL(); fputc((char)a,yyf);}

#define GenLabel()    WriteLabel(NewLabel())
#define NewLabel()    (++CurrentLabel)
#define WriteLabel(l) { /*Big*/Outdent(); DoNL(); fprintf(yyf,"CASE(%d):  ",(int)l); /*Big*/Indent(); }
#define WriteLabelValue(l) WriteInt(l)

#define yyWrite(a)   {DoNL(); fputs(a,yyf);}

#define WriteId(s)    {DoNL(); WriteIdent(yyf,s);}  

#define WarnNotImp(P,S)    ErrorMessageI(xxNotImplemented,xxWarning,P,xxString,S)
#define WNYI(S,P)          MessageI("C transformation not implemented for ",xxError,P,xxString,Tree_NodeName[S->Kind])

#define WriteOccSym(s) {DoNL(); WriteIdent(yyf,Symbol(s).Id);}


/*{{{  void WriteSymSuffix(tSymbol s)*/
void WriteSymSuffix(tSymbol s)
{
  if (Tree_IsType(SymbolKind(s),kPrototypeFunc))
  {
    tIdent Id=SymbolKind(s)->PrototypeFunc.Module;
    if (Id!=NoIdent)
    {
      fputc('_',yyf);
      WriteIdent(yyf,Id);
    }
  }
  else if (Tree_IsType(SymbolKind(s),kPrototypeProc))
  {
    tIdent Id=SymbolKind(s)->PrototypeProc.Module;
    if (Id!=NoIdent)
    {
      fputc('_',yyf);
      WriteIdent(yyf,Id);
    }
  }
  else if (Symbol(s).Depth==0)
  {
    fprintf(yyf,"_%s",outname);
  }   
  else
    fprintf(yyf,"_%d",s);
}
/*}}}*/
/*{{{  void WriteStrRef(tStringRef r)*/
static void WriteStrRef(tStringRef r)
{
  #define IsPrintable(c) (((c)>=' ') && ((c)<='~'))
  char *temp ;
  int len = LengthSt(r) ;

  DoNL();
  if ((temp = (char*) malloc(len)) == NULL)
    yyAbort("Out of heap") ;
  else
    {
      int i;
      
      StGetString (r,temp) ;

      for (i=0;i<len;i++)
      {
        char c = temp[i] ;

        if (c == '"')
          fprintf(yyf,"\\\"") ;
        else if (c == '\\')
          fprintf(yyf,"\\\\") ;
        else if (c == '\'')
          fprintf(yyf,"\\'") ;
        else if (c == '\?')
          fprintf(yyf,"\\?") ;
        else if (IsPrintable(c))
          fputc(c,yyf) ;
        else if (c == 13)
          fprintf(yyf,"\\r") ;
        else if (c == 10)
          fprintf(yyf,"\\n") ;
        else if (c == '\t')
          fprintf(yyf,"\\t") ;
        else
          fprintf(yyf,"\\x%02x",c) ;
      }
      free(temp) ;
    }
}
/*}}}*/
/*{{{  void WriteStaticSym(tSymbol sym)*/
void WriteStaticSym(tSymbol sym)
{
  tStringRef r = GetStringRef (Symbol(sym).CId);
  char *temp ;
  int len = LengthSt(r) ;

  DoNL() ;

  if ((temp = (char*) malloc(len)) == NULL)
    yyAbort("Out of heap") ;
  else
    {
      int i;
      
      StGetString (r,temp) ;

      for (i=0;i<len;i++)
      {
        char c = temp[i] ;

        if (c == '.')
          fprintf(yyf,"_") ;
        else
          fputc(c,yyf) ;
      }
      free(temp) ;
      WriteSymSuffix(sym);
    }
}
/*}}}*/
/*{{{  void WritetInt(tInt val,bool int64)*/
void WritetInt(tInt val,bool int64)
{
  char str[24];
  int len=0;
  bool neg=(val < 0);
  tInt value=(neg)?-val:val;
  bool hex=(val > 1000000) || (val < -1000000);

#ifndef SUPPORT_INT64
  int64 = false;
#endif
  if (!IS_Mode(xxSupportINT64)) int64=false;

  if (hex)
  {
    int digits = (int64) ? 16 : 8;
    char hexdigits[] = "0123456789ABCDEF";

    while(len < digits) { str[len++] = hexdigits[val & 15]; val = val >> 4; }
    while(len>1 && str[len-1]=='0') --len;

    if (int64 && val == MOSTNEGINT64) fprintf(yyf,"-0x");
    else if (!int64 && val == MOSTNEGINT32) fprintf(yyf,"-0x");
    else fprintf(yyf,"0x");
  }
  else
  {
    while(len==0 || value > 0) { str[len++]='0'+(value % 10); value = value / 10; }
    if (neg) fputc('-',yyf);
  }

  {
    int i = 0;
    int j=len-1;
    char c;

    while(i < j) { c = str[i]; str[i++] = str[j]; str[j--] = c; }
  }
  
  str[len] = 0;
  
  if (int64 && len>8) fprintf(yyf,"%sLL",str);
  else fprintf(yyf,"%s",str);

}
  
  
/*}}}*/
/*{{{  static void WriteSym(int s)*/
static void WriteSym(int s)
{
  DoNL(); 
  WriteIdent(yyf,Symbol(s).CId);
  WriteSymSuffix(s);
}
/*}}}*/

/*}}}*/
/*{{{  access to back list in IfType*/
#define BackIfType(I)     I->IfType.BackIfType
#define BackChoiceList(I) I->IfType.BackChoiceList
/*}}}*/
/*{{{  Specification handling */
#define TypeDepth(T) (T->Type.D)
#define IsTopLevel(S) (Symbol(S).Depth==0)

#define NeedsUnion(PL) (PL->ProcList.SLC > 1)
#define NeedsStruct(P) (P->Process.SpecList->SpecList.DCL > 0)

typedef struct
{
  tIdent Id;
  tIdent PrefixId;
  bool newSpec;
} tSpec;

static unsigned long SpecExtent = 0;
static tSpec *SpecTable = NULL;
static int SpecLevel;

#define CurSpec() SpecTable[SpecLevel]

/* OpenSSpec opens a structure scope if we are in a union and we
   need a new level. The current scope is then a union only if
   we were in a union before and we did not open a structure.  */

#define OpenSSpec(S,b) (!OpenSpec((S) && (b),"struct") && (S))

/* OpenUSpec opens a union scope if we are in a structure and we
   need a new level. The current scope is then a union if we 
   were in a union before or if we just opened a union.        */

#define OpenUSpec(S,b) (OpenSpec(!(S) && (b),"union") || (S))

void InitSpec()
{
  if (SpecExtent == 0)
  {
    SpecExtent = 20;
    MakeArray((char**)&SpecTable,&SpecExtent,sizeof(tSpec));
  }
  SpecLevel = 0;

  CurSpec().Id = NoIdent;
  CurSpec().PrefixId = NoIdent;
}

bool OpenSpec(bool b,char *name)
{
  tIdent id = CurSpec().Id;
  tIdent pfid = CurSpec().PrefixId;

  if (b)
  {
    id = UniqueId(toupper(name[0]));

    if (pfid)
    {
      pfid = PrefixId(pfid,id,'.');
    }
    else
      pfid = id;

    WriteStr(name); NewLine();
    WriteStr("{"); NewLine();
    Indent();
  }

  if (SpecLevel>=SpecExtent) ExtendArray((char**)&SpecTable,&SpecExtent,sizeof(tSpec));

  SpecLevel++;
  CurSpec().PrefixId = pfid;
  CurSpec().Id = id;
  CurSpec().newSpec = b;

  return(b);
}

void CloseSpec()
{
  if (CurSpec().newSpec)
  {
    Outdent();
    WriteStr("} ");
    WriteId(CurSpec().Id);
    WriteStr(";"); NewLine();
  }
  SpecLevel--;
}
/*}}}*/
/*{{{  Blocks*/
static unsigned long BlockExtent = 0;
static bool *BlockTable = NULL;
static int BlockLevel;

#define CurBlock BlockTable[BlockLevel]

void InitBlocks()
{
  if (BlockExtent == 0)
  {
    BlockExtent = 20;
    MakeArray((char**)&BlockTable,&BlockExtent,sizeof(bool));
  }
  BlockLevel = 0;
  indent = 0;
}

#define DoBlock() { if (!CurBlock) { CurBlock = true; WriteStr("{"); Indent(); NewLine(); }} 

void OpenBlock(bool b)
{
  if (BlockLevel>=BlockExtent) ExtendArray((char**)&BlockTable,&BlockExtent,sizeof(bool));

  BlockLevel++;
  CurBlock = b;
}

void CloseBlock()
{
  if (CurBlock)
  {
    Outdent();
    WriteStr("}");
    NewLine();
  }
  BlockLevel--;
}
/*}}}*/
/*{{{  static int CalcDepth(tSymbol ThisSym)*/
static int CalcDepth(tSymbol ThisSym)
{
  tSymbol S=CalcParent(SymbolKind(ThisSym));
  int D=0;
  if (S==NoSymbol) return 0;
  while (Symbol(S).Depth>0)
  {
    if (Tree_IsType(SymbolKind(S),kDefProc)) 
      S=SymbolKind(S)->DefProc.Parent;
    else if (Tree_IsType(SymbolKind(S),kPrototypeProc)) 
      S=SymbolKind(S)->PrototypeProc.Parent;
    else if (Tree_IsType(SymbolKind(S),kDefAFunc)) 
      S=SymbolKind(S)->DefAFunc.Parent;
    else
      Message("Parent is not PROC or FUNCTION",xxFatal,NoPosition);
    D++;
  }
  if ( Tree_IsType(SymbolKind(ThisSym),kDefProc) ||
       Tree_IsType(SymbolKind(ThisSym),kDefFunc) )
    D++;
  return D;
}
/*}}}*/
/*{{{  static void DoSubstitutions(FILE *inf,char *filename, tTree Root)*/
static void DoSubstitutions(FILE *inf,tTree Root)
{  
  DoNL();

  while(!feof(inf))
  {
    char *bp, buff[128];
    
    bp = fgets(buff,128,inf);
    if (bp == NULL) break;
    while(*bp)
    {
      if (strncmp(bp,M_MAIN,S_MAIN)==0)
        /*{{{  insert OuterProc name*/
        {
          bp += S_MAIN;
          if (!IS_Mode(xxLibrary))
          {
            WriteSym(TreeRoot->Start.OuterProc);
          }
        }
        /*}}}*/
      else if (strncmp(bp,M_PARAMETERS,S_PARAMETERS)==0)
        /*{{{  insert parameters to outermost proc*/
        {
          bp += S_PARAMETERS;
          if (!IS_Mode(xxLibrary))
          {
            Indent();
            CodeMainEntryParameters(SymbolKind(TreeRoot->Start.OuterProc));
            Outdent();
          }
        }
        /*}}}*/
      else if (strncmp(bp,M_SWITCHES,S_SWITCHES)==0)
        /*{{{  insert selected switches*/
        {
          int i;
          
          bp += S_SWITCHES;
        
          if (IS_Mode(xxLibrary)) { WriteStr("#define LIBRARY_UNIT"); NewLine(); }
          WriteStr("#define BYTES_PER_WORD 4"); NewLine();
        
          if (!IS_Mode(xxSupportINT64)) { WriteStr("#define NO_INT64"); NewLine(); }
        
          WriteStr("#define ");WriteStr(ERR_MODES[ErrorMode]);NewLine();
        
          for (i=xxCheckConversions;i<=xxCheckRanges;i++)
            if (IS_Mode(i)) { WriteStr("#define ");WriteStr(CHK_SWITCH[i-xxCheckConversions]); NewLine(); }
        
          if (!IS_Mode(xxOccamDebug)) { WriteStr("#define NO_DEBUG"); NewLine(); }
          WriteStr("#define FASTGOTOS"); NewLine();
          if (IS_Mode(xxSimulatedServer) && !IS_Mode(xxLibrary)) { WriteStr("#define USE_SPOC_ISERVER"); NewLine(); }
          if (IS_Mode(xxLittleEndian)) { WriteStr("#define SOURCE LITTLE"); NewLine(); }
          if (IS_Mode(xxCallF90)) { WriteStr("#define CALL_NAG_F90"); NewLine(); }
        }
        /*}}}*/
      else if (strncmp(bp,M_NAME,S_NAME)==0)
        /*{{{  insert name*/
        {
          bp += S_NAME;
          WriteStr(outname);
        }
        /*}}}*/
      else if (strncmp(bp,M_HEADER,S_HEADER) == 0)
        /*{{{  insert structure declarations*/
        {
          tTree T;
        
          bp += S_HEADER;
          
          T = Root->Start.CGNext;
          while(T != NoTree)
            T = GenTypeDef(T);
        
          T = Root->Start.CGNext;
          while(T != NoTree)
          {
            InitSpec();
            T = GenDeclStruct(T);
          }
          GenStatics(Root);
        }        
        
        /*}}}*/
      else if (strncmp(bp,M_CODE,S_CODE) == 0)
        /*{{{  insert generated code*/
        {
          tTree T;
        
          bp += S_CODE;
          
          T = Root->Start.CGNext;
          while(T != NoTree)
            T = GenCode(T);
        }
        /*}}}*/
      else if (strncmp(bp,M_PROTOTYPES,S_PROTOTYPES)==0)
        /*{{{  insert prototypes*/
        { 
          tTree T;
                
          bp += S_PROTOTYPES;
          if (IS_Mode(xxLibrary))
          {
            Indent();
            T = Root->Start.CGNext;
            while(T != NoTree)
            {
              T = GenCPrototype(T);
            }
          }
          Outdent();
        }
        /*}}}*/
      else if (strncmp(bp,M_DEBUG,S_DEBUG)==0)
        /*{{{  insert debug*/
        {
          tSymbol S;
          bp+= S_DEBUG;
        
          if (IS_Mode(xxOccamDebug))
          {
            WriteStr("#ifndef NO_DEBUG");NewLine();
            WriteStr("#undef SETSCOPE");NewLine();
            WriteStr("#define NUMSYMS ");WriteInt(OccSymSize);NewLine();
            /*{{{  generate Symbols table*/
            WriteStr("static char *Symbols[NUMSYMS]={\"");
            for (S=1;S<=OccSymSize;S++) 
            {
              WriteOccSym(S);
              if (S==OccSymSize) 
                WriteStr("\"};")
              else
                WriteStr("\",\"");
            } NewLine();
            /*}}}*/
            /*{{{  generate Kinds table*/
            WriteStr("static int Kinds[NUMSYMS]={");
            for (S=1;S<=OccSymSize;S++) 
            {
             
              WriteInt(MapKinds(SymbolKind(S),SymbolType(S),S));
              if (S==OccSymSize) 
                WriteStr("};")
              else
                WriteStr(",");
            } NewLine();
            /*}}}*/
            /*{{{  generate Scopes table*/
            WriteStr("static int Scopes[NUMSYMS]={");
            for (S=1;S<=OccSymSize;S++) 
            {
              WriteInt(Symbol(S).Scope-1);
              if (S==OccSymSize) 
                WriteStr("};")
              else
                WriteStr(",");
            } NewLine();
            /*}}}*/
            /*{{{  generate Depths table*/
            WriteStr("static int Depths[NUMSYMS]={");
            for (S=1;S<=OccSymSize;S++) 
            {
              WriteInt(CalcDepth(S));
              if (S==OccSymSize) 
                WriteStr("};")
              else
                WriteStr(",");
            } NewLine();
            /*}}}*/
            /*{{{  generate Types table*/
            WriteStr("static char *Types[NUMSYMS]={\"");
            for (S=1;S<=OccSymSize;S++) 
            {
              OccCodeType(SymbolType(S));
              if (S==OccSymSize) 
                WriteStr("\"};")
              else
                WriteStr("\",\"");
            } NewLine();
            /*}}}*/
            WriteStr("#include \"Debug.h\"");NewLine();
            /*{{{  ShowValue function*/
            WriteStr("static void *ShowValue(void *FP, int S)"); NewLine();
            WriteStr("{ switch(S)");Indent();
            WriteStr("{"); Indent();
            for (S=1;S<=OccSymSize;S++) 
            {
              WriteStr("case "); WriteInt(S-1); WriteStr(": "); 
              if (MapKinds(SymbolKind(S),SymbolType(S),S)>0 && Symbol(S).Id!=NoIdent) GenShowValue(SymbolKind(S),SymbolType(S),S);
              WriteStr(" break;");
              NewLine();
            } 
            Outdent(); WriteStr("}");
            Outdent(); WriteStr("}"); NewLine();  
            /*}}}*/
            /*{{{  DEBUGOCCAM function*/
            WriteStr("static void DEBUGOCCAM()");NewLine();
            WriteStr("{");Indent();
            WriteStr("Show(MODE,CFP);");NewLine();
            WriteStr("DEBUGDONE();");Outdent();
            WriteStr("}");NewLine();
            /*}}}*/
            WriteStr("#endif");NewLine();
          }
        }
        /*}}}*/
      else
        do fputc(*bp++,yyf); while(*bp && *bp!='<');
    }
  }
  
  fclose(inf);
}

DoGenCodeOnly(tTree Root)
{
  tTree T;

  InitSpec();
  T = Root->Start.CGNext;
  while(T != NoTree)
    T = GenCode(T);
}

/*}}}*/
/*{{{  static FILE *OpenTemplate(char *name)*/
static FILE *OpenTemplate(char *name)
{
  return(fopenenv(name,"r",OSEARCH,ODEFAULT_LIB,NULL));
}
/*}}}*/
/*{{{  void OutputC(f,t,createc)*/
void OutputC(char *name,tTree Root)
{
  FILE *savef = yyf;
  FILE *inf;
  char *template="Occam2C.c";

  inf = OpenTemplate(template);
  if (inf == NULL) MessageI("Cannot open file ",xxFatal,NoPosition,xxString,template);
  
  yyf = stdout;
  if (strcmp(name,"-") != 0)
  {
    char *dot = strrchr(name,'.');
    char *slash = strrchr(name,'/');

    if (slash == NULL) slash = strrchr(name,'\\');

    if ((yyf=fopen(name,"w"))==NULL) MessageI("Cannot open file ",xxFatal,NoPosition,xxString,name);
    if (dot != NULL) *dot=0;
    if (slash == NULL) outname = name;
    else outname = ++slash;
  }
  else
    outname = "";

  if (!IS_Mode(xxLibrary))
  {
    if (Tree_IsType(Symbol(Root->Start.OuterProc).Kind,kDefProc))
      Symbol(Root->Start.OuterProc).Kind->DefProc.isPar = true;
    else
      Message("Outermost subroutine must be a PROC",xxFatal,Symbol(Root->Start.OuterProc).Kind->DefProc.Pos);
  }
  ResetIndent();
  if (cgdebug)  DoGenCodeOnly(Root);
  else DoSubstitutions(inf,Root);
  
  if (yyf != stdout) fclose(yyf);
  if (IS_Mode(xxLibrary))
  {
    tTree T;
    char *tname = (char *)malloc(strlen(outname)+10);

    if (!tname) Message("Out of Heap",xxFatal,NoPosition);
    strcpy(tname,outname); strcat(tname,".t");
    if ((yyf=fopen(tname,"w"))==NULL) MessageI("Cannot open file ",xxFatal,NoPosition,xxString,tname);

    SetPosition(NoPosition);
    ResetIndent();
    T = Root->Start.CGNext;
    while(T != NoTree)
    {
      T = GenOccPrototypes(T);
    }

    fclose(yyf);
  }
  /*{{{  if (cgdebug)*/
  if (cgdebug)
  {
    tTree T;
          
    yyf = stdout;
  
    T = Root->Start.CGNext;
    fprintf(yyf,"\nCodeGenerator Debug\n");
  
    while(T != NoTree)
    {
      T = GenCGDebug(T);
    }
  }
  /*}}}*/
  yyf = savef;
}
/*}}}*/
/*{{{  void WriteCCode(tStringRef S, tPosition P, int scope)*/
void WriteCCode(tStringRef S, tPosition P, int scope)
{
  int l = LengthSt(S);
  int i=0;
  char *str = (char*) malloc(l);
  StGetString(S,str);
  while (i<l)
  {
    if (str[i]=='$')
    {
      tSymbol Sym;
      int start = ++i;
      while (isalnum(str[i])||(str[i]=='.')) i++;
      Sym = LookupSymbolInScope(MakeIdent(&str[start],i-start),P,scope);
      AddVUsage(Sym,xxLRead);
      CodeSymRef(Symbol(Sym).Kind,Sym,false);
    }
    else 
      WriteChar(str[i++]);
  }
  free(str);
}
/*}}}*/
/*{{{  void MarkCCodeUsage(tStringRef S, tPosition P, int scope)*/
void MarkCCodeUsage(tStringRef S, tPosition P, int scope)
{
  int l = LengthSt(S);
  int i=0;
  char *str = (char*) malloc(l);
  StGetString(S,str);
  while (i<l)
  {
    if (str[i]=='$')
    {
      tSymbol Sym;
      int start = ++i;
      while (isalnum(str[i])||(str[i]=='.')) i++;
      Sym = LookupSymbolInScope(MakeIdent(&str[start],i-start),P,scope);
      AddVUsage(Sym,xxLRead);
    }
    else ++i;
  }
  free(str);
}
/*}}}*/
/*{{{  Priority Defs.*/
#define HIPRI 0
#define LOPRI 1
/*}}}*/
/*{{{  static bool IsDuplicatedPrototype(tSymbol ThisSym)*/
static bool IsDuplicatedPrototype(tSymbol ThisSym)
{
  tSymbol S=1;
  tIdent M=CalcModule(SymbolKind(ThisSym));
  while (S<=ThisSym)
  {
    if ((M!=NoIdent) && (SymbolKind(S)!=NULL) && 
        (Symbol(S).Id==Symbol(ThisSym).Id) && 
        (CalcModule(SymbolKind(S))==M) &&
        (CalcUsage(SymbolKind(S))==xxUsed))
      break;
    S++;
  }
  return (S!=ThisSym);
}

/*}}}*/
/*{{{  static bool IsDuplicatedHeader(tSymbol ThisSym)*/
static bool IsDuplicatedHeader(tSymbol ThisSym)
{
  tSymbol S=1;
  tStringRef H=CalcHeader(SymbolKind(ThisSym));
  while (S<=ThisSym)
  {
    if ((SymbolKind(S)!=NULL) && IsPrototype(SymbolKind(S)) &&
        (CalcHeader(SymbolKind(S))==H) &&
        (CalcUsage(SymbolKind(S))==xxUsed))
      break;
    S++;
  }
  return (S!=ThisSym);
}

/*}}}*/
/*{{{  static void WriteModuleHeaderName(tStringRef St)*/
static void WriteModuleHeaderName(tStringRef St)
{
  int len = LengthSt(St);
  char *temp = (char*) malloc(len+4);

  if (temp==NULL)
      Message("Out of heap",xxFatal,NoPosition) ;
  else
  {
    int i = len-1;
    StGetString (St,temp);
    
    while(i>1 && temp[i]!='.') --i;
    if (i) temp[i] = 0;
    strcat(temp,".hdr");

    WriteStr(temp);
  }
}
/*}}}*/


static void yyExit () { Exit (1); }

void (* Cout_Exit) () = yyExit;

extern FILE *yyf;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module Cout, routine %s failed\n", yyFunction);
 Cout_Exit ();
}

tTree GenTypeDef ARGS((tTree T));
static void GenWS ARGS((tSymbol yyP1));
static void GenProtoFormals ARGS((tTree yyP3, int yyP2));
static void GenProtoArrayFormal ARGS((tTree yyP5, int yyP4));
tTree GenDeclStruct ARGS((tTree T));
static void GenParentRef ARGS((tTree yyP7, tSymbol yyP6));
static void GenDeclFormals ARGS((tTree yyP9, bool yyP8));
static void GenDeclArrayFormal ARGS((tTree yyP12, tSymbol yyP11, bool yyP10));
static void GenDeclProc ARGS((tTree P, bool yyP13));
static void GenDeclList ARGS((tTree T, bool yyP14));
static void GenDeclGuard ARGS((tTree yyP16, bool yyP15));
static void GenDeclAltTypeOuter ARGS((tTree yyP18, bool yyP17));
static void GenDeclAltTypeInner ARGS((tTree yyP19));
static void GenDeclAltList ARGS((tTree yyP20));
static void GenDeclAltRep ARGS((tTree yyP21));
static void GenNLRepState ARGS((tTree yyP22));
static void GenDeclSpecs ARGS((tTree yyP23));
static void GenDeclNLSpec ARGS((tTree yyP24));
static void GenDeclSym ARGS((tTree yyP27, tSymbol yyP26, bool yyP25));
static void GenDeclArraySym ARGS((tTree yyP29, tSymbol yyP28));
static bool IsZeroSizeType ARGS((tTree yyP30));
static bool NeedsSpecs ARGS((tTree yyP31));
static bool NeedsSplit ARGS((tTree yyP32));
static void GenDeclNLIdList ARGS((tTree yyP34, tTree yyP33));
static void GenSpecState ARGS((tTree yyP35));
int CountRepDecls ARGS((tTree yyP36));
int CountAltRepDecls ARGS((tTree yyP37));
static int CountAbbrev ARGS((tTree yyP38));
static int CountIdList ARGS((tTree yyP39));
static int CountDecl ARGS((tTree yyP40));
int CountSpec ARGS((tTree yyP41));
tTree GenCode ARGS((tTree T));
static void GenProcHead ARGS((tTree DP));
static void GenProcEntry ARGS((tTree DP));
static void GenProcTail ARGS((tTree DP));
static void GenFuncHead ARGS((tTree DF));
static void GenFuncEntry ARGS((tTree DF));
static void GenFuncExit ARGS((tTree DF));
static void GenFuncTail ARGS((tTree DF));
static bool GenFormals ARGS((tTree yyP43, bool yyP42));
static void GenArrayFormal ARGS((tTree yyP46, tSymbol yyP45, bool yyP44));
static void GenNLFormals ARGS((tTree yyP47));
static void GenNLArrayFormal ARGS((tTree yyP49, tSymbol yyP48));
static bool AnyNLFormals ARGS((tTree yyP50));
static void GenMVFormals ARGS((tTree yyP53, int yyP52, bool yyP51));
static void GenMVFResult ARGS((tTree yyP55, int yyP54));
static bool NeedsChain ARGS((tTree yyP56));
static bool UsesFreeVars ARGS((tTree yyP57));
static void GenProcess ARGS((tTree yyP58));
static void GenProcList ARGS((tTree yyP59));
static void GenParList ARGS((tTree yyP61, int yyP60));
static void GenParProc ARGS((tTree yyP65, tSymbol yyP64, int yyP63, tTree yyP62));
static void GenPlacedList ARGS((tTree yyP68, tSymbol yyP67, tTree yyP66));
static void GenPlaced ARGS((tTree yyP71, tSymbol yyP70, tTree yyP69));
static void CodePlacedExpr ARGS((tTree EX, tSymbol yyP73, tTree yyP72));
static void GenParProcParam ARGS((tTree yyP78, tTree yyP77, tIdent yyP76, tSymbol yyP75, tTree yyP74));
static void GenEnableAltType ARGS((tTree yyP79));
static void GenEnableAltList ARGS((tTree yyP80));
static void GenEnableGuard ARGS((tTree yyP81));
static void GenDisableAltType ARGS((tTree yyP82));
static void GenDisableAltList ARGS((tTree yyP83));
static void GenDisableGuard ARGS((tTree yyP85, int yyP84));
static void GenAssignRepsAltType ARGS((tTree yyP86));
static void GenAssignRepsAltList ARGS((tTree yyP87));
static tTree BuildRevSpecList ARGS((tTree yyP89, tTree yyP88));
static void GenCodeAltType ARGS((tTree yyP92, int yyP91, tTree yyP90));
static void GenCodeAltList ARGS((tTree yyP95, int yyP94, tTree yyP93));
static void GenCodeGuard ARGS((tTree yyP96));
static void GenIfType ARGS((tTree yyP98, int yyP97));
static void GenIfList ARGS((tTree yyP100, int yyP99));
static void GenIfTypeAtomic ARGS((tTree yyP102, bool yyP101));
static void GenIfListAtomic ARGS((tTree yyP105, tTree yyP104, bool yyP103));
static void GenCaseSwitches ARGS((tTree yyP107, bool yyP106));
static void GenCaseExprList ARGS((tTree yyP108));
static void GenCaseCode ARGS((tTree yyP110, int yyP109));
static void GenCaseAtomic ARGS((tTree yyP112, bool yyP111));
static void GenCaseInSwitches ARGS((tTree yyP113));
static void GenCaseInCode ARGS((tTree yyP116, tTree yyP115, int yyP114));
static void GenSetScope ARGS((tSymbol yyP117));
static void GenSetListScope ARGS((tTree yyP118));
static void GenLocalSpecs ARGS((tTree yyP119));
static void GenLocalSpec ARGS((tTree SP));
static void GenLocalRep ARGS((tTree yyP120));
static void GenLocalIdList ARGS((tTree yyP122, tTree yyP121));
static void GenLocalInits ARGS((tTree yyP123));
static void GenLocalInit ARGS((tTree SP));
static void GenInitTable ARGS((tSymbol yyP126, int yyP125, tTree yyP124));
static void GenArrayTypeSize ARGS((tTree yyP127));
static void GenEmuRetype ARGS((tTree yyP131, tSymbol yyP130, tTree yyP129, tTree yyP128));
static void CodeRetypeSize ARGS((tTree yyP134, tSymbol yyP133, int yyP132));
static int RetypeSize ARGS((tTree yyP135));
static void GenInitChanList ARGS((tTree yyP136));
static void GenInitChanSubs ARGS((int yyP138, int yyP137));
static void GenInitChanArray ARGS((tTree yyP141, tSymbol yyP140, int yyP139));
static void GenInitChanArrayList ARGS((tTree yyP143, tTree yyP142));
static void GenInitIsArray ARGS((tSymbol yyP148, tTree yyP147, tTree yyP146, tSymbol yyP145, tTree yyP144));
static void GenInitReArray ARGS((tSymbol yyP153, tTree yyP152, tTree yyP151, tSymbol yyP150, tTree yyP149));
static void GenInitReArrayUnBoundSize ARGS((tTree yyP154));
static void GenResults ARGS((tTree yyP155));
static void GenResult ARGS((tTree yyP156));
static void GenResultTable ARGS((tSymbol yyP159, int yyP158, tTree yyP157));
static void GenEmuRetypeResult ARGS((tTree yyP163, tSymbol yyP162, tTree yyP161, tTree yyP160));
static int GenRepStart ARGS((tTree yyP164));
static void GenRepEnd ARGS((tTree yyP167, int yyP166, int yyP165));
static void GenAltIndex ARGS((tTree yyP168));
static void GenAltSelect ARGS((tTree yyP169));
static void GenForLoop ARGS((tTree yyP170));
static void GenForCheck ARGS((tTree yyP171));
static void CodeArrayExpr ARGS((tTree yyP173, bool yyP172));
static void CodeExpr ARGS((tTree yyP174));
static void CodeSizeOp ARGS((tTree yyP176, tTree yyP175));
static void CodeConstExpr ARGS((tTree yyP178, tValue yyP177));
static void CodeAssign ARGS((tTree yyP180, tTree yyP179));
static void CodeAssign2 ARGS((tTree yyP182, tTree yyP181));
static void GenChkDims ARGS((tTree yyP186, tTree yyP185, tTree yyP184, tTree yyP183));
static void GenInstance ARGS((tTree DP, tTree yyP188, tIdent yyP187));
static void GenAtomicInstance ARGS((tSymbol yyP191, tTree yyP190, tTree yyP189));
static void GenNonAtomicInstance ARGS((tSymbol yyP195, tTree yyP194, tTree yyP193, tIdent yyP192));
static void GenCInstance ARGS((tSymbol yyP198, tTree yyP197, tTree yyP196));
static void GenCTemps ARGS((tTree yyP201, tTree yyP200, bool yyP199));
static void GenCParams ARGS((tTree yyP204, tTree yyP203, bool yyP202));
static void GenCResults ARGS((tTree yyP207, tTree yyP206, bool yyP205));
static void GenF90Instance ARGS((tSymbol yyP210, tTree yyP209, tTree yyP208));
static void GenF90Temps ARGS((tTree yyP213, tTree yyP212, int yyP211));
static void GenF90Inits ARGS((tTree yyP216, tTree yyP215, int yyP214));
static void GenF90DopeInits ARGS((tTree yyP221, tTree yyP220, tTree yyP219, int yyP218, int yyP217));
static void GenF90Params ARGS((tTree yyP225, tTree yyP224, int yyP223, bool yyP222));
static void GenF90CharParams ARGS((tTree yyP228, tTree yyP227, int yyP226));
static void GenF90Results ARGS((tTree yyP231, tTree yyP230, int yyP229));
static void GenArrayDimSize ARGS((tTree yyP233, tTree yyP232));
static void GenExtParams ARGS((tTree yyP237, tTree yyP236, tIdent yyP235, int yyP234));
static void GenExtArrayParams ARGS((tTree yyP242, tTree yyP241, tTree yyP240, tIdent yyP239, int yyP238));
static void GenIntParams ARGS((tTree yyP246, tTree yyP245, tIdent yyP244, tSymbol yyP243));
static void GenChain ARGS((tIdent yyP249, tSymbol yyP248, bool yyP247));
static void GenIntArrayParams ARGS((tTree yyP255, tTree yyP254, tSymbol yyP253, tTree yyP252, tIdent yyP251, tSymbol yyP250));
static void GenFrameRef ARGS((tIdent yyP257, tSymbol yyP256));
static void GenFuncCall ARGS((tTree yyP260, tTree yyP259, tTree yyP258));
static void CodeMVFParams ARGS((tTree yyP263, bool yyP262, int yyP261));
static void CodeMVFTemps ARGS((tTree yyP265, int yyP264));
static void CodeMVFTempCopies ARGS((tTree yyP267, int yyP266));
static void GenParams ARGS((tTree yyP270, tTree yyP269, bool yyP268));
static void GenArrayParams ARGS((tTree yyP274, tTree yyP273, tTree yyP272, bool yyP271));
static void GenComma ARGS((bool yyP275));
static void GenTimerInput ARGS((tTree yyP276));
static void GenInput ARGS((tTree yyP278, tTree T, tTree yyP277));
static void GenInputToExpr ARGS((tTree yyP280, tTree yyP279));
static void GenOutput ARGS((tTree yyP283, tTree yyP282, tTree yyP281));
static void GenSeqProOutput ARGS((tTree yyP286, tTree yyP285, tTree yyP284));
static void GenSimpleOutput ARGS((tTree yyP289, tTree yyP288, tTree yyP287));
static void GenSimpleOutputOfExpr ARGS((tTree yyP292, tTree yyP291, tTree yyP290));
static void CodeElement ARGS((tTree yyP294, bool yyP293));
static void CodeChannelElement ARGS((tTree yyP296, bool yyP295));
static void GenArrayIndex ARGS((tSymbol yyP299, tTree yyP298, tTree yyP297));
static void GenElementSize ARGS((tTree yyP301, tTree yyP300));
static void GenArraySize ARGS((tSymbol yyP303, tTree yyP302));
static void CodeChkExpr ARGS((bool yyP308, bool yyP307, tTree yyP306, tSymbol yyP305, tTree yyP304));
static void CodeChkUBExpr ARGS((bool yyP314, bool yyP313, tTree yyP312, tTree yyP311, tSymbol yyP310, tTree yyP309));
static void CodeChkLBExpr ARGS((bool yyP316, tTree yyP315));
static tSymbol GetElementSymbol ARGS((tTree yyP317));
void CodeSymRef ARGS((tTree yyP320, tSymbol yyP319, bool yyP318));
static void CodeSym ARGS((tSymbol yyP321));
static void CodeIndirect ARGS((tSymbol yyP323, tTree yyP322));
static void CCodeTypeName ARGS((tTree yyP325, bool yyP324));
static void CCodeType ARGS((tTree yyP326));
static void CCodeTypeId ARGS((tTree yyP327));
static void CCodeTypeIdChkConst ARGS((tTree yyP329, tPosition yyP328));
void OccCodeType ARGS((tTree yyP330));
static void OccCodeProtocol ARGS((tTree yyP331));
static void CodeOp ARGS((tTree yyP332));
static int PrimTypeSize ARGS((tTree yyP333));
static tTree GetPrimType ARGS((tTree yyP334));
static bool IsPrimType ARGS((tTree yyP335));
bool IsScalarType ARGS((tTree yyP336));
static bool IsTimer ARGS((tTree yyP337));
static bool IsAtomicProcess ARGS((tTree yyP338));
bool IsAtomicProc ARGS((tTree yyP339));
bool IsParProc ARGS((tTree yyP340));
bool IsPrototype ARGS((tTree yyP341));
static bool IsBoundedType ARGS((tTree yyP342));
static bool IsByteArray ARGS((tTree yyP343));
static int CountArrayDims ARGS((tTree yyP344));
tTree GenOccPrototypes ARGS((tTree yyP345));
static void GenOccPrototypeFormals ARGS((tTree yyP346));
tTree GenCPrototype ARGS((tTree yyP347));
tTree GenCGDebug ARGS((tTree yyP348));
void CodeMainEntryParameters ARGS((tTree yyP349));
static bool IsSPChan ARGS((tTree yyP350));
void GenStatics ARGS((tTree yyP351));
static void GenStatic ARGS((tTree yyP352));
static void CodeConstArray ARGS((tTree yyP354, tConstArray yyP353));
static void GenStaticExpr ARGS((tTree yyP355));
static void GenStaticElement ARGS((tTree yyP357, int yyP356));
static void GenStaticExprList ARGS((tTree yyP358));
void GenShowValue ARGS((tTree yyP361, tTree yyP360, tSymbol yyP359));
static void GenShowSizes ARGS((tTree yyP364, tSymbol yyP363, int yyP362));
static void GenShowTests ARGS((tTree yyP367, tSymbol yyP366, int yyP365));
static void GenShowSymRef ARGS((tTree yyP369, tSymbol yyP368));
static void GenShowSym ARGS((tTree yyP371, tSymbol yyP370));
int MapKinds ARGS((tTree yyP374, tTree yyP373, tSymbol yyP372));
tSymbol CalcParent ARGS((tTree T));
tIdent CalcModule ARGS((tTree yyP375));
tStringRef CalcHeader ARGS((tTree yyP376));
tUsage CalcUsage ARGS((tTree yyP377));
bool IsLocal ARGS((tSymbol yyP378));
bool IsNonLocal ARGS((tSymbol yyP379));
bool IsAtomic ARGS((tTree yyP380));
static bool IsMVFunction ARGS((tTree yyP381));
static bool IsNewSymbol ARGS((tSymbol yyP382));
static void BeginBlock ARGS((tTree yyP383));
static void EndBlock ARGS((tTree yyP384));
static void BeginAtomicBlock ARGS((tTree yyP387, tTree yyP386, bool yyP385));
static void EndAtomicBlock ARGS((tTree yyP388));
void MarkRefParent ARGS((tSymbol yyP391, tTree yyP390, tVUsage yyP389));

tTree GenTypeDef
# if defined __STDC__ | defined __cplusplus
(register tTree T)
# else
(T)
 register tTree T;
# endif
{
  if (T->Kind == kStart) {
/* line 917 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  }
  if (T->Kind == kDefProc) {
/* line 919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("typedef struct SF_");
/* line 920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefProc.Sym);
/* line 920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" tSF_");
/* line 920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefProc.Sym);
/* line 920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 921 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((TreeRoot -> Start . OuterProc != T->DefProc.Sym))) goto yyL2;
  }
   return T -> DefProc . CGNext;
yyL2:;

/* line 924 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcHead (T);
/* line 925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> DefProc . CGNext;

  }
  if (T->Kind == kDefFunc) {
/* line 928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("typedef struct SF_");
/* line 929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefFunc.Sym);
/* line 929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" tSF_");
/* line 929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefFunc.Sym);
/* line 929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((TreeRoot -> Start . OuterProc != T->DefFunc.Sym))) goto yyL4;
  }
   return T -> DefFunc . CGNext;
yyL4:;

/* line 933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncHead (T);
/* line 934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> DefFunc . CGNext;

  }
  if (T->Kind == kPrototypeProc) {
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsDuplicatedPrototype (T->PrototypeProc.Sym) || CalcUsage (T) != xxUsed))) goto yyL6;
  }
   return T -> PrototypeProc . CGNext;
yyL6:;

/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsDuplicatedHeader (T->PrototypeProc.Sym)))) goto yyL7;
  {
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("#include \"");
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteModuleHeaderName (T->PrototypeProc.Pos . File);
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\"");
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 941 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL7;
  }
  }
   return T -> PrototypeProc . CGNext;
yyL7:;

/* line 944 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 944 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((T -> DefAProc . U == xxUsed))) goto yyL8;
  {
/* line 944 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsAtomicProc (T)))) goto yyL8;
  {
/* line 945 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("struct SF_");
/* line 945 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->PrototypeProc.Sym);
/* line 945 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 946 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 946 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tHeader _Header;");
/* line 947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("void *Chain;");
/* line 948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoFormals (T->PrototypeProc.Formals, 0);
/* line 949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenWS (T->PrototypeProc.Sym);
/* line 950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return T -> PrototypeProc . CGNext;
yyL8:;

/* line 954 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> PrototypeProc . CGNext;

  }
  if (T->Kind == kPrototypeFunc) {
/* line 956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsDuplicatedPrototype (T->PrototypeFunc.Sym) || CalcUsage (T) != xxUsed))) goto yyL10;
  }
   return T -> PrototypeFunc . CGNext;
yyL10:;

/* line 958 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 958 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsDuplicatedHeader (T->PrototypeFunc.Sym)))) goto yyL11;
  {
/* line 959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("#include \"");
/* line 959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteModuleHeaderName (T->PrototypeFunc.Pos . File);
/* line 959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\"");
/* line 959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return T -> PrototypeFunc . CGNext;
yyL11:;

/* line 962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> PrototypeFunc . CGNext;

  }
  if (T->Kind == kHCode) {
/* line 964 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> HCode . CGNext;

  }
 yyAbort ("GenTypeDef");
}

static void GenWS
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP1)
# else
(yyP1)
 tSymbol yyP1;
# endif
{
  {tSymbol yyT; yyT = 0;
  if (equaltSymbol (yyP1, yyT)) {
/* line 967 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
/* line 968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("char WS[WS_");
/* line 968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP1);
/* line 968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("];");
/* line 968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenProtoFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP3, register int yyP2)
# else
(yyP3, yyP2)
 register tTree yyP3;
 register int yyP2;
# endif
{
  if (yyP3->Kind == kNoFormal) {
/* line 972 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP3->Kind == kAFormal) {
/* line 973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP3->AFormal.Type)))) goto yyL2;
  {
/* line 973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoFormals (yyP3->AFormal.Next, yyP2 + 1);
  }
  }
   return;
yyL2:;

  if (yyP3->AFormal.Type->Kind == kArray) {
/* line 974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoArrayFormal (yyP3->AFormal.Type, yyP2);
/* line 974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoFormals (yyP3->AFormal.Next, yyP2 + 1);
  }
   return;

  }
  if (yyP3->AFormal.By->Kind == kByVal) {
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP3->AFormal.Type);
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP2);
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoFormals (yyP3->AFormal.Next, yyP2 + 1);
  }
   return;

  }
  if (yyP3->AFormal.By->Kind == kByRef) {
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP3->AFormal.Type);
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP2);
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoFormals (yyP3->AFormal.Next, yyP2 + 1);
  }
   return;

  }
  }
;
}

static void GenProtoArrayFormal
# if defined __STDC__ | defined __cplusplus
(register tTree yyP5, register int yyP4)
# else
(yyP5, yyP4)
 register tTree yyP5;
 register int yyP4;
# endif
{
  if (yyP5->Kind == kArray) {
  if (yyP5->Array.Expr->Kind == kUnBound) {
/* line 980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoArrayFormal (yyP5->Array.Type, yyP4);
/* line 980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP4);
/* line 980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP5));
/* line 980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 981 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 981 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoArrayFormal (yyP5->Array.Type, yyP4);
  }
   return;

  }
/* line 982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP5)))) goto yyL3;
  {
/* line 982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP5);
/* line 982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP4);
/* line 982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

/* line 983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP5);
/* line 983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP4);
/* line 983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

tTree GenDeclStruct
# if defined __STDC__ | defined __cplusplus
(register tTree T)
# else
(T)
 register tTree T;
# endif
{
  if (T->Kind == kStart) {
/* line 990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  }
  if (T->Kind == kDefProc) {
/* line 992 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 993 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("struct SF_");
/* line 993 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefProc.Sym);
/* line 993 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tHeader _Header;");
/* line 995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParentRef (T, T->DefProc.Sym);
/* line 996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *Chain;");
/* line 996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 997 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (T->DefProc.Formals, IsAtomicProc (T) && ! IsParProc (T));
/* line 998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->DefProc.Process, false);
/* line 999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> DefProc . CGNext;

  }
  if (T->Kind == kDefFunc) {
/* line 1002 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("struct SF_");
/* line 1003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefFunc.Sym);
/* line 1003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tHeader _Header;");
/* line 1005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParentRef (T, T->DefFunc.Sym);
/* line 1006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *Chain;");
/* line 1006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (T->DefFunc.Formals, true);
/* line 1008 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->DefFunc.Valof->Valof.SpecList);
/* line 1009 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->DefFunc.Valof->Valof.Process, false);
/* line 1010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 1010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> DefFunc . CGNext;

  }
  if (Tree_IsType (T, kDefAFunc)) {
/* line 1013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefAFunc . CGNext;

  }
  if (Tree_IsType (T, kDefAProc)) {
/* line 1014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefAProc . CGNext;

  }
  if (T->Kind == kHCode) {
/* line 1015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> HCode . CGNext;

  }
 yyAbort ("GenDeclStruct");
}

static void GenParentRef
# if defined __STDC__ | defined __cplusplus
(register tTree yyP7, tSymbol yyP6)
# else
(yyP7, yyP6)
 register tTree yyP7;
 tSymbol yyP6;
# endif
{
  if (yyP7->Kind == kDefProc) {
/* line 1018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsTopLevel (yyP6)))) goto yyL1;
  {
/* line 1018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP7 -> DefProc . Parent);
  }
  }
   return;
yyL1:;

  }
  if (yyP7->Kind == kDefFunc) {
/* line 1019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsTopLevel (yyP6)))) goto yyL2;
  {
/* line 1019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP7 -> DefFunc . Parent);
  }
  }
   return;
yyL2:;

  }
/* line 1020 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1020 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("void");
  }
   return;

;
}

static void GenDeclFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP9, register bool yyP8)
# else
(yyP9, yyP8)
 register tTree yyP9;
 register bool yyP8;
# endif
{
  if (yyP9->Kind == kNoFormal) {
/* line 1025 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP9->Kind == kAFormal) {
/* line 1027 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1027 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP9->AFormal.Type)))) goto yyL2;
  {
/* line 1028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (yyP9->AFormal.Next, yyP8);
  }
  }
   return;
yyL2:;

/* line 1031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP9->AFormal.Sym) && yyP8))) goto yyL3;
  {
/* line 1032 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (yyP9->AFormal.Next, yyP8);
  }
  }
   return;
yyL3:;

  if (yyP9->AFormal.Type->Kind == kArray) {
/* line 1035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArrayFormal (yyP9->AFormal.Type, yyP9->AFormal.Sym, true);
/* line 1037 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (yyP9->AFormal.Next, yyP8);
  }
   return;

  }
  if (yyP9->AFormal.By->Kind == kByVal) {
/* line 1040 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP9->AFormal.Type);
/* line 1041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP9->AFormal.Sym);
/* line 1041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (yyP9->AFormal.Next, yyP8);
  }
   return;

  }
  if (yyP9->AFormal.By->Kind == kByRef) {
/* line 1045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP9->AFormal.Type);
/* line 1046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP9->AFormal.Sym);
/* line 1046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (yyP9->AFormal.Next, yyP8);
  }
   return;

  }
  }
;
}

static void GenDeclArrayFormal
# if defined __STDC__ | defined __cplusplus
(register tTree yyP12, tSymbol yyP11, register bool yyP10)
# else
(yyP12, yyP11, yyP10)
 register tTree yyP12;
 tSymbol yyP11;
 register bool yyP10;
# endif
{
  if (yyP12->Kind == kArray) {
  if (yyP12->Array.Expr->Kind == kUnBound) {
  if (equalbool (yyP10, true)) {
/* line 1053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArrayFormal (yyP12->Array.Type, yyP11, true);
/* line 1054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP11);
/* line 1054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP12));
/* line 1054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 1056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArrayFormal (yyP12->Array.Type, yyP11, false);
  }
   return;

  }
/* line 1059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArrayFormal (yyP12->Array.Type, yyP11, yyP10);
  }
   return;

  }
/* line 1062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP12)))) goto yyL4;
  {
/* line 1063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP12);
/* line 1063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 1063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP11);
/* line 1063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

/* line 1065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP12);
/* line 1066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP11);
/* line 1066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenDeclProc
# if defined __STDC__ | defined __cplusplus
(register tTree P, register bool yyP13)
# else
(P, yyP13)
 register tTree P;
 register bool yyP13;
# endif
{

  switch (P->Kind) {
  case kAlt:
/* line 1075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->Alt.SpecList));
/* line 1077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Alt.SpecList);
/* line 1078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltTypeOuter (P, yyP13);
/* line 1079 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->Alt.AltList));
/* line 1080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->Alt.AltList, yyP13);
/* line 1081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1082 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kAltRep:
/* line 1084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->AltRep.SpecList));
/* line 1086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->AltRep.SpecList);
/* line 1087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltTypeOuter (P, yyP13);
/* line 1088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->AltRep.AltList, yyP13);
/* line 1089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kCaseIn:
/* line 1091 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1092 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->CaseIn.SpecList));
/* line 1093 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->CaseIn.SpecList);
/* line 1094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->CaseIn.CaseList));
/* line 1095 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->CaseIn.CaseList, yyP13);
/* line 1096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kSeq:
/* line 1101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->Seq.SpecList));
/* line 1103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Seq.SpecList);
/* line 1104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->Seq.ProcList));
/* line 1105 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->Seq.ProcList, yyP13);
/* line 1106 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kSeqRep:
/* line 1109 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->SeqRep.SpecList));
/* line 1111 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->SeqRep.SpecList);
/* line 1112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLRepState (P->SeqRep.Replicator);
/* line 1113 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (P->SeqRep.Process, yyP13);
/* line 1114 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kPar:
/* line 1116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, (NeedsSpecs (P->Par.SpecList) || NeedsSplit (P->Par.ProcList)));
/* line 1118 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Par.SpecList);
/* line 1119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->Par.ProcList, yyP13);
/* line 1120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kParRep:
/* line 1122 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1123 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->ParRep.SpecList));
/* line 1124 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->ParRep.SpecList);
/* line 1125 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLRepState (P->ParRep.Replicator);
/* line 1126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (P->ParRep.Process, yyP13);
/* line 1127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kProcessor:
/* line 1129 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1130 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->Processor.SpecList));
/* line 1131 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Processor.SpecList);
/* line 1132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (P->Processor.Process, yyP13);
/* line 1133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kIf:
/* line 1139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->If.SpecList));
/* line 1141 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->If.SpecList);
/* line 1142 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->If.ChoiceList));
/* line 1143 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->If.ChoiceList, yyP13);
/* line 1144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1145 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kIfRep:
/* line 1147 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->IfRep.SpecList));
/* line 1149 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->IfRep.SpecList);
/* line 1150 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLRepState (P->IfRep.Replicator);
/* line 1151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->IfRep.ChoiceList, yyP13);
/* line 1152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kCase:
/* line 1154 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1155 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->Case.SpecList));
/* line 1156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Case.SpecList);
/* line 1157 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->Case.ChoiceList));
/* line 1158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->Case.ChoiceList, yyP13);
/* line 1159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1160 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kWhile:
/* line 1162 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1163 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->While.SpecList));
/* line 1164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->While.SpecList);
/* line 1165 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (P->While.Process, yyP13);
/* line 1166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kInstance:
/* line 1179 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, P->Instance.SpecList -> SpecList . DCL > 1);
/* line 1181 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Instance.SpecList);
/* line 1182 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  }

/* line 1187 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1188 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, P->Process.SpecList -> SpecList . DCL > 1);
/* line 1189 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Process.SpecList);
/* line 1190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

;
}

static void GenDeclList
# if defined __STDC__ | defined __cplusplus
(register tTree T, register bool yyP14)
# else
(T, yyP14)
 register tTree T;
 register bool yyP14;
# endif
{
/* line 1198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool S2; 

  switch (T->Kind) {
  case kNoProcess:
/* line 1201 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kAProcess:
/* line 1203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1204 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->AProcess.Process, yyP14);
/* line 1205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->AProcess.Next, yyP14);
  }
   return;

  case kNoAlt:
/* line 1209 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kAnAlt:
/* line 1211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1212 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->AnAlt.SpecList));
/* line 1213 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->AnAlt.SpecList);
/* line 1214 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclGuard (T->AnAlt.Guard, S2);
/* line 1215 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1216 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->AnAlt.Next, yyP14);
  }
   return;

  case kANewAlt:
/* line 1218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->ANewAlt.SpecList));
/* line 1220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->ANewAlt.SpecList);
/* line 1221 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->ANewAlt.AltType, S2);
/* line 1222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1223 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->ANewAlt.Next, yyP14);
  }
   return;

  case kNoChoice:
/* line 1227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kAChoice:
/* line 1229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1230 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->AChoice.SpecList));
/* line 1231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->AChoice.SpecList);
/* line 1232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->AChoice.Process, S2);
/* line 1233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->AChoice.Next, yyP14);
  }
   return;

  case kANewIf:
/* line 1236 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1237 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->ANewIf.SpecList));
/* line 1238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->ANewIf.SpecList);
/* line 1239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->ANewIf.IfType, S2);
/* line 1240 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->ANewIf.Next, yyP14);
  }
   return;

  case kNoCase:
/* line 1245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kACase:
/* line 1247 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1248 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->ACase.SpecList));
/* line 1249 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->ACase.SpecList);
/* line 1250 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->ACase.Process, S2);
/* line 1251 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->ACase.Next, yyP14);
  }
   return;

  }

;
}

static void GenDeclGuard
# if defined __STDC__ | defined __cplusplus
(register tTree yyP16, register bool yyP15)
# else
(yyP16, yyP15)
 register tTree yyP16;
 register bool yyP15;
# endif
{
  if (yyP16->Kind == kAltInput) {
/* line 1260 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1261 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP15 = OpenSSpec (yyP15, (NeedsSpecs (yyP16->AltInput.Input->Input.SpecList) || NeedsSplit (yyP16->AltInput.Process)));
/* line 1262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltInput.Input, yyP15);
/* line 1263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltInput.Process, yyP15);
/* line 1264 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  }
  if (yyP16->Kind == kAltTimer) {
/* line 1266 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1267 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP15 = OpenSSpec (yyP15, (NeedsSpecs (yyP16->AltTimer.After->After.SpecList) || NeedsSplit (yyP16->AltTimer.Process)));
/* line 1268 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltTimer.After, yyP15);
/* line 1269 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltTimer.Process, yyP15);
/* line 1270 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  }
  if (yyP16->Kind == kAltCaseIn) {
/* line 1272 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltCaseIn.CaseIn, yyP15);
  }
   return;

  }
  if (yyP16->Kind == kNoInput) {
/* line 1275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->NoInput.Process, yyP15);
  }
   return;

  }
;
}

static void GenDeclAltTypeOuter
# if defined __STDC__ | defined __cplusplus
(register tTree yyP18, register bool yyP17)
# else
(yyP18, yyP17)
 register tTree yyP18;
 register bool yyP17;
# endif
{
/* line 1284 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1284 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP18 -> AltType . TLA))) goto yyL1;
  {
/* line 1285 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OpenSSpec (yyP17, (yyP18 -> AltType . ARC > 0));
/* line 1286 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltTypeInner (yyP18);
/* line 1287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
  }
   return;
yyL1:;

;
}

static void GenDeclAltTypeInner
# if defined __STDC__ | defined __cplusplus
(register tTree yyP19)
# else
(yyP19)
 register tTree yyP19;
# endif
{
  if (yyP19->Kind == kAlt) {
/* line 1292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltList (yyP19->Alt.AltList);
  }
   return;

  }
  if (yyP19->Kind == kAltRep) {
/* line 1294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltRep (yyP19->AltRep.Replicator);
/* line 1294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltList (yyP19->AltRep.AltList);
  }
   return;

  }
;
}

static void GenDeclAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP20)
# else
(yyP20)
 register tTree yyP20;
# endif
{
  if (yyP20->Kind == kNoAlt) {
/* line 1299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP20->Kind == kAnAlt) {
/* line 1301 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1301 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltList (yyP20->AnAlt.Next);
  }
   return;

  }
  if (yyP20->Kind == kANewAlt) {
/* line 1303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltTypeInner (yyP20->ANewAlt.AltType);
/* line 1303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltList (yyP20->ANewAlt.Next);
  }
   return;

  }
;
}

static void GenDeclAltRep
# if defined __STDC__ | defined __cplusplus
(register tTree yyP21)
# else
(yyP21)
 register tTree yyP21;
# endif
{
/* line 1310 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP21->Replicator.Sym);
/* line 1311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Alt;");
/* line 1311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1312 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLRepState (yyP21);
  }
   return;

;
}

static void GenNLRepState
# if defined __STDC__ | defined __cplusplus
(register tTree yyP22)
# else
(yyP22)
 register tTree yyP22;
# endif
{
/* line 1317 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1317 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsLocal (yyP22->Replicator.Sym)))) goto yyL1;
  {
/* line 1317 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP22->Replicator.From)))) goto yyL1;
  {
/* line 1317 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP22->Replicator.For)))) goto yyL1;
  {
/* line 1318 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1318 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP22->Replicator.Sym);
/* line 1318 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1318 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1319 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP22->Replicator.Sym, PrefixId (CurSpec () . PrefixId, Symbol (yyP22->Replicator.Sym) . CId, '.'));
  }
  }
  }
  }
   return;
yyL1:;

/* line 1322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsLocal (yyP22->Replicator.Sym)))) goto yyL2;
  {
/* line 1323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP22->Replicator.Sym);
/* line 1323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP22->Replicator.Sym);
/* line 1324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End;");
/* line 1324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP22->Replicator.Sym, PrefixId (CurSpec () . PrefixId, Symbol (yyP22->Replicator.Sym) . CId, '.'));
  }
  }
   return;
yyL2:;

;
}

static void GenDeclSpecs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP23)
# else
(yyP23)
 register tTree yyP23;
# endif
{
  if (yyP23->Kind == kNoSpec) {
/* line 1330 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP23->Kind == kASpec) {
/* line 1331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclNLSpec (yyP23->ASpec.Spec);
/* line 1331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (yyP23->ASpec.Next);
  }
   return;

  }
;
}

static void GenDeclNLSpec
# if defined __STDC__ | defined __cplusplus
(register tTree yyP24)
# else
(yyP24)
 register tTree yyP24;
# endif
{

  switch (yyP24->Kind) {
  case kDecl:
/* line 1338 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1338 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclNLIdList (yyP24->Decl.Type, yyP24->Decl.IdList);
  }
   return;

  case kVal:
/* line 1341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP24->Val.Sym)))) goto yyL2;
  }
   return;
yyL2:;

  break;
  case kValRetypes:
/* line 1342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP24->ValRetypes.Sym)))) goto yyL3;
  }
   return;
yyL3:;

  break;
  case kRetypes:
/* line 1343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP24->Retypes.Sym)))) goto yyL4;
  }
   return;
yyL4:;

  break;
  case kIs:
/* line 1344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP24->Is.Sym)))) goto yyL5;
  }
   return;
yyL5:;

  break;
  case kCallFrame:
/* line 1347 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1347 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProc (SymbolKind (yyP24->CallFrame.Sym))))) goto yyL6;
  }
   return;
yyL6:;

/* line 1348 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP24->CallFrame.Sym);
/* line 1349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->CallFrame.Id);
/* line 1349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->CallFrame.Id = PrefixId (CurSpec () . PrefixId, yyP24->CallFrame.Id, '.');
  }
   return;

  case kParFrame:
/* line 1352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP24->ParFrame.Rep > 0))) goto yyL8;
  {
/* line 1353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tTask ");
/* line 1353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->ParFrame.TId);
/* line 1353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 1353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP24->ParFrame.Rep);
/* line 1353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 1353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP24->ParFrame.Sym);
/* line 1354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->ParFrame.FId);
/* line 1354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 1354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP24->ParFrame.Rep);
/* line 1354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 1354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->ParFrame.TId = PrefixId (CurSpec () . PrefixId, yyP24->ParFrame.TId, '.');
/* line 1356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->ParFrame.FId = PrefixId (CurSpec () . PrefixId, yyP24->ParFrame.FId, '.');
  }
  }
   return;
yyL8:;

/* line 1359 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tTask ");
/* line 1360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->ParFrame.TId);
/* line 1360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP24->ParFrame.Sym);
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->ParFrame.FId);
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->ParFrame.TId = PrefixId (CurSpec () . PrefixId, yyP24->ParFrame.TId, '.');
/* line 1363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->ParFrame.FId = PrefixId (CurSpec () . PrefixId, yyP24->ParFrame.FId, '.');
  }
   return;

  case kDefAProc:
  case kDefProc:
  case kPrototypeProc:
/* line 1366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAFunc:
  case kDefFunc:
  case kDefIsFunc:
  case kPrototypeFunc:
/* line 1367 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAPro:
  case kDefSeqPro:
  case kDefTagPro:
/* line 1368 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kNullSpec:
/* line 1369 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }

/* line 1371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (yyP24);
  }
   return;

;
}

static void GenDeclSym
# if defined __STDC__ | defined __cplusplus
(register tTree yyP27, tSymbol yyP26, register bool yyP25)
# else
(yyP27, yyP26, yyP25)
 register tTree yyP27;
 tSymbol yyP26;
 register bool yyP25;
# endif
{
/* line 1377 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1377 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP27)))) goto yyL1;
  }
   return;
yyL1:;

  if (equalbool (yyP25, false)) {
/* line 1380 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1380 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (yyP26))))) goto yyL2;
  {
/* line 1381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP26));
/* line 1381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP26);
/* line 1381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_CHAN");
/* line 1381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (SymbolType (yyP26));
/* line 1381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP26));
/* line 1382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP26);
/* line 1382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (SymbolType (yyP26));
/* line 1382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP26, PrefixId (CurSpec () . PrefixId, Symbol (yyP26) . CId, '.'));
  }
  }
   return;
yyL2:;

  }
  if (equalbool (yyP25, false)) {
/* line 1386 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1387 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP26));
/* line 1387 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1387 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP26);
/* line 1387 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (SymbolType (yyP26));
/* line 1387 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1387 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1388 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP26, PrefixId (CurSpec () . PrefixId, Symbol (yyP26) . CId, '.'));
  }
   return;

  }
/* line 1391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP26));
/* line 1392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP26);
/* line 1392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (SymbolType (yyP26));
/* line 1392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1393 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP26, PrefixId (CurSpec () . PrefixId, Symbol (yyP26) . CId, '.'));
  }
   return;

;
}

static void GenDeclArraySym
# if defined __STDC__ | defined __cplusplus
(register tTree yyP29, tSymbol yyP28)
# else
(yyP29, yyP28)
 register tTree yyP29;
 tSymbol yyP28;
# endif
{
/* line 1399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP29)))) goto yyL1;
  }
   return;
yyL1:;

  if (yyP29->Kind == kArray) {
  if (yyP29->Array.Expr->Kind == kUnBound) {
/* line 1402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP28);
/* line 1403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP29));
/* line 1403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1404 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP29->Array.Type, yyP28);
  }
   return;

  }
/* line 1407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP29->Array.Expr)))) goto yyL3;
  {
/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP28);
/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP29));
/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("/*SMW*/");
/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1409 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP29->Array.Type, yyP28);
  }
  }
   return;
yyL3:;

/* line 1412 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1413 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP29->Array.Type, yyP28);
  }
   return;

  }
/* line 1416 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1416 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (yyP28))))) goto yyL5;
  {
/* line 1417 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP28));
/* line 1417 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 1417 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP28);
/* line 1417 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1417 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1418 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP28, PrefixId (CurSpec () . PrefixId, Symbol (yyP28) . CId, '.'));
  }
  }
   return;
yyL5:;

/* line 1421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP28));
/* line 1422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP28);
/* line 1422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1423 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP28, PrefixId (CurSpec () . PrefixId, Symbol (yyP28) . CId, '.'));
  }
   return;

;
}

static bool IsZeroSizeType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP30)
# else
(yyP30)
 register tTree yyP30;
# endif
{
  if (yyP30->Kind == kArray) {
/* line 1431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (((IsConstExpr (yyP30->Array.Expr)) && (ValConstInt (yyP30->Array.Expr) == 0)))) goto yyL1;
  }
   return true;
yyL1:;

/* line 1433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsZeroSizeType (yyP30->Array.Type);

  }
/* line 1435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return false;

}

static bool NeedsSpecs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP31)
# else
(yyP31)
 register tTree yyP31;
# endif
{
/* line 1440 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP31 -> SpecList . DCL > 0);

}

static bool NeedsSplit
# if defined __STDC__ | defined __cplusplus
(register tTree yyP32)
# else
(yyP32)
 register tTree yyP32;
# endif
{
  if (Tree_IsType (yyP32, kProcess)) {
/* line 1444 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> Process . SLC > 1);

  }
  if (Tree_IsType (yyP32, kProcList)) {
/* line 1445 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> ProcList . SLC > 1);

  }
  if (Tree_IsType (yyP32, kChoiceList)) {
/* line 1446 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> ChoiceList . SLC > 1);

  }
  if (Tree_IsType (yyP32, kAltList)) {
/* line 1447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> AltList . SLC > 1);

  }
  if (Tree_IsType (yyP32, kGuard)) {
/* line 1448 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> Guard . SLC > 1);

  }
  if (Tree_IsType (yyP32, kCaseList)) {
/* line 1449 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> CaseList . SLC > 1);

  }
 yyAbort ("NeedsSplit");
}

static void GenDeclNLIdList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP34, register tTree yyP33)
# else
(yyP34, yyP33)
 register tTree yyP34;
 register tTree yyP33;
# endif
{
  if (yyP33->Kind == kAnId) {
/* line 1454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP33->AnId.Sym)))) goto yyL1;
  {
/* line 1454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclNLIdList (yyP34, yyP33->AnId.Next);
  }
  }
   return;
yyL1:;

/* line 1455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP34, yyP33->AnId.Sym, false);
/* line 1455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclNLIdList (yyP34, yyP33->AnId.Next);
  }
   return;

  }
  if (yyP33->Kind == kNoId) {
/* line 1456 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenSpecState
# if defined __STDC__ | defined __cplusplus
(register tTree yyP35)
# else
(yyP35)
 register tTree yyP35;
# endif
{
  if (yyP35->Kind == kVal) {
  if (Tree_IsType (yyP35->Val.Expr, kStringElement)) {
/* line 1466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->Val.Expr)))) goto yyL1;
  {
/* line 1466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (ExprType (yyP35->Val.Expr))))) goto yyL1;
  {
/* line 1467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->Val.Type, yyP35->Val.Sym);
  }
  }
  }
   return;
yyL1:;

/* line 1485 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected string element", xxError, yyP35->Val.Pos);
  }
   return;

  }
  if (yyP35->Val.Expr->Kind == kElementalExpr) {
/* line 1469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->Val.Expr)))) goto yyL2;
  {
/* line 1469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (ExprType (yyP35->Val.Expr))))) goto yyL2;
  {
/* line 1470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->Val.Type, yyP35->Val.Sym);
  }
  }
  }
   return;
yyL2:;

  if (yyP35->Val.Expr->ElementalExpr.Elemental->Kind == kTable) {
/* line 1479 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1480 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->Val.Type, yyP35->Val.Sym, false);
  }
   return;

  }
  if (Tree_IsType (yyP35->Val.Expr->ElementalExpr.Elemental, kTableElement)) {
/* line 1482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1483 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table element", xxError, yyP35->Val.Pos);
  }
   return;

  }
  }
/* line 1524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP35->Val.Sym))))) goto yyL17;
  {
/* line 1524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->Val.Expr)))) goto yyL17;
  {
/* line 1524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsNewSymbol (yyP35->Val.Sym)))) goto yyL17;
  }
  }
  }
   return;
yyL17:;

/* line 1526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP35->Val.Sym))))) goto yyL18;
  {
/* line 1527 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (SymbolType (yyP35->Val.Sym), yyP35->Val.Sym, false);
  }
  }
   return;
yyL18:;

/* line 1530 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1531 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (SymbolType (yyP35->Val.Sym), yyP35->Val.Sym);
  }
   return;

  }
  if (yyP35->Kind == kValRetypes) {
  if (Tree_IsType (yyP35->ValRetypes.Expr, kStringElement)) {
/* line 1472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->ValRetypes.Expr)))) goto yyL3;
  {
/* line 1472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (yyP35->ValRetypes.Type)))) goto yyL3;
  {
/* line 1473 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym);
  }
  }
  }
   return;
yyL3:;

/* line 1491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected string retypes", xxError, yyP35->ValRetypes.Pos);
  }
   return;

  }
  if (yyP35->ValRetypes.Expr->Kind == kElementalExpr) {
/* line 1475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->ValRetypes.Expr)))) goto yyL4;
  {
/* line 1475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (yyP35->ValRetypes.Type)))) goto yyL4;
  {
/* line 1475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IS_Mode (xxEmulate)))) goto yyL4;
  {
/* line 1476 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym);
  }
  }
  }
  }
   return;
yyL4:;

  if (Tree_IsType (yyP35->ValRetypes.Expr->ElementalExpr.Elemental, kTableElement)) {
/* line 1488 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1489 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table retypes", xxError, yyP35->ValRetypes.Pos);
  }
   return;

  }
  }
/* line 1534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP35->ValRetypes.Type)))) goto yyL20;
  {
/* line 1535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym, false);
  }
  }
   return;
yyL20:;

/* line 1538 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1538 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL21;
  {
/* line 1538 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP35->ValRetypes.Type) != RetypeSize (ExprType (yyP35->ValRetypes.Expr))))) goto yyL21;
  {
/* line 1538 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsBoundedType (yyP35->ValRetypes.Type)))) goto yyL21;
  {
/* line 1539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym, false);
  }
  }
  }
  }
   return;
yyL21:;

/* line 1542 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1543 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym);
  }
   return;

  }
  if (yyP35->Kind == kIs) {
  if (yyP35->Is.Elemental->Kind == kTable) {
/* line 1494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1495 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->Is.Type, yyP35->Is.Sym, false);
  }
   return;

  }
  if (Tree_IsType (yyP35->Is.Elemental, kTableElement)) {
/* line 1497 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1498 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table element", xxError, yyP35->Is.Pos);
  }
   return;

  }
/* line 1502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP35->Is.Sym))))) goto yyL12;
  {
/* line 1503 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (SymbolType (yyP35->Is.Sym), yyP35->Is.Sym, false);
  }
  }
   return;
yyL12:;

/* line 1506 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1507 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (SymbolType (yyP35->Is.Sym), yyP35->Is.Sym);
  }
   return;

  }
  if (yyP35->Kind == kRetypes) {
/* line 1510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP35->Retypes.Type)))) goto yyL14;
  {
/* line 1511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->Retypes.Type, yyP35->Retypes.Sym, false);
  }
  }
   return;
yyL14:;

/* line 1514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL15;
  {
/* line 1514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP35->Retypes.Type) != RetypeSize (ElementType (yyP35->Retypes.Elemental))))) goto yyL15;
  {
/* line 1514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsBoundedType (yyP35->Retypes.Type)))) goto yyL15;
  {
/* line 1515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->Retypes.Type, yyP35->Retypes.Sym, false);
  }
  }
  }
  }
   return;
yyL15:;

/* line 1518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1519 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->Retypes.Type, yyP35->Retypes.Sym);
  }
   return;

  }
/* line 1547 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1547 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP35, yyP35->Spec.Pos);
  }
   return;

;
}

int CountRepDecls
# if defined __STDC__ | defined __cplusplus
(register tTree yyP36)
# else
(yyP36)
 register tTree yyP36;
# endif
{
/* line 1557 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1557 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP36->Replicator.Sym)))) goto yyL1;
  }
   return 0;
yyL1:;

/* line 1558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP36->Replicator.From)))) goto yyL2;
  {
/* line 1558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP36->Replicator.For)))) goto yyL2;
  }
  }
   return 1;
yyL2:;

/* line 1559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 2;

}

int CountAltRepDecls
# if defined __STDC__ | defined __cplusplus
(register tTree yyP37)
# else
(yyP37)
 register tTree yyP37;
# endif
{
/* line 1566 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return CountRepDecls (yyP37) + 1;

}

static int CountAbbrev
# if defined __STDC__ | defined __cplusplus
(register tTree yyP38)
# else
(yyP38)
 register tTree yyP38;
# endif
{
  if (yyP38->Kind == kArray) {
  if (yyP38->Array.Expr->Kind == kUnBound) {
/* line 1571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1 + CountAbbrev (yyP38->Array.Type);

  }
/* line 1573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP38->Array.Expr)))) goto yyL2;
  }
   return 1 + CountAbbrev (yyP38->Array.Type);
yyL2:;

/* line 1575 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return CountAbbrev (yyP38->Array.Type);

  }
/* line 1577 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

}

static int CountIdList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP39)
# else
(yyP39)
 register tTree yyP39;
# endif
{
  if (yyP39->Kind == kNoId) {
/* line 1583 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  }
  if (yyP39->Kind == kAnId) {
/* line 1584 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (IsNonLocal(yyP39->AnId.Sym)?CountIdList(yyP39->AnId.Next)+1:CountIdList(yyP39->AnId.Next));

  }
 yyAbort ("CountIdList");
}

static int CountDecl
# if defined __STDC__ | defined __cplusplus
(register tTree yyP40)
# else
(yyP40)
 register tTree yyP40;
# endif
{
/* line 1589 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1589 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP40->Decl.Type)))) goto yyL1;
  }
   return 0;
yyL1:;

/* line 1590 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1590 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP40->Decl.Type)))) goto yyL2;
  }
   return 2 * CountIdList (yyP40->Decl.IdList);
yyL2:;

/* line 1591 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return CountIdList (yyP40->Decl.IdList);

}

int CountSpec
# if defined __STDC__ | defined __cplusplus
(register tTree yyP41)
# else
(yyP41)
 register tTree yyP41;
# endif
{

  switch (yyP41->Kind) {
  case kDefAProc:
  case kDefProc:
  case kPrototypeProc:
/* line 1596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  case kDefAFunc:
  case kDefFunc:
  case kDefIsFunc:
  case kPrototypeFunc:
/* line 1597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  case kParFrame:
/* line 1599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 2;

  case kCallFrame:
/* line 1600 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

  case kDecl:
/* line 1602 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return CountDecl (yyP41);

  case kVal:
/* line 1604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP41->Val.Sym))))) goto yyL6;
  {
/* line 1604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP41->Val.Expr)))) goto yyL6;
  {
/* line 1604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsNewSymbol (yyP41->Val.Sym)))) goto yyL6;
  }
  }
  }
   return 0;
yyL6:;

/* line 1608 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsNonLocal(yyP41->Val.Sym)?CountAbbrev(SymbolType(yyP41->Val.Sym)):0;

  case kIs:
/* line 1606 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsNonLocal(yyP41->Is.Sym)?CountAbbrev(SymbolType(yyP41->Is.Sym)):0;

  case kRetypes:
/* line 1607 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsNonLocal(yyP41->Retypes.Sym)?CountAbbrev(SymbolType(yyP41->Retypes.Sym)):0;

  case kValRetypes:
/* line 1609 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsNonLocal(yyP41->ValRetypes.Sym)?CountAbbrev(SymbolType(yyP41->ValRetypes.Sym)):0;

  }

/* line 1611 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

}

tTree GenCode
# if defined __STDC__ | defined __cplusplus
(register tTree T)
# else
(T)
 register tTree T;
# endif
{

  switch (T->Kind) {
  case kStart:
/* line 1621 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  case kDefFunc:
/* line 1623 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1624 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (T->DefFunc.Pos);
/* line 1625 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CurProc = T;
/* line 1626 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   InitBlocks ();
/* line 1627 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncHead (T);
/* line 1627 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1628 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncEntry (T);
/* line 1629 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (T->DefFunc.Valof->Valof.SpecList, NoTree, false);
/* line 1630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (T->DefFunc.Valof->Valof.Process);
/* line 1631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncExit (T);
/* line 1632 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (T->DefFunc.Valof->Valof.SpecList);
/* line 1633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncTail (T);
  }
   return T -> DefFunc . CGNext;

  case kDefProc:
/* line 1636 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (T->DefProc.Pos);
/* line 1638 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CurProc = T;
/* line 1639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   InitBlocks ();
/* line 1640 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcHead (T);
/* line 1640 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1641 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcEntry (T);
/* line 1642 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (T->DefProc.Process);
/* line 1643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcTail (T);
  }
   return T -> DefProc . CGNext;

  case kDefIsFunc:
/* line 1646 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (T, T->DefIsFunc.Pos);
  }
   return T -> DefIsFunc . CGNext;

  case kDefAFunc:
  case kPrototypeFunc:
/* line 1650 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefAFunc . CGNext;

  case kDefAProc:
  case kPrototypeProc:
/* line 1651 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefAProc . CGNext;

  case kHCode:
/* line 1652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1653 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteCCode (T->HCode.Code, T->HCode.Pos, T -> HCode . Scope);
/* line 1654 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> HCode . CGNext;

  }

 yyAbort ("GenCode");
}

static void GenProcHead
# if defined __STDC__ | defined __cplusplus
(register tTree DP)
# else
(DP)
 register tTree DP;
# endif
{
/* line 1661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; 
/* line 1663 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1664 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! IsTopLevel (DP->DefProc.Sym), "static ");
/* line 1665 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("void ");
/* line 1665 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP->DefProc.Sym);
/* line 1665 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" (");
/* line 1666 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

/* line 1669 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1669 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsAtomicProc (DP) || IsParProc (DP)))) goto yyL2;
  {
/* line 1670 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1670 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP->DefProc.Sym);
/* line 1670 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *FP)");
  }
  }
   return;
yyL2:;

/* line 1673 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1673 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (DP)))) goto yyL3;
  {
/* line 1674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP -> DefProc . Parent);
/* line 1674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *PP");
/* line 1675 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 1676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 1679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1680 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = GenFormals (DP->DefProc.Formals, comma);
/* line 1681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! comma, "void");
/* line 1682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void GenProcEntry
# if defined __STDC__ | defined __cplusplus
(register tTree DP)
# else
(DP)
 register tTree DP;
# endif
{
/* line 1691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsAtomicProc (DP)))) goto yyL1;
  {
/* line 1692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1693 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("while(true)");
/* line 1693 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(FP->_Header.IP)");
/* line 1695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1697 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CurrentLabel = - 1;
/* line 1697 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1698 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLabel ();
/* line 1698 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (DP->DefProc.Formals);
  }
  }
   return;
yyL1:;

/* line 1701 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1701 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsParProc (DP)))) goto yyL2;
  {
/* line 1702 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1702 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1702 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1703 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (DP->DefProc.Formals);
  }
  }
   return;
yyL2:;

/* line 1706 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP->DefProc.Sym);
/* line 1708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" SF;");
/* line 1708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP->DefProc.Sym);
/* line 1709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *FP = &SF;");
/* line 1709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1710 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (DP->DefProc.Formals);
/* line 1711 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (DP->DefProc.Formals);
/* line 1712 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (DP)))) goto yyL3;
  {
/* line 1713 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->Chain = PP;");
/* line 1713 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

;
}

static void GenProcTail
# if defined __STDC__ | defined __cplusplus
(register tTree DP)
# else
(DP)
 register tTree DP;
# endif
{
/* line 1727 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1727 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP -> DefProc . isPar))) goto yyL1;
  {
/* line 1728 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENDP();");
/* line 1729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 1732 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1732 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProc (DP)))) goto yyL2;
  {
/* line 1733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BlankLine ();
  }
  }
   return;
yyL2:;

/* line 1737 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1737 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! DP -> DefProc . isPar))) goto yyL3;
  {
/* line 1738 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("RETURN();");
/* line 1739 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 1742 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1743 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1744 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: SETERR(MSG_IP);");
/* line 1744 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1745 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1745 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1745 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1746 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1746 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1746 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BlankLine ();
  }
   return;

;
}

static void GenFuncHead
# if defined __STDC__ | defined __cplusplus
(register tTree DF)
# else
(DF)
 register tTree DF;
# endif
{
/* line 1755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; 
  if (DF->DefFunc.TypeList->Kind == kAType) {
  if (DF->DefFunc.TypeList->AType.Next->Kind == kNoType) {
/* line 1757 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1758 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! IsTopLevel (DF->DefFunc.Sym), "static ");
/* line 1759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (DF->DefFunc.TypeList->AType.Type);
/* line 1759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF->DefFunc.Sym);
/* line 1759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 1760 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

  }
  }
/* line 1763 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1763 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsMVFunction (DF)))) goto yyL2;
  {
/* line 1764 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! IsTopLevel (DF->DefFunc.Sym), "static ");
/* line 1765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("void ");
/* line 1765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF->DefFunc.Sym);
/* line 1765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 1766 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
  }
   return;
yyL2:;

/* line 1769 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1769 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (DF)))) goto yyL3;
  {
/* line 1770 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1770 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF -> DefFunc . Parent);
/* line 1770 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *PP");
/* line 1771 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 1772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 1775 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1776 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = GenFormals (DF->DefFunc.Formals, comma);
/* line 1777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL4;
  }
   return;
yyL4:;

/* line 1780 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1780 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsMVFunction (DF)))) goto yyL5;
  {
/* line 1781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenMVFormals (DF->DefFunc.TypeList, 0, comma);
/* line 1782 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL5:;

/* line 1785 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1786 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! comma, "void ");
/* line 1787 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void GenFuncEntry
# if defined __STDC__ | defined __cplusplus
(register tTree DF)
# else
(DF)
 register tTree DF;
# endif
{
/* line 1794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1796 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsMVFunction (DF)))) goto yyL1;
  {
/* line 1797 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (DF->DefFunc.TypeList -> AType . Type);
/* line 1797 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" _Result;");
/* line 1797 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1798 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 1801 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1802 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1802 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF->DefFunc.Sym);
/* line 1802 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" SF;");
/* line 1802 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF->DefFunc.Sym);
/* line 1803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *FP = &SF;");
/* line 1803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (DF->DefFunc.Formals);
/* line 1805 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (DF->DefFunc.Formals);
/* line 1806 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (DF)))) goto yyL2;
  {
/* line 1807 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->Chain = PP;");
/* line 1807 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL2:;

;
}

static void GenFuncExit
# if defined __STDC__ | defined __cplusplus
(register tTree DF)
# else
(DF)
 register tTree DF;
# endif
{
/* line 1815 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1815 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsMVFunction (DF)))) goto yyL1;
  {
/* line 1816 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenMVFResult (DF->DefFunc.Valof->Valof.ExprList, 0);
  }
  }
   return;
yyL1:;

  if (DF->DefFunc.Valof->Valof.ExprList->Kind == kAnExpr) {
  if (DF->DefFunc.Valof->Valof.ExprList->AnExpr.Next->Kind == kNoExpr) {
/* line 1819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1820 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Result = ");
/* line 1820 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (DF->DefFunc.Valof->Valof.ExprList->AnExpr.Expr);
/* line 1820 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1820 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
;
}

static void GenFuncTail
# if defined __STDC__ | defined __cplusplus
(register tTree DF)
# else
(DF)
 register tTree DF;
# endif
{
/* line 1827 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1827 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsMVFunction (DF)))) goto yyL1;
  {
/* line 1828 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("return _Result;");
/* line 1828 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1829 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 1832 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1833 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1833 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1833 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1834 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BlankLine ();
  }
   return;

;
}

static bool GenFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP43, register bool yyP42)
# else
(yyP43, yyP42)
 register tTree yyP43;
 register bool yyP42;
# endif
{
/* line 1841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma; 
  if (yyP43->Kind == kNoFormal) {
/* line 1843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP42;

  }
  if (yyP43->Kind == kAFormal) {
/* line 1845 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1845 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP43->AFormal.Type)))) goto yyL2;
  {
/* line 1846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = GenFormals (yyP43->AFormal.Next, false);
  }
  }
   return comma;
yyL2:;

  if (yyP43->AFormal.Type->Kind == kArray) {
/* line 1849 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayFormal (yyP43->AFormal.Type, yyP43->AFormal.Sym, yyP42);
/* line 1851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (GenFormals (yyP43->AFormal.Next, true))) goto yyL3;
  }
   return true;
yyL3:;

  }
  if (yyP43->AFormal.By->Kind == kByVal) {
/* line 1854 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1855 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP42);
/* line 1856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP43->AFormal.Type);
/* line 1856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP43->AFormal.Sym);
/* line 1857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (GenFormals (yyP43->AFormal.Next, true))) goto yyL4;
  }
   return true;
yyL4:;

  }
  if (yyP43->AFormal.By->Kind == kByRef) {
/* line 1860 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP42);
/* line 1862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP43->AFormal.Type);
/* line 1862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP43->AFormal.Sym);
/* line 1863 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (GenFormals (yyP43->AFormal.Next, true))) goto yyL5;
  }
   return true;
yyL5:;

  }
  }
 yyAbort ("GenFormals");
}

static void GenArrayFormal
# if defined __STDC__ | defined __cplusplus
(register tTree yyP46, tSymbol yyP45, register bool yyP44)
# else
(yyP46, yyP45, yyP44)
 register tTree yyP46;
 tSymbol yyP45;
 register bool yyP44;
# endif
{
  if (yyP46->Kind == kArray) {
  if (yyP46->Array.Expr->Kind == kUnBound) {
/* line 1870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1871 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP44);
/* line 1872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP45);
/* line 1872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP46));
/* line 1873 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayFormal (yyP46->Array.Type, yyP45, true);
  }
   return;

  }
/* line 1876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1877 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayFormal (yyP46->Array.Type, yyP45, yyP44);
  }
   return;

  }
/* line 1880 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1880 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP46)))) goto yyL3;
  {
/* line 1881 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP44);
/* line 1882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP46);
/* line 1882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 1882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP45);
  }
  }
   return;
yyL3:;

/* line 1885 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1886 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP44);
/* line 1887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP46);
/* line 1887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP45);
  }
   return;

;
}

static void GenNLFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP47)
# else
(yyP47)
 register tTree yyP47;
# endif
{
  if (yyP47->Kind == kAFormal) {
/* line 1894 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1894 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP47->AFormal.Type)))) goto yyL1;
  {
/* line 1895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (yyP47->AFormal.Next);
  }
  }
   return;
yyL1:;

  if (yyP47->AFormal.Type->Kind == kArray) {
/* line 1898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP47->AFormal.Sym)))) goto yyL2;
  {
/* line 1899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLArrayFormal (yyP47->AFormal.Type, yyP47->AFormal.Sym);
/* line 1900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (yyP47->AFormal.Next);
  }
  }
   return;
yyL2:;

  }
/* line 1903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP47->AFormal.Sym)))) goto yyL3;
  {
/* line 1904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP47->AFormal.Sym);
/* line 1904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 1904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP47->AFormal.Sym);
/* line 1904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (yyP47->AFormal.Next);
  }
  }
   return;
yyL3:;

/* line 1908 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1909 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (yyP47->AFormal.Next);
  }
   return;

  }
  if (yyP47->Kind == kNoFormal) {
/* line 1912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenNLArrayFormal
# if defined __STDC__ | defined __cplusplus
(register tTree yyP49, tSymbol yyP48)
# else
(yyP49, yyP48)
 register tTree yyP49;
 tSymbol yyP48;
# endif
{
  if (yyP49->Kind == kArray) {
  if (yyP49->Array.Expr->Kind == kUnBound) {
/* line 1918 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP48);
/* line 1919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP49));
/* line 1919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 1920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP48);
/* line 1920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP49));
/* line 1920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1921 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLArrayFormal (yyP49->Array.Type, yyP48);
  }
   return;

  }
/* line 1923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1924 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLArrayFormal (yyP49->Array.Type, yyP48);
  }
   return;

  }
/* line 1926 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP48);
/* line 1927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 1927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP48);
/* line 1927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static bool AnyNLFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP50)
# else
(yyP50)
 register tTree yyP50;
# endif
{
  if (yyP50->Kind == kAFormal) {
/* line 1932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP50->AFormal.Sym)))) goto yyL1;
  }
   return true;
yyL1:;

/* line 1933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((AnyNLFormals (yyP50->AFormal.Next)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

static void GenMVFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP53, register int yyP52, register bool yyP51)
# else
(yyP53, yyP52, yyP51)
 register tTree yyP53;
 register int yyP52;
 register bool yyP51;
# endif
{
  if (yyP53->Kind == kNoType) {
/* line 1940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP53->Kind == kAType) {
  if (equalbool (yyP51, true)) {
/* line 1942 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1943 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 1944 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

  }
/* line 1947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP53->AType.Type);
/* line 1948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 1948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP52);
/* line 1949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenMVFormals (yyP53->AType.Next, yyP52 + 1, true);
  }
   return;

  }
;
}

static void GenMVFResult
# if defined __STDC__ | defined __cplusplus
(register tTree yyP55, register int yyP54)
# else
(yyP55, yyP54)
 register tTree yyP55;
 register int yyP54;
# endif
{
  if (yyP55->Kind == kNoExpr) {
/* line 1954 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP55->Kind == kAnExpr) {
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP54);
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP55->AnExpr.Expr);
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenMVFResult (yyP55->AnExpr.Next, yyP54 + 1);
  }
   return;

  }
;
}

static bool NeedsChain
# if defined __STDC__ | defined __cplusplus
(register tTree yyP56)
# else
(yyP56)
 register tTree yyP56;
# endif
{
  if (yyP56->Kind == kDefProc) {
/* line 1960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((UsesFreeVars (yyP56)))) goto yyL1;
  {
/* line 1960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsTopLevel (yyP56->DefProc.Sym)))) goto yyL1;
  }
  }
   return true;
yyL1:;

  }
  if (yyP56->Kind == kDefFunc) {
/* line 1961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((UsesFreeVars (yyP56)))) goto yyL2;
  {
/* line 1961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsTopLevel (yyP56->DefFunc.Sym)))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  return false;
}

static bool UsesFreeVars
# if defined __STDC__ | defined __cplusplus
(register tTree yyP57)
# else
(yyP57)
 register tTree yyP57;
# endif
{
  if (yyP57->Kind == kDefProc) {
/* line 1966 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1966 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsEmpty (& yyP57 -> DefProc . PUOut -> W) || ! IsEmpty (& yyP57 -> DefProc . PUOut -> R)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP57->Kind == kDefFunc) {
/* line 1967 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1967 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsEmpty (& yyP57->DefFunc.Valof->Valof.ExprList -> ExprList . PUOut -> R)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (yyP57->Kind == kPar) {
/* line 1968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsEmpty (& yyP57 -> Par . PUOut -> W) || ! IsEmpty (& yyP57 -> Par . PUOut -> R)))) goto yyL3;
  }
   return true;
yyL3:;

  }
  if (yyP57->Kind == kParRep) {
/* line 1969 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1969 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsEmpty (& yyP57 -> ParRep . PUOut -> W) || ! IsEmpty (& yyP57 -> ParRep . PUOut -> R)))) goto yyL4;
  }
   return true;
yyL4:;

  }
  return false;
}

static void GenProcess
# if defined __STDC__ | defined __cplusplus
(register tTree yyP58)
# else
(yyP58)
 register tTree yyP58;
# endif
{
/* line 1978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int le,ls,lab,endlab; 

  switch (yyP58->Kind) {
  case kAssign:
/* line 1981 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->Assign.SpecList, NoTree, false);
/* line 1984 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Assign.Pos);
/* line 1985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP58->Assign.Lval, yyP58->Assign.Rval);
/* line 1986 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->Assign.SpecList);
/* line 1987 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  case kCCode:
/* line 1991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1993 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->CCode.SpecList, NoTree, false);
/* line 1994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->CCode.Pos);
/* line 1995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteCCode (yyP58->CCode.Code, yyP58->CCode.Pos, yyP58 -> CCode . Scope);
/* line 1996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->CCode.SpecList);
/* line 1997 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  case kInstance:
/* line 2001 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->Instance.SpecList, NoTree, false);
/* line 2004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Instance.Pos);
/* line 2005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInstance (SymbolKind (yyP58->Instance.Sym), yyP58->Instance.ExprList, yyP58 -> Instance . Frame -> CallFrame . Id);
/* line 2006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->Instance.SpecList);
  }
   return;

  case kWhile:
/* line 2010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP58)))) goto yyL4;
  {
/* line 2012 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->While.SpecList, NoTree, false);
/* line 2013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->While.Pos);
/* line 2014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("while (");
/* line 2014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP58->While.Expr);
/* line 2014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 2014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP58->While.Process);
/* line 2017 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->While.Pos);
/* line 2018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->While.SpecList);
/* line 2020 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

/* line 2024 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2026 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = NewLabel ();
/* line 2026 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ls = NewLabel ();
/* line 2027 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->While.SpecList);
/* line 2028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->While.Pos);
/* line 2029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (le);
/* line 2029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (ls);
/* line 2031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP58->While.Process);
/* line 2032 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->While.Pos);
/* line 2033 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (le);
/* line 2034 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 2034 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP58->While.Expr);
/* line 2034 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 2034 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (ls);
/* line 2036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2037 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2037 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2037 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->While.SpecList);
  }
   return;

  case kCase:
/* line 2042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP58)))) goto yyL6;
  {
/* line 2044 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->Case.SpecList, NoTree, false);
/* line 2045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Case.Pos);
/* line 2046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(");
/* line 2046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP58->Case.Selector);
/* line 2046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 2046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseAtomic (yyP58->Case.ChoiceList, false);
/* line 2049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2050 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->Case.SpecList);
  }
  }
   return;
yyL6:;

/* line 2054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->Case.SpecList);
/* line 2058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Case.Pos);
/* line 2059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(");
/* line 2059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP58->Case.Selector);
/* line 2059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 2059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2061 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2061 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseSwitches (yyP58->Case.ChoiceList, false);
/* line 2062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseCode (yyP58->Case.ChoiceList, lab);
/* line 2065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->Case.SpecList);
  }
   return;

  case kIfType:
  case kIf:
  case kIfRep:
/* line 2070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP58)))) goto yyL8;
  {
/* line 2072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackIfType (yyP58) = NULL;
/* line 2073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfTypeAtomic (yyP58, false);
  }
  }
   return;
yyL8:;

/* line 2077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2079 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfType (yyP58, lab);
/* line 2081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("SETERR(MSG_IF);");
/* line 2081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2082 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

  case kSkip:
/* line 2086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->Skip.SpecList, NoTree, false);
/* line 2089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Skip.Pos);
/* line 2090 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->Skip.SpecList);
  }
   return;

  case kStop:
/* line 2094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->Stop.SpecList, NoTree, false);
/* line 2097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Stop.Pos);
/* line 2098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("SETERR(MSG_STOP);");
/* line 2099 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2100 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->Stop.SpecList);
  }
   return;

  case kSeq:
/* line 2104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP58)))) goto yyL12;
  {
/* line 2106 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->Seq.SpecList, NoTree, false);
/* line 2107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Seq.Pos);
/* line 2108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2109 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcList (yyP58->Seq.ProcList);
/* line 2110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2111 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->Seq.SpecList);
  }
  }
   return;
yyL12:;

/* line 2115 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->Seq.SpecList);
/* line 2118 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Seq.Pos);
/* line 2119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcList (yyP58->Seq.ProcList);
/* line 2120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->Seq.SpecList);
  }
   return;

  case kSeqRep:
/* line 2124 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2124 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP58->SeqRep.Replicator->Replicator.For)))) goto yyL14;
  {
/* line 2124 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((ValConstInt (yyP58->SeqRep.Replicator->Replicator.For) == 0))) goto yyL14;
  }
  }
   return;
yyL14:;

/* line 2127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP58)))) goto yyL15;
  {
/* line 2129 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->SeqRep.SpecList, yyP58->SeqRep.Replicator, false);
/* line 2130 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->SeqRep.Pos);
/* line 2131 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP58->SeqRep.Replicator);
/* line 2132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP58->SeqRep.Process);
/* line 2134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2135 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->SeqRep.Pos);
/* line 2136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->SeqRep.SpecList);
  }
  }
   return;
yyL15:;

/* line 2140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2142 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->SeqRep.SpecList);
/* line 2143 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->SeqRep.Pos);
/* line 2144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = GenRepStart (yyP58->SeqRep.Replicator);
/* line 2145 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ls = NewLabel ();
/* line 2146 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (ls);
/* line 2147 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP58->SeqRep.Process);
/* line 2148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->SeqRep.Pos);
/* line 2149 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenRepEnd (yyP58->SeqRep.Replicator, ls, le);
/* line 2150 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->SeqRep.SpecList);
  }
   return;

  case kInput:
/* line 2154 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2154 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (ElementType (yyP58->Input.Element))))) goto yyL17;
  {
/* line 2156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->Input.SpecList, NoTree, false);
/* line 2157 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Input.Pos);
/* line 2158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenTimerInput (yyP58->Input.ExprList);
/* line 2159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->Input.SpecList);
  }
  }
   return;
yyL17:;

/* line 2175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->Input.SpecList);
/* line 2175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Input.Pos);
/* line 2175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP58->Input.Element, ElementType (yyP58->Input.Element), yyP58->Input.ExprList);
/* line 2175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->Input.SpecList);
  }
   return;

  case kAfter:
/* line 2166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->After.SpecList);
/* line 2168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->After.Pos);
/* line 2169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DELAY(");
/* line 2170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP58->After.Expr);
/* line 2170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2172 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->After.SpecList);
  }
   return;

  case kOutput:
/* line 2177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->Output.SpecList);
/* line 2177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Output.Pos);
/* line 2177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOutput (yyP58->Output.Element, ElementType (yyP58->Output.Element) -> Chan . Protocol, yyP58->Output.ExprList);
/* line 2177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->Output.SpecList);
  }
   return;

  case kAltType:
  case kAlt:
  case kAltRep:
/* line 2179 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 {
  register tTree yyV1;
  {
/* line 2181 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->AltType.SpecList);
/* line 2182 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->AltType.Pos);
/* line 2183 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ALT();");
/* line 2183 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltType (yyP58);
/* line 2186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2187 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ALTWT(");
/* line 2187 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2187 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2187 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2188 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2191 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BOOL OLDTMP=false, TMP = false;");
/* line 2191 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltType (yyP58);
/* line 2193 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltType (yyP58);
/* line 2194 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2194 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2194 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2196 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ALTEND();");
/* line 2198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   endlab = NewLabel ();
/* line 2199 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoSpec)
   GenCodeAltType (yyP58, endlab, yyV1);
/* line 2200 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (endlab);
/* line 2201 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->AltType.SpecList);
  }
   return;
 }

  case kCaseIn:
/* line 2205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = NewLabel ();
/* line 2208 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->CaseIn.SpecList);
/* line 2209 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->CaseIn.Pos);
/* line 2210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT1(");
/* line 2210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP58->CaseIn.Element, false);
/* line 2210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.VBYTE,");
/* line 2210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (le);
/* line 2210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2212 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (le);
/* line 2213 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = NewLabel ();
/* line 2214 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(FP->_Header.Temp.VBYTE)");
/* line 2214 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2215 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2215 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2216 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2216 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInSwitches (yyP58->CaseIn.CaseList);
/* line 2217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInCode (yyP58->CaseIn.CaseList, yyP58->CaseIn.Element, le);
/* line 2220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (le);
/* line 2221 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->CaseIn.SpecList);
  }
   return;

  case kPar:
  if (yyP58->Par.ProcList->Kind == kNoProcess) {
/* line 2225 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->Par.SpecList);
/* line 2228 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Par.Pos);
/* line 2229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->Par.SpecList);
  }
   return;

  }
/* line 2232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP58->Par.PType == xxPlacedPar))) goto yyL24;
  {
/* line 2232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((UsesFreeVars (yyP58)))) goto yyL24;
  {
/* line 2232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxNoFreeVars)))) goto yyL24;
  {
/* line 2234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("PLACED PAR uses free variables", xxError, yyP58->Par.Pos);
  }
  }
  }
  }
   return;
yyL24:;

/* line 2238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP58->Par.PType == xxPlacedPar))) goto yyL25;
  {
/* line 2240 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->Par.SpecList);
/* line 2242 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Par.Pos);
/* line 2243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlacedList (yyP58->Par.ProcList, NoSymbol, NoTree);
/* line 2244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("WAITP(");
/* line 2244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2246 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->Par.SpecList);
  }
  }
   return;
yyL25:;

/* line 2250 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2253 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP58->Par.SpecList);
/* line 2254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->Par.Pos);
/* line 2255 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParList (yyP58->Par.ProcList, yyP58->Par.PType ? HIPRI : LOPRI);
/* line 2256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("WAITP(");
/* line 2256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2257 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2258 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->Par.SpecList);
  }
   return;

  case kParRep:
/* line 2262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP58->ParRep.Replicator->Replicator.For)))) goto yyL27;
  {
/* line 2262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((ValConstInt (yyP58->ParRep.Replicator->Replicator.For) == 0))) goto yyL27;
  }
  }
   return;
yyL27:;

/* line 2265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP58->ParRep.PType == xxPlacedPar))) goto yyL28;
  {
/* line 2265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((UsesFreeVars (yyP58)))) goto yyL28;
  {
/* line 2265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxNoFreeVars)))) goto yyL28;
  {
/* line 2267 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("PLACED PAR uses free variables", xxError, yyP58->ParRep.Pos);
  }
  }
  }
  }
   return;
yyL28:;

/* line 2271 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2271 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP58->ParRep.PType == xxPlacedPar))) goto yyL29;
  {
/* line 2273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2274 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->ParRep.SpecList, yyP58->ParRep.Replicator, false);
/* line 2275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->ParRep.Pos);
/* line 2276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP58->ParRep.Replicator);
/* line 2277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlaced (yyP58->ParRep.Process, yyP58->ParRep.Replicator->Replicator.Sym, yyP58->ParRep.Replicator->Replicator.From);
/* line 2279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->ParRep.Pos);
/* line 2280 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2280 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2280 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2281 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->ParRep.SpecList);
/* line 2282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("WAITP(");
/* line 2282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2284 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->ParRep.SpecList);
  }
  }
   return;
yyL29:;

  if (yyP58->ParRep.Process->Kind == kInstance) {
/* line 2288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP58->ParRep.SpecList, yyP58->ParRep.Replicator, false);
/* line 2292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->ParRep.Pos);
/* line 2293 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP58->ParRep.Replicator);
/* line 2294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP58->ParRep.PType == xxPriPar))) goto yyL30;
  {
/* line 2296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 2296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP58->ParRep.Replicator->Replicator.Sym);
/* line 2296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 2296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (ValConstInt (yyP58->ParRep.Replicator->Replicator.From));
/* line 2296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") ");
/* line 2296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2298 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProc (yyP58->ParRep.Process, yyP58->ParRep.Replicator->Replicator.Sym, HIPRI, yyP58->ParRep.Replicator->Replicator.From);
/* line 2299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->ParRep.Pos);
/* line 2301 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("else ");
/* line 2301 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL30;
  }
  }
   return;
yyL30:;

/* line 2306 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2309 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProc (yyP58->ParRep.Process, yyP58->ParRep.Replicator->Replicator.Sym, LOPRI, yyP58->ParRep.Replicator->Replicator.From);
/* line 2310 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP58->ParRep.Pos);
/* line 2311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2312 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP58->ParRep.SpecList);
/* line 2313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("WAITP(");
/* line 2313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2315 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP58->ParRep.SpecList);
  }
   return;

  }
  break;
  }

/* line 2322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP58, yyP58->Process.Pos);
  }
   return;

;
}

static void GenProcList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP59)
# else
(yyP59)
 register tTree yyP59;
# endif
{
  if (yyP59->Kind == kAProcess) {
/* line 2326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP59->AProcess.Process);
/* line 2326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcList (yyP59->AProcess.Next);
  }
   return;

  }
  if (yyP59->Kind == kNoProcess) {
/* line 2327 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenParList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP61, register int yyP60)
# else
(yyP61, yyP60)
 register tTree yyP61;
 register int yyP60;
# endif
{
  if (yyP61->Kind == kAProcess) {
  if (yyP61->AProcess.Process->Kind == kInstance) {
/* line 2331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2332 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProc (yyP61->AProcess.Process, NoSymbol, yyP60, NoTree);
/* line 2333 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParList (yyP61->AProcess.Next, LOPRI);
  }
   return;

  }
  }
  if (yyP61->Kind == kNoProcess) {
/* line 2336 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenParProc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP65, tSymbol yyP64, register int yyP63, register tTree yyP62)
# else
(yyP65, yyP64, yyP63, yyP62)
 register tTree yyP65;
 tSymbol yyP64;
 register int yyP63;
 register tTree yyP62;
# endif
{
/* line 2341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tTree Frame; 
/* line 2343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP64 != NoSymbol))) goto yyL1;
  {
/* line 2344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProcParam (Symbol (yyP65->Instance.Sym) . Kind -> DefProc . Formals, yyP65->Instance.ExprList, yyP65 -> Instance . Frame -> ParFrame . FId, yyP64, yyP62);
/* line 2345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 2348 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Frame = yyP65 -> Instance . Frame;
/* line 2350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP65->Instance.Pos);
/* line 2351 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("STARTP(");
/* line 2352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

/* line 2355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP64 == NoSymbol))) goto yyL3;
  {
/* line 2356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&FP->");
/* line 2356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . TId);
/* line 2356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP65->Instance.Sym);
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . FId);
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (Frame -> CallFrame . Sym);
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\",");
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP63);
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

/* line 2360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&FP->");
/* line 2361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . TId);
/* line 2362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP64) . Kind, yyP64, false);
/* line 2362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP62);
/* line 2362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP65->Instance.Sym);
/* line 2363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 2363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . FId);
/* line 2364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP64) . Kind, yyP64, false);
/* line 2364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP62);
/* line 2364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2365 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 2365 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (Frame -> CallFrame . Sym);
/* line 2365 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\",");
/* line 2365 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP63);
/* line 2365 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2365 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenPlacedList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP68, tSymbol yyP67, register tTree yyP66)
# else
(yyP68, yyP67, yyP66)
 register tTree yyP68;
 tSymbol yyP67;
 register tTree yyP66;
# endif
{
  if (yyP68->Kind == kAProcess) {
/* line 2372 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2372 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlaced (yyP68->AProcess.Process, yyP67, yyP66);
/* line 2372 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlacedList (yyP68->AProcess.Next, yyP67, yyP66);
  }
   return;

  }
  if (yyP68->Kind == kNoProcess) {
/* line 2373 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenPlaced
# if defined __STDC__ | defined __cplusplus
(register tTree yyP71, tSymbol yyP70, register tTree yyP69)
# else
(yyP71, yyP70, yyP69)
 register tTree yyP71;
 tSymbol yyP70;
 register tTree yyP69;
# endif
{
/* line 2377 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tFrame Frame; 
  if (yyP71->Kind == kPar) {
/* line 2379 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP71->Par.SpecList);
/* line 2382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP71->Par.Pos);
/* line 2383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlacedList (yyP71->Par.ProcList, yyP70, yyP69);
/* line 2384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP71->Par.SpecList);
  }
   return;

  }
  if (yyP71->Kind == kParRep) {
/* line 2388 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2388 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP70 == NoSymbol))) goto yyL2;
  {
/* line 2390 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP71->ParRep.SpecList, yyP71->ParRep.Replicator, false);
/* line 2391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP71->ParRep.Pos);
/* line 2392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP71->ParRep.Replicator);
/* line 2393 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2393 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2393 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2394 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlaced (yyP71->ParRep.Process, yyP71->ParRep.Replicator->Replicator.Sym, yyP71->ParRep.Replicator->Replicator.From);
/* line 2395 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP71->ParRep.Pos);
/* line 2396 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2396 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2396 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP71->ParRep.SpecList);
  }
  }
   return;
yyL2:;

/* line 2401 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP71, yyP71->ParRep.Pos);
  }
   return;

  }
  if (yyP71->Kind == kProcessor) {
  if (yyP71->Processor.Process->Kind == kInstance) {
/* line 2405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP70 != NoSymbol))) goto yyL4;
  {
/* line 2406 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProcParam (Symbol (yyP71->Processor.Process->Instance.Sym) . Kind -> DefProc . Formals, yyP71->Processor.Process->Instance.ExprList, yyP71->Processor.Process -> Instance . Frame -> ParFrame . FId, yyP70, yyP69);
/* line 2407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL4;
  }
  }
   return;
yyL4:;

/* line 2410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Frame = yyP71->Processor.Process -> Instance . Frame;
/* line 2412 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP71->Processor.Process->Instance.Pos);
/* line 2413 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("PLACED_STARTP(");
/* line 2414 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodePlacedExpr (yyP71->Processor.Expr, yyP70, yyP69);
/* line 2414 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2415 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL5;
  }
   return;
yyL5:;

/* line 2418 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2418 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP70 == NoSymbol))) goto yyL6;
  {
/* line 2419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&FP->");
/* line 2419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . TId);
/* line 2419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP71->Processor.Process->Instance.Sym);
/* line 2420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 2420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . FId);
/* line 2420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 2420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (Frame -> CallFrame . Sym);
/* line 2420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
/* line 2420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

/* line 2423 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&FP->");
/* line 2424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . TId);
/* line 2425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP70);
/* line 2425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP69);
/* line 2425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP71->Processor.Process->Instance.Sym);
/* line 2426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 2426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . FId);
/* line 2427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP70);
/* line 2427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP69);
/* line 2427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 2428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (Frame -> CallFrame . Sym);
/* line 2428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
/* line 2428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 2431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP71, yyP71->Process.Pos);
  }
   return;

;
}

static void CodePlacedExpr
# if defined __STDC__ | defined __cplusplus
(register tTree EX, tSymbol yyP73, register tTree yyP72)
# else
(EX, yyP73, yyP72)
 register tTree EX;
 tSymbol yyP73;
 register tTree yyP72;
# endif
{
  if (EX->Kind == kElementalExpr) {
  if (EX->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 2436 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP73);
/* line 2437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP72);
  }
   return;

  }
  }
  if (EX->Kind == kConst) {
/* line 2440 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (EX);
  }
   return;

  }
/* line 2444 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2445 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (EX, EX->Expr.Pos);
  }
   return;

;
}

static void GenParProcParam
# if defined __STDC__ | defined __cplusplus
(register tTree yyP78, register tTree yyP77, register tIdent yyP76, tSymbol yyP75, register tTree yyP74)
# else
(yyP78, yyP77, yyP76, yyP75, yyP74)
 register tTree yyP78;
 register tTree yyP77;
 register tIdent yyP76;
 tSymbol yyP75;
 register tTree yyP74;
# endif
{
  if (yyP78->Kind == kAFormal) {
  if (yyP78->AFormal.By->Kind == kByVal) {
  if (yyP77->Kind == kAnExpr) {
/* line 2452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2453 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 2453 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP76);
/* line 2453 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2453 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP75) . Kind, yyP75, false);
/* line 2453 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2453 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP74);
/* line 2453 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 2454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP78->AFormal.Sym);
/* line 2454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 2454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP77->AnExpr.Expr);
/* line 2454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  }
;
}

static void GenEnableAltType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP79)
# else
(yyP79)
 register tTree yyP79;
# endif
{
  if (yyP79->Kind == kAlt) {
/* line 2462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltList (yyP79->Alt.AltList);
  }
   return;

  }
  if (yyP79->Kind == kAltRep) {
/* line 2464 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2465 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP79->AltRep.Pos);
/* line 2466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP79->AltRep.Replicator);
/* line 2467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltList (yyP79->AltRep.AltList);
/* line 2469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP79->AltRep.Pos);
/* line 2470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenEnableAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP80)
# else
(yyP80)
 register tTree yyP80;
# endif
{
  if (yyP80->Kind == kNoAlt) {
/* line 2476 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP80->Kind == kAnAlt) {
/* line 2478 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2479 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP80->AnAlt.SpecList);
/* line 2480 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableGuard (yyP80->AnAlt.Guard);
/* line 2481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltList (yyP80->AnAlt.Next);
/* line 2482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP80->AnAlt.SpecList);
  }
   return;

  }
  if (yyP80->Kind == kANewAlt) {
/* line 2485 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP80->ANewAlt.SpecList);
/* line 2487 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP80->ANewAlt.AltType->AltType.SpecList);
/* line 2488 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltType (yyP80->ANewAlt.AltType);
/* line 2489 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltList (yyP80->ANewAlt.Next);
/* line 2490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP80->ANewAlt.AltType->AltType.SpecList);
/* line 2491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP80->ANewAlt.SpecList);
  }
   return;

  }
;
}

static void GenEnableGuard
# if defined __STDC__ | defined __cplusplus
(register tTree yyP81)
# else
(yyP81)
 register tTree yyP81;
# endif
{
  if (yyP81->Kind == kAltInput) {
/* line 2497 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2497 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimer (yyP81->AltInput.Input->Input.Element)))) goto yyL1;
  {
/* line 2498 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBS(");
/* line 2498 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP81->AltInput.Expr);
/* line 2499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL1:;

/* line 2502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2503 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBC(");
/* line 2503 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP81->AltInput.Expr);
/* line 2504 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2504 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP81->AltInput.Input->Input.Element, false);
/* line 2505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP81->Kind == kAltTimer) {
/* line 2508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBT(");
/* line 2509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP81->AltTimer.Expr);
/* line 2510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP81->AltTimer.After->After.Expr);
/* line 2511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP81->Kind == kAltCaseIn) {
/* line 2514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBC(");
/* line 2515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP81->AltCaseIn.Expr);
/* line 2516 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2516 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP81->AltCaseIn.CaseIn->CaseIn.Element, false);
/* line 2517 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2517 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP81->Kind == kNoInput) {
/* line 2520 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2521 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBS(");
/* line 2521 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP81->NoInput.Expr);
/* line 2522 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2522 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenDisableAltType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP82)
# else
(yyP82)
 register tTree yyP82;
# endif
{
  if (yyP82->Kind == kAlt) {
/* line 2529 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2529 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltList (yyP82->Alt.AltList);
  }
   return;

  }
  if (yyP82->Kind == kAltRep) {
/* line 2531 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2532 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2532 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2532 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2533 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BOOL OLDTMP = TMP;");
/* line 2533 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP82->AltRep.Replicator);
/* line 2535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2536 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltList (yyP82->AltRep.AltList);
/* line 2537 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (TMP && (!OLDTMP))");
/* line 2537 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAltSelect (yyP82->AltRep.Replicator);
/* line 2537 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 2537 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAltIndex (yyP82->AltRep.Replicator);
/* line 2537 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2537 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2538 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP;");
/* line 2538 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2540 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2540 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2540 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenDisableAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP83)
# else
(yyP83)
 register tTree yyP83;
# endif
{
  if (yyP83->Kind == kNoAlt) {
/* line 2547 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP83->Kind == kAnAlt) {
/* line 2549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2550 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP83->AnAlt.SpecList);
/* line 2551 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP83 -> AnAlt . Label = NewLabel ();
/* line 2552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableGuard (yyP83->AnAlt.Guard, yyP83 -> AnAlt . Label);
/* line 2553 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltList (yyP83->AnAlt.Next);
/* line 2554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP83->AnAlt.SpecList);
  }
   return;

  }
  if (yyP83->Kind == kANewAlt) {
/* line 2557 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP83->ANewAlt.SpecList);
/* line 2559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP83->ANewAlt.AltType->AltType.SpecList);
/* line 2560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltType (yyP83->ANewAlt.AltType);
/* line 2561 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltList (yyP83->ANewAlt.Next);
/* line 2562 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP83->ANewAlt.AltType->AltType.SpecList);
/* line 2563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP83->ANewAlt.SpecList);
  }
   return;

  }
;
}

static void GenDisableGuard
# if defined __STDC__ | defined __cplusplus
(register tTree yyP85, register int yyP84)
# else
(yyP85, yyP84)
 register tTree yyP85;
 register int yyP84;
# endif
{
  if (yyP85->Kind == kAltInput) {
/* line 2569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimer (yyP85->AltInput.Input->Input.Element)))) goto yyL1;
  {
/* line 2570 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DISS(");
/* line 2571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP84);
/* line 2572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP85->AltInput.Expr);
/* line 2573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL1:;

/* line 2576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2577 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DISC(");
/* line 2578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP84);
/* line 2579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP85->AltInput.Expr);
/* line 2580 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2580 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP85->AltInput.Input->Input.Element, false);
/* line 2581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP85->Kind == kAltTimer) {
/* line 2584 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DIST(");
/* line 2586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP84);
/* line 2587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP85->AltTimer.Expr);
/* line 2588 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2588 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP85->AltTimer.After->After.Expr);
/* line 2589 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2589 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP85->Kind == kAltCaseIn) {
/* line 2592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2593 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2594 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DISC(");
/* line 2594 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP84);
/* line 2595 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2595 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP85->AltCaseIn.Expr);
/* line 2596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP85->AltCaseIn.CaseIn->CaseIn.Element, false);
/* line 2597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP85->Kind == kNoInput) {
/* line 2600 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2602 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DISS(");
/* line 2602 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP84);
/* line 2603 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2603 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP85->NoInput.Expr);
/* line 2604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenAssignRepsAltType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP86)
# else
(yyP86)
 register tTree yyP86;
# endif
{
  if (yyP86->Kind == kAlt) {
/* line 2611 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2611 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltList (yyP86->Alt.AltList);
  }
   return;

  }
  if (yyP86->Kind == kAltRep) {
/* line 2613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2614 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAltIndex (yyP86->AltRep.Replicator);
/* line 2614 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 2614 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAltSelect (yyP86->AltRep.Replicator);
/* line 2614 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2614 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2615 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltList (yyP86->AltRep.AltList);
  }
   return;

  }
;
}

static void GenAssignRepsAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP87)
# else
(yyP87)
 register tTree yyP87;
# endif
{
  if (yyP87->Kind == kNoAlt) {
/* line 2621 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP87->Kind == kAnAlt) {
/* line 2623 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2624 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltList (yyP87->AnAlt.Next);
  }
   return;

  }
  if (yyP87->Kind == kANewAlt) {
/* line 2627 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2628 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltType (yyP87->ANewAlt.AltType);
/* line 2629 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltList (yyP87->ANewAlt.Next);
  }
   return;

  }
;
}

static tTree BuildRevSpecList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP89, register tTree yyP88)
# else
(yyP89, yyP88)
 register tTree yyP89;
 register tTree yyP88;
# endif
{
  if (yyP88->Kind == kNoSpec) {
/* line 2639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP89;

  }
  if (yyP88->Kind == kASpec) {
/* line 2640 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kASpec)
    yyV1->ASpec.Spec = yyP88->ASpec.Spec;
    yyV1->ASpec.Next = yyP89;
   return BuildRevSpecList (yyV1, yyP88->ASpec.Next);
  }
 }

  }
 yyAbort ("BuildRevSpecList");
}

static void GenCodeAltType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP92, register int yyP91, register tTree yyP90)
# else
(yyP92, yyP91, yyP90)
 register tTree yyP92;
 register int yyP91;
 register tTree yyP90;
# endif
{
  if (yyP92->Kind == kAlt) {
/* line 2646 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2646 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltList (yyP92->Alt.AltList, yyP91, yyP90);
  }
   return;

  }
  if (yyP92->Kind == kAltRep) {
/* line 2648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltList (yyP92->AltRep.AltList, yyP91, yyP90);
  }
   return;

  }
;
}

static void GenCodeAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP95, register int yyP94, register tTree yyP93)
# else
(yyP95, yyP94, yyP93)
 register tTree yyP95;
 register int yyP94;
 register tTree yyP93;
# endif
{
/* line 2660 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tTree UnreversedSL; 
  if (yyP95->Kind == kNoAlt) {
/* line 2662 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP95->Kind == kAnAlt) {
/* line 2664 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2665 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP95 -> AnAlt . Label);
/* line 2666 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   UnreversedSL = ReverseTree (yyP93);
/* line 2667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (UnreversedSL);
/* line 2668 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP95->AnAlt.SpecList);
/* line 2669 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeGuard (yyP95->AnAlt.Guard);
/* line 2670 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP95->AnAlt.SpecList);
/* line 2671 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (UnreversedSL);
/* line 2672 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2672 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP94);
/* line 2672 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2673 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReverseTree (UnreversedSL);
/* line 2674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltList (yyP95->AnAlt.Next, yyP94, yyP93);
  }
   return;

  }
  if (yyP95->Kind == kANewAlt) {
/* line 2677 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2678 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltType (yyP95->ANewAlt.AltType, yyP94, BuildRevSpecList (BuildRevSpecList (yyP93, yyP95->ANewAlt.SpecList), yyP95->ANewAlt.AltType->AltType.SpecList));
/* line 2679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltList (yyP95->ANewAlt.Next, yyP94, yyP93);
  }
   return;

  }
;
}

static void GenCodeGuard
# if defined __STDC__ | defined __cplusplus
(register tTree yyP96)
# else
(yyP96)
 register tTree yyP96;
# endif
{
/* line 2684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
  if (yyP96->Kind == kAltInput) {
/* line 2686 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2687 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP96->AltInput.Input->Input.SpecList);
/* line 2688 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP96->AltInput.Input->Input.Element, ElementType (yyP96->AltInput.Input->Input.Element), yyP96->AltInput.Input->Input.ExprList);
/* line 2689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP96->AltInput.Process);
/* line 2690 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP96->AltInput.Input->Input.SpecList);
  }
   return;

  }
  if (yyP96->Kind == kAltTimer) {
/* line 2692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2693 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP96->AltTimer.After->After.SpecList);
/* line 2694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP96->AltTimer.Process);
/* line 2695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP96->AltTimer.After->After.SpecList);
  }
   return;

  }
  if (yyP96->Kind == kAltCaseIn) {
/* line 2697 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2698 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2699 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP96->AltCaseIn.CaseIn->CaseIn.SpecList);
/* line 2700 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT1(");
/* line 2700 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP96->AltCaseIn.CaseIn->CaseIn.Element, false);
/* line 2700 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.VBYTE,");
/* line 2700 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2700 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2700 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2702 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2703 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2704 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(FP->_Header.Temp.VBYTE)");
/* line 2704 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2705 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2705 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2706 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2706 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInSwitches (yyP96->AltCaseIn.CaseIn->CaseIn.CaseList);
/* line 2707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInCode (yyP96->AltCaseIn.CaseIn->CaseIn.CaseList, yyP96->AltCaseIn.CaseIn->CaseIn.Element, lab);
/* line 2710 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2711 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP96->AltCaseIn.CaseIn->CaseIn.SpecList);
  }
   return;

  }
  if (yyP96->Kind == kNoInput) {
/* line 2713 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2714 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP96->NoInput.Process);
  }
   return;

  }
;
}

static void GenIfType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP98, register int yyP97)
# else
(yyP98, yyP97)
 register tTree yyP98;
 register int yyP97;
# endif
{
/* line 2723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int le,ls; 
  if (yyP98->Kind == kIf) {
/* line 2725 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2726 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP98->If.SpecList);
/* line 2727 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP98->If.Pos);
/* line 2728 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfList (yyP98->If.ChoiceList, yyP97);
/* line 2729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP98->If.SpecList);
  }
   return;

  }
  if (yyP98->Kind == kIfRep) {
/* line 2732 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = GenRepStart (yyP98->IfRep.Replicator);
/* line 2734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ls = NewLabel ();
/* line 2735 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (ls);
/* line 2736 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP98->IfRep.SpecList);
/* line 2737 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP98->IfRep.Pos);
/* line 2738 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfList (yyP98->IfRep.ChoiceList, yyP97);
/* line 2739 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenRepEnd (yyP98->IfRep.Replicator, ls, le);
/* line 2740 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP98->IfRep.SpecList);
  }
   return;

  }
;
}

static void GenIfList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP100, register int yyP99)
# else
(yyP100, yyP99)
 register tTree yyP100;
 register int yyP99;
# endif
{
/* line 2745 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int nlab; 
  if (yyP100->Kind == kAChoice) {
  if (yyP100->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP100->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
/* line 2747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP100->AChoice.SpecList);
/* line 2750 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP100->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
/* line 2751 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (!");
/* line 2751 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP100->AChoice.ExprList->AnExpr.Expr);
/* line 2751 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") GOTO(");
/* line 2751 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2751 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2751 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2752 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP100->AChoice.Process);
/* line 2753 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP100->AChoice.SpecList);
/* line 2754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP99);
/* line 2754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (nlab);
/* line 2756 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfList (yyP100->AChoice.Next, yyP99);
  }
   return;

  }
  }
  }
  if (yyP100->Kind == kANewIf) {
/* line 2759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2760 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP100->ANewIf.SpecList);
/* line 2761 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfType (yyP100->ANewIf.IfType, yyP99);
/* line 2762 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfList (yyP100->ANewIf.Next, yyP99);
/* line 2763 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP100->ANewIf.SpecList);
  }
   return;

  }
  if (yyP100->Kind == kNoChoice) {
/* line 2766 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenIfTypeAtomic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP102, register bool yyP101)
# else
(yyP102, yyP101)
 register tTree yyP102;
 register bool yyP101;
# endif
{
  if (yyP102->Kind == kIf) {
/* line 2775 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2776 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP102->If.SpecList, NoTree, false);
/* line 2777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP102->If.Pos);
/* line 2778 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (yyP102, yyP102->If.ChoiceList, yyP101);
/* line 2779 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP102->If.SpecList);
  }
   return;

  }
  if (yyP102->Kind == kIfRep) {
/* line 2782 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2783 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP102->IfRep.SpecList, yyP102->IfRep.Replicator, false);
/* line 2784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP102->IfRep.Pos);
/* line 2785 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP102->IfRep.Replicator);
/* line 2786 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2786 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2787 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (yyP102, yyP102->IfRep.ChoiceList, true);
/* line 2788 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2788 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2790 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForCheck (yyP102->IfRep.Replicator);
/* line 2791 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

/* line 2793 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2793 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((BackIfType (yyP102) != NULL))) goto yyL3;
  {
/* line 2794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (BackIfType (yyP102), BackChoiceList (yyP102), yyP101);
/* line 2795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP102->IfRep.SpecList);
  }
  }
   return;
yyL3:;

  if (equalbool (yyP101, false)) {
/* line 2798 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("SETERR(MSG_IF);");
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2800 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP102->IfRep.SpecList);
  }
   return;

  }
  if (equalbool (yyP101, true)) {
/* line 2803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("continue;");
/* line 2804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2805 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP102->IfRep.SpecList);
  }
   return;

  }
  }
;
}

static void GenIfListAtomic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP105, register tTree yyP104, register bool yyP103)
# else
(yyP105, yyP104, yyP103)
 register tTree yyP105;
 register tTree yyP104;
 register bool yyP103;
# endif
{
  if (yyP104->Kind == kAChoice) {
  if (yyP104->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP104->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
/* line 2814 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2815 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP104->AChoice.SpecList, NoTree, false);
/* line 2816 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP104->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
/* line 2817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 2817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP104->AChoice.ExprList->AnExpr.Expr);
/* line 2817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 2817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP104->AChoice.Process);
/* line 2818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("else");
/* line 2819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2820 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (yyP105, yyP104->AChoice.Next, yyP103);
/* line 2821 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP104->AChoice.SpecList);
  }
   return;

  }
  }
  }
  if (yyP104->Kind == kANewIf) {
  if (yyP104->ANewIf.IfType->Kind == kIf) {
/* line 2824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2825 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP104->ANewIf.SpecList, NoTree, false);
/* line 2826 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP104->ANewIf.IfType->If.Pos);
/* line 2827 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackIfType (yyP104->ANewIf.IfType) = yyP105;
/* line 2828 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackChoiceList (yyP104->ANewIf.IfType) = yyP104->ANewIf.Next;
/* line 2829 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfTypeAtomic (yyP104->ANewIf.IfType, yyP103);
/* line 2830 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP104->ANewIf.SpecList);
  }
   return;

  }
  if (yyP104->ANewIf.IfType->Kind == kIfRep) {
/* line 2833 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2834 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP104->ANewIf.SpecList, NoTree, false);
/* line 2835 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP104->ANewIf.IfType->IfRep.Pos);
/* line 2836 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackIfType (yyP104->ANewIf.IfType) = yyP105;
/* line 2837 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackChoiceList (yyP104->ANewIf.IfType) = yyP104->ANewIf.Next;
/* line 2838 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfTypeAtomic (yyP104->ANewIf.IfType, yyP103);
/* line 2839 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP104->ANewIf.SpecList);
  }
   return;

  }
  }
  if (yyP104->Kind == kNoChoice) {
/* line 2842 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2842 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((BackIfType (yyP105) != NULL))) goto yyL4;
  {
/* line 2842 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (yyP105, kIf)))) goto yyL4;
  {
/* line 2843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (BackIfType (yyP105), BackChoiceList (yyP105), yyP103);
  }
  }
  }
   return;
yyL4:;

  if (equalbool (yyP103, false)) {
/* line 2846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("SETERR(MSG_IF);");
/* line 2847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (equalbool (yyP103, true)) {
/* line 2850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("continue;");
/* line 2851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
;
}

static void GenCaseSwitches
# if defined __STDC__ | defined __cplusplus
(register tTree yyP107, register bool yyP106)
# else
(yyP107, yyP106)
 register tTree yyP107;
 register bool yyP106;
# endif
{
/* line 2858 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int nlab; 
  if (yyP107->Kind == kAChoice) {
  if (yyP107->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP107->AChoice.ExprList->AnExpr.Expr->Kind == kDefault) {
/* line 2860 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: GOTO(");
/* line 2862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2863 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP107 -> AChoice . Label = nlab;
/* line 2864 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseSwitches (yyP107->AChoice.Next, true);
  }
   return;

  }
  }
/* line 2867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2868 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2869 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseExprList (yyP107->AChoice.ExprList);
/* line 2870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO (");
/* line 2870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2871 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP107 -> AChoice . Label = nlab;
/* line 2872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseSwitches (yyP107->AChoice.Next, yyP106);
  }
   return;

  }
  if (yyP107->Kind == kNoChoice) {
  if (equalbool (yyP106, false)) {
/* line 2875 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: SETERR(MSG_CASE);");
/* line 2876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
;
}

static void GenCaseExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP108)
# else
(yyP108)
 register tTree yyP108;
# endif
{
  if (yyP108->Kind == kAnExpr) {
/* line 2882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("case ");
/* line 2883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP108->AnExpr.Expr);
/* line 2883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (": ");
/* line 2884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseExprList (yyP108->AnExpr.Next);
  }
   return;

  }
;
}

static void GenCaseCode
# if defined __STDC__ | defined __cplusplus
(register tTree yyP110, register int yyP109)
# else
(yyP110, yyP109)
 register tTree yyP110;
 register int yyP109;
# endif
{
  if (yyP110->Kind == kAChoice) {
/* line 2890 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2891 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP110 -> AChoice . Label);
/* line 2892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP110->AChoice.SpecList);
/* line 2893 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP110->AChoice.Process);
/* line 2894 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP110->AChoice.SpecList);
/* line 2895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP109);
/* line 2895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2896 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseCode (yyP110->AChoice.Next, yyP109);
  }
   return;

  }
  if (yyP110->Kind == kNoChoice) {
/* line 2899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenCaseAtomic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP112, register bool yyP111)
# else
(yyP112, yyP111)
 register tTree yyP112;
 register bool yyP111;
# endif
{
  if (yyP112->Kind == kAChoice) {
  if (yyP112->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP112->AChoice.ExprList->AnExpr.Expr->Kind == kDefault) {
/* line 2904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: ");
/* line 2905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP112->AChoice.SpecList, NoTree, false);
/* line 2907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP112->AChoice.Process);
/* line 2908 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP112->AChoice.SpecList);
/* line 2909 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2909 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2910 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseAtomic (yyP112->AChoice.Next, true);
  }
   return;

  }
  }
/* line 2913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseExprList (yyP112->AChoice.ExprList);
/* line 2914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2915 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP112->AChoice.SpecList, NoTree, false);
/* line 2916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP112->AChoice.Process);
/* line 2917 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP112->AChoice.SpecList);
/* line 2918 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2918 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseAtomic (yyP112->AChoice.Next, yyP111);
  }
   return;

  }
  if (yyP112->Kind == kNoChoice) {
  if (equalbool (yyP111, false)) {
/* line 2922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: SETERR(MSG_CASE);");
/* line 2923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
;
}

static void GenCaseInSwitches
# if defined __STDC__ | defined __cplusplus
(register tTree yyP113)
# else
(yyP113)
 register tTree yyP113;
# endif
{
/* line 2929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int nlab; 
  if (yyP113->Kind == kACase) {
  if (yyP113->ACase.Next->Kind == kNoCase) {
  if (yyP113->ACase.ExprList->Kind == kAnExpr) {
  if (yyP113->ACase.ExprList->AnExpr.Expr->Kind == kDefault) {
/* line 2934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2935 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2936 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: GOTO(");
/* line 2936 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2936 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2936 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP113 -> ACase . Label = nlab;
  }
   return;

  }
  }
  }
  if (yyP113->ACase.ExprList->Kind == kAnExpr) {
  if (yyP113->ACase.ExprList->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP113->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 2940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2941 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2942 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("case ");
/* line 2942 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP113->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 2942 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (": ");
/* line 2943 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO (");
/* line 2943 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2943 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2943 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2944 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP113 -> ACase . Label = nlab;
/* line 2945 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInSwitches (yyP113->ACase.Next);
  }
   return;

  }
  }
  }
  }
  if (yyP113->Kind == kNoCase) {
/* line 2948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: SETERR(MSG_CASEIN);");
/* line 2949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenCaseInCode
# if defined __STDC__ | defined __cplusplus
(register tTree yyP116, register tTree yyP115, register int yyP114)
# else
(yyP116, yyP115, yyP114)
 register tTree yyP116;
 register tTree yyP115;
 register int yyP114;
# endif
{
  if (yyP116->Kind == kACase) {
  if (yyP116->ACase.ExprList->Kind == kAnExpr) {
/* line 2955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP116 -> ACase . Label);
/* line 2957 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP116->ACase.SpecList);
/* line 2958 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP116->ACase.ExprList->AnExpr.Expr->Expr.Pos);
/* line 2959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP115, ElementType (yyP115), yyP116->ACase.ExprList->AnExpr.Next);
/* line 2960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP116->ACase.Process);
/* line 2961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP116->ACase.SpecList);
/* line 2962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP114);
/* line 2962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInCode (yyP116->ACase.Next, yyP115, yyP114);
  }
   return;

  }
  }
  if (yyP116->Kind == kNoCase) {
/* line 2966 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenSetScope
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP117)
# else
(yyP117)
 tSymbol yyP117;
# endif
{
/* line 2973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxOccamDebug)))) goto yyL1;
  {
/* line 2973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP117 <= OccSymSize))) goto yyL1;
  {
/* line 2974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr ("SETSCOPE(");
/* line 2974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP117 - 1);
/* line 2974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

;
}

static void GenSetListScope
# if defined __STDC__ | defined __cplusplus
(register tTree yyP118)
# else
(yyP118)
 register tTree yyP118;
# endif
{
  if (yyP118->Kind == kAnId) {
  if (yyP118->AnId.Next->Kind == kNoId) {
/* line 2979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP118->AnId.Sym);
  }
   return;

  }
/* line 2980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (yyP118->AnId.Next);
  }
   return;

  }
  if (yyP118->Kind == kAFormal) {
  if (yyP118->AFormal.Next->Kind == kNoFormal) {
/* line 2981 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2981 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP118->AFormal.Sym);
  }
   return;

  }
/* line 2982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (yyP118->AFormal.Next);
  }
   return;

  }
;
}

static void GenLocalSpecs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP119)
# else
(yyP119)
 register tTree yyP119;
# endif
{
  if (yyP119->Kind == kASpec) {
/* line 2987 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2987 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP119->ASpec.Spec->Spec.Pos);
/* line 2987 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalSpec (yyP119->ASpec.Spec);
/* line 2987 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalSpecs (yyP119->ASpec.Next);
  }
   return;

  }
  if (yyP119->Kind == kNoSpec) {
/* line 2988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenLocalSpec
# if defined __STDC__ | defined __cplusplus
(register tTree SP)
# else
(SP)
 register tTree SP;
# endif
{
  if (SP->Kind == kDecl) {
/* line 2994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalIdList (SP->Decl.Type, SP->Decl.IdList);
/* line 2994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

  }
  if (SP->Kind == kVal) {
/* line 2996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (SP->Val.Sym)))) goto yyL2;
  {
/* line 2996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (SP);
  }
  }
   return;
yyL2:;

  }
  if (SP->Kind == kValRetypes) {
/* line 2997 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2997 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (SP->ValRetypes.Sym)))) goto yyL3;
  {
/* line 2997 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2997 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (SP);
  }
  }
   return;
yyL3:;

  }
  if (SP->Kind == kRetypes) {
/* line 2998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (SP->Retypes.Sym)))) goto yyL4;
  {
/* line 2998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (SP);
  }
  }
   return;
yyL4:;

  }
  if (SP->Kind == kIs) {
/* line 2999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (SP->Is.Sym)))) goto yyL5;
  {
/* line 2999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (SP);
  }
  }
   return;
yyL5:;

  }
/* line 3002 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

;
}

static void GenLocalRep
# if defined __STDC__ | defined __cplusplus
(register tTree yyP120)
# else
(yyP120)
 register tTree yyP120;
# endif
{
/* line 3007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP120->Replicator.Sym)))) goto yyL1;
  {
/* line 3007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP120->Replicator.From)))) goto yyL1;
  {
/* line 3007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP120->Replicator.For)))) goto yyL1;
  {
/* line 3008 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 3009 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 3009 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP120->Replicator.Sym);
/* line 3009 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3009 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP120->Replicator.Sym, PrefixId (CurSpec () . PrefixId, Symbol (yyP120->Replicator.Sym) . CId, '.'));
  }
  }
  }
  }
   return;
yyL1:;

/* line 3013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP120->Replicator.Sym)))) goto yyL2;
  {
/* line 3014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 3015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 3015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP120->Replicator.Sym);
/* line 3015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 3016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP120->Replicator.Sym);
/* line 3016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End;");
/* line 3016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3017 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP120->Replicator.Sym, PrefixId (CurSpec () . PrefixId, Symbol (yyP120->Replicator.Sym) . CId, '.'));
  }
  }
   return;
yyL2:;

;
}

static void GenLocalIdList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP122, register tTree yyP121)
# else
(yyP122, yyP121)
 register tTree yyP122;
 register tTree yyP121;
# endif
{
  if (yyP121->Kind == kAnId) {
/* line 3022 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3022 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP121->AnId.Sym)))) goto yyL1;
  {
/* line 3022 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 3022 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP122, yyP121->AnId.Sym, false);
/* line 3022 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalIdList (yyP122, yyP121->AnId.Next);
  }
  }
   return;
yyL1:;

/* line 3023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalIdList (yyP122, yyP121->AnId.Next);
  }
   return;

  }
  if (yyP121->Kind == kNoId) {
/* line 3024 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenLocalInits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP123)
# else
(yyP123)
 register tTree yyP123;
# endif
{
  if (yyP123->Kind == kASpec) {
/* line 3030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP123->ASpec.Spec->Spec.Pos);
/* line 3030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInit (yyP123->ASpec.Spec);
/* line 3030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP123->ASpec.Next);
  }
   return;

  }
  if (yyP123->Kind == kNoSpec) {
/* line 3031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenLocalInit
# if defined __STDC__ | defined __cplusplus
(register tTree SP)
# else
(SP)
 register tTree SP;
# endif
{
  if (SP->Kind == kDecl) {
  if (SP->Decl.Type->Kind == kChan) {
/* line 3036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (SP->Decl.IdList);
/* line 3036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanList (SP->Decl.IdList);
  }
   return;

  }
  if (SP->Decl.Type->Kind == kArray) {
/* line 3038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SP->Decl.Type)))) goto yyL2;
  {
/* line 3038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (SP->Decl.IdList);
/* line 3038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanArrayList (SP->Decl.Type, SP->Decl.IdList);
  }
  }
   return;
yyL2:;

  }
/* line 3040 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3040 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (SP->Decl.IdList);
  }
   return;

  }
  if (Tree_IsType (SP, kAVal)) {
/* line 3043 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3043 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (ExprType (SP->AVal.Expr))))) goto yyL4;
  {
/* line 3044 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->AVal.Sym);
/* line 3045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->AVal.Sym);
/* line 3045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 3045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

  }

  switch (SP->Kind) {
  case kIs:
/* line 3047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (ExprType (SP->Is.Elemental))))) goto yyL5;
  {
/* line 3048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 3049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 3049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL5:;

/* line 3163 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3163 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (SymbolType (SP->Is.Sym))))) goto yyL24;
  }
   return;
yyL24:;

  if (SP->Is.Elemental->Kind == kTable) {
/* line 3165 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitTable (SP->Is.Sym, 0, SP->Is.Elemental->Table.ExprList);
  }
   return;

  }
  if (Tree_IsType (SP->Is.Elemental, kElement)) {
/* line 3169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (SP->Is.Sym))))) goto yyL26;
  {
/* line 3169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (SP->Is.Sym))))) goto yyL26;
  {
/* line 3170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Is.Sym), false);
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (SP->Is.Elemental, false);
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL26:;

/* line 3173 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3173 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (SP->Is.Sym))))) goto yyL27;
  {
/* line 3174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 3175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Is.Sym), true);
/* line 3175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (SP->Is.Elemental, true);
/* line 3175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3176 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (SP->Is.Sym, SymbolType (SP->Is.Sym), SP->Is.Elemental, GetElementSymbol (SP->Is.Elemental), ElementType (SP->Is.Elemental));
  }
  }
   return;
yyL27:;

/* line 3178 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3178 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (SP->Is.Sym))))) goto yyL28;
  {
/* line 3179 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 3180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (SP->Is.Elemental, false);
/* line 3180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL28:;

/* line 3182 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3183 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Is.Sym), true);
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (SP->Is.Elemental, true);
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (SP->Is.Sym, SymbolType (SP->Is.Sym), SP->Is.Elemental, GetElementSymbol (SP->Is.Elemental), ElementType (SP->Is.Elemental));
  }
   return;

  }
  break;
  case kRetypes:
/* line 3051 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3051 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (SP->Retypes.Type)))) goto yyL6;
  {
/* line 3052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 3053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 3053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 3053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

  if (Tree_IsType (SP->Retypes.Elemental, kElement)) {
/* line 3058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SP->Retypes.Type)))) goto yyL7;
  {
/* line 3058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SP->Retypes.Type)))) goto yyL7;
  {
/* line 3059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 3060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 3060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->Retypes.Type, false);
/* line 3060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (SP->Retypes.Elemental, false);
/* line 3060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL7:;

/* line 3063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SP->Retypes.Type)))) goto yyL8;
  {
/* line 3064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 3065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 3065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->Retypes.Type, true);
/* line 3065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (SP->Retypes.Elemental, true);
/* line 3065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (SP->Retypes.Sym, SP->Retypes.Type, SP->Retypes.Elemental, GetElementSymbol (SP->Retypes.Elemental), ElementType (SP->Retypes.Elemental));
  }
  }
   return;
yyL8:;

/* line 3069 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3069 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL9;
  {
/* line 3070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEmuRetype (SP->Retypes.Type, SP->Retypes.Sym, ElementType (SP->Retypes.Elemental), SP->Retypes.Elemental);
  }
  }
   return;
yyL9:;

/* line 3073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SP->Retypes.Type)))) goto yyL10;
  {
/* line 3074 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 3075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 3075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = *");
/* line 3075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->Retypes.Type, true);
/* line 3075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (SP->Retypes.Elemental, true);
/* line 3075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL10:;

/* line 3078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3079 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 3080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 3080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->Retypes.Type, true);
/* line 3080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (SP->Retypes.Elemental, true);
/* line 3080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (SP->Retypes.Sym, SP->Retypes.Type, SP->Retypes.Elemental, GetElementSymbol (SP->Retypes.Elemental), ElementType (SP->Retypes.Elemental));
  }
   return;

  }
  break;
  case kValRetypes:
/* line 3086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL12;
  {
/* line 3086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (SP->ValRetypes.Expr))))) goto yyL12;
  {
/* line 3086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->ValRetypes.Expr)))) goto yyL12;
  {
/* line 3087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 3088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->ValRetypes.Expr));
/* line 3088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP; TMP = ");
/* line 3088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (SP->ValRetypes.Expr);
/* line 3088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3090 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("RETYPE(");
/* line 3090 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (SP->ValRetypes.Type));
/* line 3090 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("^");
/* line 3090 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (ExprType (SP->ValRetypes.Expr)));
/* line 3090 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3091 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (SP->ValRetypes.Type, SP->ValRetypes.Sym, 1);
/* line 3091 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3092 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (SymbolKind (SP->ValRetypes.Sym), SP->ValRetypes.Sym, true);
/* line 3092 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3093 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP);");
/* line 3093 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
   return;
yyL12:;

  if (SP->ValRetypes.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (SP->ValRetypes.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL13;
  {
/* line 3098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEmuRetype (SP->ValRetypes.Type, SP->ValRetypes.Sym, ExprType (SP->ValRetypes.Expr), SP->ValRetypes.Expr->ElementalExpr.Elemental);
  }
  }
   return;
yyL13:;

  }
  }
/* line 3101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SP->ValRetypes.Type)))) goto yyL14;
  {
/* line 3101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (SP->ValRetypes.Expr))))) goto yyL14;
  {
/* line 3102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*(");
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (ExprType (SP->ValRetypes.Expr), true);
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (SymbolKind (SP->ValRetypes.Sym), SP->ValRetypes.Sym, true);
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") = ");
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (SP->ValRetypes.Expr);
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL14:;

/* line 3106 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3106 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (SP->ValRetypes.Expr))))) goto yyL15;
  {
/* line 3106 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->ValRetypes.Expr)))) goto yyL15;
  {
/* line 3107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 3108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->ValRetypes.Expr));
/* line 3108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP; TMP = ");
/* line 3108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (SP->ValRetypes.Expr);
/* line 3108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3109 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->ValRetypes.Sym);
/* line 3110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->ValRetypes.Type, true);
/* line 3110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP;");
/* line 3110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3111 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3111 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3111 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL15:;

  if (SP->ValRetypes.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (SP->ValRetypes.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3114 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3114 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SP->ValRetypes.Type)))) goto yyL16;
  {
/* line 3115 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->ValRetypes.Sym);
/* line 3116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = *(");
/* line 3116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->ValRetypes.Type, true);
/* line 3116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (SP->ValRetypes.Expr, true);
/* line 3116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (SP->ValRetypes.Sym, SP->ValRetypes.Type, SP->ValRetypes.Expr->ElementalExpr.Elemental, GetElementSymbol (SP->ValRetypes.Expr->ElementalExpr.Elemental), ExprType (SP->ValRetypes.Expr->ElementalExpr.Elemental));
  }
  }
   return;
yyL16:;

/* line 3120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3122 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->ValRetypes.Sym);
/* line 3122 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3122 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->ValRetypes.Type, true);
/* line 3122 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (SP->ValRetypes.Expr, true);
/* line 3122 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3122 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3123 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (SP->ValRetypes.Sym, SP->ValRetypes.Type, SP->ValRetypes.Expr->ElementalExpr.Elemental, GetElementSymbol (SP->ValRetypes.Expr->ElementalExpr.Elemental), ExprType (SP->ValRetypes.Expr->ElementalExpr.Elemental));
  }
   return;

  }
  }
  break;
  case kVal:
  if (SP->Val.Expr->Kind == kElementalExpr) {
/* line 3130 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3130 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->Val.Expr)))) goto yyL18;
  {
/* line 3130 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (ExprType (SP->Val.Expr))))) goto yyL18;
  {
/* line 3131 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3131 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->Val.Expr));
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (ExprType (SP->Val.Expr));
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (ExprType (SP->Val.Expr->ElementalExpr.Elemental), SP->Val.Expr->ElementalExpr.Elemental -> Elemental . CA);
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
/* line 3134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Val.Sym);
/* line 3134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = (");
/* line 3134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->Val.Expr));
/* line 3134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)TMP;");
/* line 3134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3135 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3135 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3135 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL18:;

  }
  if (Tree_IsType (SP->Val.Expr, kStringElement)) {
/* line 3137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->Val.Expr)))) goto yyL19;
  {
/* line 3137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (ExprType (SP->Val.Expr))))) goto yyL19;
  {
/* line 3138 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3138 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 3139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->Val.Expr));
/* line 3139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (ExprType (SP->Val.Expr));
/* line 3139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 3139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (ExprType (SP->Val.Expr), SP->Val.Expr -> StringElement . CA);
/* line 3139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 3139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
/* line 3141 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Val.Sym);
/* line 3141 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = TMP;");
/* line 3141 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3142 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3142 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3142 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL19:;

  }
/* line 3144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->Val.Expr)))) goto yyL20;
  {
/* line 3144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsNewSymbol (SP->Val.Sym)))) goto yyL20;
  }
  }
   return;
yyL20:;

  if (SP->Val.Expr->Kind == kElementalExpr) {
  if (SP->Val.Expr->ElementalExpr.Elemental->Kind == kTable) {
/* line 3146 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3147 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitTable (SP->Val.Sym, 0, SP->Val.Expr->ElementalExpr.Elemental->Table.ExprList);
/* line 3148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
  }
   return;

  }
  }
/* line 3150 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3150 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (SP->Val.Sym))))) goto yyL22;
  {
/* line 3151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
/* line 3152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Val.Sym);
/* line 3152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Val.Sym), false);
/* line 3152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (SP->Val.Expr);
/* line 3152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL22:;

  if (SP->Val.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (SP->Val.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3154 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3155 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
/* line 3156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Val.Sym);
/* line 3156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Val.Sym), true);
/* line 3156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (SP->Val.Expr, true);
/* line 3156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3157 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (SP->Val.Sym, SymbolType (SP->Val.Sym), SP->Val.Expr->ElementalExpr.Elemental, GetElementSymbol (SP->Val.Expr->ElementalExpr.Elemental), ExprType (SP->Val.Expr));
  }
   return;

  }
  }
  break;
  case kCallFrame:
/* line 3189 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kParFrame:
/* line 3190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAProc:
  case kDefProc:
  case kPrototypeProc:
/* line 3191 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAFunc:
  case kDefFunc:
  case kDefIsFunc:
  case kPrototypeFunc:
/* line 3192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAPro:
  case kDefSeqPro:
  case kDefTagPro:
/* line 3193 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kNullSpec:
/* line 3194 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }

/* line 3196 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3196 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (SP, SP->Spec.Pos);
  }
   return;

;
}

static void GenInitTable
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP126, register int yyP125, register tTree yyP124)
# else
(yyP126, yyP125, yyP124)
 tSymbol yyP126;
 register int yyP125;
 register tTree yyP124;
# endif
{
  if (yyP124->Kind == kAnExpr) {
/* line 3202 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3202 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (yyP124->AnExpr.Expr))))) goto yyL1;
  {
/* line 3203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP126);
/* line 3203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 3203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP125);
/* line 3203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("] = ");
/* line 3203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP124->AnExpr.Expr);
/* line 3203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3204 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitTable (yyP126, yyP125 + 1, yyP124->AnExpr.Next);
  }
  }
   return;
yyL1:;

/* line 3206 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3208 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP126);
/* line 3208 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 3208 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP125);
/* line 3208 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("],");
/* line 3209 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (yyP124->AnExpr.Expr, true);
/* line 3209 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayTypeSize (ExprType (yyP124->AnExpr.Expr));
/* line 3210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("); ");
/* line 3210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitTable (yyP126, yyP125 + 1, yyP124->AnExpr.Next);
  }
   return;

  }
;
}

static void GenArrayTypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP127)
# else
(yyP127)
 register tTree yyP127;
# endif
{
  if (yyP127->Kind == kArray) {
/* line 3216 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP127->Array.Expr);
/* line 3217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 3217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayTypeSize (yyP127->Array.Type);
/* line 3217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 3220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP127)))) goto yyL2;
  {
/* line 3221 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 3221 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP127);
/* line 3221 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *)");
  }
  }
   return;
yyL2:;

/* line 3224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3225 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 3225 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP127);
/* line 3225 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void GenEmuRetype
# if defined __STDC__ | defined __cplusplus
(register tTree yyP131, tSymbol yyP130, register tTree yyP129, register tTree yyP128)
# else
(yyP131, yyP130, yyP129, yyP128)
 register tTree yyP131;
 tSymbol yyP130;
 register tTree yyP129;
 register tTree yyP128;
# endif
{
/* line 3233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP131) == RetypeSize (yyP129)))) goto yyL1;
  {
/* line 3233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (yyP131)))) goto yyL1;
  {
/* line 3234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP130);
/* line 3234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (yyP131, true);
/* line 3235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP128, true);
/* line 3235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3236 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (yyP130, SymbolType (yyP130), yyP128, GetElementSymbol (yyP128), yyP129);
  }
  }
  }
   return;
yyL1:;

/* line 3239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP131)))) goto yyL2;
  {
/* line 3240 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (yyP130, SymbolType (yyP130), yyP128, GetElementSymbol (yyP128), yyP129);
/* line 3241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ALLOCRETYPE(");
/* line 3241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP130);
/* line 3241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP131);
/* line 3241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*,");
/* line 3241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP131, yyP130, 1);
/* line 3241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3242 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
  }
   return;
yyL2:;

/* line 3245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3246 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP130);
/* line 3247 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("RETYPE(");
/* line 3248 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (yyP131));
/* line 3248 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("^");
/* line 3248 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (yyP129));
/* line 3248 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3249 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP131, yyP130, 1);
/* line 3249 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3250 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (SymbolKind (yyP130), yyP130, true);
/* line 3251 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP128, true);
/* line 3253 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3253 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void CodeRetypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP134, tSymbol yyP133, register int yyP132)
# else
(yyP134, yyP133, yyP132)
 register tTree yyP134;
 tSymbol yyP133;
 register int yyP132;
# endif
{
  if (yyP134->Kind == kArray) {
  if (yyP134->Array.Expr->Kind == kUnBound) {
/* line 3260 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3261 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP133);
/* line 3261 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Dim");
/* line 3261 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP134));
/* line 3261 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 3262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP134->Array.Type, yyP133, yyP132);
  }
   return;

  }
/* line 3264 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP134->Array.Type, yyP133, yyP132 * ValConstInt (yyP134->Array.Expr));
  }
   return;

  }
/* line 3268 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3269 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP132 * PrimTypeSize (yyP134));
  }
   return;

;
}

static int RetypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP135)
# else
(yyP135)
 register tTree yyP135;
# endif
{
  if (yyP135->Kind == kArray) {
/* line 3274 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return RetypeSize (yyP135->Array.Type);

  }
/* line 3275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return PrimTypeSize (yyP135) - 1;

}

static void GenInitChanList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP136)
# else
(yyP136)
 register tTree yyP136;
# endif
{
  if (yyP136->Kind == kAnId) {
/* line 3281 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP136->AnId.Sym);
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = &");
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP136->AnId.Sym);
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_CHAN");
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INITCH(");
/* line 3283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP136->AnId.Sym);
/* line 3283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3284 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanList (yyP136->AnId.Next);
  }
   return;

  }
;
}

static void GenInitChanSubs
# if defined __STDC__ | defined __cplusplus
(register int yyP138, register int yyP137)
# else
(yyP138, yyP137)
 register int yyP138;
 register int yyP137;
# endif
{
/* line 3288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP138 < yyP137))) goto yyL1;
  {
/* line 3288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[TMP");
/* line 3288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP138);
/* line 3288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 3288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanSubs (yyP138 + 1, yyP137);
  }
  }
   return;
yyL1:;

;
}

static void GenInitChanArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP141, tSymbol yyP140, register int yyP139)
# else
(yyP141, yyP140, yyP139)
 register tTree yyP141;
 tSymbol yyP140;
 register int yyP139;
# endif
{
  if (yyP141->Kind == kArray) {
/* line 3293 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int TMP");
/* line 3295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP139);
/* line 3295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("for (TMP");
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP139);
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=0;TMP");
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP139);
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("<");
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP141->Array.Expr);
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";TMP");
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP139);
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++)");
/* line 3296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3298 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanArray (yyP141->Array.Type, yyP140, yyP139 + 1);
/* line 3299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP141->Kind == kChan) {
/* line 3302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP140);
/* line 3303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanSubs (0, yyP139);
/* line 3303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = &");
/* line 3303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP140);
/* line 3303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_CHAN");
/* line 3303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanSubs (0, yyP139);
/* line 3303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INITCH(");
/* line 3304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP140);
/* line 3304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanSubs (0, yyP139);
/* line 3304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenInitChanArrayList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP143, register tTree yyP142)
# else
(yyP143, yyP142)
 register tTree yyP143;
 register tTree yyP142;
# endif
{
  if (yyP142->Kind == kAnId) {
/* line 3308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanArray (yyP143, yyP142->AnId.Sym, 0);
/* line 3308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanArrayList (yyP143, yyP142->AnId.Next);
  }
   return;

  }
;
}

static void GenInitIsArray
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP148, register tTree yyP147, register tTree yyP146, tSymbol yyP145, register tTree yyP144)
# else
(yyP148, yyP147, yyP146, yyP145, yyP144)
 tSymbol yyP148;
 register tTree yyP147;
 register tTree yyP146;
 tSymbol yyP145;
 register tTree yyP144;
# endif
{
  if (yyP147->Kind == kArray) {
  if (yyP146->Kind == kRange) {
  if (yyP144->Kind == kArray) {
/* line 3314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP147->Array.Expr)))) goto yyL1;
  {
/* line 3315 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP148, yyP147->Array.Type, yyP146->Range.Next, yyP145, yyP144->Array.Type);
/* line 3316 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP148);
/* line 3316 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3316 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP147));
/* line 3316 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3316 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP146->Range.For);
/* line 3316 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3317 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL1:;

/* line 3320 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3321 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP148, yyP147->Array.Type, yyP146->Range.Next, yyP145, yyP144->Array.Type);
/* line 3322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP147->Array.Expr);
/* line 3323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
/* line 3324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP146->Range.For);
/* line 3325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_AIM);
/* line 3325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  if (yyP144->Kind == kArray) {
/* line 3329 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3329 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP147->Array.Expr)))) goto yyL3;
  {
/* line 3330 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP148, yyP147->Array.Type, yyP146, yyP145, yyP144->Array.Type);
/* line 3331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP148);
/* line 3331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP147));
/* line 3331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP146, yyP144);
/* line 3331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3332 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

/* line 3335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP144->Array.Expr)))) goto yyL4;
  {
/* line 3336 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP148, yyP147->Array.Type, yyP146, yyP145, yyP144->Array.Type);
/* line 3337 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3337 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3338 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP147->Array.Expr);
/* line 3338 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
/* line 3339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP145);
/* line 3339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP144));
/* line 3340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_AIM);
/* line 3340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

/* line 3344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP148, yyP147->Array.Type, yyP146, yyP145, yyP144->Array.Type);
  }
   return;

  }
  }
;
}

static void GenInitReArray
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP153, register tTree yyP152, register tTree yyP151, tSymbol yyP150, register tTree yyP149)
# else
(yyP153, yyP152, yyP151, yyP150, yyP149)
 tSymbol yyP153;
 register tTree yyP152;
 register tTree yyP151;
 tSymbol yyP150;
 register tTree yyP149;
# endif
{
  if (yyP152->Kind == kArray) {
  if (yyP152->Array.Expr->Kind == kUnBound) {
  if (yyP149->Kind == kArray) {
/* line 3351 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT _TMP_RSIZE = ");
/* line 3353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP151, yyP149);
/* line 3353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(_TMP_RSIZE % ");
/* line 3354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP153, yyP152->Array.Type);
/* line 3354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == 0,");
/* line 3354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ARM);
/* line 3354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP153);
/* line 3355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP152));
/* line 3355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(_TMP_RSIZE / ");
/* line 3355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP153, yyP152->Array.Type);
/* line 3355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  }
/* line 3358 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3358 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP149)))) goto yyL2;
  {
/* line 3359 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3359 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3359 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP153, yyP152);
/* line 3359 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
/* line 3359 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP151, yyP149);
/* line 3360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ARM);
/* line 3360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL2:;

;
}

static void GenInitReArrayUnBoundSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP154)
# else
(yyP154)
 register tTree yyP154;
# endif
{
  if (yyP154->Kind == kArray) {
  if (yyP154->Array.Expr->Kind == kUnBound) {
/* line 3365 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArrayUnBoundSize (yyP154->Array.Type);
  }
   return;

  }
/* line 3369 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP154->Array.Expr);
/* line 3371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" * ");
/* line 3372 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArrayUnBoundSize (yyP154->Array.Type);
  }
   return;

  }
/* line 3375 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3376 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 3376 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP154);
/* line 3376 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void GenResults
# if defined __STDC__ | defined __cplusplus
(register tTree yyP155)
# else
(yyP155)
 register tTree yyP155;
# endif
{
  if (yyP155->Kind == kASpec) {
/* line 3382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP155->ASpec.Next);
/* line 3382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResult (yyP155->ASpec.Spec);
  }
   return;

  }
  if (yyP155->Kind == kNoSpec) {
/* line 3383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenResult
# if defined __STDC__ | defined __cplusplus
(register tTree yyP156)
# else
(yyP156)
 register tTree yyP156;
# endif
{
  if (yyP156->Kind == kIs) {
/* line 3388 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3388 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanOrTimerType (SymbolType (yyP156->Is.Sym))))) goto yyL1;
  }
   return;
yyL1:;

  if (yyP156->Is.Elemental->Kind == kTable) {
/* line 3394 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3395 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResultTable (yyP156->Is.Sym, 0, yyP156->Is.Elemental->Table.ExprList);
  }
   return;

  }
  if (Tree_IsType (yyP156->Is.Elemental, kElement)) {
/* line 3398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP156->Is.Sym))))) goto yyL4;
  {
/* line 3399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP156->Is.Elemental, false);
/* line 3399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP156->Is.Sym);
/* line 3399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

  }
  }
  if (yyP156->Kind == kRetypes) {
/* line 3391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanOrTimerType (SymbolType (yyP156->Retypes.Sym))))) goto yyL2;
  }
   return;
yyL2:;

/* line 3406 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3406 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL6;
  {
/* line 3407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEmuRetypeResult (yyP156->Retypes.Type, yyP156->Retypes.Sym, ElementType (yyP156->Retypes.Elemental), yyP156->Retypes.Elemental);
  }
  }
   return;
yyL6:;

  if (Tree_IsType (yyP156->Retypes.Elemental, kElement)) {
/* line 3410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP156->Retypes.Type)))) goto yyL7;
  {
/* line 3411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 3411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (yyP156->Retypes.Type, true);
/* line 3411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP156->Retypes.Elemental, true);
/* line 3411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP156->Retypes.Sym);
/* line 3411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL7:;

  }
  }
  if (yyP156->Kind == kValRetypes) {
  if (yyP156->ValRetypes.Expr->Kind == kElementalExpr) {
/* line 3402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL5;
  {
/* line 3402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP156->ValRetypes.Type) != RetypeSize (ElementType (yyP156->ValRetypes.Expr->ElementalExpr.Elemental))))) goto yyL5;
  {
/* line 3402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP156->ValRetypes.Type)))) goto yyL5;
  {
/* line 3402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (yyP156->ValRetypes.Type)))) goto yyL5;
  {
/* line 3403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FREERETYPE(");
/* line 3403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP156->ValRetypes.Sym);
/* line 3403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
  }
   return;
yyL5:;

  }
  }
;
}

static void GenResultTable
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP159, register int yyP158, register tTree yyP157)
# else
(yyP159, yyP158, yyP157)
 tSymbol yyP159;
 register int yyP158;
 register tTree yyP157;
# endif
{
  if (yyP157->Kind == kAnExpr) {
/* line 3419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (yyP157->AnExpr.Expr))))) goto yyL1;
  {
/* line 3420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP157->AnExpr.Expr);
/* line 3420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP159);
/* line 3420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 3420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP158);
/* line 3420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("];");
/* line 3420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResultTable (yyP159, yyP158 + 1, yyP157->AnExpr.Next);
  }
  }
   return;
yyL1:;

/* line 3423 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (yyP157->AnExpr.Expr, true);
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP159);
/* line 3426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 3426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP158);
/* line 3426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("],");
/* line 3427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayTypeSize (ExprType (yyP157->AnExpr.Expr));
/* line 3427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("); ");
/* line 3427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResultTable (yyP159, yyP158 + 1, yyP157->AnExpr.Next);
  }
   return;

  }
;
}

static void GenEmuRetypeResult
# if defined __STDC__ | defined __cplusplus
(register tTree yyP163, tSymbol yyP162, register tTree yyP161, register tTree yyP160)
# else
(yyP163, yyP162, yyP161, yyP160)
 register tTree yyP163;
 tSymbol yyP162;
 register tTree yyP161;
 register tTree yyP160;
# endif
{
/* line 3433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP163)))) goto yyL1;
  }
   return;
yyL1:;

  if (Tree_IsType (yyP160, kElement)) {
/* line 3435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3436 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP162);
/* line 3437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("RETYPE(");
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (yyP163));
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("^");
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (yyP161));
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3439 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP163, yyP162, 1);
/* line 3439 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3440 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP160, true);
/* line 3441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3442 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (SymbolKind (yyP162), yyP162, true);
/* line 3443 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3443 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3444 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

/* line 3447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP163) != RetypeSize (ElementType (yyP160))))) goto yyL3;
  {
/* line 3447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP163)))) goto yyL3;
  {
/* line 3447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (yyP163)))) goto yyL3;
  {
/* line 3448 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FREERETYPE(");
/* line 3448 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP162);
/* line 3448 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3448 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
   return;
yyL3:;

  }
;
}

static int GenRepStart
# if defined __STDC__ | defined __cplusplus
(register tTree yyP164)
# else
(yyP164)
 register tTree yyP164;
# endif
{
/* line 3457 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
/* line 3458 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3458 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP164->Replicator.From)))) goto yyL1;
  {
/* line 3458 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP164->Replicator.For)))) goto yyL1;
  {
/* line 3459 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 3460 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP164->Replicator.Sym);
/* line 3461 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP164->Replicator.Sym) . Kind, yyP164->Replicator.Sym, false);
/* line 3461 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3461 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP164->Replicator.From);
/* line 3461 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3461 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 3462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 3462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return lab;
yyL1:;

/* line 3464 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3465 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 3466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP164->Replicator.Sym);
/* line 3467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP164->Replicator.Sym) . Kind, yyP164->Replicator.Sym, false);
/* line 3467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP164->Replicator.From);
/* line 3467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP164->Replicator.Sym) . Kind, yyP164->Replicator.Sym, false);
/* line 3468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End = ");
/* line 3468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP164->Replicator.Sym) . Kind, yyP164->Replicator.Sym, false);
/* line 3468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
/* line 3468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP164->Replicator.For);
/* line 3468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return lab;

}

static void GenRepEnd
# if defined __STDC__ | defined __cplusplus
(register tTree yyP167, register int yyP166, register int yyP165)
# else
(yyP167, yyP166, yyP165)
 register tTree yyP167;
 register int yyP166;
 register int yyP165;
# endif
{
/* line 3474 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3474 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP167->Replicator.From)))) goto yyL1;
  {
/* line 3474 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP167->Replicator.For)))) goto yyL1;
  {
/* line 3475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++;");
/* line 3475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3476 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP165);
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" != (");
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP167->Replicator.From);
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP167->Replicator.For);
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")) GOTO(");
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP166);
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

/* line 3479 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3480 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3480 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++;");
/* line 3480 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP165);
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" != ");
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End) GOTO(");
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP166);
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenAltIndex
# if defined __STDC__ | defined __cplusplus
(register tTree yyP168)
# else
(yyP168)
 register tTree yyP168;
# endif
{
/* line 3488 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3489 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP168->Replicator.Sym) . Kind, yyP168->Replicator.Sym, false);
  }
   return;

;
}

static void GenAltSelect
# if defined __STDC__ | defined __cplusplus
(register tTree yyP169)
# else
(yyP169)
 register tTree yyP169;
# endif
{
/* line 3493 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP169->Replicator.Sym) . Kind, yyP169->Replicator.Sym, false);
/* line 3494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Alt");
  }
   return;

;
}

static void GenForLoop
# if defined __STDC__ | defined __cplusplus
(register tTree yyP170)
# else
(yyP170)
 register tTree yyP170;
# endif
{
/* line 3499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP170->Replicator.From)))) goto yyL1;
  {
/* line 3499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP170->Replicator.For)))) goto yyL1;
  {
/* line 3500 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP170->Replicator.Sym);
/* line 3501 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("for (");
/* line 3501 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP170->Replicator.Sym) . Kind, yyP170->Replicator.Sym, false);
/* line 3501 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3501 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP170->Replicator.From);
/* line 3501 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP170->Replicator.Sym) . Kind, yyP170->Replicator.Sym, false);
/* line 3502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" != ");
/* line 3502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP170->Replicator.From);
/* line 3502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
/* line 3502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP170->Replicator.For);
/* line 3502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP170->Replicator.Sym) . Kind, yyP170->Replicator.Sym, false);
/* line 3502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++)");
/* line 3502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

/* line 3505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3506 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP170->Replicator.Sym);
/* line 3507 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP170->Replicator.Sym) . Kind, yyP170->Replicator.Sym, false);
/* line 3507 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3507 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP170->Replicator.From);
/* line 3507 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP170->Replicator.Sym) . Kind, yyP170->Replicator.Sym, false);
/* line 3508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End = ");
/* line 3508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP170->Replicator.Sym) . Kind, yyP170->Replicator.Sym, false);
/* line 3508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
/* line 3508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP170->Replicator.For);
/* line 3508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("for (; ");
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP170->Replicator.Sym) . Kind, yyP170->Replicator.Sym, false);
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" != ");
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP170->Replicator.Sym) . Kind, yyP170->Replicator.Sym, false);
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End; ");
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP170->Replicator.Sym) . Kind, yyP170->Replicator.Sym, false);
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++)");
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenForCheck
# if defined __STDC__ | defined __cplusplus
(register tTree yyP171)
# else
(yyP171)
 register tTree yyP171;
# endif
{
/* line 3514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP171->Replicator.From)))) goto yyL1;
  {
/* line 3514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP171->Replicator.For)))) goto yyL1;
  {
/* line 3515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 3515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP171->Replicator.Sym) . Kind, yyP171->Replicator.Sym, false);
/* line 3515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == (");
/* line 3515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Replicator.From);
/* line 3515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
/* line 3515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Replicator.For);
/* line 3515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("))");
/* line 3515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

/* line 3517 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 3518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP171->Replicator.Sym) . Kind, yyP171->Replicator.Sym, false);
/* line 3518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
/* line 3518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP171->Replicator.Sym) . Kind, yyP171->Replicator.Sym, false);
/* line 3518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End) ");
/* line 3518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void CodeArrayExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP173, register bool yyP172)
# else
(yyP173, yyP172)
 register tTree yyP173;
 register bool yyP172;
# endif
{
  if (yyP173->Kind == kElementalExpr) {
  if (Tree_IsType (yyP173->ElementalExpr.Elemental, kElement)) {
/* line 3527 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3527 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP173->ElementalExpr.Elemental))))) goto yyL1;
  {
/* line 3528 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP173->ElementalExpr.Elemental, yyP172);
  }
  }
   return;
yyL1:;

/* line 3530 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3531 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP173->ElementalExpr.Elemental, yyP172);
  }
   return;

  }
  if (Tree_IsType (yyP173->ElementalExpr.Elemental, kTableElement)) {
/* line 3533 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table element", xxError, yyP173->ElementalExpr.Elemental->TableElement.Pos);
  }
   return;

  }
  }
  if (Tree_IsType (yyP173, kStringElement)) {
/* line 3536 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3537 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected string element", xxError, yyP173->StringElement.Pos);
  }
   return;

  }
;
}

static void CodeExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP174)
# else
(yyP174)
 register tTree yyP174;
# endif
{
/* line 3543 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3543 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP174)))) goto yyL1;
  {
/* line 3543 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (yyP174))))) goto yyL1;
  {
/* line 3543 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstExpr (ExprType (yyP174), ValConstExpr (yyP174));
  }
  }
  }
   return;
yyL1:;


  switch (yyP174->Kind) {
  case kBinary:
  if (yyP174->Binary.Op->Kind == kLeftShift) {
/* line 3545 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("LOGSHIFTLEFT(");
/* line 3546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP174->Binary.Lop));
/* line 3546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Lop);
/* line 3546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Rop);
/* line 3546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP174->Binary.Op->Kind == kRightShift) {
/* line 3548 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("LOGSHIFTRIGHT(");
/* line 3549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP174->Binary.Lop));
/* line 3549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Lop);
/* line 3549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Rop);
/* line 3549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP174->Binary.Op->Kind == kAfterOp) {
/* line 3551 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("AFTER(");
/* line 3552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Lop);
/* line 3552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Rop);
/* line 3552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP174->Binary.Op->Kind == kRem) {
/* line 3554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (ExprType (yyP174), kReal)))) goto yyL5;
  {
/* line 3555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("( remainder((");
/* line 3555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Lop);
/* line 3555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),(");
/* line 3555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Rop);
/* line 3555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")))");
  }
  }
   return;
yyL5:;

  }
/* line 3558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Lop);
/* line 3558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeOp (yyP174->Binary.Op);
/* line 3558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Binary.Rop);
/* line 3558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kUnary:
  if (yyP174->Unary.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP174->Unary.Expr->ElementalExpr.Elemental, kElement)) {
  if (yyP174->Unary.Op->Kind == kSize) {
/* line 3559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP174->Unary.Expr->ElementalExpr.Elemental, ExprType (yyP174->Unary.Expr));
/* line 3559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  }
  }
/* line 3560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeOp (yyP174->Unary.Op);
/* line 3560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Unary.Expr);
/* line 3560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kElementalExpr:
  if (Tree_IsType (yyP174->ElementalExpr.Elemental, kElement)) {
/* line 3563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP174->ElementalExpr.Elemental))))) goto yyL9;
  {
/* line 3563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ElementType (yyP174->ElementalExpr.Elemental))))) goto yyL9;
  {
/* line 3563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP174->ElementalExpr.Elemental, false);
  }
  }
  }
   return;
yyL9:;

/* line 3565 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3565 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP174->ElementalExpr.Elemental))))) goto yyL10;
  {
/* line 3565 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP174->ElementalExpr.Elemental, true);
  }
  }
   return;
yyL10:;

/* line 3567 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3567 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP174->ElementalExpr.Elemental, false);
  }
   return;

  }
  break;
  case kConvert:
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP174->Convert.Type);
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP174->Convert.Expr));
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Convert.Expr);
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kRound:
/* line 3570 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3570 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP174->Round.Type);
/* line 3570 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP174->Round.Expr));
/* line 3570 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ROUND(");
/* line 3570 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Round.Expr);
/* line 3570 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kTrunc:
/* line 3571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP174->Trunc.Type);
/* line 3571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP174->Trunc.Expr));
/* line 3571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TRUNC(");
/* line 3571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP174->Trunc.Expr);
/* line 3571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kMostPos:
/* line 3572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MOSTPOS");
/* line 3572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP174->MostPos.Type);
  }
   return;

  case kMostNeg:
/* line 3573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MOSTNEG");
/* line 3573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP174->MostNeg.Type);
  }
   return;

  case kFuncCall:
/* line 3574 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3574 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncCall (SymbolKind (yyP174->FuncCall.Sym), yyP174, NoTree);
  }
   return;

  }

/* line 3576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP174, yyP174->Expr.Pos);
  }
   return;

;
}

static void CodeSizeOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP176, register tTree yyP175)
# else
(yyP176, yyP175)
 register tTree yyP176;
 register tTree yyP175;
# endif
{
  if (yyP176->Kind == kRange) {
  if (yyP175->Kind == kArray) {
/* line 3581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP175->Array.Expr)))) goto yyL1;
  {
/* line 3582 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP176->Range.For);
  }
  }
   return;
yyL1:;

  }
  }
  if (yyP175->Kind == kArray) {
/* line 3585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP175->Array.Expr)))) goto yyL2;
  {
/* line 3586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP176));
/* line 3586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP175));
  }
  }
   return;
yyL2:;

/* line 3589 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3590 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP175->Array.Expr);
  }
   return;

  }
;
}

static void CodeConstExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP178, tValue yyP177)
# else
(yyP178, yyP177)
 register tTree yyP178;
 tValue yyP177;
# endif
{
  if (yyP178->Kind == kInt64) {
/* line 3597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 WritetInt(yyP177.Number,true); 
  }
   return;

  }
  if (Tree_IsType (yyP178, kInteger)) {
/* line 3598 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3598 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 WritetInt(yyP177.Number,false); 
  }
   return;

  }
  if (yyP178->Kind == kByte) {
/* line 3599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
WriteInt((unsigned char)yyP177.Number);
  }
   return;

  }
  if (yyP178->Kind == kBool) {
/* line 3600 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3600 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP177 . Number))) goto yyL4;
  {
/* line 3600 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("true");
  }
  }
   return;
yyL4:;

/* line 3601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("false");
  }
   return;

  }
  if (Tree_IsType (yyP178, kReal)) {
/* line 3603 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3603 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteReal (yyP177);
  }
   return;

  }
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP178, NoPosition);
  }
   return;

;
}

static void CodeAssign
# if defined __STDC__ | defined __cplusplus
(register tTree yyP180, register tTree yyP179)
# else
(yyP180, yyP179)
 register tTree yyP180;
 register tTree yyP179;
# endif
{
  if (yyP180->Kind == kNoExpr) {
  if (yyP179->Kind == kNoExpr) {
/* line 3611 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
  if (yyP180->Kind == kAnExpr) {
  if (yyP180->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP180->AnExpr.Expr->ElementalExpr.Elemental, kTableElement)) {
/* line 3613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3614 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table elements on LHS of assign", xxError, yyP180->AnExpr.Expr->ElementalExpr.Pos);
  }
   return;

  }
  }
  if (yyP179->Kind == kAnExpr) {
  if (yyP179->AnExpr.Expr->Kind == kFuncCall) {
/* line 3616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsMVFunction (SymbolKind (yyP179->AnExpr.Expr->FuncCall.Sym))))) goto yyL3;
  {
/* line 3617 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OpenBlock (false);
/* line 3617 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 3618 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFTemps (yyP180, 0);
/* line 3619 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncCall (SymbolKind (yyP179->AnExpr.Expr->FuncCall.Sym), yyP179->AnExpr.Expr, yyP180);
/* line 3619 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3619 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3620 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFTempCopies (yyP180, 0);
/* line 3621 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseBlock ();
  }
  }
   return;
yyL3:;

  }
  }
  }
/* line 3624 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3625 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign2 (yyP180, yyP179);
  }
   return;

;
}

static void CodeAssign2
# if defined __STDC__ | defined __cplusplus
(register tTree yyP182, register tTree yyP181)
# else
(yyP182, yyP181)
 register tTree yyP182;
 register tTree yyP181;
# endif
{
/* line 3630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tTree T;
  if (yyP182->Kind == kAnExpr) {
  if (yyP182->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP182->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
  if (yyP181->Kind == kAnExpr) {
  if (yyP181->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP181->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3632 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3632 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((TempRequired (yyP182)))) goto yyL1;
  {
/* line 3632 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (T = ElementType (yyP182->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL1;
  {
/* line 3633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP182->AnExpr.Expr->ElementalExpr.Elemental));
/* line 3634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeIdChkConst (ElementType (yyP182->AnExpr.Expr->ElementalExpr.Elemental), yyP182->AnExpr.Expr->ElementalExpr.Pos);
/* line 3634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3635 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT len = ");
/* line 3635 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP182->AnExpr.Expr->ElementalExpr.Elemental, T);
/* line 3635 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3635 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3636 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP182->AnExpr.Expr->ElementalExpr.Elemental, T, yyP181->AnExpr.Expr->ElementalExpr.Elemental, ExprType (yyP181->AnExpr.Expr));
/* line 3637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(TMP,");
/* line 3637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (yyP181->AnExpr.Expr, true);
/* line 3637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",len); ");
/* line 3637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3638 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP182->AnExpr.Next, yyP181->AnExpr.Next);
/* line 3639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP182->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",TMP,len); ");
/* line 3639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3640 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3640 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

/* line 3642 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3642 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (T = ElementType (yyP182->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL2;
  {
/* line 3643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP182->AnExpr.Expr->ElementalExpr.Elemental, T, yyP181->AnExpr.Expr->ElementalExpr.Elemental, ExprType (yyP181->AnExpr.Expr));
/* line 3644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP182->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (yyP181->AnExpr.Expr, true);
/* line 3644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3645 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP182->AnExpr.Expr->ElementalExpr.Elemental, T);
/* line 3645 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("); ");
/* line 3645 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3646 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP182->AnExpr.Next, yyP181->AnExpr.Next);
  }
  }
   return;
yyL2:;

  }
  }
/* line 3648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! TempRequired (yyP182)))) goto yyL3;
  {
/* line 3649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP182->AnExpr.Next, yyP181->AnExpr.Next);
/* line 3649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP182->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 3649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP181->AnExpr.Expr);
/* line 3649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

  if (yyP181->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP181->AnExpr.Expr->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 3651 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3651 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP181->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym), kAVal)))) goto yyL4;
  {
/* line 3652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP182->AnExpr.Next, yyP181->AnExpr.Next);
/* line 3652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP182->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 3652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP181->AnExpr.Expr);
/* line 3652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

  }
  }
/* line 3654 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP182->AnExpr.Expr->ElementalExpr.Elemental));
/* line 3656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP = ");
/* line 3656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP181->AnExpr.Expr);
/* line 3656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3657 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP182->AnExpr.Next, yyP181->AnExpr.Next);
/* line 3658 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP182->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 3658 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = TMP;");
/* line 3658 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  }
  }
/* line 3661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyAbort ("Unbalanced assignment list");
  }
   return;

;
}

static void GenChkDims
# if defined __STDC__ | defined __cplusplus
(register tTree yyP186, register tTree yyP185, register tTree yyP184, register tTree yyP183)
# else
(yyP186, yyP185, yyP184, yyP183)
 register tTree yyP186;
 register tTree yyP185;
 register tTree yyP184;
 register tTree yyP183;
# endif
{
  if (yyP185->Kind == kArray) {
  if (yyP184->Kind == kRange) {
  if (yyP183->Kind == kArray) {
/* line 3666 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP186, yyP185);
/* line 3667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 3667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP184, yyP183);
/* line 3667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 3667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3668 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP186, yyP185->Array.Type, yyP184->Range.Next, yyP183->Array.Type);
  }
   return;

  }
  }
  if (yyP183->Kind == kArray) {
/* line 3671 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3671 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP185->Array.Expr)))) goto yyL2;
  {
/* line 3671 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP183->Array.Expr)))) goto yyL2;
  {
/* line 3672 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP186, yyP185->Array.Type, yyP184, yyP183->Array.Type);
  }
  }
  }
   return;
yyL2:;

/* line 3675 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP186, yyP185);
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP184, yyP183);
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3677 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP186, yyP185->Array.Type, yyP184, yyP183->Array.Type);
  }
   return;

  }
  }
;
}

static void GenInstance
# if defined __STDC__ | defined __cplusplus
(register tTree DP, register tTree yyP188, register tIdent yyP187)
# else
(DP, yyP188, yyP187)
 register tTree DP;
 register tTree yyP188;
 register tIdent yyP187;
# endif
{
/* line 3689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; int lab; 
  if (DP->Kind == kDefProc) {
/* line 3691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProc (DP)))) goto yyL1;
  {
/* line 3692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAtomicInstance (DP->DefProc.Sym, DP->DefProc.Formals, yyP188);
  }
  }
   return;
yyL1:;

/* line 3695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNonAtomicInstance (DP->DefProc.Sym, DP->DefProc.Formals, yyP188, yyP187);
  }
   return;

  }
  if (DP->Kind == kPrototypeProc) {
/* line 3699 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3699 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxOccam))) goto yyL3;
  {
/* line 3700 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNonAtomicInstance (DP->PrototypeProc.Sym, DP->PrototypeProc.Formals, yyP188, yyP187);
  }
  }
   return;
yyL3:;

/* line 3703 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3703 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxAtomicOccam))) goto yyL4;
  {
/* line 3704 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAtomicInstance (DP->PrototypeProc.Sym, DP->PrototypeProc.Formals, yyP188);
  }
  }
   return;
yyL4:;

/* line 3707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxC))) goto yyL5;
  {
/* line 3708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCInstance (DP->PrototypeProc.Sym, DP->PrototypeProc.Formals, yyP188);
  }
  }
   return;
yyL5:;

/* line 3711 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3711 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxF90))) goto yyL6;
  {
/* line 3712 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Instance (DP->PrototypeProc.Sym, DP->PrototypeProc.Formals, yyP188);
  }
  }
   return;
yyL6:;

/* line 3715 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3715 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxF77))) goto yyL7;
  {
/* line 3716 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Fortran 77 interface not yet implemented", xxError, DP->PrototypeProc.Pos);
  }
  }
   return;
yyL7:;

  }
;
}

static void GenAtomicInstance
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP191, register tTree yyP190, register tTree yyP189)
# else
(yyP191, yyP190, yyP189)
 tSymbol yyP191;
 register tTree yyP190;
 register tTree yyP189;
# endif
{
/* line 3722 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; 
/* line 3724 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3725 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP191);
/* line 3725 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3726 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (SymbolKind (yyP191))))) goto yyL1;
  {
/* line 3727 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP");
/* line 3727 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP191, CurProc);
/* line 3728 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 3729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 3732 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP190, yyP189, comma);
/* line 3734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenNonAtomicInstance
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP195, register tTree yyP194, register tTree yyP193, register tIdent yyP192)
# else
(yyP195, yyP194, yyP193, yyP192)
 tSymbol yyP195;
 register tTree yyP194;
 register tTree yyP193;
 register tIdent yyP192;
# endif
{
/* line 3739 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
/* line 3741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrototype (SymbolKind (yyP195))))) goto yyL1;
  {
/* line 3742 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP194, yyP193, yyP192, 0);
/* line 3743 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChain (yyP192, yyP195, true);
/* line 3744 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 3747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsPrototype (SymbolKind (yyP195))))) goto yyL2;
  {
/* line 3748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP194, yyP193, yyP192, NoSymbol);
/* line 3749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChain (yyP192, yyP195, (IsTopLevel (yyP195)));
/* line 3750 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
  }
   return;
yyL2:;

/* line 3753 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("CALL(");
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP195);
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP192);
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (lab);
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP195);
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3756 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

;
}

static void GenCInstance
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP198, register tTree yyP197, register tTree yyP196)
# else
(yyP198, yyP197, yyP196)
 tSymbol yyP198;
 register tTree yyP197;
 register tTree yyP196;
# endif
{
/* line 3762 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3763 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCTemps (yyP197, yyP196, 0);
/* line 3764 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Symbol (yyP198) . Id);
/* line 3764 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCParams (yyP197, yyP196, false);
/* line 3766 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3766 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3767 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCResults (yyP197, yyP196, 0);
  }
   return;

;
}

static void GenCTemps
# if defined __STDC__ | defined __cplusplus
(register tTree yyP201, register tTree yyP200, register bool yyP199)
# else
(yyP201, yyP200, yyP199)
 register tTree yyP201;
 register tTree yyP200;
 register bool yyP199;
# endif
{
  if (yyP200->Kind == kNoExpr) {
/* line 3774 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP201->Kind == kAFormal) {
  if (yyP200->Kind == kAnExpr) {
  if (yyP200->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP200->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3776 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3776 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP201->AFormal.Type)))) goto yyL2;
  {
/* line 3777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCTemps (yyP201->AFormal.Next, yyP200->AnExpr.Next, yyP199 + 1);
  }
  }
   return;
yyL2:;

  }
  }
/* line 3780 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCTemps (yyP201->AFormal.Next, yyP200->AnExpr.Next, yyP199 + 1);
  }
   return;

  }
  }
;
}

static void GenCParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP204, register tTree yyP203, register bool yyP202)
# else
(yyP204, yyP203, yyP202)
 register tTree yyP204;
 register tTree yyP203;
 register bool yyP202;
# endif
{
  if (yyP203->Kind == kNoExpr) {
/* line 3787 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP204->Kind == kAFormal) {
  if (yyP204->AFormal.Type->Kind == kArray) {
  if (yyP203->Kind == kAnExpr) {
  if (yyP203->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP203->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ArrayPrimType (yyP204->AFormal.Type))))) goto yyL2;
  {
/* line 3790 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3790 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ArrayPrimType (yyP204->AFormal.Type));
/* line 3790 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 3790 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP203->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3791 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCParams (yyP204->AFormal.Next, yyP203->AnExpr.Next, true);
  }
  }
   return;
yyL2:;

/* line 3794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP202);
/* line 3796 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3796 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP204->AFormal.Type);
/* line 3796 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 3796 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP203->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3797 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCParams (yyP204->AFormal.Next, yyP203->AnExpr.Next, true);
  }
   return;

  }
  }
  }
  }
  if (yyP204->AFormal.By->Kind == kByRef) {
  if (yyP203->Kind == kAnExpr) {
  if (yyP203->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP203->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3800 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3800 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP203->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL4;
  {
/* line 3801 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP202);
/* line 3802 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP203->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 3803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCParams (yyP204->AFormal.Next, yyP203->AnExpr.Next, true);
  }
  }
   return;
yyL4:;

/* line 3806 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3807 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP202);
/* line 3808 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP203->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3809 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP204->AFormal.Next, yyP203->AnExpr.Next, true);
  }
   return;

  }
  }
  }
  }
  if (yyP204->AFormal.By->Kind == kByVal) {
  if (yyP203->Kind == kAnExpr) {
/* line 3812 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3813 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP202);
/* line 3814 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP203->AnExpr.Expr);
/* line 3815 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP204->AFormal.Next, yyP203->AnExpr.Next, true);
  }
   return;

  }
  }
  }
;
}

static void GenCResults
# if defined __STDC__ | defined __cplusplus
(register tTree yyP207, register tTree yyP206, register bool yyP205)
# else
(yyP207, yyP206, yyP205)
 register tTree yyP207;
 register tTree yyP206;
 register bool yyP205;
# endif
{
  if (yyP206->Kind == kNoExpr) {
/* line 3821 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP207->Kind == kAFormal) {
  if (yyP207->AFormal.By->Kind == kByRef) {
  if (yyP206->Kind == kAnExpr) {
  if (yyP206->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP206->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3823 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3823 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP207->AFormal.Type)))) goto yyL2;
  {
/* line 3824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCResults (yyP207->AFormal.Next, yyP206->AnExpr.Next, yyP205 + 1);
  }
  }
   return;
yyL2:;

  }
  }
  }
  }
  if (yyP206->Kind == kAnExpr) {
/* line 3827 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3828 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCResults (yyP207->AFormal.Next, yyP206->AnExpr.Next, yyP205 + 1);
  }
   return;

  }
  }
;
}

static void GenF90Instance
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP210, register tTree yyP209, register tTree yyP208)
# else
(yyP210, yyP209, yyP208)
 tSymbol yyP210;
 register tTree yyP209;
 register tTree yyP208;
# endif
{
/* line 3834 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3835 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3835 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3835 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3836 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP209, yyP208, 0);
/* line 3837 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP209, yyP208, 0);
/* line 3838 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (CalcModule (SymbolKind (yyP210)));
/* line 3838 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_MP_");
/* line 3838 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Symbol (yyP210) . Id);
/* line 3838 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3839 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP209, yyP208, 0, false);
/* line 3840 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90CharParams (yyP209, yyP208, 0);
/* line 3841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3842 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Results (yyP209, yyP208, 0);
/* line 3843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenF90Temps
# if defined __STDC__ | defined __cplusplus
(register tTree yyP213, register tTree yyP212, register int yyP211)
# else
(yyP213, yyP212, yyP211)
 register tTree yyP213;
 register tTree yyP212;
 register int yyP211;
# endif
{
  if (yyP212->Kind == kNoExpr) {
/* line 3850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP213->Kind == kAFormal) {
  if (yyP213->AFormal.Type->Kind == kArray) {
  if (yyP213->AFormal.Type->Array.Type->Kind == kByte) {
  if (yyP212->Kind == kAnExpr) {
  if (yyP212->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP212->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3852 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3853 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
   return;

  }
  }
  }
  }
  if (yyP212->Kind == kAnExpr) {
  if (yyP212->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP212->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP213->AFormal.Type)))) goto yyL3;
  {
/* line 3856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP213->AFormal.Type)))) goto yyL3;
  {
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ChDope");
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (CountArrayDims (yyP213->AFormal.Type) - 1);
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP211);
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3858 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
  }
  }
   return;
yyL3:;

/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP213->AFormal.Type)))) goto yyL4;
  {
/* line 3862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("Dope");
/* line 3862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (CountArrayDims (yyP213->AFormal.Type));
/* line 3862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP211);
/* line 3862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3863 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
  }
   return;
yyL4:;

  }
  }
  }
  }
  if (yyP212->Kind == kAnExpr) {
  if (yyP212->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP212->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3866 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3866 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP213->AFormal.Type)))) goto yyL5;
  {
/* line 3866 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP212->AnExpr.Expr)))) goto yyL5;
  {
/* line 3867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP213->AFormal.Type);
/* line 3867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP211);
/* line 3867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP212->AnExpr.Expr);
/* line 3867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3868 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
  }
  }
   return;
yyL5:;

/* line 3871 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
   return;

  }
  }
/* line 3875 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP213->AFormal.Type);
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP211);
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP212->AnExpr.Expr);
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3877 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
   return;

  }
  }
;
}

static void GenF90Inits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP216, register tTree yyP215, register int yyP214)
# else
(yyP216, yyP215, yyP214)
 register tTree yyP216;
 register tTree yyP215;
 register int yyP214;
# endif
{
/* line 3882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int tmp; 
  if (yyP215->Kind == kNoExpr) {
/* line 3884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP216->Kind == kAFormal) {
  if (yyP216->AFormal.Type->Kind == kArray) {
  if (yyP216->AFormal.Type->Array.Type->Kind == kByte) {
  if (yyP215->Kind == kAnExpr) {
/* line 3886 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP216->AFormal.Next, yyP215->AnExpr.Next, yyP214 + 1);
  }
   return;

  }
  }
  if (yyP215->Kind == kAnExpr) {
  if (yyP215->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP215->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3890 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3890 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP216->AFormal.Type)))) goto yyL3;
  {
/* line 3890 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP216->AFormal.Type)))) goto yyL3;
  {
/* line 3891 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3891 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP214);
/* line 3891 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".offset = 0; ");
/* line 3891 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP214);
/* line 3892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".addr = (Pointer)");
/* line 3892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP215->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3893 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90DopeInits (yyP216->AFormal.Type, ExprType (yyP215->AnExpr.Expr), yyP215->AnExpr.Expr->ElementalExpr.Elemental, yyP214, CountArrayDims (yyP216->AFormal.Type) - 2);
/* line 3894 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP216->AFormal.Next, yyP215->AnExpr.Next, yyP214 + 1);
  }
  }
  }
   return;
yyL3:;

/* line 3897 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3897 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP216->AFormal.Type)))) goto yyL4;
  {
/* line 3898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP214);
/* line 3898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".offset = 0; ");
/* line 3898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP214);
/* line 3899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".addr = (Pointer)");
/* line 3899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP215->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90DopeInits (yyP216->AFormal.Type, ExprType (yyP215->AnExpr.Expr), yyP215->AnExpr.Expr->ElementalExpr.Elemental, yyP214, CountArrayDims (yyP216->AFormal.Type) - 1);
/* line 3901 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP216->AFormal.Next, yyP215->AnExpr.Next, yyP214 + 1);
  }
  }
   return;
yyL4:;

  }
  }
  }
  }
  if (yyP215->Kind == kAnExpr) {
/* line 3904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP216->AFormal.Next, yyP215->AnExpr.Next, yyP214 + 1);
  }
   return;

  }
  }
;
}

static void GenF90DopeInits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP221, register tTree yyP220, register tTree yyP219, register int yyP218, register int yyP217)
# else
(yyP221, yyP220, yyP219, yyP218, yyP217)
 register tTree yyP221;
 register tTree yyP220;
 register tTree yyP219;
 register int yyP218;
 register int yyP217;
# endif
{
/* line 3910 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int extent; 
/* line 3912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP218);
/* line 3913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP217);
/* line 3913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].lower = 0;");
/* line 3914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP218);
/* line 3914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP217);
/* line 3914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].extent = ");
/* line 3914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (yyP220, yyP219);
/* line 3914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3915 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

  if (yyP220->Kind == kArray) {
/* line 3918 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3918 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP217 == 0))) goto yyL2;
  {
/* line 3918 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP220->Array.Type)))) goto yyL2;
  {
/* line 3919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP218);
/* line 3919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".len = ");
/* line 3919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (yyP220->Array.Type, yyP219);
/* line 3919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP218);
/* line 3920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[0].mult = ");
/* line 3920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (yyP220->Array.Type, yyP219);
/* line 3920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL2:;

/* line 3923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP217 > 0))) goto yyL3;
  {
/* line 3924 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90DopeInits (yyP221, yyP220->Array.Type, yyP219, yyP218, yyP217 - 1);
/* line 3925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 3928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP217 > 0))) goto yyL4;
  {
/* line 3929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP218);
/* line 3929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP217);
/* line 3929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].mult = ");
/* line 3930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP218);
/* line 3930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP217 - 1);
/* line 3930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].mult * ");
/* line 3930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (yyP220->Array.Type, yyP219);
/* line 3930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

/* line 3933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP218);
/* line 3934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP217);
/* line 3934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].mult = sizeof(");
/* line 3934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP220->Array.Type);
/* line 3934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 3937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

;
}

static void GenF90Params
# if defined __STDC__ | defined __cplusplus
(register tTree yyP225, register tTree yyP224, register int yyP223, register bool yyP222)
# else
(yyP225, yyP224, yyP223, yyP222)
 register tTree yyP225;
 register tTree yyP224;
 register int yyP223;
 register bool yyP222;
# endif
{
  if (yyP224->Kind == kNoExpr) {
/* line 3945 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP225->Kind == kAFormal) {
  if (yyP225->AFormal.Type->Kind == kArray) {
  if (yyP225->AFormal.Type->Array.Type->Kind == kByte) {
  if (yyP224->Kind == kAnExpr) {
  if (yyP224->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP224->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP222);
/* line 3949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ArrayPrimType (yyP225->AFormal.Type));
/* line 3949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 3949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP224->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP225->AFormal.Next, yyP224->AnExpr.Next, yyP223 + 1, true);
  }
   return;

  }
  }
  }
  }
  if (yyP224->Kind == kAnExpr) {
  if (yyP224->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP224->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3953 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3953 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsBoundedType (yyP225->AFormal.Type)))) goto yyL3;
  {
/* line 3954 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP222);
/* line 3955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ArrayPrimType (yyP225->AFormal.Type));
/* line 3955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 3955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP224->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP225->AFormal.Next, yyP224->AnExpr.Next, yyP223 + 1, true);
  }
  }
   return;
yyL3:;

/* line 3959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP222);
/* line 3961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP");
/* line 3961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP223);
/* line 3962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP225->AFormal.Next, yyP224->AnExpr.Next, yyP223 + 1, true);
  }
   return;

  }
  }
  }
  }
  if (yyP224->Kind == kAnExpr) {
  if (yyP224->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP224->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3965 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3965 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP225->AFormal.Type)))) goto yyL5;
  {
/* line 3965 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP224->AnExpr.Expr)))) goto yyL5;
  {
/* line 3966 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP222);
/* line 3967 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP");
/* line 3967 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP223);
/* line 3968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP225->AFormal.Next, yyP224->AnExpr.Next, yyP223 + 1, true);
  }
  }
  }
   return;
yyL5:;

/* line 3971 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3972 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP222);
/* line 3973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP224->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP225->AFormal.Next, yyP224->AnExpr.Next, yyP223 + 1, true);
  }
   return;

  }
  }
/* line 3977 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP222);
/* line 3979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP");
/* line 3979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP223);
/* line 3980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP225->AFormal.Next, yyP224->AnExpr.Next, yyP223 + 1, true);
  }
   return;

  }
  }
;
}

static void GenF90CharParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP228, register tTree yyP227, register int yyP226)
# else
(yyP228, yyP227, yyP226)
 register tTree yyP228;
 register tTree yyP227;
 register int yyP226;
# endif
{
  if (yyP227->Kind == kNoExpr) {
/* line 3986 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP228->Kind == kAFormal) {
  if (yyP228->AFormal.Type->Kind == kArray) {
  if (yyP228->AFormal.Type->Array.Type->Kind == kByte) {
  if (yyP227->Kind == kAnExpr) {
  if (yyP227->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP227->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3989 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (true);
/* line 3990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (ExprType (yyP227->AnExpr.Expr), yyP227->AnExpr.Expr->ElementalExpr.Elemental);
/* line 3991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90CharParams (yyP228->AFormal.Next, yyP227->AnExpr.Next, yyP226 + 1);
  }
   return;

  }
  }
  }
  }
  if (yyP227->Kind == kAnExpr) {
  if (yyP227->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP227->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP228->AFormal.Type)))) goto yyL3;
  {
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (true);
/* line 3996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP226);
/* line 3996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".len");
/* line 3997 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90CharParams (yyP228->AFormal.Next, yyP227->AnExpr.Next, yyP226 + 1);
  }
  }
   return;
yyL3:;

  }
  }
  }
  }
  if (yyP227->Kind == kAnExpr) {
/* line 4000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4001 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90CharParams (yyP228->AFormal.Next, yyP227->AnExpr.Next, yyP226 + 1);
  }
   return;

  }
  }
;
}

static void GenF90Results
# if defined __STDC__ | defined __cplusplus
(register tTree yyP231, register tTree yyP230, register int yyP229)
# else
(yyP231, yyP230, yyP229)
 register tTree yyP231;
 register tTree yyP230;
 register int yyP229;
# endif
{
  if (yyP230->Kind == kNoExpr) {
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP231->Kind == kAFormal) {
  if (yyP230->Kind == kAnExpr) {
  if (yyP230->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP230->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4009 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4009 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsBoundedType (yyP231->AFormal.Type)))) goto yyL2;
  {
/* line 4010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Results (yyP231->AFormal.Next, yyP230->AnExpr.Next, yyP229 + 1);
  }
  }
   return;
yyL2:;

  }
  }
/* line 4017 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Results (yyP231->AFormal.Next, yyP230->AnExpr.Next, yyP229 + 1);
  }
   return;

  }
  if (yyP231->AFormal.Type->Kind == kArray) {
  if (yyP230->Kind == kAnExpr) {
  if (yyP230->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP230->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Results (yyP231->AFormal.Next, yyP230->AnExpr.Next, yyP229 + 1);
  }
   return;

  }
  }
  }
  }
  }
;
}

static void GenArrayDimSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP233, register tTree yyP232)
# else
(yyP233, yyP232)
 register tTree yyP233;
 register tTree yyP232;
# endif
{
  if (yyP233->Kind == kArray) {
  if (yyP233->Array.Expr->Kind == kUnBound) {
/* line 4023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4024 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP232));
/* line 4024 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4024 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP233));
  }
   return;

  }
/* line 4027 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (ValConstInt (yyP233->Array.Expr));
  }
   return;

  }
;
}

static void GenExtParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP237, register tTree yyP236, register tIdent yyP235, register int yyP234)
# else
(yyP237, yyP236, yyP235, yyP234)
 register tTree yyP237;
 register tTree yyP236;
 register tIdent yyP235;
 register int yyP234;
# endif
{
  if (yyP237->Kind == kNoFormal) {
  if (yyP236->Kind == kNoExpr) {
/* line 4036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
  if (yyP237->Kind == kAFormal) {
  if (yyP236->Kind == kAnExpr) {
/* line 4038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP237->AFormal.Type)))) goto yyL2;
  {
/* line 4039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP237->AFormal.Next, yyP236->AnExpr.Next, yyP235, yyP234);
  }
  }
   return;
yyL2:;

  }
  if (yyP237->AFormal.Type->Kind == kArray) {
  if (yyP236->Kind == kAnExpr) {
/* line 4041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP237->AFormal.Type, ExprType (yyP236->AnExpr.Expr), yyP236->AnExpr.Expr, yyP235, yyP234);
/* line 4043 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP237->AFormal.Next, yyP236->AnExpr.Next, yyP235, yyP234 + 1);
  }
   return;

  }
  }
  if (yyP237->AFormal.By->Kind == kByRef) {
  if (yyP236->Kind == kAnExpr) {
  if (yyP236->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP236->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP236->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL4;
  {
/* line 4046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP235);
/* line 4046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 4046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP234);
/* line 4047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP236->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 4047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP237->AFormal.Next, yyP236->AnExpr.Next, yyP235, yyP234 + 1);
  }
  }
   return;
yyL4:;

/* line 4050 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4051 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4051 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP235);
/* line 4051 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4051 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 4051 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP234);
/* line 4052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP236->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 4052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP237->AFormal.Next, yyP236->AnExpr.Next, yyP235, yyP234 + 1);
  }
   return;

  }
  }
  }
  }
  if (yyP237->AFormal.By->Kind == kByVal) {
  if (yyP236->Kind == kAnExpr) {
/* line 4055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP235);
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP234);
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP236->AnExpr.Expr);
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP237->AFormal.Next, yyP236->AnExpr.Next, yyP235, yyP234 + 1);
  }
   return;

  }
  }
  }
;
}

static void GenExtArrayParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP242, register tTree yyP241, register tTree yyP240, register tIdent yyP239, register int yyP238)
# else
(yyP242, yyP241, yyP240, yyP239, yyP238)
 register tTree yyP242;
 register tTree yyP241;
 register tTree yyP240;
 register tIdent yyP239;
 register int yyP238;
# endif
{
  if (yyP242->Kind == kArray) {
  if (yyP242->Array.Expr->Kind == kUnBound) {
  if (yyP241->Kind == kArray) {
  if (yyP241->Array.Expr->Kind == kUnBound) {
  if (yyP240->Kind == kElementalExpr) {
  if (Tree_IsType (yyP240->ElementalExpr.Elemental, kElement)) {
/* line 4062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP239);
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP238);
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP242));
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP240->ElementalExpr.Elemental));
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP241));
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP242->Array.Type, yyP241->Array.Type, yyP240, yyP239, yyP238);
  }
   return;

  }
  }
  }
/* line 4067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP239);
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP238);
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP242));
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP241->Array.Expr);
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4069 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP242->Array.Type, yyP241->Array.Type, yyP240, yyP239, yyP238);
  }
   return;

  }
  }
  if (yyP241->Kind == kArray) {
  if (yyP241->Array.Expr->Kind == kUnBound) {
  if (yyP240->Kind == kElementalExpr) {
  if (Tree_IsType (yyP240->ElementalExpr.Elemental, kElement)) {
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 4072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP242->Array.Expr);
/* line 4072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 4073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP240->ElementalExpr.Elemental));
/* line 4073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP241));
/* line 4073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 4073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4074 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP242->Array.Type, yyP241->Array.Type, yyP240, yyP239, yyP238);
  }
   return;

  }
  }
  }
/* line 4076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP242->Array.Expr)))) goto yyL4;
  {
/* line 4076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP241->Array.Expr)))) goto yyL4;
  {
/* line 4077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP242->Array.Type, yyP241->Array.Type, yyP240, yyP239, yyP238);
  }
  }
  }
   return;
yyL4:;

/* line 4079 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP242->Array.Expr);
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP241->Array.Expr);
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP242->Array.Type, yyP241->Array.Type, yyP240, yyP239, yyP238);
  }
   return;

  }
  }
  if (yyP240->Kind == kElementalExpr) {
  if (Tree_IsType (yyP240->ElementalExpr.Elemental, kElement)) {
/* line 4083 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4083 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP242)))) goto yyL6;
  {
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP239);
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP238);
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= (");
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP242);
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP240->ElementalExpr.Elemental, true);
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

/* line 4086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP239);
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP238);
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= (");
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP242);
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP240->ElementalExpr.Elemental, true);
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 4089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP240, yyP240->Expr.Pos);
  }
   return;

;
}

static void GenIntParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP246, register tTree yyP245, register tIdent yyP244, tSymbol yyP243)
# else
(yyP246, yyP245, yyP244, yyP243)
 register tTree yyP246;
 register tTree yyP245;
 register tIdent yyP244;
 tSymbol yyP243;
# endif
{
  if (yyP246->Kind == kNoFormal) {
  if (yyP245->Kind == kNoExpr) {
/* line 4094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
  if (yyP246->Kind == kAFormal) {
  if (yyP245->Kind == kAnExpr) {
/* line 4096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP246->AFormal.Type)))) goto yyL2;
  {
/* line 4097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP246->AFormal.Next, yyP245->AnExpr.Next, yyP244, yyP243);
  }
  }
   return;
yyL2:;

  }
  if (yyP246->AFormal.Type->Kind == kArray) {
  if (yyP245->Kind == kAnExpr) {
/* line 4099 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4100 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP246->AFormal.Type, ExprType (yyP245->AnExpr.Expr), yyP246->AFormal.Sym, yyP245->AnExpr.Expr, yyP244, yyP243);
/* line 4101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP246->AFormal.Next, yyP245->AnExpr.Next, yyP244, yyP243);
  }
   return;

  }
  }
  if (yyP246->AFormal.By->Kind == kByRef) {
  if (yyP245->Kind == kAnExpr) {
  if (yyP245->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP245->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP245->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL4;
  {
/* line 4104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP244, yyP243);
/* line 4104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP246->AFormal.Sym);
/* line 4104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP245->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 4104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4105 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP246->AFormal.Next, yyP245->AnExpr.Next, yyP244, yyP243);
  }
  }
   return;
yyL4:;

/* line 4107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP244, yyP243);
/* line 4108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP246->AFormal.Sym);
/* line 4108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP245->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 4108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4109 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP246->AFormal.Next, yyP245->AnExpr.Next, yyP244, yyP243);
  }
   return;

  }
  }
  }
  }
  if (yyP246->AFormal.By->Kind == kByVal) {
  if (yyP245->Kind == kAnExpr) {
/* line 4111 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP244, yyP243);
/* line 4112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP246->AFormal.Sym);
/* line 4112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP245->AnExpr.Expr);
/* line 4112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4113 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP246->AFormal.Next, yyP245->AnExpr.Next, yyP244, yyP243);
  }
   return;

  }
  }
  }
;
}

static void GenChain
# if defined __STDC__ | defined __cplusplus
(register tIdent yyP249, tSymbol yyP248, register bool yyP247)
# else
(yyP249, yyP248, yyP247)
 register tIdent yyP249;
 tSymbol yyP248;
 register bool yyP247;
# endif
{
  if (equalbool (yyP247, true)) {
/* line 4120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP249);
/* line 4120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".Chain = NULL;");
/* line 4120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 4121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP249);
/* line 4121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".Chain = ");
/* line 4121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP");
/* line 4121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP248, CurProc);
/* line 4121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenIntArrayParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP255, register tTree yyP254, tSymbol yyP253, register tTree yyP252, register tIdent yyP251, tSymbol yyP250)
# else
(yyP255, yyP254, yyP253, yyP252, yyP251, yyP250)
 register tTree yyP255;
 register tTree yyP254;
 tSymbol yyP253;
 register tTree yyP252;
 register tIdent yyP251;
 tSymbol yyP250;
# endif
{
  if (yyP255->Kind == kArray) {
  if (yyP255->Array.Expr->Kind == kUnBound) {
  if (yyP254->Kind == kArray) {
  if (yyP254->Array.Expr->Kind == kUnBound) {
  if (yyP252->Kind == kElementalExpr) {
  if (Tree_IsType (yyP252->ElementalExpr.Elemental, kElement)) {
/* line 4126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP251, yyP250);
/* line 4127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP253);
/* line 4127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP255));
/* line 4127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4128 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP252->ElementalExpr.Elemental));
/* line 4128 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4128 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP254));
/* line 4128 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4128 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4129 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP255->Array.Type, yyP254->Array.Type, yyP253, yyP252, yyP251, yyP250);
  }
   return;

  }
  }
  }
/* line 4131 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP251, yyP250);
/* line 4132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP253);
/* line 4132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP255));
/* line 4132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP254->Array.Expr);
/* line 4132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP255->Array.Type, yyP254->Array.Type, yyP253, yyP252, yyP251, yyP250);
  }
   return;

  }
  }
  if (yyP254->Kind == kArray) {
  if (yyP254->Array.Expr->Kind == kUnBound) {
  if (yyP252->Kind == kElementalExpr) {
  if (Tree_IsType (yyP252->ElementalExpr.Elemental, kElement)) {
/* line 4135 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 4136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP255->Array.Expr);
/* line 4136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 4137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP252->ElementalExpr.Elemental));
/* line 4137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP254));
/* line 4137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 4137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4138 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP255->Array.Type, yyP254->Array.Type, yyP253, yyP252, yyP251, yyP250);
  }
   return;

  }
  }
  }
/* line 4140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP255->Array.Expr)))) goto yyL4;
  {
/* line 4140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP254->Array.Expr)))) goto yyL4;
  {
/* line 4141 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP255->Array.Type, yyP254->Array.Type, yyP253, yyP252, yyP251, yyP250);
  }
  }
  }
   return;
yyL4:;

/* line 4143 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP255->Array.Expr);
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP254->Array.Expr);
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4145 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP255->Array.Type, yyP254->Array.Type, yyP253, yyP252, yyP251, yyP250);
  }
   return;

  }
  }
  if (yyP252->Kind == kElementalExpr) {
  if (Tree_IsType (yyP252->ElementalExpr.Elemental, kElement)) {
/* line 4147 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4147 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP255)))) goto yyL6;
  {
/* line 4148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP251, yyP250);
/* line 4148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP253);
/* line 4148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= (");
/* line 4148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP255);
/* line 4148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP252->ElementalExpr.Elemental, true);
/* line 4148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

/* line 4150 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP251, yyP250);
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP253);
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= (");
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP255);
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP252->ElementalExpr.Elemental, true);
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 4153 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4153 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP252, yyP252->Expr.Pos);
  }
   return;

;
}

static void GenFrameRef
# if defined __STDC__ | defined __cplusplus
(register tIdent yyP257, tSymbol yyP256)
# else
(yyP257, yyP256)
 register tIdent yyP257;
 tSymbol yyP256;
# endif
{
  {tSymbol yyT; yyT = NoSymbol;
  if (equaltSymbol (yyP256, yyT)) {
/* line 4158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP257);
  }
   return;

  }
  }
/* line 4159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP257);
/* line 4159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 4159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP256) . Kind, yyP256, false);
/* line 4159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
  }
   return;

;
}

static void GenFuncCall
# if defined __STDC__ | defined __cplusplus
(register tTree yyP260, register tTree yyP259, register tTree yyP258)
# else
(yyP260, yyP259, yyP258)
 register tTree yyP260;
 register tTree yyP259;
 register tTree yyP258;
# endif
{
/* line 4164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; 
/* line 4166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP259->FuncCall.Sym);
/* line 4167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (yyP260)))) goto yyL1;
  {
/* line 4169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP");
/* line 4169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP259->FuncCall.Sym, CurProc);
/* line 4170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 4171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

  if (yyP260->DefFunc.Formals->Kind == kAFormal) {
/* line 4174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP260->DefFunc.Formals, yyP259->FuncCall.ExprList, comma);
/* line 4176 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 4177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

  }
/* line 4180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsMVFunction (yyP260)))) goto yyL3;
  {
/* line 4181 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFParams (yyP258, comma, 0);
/* line 4182 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 4185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void CodeMVFParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP263, register bool yyP262, register int yyP261)
# else
(yyP263, yyP262, yyP261)
 register tTree yyP263;
 register bool yyP262;
 register int yyP261;
# endif
{
  if (yyP263->Kind == kNoExpr) {
/* line 4194 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP263->Kind == kAnExpr) {
  if (yyP263->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP263->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4196 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4196 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((TempRequired (yyP263)))) goto yyL2;
  {
/* line 4197 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP262);
/* line 4198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&_TMP");
/* line 4198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP261);
/* line 4199 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFParams (yyP263->AnExpr.Next, true, yyP261 + 1);
  }
  }
   return;
yyL2:;

/* line 4202 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP262);
/* line 4204 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP263->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 4205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFParams (yyP263->AnExpr.Next, true, yyP261 + 1);
  }
   return;

  }
  }
  }
;
}

static void CodeMVFTemps
# if defined __STDC__ | defined __cplusplus
(register tTree yyP265, register int yyP264)
# else
(yyP265, yyP264)
 register tTree yyP265;
 register int yyP264;
# endif
{
  if (yyP265->Kind == kNoExpr) {
/* line 4212 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP265->Kind == kAnExpr) {
  if (yyP265->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP265->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4214 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4214 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((TempRequired (yyP265)))) goto yyL2;
  {
/* line 4215 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP265->AnExpr.Expr->ElementalExpr.Elemental));
/* line 4215 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" _TMP");
/* line 4215 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP264);
/* line 4215 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4215 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4216 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFTemps (yyP265->AnExpr.Next, yyP264 + 1);
  }
  }
   return;
yyL2:;

/* line 4219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFTemps (yyP265->AnExpr.Next, yyP264 + 1);
  }
   return;

  }
  }
  }
;
}

static void CodeMVFTempCopies
# if defined __STDC__ | defined __cplusplus
(register tTree yyP267, register int yyP266)
# else
(yyP267, yyP266)
 register tTree yyP267;
 register int yyP266;
# endif
{
  if (yyP267->Kind == kNoExpr) {
/* line 4226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP267->Kind == kAnExpr) {
  if (yyP267->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP267->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4228 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4228 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((TempRequired (yyP267)))) goto yyL2;
  {
/* line 4229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP267->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 4229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = _TMP");
/* line 4229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP266);
/* line 4229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4230 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFTempCopies (yyP267->AnExpr.Next, yyP266 + 1);
  }
  }
   return;
yyL2:;

/* line 4233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFTempCopies (yyP267->AnExpr.Next, yyP266 + 1);
  }
   return;

  }
  }
  }
;
}

static void GenParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP270, register tTree yyP269, register bool yyP268)
# else
(yyP270, yyP269, yyP268)
 register tTree yyP270;
 register tTree yyP269;
 register bool yyP268;
# endif
{
  if (yyP269->Kind == kNoExpr) {
/* line 4241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP270->Kind == kAFormal) {
  if (yyP269->Kind == kAnExpr) {
/* line 4243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP270->AFormal.Type)))) goto yyL2;
  {
/* line 4244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP270->AFormal.Next, yyP269->AnExpr.Next, yyP268);
  }
  }
   return;
yyL2:;

  }
  if (yyP270->AFormal.Type->Kind == kArray) {
  if (yyP269->Kind == kAnExpr) {
/* line 4247 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4248 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP270->AFormal.Type, ExprType (yyP269->AnExpr.Expr), yyP269->AnExpr.Expr, yyP268);
/* line 4249 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP270->AFormal.Next, yyP269->AnExpr.Next, true);
  }
   return;

  }
  }
  if (yyP270->AFormal.By->Kind == kByRef) {
  if (yyP269->Kind == kAnExpr) {
  if (yyP269->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP269->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP269->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL4;
  {
/* line 4253 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP268);
/* line 4254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP269->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 4255 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP270->AFormal.Next, yyP269->AnExpr.Next, true);
  }
  }
   return;
yyL4:;

/* line 4257 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4258 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP268);
/* line 4259 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP269->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 4260 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP270->AFormal.Next, yyP269->AnExpr.Next, true);
  }
   return;

  }
  }
  }
  }
  if (yyP270->AFormal.By->Kind == kByVal) {
  if (yyP269->Kind == kAnExpr) {
/* line 4262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP268);
/* line 4264 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP269->AnExpr.Expr);
/* line 4265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP270->AFormal.Next, yyP269->AnExpr.Next, true);
  }
   return;

  }
  }
  }
;
}

static void GenArrayParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP274, register tTree yyP273, register tTree yyP272, register bool yyP271)
# else
(yyP274, yyP273, yyP272, yyP271)
 register tTree yyP274;
 register tTree yyP273;
 register tTree yyP272;
 register bool yyP271;
# endif
{
  if (yyP274->Kind == kArray) {
  if (yyP274->Array.Expr->Kind == kUnBound) {
  if (yyP273->Kind == kArray) {
  if (yyP273->Array.Expr->Kind == kUnBound) {
  if (yyP272->Kind == kElementalExpr) {
  if (Tree_IsType (yyP272->ElementalExpr.Elemental, kElement)) {
/* line 4274 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP271);
/* line 4276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP272->ElementalExpr.Elemental));
/* line 4276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP273));
/* line 4277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP274->Array.Type, yyP273->Array.Type, yyP272, true);
  }
   return;

  }
  }
  }
/* line 4279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4280 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP271);
/* line 4281 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP273->Array.Expr);
/* line 4282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP274->Array.Type, yyP273->Array.Type, yyP272, true);
  }
   return;

  }
  }
  if (yyP273->Kind == kArray) {
/* line 4285 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4285 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP274->Array.Expr)))) goto yyL3;
  {
/* line 4285 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP273->Array.Expr)))) goto yyL3;
  {
/* line 4286 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP274->Array.Type, yyP273->Array.Type, yyP272, yyP271);
  }
  }
  }
   return;
yyL3:;

  if (yyP273->Array.Expr->Kind == kUnBound) {
  if (yyP272->Kind == kElementalExpr) {
  if (Tree_IsType (yyP272->ElementalExpr.Elemental, kElement)) {
/* line 4289 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP274->Array.Type, yyP273->Array.Type, yyP272, yyP271);
  }
   return;

  }
  }
  }
/* line 4293 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP274->Array.Type, yyP273->Array.Type, yyP272, yyP271);
  }
   return;

  }
  }
  if (yyP272->Kind == kElementalExpr) {
  if (Tree_IsType (yyP272->ElementalExpr.Elemental, kElement)) {
/* line 4298 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4298 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP274)))) goto yyL6;
  {
/* line 4299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP271);
/* line 4300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP274);
/* line 4300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP272->ElementalExpr.Elemental, true);
  }
  }
   return;
yyL6:;

/* line 4303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP271);
/* line 4305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP274);
/* line 4305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP272->ElementalExpr.Elemental, true);
  }
   return;

  }
  }
/* line 4308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP272, yyP272->Expr.Pos);
  }
   return;

;
}

static void GenComma
# if defined __STDC__ | defined __cplusplus
(register bool yyP275)
# else
(yyP275)
 register bool yyP275;
# endif
{
  if (equalbool (yyP275, true)) {
/* line 4313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
  }
   return;

  }
/* line 4317 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

;
}

static void GenTimerInput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP276)
# else
(yyP276)
 register tTree yyP276;
# endif
{
  if (yyP276->Kind == kAnExpr) {
/* line 4327 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4328 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP276->AnExpr.Expr);
/* line 4328 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ReadTimer();");
/* line 4328 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenInput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP278, register tTree T, register tTree yyP277)
# else
(yyP278, T, yyP277)
 register tTree yyP278;
 register tTree T;
 register tTree yyP277;
# endif
{
/* line 4334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
  if (yyP277->Kind == kNoExpr) {
/* line 4335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP277->Kind == kAnExpr) {
  if (yyP277->AnExpr.Expr->Kind == kCountArray) {
  if (yyP277->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP277->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP277->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4337 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4338 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInputToExpr (yyP278, yyP277->AnExpr.Expr->CountArray.Length);
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP277->AnExpr.Expr->CountArray.Length);
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("<=");
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP277->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental, ExprType (yyP277->AnExpr.Expr->CountArray.Expr));
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_CITL);
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT");
/* line 4341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP278, false);
/* line 4341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP277->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental, true);
/* line 4341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP277->AnExpr.Expr->CountArray.Length);
/* line 4342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")*(");
/* line 4342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (GetElementSymbol (yyP277->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental), ExprType (yyP277->AnExpr.Expr->CountArray.Expr) -> Array . Type);
/* line 4342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
/* line 4343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 4344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP278, T, yyP277->AnExpr.Next);
  }
   return;

  }
  }
  }
  }
/* line 4346 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4346 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP277->AnExpr.Expr))))) goto yyL3;
  {
/* line 4347 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInputToExpr (yyP278, yyP277->AnExpr.Expr);
/* line 4348 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP278, T, yyP277->AnExpr.Next);
  }
  }
   return;
yyL3:;

  if (yyP277->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP277->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4351 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4351 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT");
/* line 4352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP278, false);
/* line 4352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP277->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 4352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP277->AnExpr.Expr->ElementalExpr.Elemental, ExprType (yyP277->AnExpr.Expr));
/* line 4353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 4355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP278, T, yyP277->AnExpr.Next);
  }
   return;

  }
  }
  }
/* line 4357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP278, yyP278->Element.Pos);
  }
   return;

;
}

static void GenInputToExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP280, register tTree yyP279)
# else
(yyP280, yyP279)
 register tTree yyP280;
 register tTree yyP279;
# endif
{
/* line 4360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
  if (yyP279->Kind == kElementalExpr) {
  if (Tree_IsType (yyP279->ElementalExpr.Elemental, kElement)) {
/* line 4361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP279))))) goto yyL1;
  {
/* line 4362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT");
/* line 4362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (ExprType (yyP279)));
/* line 4363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP280, false);
/* line 4363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP279->ElementalExpr.Elemental, true);
/* line 4364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
  }
   return;
yyL1:;

  }
  }
;
}

static void GenOutput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP283, register tTree yyP282, register tTree yyP281)
# else
(yyP283, yyP282, yyP281)
 register tTree yyP283;
 register tTree yyP282;
 register tTree yyP281;
# endif
{
  if (yyP281->Kind == kNoExpr) {
/* line 4371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP282->Kind == kNamed) {
/* line 4373 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4373 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP282->Named.Sym), kDefSeqPro)))) goto yyL2;
  {
/* line 4374 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSeqProOutput (yyP283, SymbolKind (yyP282->Named.Sym) -> DefSeqPro . SeqProList, yyP281);
  }
  }
   return;
yyL2:;

  if (yyP281->Kind == kAnExpr) {
  if (yyP281->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP281->AnExpr.Expr->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 4376 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4376 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP282->Named.Sym), kDefTagPro)))) goto yyL3;
  {
/* line 4377 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutputOfExpr (yyP283, yyP281->AnExpr.Expr, ExprType (yyP281->AnExpr.Expr));
/* line 4378 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSeqProOutput (yyP283, SymbolKind (yyP281->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym) -> ATagPro . SeqProList, yyP281->AnExpr.Next);
  }
  }
   return;
yyL3:;

  }
  }
  }
  }
  if (yyP282->Kind == kAny) {
  if (yyP281->Kind == kAnExpr) {
/* line 4380 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4380 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutput (yyP283, yyP282, yyP281->AnExpr.Expr);
/* line 4380 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOutput (yyP283, yyP282, yyP281->AnExpr.Next);
  }
   return;

  }
  if (yyP281->Kind == kNoExpr) {
/* line 4381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
  if (yyP282->Kind == kSimple) {
  if (yyP281->Kind == kAnExpr) {
  if (yyP281->AnExpr.Next->Kind == kNoExpr) {
/* line 4383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutput (yyP283, yyP282, yyP281->AnExpr.Expr);
  }
   return;

  }
  }
  }
  if (yyP282->Kind == kCounted) {
  if (yyP281->Kind == kAnExpr) {
  if (yyP281->AnExpr.Next->Kind == kNoExpr) {
/* line 4385 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4385 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutput (yyP283, yyP282, yyP281->AnExpr.Expr);
  }
   return;

  }
  }
  }
  if (yyP281->Kind == kAnExpr) {
/* line 4387 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4387 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP281->AnExpr.Expr, yyP281->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
;
}

static void GenSeqProOutput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP286, register tTree yyP285, register tTree yyP284)
# else
(yyP286, yyP285, yyP284)
 register tTree yyP286;
 register tTree yyP285;
 register tTree yyP284;
# endif
{
  if (yyP285->Kind == kASeqPro) {
  if (yyP284->Kind == kAnExpr) {
/* line 4390 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4390 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutput (yyP286, yyP285->ASeqPro.Protocol, yyP284->AnExpr.Expr);
/* line 4390 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSeqProOutput (yyP286, yyP285->ASeqPro.Next, yyP284->AnExpr.Next);
  }
   return;

  }
  }
;
}

static void GenSimpleOutput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP289, register tTree yyP288, register tTree yyP287)
# else
(yyP289, yyP288, yyP287)
 register tTree yyP289;
 register tTree yyP288;
 register tTree yyP287;
# endif
{
/* line 4393 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
  if (yyP288->Kind == kCounted) {
  if (yyP287->Kind == kCountArray) {
  if (yyP287->CountArray.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP287->CountArray.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4395 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4396 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutputOfExpr (yyP289, yyP287->CountArray.Length, ExprType (yyP287->CountArray.Length));
/* line 4397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP289, false);
/* line 4398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP287->CountArray.Expr->ElementalExpr.Elemental, true);
/* line 4398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP287->CountArray.Length);
/* line 4399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")*(");
/* line 4399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (GetElementSymbol (yyP287->CountArray.Expr->ElementalExpr.Elemental), ExprType (yyP287->CountArray.Expr) -> Array . Type);
/* line 4399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
/* line 4400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

  }
  }
  }
  if (yyP287->Kind == kElementalExpr) {
  if (Tree_IsType (yyP287->ElementalExpr.Elemental, kElement)) {
/* line 4403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4404 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->_Header.Temp.V");
/* line 4405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP288->Counted.Type);
/* line 4405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 4405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP287->ElementalExpr.Elemental, ExprType (yyP287));
/* line 4405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4406 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4406 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (yyP288->Counted.Type));
/* line 4407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP289, false);
/* line 4407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.V");
/* line 4407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP288->Counted.Type);
/* line 4408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 4409 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4409 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP289, false);
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP287->ElementalExpr.Elemental, true);
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP287->ElementalExpr.Elemental, ExprType (yyP287));
/* line 4411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
/* line 4412 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4412 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4412 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4412 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

  }
  }
  }
/* line 4415 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4415 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP287))))) goto yyL3;
  {
/* line 4416 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutputOfExpr (yyP289, yyP287, ExprType (yyP287));
  }
  }
   return;
yyL3:;

  if (yyP287->Kind == kElementalExpr) {
  if (Tree_IsType (yyP287->ElementalExpr.Elemental, kElement)) {
/* line 4419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP289, false);
/* line 4421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP287->ElementalExpr.Elemental, true);
/* line 4421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP287->ElementalExpr.Elemental, ExprType (yyP287));
/* line 4422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4423 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4423 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4423 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4423 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

  }
  }
/* line 4425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP287, yyP287->Expr.Pos);
  }
   return;

;
}

static void GenSimpleOutputOfExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP292, register tTree yyP291, register tTree yyP290)
# else
(yyP292, yyP291, yyP290)
 register tTree yyP292;
 register tTree yyP291;
 register tTree yyP290;
# endif
{
/* line 4428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
/* line 4430 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4430 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP291))))) goto yyL1;
  {
/* line 4430 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP291)))) goto yyL1;
  {
/* line 4431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->_Header.Temp.V");
/* line 4432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP290);
/* line 4432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 4433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP291);
/* line 4433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4434 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4434 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (yyP290));
/* line 4435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP292, false);
/* line 4435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.V");
/* line 4435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP290);
/* line 4436 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4436 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4436 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4436 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4436 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
  }
  }
   return;
yyL1:;

  if (yyP291->Kind == kElementalExpr) {
  if (Tree_IsType (yyP291->ElementalExpr.Elemental, kElement)) {
/* line 4439 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4439 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP291))))) goto yyL2;
  {
/* line 4440 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (yyP290));
/* line 4442 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4442 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP292, false);
/* line 4442 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4442 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP291->ElementalExpr.Elemental, true);
/* line 4443 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4443 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4443 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4443 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4443 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
  }
   return;
yyL2:;

  }
  }
/* line 4446 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4446 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP291))))) goto yyL3;
  {
/* line 4447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4448 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->_Header.Temp.V");
/* line 4448 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP290);
/* line 4448 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 4449 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP291);
/* line 4449 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4449 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4450 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4450 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (yyP290));
/* line 4451 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4451 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP292, false);
/* line 4451 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.V");
/* line 4451 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP290);
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
  }
   return;
yyL3:;

/* line 4456 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4456 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP291, yyP291->Expr.Pos);
  }
   return;

;
}

static void CodeElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP294, register bool yyP293)
# else
(yyP294, yyP293)
 register tTree yyP294;
 register bool yyP293;
# endif
{
/* line 4466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tSymbol Sym; 
/* line 4468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP294))))) goto yyL1;
  {
/* line 4469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected channel element", xxError, yyP294->Element.Pos);
  }
  }
   return;
yyL1:;

  if (yyP294->Kind == kIdentifier) {
  if (equalbool (yyP293, false)) {
/* line 4471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((ConstFlag (yyP294 -> Element)))) goto yyL2;
  {
/* line 4472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstExpr (ElementType (yyP294), yyP294 -> Element . CV);
  }
  }
   return;
yyL2:;

  }
/* line 4474 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4474 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolType (yyP294->Identifier.Sym), kArray)))) goto yyL3;
  {
/* line 4475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP294->Identifier.Sym);
  }
  }
   return;
yyL3:;

/* line 4477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4478 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP294->Identifier.Sym) . Kind, yyP294->Identifier.Sym, yyP293);
  }
   return;

  }
  if (yyP294->Kind == kSubscript) {
/* line 4480 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4480 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! yyP293))) goto yyL5;
  {
/* line 4480 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! Tree_IsType (ElementType (yyP294), kArray)))) goto yyL5;
  {
/* line 4481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP294, true);
  }
  }
  }
   return;
yyL5:;

/* line 4484 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4485 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP294);
/* line 4486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 4486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP294));
/* line 4486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4487 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP294), yyP294);
/* line 4487 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP294->Kind == kRange) {
/* line 4489 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP294);
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP294));
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP294) -> Array . Type, yyP294);
/* line 4492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP294, yyP294->Element.Pos);
  }
   return;

;
}

static void CodeChannelElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP296, register bool yyP295)
# else
(yyP296, yyP295)
 register tTree yyP296;
 register bool yyP295;
# endif
{
/* line 4499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tSymbol Sym; 
/* line 4501 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4501 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsChanType (ElementType (yyP296))))) goto yyL1;
  {
/* line 4502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Expected channel element", xxError, yyP296->Element.Pos);
  }
  }
   return;
yyL1:;

  if (yyP296->Kind == kIdentifier) {
  if (equalbool (yyP295, false)) {
/* line 4504 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4504 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolType (yyP296->Identifier.Sym), kArray)))) goto yyL2;
  {
/* line 4505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Can only take reference to channel arrays", xxError, yyP296->Identifier.Pos);
  }
  }
   return;
yyL2:;

  }
  if (equalbool (yyP295, true)) {
/* line 4507 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4507 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolType (yyP296->Identifier.Sym), kArray)))) goto yyL3;
  {
/* line 4508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP296->Identifier.Sym);
  }
  }
   return;
yyL3:;

  }
  if (equalbool (yyP295, true)) {
/* line 4510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(&");
/* line 4511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP296->Identifier.Sym);
/* line 4511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4513 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP296->Identifier.Sym);
  }
   return;

  }
  if (yyP296->Kind == kSubscript) {
  if (equalbool (yyP295, false)) {
/* line 4516 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4516 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! Tree_IsType (ElementType (yyP296), kArray)))) goto yyL6;
  {
/* line 4517 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP296);
/* line 4518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*(((");
/* line 4518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP296));
/* line 4518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4519 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP296), yyP296);
/* line 4519 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL6:;

  }
/* line 4521 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4522 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP296);
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP296));
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP296), yyP296);
/* line 4524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP296->Kind == kRange) {
  if (equalbool (yyP295, true)) {
/* line 4526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4527 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP296);
/* line 4528 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 4528 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP296));
/* line 4528 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4528 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4528 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4529 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP296) -> Array . Type, yyP296);
/* line 4529 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4531 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4532 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Can only take reference to channel arrays", xxError, yyP296->Range.Pos);
  }
   return;

  }
/* line 4534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP296, yyP296->Element.Pos);
  }
   return;

;
}

static void GenArrayIndex
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP299, register tTree yyP298, register tTree yyP297)
# else
(yyP299, yyP298, yyP297)
 tSymbol yyP299;
 register tTree yyP298;
 register tTree yyP297;
# endif
{
  if (yyP298->Kind == kArray) {
/* line 4545 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4545 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP298->Array.Expr)))) goto yyL1;
  {
/* line 4546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP299);
/* line 4546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP298));
/* line 4546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP299, yyP298->Array.Type, yyP297);
/* line 4546 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL1:;

/* line 4548 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP298->Array.Expr);
/* line 4549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP299, yyP298->Array.Type, yyP297);
/* line 4549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP297->Kind == kSubscript) {
  if (yyP297->Subscript.Next->Kind == kIdentifier) {
/* line 4552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (ElementType (yyP297->Subscript.Next) -> Array . Expr)))) goto yyL3;
  {
/* line 4553 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkExpr (DoBndChk (yyP297), true, yyP297->Subscript.Expr, yyP299, ElementType (yyP297->Subscript.Next));
  }
  }
   return;
yyL3:;

/* line 4555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4556 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkExpr (DoBndChk (yyP297), false, yyP297->Subscript.Expr, yyP299, ElementType (yyP297->Subscript.Next));
  }
   return;

  }
/* line 4559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (ElementType (yyP297->Subscript.Next) -> Array . Expr, kUnBound)))) goto yyL5;
  {
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkExpr (DoBndChk (yyP297), true, yyP297->Subscript.Expr, yyP299, ElementType (yyP297->Subscript.Next));
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP299);
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (ElementType (yyP297->Subscript.Next)));
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP299, yyP298, yyP297->Subscript.Next);
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL5:;

/* line 4562 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkExpr (DoBndChk (yyP297), false, yyP297->Subscript.Expr, yyP299, ElementType (yyP297->Subscript.Next));
/* line 4563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 4563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (ElementType (yyP297->Subscript.Next) -> Array . Expr);
/* line 4563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP299, yyP298, yyP297->Subscript.Next);
/* line 4563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP297->Kind == kRange) {
  if (yyP297->Range.Next->Kind == kIdentifier) {
/* line 4566 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4566 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (ElementType (yyP297->Range.Next) -> Array . Expr)))) goto yyL7;
  {
/* line 4567 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4567 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkUBExpr (DoUprBndChk (yyP297), true, yyP297->Range.From, yyP297->Range.For, yyP299, ElementType (yyP297->Range.Next));
/* line 4568 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkLBExpr (DoLwrBndChk (yyP297), yyP297->Range.From);
/* line 4568 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL7:;

/* line 4570 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkUBExpr (DoUprBndChk (yyP297), false, yyP297->Range.From, yyP297->Range.For, yyP299, ElementType (yyP297->Range.Next));
/* line 4572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkLBExpr (DoLwrBndChk (yyP297), yyP297->Range.From);
/* line 4572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4575 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4575 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (ElementType (yyP297->Range.Next) -> Array . Expr, kUnBound)))) goto yyL9;
  {
/* line 4576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4577 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4577 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkUBExpr (DoUprBndChk (yyP297), true, yyP297->Range.From, yyP297->Range.For, yyP299, ElementType (yyP297->Range.Next));
/* line 4578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkLBExpr (DoLwrBndChk (yyP297), yyP297->Range.From);
/* line 4578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP299);
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (ElementType (yyP297->Range.Next)));
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP299, yyP298, yyP297->Range.Next);
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL9:;

/* line 4581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4582 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4583 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4583 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkUBExpr (DoUprBndChk (yyP297), false, yyP297->Range.From, yyP297->Range.For, yyP299, ElementType (yyP297->Range.Next));
/* line 4584 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkLBExpr (DoLwrBndChk (yyP297), yyP297->Range.From);
/* line 4584 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 4585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 4585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (ElementType (yyP297->Range.Next) -> Array . Expr);
/* line 4585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP299, yyP298, yyP297->Range.Next);
/* line 4585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
;
}

static void GenElementSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP301, register tTree yyP300)
# else
(yyP301, yyP300)
 register tTree yyP301;
 register tTree yyP300;
# endif
{
  if (yyP301->Kind == kRange) {
  if (yyP300->Kind == kArray) {
/* line 4598 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP301->Range.For);
/* line 4599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (GetElementSymbol (yyP301), yyP300->Array.Type);
/* line 4599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  }
/* line 4602 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4603 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (GetElementSymbol (yyP301), yyP300);
  }
   return;

;
}

static void GenArraySize
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP303, register tTree yyP302)
# else
(yyP303, yyP302)
 tSymbol yyP303;
 register tTree yyP302;
# endif
{
  if (yyP302->Kind == kArray) {
/* line 4612 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4612 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP302->Array.Expr)))) goto yyL1;
  {
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP303);
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP302));
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP303, yyP302->Array.Type);
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL1:;

/* line 4615 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP302->Array.Expr);
/* line 4616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP303, yyP302->Array.Type);
/* line 4616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4618 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4618 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP302)))) goto yyL3;
  {
/* line 4619 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 4619 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP302);
/* line 4619 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *)");
  }
  }
   return;
yyL3:;

/* line 4621 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 4622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP302);
/* line 4622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void CodeChkExpr
# if defined __STDC__ | defined __cplusplus
(register bool yyP308, register bool yyP307, register tTree yyP306, tSymbol yyP305, register tTree yyP304)
# else
(yyP308, yyP307, yyP306, yyP305, yyP304)
 register bool yyP308;
 register bool yyP307;
 register tTree yyP306;
 tSymbol yyP305;
 register tTree yyP304;
# endif
{
  if (equalbool (yyP308, true)) {
  if (equalbool (yyP307, true)) {
/* line 4630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHK);
/* line 4631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP306);
/* line 4631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP305);
/* line 4631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP304));
/* line 4631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  }
  if (equalbool (yyP308, true)) {
  if (yyP304->Kind == kArray) {
/* line 4633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHK);
/* line 4634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP306);
/* line 4634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP304->Array.Expr);
/* line 4634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  }
/* line 4636 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4636 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP306);
  }
   return;

;
}

static void CodeChkUBExpr
# if defined __STDC__ | defined __cplusplus
(register bool yyP314, register bool yyP313, register tTree yyP312, register tTree yyP311, tSymbol yyP310, register tTree yyP309)
# else
(yyP314, yyP313, yyP312, yyP311, yyP310, yyP309)
 register bool yyP314;
 register bool yyP313;
 register tTree yyP312;
 register tTree yyP311;
 tSymbol yyP310;
 register tTree yyP309;
# endif
{
  if (equalbool (yyP314, true)) {
  if (equalbool (yyP313, true)) {
  if (yyP309->Kind == kArray) {
/* line 4642 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHKUB);
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP312);
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP311);
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP310);
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP309));
/* line 4643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
  }
   return;

  }
  }
  }
  if (equalbool (yyP314, true)) {
  if (yyP309->Kind == kArray) {
/* line 4646 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHKUB);
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP312);
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP311);
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP309->Array.Expr);
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
  }
   return;

  }
  }
/* line 4650 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

;
}

static void CodeChkLBExpr
# if defined __STDC__ | defined __cplusplus
(register bool yyP316, register tTree yyP315)
# else
(yyP316, yyP315)
 register bool yyP316;
 register tTree yyP315;
# endif
{
  if (equalbool (yyP316, true)) {
/* line 4655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHKLB);
/* line 4655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP315);
/* line 4655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP315);
  }
   return;

;
}

static tSymbol GetElementSymbol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP317)
# else
(yyP317)
 register tTree yyP317;
# endif
{
  if (yyP317->Kind == kIdentifier) {
/* line 4660 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP317->Identifier.Sym;

  }
  if (yyP317->Kind == kSubscript) {
/* line 4661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return GetElementSymbol (yyP317->Subscript.Next);

  }
  if (yyP317->Kind == kRange) {
/* line 4662 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return GetElementSymbol (yyP317->Range.Next);

  }
 yyAbort ("GetElementSymbol");
}

void CodeSymRef
# if defined __STDC__ | defined __cplusplus
(register tTree yyP320, tSymbol yyP319, register bool yyP318)
# else
(yyP320, yyP319, yyP318)
 register tTree yyP320;
 tSymbol yyP319;
 register bool yyP318;
# endif
{

  switch (yyP320->Kind) {
  case kAFormal:
  if (yyP320->AFormal.By->Kind == kByRef) {
  if (equalbool (yyP318, true)) {
/* line 4667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
/* line 4668 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4668 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4668 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
  if (yyP320->AFormal.By->Kind == kByVal) {
  if (equalbool (yyP318, true)) {
/* line 4670 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4670 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4670 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
/* line 4671 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4671 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
  break;
  case kAnId:
  if (equalbool (yyP318, true)) {
/* line 4673 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4673 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4673 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
/* line 4674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  case kReplicator:
  if (equalbool (yyP318, true)) {
/* line 4676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
/* line 4677 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4677 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  case kIs:
  if (equalbool (yyP318, true)) {
/* line 4679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP319))))) goto yyL9;
  {
/* line 4679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
  }
   return;
yyL9:;

  }
/* line 4680 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4680 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP319))))) goto yyL10;
  {
/* line 4680 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
  }
   return;
yyL10:;

  if (equalbool (yyP318, true)) {
/* line 4681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
/* line 4682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  case kRetypes:
  if (equalbool (yyP318, true)) {
/* line 4684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP320->Retypes.Type)))) goto yyL13;
  {
/* line 4684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
  }
   return;
yyL13:;

  }
/* line 4685 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4685 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP320->Retypes.Type)))) goto yyL14;
  {
/* line 4685 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
  }
   return;
yyL14:;

  if (equalbool (yyP318, true)) {
/* line 4686 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4686 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
/* line 4687 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4687 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4687 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  case kVal:
  if (equalbool (yyP318, true)) {
/* line 4689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP319))))) goto yyL17;
  {
/* line 4689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
  }
   return;
yyL17:;

  }
/* line 4690 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4690 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP319))))) goto yyL18;
  {
/* line 4690 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
  }
   return;
yyL18:;

  if (equalbool (yyP318, true)) {
/* line 4691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
/* line 4692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  case kValRetypes:
  if (equalbool (yyP318, true)) {
/* line 4694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP320->ValRetypes.Type)))) goto yyL21;
  {
/* line 4694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
  }
   return;
yyL21:;

  }
/* line 4695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP320->ValRetypes.Type)))) goto yyL22;
  {
/* line 4695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
  }
   return;
yyL22:;

  if (equalbool (yyP318, true)) {
/* line 4696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }
/* line 4697 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4697 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4697 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP319);
  }
   return;

  }

  if (Tree_IsType (yyP320, kSpec)) {
/* line 4699 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4699 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP320, yyP320->Spec.Pos);
  }
   return;

  }
;
}

static void CodeSym
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP321)
# else
(yyP321)
 tSymbol yyP321;
# endif
{
/* line 4704 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4704 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP321) . Depth == 0))) goto yyL1;
  {
/* line 4705 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP321);
  }
  }
   return;
yyL1:;

/* line 4707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP321)))) goto yyL2;
  {
/* line 4707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP321);
  }
  }
   return;
yyL2:;

/* line 4709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP");
/* line 4709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP321, CurProc);
/* line 4709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("->");
/* line 4709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP321);
  }
   return;

;
}

static void CodeIndirect
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP323, register tTree yyP322)
# else
(yyP323, yyP322)
 tSymbol yyP323;
 register tTree yyP322;
# endif
{
  if (yyP322->Kind == kDefProc) {
/* line 4713 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4713 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP323) . Depth <= Symbol (yyP322->DefProc.Sym) . Depth))) goto yyL1;
  {
/* line 4713 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("->Chain");
/* line 4713 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP323, Symbol (yyP322 -> DefProc . Parent) . Kind);
  }
  }
   return;
yyL1:;

  }
  if (yyP322->Kind == kDefFunc) {
/* line 4714 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4714 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP323) . Depth <= Symbol (yyP322->DefFunc.Sym) . Depth))) goto yyL2;
  {
/* line 4714 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("->Chain");
/* line 4714 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP323, Symbol (yyP322 -> DefFunc . Parent) . Kind);
  }
  }
   return;
yyL2:;

  }
;
}

static void CCodeTypeName
# if defined __STDC__ | defined __cplusplus
(register tTree yyP325, register bool yyP324)
# else
(yyP325, yyP324)
 register tTree yyP325;
 register bool yyP324;
# endif
{
  if (equalbool (yyP324, true)) {
/* line 4720 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4720 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP325)))) goto yyL1;
  {
/* line 4720 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4720 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP325);
/* line 4720 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
  }
  }
   return;
yyL1:;

  }
/* line 4721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP325)))) goto yyL2;
  {
/* line 4721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP325);
/* line 4721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
  }
  }
   return;
yyL2:;

  if (equalbool (yyP324, true)) {
/* line 4723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP325);
/* line 4723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
  }
   return;

  }
/* line 4724 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4724 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4724 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP325);
/* line 4724 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void CCodeType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP326)
# else
(yyP326)
 register tTree yyP326;
# endif
{

  switch (yyP326->Kind) {
  case kInt:
/* line 4728 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4728 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT");
  }
   return;

  case kInt64:
/* line 4729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT64");
  }
   return;

  case kInt32:
/* line 4730 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4730 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT32");
  }
   return;

  case kInt16:
/* line 4731 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4731 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT16");
  }
   return;

  case kReal32:
/* line 4732 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4732 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("REAL32");
  }
   return;

  case kReal64:
/* line 4733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("REAL64");
  }
   return;

  case kBool:
/* line 4734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BOOL");
  }
   return;

  case kByte:
/* line 4735 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4735 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BYTE");
  }
   return;

  case kArray:
/* line 4736 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4736 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP326->Array.Type);
  }
   return;

  case kChan:
/* line 4737 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4737 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("CHAN");
  }
   return;

  }

;
}

static void CCodeTypeId
# if defined __STDC__ | defined __cplusplus
(register tTree yyP327)
# else
(yyP327)
 register tTree yyP327;
# endif
{
  if (yyP327->Kind == kArray) {
/* line 4741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 4741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP327->Array.Expr);
/* line 4741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 4741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP327->Array.Type);
  }
   return;

  }
;
}

static void CCodeTypeIdChkConst
# if defined __STDC__ | defined __cplusplus
(register tTree yyP329, register tPosition yyP328)
# else
(yyP329, yyP328)
 register tTree yyP329;
 register tPosition yyP328;
# endif
{
  if (yyP329->Kind == kArray) {
/* line 4745 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4745 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstInt (yyP329->Array.Expr)))) goto yyL1;
  {
/* line 4746 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[]");
/* line 4746 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP329->Array.Type);
/* line 4747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Implementation restriction: arrays may not be unknown size", xxError, yyP328);
  }
  }
   return;
yyL1:;

/* line 4749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 4749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP329->Array.Expr);
/* line 4749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 4749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP329->Array.Type);
  }
   return;

  }
;
}

void OccCodeType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP330)
# else
(yyP330)
 register tTree yyP330;
# endif
{
  if (yyP330 == NULL) {
/* line 4754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }

  switch (yyP330->Kind) {
  case kAType:
  if (yyP330->AType.Next->Kind == kNoType) {
/* line 4755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP330->AType.Type);
  }
   return;

  }
/* line 4756 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4756 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP330->AType.Type);
/* line 4756 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4756 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP330->AType.Next);
  }
   return;

  case kInt:
/* line 4757 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4757 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT");
  }
   return;

  case kInt16:
/* line 4758 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4758 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT16");
  }
   return;

  case kInt32:
/* line 4759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT32");
  }
   return;

  case kInt64:
/* line 4760 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4760 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT64");
  }
   return;

  case kReal32:
/* line 4761 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4761 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("REAL32");
  }
   return;

  case kReal64:
/* line 4762 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4762 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("REAL64");
  }
   return;

  case kBool:
/* line 4763 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4763 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BOOL");
  }
   return;

  case kByte:
/* line 4764 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4764 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BYTE");
  }
   return;

  case kArray:
/* line 4765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP330->Array.Expr)))) goto yyL12;
  {
/* line 4765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 4765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (ValConstInt (yyP330->Array.Expr));
/* line 4765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 4765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP330->Array.Type);
  }
  }
   return;
yyL12:;

/* line 4766 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4766 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[]");
/* line 4766 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP330->Array.Type);
  }
   return;

  case kChan:
/* line 4767 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4767 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("CHAN OF ");
/* line 4767 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeProtocol (yyP330->Chan.Protocol);
  }
   return;

  case kTimer:
/* line 4768 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4768 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TIMER");
  }
   return;

  }

;
}

static void OccCodeProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP331)
# else
(yyP331)
 register tTree yyP331;
# endif
{
  if (yyP331->Kind == kAny) {
/* line 4772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ANY");
  }
   return;

  }
  if (yyP331->Kind == kNamed) {
/* line 4773 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4773 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteOccSym (yyP331->Named.Sym);
  }
   return;

  }
  if (yyP331->Kind == kSimple) {
/* line 4774 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4774 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP331->Simple.Type);
  }
   return;

  }
  if (yyP331->Kind == kCounted) {
/* line 4775 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4775 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP331->Counted.Length);
/* line 4775 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (":: ");
/* line 4775 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP331->Counted.Type);
  }
   return;

  }
;
}

static void CodeOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP332)
# else
(yyP332)
 register tTree yyP332;
# endif
{

  switch (yyP332->Kind) {
  case kLess:
/* line 4780 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4780 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" < ");
  }
   return;

  case kGreater:
/* line 4781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" > ");
  }
   return;

  case kLessEqual:
/* line 4782 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4782 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" <= ");
  }
   return;

  case kGreaterEqual:
/* line 4783 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4783 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" >= ");
  }
   return;

  case kEqual:
/* line 4784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
  }
   return;

  case kNotEqual:
/* line 4785 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4785 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" != ");
  }
   return;

  case kAdd:
/* line 4786 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4786 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
  }
   return;

  case kSubtract:
/* line 4787 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4787 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" - ");
  }
   return;

  case kMultiply:
/* line 4788 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4788 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" * ");
  }
   return;

  case kDivide:
/* line 4789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" / ");
  }
   return;

  case kRem:
/* line 4791 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4791 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" % ");
  }
   return;

  case kBitAnd:
/* line 4793 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4793 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" & ");
  }
   return;

  case kBitOr:
/* line 4794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" | ");
  }
   return;

  case kBitEor:
/* line 4795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ^ ");
  }
   return;

  case kBitNot:
/* line 4796 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4796 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ~ ");
  }
   return;

  case kSize:
/* line 4798 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4798 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" sizeof ");
  }
   return;

  case kPlus:
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
  }
   return;

  case kMinus:
/* line 4800 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4800 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" - ");
  }
   return;

  case kTimes:
/* line 4801 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4801 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" * ");
  }
   return;

  case kAnd:
/* line 4802 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4802 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" && ");
  }
   return;

  case kOr:
/* line 4803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" || ");
  }
   return;

  case kNot:
/* line 4804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ! ");
  }
   return;

  }

;
}

static int PrimTypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP333)
# else
(yyP333)
 register tTree yyP333;
# endif
{

  switch (yyP333->Kind) {
  case kInt:
/* line 4812 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return  (IS_Mode(xx16bitINT)) ? 2 : 4;

  case kInt16:
/* line 4813 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 2;

  case kInt32:
/* line 4814 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 4;

  case kInt64:
/* line 4815 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 8;

  case kReal32:
/* line 4816 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 4;

  case kReal64:
/* line 4817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 8;

  case kByte:
/* line 4818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

  case kBool:
/* line 4819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

  }

 yyAbort ("PrimTypeSize");
}

static tTree GetPrimType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP334)
# else
(yyP334)
 register tTree yyP334;
# endif
{
  if (yyP334->Kind == kArray) {
/* line 4824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return GetPrimType (yyP334->Array.Type);

  }
/* line 4825 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP334;

}

static bool IsPrimType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP335)
# else
(yyP335)
 register tTree yyP335;
# endif
{
  if (Tree_IsType (yyP335, kPrimitive)) {
/* line 4829 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  return false;
}

bool IsScalarType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP336)
# else
(yyP336)
 register tTree yyP336;
# endif
{
  if (yyP336->Kind == kArray) {
/* line 4833 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return false;

  }
/* line 4834 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

}

static bool IsTimer
# if defined __STDC__ | defined __cplusplus
(register tTree yyP337)
# else
(yyP337)
 register tTree yyP337;
# endif
{
  if (yyP337->Kind == kIdentifier) {
/* line 4838 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return Tree_IsType (SymbolType (yyP337->Identifier.Sym), kTimer);

  }
  if (yyP337->Kind == kSubscript) {
/* line 4839 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsTimer (yyP337->Subscript.Next);

  }
  if (yyP337->Kind == kRange) {
/* line 4840 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsTimer (yyP337->Range.Next);

  }
 yyAbort ("IsTimer");
}

static bool IsAtomicProcess
# if defined __STDC__ | defined __cplusplus
(register tTree yyP338)
# else
(yyP338)
 register tTree yyP338;
# endif
{
/* line 4845 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP338 -> Process . ATOMIC);

}

bool IsAtomicProc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP339)
# else
(yyP339)
 register tTree yyP339;
# endif
{
  if (yyP339->Kind == kPrototypeProc) {
/* line 4849 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4849 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP339 -> PrototypeProc . Lang != xxOccam))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP339->Kind == kDefProc) {
/* line 4850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP339 -> DefProc . ATOMIC))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (Tree_IsType (yyP339, kDefAFunc)) {
/* line 4851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  return false;
}

bool IsParProc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP340)
# else
(yyP340)
 register tTree yyP340;
# endif
{
  if (yyP340->Kind == kDefProc) {
/* line 4856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP340 -> DefProc . isPar || (yyP340->DefProc.Sym == TreeRoot -> Start . OuterProc && ! IS_Mode (xxLibrary))))) goto yyL1;
  }
   return true;
yyL1:;

  }
  return false;
}

bool IsPrototype
# if defined __STDC__ | defined __cplusplus
(register tTree yyP341)
# else
(yyP341)
 register tTree yyP341;
# endif
{
  if (yyP341->Kind == kPrototypeProc) {
/* line 4861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  if (yyP341->Kind == kPrototypeFunc) {
/* line 4862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  return false;
}

static bool IsBoundedType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP342)
# else
(yyP342)
 register tTree yyP342;
# endif
{
  if (yyP342->Kind == kArray) {
  if (yyP342->Array.Expr->Kind == kUnBound) {
/* line 4868 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return false;

  }
/* line 4870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsBoundedType (yyP342->Array.Type);

  }
/* line 4872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

}

static bool IsByteArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP343)
# else
(yyP343)
 register tTree yyP343;
# endif
{
  if (yyP343->Kind == kArray) {
  if (yyP343->Array.Type->Kind == kByte) {
/* line 4877 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
/* line 4878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP343->Array.Type)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

static int CountArrayDims
# if defined __STDC__ | defined __cplusplus
(register tTree yyP344)
# else
(yyP344)
 register tTree yyP344;
# endif
{
  if (yyP344->Kind == kArray) {
/* line 4883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1 + CountArrayDims (yyP344->Array.Type);

  }
/* line 4884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

}

tTree GenOccPrototypes
# if defined __STDC__ | defined __cplusplus
(register tTree yyP345)
# else
(yyP345)
 register tTree yyP345;
# endif
{
  if (yyP345->Kind == kStart) {
/* line 4893 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  }
  if (yyP345->Kind == kPrototypeProc) {
/* line 4895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP345 -> PrototypeProc . CGNext;

  }
  if (yyP345->Kind == kPrototypeFunc) {
/* line 4897 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP345 -> PrototypeFunc . CGNext;

  }
  if (yyP345->Kind == kDefProc) {
/* line 4899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP345->DefProc.Sym)))) goto yyL4;
  {
/* line 4899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsAtomicProc (yyP345))) goto yyL4;
  {
/* line 4900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("EXTERN_ATOMIC PROC ");
/* line 4900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteOccSym (yyP345->DefProc.Sym);
/* line 4900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP345->DefProc.Formals);
/* line 4900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") : ");
/* line 4900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (outname);
/* line 4900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return yyP345 -> DefProc . CGNext;
yyL4:;

/* line 4902 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4902 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP345->DefProc.Sym)))) goto yyL5;
  {
/* line 4903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("EXTERN_OCCAM PROC ");
/* line 4903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteOccSym (yyP345->DefProc.Sym);
/* line 4903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP345->DefProc.Formals);
/* line 4903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") : ");
/* line 4903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (outname);
/* line 4903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return yyP345 -> DefProc . CGNext;
yyL5:;

/* line 4904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP345 -> DefProc . CGNext;

  }
  if (Tree_IsType (yyP345, kDefAFunc)) {
/* line 4906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP345->DefAFunc.Sym)))) goto yyL7;
  {
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("EXTERN_ATOMIC ");
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP345->DefAFunc.TypeList);
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" FUNCTION ");
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteOccSym (yyP345->DefAFunc.Sym);
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP345->DefAFunc.Formals);
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") : ");
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (outname);
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return yyP345 -> DefAFunc . CGNext;
yyL7:;

/* line 4908 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP345 -> DefAFunc . CGNext;

  }
  if (yyP345->Kind == kHCode) {
/* line 4909 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP345 -> HCode . CGNext;

  }
 yyAbort ("GenOccPrototypes");
}

static void GenOccPrototypeFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP346)
# else
(yyP346)
 register tTree yyP346;
# endif
{
  if (yyP346->Kind == kAFormal) {
  if (yyP346->AFormal.Next->Kind == kNoFormal) {
/* line 4913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP346 -> AFormal . U == xxOutput))) goto yyL1;
  {
/* line 4914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP346->AFormal.Sym));
/* line 4914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" out");
  }
  }
   return;
yyL1:;

/* line 4916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP346 -> AFormal . U == xxInput))) goto yyL2;
  {
/* line 4917 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP346->AFormal.Sym));
/* line 4917 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" in");
  }
  }
   return;
yyL2:;

  if (yyP346->AFormal.By->Kind == kByRef) {
/* line 4919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP346->AFormal.Sym));
  }
   return;

  }
  if (yyP346->AFormal.By->Kind == kByVal) {
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("VAL ");
/* line 4923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP346->AFormal.Sym));
  }
   return;

  }
  }
/* line 4925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP346 -> AFormal . U == xxOutput))) goto yyL5;
  {
/* line 4926 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP346->AFormal.Sym));
/* line 4926 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" out,");
/* line 4927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP346->AFormal.Next);
  }
  }
   return;
yyL5:;

/* line 4929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP346 -> AFormal . U == xxInput))) goto yyL6;
  {
/* line 4930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP346->AFormal.Sym));
/* line 4930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" in,");
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP346->AFormal.Next);
  }
  }
   return;
yyL6:;

  if (yyP346->AFormal.By->Kind == kByRef) {
/* line 4933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP346->AFormal.Sym));
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4935 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP346->AFormal.Next);
  }
   return;

  }
  if (yyP346->AFormal.By->Kind == kByVal) {
/* line 4937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("VAL ");
/* line 4938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP346->AFormal.Sym));
/* line 4938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP346->AFormal.Next);
  }
   return;

  }
  }
;
}

tTree GenCPrototype
# if defined __STDC__ | defined __cplusplus
(register tTree yyP347)
# else
(yyP347)
 register tTree yyP347;
# endif
{
  if (yyP347->Kind == kStart) {
/* line 4944 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  }
  if (yyP347->Kind == kPrototypeProc) {
/* line 4946 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP347 -> PrototypeProc . CGNext;

  }
  if (yyP347->Kind == kPrototypeFunc) {
/* line 4948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP347 -> PrototypeFunc . CGNext;

  }
  if (yyP347->Kind == kDefFunc) {
/* line 4950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP347->DefFunc.Sym)))) goto yyL4;
  {
/* line 4951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{\"");
/* line 4951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncHead (yyP347);
/* line 4951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";\",NULL,0},");
/* line 4951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return yyP347 -> DefFunc . CGNext;
yyL4:;

  }
  if (yyP347->Kind == kDefProc) {
/* line 4954 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4954 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP347->DefProc.Sym)))) goto yyL5;
  {
/* line 4954 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProc (yyP347)))) goto yyL5;
  {
/* line 4955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{\"");
/* line 4955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcHead (yyP347);
/* line 4955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";\",NULL,0},");
/* line 4955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return yyP347 -> DefProc . CGNext;
yyL5:;

/* line 4958 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4958 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP347->DefProc.Sym)))) goto yyL6;
  {
/* line 4959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{\"");
/* line 4959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcHead (yyP347);
/* line 4959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";\",\"");
/* line 4959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP347->DefProc.Sym);
/* line 4959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\",sizeof(tSF_");
/* line 4959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP347->DefProc.Sym);
/* line 4959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")},");
/* line 4959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return yyP347 -> DefProc . CGNext;
yyL6:;

/* line 4963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP347 -> DefProc . CGNext;

  }
  if (Tree_IsType (yyP347, kDefAFunc)) {
/* line 4962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP347 -> DefAFunc . CGNext;

  }
  if (yyP347->Kind == kHCode) {
/* line 4965 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP347 -> HCode . CGNext;

  }
 yyAbort ("GenCPrototype");
}

tTree GenCGDebug
# if defined __STDC__ | defined __cplusplus
(register tTree yyP348)
# else
(yyP348)
 register tTree yyP348;
# endif
{
  if (yyP348->Kind == kStart) {
/* line 4970 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  }
  if (yyP348->Kind == kDefFunc) {
/* line 4972 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FUNC ");
/* line 4973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP348->DefFunc.Sym);
/* line 4973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("() ");
/* line 4974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (NeedsChain (yyP348), "CHAIN ");
/* line 4975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (IsTopLevel (yyP348->DefFunc.Sym), "TOP ");
/* line 4976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (IsMVFunction (yyP348), "MV ");
/* line 4977 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! IsEmpty (& yyP348->DefFunc.Valof->Valof.ExprList -> ExprList . PUOut -> R), "NLR ");
/* line 4978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\n");
  }
   return yyP348 -> DefFunc . CGNext;

  }
  if (yyP348->Kind == kDefProc) {
/* line 4981 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("PROC ");
/* line 4982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP348->DefProc.Sym);
/* line 4982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("() ");
/* line 4983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (IsAtomicProc (yyP348), "ATOMIC ");
/* line 4984 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (NeedsChain (yyP348), "CHAIN ");
/* line 4985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (IsTopLevel (yyP348->DefProc.Sym), "TOP ");
/* line 4986 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! IsEmpty (& yyP348 -> DefProc . PUOut -> R), "NLR ");
/* line 4987 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! IsEmpty (& yyP348 -> DefProc . PUOut -> W), "NLW ");
/* line 4988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\n");
  }
   return yyP348 -> DefProc . CGNext;

  }
  if (Tree_IsType (yyP348, kDefAFunc)) {
/* line 4991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP348 -> DefAFunc . CGNext;

  }
  if (Tree_IsType (yyP348, kDefAProc)) {
/* line 4992 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP348 -> DefAProc . CGNext;

  }
  if (yyP348->Kind == kHCode) {
/* line 4994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP348 -> HCode . CGNext;

  }
 yyAbort ("GenCGDebug");
}

void CodeMainEntryParameters
# if defined __STDC__ | defined __cplusplus
(register tTree yyP349)
# else
(yyP349)
 register tTree yyP349;
# endif
{
  if (yyP349->Kind == kDefProc) {
  if (yyP349->DefProc.Formals->Kind == kNoFormal) {
/* line 5001 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP349->DefProc.Formals->Kind == kAFormal) {
  if (yyP349->DefProc.Formals->AFormal.Next->Kind == kAFormal) {
  if (yyP349->DefProc.Formals->AFormal.Next->AFormal.Next->Kind == kNoFormal) {
/* line 5003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsSPChan (SymbolType (yyP349->DefProc.Formals->AFormal.Sym)))) goto yyL2;
  {
/* line 5004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsSPChan (SymbolType (yyP349->DefProc.Formals->AFormal.Next->AFormal.Sym)))) goto yyL2;
  {
/* line 5005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP349->DefProc.Formals -> AFormal . U != xxOutput))) goto yyL2;
  {
/* line 5005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP349->DefProc.Formals->AFormal.Next -> AFormal . U != xxInput))) goto yyL2;
  {
/* line 5006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 5006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP349->DefProc.Formals->AFormal.Sym);
/* line 5006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=&fs;");
/* line 5006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 5007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP349->DefProc.Formals->AFormal.Next->AFormal.Sym);
/* line 5007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=&ts;");
/* line 5007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
  }
   return;
yyL2:;

  }
  if (yyP349->DefProc.Formals->AFormal.Next->AFormal.Next->Kind == kAFormal) {
  if (yyP349->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Next->Kind == kNoFormal) {
  if (yyP349->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Type->Kind == kArray) {
  if (yyP349->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Type->Array.Expr->Kind == kUnBound) {
  if (yyP349->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Type->Array.Type->Kind == kInt) {
/* line 5010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsSPChan (SymbolType (yyP349->DefProc.Formals->AFormal.Sym)))) goto yyL3;
  {
/* line 5011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsSPChan (SymbolType (yyP349->DefProc.Formals->AFormal.Next->AFormal.Sym)))) goto yyL3;
  {
/* line 5012 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP349->DefProc.Formals -> AFormal . U != xxOutput))) goto yyL3;
  {
/* line 5012 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP349->DefProc.Formals->AFormal.Next -> AFormal . U != xxInput))) goto yyL3;
  {
/* line 5013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 5013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP349->DefProc.Formals->AFormal.Sym);
/* line 5013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=&fs;");
/* line 5013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 5014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP349->DefProc.Formals->AFormal.Next->AFormal.Sym);
/* line 5014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=&ts;");
/* line 5014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 5015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP349->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Sym);
/* line 5015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=mem;");
/* line 5015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 5016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP349->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Sym);
/* line 5016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Dim0=mem_size;");
/* line 5016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
  }
   return;
yyL3:;

  }
  }
  }
  }
  }
  }
  if (yyP349->DefProc.Formals->AFormal.Next->Kind == kNoFormal) {
  if (yyP349->DefProc.Formals->AFormal.Type->Kind == kArray) {
  if (yyP349->DefProc.Formals->AFormal.Type->Array.Expr->Kind == kUnBound) {
  if (yyP349->DefProc.Formals->AFormal.Type->Array.Type->Kind == kInt) {
/* line 5019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5020 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 5020 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP349->DefProc.Formals->AFormal.Sym);
/* line 5020 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=mem;");
/* line 5020 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 5021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP349->DefProc.Formals->AFormal.Sym);
/* line 5021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Dim0=mem_size;");
/* line 5021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  }
  }
  }
/* line 5024 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5024 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Main entry point does not have acceptable parameter list", xxError, yyP349->DefProc.Pos);
  }
   return;

  }
/* line 5026 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5026 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Main Entry Point must be a PROC", xxError, yyP349->Spec.Pos);
  }
   return;

;
}

static bool IsSPChan
# if defined __STDC__ | defined __cplusplus
(register tTree yyP350)
# else
(yyP350)
 register tTree yyP350;
# endif
{
  if (yyP350->Kind == kChan) {
  if (yyP350->Chan.Protocol->Kind == kNamed) {
/* line 5031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP350->Chan.Protocol->Named.Sym) . Id == MakeIdent ("SP", 2)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  }
  return false;
}

void GenStatics
# if defined __STDC__ | defined __cplusplus
(register tTree yyP351)
# else
(yyP351)
 register tTree yyP351;
# endif
{
  if (yyP351->Kind == kStart) {
/* line 5036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStatics (yyP351->Start.Process);
  }
   return;

  }
  if (yyP351->Kind == kNullProcess) {
/* line 5038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStatics (yyP351->NullProcess.SpecList);
  }
   return;

  }
  if (yyP351->Kind == kNoSpec) {
/* line 5040 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP351->Kind == kASpec) {
/* line 5042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStatic (yyP351->ASpec.Spec);
/* line 5042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStatics (yyP351->ASpec.Next);
  }
   return;

  }
/* line 5044 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5044 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("Error in GenStatics - ");
/* line 5044 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteTreeNode (yyf, yyP351);
  }
   return;

;
}

static void GenStatic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP352)
# else
(yyP352)
 register tTree yyP352;
# endif
{
  if (yyP352->Kind == kVal) {
/* line 5050 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5050 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP352->Val.Expr))))) goto yyL1;
  }
   return;
yyL1:;

/* line 5052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (ExprType (yyP352->Val.Expr))))) goto yyL2;
  {
/* line 5053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 5053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP352->Val.Expr));
/* line 5053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 5053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP352->Val.Sym);
/* line 5053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 5053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL2:;

  if (Tree_IsType (yyP352->Val.Expr, kStringElement)) {
/* line 5055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static BYTE ");
/* line 5056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP352->Val.Sym);
/* line 5056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[] = {");
/* line 5056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (ExprType (yyP352->Val.Expr), yyP352->Val.Expr -> StringElement . CA);
/* line 5056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 5056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP352->Val.Expr->Kind == kElementalExpr) {
/* line 5058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP352->Val.Expr));
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP352->Val.Sym);
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (ExprType (yyP352->Val.Expr));
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (ExprType (yyP352->Val.Expr->ElementalExpr.Elemental), yyP352->Val.Expr->ElementalExpr.Elemental -> Elemental . CA);
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  if (yyP352->Kind == kValRetypes) {
/* line 5062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (yyP352->ValRetypes.Type)))) goto yyL5;
  }
   return;
yyL5:;

/* line 5064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (ExprType (yyP352->ValRetypes.Expr))))) goto yyL6;
  {
/* line 5065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 5065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP352->ValRetypes.Type);
/* line 5065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 5065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP352->ValRetypes.Sym);
/* line 5065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 5065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

  if (Tree_IsType (yyP352->ValRetypes.Expr, kStringElement)) {
/* line 5067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP352->ValRetypes.Type);
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP352->ValRetypes.Sym);
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP352->ValRetypes.Type);
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (yyP352->ValRetypes.Type, yyP352->ValRetypes.Expr -> StringElement . CA);
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP352->ValRetypes.Expr->Kind == kElementalExpr) {
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP352->ValRetypes.Type);
/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP352->ValRetypes.Sym);
/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP352->ValRetypes.Type);
/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (yyP352->ValRetypes.Type, yyP352->ValRetypes.Expr->ElementalExpr.Elemental -> Elemental . CA);
/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 5074 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5074 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsPrimType (ExprType (yyP352->ValRetypes.Expr)))) goto yyL9;
  {
/* line 5075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 5075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP352->ValRetypes.Type);
/* line 5075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 5075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP352->ValRetypes.Sym);
/* line 5075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP352->ValRetypes.Type);
/* line 5075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 5076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
{
      unsigned char tmp[8];
      tConstArray CA = (tConstArray)tmp;

      WriteConstArray(ExprType(yyP352->ValRetypes.Expr),ValConstExpr(yyP352->ValRetypes.Expr),CA);
      RetypeConst(PrimTypeSize(ExprType(yyP352->ValRetypes.Expr)),CA,PrimTypeSize(ArrayPrimType(yyP352->ValRetypes.Type)),CA);
      CodeConstArray(yyP352->ValRetypes.Type,CA);
    }
/* line 5084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 5084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL9:;

  }
  if (Tree_IsType (yyP352, kAVal)) {
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("VAL constant cannot be calculated at compile time", xxError, yyP352->AVal.Pos);
  }
   return;

  }
  if (Tree_IsType (yyP352, kDefAProc)) {
/* line 5111 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (Tree_IsType (yyP352, kDefAFunc)) {
/* line 5112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP352->Kind == kHCode) {
/* line 5113 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP352->Kind == kNullSpec) {
/* line 5114 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (Tree_IsType (yyP352, kDefAPro)) {
/* line 5115 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
/* line 5117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("Error in GenStatic - ");
/* line 5117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteTreeNode (yyf, yyP352);
  }
   return;

;
}

static void CodeConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP354, tConstArray yyP353)
# else
(yyP354, yyP353)
 register tTree yyP354;
 tConstArray yyP353;
# endif
{
  if (yyP354->Kind == kArray) {
  if (yyP354->Array.Type->Kind == kArray) {
/* line 5122 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5123 "/home/ringwood/smw/occam/source/gmd/c.trafo" */

      { int i,sz;
        sz = CalcTypeSize(yyP354->Array.Type);
        for(i = 0; i < ValConstInt(yyP354->Array.Expr); ++i)
        {
          if (i) WriteChar(',');
          WriteStr("{");
          CodeConstArray(yyP354->Array.Type,yyP353+i*sz);
          WriteStr("}");
        }
      }
    
  }
   return;

  }
/* line 5137 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5138 "/home/ringwood/smw/occam/source/gmd/c.trafo" */

      { int i;
        int sz = PrimTypeSize(yyP354->Array.Type);

        for(i = 0; i < ValConstInt(yyP354->Array.Expr); ++i)
        {
          if (i) WriteChar(',');
          CodeConstExpr(yyP354->Array.Type,ReadConstArray(yyP354->Array.Type,yyP353+(sz*i)));
        }
      }
    
  }
   return;

  }
;
}

static void GenStaticExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP355)
# else
(yyP355)
 register tTree yyP355;
# endif
{
  if (yyP355->Kind == kElementalExpr) {
  if (yyP355->ElementalExpr.Elemental->Kind == kTable) {
/* line 5156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{ ");
/* line 5156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticExprList (yyP355->ElementalExpr.Elemental->Table.ExprList);
/* line 5156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" }");
  }
   return;

  }
  }
  if (yyP355->Kind == kString) {
/* line 5158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\"");
/* line 5158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStrRef (yyP355->String.Value);
/* line 5158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\"");
  }
   return;

  }
/* line 5160 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5160 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP355)))) goto yyL3;
  {
/* line 5160 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP355);
  }
  }
   return;
yyL3:;

/* line 5162 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5162 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("VAL constant cannot be calculated at compile time", xxError, yyP355->Expr.Pos);
  }
   return;

;
}

static void GenStaticElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP357, register int yyP356)
# else
(yyP357, yyP356)
 register tTree yyP357;
 register int yyP356;
# endif
{
  if (yyP357->Kind == kIdentifier) {
/* line 5166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 5166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP357->Identifier.Sym);
/* line 5166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 5166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP356);
/* line 5166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
  }
   return;

  }
  if (yyP357->Kind == kSubscript) {
/* line 5167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticElement (yyP357->Subscript.Next, ValConstInt (yyP357->Subscript.Expr));
/* line 5167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 5167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP356);
/* line 5167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
  }
   return;

  }
  if (yyP357->Kind == kRange) {
/* line 5168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticElement (yyP357->Range.Next, ValConstInt (yyP357->Range.From) + yyP356);
  }
   return;

  }
;
}

static void GenStaticExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP358)
# else
(yyP358)
 register tTree yyP358;
# endif
{
  if (yyP358->Kind == kAnExpr) {
  if (yyP358->AnExpr.Next->Kind == kNoExpr) {
/* line 5173 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5173 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticExpr (yyP358->AnExpr.Expr);
  }
   return;

  }
/* line 5174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticExpr (yyP358->AnExpr.Expr);
/* line 5174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (", ");
/* line 5174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticExprList (yyP358->AnExpr.Next);
  }
   return;

  }
;
}

void GenShowValue
# if defined __STDC__ | defined __cplusplus
(register tTree yyP361, register tTree yyP360, tSymbol yyP359)
# else
(yyP361, yyP360, yyP359)
 register tTree yyP361;
 register tTree yyP360;
 tSymbol yyP359;
# endif
{
  if (yyP361->Kind == kATagPro) {
/* line 5179 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP361->Kind == kDefTagPro) {
/* line 5180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
/* line 5181 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5182 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (yyP361, kAFormal) && (Tree_IsType (SymbolKind (CalcParent (SymbolKind (yyP359))), kPrototypeProc) || Tree_IsType (SymbolKind (CalcParent (SymbolKind (yyP359))), kPrototypeFunc))))) goto yyL3;
  }
   return;
yyL3:;

  if (Tree_IsType (yyP361, kDefAProc)) {
/* line 5185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("printf(\"");
/* line 5185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP359);
/* line 5185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
  }
   return;

  }
  if (Tree_IsType (yyP361, kDefAFunc)) {
/* line 5186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("printf(\"");
/* line 5186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP359);
/* line 5186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
  }
   return;

  }
  if (yyP360 == NULL) {
/* line 5188 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP360->Kind == kArray) {
  if (yyP360->Array.Type->Kind == kArray) {
/* line 5190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5191 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{ int i;");
/* line 5192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 5193 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP360, yyP359, 0);
/* line 5194 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("for(i=0;i<s0;i++)");
/* line 5194 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5195 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 5195 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 5196 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowTests (yyP360, yyP359, 0);
/* line 5197 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("else putchar(',');");
/* line 5198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 5198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 5199 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 5199 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
  }
   return;

  }
  if (yyP360->Array.Expr->Kind == kUnBound) {
/* line 5202 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ShowArray");
/* line 5203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP360->Array.Type);
/* line 5203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("((");
/* line 5203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (yyP360->Array.Type, true);
/* line 5203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP359) . Kind, yyP359);
/* line 5203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
/* line 5204 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP359) . Kind, yyP359);
/* line 5204 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 5204 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP360));
/* line 5205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
  }
   return;

  }
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP360->Array.Expr)))) goto yyL9;
  {
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ShowArray");
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP360->Array.Type);
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP359) . Kind, yyP359);
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP360->Array.Expr);
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
  }
  }
   return;
yyL9:;

/* line 5208 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP360->Kind == kTimer) {
/* line 5209 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
/* line 5210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("Show");
/* line 5210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP360);
/* line 5210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 5210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP359) . Kind, yyP359);
/* line 5210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
  }
   return;

;
}

static void GenShowSizes
# if defined __STDC__ | defined __cplusplus
(register tTree yyP364, tSymbol yyP363, register int yyP362)
# else
(yyP364, yyP363, yyP362)
 register tTree yyP364;
 tSymbol yyP363;
 register int yyP362;
# endif
{
  if (yyP364->Kind == kArray) {
  if (yyP364->Array.Expr->Kind == kUnBound) {
  if (yyP364->Array.Type->Kind == kArray) {
  if (yyP364->Array.Type->Array.Type->Kind == kArray) {
/* line 5216 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP364->Array.Type, yyP363, yyP362 + 1);
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int s");
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP362);
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= s");
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP362 + 1);
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP363) . Kind, yyP363);
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP364));
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP364->Array.Type, yyP363, yyP362 + 1);
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int s");
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP362);
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP363) . Kind, yyP363);
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP364));
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 5224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP364->Array.Type->Kind == kArray) {
  if (yyP364->Array.Type->Array.Type->Kind == kArray) {
/* line 5220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5221 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP364->Array.Type, yyP363, yyP362 + 1);
/* line 5222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int s");
/* line 5222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP362);
/* line 5222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= s");
/* line 5222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP362 + 1);
/* line 5222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 5222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP364->Array.Expr);
/* line 5222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 5222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 5226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP364->Array.Type, yyP363, yyP362 + 1);
/* line 5226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int s");
/* line 5226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP362);
/* line 5226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 5226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP364->Array.Expr);
/* line 5226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 5226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenShowTests
# if defined __STDC__ | defined __cplusplus
(register tTree yyP367, tSymbol yyP366, register int yyP365)
# else
(yyP367, yyP366, yyP365)
 register tTree yyP367;
 tSymbol yyP366;
 register int yyP365;
# endif
{
  if (yyP367->Kind == kArray) {
  if (yyP367->Array.Type->Kind == kArray) {
/* line 5231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if ((i%s");
/* line 5232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP365);
/* line 5232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")==0) LP; ");
/* line 5233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowTests (yyP367->Array.Type, yyP366, yyP365 + 1);
/* line 5234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (((i+1)%s");
/* line 5234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP365);
/* line 5234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")==0) RP; ");
  }
   return;

  }
  if (yyP367->Array.Type->Kind == kChan) {
/* line 5237 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ShowArray");
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP367->Array.Type);
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP367->Array.Type);
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP366) . Kind, yyP366);
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+(i*s");
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP365);
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("), s");
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP365);
/* line 5239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 5240 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 5243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ShowArray");
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP367->Array.Type);
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP367->Array.Type);
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP366) . Kind, yyP366);
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+(i*s");
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP365);
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("), s");
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP365);
/* line 5245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 5246 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenShowSymRef
# if defined __STDC__ | defined __cplusplus
(register tTree yyP369, tSymbol yyP368)
# else
(yyP369, yyP368)
 register tTree yyP369;
 tSymbol yyP368;
# endif
{
/* line 5253 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5253 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (SymbolType (yyP368))))) goto yyL1;
  }
   return;
yyL1:;

/* line 5255 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5255 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (yyP368))))) goto yyL2;
  }
   return;
yyL2:;


  switch (yyP369->Kind) {
  case kAFormal:
  if (yyP369->AFormal.By->Kind == kByRef) {
/* line 5257 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5257 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
  }
   return;

  }
  if (yyP369->AFormal.By->Kind == kByVal) {
/* line 5259 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  break;
  case kAnId:
/* line 5261 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kReplicator:
/* line 5263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kIs:
/* line 5265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kRetypes:
/* line 5267 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kVal:
/* line 5269 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kValRetypes:
/* line 5271 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }

/* line 5273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("** Error in GenShowSymRef -");
/* line 5273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteTreeNode (yyf, yyP369);
/* line 5273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 5273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenShowSym
# if defined __STDC__ | defined __cplusplus
(register tTree yyP371, tSymbol yyP370)
# else
(yyP371, yyP370)
 register tTree yyP371;
 tSymbol yyP370;
# endif
{
  if (yyP371->Kind == kVal) {
/* line 5279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP371->Val.Expr)) && IsConstExpr (yyP371->Val.Expr)))) goto yyL1;
  {
/* line 5280 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstExpr (ExprType (yyP371->Val.Expr), ValConstExpr (yyP371->Val.Expr));
  }
  }
   return;
yyL1:;

  }
  if (yyP371->Kind == kValRetypes) {
/* line 5282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (yyP371->ValRetypes.Type) && IsConstExpr (yyP371->ValRetypes.Expr)))) goto yyL2;
  {
/* line 5283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstExpr (yyP371->ValRetypes.Type, EvalConstId (yyP371));
  }
  }
   return;
yyL2:;

  }
/* line 5285 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5285 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP370) . Depth == 0))) goto yyL3;
  {
/* line 5286 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP370);
  }
  }
   return;
yyL3:;

/* line 5288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP370)))) goto yyL4;
  }
   return;
yyL4:;

/* line 5290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSymRef (yyP371, yyP370);
/* line 5290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("((tSF_");
/* line 5290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (CalcParent (SymbolKind (yyP370)));
/* line 5290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *)FP)->");
/* line 5290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP370);
  }
   return;

;
}

int MapKinds
# if defined __STDC__ | defined __cplusplus
(register tTree yyP374, register tTree yyP373, tSymbol yyP372)
# else
(yyP374, yyP373, yyP372)
 register tTree yyP374;
 register tTree yyP373;
 tSymbol yyP372;
# endif
{
  if (yyP374 == NULL) {
/* line 5295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  }
  if (yyP374->Kind == kDefProc) {
/* line 5297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 3;

  }
  if (yyP374->Kind == kPrototypeProc) {
/* line 5298 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5298 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP374 -> DefAProc . U == xxUsed))) goto yyL3;
  }
   return 10;
yyL3:;

/* line 5299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  }
  if (yyP373 == NULL) {
/* line 5301 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  }

  switch (yyP374->Kind) {
  case kDefFunc:
/* line 5303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 2;

  case kPrototypeFunc:
/* line 5304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP374 -> DefAFunc . U == xxUsed))) goto yyL7;
  }
   return 10;
yyL7:;

/* line 5305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  case kAFormal:
/* line 5307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP372)))) goto yyL9;
  }
   return 1;
yyL9:;

  break;
  case kAnId:
/* line 5308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP372)))) goto yyL10;
  }
   return 4;
yyL10:;

  break;
  case kVal:
/* line 5309 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5309 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP372)))) goto yyL11;
  }
   return 5;
yyL11:;

  break;
  case kValRetypes:
/* line 5310 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5310 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP372)))) goto yyL12;
  }
   return 6;
yyL12:;

  break;
  case kIs:
/* line 5311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP372)))) goto yyL13;
  }
   return 7;
yyL13:;

  break;
  case kRetypes:
/* line 5312 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5312 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP372)))) goto yyL14;
  }
   return 8;
yyL14:;

  break;
  case kReplicator:
/* line 5313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP372)))) goto yyL15;
  }
   return 9;
yyL15:;

  break;
  }

/* line 5314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

}

tSymbol CalcParent
# if defined __STDC__ | defined __cplusplus
(register tTree T)
# else
(T)
 register tTree T;
# endif
{
  if (T == NULL) {
/* line 5319 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoSymbol;

  }

  switch (T->Kind) {
  case kATagPro:
/* line 5320 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoSymbol;

  case kDefTagPro:
/* line 5321 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoSymbol;

  case kDefSeqPro:
/* line 5322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoSymbol;

  case kTableElement:
  case kTable:
  case kTableSubscript:
  case kTableRange:
/* line 5323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoSymbol;

  case kAnId:
/* line 5325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> AnId . Parent;

  case kAVal:
  case kVal:
  case kValRetypes:
/* line 5326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> AVal . Parent;

  case kIs:
/* line 5327 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> Is . Parent;

  case kReplicator:
/* line 5328 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> Replicator . Parent;

  case kRetypes:
/* line 5329 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> Retypes . Parent;

  case kAFormal:
/* line 5330 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> AFormal . Parent;

  case kValof:
/* line 5331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> Valof . Parent;

  case kDefProc:
/* line 5333 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefProc . Parent;

  case kDefFunc:
/* line 5334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefFunc . Parent;

  case kPrototypeProc:
/* line 5336 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> PrototypeProc . Parent;

  case kPrototypeFunc:
/* line 5337 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> PrototypeFunc . Parent;

  }

/* line 5339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   fprintf (stderr, "Fell through CalcParent with\n");
/* line 5339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteTreeNode (stderr, T);
  }
   return 0;

}

tIdent CalcModule
# if defined __STDC__ | defined __cplusplus
(register tTree yyP375)
# else
(yyP375)
 register tTree yyP375;
# endif
{
  if (yyP375->Kind == kPrototypeFunc) {
/* line 5343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP375 -> PrototypeFunc . Module;

  }
  if (yyP375->Kind == kPrototypeProc) {
/* line 5344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP375 -> PrototypeProc . Module;

  }
/* line 5345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoIdent;

}

tStringRef CalcHeader
# if defined __STDC__ | defined __cplusplus
(register tTree yyP376)
# else
(yyP376)
 register tTree yyP376;
# endif
{
  if (yyP376->Kind == kPrototypeFunc) {
/* line 5349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP376->PrototypeFunc.Pos . File;

  }
  if (yyP376->Kind == kPrototypeProc) {
/* line 5350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP376->PrototypeProc.Pos . File;

  }
/* line 5351 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NULL;

}

tUsage CalcUsage
# if defined __STDC__ | defined __cplusplus
(register tTree yyP377)
# else
(yyP377)
 register tTree yyP377;
# endif
{
  if (yyP377->Kind == kPrototypeFunc) {
/* line 5355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP377 -> PrototypeFunc . U;

  }
  if (yyP377->Kind == kPrototypeProc) {
/* line 5356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP377 -> PrototypeProc . U;

  }
 yyAbort ("CalcUsage");
}

bool IsLocal
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP378)
# else
(yyP378)
 tSymbol yyP378;
# endif
{
/* line 5361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsNonLocal (yyP378)))) goto yyL1;
  }
   return true;
yyL1:;

  return false;
}

bool IsNonLocal
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP379)
# else
(yyP379)
 tSymbol yyP379;
# endif
{
/* line 5366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymbolUsage (yyP379) & (xxNLRead | xxNLWrite)))) goto yyL1;
  }
   return true;
yyL1:;

/* line 5367 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5367 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! (SymbolUsage (yyP379) & xxAtomic)))) goto yyL2;
  }
   return true;
yyL2:;

  return false;
}

bool IsAtomic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP380)
# else
(yyP380)
 register tTree yyP380;
# endif
{
  if (Tree_IsType (yyP380, kProcess)) {
/* line 5372 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5372 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP380 -> Process . ATOMIC))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (Tree_IsType (yyP380, kAChoices)) {
/* line 5373 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5373 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP380 -> AChoices . ATOMIC))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (yyP380->Kind == kReplicator) {
/* line 5374 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5374 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP380 -> Replicator . AtomicSpec))) goto yyL3;
  }
   return true;
yyL3:;

  }
  return false;
}

static bool IsMVFunction
# if defined __STDC__ | defined __cplusplus
(register tTree yyP381)
# else
(yyP381)
 register tTree yyP381;
# endif
{
  if (yyP381->DefFunc.TypeList->Kind == kAType) {
  if (yyP381->DefFunc.TypeList->AType.Next->Kind == kAType) {
/* line 5378 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  }
  return false;
}

static bool IsNewSymbol
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP382)
# else
(yyP382)
 tSymbol yyP382;
# endif
{
/* line 5382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymTable[yyP382].Id == NoIdent))) goto yyL1;
  }
   return true;
yyL1:;

  return false;
}

static void BeginBlock
# if defined __STDC__ | defined __cplusplus
(register tTree yyP383)
# else
(yyP383)
 register tTree yyP383;
# endif
{
/* line 5388 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5389 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP383);
  }
   return;

;
}

static void EndBlock
# if defined __STDC__ | defined __cplusplus
(register tTree yyP384)
# else
(yyP384)
 register tTree yyP384;
# endif
{
/* line 5394 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5395 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP384);
  }
   return;

;
}

static void BeginAtomicBlock
# if defined __STDC__ | defined __cplusplus
(register tTree yyP387, register tTree yyP386, register bool yyP385)
# else
(yyP387, yyP386, yyP385)
 register tTree yyP387;
 register tTree yyP386;
 register bool yyP385;
# endif
{
/* line 5401 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OpenBlock (yyP385);
/* line 5403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalSpecs (yyP387);
/* line 5404 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

/* line 5407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP386 != NoTree))) goto yyL2;
  {
/* line 5408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalRep (yyP386);
/* line 5409 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
  }
   return;
yyL2:;

/* line 5412 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5413 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP387);
  }
   return;

;
}

static void EndAtomicBlock
# if defined __STDC__ | defined __cplusplus
(register tTree yyP388)
# else
(yyP388)
 register tTree yyP388;
# endif
{
/* line 5418 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP388);
/* line 5420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseBlock ();
  }
   return;

;
}

void MarkRefParent
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP391, register tTree yyP390, tVUsage yyP389)
# else
(yyP391, yyP390, yyP389)
 tSymbol yyP391;
 register tTree yyP390;
 tVUsage yyP389;
# endif
{
/* line 5426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP391)))) goto yyL1;
  }
   return;
yyL1:;

  if (yyP390->Kind == kDefProc) {
/* line 5428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymbolDepth (yyP391) <= SymbolDepth (yyP390->DefProc.Sym)))) goto yyL2;
  {
/* line 5429 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   AddVUsage (yyP390->DefProc.Sym, yyP389);
/* line 5430 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   MarkRefParent (yyP391, SymbolKind (yyP390 -> DefProc . Parent), yyP389);
  }
  }
   return;
yyL2:;

  }
  if (yyP390->Kind == kDefFunc) {
/* line 5433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymbolDepth (yyP391) <= SymbolDepth (yyP390->DefFunc.Sym)))) goto yyL3;
  {
/* line 5434 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   AddVUsage (yyP390->DefFunc.Sym, yyP389);
/* line 5435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   MarkRefParent (yyP391, SymbolKind (yyP390 -> DefFunc . Parent), yyP389);
  }
  }
   return;
yyL3:;

  }
;
}

void BeginCout ()
{
}

void CloseCout ()
{
}
