/* $Id: Parser.c,v 2.9 1992/08/07 15:28:42 grosch rel $ */

# define bool		char
# define true		1
# define false		0

# include "Parser.h"
# include "Errors.h"

# ifdef __cplusplus
extern "C" {
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
}
# else
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
# endif

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifdef lex_interface
#    define GetToken	yylex
     extern int yylex ();
#    ifndef AttributeDef
#	include "Positions.h"
        typedef struct { tPosition Position; } tScanAttribute;
        static	tScanAttribute	Attribute = {{ 0, 0 }};
#    endif
#    ifndef ErrorAttributeDef
#	define ErrorAttribute(Token, RepairAttribute)
#    endif
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) * yyAttrStackPtr = yylval
#    endif
# else
#    include "Scanner.h"
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) (yyAttrStackPtr)->Scan = Attribute
#    endif
# endif

/* line 11 "/tmp/lalr1423" */
/* line 24 "occam.lalr" */

  #include "Scanner.h"
  #include "TreeFix.h"
  #include "Tree.h"
  #include "Symbol.h"
  #include "TypeChk.h"
  
  #define InheritTypes(t)
  #define DEBUG(s) fprintf(stderr,"DEBUG: %s\n",s);

  typedef struct { tScanAttribute Scan; tTree Tree; } tParsAttribute;

  #define Posn(a)  ((a).Scan.Position)
  #define Val(a) ((a).Scan.Value)
  #define InsertASpec(a,s) a=mASpec(s,a)

  static tSymbol S;
  static tTree T;
  static last_type_was_chan = false;
  static tValue Vtrue,Vfalse;


# if defined lex_interface & ! defined yylvalDef
     tParsAttribute yylval;
# endif

# ifndef yyInitStackSize
#    define yyInitStackSize	100
# endif
# define yyNoState		0

# define yyFirstTerminal	0
# define yyLastTerminal		109
# define yyTableMax		2630
# define yyNTableMax		5199
# define yyFirstReadState	1
# define yyLastReadState	371
# define yyFirstReadTermState	372
# define yyLastReadTermState	505
# define yyLastReadNontermState	625
# define yyFirstReduceState	626
# define yyLastReduceState	922
# define yyStartState		1
# define yyStopState		626

# define yyFirstFinalState	yyFirstReadTermState

typedef unsigned short	yyStateRange	;
typedef unsigned short	yySymbolRange	;
typedef struct	{ yyStateRange Check, Next; } yyTCombType ;

	char *		Parser_TokenName	[yyLastTerminal + 1] = {
"_EndOfFile",
"DECLCOMMA",
"ID",
"EOL",
"NUMBER",
"HEXNUMBER",
"CHCON",
"STR",
"CSTR",
"RNUMBER",
"BEGIN",
"END",
"LT",
"GT",
"LE",
"GE",
"EQ",
"NE",
"ADD",
"SUBTRACT",
"MULTIPLY",
"DIVIDE",
"BITEOR",
"LSHIFT",
"RSHIFT",
"DCOLON",
"ASSIGN",
"LP",
"RP",
"COLON",
"SEMICOLON",
"COMMA",
"AMPERSAND",
"LSB",
"RSB",
"QUERY",
"PLING",
"HASHC",
"HASHH",
"AFTER",
"ALT",
"AND",
"ANY",
"BITAND",
"BITNOT",
"BITOR",
"BOOL",
"BYTE",
"CASE",
"CHAN",
"ELSE",
"FALSE",
"FOR",
"FROM",
"FUNCTION",
"IF",
"INT",
"INT16",
"INT32",
"INT64",
"IS",
"MINUS",
"MOSTNEG",
"MOSTPOS",
"NOT",
"OF",
"OR",
"PAR",
"PLACED",
"PLUS",
"PORT",
"PRI",
"PROC",
"PROCESSOR",
"PROTOCOL",
"REAL32",
"REAL64",
"REM",
"RESULT",
"RETYPES",
"ROUND",
"SEQ",
"SIZE",
"SKIP",
"STOP",
"TIMER",
"TIMES",
"TRUE",
"TRUNC",
"VAL",
"VALOF",
"WHILE",
"EXTERN_OCCAM",
"EXTERN_ATOMIC",
"EXTERN_F90",
"EXTERN_F77",
"EXTERN_C",
"DATA",
"kNONE",
"TYPE",
"RECORD",
"UNION",
"ASM",
"AT",
"GUY",
"IN",
"INLINE",
"PLACE",
"WORKSPACE",
"VECSPACE",
};
static	yyTCombType	yyTComb		[yyTableMax + 1] = {
{369, 626},
{0, 0},
{20, 391},
{72, 73},
{85, 86},
{90, 435},
{94, 95},
{98, 99},
{105, 106},
{107, 108},
{81, 82},
{84, 85},
{84, 93},
{90, 91},
{91, 92},
{110, 111},
{120, 435},
{129, 456},
{144, 145},
{147, 148},
{152, 153},
{159, 160},
{161, 162},
{173, 174},
{177, 178},
{180, 181},
{2, 822},
{2, 3},
{3, 363},
{5, 388},
{8, 378},
{2, 822},
{11, 379},
{2, 822},
{14, 380},
{2, 822},
{2, 822},
{15, 16},
{1, 368},
{4, 822},
{4, 822},
{4, 822},
{17, 384},
{24, 392},
{32, 398},
{33, 399},
{38, 400},
{41, 401},
{45, 402},
{51, 52},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{62, 63},
{4, 5},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{4, 822},
{19, 20},
{27, 28},
{16, 382},
{16, 383},
{4, 822},
{47, 48},
{4, 822},
{34, 35},
{4, 822},
{64, 428},
{4, 822},
{31, 372},
{31, 373},
{53, 54},
{67, 68},
{34, 321},
{53, 427},
{4, 822},
{4, 822},
{69, 429},
{70, 430},
{31, 374},
{31, 375},
{31, 376},
{31, 377},
{71, 825},
{4, 822},
{73, 74},
{78, 79},
{71, 37},
{79, 80},
{4, 822},
{75, 434},
{75, 76},
{4, 822},
{82, 83},
{87, 433},
{92, 436},
{93, 437},
{97, 438},
{99, 439},
{86, 774},
{4, 822},
{6, 887},
{6, 887},
{6, 887},
{101, 440},
{103, 441},
{104, 105},
{106, 107},
{108, 448},
{4, 822},
{88, 775},
{109, 449},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{86, 87},
{6, 7},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{6, 887},
{47, 431},
{6, 887},
{47, 72},
{111, 112},
{88, 76},
{111, 116},
{6, 887},
{112, 113},
{6, 887},
{114, 450},
{6, 887},
{115, 451},
{6, 887},
{116, 117},
{116, 118},
{117, 452},
{118, 453},
{47, 94},
{47, 442},
{6, 887},
{47, 443},
{47, 444},
{47, 445},
{47, 446},
{47, 447},
{47, 104},
{121, 403},
{125, 454},
{6, 887},
{127, 455},
{128, 457},
{133, 458},
{135, 459},
{6, 887},
{47, 109},
{47, 110},
{6, 887},
{138, 139},
{142, 143},
{146, 389},
{150, 466},
{154, 155},
{131, 730},
{163, 466},
{6, 887},
{9, 888},
{9, 888},
{9, 888},
{184, 468},
{122, 805},
{122, 123},
{130, 806},
{130, 131},
{6, 887},
{136, 129},
{134, 404},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{131, 730},
{9, 10},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{9, 888},
{186, 435},
{9, 888},
{122, 805},
{190, 469},
{130, 806},
{136, 460},
{9, 888},
{192, 193},
{9, 888},
{134, 50},
{9, 888},
{194, 470},
{9, 888},
{199, 435},
{201, 202},
{203, 471},
{204, 152},
{207, 463},
{209, 435},
{9, 888},
{211, 212},
{213, 472},
{217, 474},
{219, 220},
{221, 222},
{122, 805},
{222, 223},
{130, 806},
{9, 888},
{214, 473},
{227, 228},
{230, 231},
{231, 476},
{9, 888},
{232, 233},
{234, 235},
{9, 888},
{236, 237},
{237, 238},
{229, 121},
{240, 811},
{246, 478},
{248, 461},
{240, 241},
{9, 888},
{12, 891},
{12, 891},
{12, 891},
{245, 813},
{249, 250},
{250, 809},
{245, 246},
{224, 225},
{9, 888},
{251, 252},
{252, 253},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{229, 21},
{12, 13},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{12, 891},
{122, 805},
{12, 891},
{130, 806},
{224, 475},
{214, 217},
{224, 226},
{12, 891},
{178, 48},
{12, 891},
{244, 462},
{12, 891},
{255, 256},
{12, 891},
{253, 477},
{253, 765},
{257, 479},
{260, 435},
{261, 262},
{263, 778},
{12, 891},
{267, 804},
{266, 37},
{261, 264},
{276, 435},
{260, 480},
{267, 804},
{281, 265},
{267, 37},
{12, 891},
{282, 283},
{284, 481},
{285, 482},
{288, 779},
{12, 891},
{250, 140},
{244, 820},
{12, 891},
{295, 296},
{244, 820},
{297, 483},
{247, 215},
{266, 61},
{298, 299},
{299, 300},
{12, 891},
{22, 890},
{22, 890},
{22, 890},
{301, 302},
{303, 484},
{229, 442},
{246, 242},
{305, 306},
{12, 891},
{307, 485},
{178, 179},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{247, 216},
{22, 23},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{22, 890},
{178, 431},
{22, 890},
{178, 72},
{292, 789},
{268, 803},
{277, 796},
{22, 890},
{309, 310},
{22, 890},
{268, 803},
{22, 890},
{279, 797},
{22, 890},
{268, 269},
{268, 289},
{290, 792},
{247, 248},
{178, 94},
{311, 486},
{22, 890},
{178, 443},
{178, 444},
{178, 445},
{178, 446},
{178, 447},
{178, 104},
{314, 432},
{277, 278},
{22, 890},
{312, 37},
{292, 293},
{312, 313},
{277, 796},
{22, 890},
{178, 109},
{178, 110},
{22, 890},
{290, 291},
{279, 797},
{313, 270},
{315, 281},
{279, 37},
{290, 792},
{316, 317},
{22, 890},
{30, 889},
{30, 889},
{30, 889},
{313, 464},
{318, 487},
{324, 488},
{326, 327},
{328, 489},
{22, 890},
{329, 490},
{331, 332},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{274, 822},
{30, 31},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{30, 889},
{242, 21},
{30, 889},
{319, 805},
{319, 320},
{333, 491},
{335, 336},
{30, 889},
{273, 274},
{30, 889},
{337, 492},
{30, 889},
{338, 493},
{30, 889},
{340, 435},
{341, 54},
{274, 822},
{242, 19},
{342, 343},
{344, 494},
{30, 889},
{274, 822},
{345, 495},
{346, 496},
{274, 822},
{347, 497},
{348, 498},
{351, 150},
{350, 435},
{30, 889},
{352, 499},
{353, 354},
{351, 158},
{319, 805},
{30, 889},
{350, 351},
{354, 500},
{30, 889},
{242, 27},
{273, 146},
{355, 501},
{356, 502},
{359, 360},
{242, 382},
{242, 383},
{30, 889},
{36, 844},
{36, 844},
{36, 844},
{361, 503},
{362, 504},
{368, 505},
{365, 366},
{242, 396},
{30, 889},
{365, 54},
{319, 805},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{370, 432},
{371, 629},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{36, 844},
{273, 431},
{36, 844},
{273, 72},
{0, 0},
{0, 0},
{0, 0},
{36, 844},
{0, 0},
{36, 844},
{0, 0},
{36, 844},
{0, 0},
{36, 844},
{320, 822},
{0, 0},
{0, 0},
{0, 0},
{273, 94},
{0, 0},
{36, 844},
{273, 443},
{273, 444},
{273, 445},
{273, 446},
{273, 447},
{273, 104},
{0, 0},
{0, 0},
{36, 844},
{0, 0},
{319, 805},
{0, 0},
{371, 368},
{36, 844},
{273, 109},
{273, 110},
{36, 844},
{320, 5},
{320, 822},
{0, 0},
{0, 0},
{320, 822},
{320, 822},
{320, 822},
{36, 844},
{39, 831},
{39, 831},
{39, 831},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{36, 844},
{0, 0},
{0, 0},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{0, 0},
{0, 0},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 831},
{39, 40},
{39, 831},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{39, 831},
{0, 0},
{39, 831},
{0, 0},
{39, 831},
{0, 0},
{39, 831},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{39, 831},
{39, 831},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{39, 831},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{39, 831},
{0, 0},
{0, 0},
{39, 831},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{39, 831},
{42, 832},
{42, 832},
{42, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{39, 831},
{0, 0},
{0, 0},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{0, 0},
{0, 0},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 832},
{42, 21},
{42, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{42, 832},
{0, 0},
{42, 832},
{0, 0},
{42, 832},
{0, 0},
{42, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{42, 832},
{42, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{42, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{42, 832},
{0, 0},
{0, 0},
{42, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{42, 832},
{43, 846},
{43, 846},
{43, 846},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{42, 832},
{0, 0},
{0, 0},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{0, 0},
{0, 0},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 846},
{43, 44},
{43, 846},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{43, 846},
{0, 0},
{43, 846},
{0, 0},
{43, 846},
{0, 0},
{43, 846},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{43, 846},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{43, 846},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{43, 846},
{0, 0},
{0, 0},
{43, 846},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{43, 846},
{48, 822},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{43, 846},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{48, 822},
{0, 0},
{0, 0},
{48, 5},
{48, 822},
{0, 0},
{0, 0},
{48, 822},
{48, 822},
{48, 822},
{0, 0},
{48, 822},
{0, 0},
{0, 0},
{0, 0},
{48, 822},
{0, 0},
{48, 822},
{0, 0},
{48, 822},
{0, 0},
{48, 822},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{48, 822},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{48, 822},
{0, 0},
{0, 0},
{48, 822},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{48, 822},
{55, 838},
{55, 838},
{55, 838},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{48, 822},
{0, 0},
{0, 0},
{55, 405},
{55, 406},
{55, 407},
{55, 408},
{55, 409},
{55, 410},
{55, 411},
{55, 412},
{55, 413},
{55, 414},
{55, 415},
{55, 416},
{55, 417},
{55, 838},
{0, 0},
{0, 0},
{55, 838},
{55, 838},
{55, 838},
{55, 838},
{55, 838},
{0, 0},
{55, 838},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{55, 418},
{0, 0},
{0, 0},
{0, 0},
{55, 420},
{0, 0},
{55, 421},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{55, 838},
{0, 0},
{58, 840},
{58, 840},
{58, 840},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{55, 422},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{55, 424},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{55, 425},
{58, 840},
{0, 0},
{0, 0},
{58, 840},
{58, 840},
{58, 840},
{58, 840},
{58, 840},
{55, 426},
{58, 840},
{189, 2},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{58, 419},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{58, 840},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{60, 844},
{58, 423},
{0, 0},
{0, 0},
{0, 0},
{189, 147},
{0, 0},
{60, 844},
{189, 463},
{0, 0},
{60, 844},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 844},
{189, 464},
{60, 844},
{0, 0},
{60, 844},
{0, 0},
{60, 844},
{0, 0},
{189, 465},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{189, 466},
{189, 150},
{60, 844},
{0, 0},
{189, 163},
{0, 0},
{189, 158},
{60, 844},
{0, 0},
{0, 0},
{60, 844},
{0, 0},
{0, 0},
{0, 0},
{189, 467},
{0, 0},
{189, 167},
{189, 169},
{60, 844},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{189, 171},
{0, 0},
{0, 0},
{60, 844},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{65, 845},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{65, 845},
{0, 0},
{0, 0},
{65, 845},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{65, 845},
{0, 0},
{65, 845},
{0, 0},
{65, 845},
{0, 0},
{65, 845},
{77, 907},
{77, 907},
{77, 907},
{77, 907},
{77, 907},
{77, 907},
{77, 907},
{65, 66},
{77, 907},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{321, 4},
{65, 845},
{321, 6},
{321, 9},
{321, 12},
{321, 381},
{65, 845},
{321, 15},
{0, 0},
{65, 845},
{77, 78},
{0, 0},
{77, 907},
{77, 907},
{77, 907},
{77, 907},
{77, 907},
{65, 845},
{77, 907},
{0, 0},
{0, 0},
{0, 0},
{149, 644},
{0, 0},
{149, 644},
{321, 387},
{65, 845},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{321, 18},
{0, 0},
{149, 644},
{0, 0},
{0, 0},
{77, 907},
{0, 0},
{0, 0},
{77, 907},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 907},
{77, 907},
{321, 22},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{149, 644},
{0, 0},
{0, 0},
{0, 0},
{149, 644},
{321, 25},
{321, 26},
{149, 644},
{0, 0},
{0, 0},
{77, 907},
{0, 0},
{0, 0},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{77, 907},
{77, 907},
{0, 0},
{0, 0},
{0, 0},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{0, 0},
{0, 0},
{0, 0},
{321, 30},
{0, 0},
{0, 0},
{0, 0},
{149, 644},
{149, 644},
{77, 907},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{156, 681},
{149, 644},
{156, 681},
{0, 0},
{149, 644},
{0, 0},
{149, 644},
{149, 644},
{149, 644},
{0, 0},
{156, 157},
{156, 681},
{149, 644},
{0, 0},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{149, 644},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{149, 644},
{149, 644},
{0, 0},
{0, 0},
{156, 681},
{0, 0},
{0, 0},
{0, 0},
{156, 681},
{0, 0},
{0, 0},
{156, 681},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 681},
{156, 681},
{0, 0},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{165, 675},
{156, 681},
{165, 675},
{0, 0},
{156, 681},
{0, 0},
{156, 681},
{156, 681},
{156, 681},
{0, 0},
{165, 166},
{165, 675},
{156, 681},
{0, 0},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{156, 681},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 681},
{156, 681},
{0, 0},
{0, 0},
{165, 675},
{0, 0},
{0, 0},
{0, 0},
{165, 675},
{0, 0},
{0, 0},
{165, 675},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 675},
{165, 675},
{0, 0},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{168, 637},
{165, 675},
{168, 637},
{0, 0},
{165, 675},
{0, 0},
{165, 675},
{165, 675},
{165, 675},
{0, 0},
{0, 0},
{168, 637},
{165, 675},
{0, 0},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{165, 675},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 675},
{165, 675},
{0, 0},
{0, 0},
{168, 637},
{0, 0},
{0, 0},
{0, 0},
{168, 637},
{0, 0},
{0, 0},
{168, 637},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{168, 637},
{168, 637},
{0, 0},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{170, 638},
{168, 637},
{170, 638},
{0, 0},
{168, 637},
{0, 0},
{168, 637},
{168, 637},
{168, 637},
{0, 0},
{0, 0},
{170, 638},
{168, 637},
{0, 0},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{168, 637},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{168, 637},
{168, 637},
{0, 0},
{0, 0},
{170, 638},
{0, 0},
{0, 0},
{0, 0},
{170, 638},
{0, 0},
{0, 0},
{170, 638},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 638},
{170, 638},
{0, 0},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{0, 0},
{170, 638},
{0, 0},
{0, 0},
{170, 638},
{0, 0},
{170, 638},
{170, 638},
{170, 638},
{175, 385},
{175, 386},
{0, 0},
{170, 638},
{0, 0},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{170, 638},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 638},
{170, 638},
{183, 636},
{0, 0},
{183, 636},
{0, 0},
{175, 390},
{0, 0},
{175, 372},
{175, 373},
{0, 0},
{175, 19},
{0, 0},
{183, 636},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{175, 374},
{175, 375},
{175, 376},
{175, 377},
{0, 0},
{175, 393},
{0, 0},
{0, 0},
{175, 394},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{175, 395},
{175, 27},
{0, 0},
{0, 0},
{183, 636},
{0, 0},
{175, 382},
{175, 383},
{183, 636},
{0, 0},
{0, 0},
{183, 636},
{0, 0},
{175, 397},
{0, 0},
{0, 0},
{175, 396},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{183, 636},
{183, 636},
{0, 0},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{188, 666},
{183, 636},
{188, 666},
{0, 0},
{183, 636},
{0, 0},
{183, 636},
{183, 636},
{183, 636},
{0, 0},
{188, 189},
{188, 666},
{183, 636},
{0, 0},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{183, 636},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{183, 636},
{183, 636},
{0, 0},
{0, 0},
{188, 666},
{0, 0},
{0, 0},
{0, 0},
{188, 666},
{0, 0},
{0, 0},
{188, 666},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{188, 666},
{188, 666},
{0, 0},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{0, 0},
{188, 666},
{0, 0},
{0, 0},
{188, 666},
{0, 0},
{188, 666},
{188, 666},
{188, 666},
{0, 0},
{0, 0},
{0, 0},
{188, 666},
{0, 0},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{188, 666},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{188, 666},
{188, 666},
{196, 689},
{0, 0},
{196, 689},
{0, 0},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{0, 0},
{196, 689},
{196, 197},
{196, 689},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{196, 689},
{196, 689},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{196, 689},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{196, 689},
{0, 0},
{0, 0},
{0, 0},
{196, 689},
{0, 0},
{0, 0},
{196, 689},
{0, 0},
{0, 0},
{0, 0},
{196, 689},
{197, 48},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{0, 0},
{196, 689},
{0, 0},
{0, 0},
{0, 0},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{0, 0},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{0, 0},
{0, 0},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{0, 0},
{196, 689},
{0, 0},
{0, 0},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{0, 0},
{196, 689},
{0, 0},
{196, 689},
{0, 0},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{196, 689},
{197, 465},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{196, 689},
{196, 689},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{197, 431},
{0, 0},
{197, 72},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{197, 94},
{0, 0},
{0, 0},
{197, 443},
{197, 444},
{197, 445},
{197, 446},
{197, 447},
{197, 104},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{197, 109},
{197, 110},
{205, 695},
{0, 0},
{205, 695},
{0, 0},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{0, 0},
{205, 695},
{205, 206},
{205, 695},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{205, 695},
{205, 695},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{205, 695},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{205, 695},
{0, 0},
{0, 0},
{0, 0},
{205, 695},
{0, 0},
{206, 48},
{205, 695},
{0, 0},
{0, 0},
{0, 0},
{205, 695},
{0, 0},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{0, 0},
{205, 695},
{0, 0},
{0, 0},
{0, 0},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{0, 0},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{0, 0},
{0, 0},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{206, 463},
{205, 695},
{0, 0},
{0, 0},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{0, 0},
{205, 695},
{0, 0},
{205, 695},
{0, 0},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{205, 695},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{228, 741},
{0, 0},
{205, 695},
{205, 695},
{206, 207},
{206, 431},
{0, 0},
{206, 72},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{206, 94},
{0, 0},
{0, 0},
{206, 443},
{206, 444},
{206, 445},
{206, 446},
{206, 447},
{206, 104},
{228, 741},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{206, 109},
{206, 110},
{0, 0},
{0, 0},
{0, 0},
{228, 741},
{228, 741},
{0, 0},
{228, 741},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{228, 741},
{228, 741},
{228, 741},
{228, 741},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{228, 741},
{0, 0},
{228, 741},
{0, 0},
{228, 741},
{228, 741},
{228, 741},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{228, 741},
{0, 0},
{0, 0},
{0, 0},
{228, 741},
{228, 741},
{0, 0},
{228, 741},
{228, 741},
{228, 741},
{228, 741},
{228, 741},
{228, 741},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{228, 741},
{228, 741},
{272, 781},
{0, 0},
{272, 781},
{0, 0},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{0, 0},
{272, 781},
{272, 273},
{272, 781},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{272, 781},
{272, 781},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{272, 781},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{272, 781},
{0, 0},
{0, 0},
{0, 0},
{272, 781},
{0, 0},
{0, 0},
{272, 781},
{0, 0},
{0, 0},
{0, 0},
{272, 781},
{0, 0},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{0, 0},
{272, 781},
{0, 0},
{0, 0},
{0, 0},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{0, 0},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{0, 0},
{0, 0},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{287, 783},
{272, 781},
{287, 783},
{0, 0},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{0, 0},
{272, 781},
{287, 783},
{272, 781},
{0, 0},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{272, 781},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{272, 781},
{272, 781},
{0, 0},
{0, 0},
{287, 783},
{0, 0},
{0, 0},
{0, 0},
{287, 783},
{0, 0},
{0, 0},
{287, 783},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{287, 783},
{287, 783},
{0, 0},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{0, 0},
{287, 783},
{0, 0},
{0, 0},
{287, 783},
{0, 0},
{287, 783},
{287, 783},
{287, 783},
{0, 0},
{0, 0},
{0, 0},
{287, 783},
{0, 0},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{287, 783},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{287, 783},
{287, 783},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{322, 844},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{322, 844},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{322, 844},
{0, 0},
{322, 844},
{0, 0},
{322, 844},
{0, 0},
{322, 844},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{322, 844},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{322, 844},
{0, 0},
{0, 0},
{322, 844},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{322, 844},
{323, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{322, 844},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{323, 832},
{0, 0},
{0, 0},
{0, 0},
{323, 832},
{0, 0},
{0, 0},
{323, 832},
{323, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{323, 832},
{0, 0},
{323, 832},
{0, 0},
{323, 832},
{0, 0},
{323, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{323, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{323, 832},
{0, 0},
{0, 0},
{323, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{323, 832},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{323, 832},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{357, 846},
{364, 663},
{0, 0},
{364, 663},
{0, 0},
{0, 0},
{0, 0},
{357, 846},
{0, 0},
{357, 44},
{357, 846},
{0, 0},
{364, 663},
{0, 0},
{0, 0},
{357, 846},
{0, 0},
{357, 846},
{0, 0},
{357, 846},
{0, 0},
{357, 846},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{357, 358},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{364, 663},
{0, 0},
{0, 0},
{357, 846},
{364, 663},
{0, 0},
{0, 0},
{364, 663},
{357, 846},
{0, 0},
{0, 0},
{357, 846},
{0, 0},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{0, 0},
{0, 0},
{357, 846},
{0, 0},
{0, 0},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{0, 0},
{357, 846},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{364, 663},
{364, 663},
{0, 0},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{367, 662},
{364, 663},
{367, 662},
{0, 0},
{364, 663},
{0, 0},
{364, 663},
{364, 663},
{364, 663},
{0, 0},
{0, 0},
{367, 662},
{364, 663},
{0, 0},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{364, 663},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{364, 663},
{364, 663},
{0, 0},
{0, 0},
{367, 662},
{0, 0},
{0, 0},
{0, 0},
{367, 662},
{0, 0},
{0, 0},
{367, 662},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{367, 662},
{367, 662},
{0, 0},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{0, 0},
{367, 662},
{0, 0},
{0, 0},
{367, 662},
{0, 0},
{367, 662},
{367, 662},
{367, 662},
{0, 0},
{0, 0},
{0, 0},
{367, 662},
{0, 0},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{367, 662},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{367, 662},
{367, 662},
{0, 0},
{0, 0},
};
static	unsigned short	yyNComb		[yyNTableMax - yyLastTerminal] = {
620,
369,
621,
370,
81,
623,
624,
625,
175,
182,
84,
90,
544,
545,
546,
547,
120,
144,
549,
550,
551,
552,
149,
156,
161,
553,
554,
555,
556,
557,
187,
168,
170,
164,
560,
561,
173,
191,
177,
195,
365,
526,
204,
567,
151,
180,
614,
183,
349,
348,
186,
612,
122,
128,
130,
538,
49,
96,
100,
102,
124,
126,
537,
137,
136,
214,
538,
512,
138,
34,
573,
574,
232,
89,
192,
511,
362,
526,
261,
268,
8,
11,
14,
24,
506,
507,
32,
533,
532,
199,
511,
539,
511,
201,
29,
209,
36,
211,
56,
132,
134,
165,
57,
59,
513,
34,
17,
514,
516,
518,
39,
42,
43,
46,
55,
51,
524,
58,
47,
513,
522,
513,
514,
515,
514,
516,
164,
613,
511,
612,
191,
188,
36,
218,
196,
204,
565,
205,
219,
227,
229,
234,
575,
34,
576,
518,
39,
42,
43,
46,
55,
578,
524,
58,
47,
579,
522,
513,
249,
334,
514,
516,
330,
584,
255,
325,
511,
258,
260,
33,
60,
267,
266,
276,
279,
282,
287,
295,
301,
508,
305,
509,
70,
65,
39,
42,
357,
46,
55,
309,
524,
58,
47,
316,
522,
513,
528,
34,
514,
516,
277,
618,
77,
71,
619,
508,
586,
509,
326,
331,
335,
340,
272,
342,
615,
350,
527,
39,
42,
352,
511,
29,
510,
364,
36,
367,
371,
0,
511,
0,
517,
513,
516,
0,
514,
516,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
29,
522,
513,
36,
0,
514,
516,
0,
0,
271,
513,
34,
0,
514,
516,
36,
518,
39,
42,
43,
517,
601,
582,
0,
583,
47,
272,
522,
518,
39,
42,
43,
516,
617,
511,
247,
0,
47,
36,
522,
277,
286,
314,
0,
516,
511,
588,
0,
34,
0,
38,
518,
39,
42,
43,
46,
55,
517,
524,
58,
47,
0,
522,
513,
29,
0,
514,
516,
0,
0,
0,
511,
0,
0,
513,
36,
0,
514,
516,
0,
277,
288,
0,
0,
0,
34,
588,
41,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
277,
315,
514,
516,
0,
0,
588,
511,
0,
51,
0,
36,
277,
288,
0,
0,
0,
0,
588,
0,
0,
125,
0,
45,
518,
39,
42,
43,
46,
55,
36,
524,
58,
47,
0,
522,
513,
34,
0,
514,
516,
0,
71,
518,
39,
42,
43,
0,
519,
534,
535,
536,
47,
0,
522,
527,
39,
42,
0,
516,
511,
119,
0,
0,
60,
0,
0,
0,
355,
0,
127,
516,
0,
0,
0,
0,
0,
65,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
71,
514,
516,
0,
0,
319,
0,
130,
0,
0,
53,
526,
0,
527,
39,
42,
137,
0,
214,
0,
356,
0,
0,
573,
574,
232,
0,
0,
511,
516,
0,
0,
36,
0,
0,
0,
0,
566,
0,
34,
0,
520,
304,
308,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
254,
0,
514,
516,
511,
0,
0,
0,
36,
0,
0,
34,
0,
0,
0,
596,
597,
0,
0,
0,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
511,
0,
514,
516,
36,
0,
0,
0,
0,
0,
312,
0,
0,
0,
0,
0,
0,
518,
39,
42,
43,
46,
55,
36,
524,
58,
47,
0,
522,
513,
517,
0,
514,
516,
0,
36,
518,
39,
42,
43,
0,
521,
0,
0,
0,
47,
0,
522,
518,
39,
42,
43,
516,
523,
36,
0,
0,
47,
34,
522,
517,
0,
0,
0,
516,
0,
0,
518,
39,
42,
43,
0,
525,
0,
0,
0,
47,
0,
522,
0,
0,
511,
0,
516,
0,
36,
0,
0,
34,
0,
517,
0,
0,
0,
0,
0,
0,
62,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
511,
0,
514,
516,
36,
0,
0,
34,
0,
517,
0,
0,
0,
0,
0,
0,
64,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
511,
0,
514,
516,
36,
0,
0,
34,
0,
0,
0,
0,
0,
0,
0,
0,
67,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
511,
0,
514,
516,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
69,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
133,
522,
513,
0,
0,
514,
516,
508,
0,
509,
0,
0,
0,
0,
0,
508,
75,
509,
0,
0,
0,
71,
0,
508,
528,
509,
0,
0,
0,
531,
77,
0,
528,
0,
527,
39,
42,
529,
77,
0,
530,
97,
0,
0,
0,
0,
511,
0,
0,
29,
516,
508,
0,
509,
0,
0,
0,
29,
0,
513,
88,
0,
514,
516,
0,
29,
0,
513,
528,
34,
514,
516,
0,
531,
77,
513,
0,
101,
514,
516,
0,
508,
0,
509,
0,
0,
0,
0,
0,
0,
0,
0,
511,
29,
0,
0,
36,
0,
98,
0,
0,
0,
0,
513,
511,
34,
514,
516,
0,
518,
39,
42,
43,
46,
55,
103,
524,
58,
47,
0,
522,
513,
0,
29,
514,
516,
0,
0,
511,
0,
0,
0,
36,
513,
0,
0,
514,
516,
0,
0,
0,
0,
0,
34,
0,
518,
39,
42,
43,
46,
55,
115,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
34,
0,
114,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
511,
0,
0,
0,
36,
0,
0,
34,
0,
0,
135,
0,
0,
0,
0,
0,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
511,
71,
514,
516,
36,
0,
0,
0,
0,
0,
0,
534,
535,
536,
527,
39,
42,
518,
39,
42,
43,
46,
55,
119,
524,
58,
47,
0,
522,
513,
516,
0,
514,
516,
0,
0,
0,
0,
0,
0,
508,
0,
509,
0,
0,
0,
0,
508,
0,
509,
0,
0,
142,
0,
0,
0,
0,
239,
122,
0,
130,
0,
0,
511,
141,
0,
0,
0,
0,
137,
511,
214,
0,
616,
577,
240,
573,
574,
232,
0,
0,
511,
29,
0,
0,
0,
0,
0,
0,
29,
0,
0,
513,
0,
0,
514,
516,
0,
0,
513,
29,
0,
514,
516,
0,
0,
0,
0,
0,
0,
513,
254,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
353,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
33,
204,
567,
0,
508,
0,
509,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
568,
137,
0,
214,
0,
0,
511,
34,
573,
574,
232,
0,
0,
511,
0,
540,
261,
268,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
511,
0,
29,
0,
60,
513,
0,
154,
514,
516,
0,
0,
513,
34,
0,
514,
516,
518,
39,
42,
43,
46,
55,
541,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
542,
0,
0,
0,
0,
34,
0,
518,
39,
42,
43,
46,
55,
159,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
34,
0,
0,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
347,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
508,
0,
509,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
569,
0,
137,
0,
214,
0,
511,
0,
36,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
518,
39,
42,
43,
29,
600,
0,
0,
0,
47,
0,
522,
29,
0,
513,
0,
516,
514,
516,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
610,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
346,
191,
0,
195,
0,
172,
204,
567,
0,
508,
0,
509,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
244,
137,
0,
214,
0,
0,
511,
34,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
580,
245,
0,
0,
0,
0,
29,
0,
0,
0,
0,
511,
0,
29,
0,
36,
513,
0,
0,
514,
516,
0,
0,
513,
0,
0,
514,
516,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
345,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
176,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
609,
0,
0,
0,
0,
0,
128,
122,
538,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
34,
0,
511,
0,
36,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
42,
43,
29,
601,
511,
0,
0,
47,
36,
522,
0,
0,
513,
0,
516,
514,
516,
0,
0,
0,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
534,
535,
536,
0,
0,
0,
338,
0,
0,
0,
0,
0,
339,
0,
0,
0,
0,
608,
341,
526,
508,
0,
509,
0,
0,
0,
0,
0,
0,
508,
0,
509,
221,
0,
0,
0,
0,
239,
0,
0,
0,
236,
0,
511,
0,
0,
239,
319,
0,
130,
0,
0,
511,
0,
577,
240,
0,
0,
137,
0,
214,
0,
29,
577,
240,
573,
574,
232,
0,
0,
511,
29,
513,
0,
36,
514,
516,
0,
0,
0,
0,
513,
0,
0,
514,
516,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
184,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
508,
0,
509,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
243,
0,
137,
0,
214,
0,
511,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
29,
0,
513,
0,
0,
514,
516,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
548,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
508,
0,
509,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
244,
0,
137,
0,
214,
0,
511,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
581,
245,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
29,
0,
513,
0,
0,
514,
516,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
558,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
190,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
559,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
194,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
534,
535,
536,
0,
0,
0,
0,
0,
0,
0,
0,
0,
198,
0,
29,
0,
0,
0,
0,
562,
0,
508,
563,
509,
513,
0,
0,
514,
516,
0,
0,
0,
0,
251,
195,
329,
605,
0,
239,
0,
0,
0,
0,
200,
511,
0,
0,
319,
0,
130,
0,
0,
0,
0,
0,
577,
240,
0,
137,
0,
214,
0,
0,
29,
0,
573,
574,
232,
0,
0,
511,
0,
0,
513,
36,
0,
514,
516,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
534,
535,
536,
0,
0,
0,
0,
0,
0,
0,
0,
0,
198,
0,
0,
0,
0,
0,
0,
562,
0,
0,
563,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
195,
0,
564,
0,
0,
0,
0,
0,
0,
200,
0,
0,
0,
319,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
203,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
534,
535,
536,
0,
0,
0,
0,
0,
0,
566,
0,
29,
208,
0,
210,
294,
0,
0,
0,
562,
0,
513,
0,
594,
514,
516,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
204,
567,
324,
603,
0,
0,
298,
598,
599,
597,
319,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
322,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
534,
535,
536,
0,
0,
0,
0,
0,
0,
566,
0,
0,
208,
0,
210,
294,
0,
0,
0,
562,
0,
0,
0,
594,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
204,
567,
0,
595,
0,
0,
298,
598,
599,
597,
319,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
322,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
213,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
570,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
34,
573,
574,
232,
0,
0,
511,
0,
571,
261,
268,
0,
0,
0,
0,
0,
224,
0,
0,
0,
0,
0,
0,
511,
0,
29,
0,
36,
0,
0,
0,
0,
0,
0,
0,
513,
34,
0,
514,
516,
518,
39,
42,
43,
46,
55,
572,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
34,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
534,
535,
536,
0,
511,
0,
0,
0,
36,
0,
0,
0,
119,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
230,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
254,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
257,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
259,
526,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
34,
573,
574,
232,
0,
0,
511,
263,
526,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
511,
0,
29,
0,
36,
0,
0,
0,
0,
0,
0,
0,
513,
34,
0,
514,
516,
518,
39,
42,
43,
46,
55,
585,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
34,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
534,
535,
536,
0,
511,
0,
0,
0,
36,
0,
0,
0,
275,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
534,
535,
536,
0,
0,
0,
0,
137,
0,
214,
0,
0,
275,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
277,
280,
285,
590,
0,
0,
588,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
122,
513,
130,
0,
514,
516,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
277,
280,
0,
587,
0,
0,
588,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
284,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
534,
535,
536,
0,
0,
0,
0,
137,
0,
214,
0,
0,
275,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
290,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
122,
513,
130,
0,
514,
516,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
34,
573,
574,
232,
0,
0,
511,
0,
591,
0,
277,
280,
0,
589,
0,
0,
588,
0,
0,
0,
0,
0,
0,
511,
0,
29,
0,
36,
0,
0,
0,
292,
593,
0,
0,
513,
34,
0,
514,
516,
518,
39,
42,
43,
46,
55,
290,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
34,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
592,
0,
0,
0,
0,
0,
0,
0,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
297,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
303,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
307,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
311,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
318,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
534,
535,
536,
0,
0,
0,
0,
0,
0,
566,
0,
29,
208,
0,
210,
294,
0,
0,
0,
562,
0,
513,
0,
594,
514,
516,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
204,
567,
0,
602,
0,
0,
298,
598,
599,
597,
319,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
322,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
534,
535,
536,
0,
0,
0,
0,
0,
0,
566,
0,
0,
208,
0,
210,
294,
0,
0,
0,
562,
0,
0,
0,
594,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
204,
567,
0,
328,
0,
0,
298,
598,
599,
597,
319,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
322,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
534,
535,
536,
0,
0,
0,
0,
0,
0,
0,
0,
0,
198,
0,
0,
0,
0,
0,
0,
562,
0,
0,
563,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
195,
0,
604,
0,
0,
0,
0,
0,
0,
200,
0,
0,
0,
319,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
534,
535,
536,
0,
0,
0,
0,
0,
0,
0,
0,
0,
198,
0,
0,
0,
0,
0,
0,
562,
0,
0,
563,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
195,
0,
333,
0,
0,
0,
0,
0,
0,
200,
0,
0,
0,
319,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
337,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
534,
535,
536,
0,
0,
0,
0,
0,
0,
0,
0,
0,
339,
0,
29,
0,
0,
607,
341,
526,
0,
0,
0,
0,
513,
0,
0,
514,
516,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
319,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
534,
535,
536,
0,
573,
574,
232,
0,
0,
511,
0,
0,
339,
36,
0,
0,
0,
606,
341,
526,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
0,
0,
319,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
518,
39,
323,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
344,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
0,
543,
514,
516,
534,
535,
536,
175,
182,
0,
0,
544,
545,
546,
547,
611,
185,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
517,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
34,
0,
511,
0,
0,
261,
268,
0,
517,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
511,
0,
0,
0,
36,
0,
0,
0,
513,
0,
0,
514,
516,
34,
0,
0,
359,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
0,
0,
511,
0,
0,
0,
36,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
361,
518,
39,
42,
43,
46,
55,
0,
524,
58,
47,
0,
522,
513,
0,
0,
514,
516,
622,
0,
621,
370,
0,
623,
624,
625,
175,
182,
0,
0,
544,
545,
546,
547,
0,
0,
549,
550,
551,
552,
0,
0,
0,
553,
554,
555,
556,
557,
187,
0,
0,
164,
560,
561,
0,
191,
0,
195,
0,
0,
204,
567,
0,
0,
0,
0,
0,
0,
0,
0,
122,
0,
130,
0,
0,
0,
0,
0,
0,
0,
0,
137,
0,
214,
0,
0,
0,
0,
573,
574,
232,
0,
0,
511,
0,
0,
261,
268,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
29,
0,
0,
0,
0,
0,
0,
0,
0,
0,
513,
0,
0,
514,
516,
0,
};
static	yyTCombType *	yyTBasePtr	[yyLastReadState + 1] = {
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [38],
& yyTComb [1],
& yyTComb [115],
& yyTComb [0],
& yyTComb [2],
& yyTComb [192],
& yyTComb [0],
& yyTComb [4],
& yyTComb [269],
& yyTComb [0],
& yyTComb [6],
& yyTComb [10],
& yyTComb [0],
& yyTComb [14],
& yyTComb [0],
& yyTComb [8],
& yyTComb [0],
& yyTComb [0],
& yyTComb [346],
& yyTComb [0],
& yyTComb [15],
& yyTComb [0],
& yyTComb [0],
& yyTComb [9],
& yyTComb [0],
& yyTComb [0],
& yyTComb [423],
& yyTComb [38],
& yyTComb [16],
& yyTComb [11],
& yyTComb [0],
& yyTComb [0],
& yyTComb [500],
& yyTComb [0],
& yyTComb [12],
& yyTComb [577],
& yyTComb [0],
& yyTComb [13],
& yyTComb [654],
& yyTComb [731],
& yyTComb [0],
& yyTComb [14],
& yyTComb [0],
& yyTComb [76],
& yyTComb [806],
& yyTComb [0],
& yyTComb [0],
& yyTComb [18],
& yyTComb [0],
& yyTComb [55],
& yyTComb [0],
& yyTComb [883],
& yyTComb [0],
& yyTComb [0],
& yyTComb [936],
& yyTComb [0],
& yyTComb [977],
& yyTComb [0],
& yyTComb [12],
& yyTComb [0],
& yyTComb [48],
& yyTComb [1052],
& yyTComb [0],
& yyTComb [35],
& yyTComb [0],
& yyTComb [58],
& yyTComb [64],
& yyTComb [69],
& yyTComb [1],
& yyTComb [40],
& yyTComb [0],
& yyTComb [76],
& yyTComb [0],
& yyTComb [1097],
& yyTComb [68],
& yyTComb [69],
& yyTComb [0],
& yyTComb [0],
& yyTComb [60],
& yyTComb [0],
& yyTComb [1],
& yyTComb [2],
& yyTComb [111],
& yyTComb [67],
& yyTComb [122],
& yyTComb [0],
& yyTComb [2],
& yyTComb [3],
& yyTComb [81],
& yyTComb [82],
& yyTComb [4],
& yyTComb [0],
& yyTComb [0],
& yyTComb [83],
& yyTComb [5],
& yyTComb [34],
& yyTComb [0],
& yyTComb [90],
& yyTComb [0],
& yyTComb [91],
& yyTComb [22],
& yyTComb [6],
& yyTComb [62],
& yyTComb [7],
& yyTComb [94],
& yyTComb [54],
& yyTComb [13],
& yyTComb [48],
& yyTComb [47],
& yyTComb [0],
& yyTComb [128],
& yyTComb [130],
& yyTComb [53],
& yyTComb [134],
& yyTComb [135],
& yyTComb [0],
& yyTComb [13],
& yyTComb [114],
& yyTComb [196],
& yyTComb [0],
& yyTComb [0],
& yyTComb [146],
& yyTComb [0],
& yyTComb [148],
& yyTComb [149],
& yyTComb [15],
& yyTComb [198],
& yyTComb [189],
& yyTComb [0],
& yyTComb [150],
& yyTComb [201],
& yyTComb [151],
& yyTComb [201],
& yyTComb [0],
& yyTComb [158],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [158],
& yyTComb [0],
& yyTComb [8],
& yyTComb [0],
& yyTComb [153],
& yyTComb [11],
& yyTComb [0],
& yyTComb [1134],
& yyTComb [121],
& yyTComb [0],
& yyTComb [4],
& yyTComb [0],
& yyTComb [137],
& yyTComb [0],
& yyTComb [1211],
& yyTComb [0],
& yyTComb [0],
& yyTComb [19],
& yyTComb [0],
& yyTComb [12],
& yyTComb [0],
& yyTComb [124],
& yyTComb [0],
& yyTComb [1288],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1365],
& yyTComb [0],
& yyTComb [1442],
& yyTComb [0],
& yyTComb [0],
& yyTComb [13],
& yyTComb [0],
& yyTComb [1510],
& yyTComb [0],
& yyTComb [14],
& yyTComb [307],
& yyTComb [0],
& yyTComb [15],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1550],
& yyTComb [185],
& yyTComb [0],
& yyTComb [222],
& yyTComb [0],
& yyTComb [1627],
& yyTComb [969],
& yyTComb [217],
& yyTComb [0],
& yyTComb [222],
& yyTComb [0],
& yyTComb [225],
& yyTComb [0],
& yyTComb [1735],
& yyTComb [1778],
& yyTComb [0],
& yyTComb [235],
& yyTComb [0],
& yyTComb [229],
& yyTComb [0],
& yyTComb [229],
& yyTComb [239],
& yyTComb [1886],
& yyTComb [1923],
& yyTComb [202],
& yyTComb [0],
& yyTComb [240],
& yyTComb [0],
& yyTComb [235],
& yyTComb [0],
& yyTComb [235],
& yyTComb [200],
& yyTComb [0],
& yyTComb [0],
& yyTComb [193],
& yyTComb [0],
& yyTComb [221],
& yyTComb [0],
& yyTComb [221],
& yyTComb [191],
& yyTComb [0],
& yyTComb [276],
& yyTComb [0],
& yyTComb [0],
& yyTComb [245],
& yyTComb [1988],
& yyTComb [262],
& yyTComb [245],
& yyTComb [228],
& yyTComb [187],
& yyTComb [0],
& yyTComb [233],
& yyTComb [0],
& yyTComb [234],
& yyTComb [234],
& yyTComb [0],
& yyTComb [0],
& yyTComb [237],
& yyTComb [0],
& yyTComb [423],
& yyTComb [0],
& yyTComb [309],
& yyTComb [245],
& yyTComb [264],
& yyTComb [341],
& yyTComb [265],
& yyTComb [247],
& yyTComb [247],
& yyTComb [251],
& yyTComb [251],
& yyTComb [313],
& yyTComb [0],
& yyTComb [303],
& yyTComb [0],
& yyTComb [239],
& yyTComb [0],
& yyTComb [0],
& yyTComb [315],
& yyTComb [293],
& yyTComb [0],
& yyTComb [317],
& yyTComb [0],
& yyTComb [0],
& yyTComb [290],
& yyTComb [296],
& yyTComb [357],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [2096],
& yyTComb [461],
& yyTComb [446],
& yyTComb [0],
& yyTComb [322],
& yyTComb [381],
& yyTComb [0],
& yyTComb [387],
& yyTComb [0],
& yyTComb [295],
& yyTComb [321],
& yyTComb [0],
& yyTComb [321],
& yyTComb [322],
& yyTComb [0],
& yyTComb [2173],
& yyTComb [331],
& yyTComb [0],
& yyTComb [391],
& yyTComb [0],
& yyTComb [379],
& yyTComb [0],
& yyTComb [0],
& yyTComb [329],
& yyTComb [0],
& yyTComb [330],
& yyTComb [312],
& yyTComb [262],
& yyTComb [0],
& yyTComb [340],
& yyTComb [0],
& yyTComb [340],
& yyTComb [0],
& yyTComb [344],
& yyTComb [0],
& yyTComb [345],
& yyTComb [0],
& yyTComb [376],
& yyTComb [0],
& yyTComb [386],
& yyTComb [375],
& yyTComb [379],
& yyTComb [402],
& yyTComb [389],
& yyTComb [412],
& yyTComb [0],
& yyTComb [417],
& yyTComb [457],
& yyTComb [543],
& yyTComb [1110],
& yyTComb [2269],
& yyTComb [2344],
& yyTComb [418],
& yyTComb [0],
& yyTComb [420],
& yyTComb [0],
& yyTComb [420],
& yyTComb [422],
& yyTComb [0],
& yyTComb [424],
& yyTComb [0],
& yyTComb [449],
& yyTComb [0],
& yyTComb [451],
& yyTComb [0],
& yyTComb [454],
& yyTComb [456],
& yyTComb [0],
& yyTComb [466],
& yyTComb [439],
& yyTComb [463],
& yyTComb [0],
& yyTComb [463],
& yyTComb [466],
& yyTComb [467],
& yyTComb [469],
& yyTComb [470],
& yyTComb [0],
& yyTComb [480],
& yyTComb [414],
& yyTComb [474],
& yyTComb [475],
& yyTComb [462],
& yyTComb [467],
& yyTComb [468],
& yyTComb [2419],
& yyTComb [0],
& yyTComb [445],
& yyTComb [0],
& yyTComb [470],
& yyTComb [477],
& yyTComb [0],
& yyTComb [2444],
& yyTComb [479],
& yyTComb [0],
& yyTComb [2521],
& yyTComb [498],
& yyTComb [0],
& yyTComb [523],
& yyTComb [527],
};
static	unsigned short*	yyNBasePtr	[yyLastReadState + 1] = {
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-93],
& yyNComb [-110],
& yyNComb [-57],
& yyNComb [-110],
& yyNComb [-105],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-104],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-103],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-108],
& yyNComb [-110],
& yyNComb [-19],
& yyNComb [-110],
& yyNComb [17],
& yyNComb [35],
& yyNComb [-110],
& yyNComb [-102],
& yyNComb [-110],
& yyNComb [-101],
& yyNComb [-100],
& yyNComb [-110],
& yyNComb [43],
& yyNComb [-95],
& yyNComb [-110],
& yyNComb [-99],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [61],
& yyNComb [73],
& yyNComb [-110],
& yyNComb [96],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [133],
& yyNComb [-110],
& yyNComb [-95],
& yyNComb [-110],
& yyNComb [170],
& yyNComb [-110],
& yyNComb [189],
& yyNComb [282],
& yyNComb [-110],
& yyNComb [14],
& yyNComb [223],
& yyNComb [-110],
& yyNComb [316],
& yyNComb [-110],
& yyNComb [346],
& yyNComb [-110],
& yyNComb [365],
& yyNComb [377],
& yyNComb [-109],
& yyNComb [396],
& yyNComb [-110],
& yyNComb [427],
& yyNComb [-110],
& yyNComb [457],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [487],
& yyNComb [-110],
& yyNComb [517],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [574],
& yyNComb [-110],
& yyNComb [582],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [590],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-104],
& yyNComb [-110],
& yyNComb [-99],
& yyNComb [-110],
& yyNComb [618],
& yyNComb [-110],
& yyNComb [-103],
& yyNComb [-98],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [648],
& yyNComb [-109],
& yyNComb [636],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-108],
& yyNComb [672],
& yyNComb [-110],
& yyNComb [710],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [746],
& yyNComb [776],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-98],
& yyNComb [857],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-106],
& yyNComb [201],
& yyNComb [-110],
& yyNComb [250],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-103],
& yyNComb [-99],
& yyNComb [-67],
& yyNComb [561],
& yyNComb [-110],
& yyNComb [773],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-101],
& yyNComb [-110],
& yyNComb [839],
& yyNComb [846],
& yyNComb [-109],
& yyNComb [-110],
& yyNComb [-97],
& yyNComb [-110],
& yyNComb [961],
& yyNComb [978],
& yyNComb [-110],
& yyNComb [-92],
& yyNComb [-110],
& yyNComb [-99],
& yyNComb [-91],
& yyNComb [-110],
& yyNComb [1014],
& yyNComb [-110],
& yyNComb [1052],
& yyNComb [-110],
& yyNComb [-99],
& yyNComb [1088],
& yyNComb [-110],
& yyNComb [-90],
& yyNComb [-110],
& yyNComb [1192],
& yyNComb [-17],
& yyNComb [-13],
& yyNComb [-110],
& yyNComb [1296],
& yyNComb [-83],
& yyNComb [-110],
& yyNComb [-82],
& yyNComb [-110],
& yyNComb [1313],
& yyNComb [-78],
& yyNComb [-110],
& yyNComb [1417],
& yyNComb [1438],
& yyNComb [-76],
& yyNComb [-110],
& yyNComb [1542],
& yyNComb [-69],
& yyNComb [-110],
& yyNComb [1646],
& yyNComb [-67],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-64],
& yyNComb [1750],
& yyNComb [17],
& yyNComb [-110],
& yyNComb [1854],
& yyNComb [1958],
& yyNComb [-40],
& yyNComb [-110],
& yyNComb [2062],
& yyNComb [-110],
& yyNComb [20],
& yyNComb [-110],
& yyNComb [2137],
& yyNComb [-25],
& yyNComb [2241],
& yyNComb [-21],
& yyNComb [-110],
& yyNComb [2345],
& yyNComb [-110],
& yyNComb [23],
& yyNComb [-110],
& yyNComb [2423],
& yyNComb [-17],
& yyNComb [-19],
& yyNComb [2527],
& yyNComb [-17],
& yyNComb [-110],
& yyNComb [2631],
& yyNComb [-110],
& yyNComb [-43],
& yyNComb [954],
& yyNComb [1184],
& yyNComb [-110],
& yyNComb [-31],
& yyNComb [-110],
& yyNComb [1515],
& yyNComb [-110],
& yyNComb [25],
& yyNComb [2648],
& yyNComb [-110],
& yyNComb [2684],
& yyNComb [2722],
& yyNComb [-110],
& yyNComb [-30],
& yyNComb [2788],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [107],
& yyNComb [-28],
& yyNComb [-110],
& yyNComb [1524],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-41],
& yyNComb [-56],
& yyNComb [-110],
& yyNComb [1289],
& yyNComb [1638],
& yyNComb [-49],
& yyNComb [-45],
& yyNComb [-110],
& yyNComb [1742],
& yyNComb [-110],
& yyNComb [-11],
& yyNComb [-110],
& yyNComb [2111],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-20],
& yyNComb [50],
& yyNComb [-110],
& yyNComb [2892],
& yyNComb [-49],
& yyNComb [2909],
& yyNComb [54],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [2945],
& yyNComb [-110],
& yyNComb [-18],
& yyNComb [-17],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [138],
& yyNComb [2983],
& yyNComb [98],
& yyNComb [-110],
& yyNComb [3049],
& yyNComb [-110],
& yyNComb [59],
& yyNComb [3100],
& yyNComb [-110],
& yyNComb [-15],
& yyNComb [-110],
& yyNComb [61],
& yyNComb [11],
& yyNComb [-110],
& yyNComb [3204],
& yyNComb [-110],
& yyNComb [3255],
& yyNComb [62],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [3272],
& yyNComb [-110],
& yyNComb [3308],
& yyNComb [-110],
& yyNComb [3346],
& yyNComb [63],
& yyNComb [-110],
& yyNComb [3450],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [352],
& yyNComb [64],
& yyNComb [-110],
& yyNComb [3554],
& yyNComb [-110],
& yyNComb [66],
& yyNComb [-110],
& yyNComb [3658],
& yyNComb [-110],
& yyNComb [75],
& yyNComb [-110],
& yyNComb [3762],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [171],
& yyNComb [159],
& yyNComb [79],
& yyNComb [-110],
& yyNComb [3866],
& yyNComb [-110],
& yyNComb [1415],
& yyNComb [-106],
& yyNComb [1182],
& yyNComb [-110],
& yyNComb [-95],
& yyNComb [3944],
& yyNComb [94],
& yyNComb [-110],
& yyNComb [4048],
& yyNComb [-110],
& yyNComb [4152],
& yyNComb [95],
& yyNComb [-110],
& yyNComb [4256],
& yyNComb [-110],
& yyNComb [96],
& yyNComb [-110],
& yyNComb [4360],
& yyNComb [-110],
& yyNComb [4435],
& yyNComb [97],
& yyNComb [4496],
& yyNComb [99],
& yyNComb [-110],
& yyNComb [4600],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [4704],
& yyNComb [-110],
& yyNComb [69],
& yyNComb [101],
& yyNComb [-110],
& yyNComb [74],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [4725],
& yyNComb [-110],
& yyNComb [4761],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [109],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [111],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [-110],
& yyNComb [112],
& yyNComb [4870],
};
static	unsigned short	yyDefault	[yyLastReadState + 1] = {
0,
189,
121,
175,
0,
175,
0,
31,
0,
0,
31,
0,
0,
31,
0,
0,
0,
0,
146,
0,
87,
146,
0,
31,
0,
31,
31,
0,
242,
242,
0,
0,
0,
0,
321,
321,
71,
175,
0,
0,
175,
0,
0,
0,
175,
0,
321,
175,
121,
134,
146,
33,
175,
0,
175,
58,
321,
321,
0,
321,
266,
175,
0,
175,
0,
0,
175,
0,
175,
0,
0,
0,
0,
370,
87,
0,
87,
0,
0,
0,
242,
350,
0,
370,
350,
0,
0,
242,
0,
370,
85,
0,
0,
0,
242,
121,
175,
0,
0,
121,
175,
0,
175,
0,
0,
0,
0,
0,
0,
0,
0,
0,
175,
175,
0,
0,
0,
0,
0,
370,
229,
0,
0,
131,
134,
0,
134,
0,
136,
0,
0,
99,
134,
0,
0,
0,
0,
248,
0,
250,
242,
244,
0,
370,
350,
189,
175,
0,
370,
260,
0,
204,
0,
175,
0,
175,
350,
351,
175,
0,
370,
350,
189,
207,
204,
350,
189,
370,
260,
370,
260,
175,
370,
350,
189,
321,
370,
350,
175,
370,
350,
189,
370,
260,
0,
370,
189,
204,
350,
273,
189,
370,
350,
189,
0,
204,
350,
175,
370,
197,
370,
350,
189,
0,
370,
350,
175,
0,
370,
206,
370,
350,
189,
0,
247,
242,
242,
0,
248,
0,
250,
0,
370,
175,
0,
175,
175,
350,
0,
273,
0,
0,
242,
248,
0,
250,
0,
0,
253,
244,
0,
246,
31,
244,
0,
0,
242,
0,
0,
0,
242,
0,
0,
0,
370,
350,
189,
0,
175,
341,
0,
0,
175,
341,
281,
281,
0,
0,
312,
313,
175,
314,
350,
242,
121,
370,
273,
279,
281,
0,
315,
134,
350,
189,
0,
273,
315,
260,
315,
175,
0,
175,
0,
175,
370,
350,
189,
0,
0,
281,
370,
350,
189,
0,
370,
350,
189,
0,
370,
350,
189,
0,
0,
281,
281,
370,
350,
189,
0,
34,
131,
0,
312,
242,
206,
370,
350,
206,
0,
197,
370,
350,
197,
0,
370,
350,
189,
0,
178,
370,
178,
370,
350,
189,
0,
0,
189,
0,
351,
370,
0,
0,
0,
0,
0,
0,
0,
0,
175,
0,
175,
0,
365,
370,
260,
0,
370,
260,
0,
0,
0,
186,
};
static	unsigned char	yyLength	[yyLastReduceState - yyFirstReduceState + 1] = {
2,
1,
1,
2,
3,
1,
1,
1,
2,
1,
2,
2,
2,
6,
1,
1,
1,
1,
3,
1,
3,
1,
1,
1,
1,
1,
2,
5,
5,
3,
1,
1,
1,
1,
1,
1,
5,
4,
1,
5,
2,
6,
1,
2,
1,
1,
2,
1,
5,
2,
5,
1,
2,
2,
6,
3,
6,
7,
1,
2,
1,
5,
6,
2,
1,
1,
2,
5,
6,
2,
6,
1,
2,
1,
2,
1,
2,
5,
1,
1,
5,
1,
3,
1,
3,
1,
7,
5,
7,
5,
7,
3,
1,
1,
1,
1,
1,
1,
3,
3,
5,
6,
5,
5,
1,
1,
3,
1,
1,
5,
5,
4,
5,
5,
1,
0,
5,
8,
12,
10,
12,
9,
5,
6,
6,
1,
1,
6,
1,
2,
1,
2,
1,
1,
1,
1,
1,
8,
9,
0,
1,
1,
5,
1,
1,
3,
1,
3,
1,
3,
1,
1,
3,
3,
4,
4,
7,
5,
8,
1,
2,
5,
3,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
3,
1,
3,
1,
1,
3,
3,
0,
1,
1,
3,
1,
3,
2,
3,
2,
3,
1,
0,
1,
1,
4,
7,
1,
1,
1,
5,
4,
7,
1,
1,
1,
4,
7,
2,
3,
1,
1,
1,
1,
3,
3,
1,
1,
1,
1,
4,
3,
3,
4,
3,
2,
2,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
3,
3,
1,
1,
1,
1,
1,
4,
4,
4,
4,
4,
1,
1,
8,
3,
1,
1,
3,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
2,
3,
1,
2,
1,
};
static	yySymbolRange	yyLeftHandSide	[yyLastReduceState - yyFirstReduceState + 1] = {
219,
111,
110,
110,
110,
113,
113,
113,
113,
118,
112,
112,
112,
112,
112,
112,
112,
112,
112,
126,
126,
119,
119,
119,
119,
121,
121,
132,
132,
132,
120,
122,
122,
122,
122,
122,
123,
123,
140,
135,
135,
135,
141,
141,
143,
136,
136,
136,
144,
144,
144,
146,
146,
147,
145,
145,
145,
145,
148,
148,
149,
137,
137,
137,
152,
138,
138,
153,
153,
153,
139,
114,
114,
150,
150,
154,
154,
142,
156,
157,
151,
151,
151,
155,
155,
155,
159,
159,
159,
159,
159,
159,
159,
160,
160,
127,
127,
127,
117,
117,
117,
117,
117,
117,
165,
163,
163,
166,
167,
116,
116,
116,
116,
116,
169,
170,
115,
115,
115,
115,
115,
115,
115,
115,
115,
115,
115,
181,
173,
173,
176,
176,
182,
182,
182,
182,
182,
180,
180,
183,
183,
184,
184,
184,
171,
171,
172,
172,
186,
186,
187,
187,
128,
129,
130,
124,
124,
125,
161,
191,
191,
192,
192,
131,
193,
193,
194,
194,
190,
190,
195,
195,
133,
133,
178,
178,
178,
188,
188,
175,
175,
175,
175,
174,
174,
196,
196,
198,
198,
197,
197,
199,
199,
199,
200,
200,
189,
189,
189,
168,
168,
201,
203,
203,
203,
202,
202,
205,
205,
205,
134,
134,
134,
134,
134,
211,
210,
210,
207,
207,
207,
207,
207,
207,
207,
207,
207,
207,
207,
206,
206,
206,
206,
206,
206,
206,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
208,
212,
212,
209,
209,
209,
213,
213,
213,
213,
213,
213,
213,
213,
213,
213,
215,
216,
177,
177,
179,
179,
162,
162,
162,
162,
217,
217,
185,
185,
185,
185,
185,
185,
214,
214,
164,
218,
218,
204,
204,
158,
};
static	yySymbolRange	yyContinuation	[yyLastReadState + 1] = {
0,
83,
26,
28,
1,
28,
1,
46,
28,
1,
46,
28,
1,
46,
28,
27,
75,
28,
2,
65,
2,
34,
1,
46,
28,
46,
46,
65,
85,
85,
1,
46,
28,
34,
2,
2,
1,
2,
34,
1,
2,
34,
1,
1,
2,
34,
2,
2,
3,
2,
2,
34,
2,
34,
2,
1,
2,
2,
1,
2,
53,
2,
52,
2,
34,
12,
2,
52,
2,
34,
29,
29,
2,
60,
85,
29,
85,
1,
33,
34,
85,
10,
48,
3,
11,
2,
3,
85,
3,
3,
11,
11,
29,
29,
2,
60,
2,
29,
2,
60,
2,
29,
2,
29,
99,
2,
60,
2,
29,
72,
2,
103,
2,
2,
29,
29,
109,
29,
29,
3,
90,
60,
2,
1,
2,
29,
2,
29,
29,
2,
2,
1,
2,
29,
2,
29,
29,
2,
27,
28,
85,
28,
28,
3,
10,
83,
2,
8,
3,
0,
67,
3,
16,
2,
52,
2,
0,
68,
2,
2,
3,
10,
83,
67,
3,
0,
83,
3,
0,
3,
0,
2,
3,
10,
83,
2,
3,
10,
2,
3,
10,
83,
3,
0,
11,
3,
83,
3,
0,
83,
11,
3,
10,
83,
11,
3,
0,
55,
3,
55,
3,
10,
83,
11,
3,
0,
40,
40,
3,
40,
3,
10,
83,
11,
54,
85,
85,
54,
2,
27,
28,
28,
60,
2,
29,
2,
2,
10,
2,
90,
11,
29,
72,
2,
27,
28,
28,
29,
3,
28,
28,
85,
85,
28,
28,
28,
85,
54,
2,
27,
28,
28,
29,
3,
3,
10,
83,
78,
2,
3,
11,
26,
2,
3,
2,
2,
53,
26,
26,
2,
2,
3,
0,
2,
3,
3,
2,
3,
2,
3,
3,
2,
10,
83,
11,
11,
3,
0,
3,
2,
3,
2,
3,
2,
3,
10,
83,
11,
32,
2,
3,
10,
83,
11,
3,
10,
83,
11,
3,
10,
83,
11,
35,
48,
3,
3,
10,
83,
11,
2,
3,
2,
35,
3,
11,
3,
10,
40,
11,
11,
3,
10,
55,
11,
3,
10,
83,
11,
11,
3,
2,
3,
10,
83,
11,
11,
11,
11,
11,
3,
10,
68,
11,
11,
29,
28,
28,
53,
2,
52,
2,
34,
28,
3,
0,
28,
3,
0,
8,
0,
3,
0,
};
static	unsigned short	yyFinalToProd	[yyLastReadNontermState - yyFirstReadTermState + 1] = {
909,
910,
911,
912,
913,
914,
892,
893,
894,
833,
915,
916,
848,
859,
855,
841,
852,
918,
857,
776,
896,
860,
856,
861,
905,
858,
895,
919,
823,
829,
834,
733,
822,
862,
863,
864,
865,
866,
867,
868,
869,
870,
871,
874,
875,
876,
881,
882,
872,
873,
878,
883,
879,
877,
880,
828,
824,
830,
737,
754,
697,
769,
742,
698,
744,
743,
748,
734,
749,
750,
897,
758,
762,
759,
760,
761,
753,
755,
727,
726,
729,
728,
735,
738,
730,
724,
736,
739,
725,
740,
821,
690,
635,
686,
670,
664,
654,
665,
676,
706,
713,
756,
757,
747,
746,
766,
819,
898,
899,
787,
782,
715,
716,
712,
714,
784,
693,
694,
687,
688,
667,
639,
653,
696,
674,
683,
680,
682,
745,
849,
850,
835,
851,
634,
854,
853,
901,
902,
904,
907,
917,
908,
906,
921,
920,
827,
845,
836,
799,
837,
847,
842,
839,
843,
798,
826,
767,
771,
768,
770,
773,
772,
723,
722,
721,
732,
731,
816,
704,
705,
703,
645,
640,
641,
642,
643,
646,
647,
648,
649,
650,
657,
658,
659,
660,
661,
668,
669,
671,
673,
922,
707,
708,
692,
719,
691,
807,
808,
800,
802,
801,
751,
752,
763,
815,
810,
818,
817,
812,
814,
805,
806,
764,
780,
795,
788,
794,
786,
785,
793,
791,
790,
711,
710,
717,
720,
709,
718,
886,
884,
702,
701,
700,
699,
655,
652,
651,
656,
677,
678,
679,
672,
684,
685,
900,
885,
777,
903,
627,
628,
630,
631,
632,
633,
};

static	void	yyErrorRecovery		ARGS((yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeContinuation	ARGS((yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet));
static	bool	yyIsContinuation	ARGS((yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeRestartPoints	ARGS((yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet));
static	yyStateRange yyNext		ARGS((yyStateRange yyState, yySymbolRange yySymbol));
static	void	BeginParser		();

int Parser ()
   {
      register	yyStateRange	yyState		;
      register	long		yyTerminal	;
      register	yyStateRange *	yyStateStackPtr ;
      register	tParsAttribute *yyAttrStackPtr	;
      register	bool		yyIsRepairing	;
		unsigned long	yyStateStackSize= yyInitStackSize;
		unsigned long	yyAttrStackSize = yyInitStackSize;
		yyStateRange *	yyStateStack	;
		tParsAttribute* yyAttributeStack;
		tParsAttribute	yySynAttribute	;	/* synthesized attribute */
      register	yyStateRange *	yyEndOfStack	;
		int		yyErrorCount	= 0;
   


      BeginParser ();
      yyState		= yyStartState;
      yyTerminal	= GetToken ();

#ifdef YYDEBUG
if (yydebug)  /* SMW */
{
           printf("Reading a token: Next token is %d (%s)\n",yyTerminal,Parser_TokenName[yyTerminal]);
}
#endif

      MakeArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
      MakeArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
      yyEndOfStack	= & yyStateStack [yyStateStackSize];
      yyStateStackPtr	= yyStateStack;
      yyAttrStackPtr	= yyAttributeStack;
      yyIsRepairing	= false;

   ParseLoop:
      for (;;) {
	 if (yyStateStackPtr >= yyEndOfStack) {
	    int yyyStateStackPtr= yyStateStackPtr - yyStateStack;
	    int yyyAttrStackPtr	= yyAttrStackPtr - yyAttributeStack;
	    ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
	    ExtendArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
	    yyStateStackPtr	= yyStateStack + yyyStateStackPtr;
	    yyAttrStackPtr	= yyAttributeStack + yyyAttrStackPtr;
	    yyEndOfStack	= & yyStateStack [yyStateStackSize];
	 }
	 * yyStateStackPtr = yyState;

#ifdef YYDEBUG
  if (yydebug)      /* SMW */
  {
    yyStateRange *yys = yyStateStack;
    printf("state stack now");
    while(yys <= yyStateStackPtr) printf(" %d",*yys++);
    printf("\n");
  }
#endif

   TermTrans:
	 for (;;) {	/* SPEC State = Next (State, Terminal); terminal transition */
	    register short * yyTCombPtr;

	    yyTCombPtr = (short *) (yyTBasePtr [yyState] + yyTerminal);
	    if (* yyTCombPtr ++ == yyState) { yyState = * yyTCombPtr; break; }
	    if ((yyState = yyDefault [yyState]) != yyNoState) goto TermTrans;

							/* syntax error */
	    if (! yyIsRepairing) {			/* report and recover */
	       yySymbolRange yyyTerminal = yyTerminal;

	       yyErrorCount ++;
	       yyErrorRecovery (& yyyTerminal, yyStateStack, yyStateStackSize, yyStateStackPtr - yyStateStack);
	       yyTerminal = yyyTerminal;
	       yyIsRepairing = true;
	    }
	    yyState = * yyStateStackPtr;
	    for (;;) {
	       if (yyNext (yyState, (yySymbolRange) yyTerminal) == yyNoState) { /* repair */
		  yySymbolRange		yyRepairToken;
		  tScanAttribute	yyRepairAttribute;
	    
		  yyRepairToken = yyContinuation [yyState];
		  yyState = yyNext (yyState, yyRepairToken);
		  if (yyState <= yyLastReadTermState) { /* read or read terminal reduce ? */
		     ErrorAttribute ((int) yyRepairToken, & yyRepairAttribute);
		     ErrorMessageI (xxTokenInserted, xxRepair, Attribute.Position,
			xxString, Parser_TokenName [yyRepairToken]);
		     if (yyState >= yyFirstFinalState) {	/* avoid second push */
			yyState = yyFinalToProd [yyState - yyFirstReadTermState];
		     }
		     yyGetAttribute (yyAttrStackPtr ++, yyRepairAttribute);
		     * ++ yyStateStackPtr = yyState;
		  }
		  if (yyState >= yyFirstFinalState) goto Final; /* final state ? */
	       } else {
		  yyState = yyNext (yyState, (yySymbolRange) yyTerminal);
		  goto Final;
	       }
	    }
	 }

   Final:
	 if (yyState >= yyFirstFinalState) {		/* final state ? */
	    if (yyState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStateStackPtr ++;
	       yyGetAttribute (yyAttrStackPtr ++, Attribute);
	       yyTerminal = GetToken ();

#ifdef YYDEBUG
if (yydebug)        /* SMW */
{
  printf("Reading a token: Next token is %d (%s)\n",yyTerminal,Parser_TokenName[yyTerminal]);
}
#endif

	       yyIsRepairing = false;
	    }

	    for (;;) {
	       /* register long yyNonterminal;		/* left-hand side */
# define yyNonterminal yyState

switch (yyState) {
case 626: /* _0000_ : __START__ _EndOfFile .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 0), ");  printf("__START__ _EndOfFile  -> _0000_ \n");
}
#endif
  ReleaseArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
  ReleaseArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
  return yyErrorCount;

case 627:
case 620: /* __START__ : program .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 153), ");  printf("program  -> __START__ \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 111; {
/* line 153 "/tmp/lalr1423" */
/* line 166 "occam.lalr" */
 TreeRoot = mStart(yyAttrStackPtr [1-1].Tree); 
} break;
case 628:
case 621: /* program : proc .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 157), ");  printf("proc  -> program \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 110; {
/* line 157 "/tmp/lalr1423" */
/* line 169 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; Message("Not allowed at outermost level of compilation unit",xxError,Posn(yyAttrStackPtr [1-1]));
} break;
case 629: /* program : outerspec sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 158), ");  printf("outerspec sep  -> program \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 110; {
/* line 158 "/tmp/lalr1423" */
/* line 170 "occam.lalr" */
 yySynAttribute.Tree = mNullProcess(Posn(yyAttrStackPtr [1-1]),mNoSpec()); InsertASpec(yySynAttribute.Tree->Process.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 630:
case 622: /* program : outerspec sep program .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 160), ");  printf("outerspec sep program  -> program \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 110; {
/* line 160 "/tmp/lalr1423" */
/* line 171 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->Process.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 631:
case 623: /* outerspec : definition .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 163), ");  printf("definition  -> outerspec \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 113; {
/* line 163 "/tmp/lalr1423" */
/* line 174 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 632:
case 624: /* outerspec : abbreviation .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 166), ");  printf("abbreviation  -> outerspec \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 113; {
/* line 166 "/tmp/lalr1423" */
/* line 175 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; Message("Not allowed at outermost level of compilation unit",xxError,Posn(yyAttrStackPtr [1-1]));
} break;
case 633:
case 625: /* outerspec : declaration .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 168), ");  printf("declaration  -> outerspec \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 113; {
/* line 168 "/tmp/lalr1423" */
/* line 176 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; Message("Not allowed at outermost level of compilation unit",xxError,Posn(yyAttrStackPtr [1-1]));
} break;
case 634:
case 505: /* outerspec : HASHH CSTR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 169), ");  printf("HASHH CSTR  -> outerspec \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 113; {
/* line 169 "/tmp/lalr1423" */
/* line 177 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; yySynAttribute.Tree = mHCode(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [2-1]).String,CurrentScope()); 
} break;
case 635:
case 464: /* case : CASE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 172), ");  printf("CASE  -> case \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 118; {
/* line 172 "/tmp/lalr1423" */
/* line 180 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 636: /* proc : action sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 175), ");  printf("action sep  -> proc \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 112; {
/* line 175 "/tmp/lalr1423" */
/* line 182 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 637: /* proc : SKIP sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 177), ");  printf("SKIP sep  -> proc \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 112; {
/* line 177 "/tmp/lalr1423" */
/* line 183 "occam.lalr" */
 yySynAttribute.Tree = mSkip(Posn(yyAttrStackPtr [1-1]),mNoSpec()); 
} break;
case 638: /* proc : STOP sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 179), ");  printf("STOP sep  -> proc \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 112; {
/* line 179 "/tmp/lalr1423" */
/* line 184 "occam.lalr" */
 yySynAttribute.Tree = mStop(Posn(yyAttrStackPtr [1-1]),mNoSpec()); 
} break;
case 639:
case 493: /* proc : case selector sep BEGIN selectlist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 181), ");  printf("case selector sep BEGIN selectlist END  -> proc \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 112; {
/* line 181 "/tmp/lalr1423" */
/* line 185 "occam.lalr" */
 yySynAttribute.Tree = mCase(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,ReverseTree(yyAttrStackPtr [5-1].Tree)); CloseScope();
} break;
case 640:
case 544: /* proc : construct .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 183), ");  printf("construct  -> proc \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 112; {
/* line 183 "/tmp/lalr1423" */
/* line 186 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 641:
case 545: /* proc : instance .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 185), ");  printf("instance  -> proc \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 112; {
/* line 185 "/tmp/lalr1423" */
/* line 187 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 642:
case 546: /* proc : caseinput .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 187), ");  printf("caseinput  -> proc \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 112; {
/* line 187 "/tmp/lalr1423" */
/* line 188 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 643:
case 547: /* proc : casesingle .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 189), ");  printf("casesingle  -> proc \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 112; {
/* line 189 "/tmp/lalr1423" */
/* line 189 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 644: /* proc : HASHC CSTR sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 191), ");  printf("HASHC CSTR sep  -> proc \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 112; {
/* line 191 "/tmp/lalr1423" */
/* line 190 "occam.lalr" */
 yySynAttribute.Tree = mCCode(Posn(yyAttrStackPtr [1-1]),mNoSpec(),Val(yyAttrStackPtr [2-1]).String,CurrentScope()); 
} break;
case 645:
case 543: /* process : proc .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 194), ");  printf("proc  -> process \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 126; {
/* line 194 "/tmp/lalr1423" */
/* line 193 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 646:
case 548: /* process : specification sep process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 196), ");  printf("specification sep process  -> process \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 126; {
/* line 196 "/tmp/lalr1423" */
/* line 194 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->Process.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 647:
case 549: /* action : assignment .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 199), ");  printf("assignment  -> action \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 119; {
/* line 199 "/tmp/lalr1423" */
/* line 197 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 648:
case 550: /* action : input .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 201), ");  printf("input  -> action \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 119; {
/* line 201 "/tmp/lalr1423" */
/* line 198 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 649:
case 551: /* action : after .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 203), ");  printf("after  -> action \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 119; {
/* line 203 "/tmp/lalr1423" */
/* line 199 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 650:
case 552: /* action : output .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 205), ");  printf("output  -> action \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 119; {
/* line 205 "/tmp/lalr1423" */
/* line 200 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 651:
case 608: /* selectlist : select .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 208), ");  printf("select  -> selectlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 121; {
/* line 208 "/tmp/lalr1423" */
/* line 203 "occam.lalr" */
  yyAttrStackPtr [1-1].Tree->AChoice.Next= mNoChoice(); CloseScope(); OpenScope(); 
} break;
case 652:
case 607: /* selectlist : selectlist select .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 210), ");  printf("selectlist select  -> selectlist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 121; {
/* line 210 "/tmp/lalr1423" */
/* line 204 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yyAttrStackPtr [2-1].Tree->AChoice.Next= yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 653:
case 494: /* select : explist sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 213), ");  printf("explist sep BEGIN process END  -> select \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 132; {
/* line 213 "/tmp/lalr1423" */
/* line 208 "occam.lalr" */
 yySynAttribute.Tree = mAChoice(mNoSpec(),NoTree,ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [4-1].Tree); 
} break;
case 654:
case 468: /* select : ELSE sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 215), ");  printf("ELSE sep BEGIN process END  -> select \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 132; {
/* line 215 "/tmp/lalr1423" */
/* line 209 "occam.lalr" */
 yySynAttribute.Tree = mAChoice(mNoSpec(),NoTree,mAnExpr(mNoExpr(),mDefault(Posn(yyAttrStackPtr [1-1]))),yyAttrStackPtr [4-1].Tree); 
} break;
case 655:
case 606: /* select : specification sep select .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 217), ");  printf("specification sep select  -> select \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 132; {
/* line 217 "/tmp/lalr1423" */
/* line 210 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->AChoice.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 656:
case 609: /* selector : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 220), ");  printf("expr  -> selector \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 120; {
/* line 220 "/tmp/lalr1423" */
/* line 213 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 657:
case 553: /* construct : sequence .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 223), ");  printf("sequence  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 122; {
/* line 223 "/tmp/lalr1423" */
/* line 217 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 658:
case 554: /* construct : parallel .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 225), ");  printf("parallel  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 122; {
/* line 225 "/tmp/lalr1423" */
/* line 218 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 659:
case 555: /* construct : conditional .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 227), ");  printf("conditional  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 122; {
/* line 227 "/tmp/lalr1423" */
/* line 219 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 660:
case 556: /* construct : alternation .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 229), ");  printf("alternation  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 122; {
/* line 229 "/tmp/lalr1423" */
/* line 220 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 661:
case 557: /* construct : loop .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 231), ");  printf("loop  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 122; {
/* line 231 "/tmp/lalr1423" */
/* line 221 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 662: /* instance : ID LP explist RP sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 234), ");  printf("ID LP explist RP sep  -> instance \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 123; {
/* line 234 "/tmp/lalr1423" */
/* line 225 "occam.lalr" */
 yySynAttribute.Tree = mInstance(Posn(yyAttrStackPtr [1-1]),mNoSpec(), LookupSymbol(yyAttrStackPtr [1-1].Scan),ReverseTree(yyAttrStackPtr [3-1].Tree),CurrentScope()); 
} break;
case 663: /* instance : ID LP RP sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 236), ");  printf("ID LP RP sep  -> instance \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 123; {
/* line 236 "/tmp/lalr1423" */
/* line 226 "occam.lalr" */
 yySynAttribute.Tree = mInstance(Posn(yyAttrStackPtr [1-1]),mNoSpec(), LookupSymbol(yyAttrStackPtr [1-1].Scan),mNoExpr(),CurrentScope()); 
} break;
case 664:
case 467: /* seq : SEQ .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 239), ");  printf("SEQ  -> seq \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 140; {
/* line 239 "/tmp/lalr1423" */
/* line 229 "occam.lalr" */
 OpenScope(); yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 665:
case 469: /* sequence : seq sep BEGIN proclist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 242), ");  printf("seq sep BEGIN proclist END  -> sequence \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 135; {
/* line 242 "/tmp/lalr1423" */
/* line 232 "occam.lalr" */
 yySynAttribute.Tree = mSeq(Posn(yyAttrStackPtr [1-1]),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); 
} break;
case 666: /* sequence : seq sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 244), ");  printf("seq sep  -> sequence \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 135; {
/* line 244 "/tmp/lalr1423" */
/* line 233 "occam.lalr" */
 yySynAttribute.Tree = mSeq(Posn(yyAttrStackPtr [1-1]),mNoSpec(),mNoProcess()); CloseScope(); 
} break;
case 667:
case 492: /* sequence : seq replic sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 246), ");  printf("seq replic sep BEGIN process END  -> sequence \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 135; {
/* line 246 "/tmp/lalr1423" */
/* line 234 "occam.lalr" */
 yySynAttribute.Tree = mSeqRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree); CloseScope(); 
} break;
case 668:
case 558: /* proclist : process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 249), ");  printf("process  -> proclist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 141; {
/* line 249 "/tmp/lalr1423" */
/* line 237 "occam.lalr" */
 yySynAttribute.Tree = mAProcess(mNoProcess(),yyAttrStackPtr [1-1].Tree,NoSymbol); CloseScope(); OpenScope(); 
} break;
case 669:
case 559: /* proclist : proclist process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 251), ");  printf("proclist process  -> proclist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 141; {
/* line 251 "/tmp/lalr1423" */
/* line 238 "occam.lalr" */
 yySynAttribute.Tree = mAProcess(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree,NoSymbol); CloseScope(); OpenScope(); 
} break;
case 670:
case 466: /* par : PAR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 254), ");  printf("PAR  -> par \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 143; {
/* line 254 "/tmp/lalr1423" */
/* line 241 "occam.lalr" */
 OpenScope(); OpenScope(); yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 671:
case 560: /* parallel : partype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 257), ");  printf("partype  -> parallel \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 136; {
/* line 257 "/tmp/lalr1423" */
/* line 244 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 672:
case 613: /* parallel : PRI partype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 259), ");  printf("PRI partype  -> parallel \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 136; {
/* line 259 "/tmp/lalr1423" */
/* line 245 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [2-1]; ParType(yySynAttribute.Tree) = xxPriPar; 
} break;
case 673:
case 561: /* parallel : placedpar .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 261), ");  printf("placedpar  -> parallel \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 136; {
/* line 261 "/tmp/lalr1423" */
/* line 246 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 674:
case 496: /* partype : par sep BEGIN parproclist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 264), ");  printf("par sep BEGIN parproclist END  -> partype \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 144; {
/* line 264 "/tmp/lalr1423" */
/* line 249 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPar,ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); CloseScope(); 
} break;
case 675: /* partype : par sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 266), ");  printf("par sep  -> partype \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 144; {
/* line 266 "/tmp/lalr1423" */
/* line 250 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPar,mNoProcess()); CloseScope(); CloseScope(); 
} break;
case 676:
case 470: /* partype : parrep sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 268), ");  printf("parrep sep BEGIN process END  -> partype \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 144; {
/* line 268 "/tmp/lalr1423" */
/* line 251 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mParRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPar,yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); CloseScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 677:
case 610: /* parproclist : process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 271), ");  printf("process  -> parproclist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 146; {
/* line 271 "/tmp/lalr1423" */
/* line 254 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(mNoProcess(),yyAttrStackPtr [1-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 678:
case 611: /* parproclist : parproclist process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 273), ");  printf("parproclist process  -> parproclist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 146; {
/* line 273 "/tmp/lalr1423" */
/* line 255 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 679:
case 612: /* parrep : par replic .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 276), ");  printf("par replic  -> parrep \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 147; {
/* line 276 "/tmp/lalr1423" */
/* line 258 "occam.lalr" */
 OpenScope(); S=AddSymbol(NoIdent); yySynAttribute.Tree=yyAttrStackPtr [2-1].Tree; yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; 
} break;
case 680:
case 498: /* placedpar : PLACED par sep BEGIN placedlist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 279), ");  printf("PLACED par sep BEGIN placedlist END  -> placedpar \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 145; {
/* line 279 "/tmp/lalr1423" */
/* line 262 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPlacedPar,ReverseTree(yyAttrStackPtr [5-1].Tree)); CloseScope(); CloseScope(); 
} break;
case 681: /* placedpar : PLACED par sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 281), ");  printf("PLACED par sep  -> placedpar \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 145; {
/* line 281 "/tmp/lalr1423" */
/* line 263 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPlacedPar,mNoProcess()); CloseScope(); CloseScope(); 
} break;
case 682:
case 499: /* placedpar : PLACED parrep sep BEGIN placedpar END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 283), ");  printf("PLACED parrep sep BEGIN placedpar END  -> placedpar \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 145; {
/* line 283 "/tmp/lalr1423" */
/* line 264 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mParRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPlacedPar,yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); CloseScope(); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 683:
case 497: /* placedpar : PROCESSOR expr ID sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 285), ");  printf("PROCESSOR expr ID sep BEGIN process END  -> placedpar \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 145; {
/* line 285 "/tmp/lalr1423" */
/* line 265 "occam.lalr" */
 yySynAttribute.Tree = mProcessor(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,Val(yyAttrStackPtr [3-1]).Ident,yyAttrStackPtr [6-1].Tree); 
} break;
case 684:
case 614: /* placedlist : placedpar .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 288), ");  printf("placedpar  -> placedlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 148; {
/* line 288 "/tmp/lalr1423" */
/* line 268 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(mNoProcess(),yyAttrStackPtr [1-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 685:
case 615: /* placedlist : placedlist placedpar .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 290), ");  printf("placedlist placedpar  -> placedlist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 148; {
/* line 290 "/tmp/lalr1423" */
/* line 269 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 686:
case 465: /* if : IF .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 293), ");  printf("IF  -> if \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 149; {
/* line 293 "/tmp/lalr1423" */
/* line 272 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 687:
case 490: /* conditional : if sep BEGIN choicelist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 296), ");  printf("if sep BEGIN choicelist END  -> conditional \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 137; {
/* line 296 "/tmp/lalr1423" */
/* line 274 "occam.lalr" */
 yySynAttribute.Tree = mIf(Posn(yyAttrStackPtr [1-1]),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); 
} break;
case 688:
case 491: /* conditional : if replic sep BEGIN choice END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 298), ");  printf("if replic sep BEGIN choice END  -> conditional \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 137; {
/* line 298 "/tmp/lalr1423" */
/* line 275 "occam.lalr" */
 yySynAttribute.Tree = mIfRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree); yyAttrStackPtr [5-1].Tree->AChoice.Next=mNoChoice(); CloseScope(); 
} break;
case 689: /* conditional : if sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 300), ");  printf("if sep  -> conditional \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 137; {
/* line 300 "/tmp/lalr1423" */
/* line 276 "occam.lalr" */
 yySynAttribute.Tree = mIf(Posn(yyAttrStackPtr [1-1]),mNoSpec(),mNoChoice()); CloseScope(); 
} break;
case 690:
case 463: /* alt : ALT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 303), ");  printf("ALT  -> alt \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 152; {
/* line 303 "/tmp/lalr1423" */
/* line 279 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 691:
case 567: /* alternation : alttype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 306), ");  printf("alttype  -> alternation \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 138; {
/* line 306 "/tmp/lalr1423" */
/* line 282 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 692:
case 565: /* alternation : PRI alttype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 308), ");  printf("PRI alttype  -> alternation \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 138; {
/* line 308 "/tmp/lalr1423" */
/* line 283 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [2-1]; AltIsPri(yySynAttribute.Tree) = true; 
} break;
case 693:
case 488: /* alttype : alt sep BEGIN alternativelist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 311), ");  printf("alt sep BEGIN alternativelist END  -> alttype \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 153; {
/* line 311 "/tmp/lalr1423" */
/* line 286 "occam.lalr" */
 yySynAttribute.Tree = mAlt(Posn(yyAttrStackPtr [1-1]),mNoSpec(),false,ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); 
} break;
case 694:
case 489: /* alttype : alt replic sep BEGIN alternative END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 313), ");  printf("alt replic sep BEGIN alternative END  -> alttype \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 153; {
/* line 313 "/tmp/lalr1423" */
/* line 287 "occam.lalr" */
 yySynAttribute.Tree = mAltRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),false,yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree); yyAttrStackPtr [5-1].Tree->AnAlts.Next = mNoAlt(); CloseScope(); 
} break;
case 695: /* alttype : alt sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 315), ");  printf("alt sep  -> alttype \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 153; {
/* line 315 "/tmp/lalr1423" */
/* line 288 "occam.lalr" */
 yySynAttribute.Tree = mAlt(Posn(yyAttrStackPtr [1-1]),mNoSpec(),false,mNoAlt()); CloseScope(); 
} break;
case 696:
case 495: /* loop : WHILE expr sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 318), ");  printf("WHILE expr sep BEGIN process END  -> loop \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 139; {
/* line 318 "/tmp/lalr1423" */
/* line 292 "occam.lalr" */
 yySynAttribute.Tree = mWhile(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [5-1].Tree); 
} break;
case 697:
case 432: /* sep : EOL .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 321), ");  printf("EOL  -> sep \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 114; {
/* line 321 "/tmp/lalr1423" */
/* line 296 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 698:
case 435: /* sep : sep EOL .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 323), ");  printf("sep EOL  -> sep \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 114; {
/* line 323 "/tmp/lalr1423" */
/* line 297 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 699:
case 605: /* choicelist : choice .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 326), ");  printf("choice  -> choicelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 326 "/tmp/lalr1423" */
/* line 300 "occam.lalr" */
 yySynAttribute.Tree->AChoices.Next = mNoChoice(); CloseScope(); OpenScope();
} break;
case 700:
case 604: /* choicelist : choicelist choice .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 328), ");  printf("choicelist choice  -> choicelist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 150; {
/* line 328 "/tmp/lalr1423" */
/* line 301 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yySynAttribute.Tree->AChoices.Next=yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 701:
case 603: /* alternativelist : alternative .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 331), ");  printf("alternative  -> alternativelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 154; {
/* line 331 "/tmp/lalr1423" */
/* line 305 "occam.lalr" */
  yySynAttribute.Tree->AnAlts.Next = mNoAlt() ; CloseScope(); OpenScope(); 
} break;
case 702:
case 602: /* alternativelist : alternativelist alternative .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 333), ");  printf("alternativelist alternative  -> alternativelist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 154; {
/* line 333 "/tmp/lalr1423" */
/* line 306 "occam.lalr" */
 yySynAttribute.Scan =yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yySynAttribute.Tree->AnAlts.Next = yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 703:
case 542: /* replic : ID EQ base FOR count .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 336), ");  printf("ID EQ base FOR count  -> replic \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 142; {
/* line 336 "/tmp/lalr1423" */
/* line 309 "occam.lalr" */
  yySynAttribute.Tree = mReplicator(S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=mInt(); 
} break;
case 704:
case 540: /* base : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 339), ");  printf("expr  -> base \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 156; {
/* line 339 "/tmp/lalr1423" */
/* line 312 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 705:
case 541: /* count : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 342), ");  printf("expr  -> count \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 157; {
/* line 342 "/tmp/lalr1423" */
/* line 315 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 706:
case 471: /* choice : boolean sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 345), ");  printf("boolean sep BEGIN process END  -> choice \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 151; {
/* line 345 "/tmp/lalr1423" */
/* line 318 "occam.lalr" */
 yySynAttribute.Tree = mAChoice(mNoSpec(),NoTree,mAnExpr(mNoExpr(),yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [4-1].Tree);
} break;
case 707:
case 563: /* choice : conditional .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 347), ");  printf("conditional  -> choice \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 151; {
/* line 347 "/tmp/lalr1423" */
/* line 319 "occam.lalr" */
 yySynAttribute.Tree = mANewIf(mNoSpec(),NoTree,yyAttrStackPtr [1-1].Tree);
} break;
case 708:
case 564: /* choice : specification sep choice .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 349), ");  printf("specification sep choice  -> choice \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 151; {
/* line 349 "/tmp/lalr1423" */
/* line 320 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->AChoice.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 709:
case 598: /* alternative : guard .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 352), ");  printf("guard  -> alternative \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 352 "/tmp/lalr1423" */
/* line 324 "occam.lalr" */
 yySynAttribute.Tree = mAnAlt(mNoSpec(),NoTree,yyAttrStackPtr [1-1].Tree); 
} break;
case 710:
case 595: /* alternative : specification sep alternative .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 354), ");  printf("specification sep alternative  -> alternative \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 155; {
/* line 354 "/tmp/lalr1423" */
/* line 325 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->AnAlt.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 711:
case 594: /* alternative : alternation .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 356), ");  printf("alternation  -> alternative \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 356 "/tmp/lalr1423" */
/* line 326 "occam.lalr" */
 yySynAttribute.Tree = mANewAlt(mNoSpec(),NoTree,yyAttrStackPtr [1-1].Tree); 
} break;
case 712:
case 485: /* guard : boolean AMPERSAND input sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 359), ");  printf("boolean AMPERSAND input sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 159; {
/* line 359 "/tmp/lalr1423" */
/* line 329 "occam.lalr" */
 yySynAttribute.Tree = mAltInput(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [6-1].Tree);
} break;
case 713:
case 472: /* guard : input sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 361), ");  printf("input sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 159; {
/* line 361 "/tmp/lalr1423" */
/* line 330 "occam.lalr" */
 yySynAttribute.Tree = mAltInput(Posn(yyAttrStackPtr [1-1]),mConst(Posn(yyAttrStackPtr [1-1]),Vtrue,mBool()),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree);
} break;
case 714:
case 486: /* guard : boolean AMPERSAND after sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 363), ");  printf("boolean AMPERSAND after sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 159; {
/* line 363 "/tmp/lalr1423" */
/* line 331 "occam.lalr" */
 yySynAttribute.Tree = mAltTimer(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [6-1].Tree);
} break;
case 715:
case 483: /* guard : after sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 365), ");  printf("after sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 159; {
/* line 365 "/tmp/lalr1423" */
/* line 332 "occam.lalr" */
 yySynAttribute.Tree = mAltTimer(Posn(yyAttrStackPtr [1-1]),mConst(Posn(yyAttrStackPtr [1-1]),Vtrue,mBool()),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree);
} break;
case 716:
case 484: /* guard : boolean AMPERSAND SKIP sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 367), ");  printf("boolean AMPERSAND SKIP sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 159; {
/* line 367 "/tmp/lalr1423" */
/* line 333 "occam.lalr" */
 yySynAttribute.Tree = mNoInput(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [6-1].Tree);
} break;
case 717:
case 596: /* guard : boolean AMPERSAND caseguard .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 369), ");  printf("boolean AMPERSAND caseguard  -> guard \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 159; {
/* line 369 "/tmp/lalr1423" */
/* line 334 "occam.lalr" */
 yySynAttribute.Tree = mAltCaseIn(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree);
} break;
case 718:
case 599: /* guard : caseguard .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 371), ");  printf("caseguard  -> guard \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 159; {
/* line 371 "/tmp/lalr1423" */
/* line 335 "occam.lalr" */
 yySynAttribute.Tree = mAltCaseIn(Posn(yyAttrStackPtr [1-1]),mConst(Posn(yyAttrStackPtr [1-1]),Vtrue,mBool()),yyAttrStackPtr [1-1].Tree);
} break;
case 719:
case 566: /* caseguard : caseinput .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 374), ");  printf("caseinput  -> caseguard \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 160; {
/* line 374 "/tmp/lalr1423" */
/* line 338 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 720:
case 597: /* caseguard : casesingleproc .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 376), ");  printf("casesingleproc  -> caseguard \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 160; {
/* line 376 "/tmp/lalr1423" */
/* line 339 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 721:
case 536: /* specification : declaration .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 379), ");  printf("declaration  -> specification \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 127; {
/* line 379 "/tmp/lalr1423" */
/* line 342 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 722:
case 535: /* specification : abbreviation .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 381), ");  printf("abbreviation  -> specification \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 127; {
/* line 381 "/tmp/lalr1423" */
/* line 343 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 723:
case 534: /* specification : definition .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 383), ");  printf("definition  -> specification \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 127; {
/* line 383 "/tmp/lalr1423" */
/* line 344 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 724:
case 457: /* declaration : primtype namelist COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 386), ");  printf("primtype namelist COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 117; {
/* line 386 "/tmp/lalr1423" */
/* line 347 "occam.lalr" */
 yySynAttribute.Tree = mDecl(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,T=ReverseTree(yyAttrStackPtr [2-1].Tree)); TypeDecl(yyAttrStackPtr [1-1].Tree,T); 
} break;
case 725:
case 460: /* declaration : arrtype namelist COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 388), ");  printf("arrtype namelist COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 117; {
/* line 388 "/tmp/lalr1423" */
/* line 348 "occam.lalr" */
 yySynAttribute.Tree = mDecl(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,T=ReverseTree(yyAttrStackPtr [2-1].Tree)); TypeDecl(yyAttrStackPtr [1-1].Tree,T); 
} break;
case 726:
case 451: /* declaration : PLACE ID AT expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 391), ");  printf("PLACE ID AT expr COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 117; {
/* line 391 "/tmp/lalr1423" */
/* line 349 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Variable placement not allowed",xxError,Posn(yyAttrStackPtr [1-1])); 
} break;
case 727:
case 450: /* declaration : PLACE ID AT WORKSPACE expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 393), ");  printf("PLACE ID AT WORKSPACE expr COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 117; {
/* line 393 "/tmp/lalr1423" */
/* line 350 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Ignored variable placement",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 728:
case 453: /* declaration : PLACE ID IN VECSPACE COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 395), ");  printf("PLACE ID IN VECSPACE COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 117; {
/* line 395 "/tmp/lalr1423" */
/* line 351 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Ignored variable placement",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 729:
case 452: /* declaration : PLACE ID IN WORKSPACE COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 397), ");  printf("PLACE ID IN WORKSPACE COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 117; {
/* line 397 "/tmp/lalr1423" */
/* line 352 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Ignored variable placement",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 730:
case 456: /* name : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 399), ");  printf("ID  -> name \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 165; {
/* line 399 "/tmp/lalr1423" */
/* line 355 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 731:
case 538: /* namelist : name .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 402), ");  printf("name  -> namelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 163; {
/* line 402 "/tmp/lalr1423" */
/* line 356 "occam.lalr" */
 if (last_type_was_chan) S=AddChanSymbol(Val(yyAttrStackPtr [1-1]).Ident); else S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident); yySynAttribute.Tree = mAnId(mNoId(),S); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 732:
case 537: /* namelist : namelist DECLCOMMA name .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 404), ");  printf("namelist DECLCOMMA name  -> namelist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 163; {
/* line 404 "/tmp/lalr1423" */
/* line 357 "occam.lalr" */
 if (last_type_was_chan) S=AddChanSymbol(Val(yyAttrStackPtr [3-1]).Ident); else S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident); yySynAttribute.Tree = mAnId(yyAttrStackPtr [1-1].Tree,S); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 733:
case 403: /* is : IS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 407), ");  printf("IS  -> is \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 166; {
/* line 407 "/tmp/lalr1423" */
/* line 360 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; colon_ended=false; 
} break;
case 734:
case 439: /* retypes : RETYPES .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 410), ");  printf("RETYPES  -> retypes \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 167; {
/* line 410 "/tmp/lalr1423" */
/* line 363 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; colon_ended=false; 
} break;
case 735:
case 454: /* abbreviation : primtype ID is elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 413), ");  printf("primtype ID is elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 116; {
/* line 413 "/tmp/lalr1423" */
/* line 367 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIs(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 736:
case 458: /* abbreviation : arrtype ID is elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 415), ");  printf("arrtype ID is elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 116; {
/* line 415 "/tmp/lalr1423" */
/* line 369 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIs(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 737:
case 430: /* abbreviation : ID is elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 417), ");  printf("ID is elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 116; {
/* line 417 "/tmp/lalr1423" */
/* line 371 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIs(Posn(yyAttrStackPtr [1-1]),mUntyped(),S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),yyAttrStackPtr [3-1].Tree); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 738:
case 455: /* abbreviation : primtype ID retypes elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 419), ");  printf("primtype ID retypes elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 116; {
/* line 419 "/tmp/lalr1423" */
/* line 373 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRetypes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree; 
} break;
case 739:
case 459: /* abbreviation : arrtype ID retypes elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 421), ");  printf("arrtype ID retypes elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 116; {
/* line 421 "/tmp/lalr1423" */
/* line 375 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRetypes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 740:
case 461: /* id : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 424), ");  printf("ID  -> id \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 169; {
/* line 424 "/tmp/lalr1423" */
/* line 378 "occam.lalr" */
 Val(yySynAttribute).Ident = Val(yyAttrStackPtr [1-1]).Ident; OpenScope(); colon_ended=false; 
} break;
case 741: /* pushtok : .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 427), ");  printf(" -> pushtok \n");
}
#endif
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 170; {
/* line 427 "/tmp/lalr1423" */
/* line 382 "occam.lalr" */
 OpenScope(); PushTokenColumn(); 
} break;
case 742:
case 434: /* definition : PROTOCOL ID IS seqproto COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 430), ");  printf("PROTOCOL ID IS seqproto COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 115; {
/* line 430 "/tmp/lalr1423" */
/* line 385 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDefSeqPro(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),ReverseTree(yyAttrStackPtr [4-1].Tree)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 743:
case 437: /* definition : PROTOCOL ID sep BEGIN CASE sep END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 432), ");  printf("PROTOCOL ID sep BEGIN CASE sep END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 115; {
/* line 432 "/tmp/lalr1423" */
/* line 387 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDefTagPro(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),mNoTagPro()); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 744:
case 436: /* definition : PROTOCOL ID sep BEGIN CASE sep BEGIN tagprotolist sep END END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 434), ");  printf("PROTOCOL ID sep BEGIN CASE sep BEGIN tagprotolist sep END END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=12; yyAttrStackPtr -=12; yyNonterminal = 115; {
/* line 434 "/tmp/lalr1423" */
/* line 389 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDefTagPro(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),ReverseTree(yyAttrStackPtr [8-1].Tree)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 745:
case 500: /* definition : procedure id LP O_fparmlist RP sep BEGIN process END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 436), ");  printf("procedure id LP O_fparmlist RP sep BEGIN process END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=10; yyAttrStackPtr -=10; yyNonterminal = 115; {
/* line 436 "/tmp/lalr1423" */
/* line 391 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mDefProc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree,yyAttrStackPtr [8-1].Tree); SymbolKind(S)=yySynAttribute.Tree; TypeFormals(yyAttrStackPtr [4-1].Tree);
} break;
case 746:
case 476: /* definition : typelist function id LP O_fparmlist RP sep BEGIN pushtok valof END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 438), ");  printf("typelist function id LP O_fparmlist RP sep BEGIN pushtok valof END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=12; yyAttrStackPtr -=12; yyNonterminal = 115; {
/* line 438 "/tmp/lalr1423" */
/* line 393 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mDefFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [5-1].Tree,yyAttrStackPtr [10-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [5-1].Tree); yyAttrStackPtr [10-1].Tree->Valof.Sym=S; 
} break;
case 747:
case 475: /* definition : typelist function id LP O_fparmlist RP IS isexplist COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 440), ");  printf("typelist function id LP O_fparmlist RP IS isexplist COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 115; {
/* line 440 "/tmp/lalr1423" */
/* line 395 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mDefIsFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [5-1].Tree,ReverseTree(yyAttrStackPtr [8-1].Tree)); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [5-1].Tree);
} break;
case 748:
case 438: /* definition : VAL ID is expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 442), ");  printf("VAL ID is expr COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 115; {
/* line 442 "/tmp/lalr1423" */
/* line 397 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mVal(Posn(yyAttrStackPtr [1-1]),mUntyped(),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 749:
case 440: /* definition : VAL spectype ID is expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 444), ");  printf("VAL spectype ID is expr COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 115; {
/* line 444 "/tmp/lalr1423" */
/* line 399 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mVal(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [2-1].Tree;
} break;
case 750:
case 441: /* definition : VAL spectype ID retypes expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 446), ");  printf("VAL spectype ID retypes expr COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 115; {
/* line 446 "/tmp/lalr1423" */
/* line 401 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mValRetypes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [2-1].Tree;
} break;
case 751:
case 573: /* definition : prototype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 448), ");  printf("prototype  -> definition \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 115; {
/* line 448 "/tmp/lalr1423" */
/* line 403 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CHK_Mode(xxPrototype,Posn(yyAttrStackPtr [1-1])); yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 752:
case 574: /* definition : userdatatype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 450), ");  printf("userdatatype  -> definition \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 115; {
/* line 450 "/tmp/lalr1423" */
/* line 405 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 753:
case 448: /* userdatatype : DATA TYPE ID IS ID COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 453), ");  printf("DATA TYPE ID IS ID COLON  -> userdatatype \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 181; {
/* line 453 "/tmp/lalr1423" */
/* line 409 "occam.lalr" */
 
} break;
case 754:
case 431: /* procedure : PROC .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 456), ");  printf("PROC  -> procedure \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 173; {
/* line 456 "/tmp/lalr1423" */
/* line 412 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
} break;
case 755:
case 449: /* procedure : INLINE PROC .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 458), ");  printf("INLINE PROC  -> procedure \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 173; {
/* line 458 "/tmp/lalr1423" */
/* line 413 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
} break;
case 756:
case 473: /* function : FUNCTION .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 461), ");  printf("FUNCTION  -> function \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 176; {
/* line 461 "/tmp/lalr1423" */
/* line 416 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
} break;
case 757:
case 474: /* function : INLINE FUNCTION .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 463), ");  printf("INLINE FUNCTION  -> function \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 176; {
/* line 463 "/tmp/lalr1423" */
/* line 417 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
} break;
case 758:
case 443: /* LANG : EXTERN_OCCAM .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 466), ");  printf("EXTERN_OCCAM  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 182; {
/* line 466 "/tmp/lalr1423" */
/* line 421 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxOccam; 
} break;
case 759:
case 445: /* LANG : EXTERN_F90 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 468), ");  printf("EXTERN_F90  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 182; {
/* line 468 "/tmp/lalr1423" */
/* line 423 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxF90; ADD_Mode(xxCallF90); 
} break;
case 760:
case 446: /* LANG : EXTERN_F77 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 470), ");  printf("EXTERN_F77  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 182; {
/* line 470 "/tmp/lalr1423" */
/* line 425 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxF77; 
} break;
case 761:
case 447: /* LANG : EXTERN_C .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 472), ");  printf("EXTERN_C  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 182; {
/* line 472 "/tmp/lalr1423" */
/* line 427 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxC; 
} break;
case 762:
case 444: /* LANG : EXTERN_ATOMIC .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 474), ");  printf("EXTERN_ATOMIC  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 182; {
/* line 474 "/tmp/lalr1423" */
/* line 429 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxAtomicOccam; 
} break;
case 763:
case 575: /* prototype : LANG PROC id LP O_fparmlist RP COLON proto_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 477), ");  printf("LANG PROC id LP O_fparmlist RP COLON proto_id  -> prototype \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 180; {
/* line 477 "/tmp/lalr1423" */
/* line 434 "occam.lalr" */
 CloseScope(); yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPrototypeProc(Posn(yyAttrStackPtr [2-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree,Val(yyAttrStackPtr [8-1]).Ident,Val(yyAttrStackPtr [1-1]).Number); SymbolKind(S)=yySynAttribute.Tree; TypeFormals(yyAttrStackPtr [5-1].Tree);
} break;
case 764:
case 584: /* prototype : LANG typelist FUNCTION id LP O_fparmlist RP COLON proto_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 479), ");  printf("LANG typelist FUNCTION id LP O_fparmlist RP COLON proto_id  -> prototype \n");
}
#endif
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 180; {
/* line 479 "/tmp/lalr1423" */
/* line 436 "occam.lalr" */
 CloseScope(); yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPrototypeFunc(Posn(yyAttrStackPtr [2-1]),S=AddSymbol(Val(yyAttrStackPtr [4-1]).Ident),T=ReverseTree(yyAttrStackPtr [2-1].Tree),yyAttrStackPtr [6-1].Tree,Val(yyAttrStackPtr [9-1]).Ident,Val(yyAttrStackPtr [1-1]).Number); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [6-1].Tree);
} break;
case 765: /* proto_id : .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 482), ");  printf(" -> proto_id \n");
}
#endif
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 183; {
/* line 482 "/tmp/lalr1423" */
/* line 440 "occam.lalr" */
 Val(yySynAttribute).Ident = NoIdent; 
} break;
case 766:
case 477: /* proto_id : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 484), ");  printf("ID  -> proto_id \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 183; {
/* line 484 "/tmp/lalr1423" */
/* line 442 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 767:
case 528: /* simpleproto : spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 487), ");  printf("spectype  -> simpleproto \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 184; {
/* line 487 "/tmp/lalr1423" */
/* line 445 "occam.lalr" */
  yySynAttribute.Tree = mSimple(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 768:
case 530: /* simpleproto : inttype DCOLON LSB RSB spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 489), ");  printf("inttype DCOLON LSB RSB spectype  -> simpleproto \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 184; {
/* line 489 "/tmp/lalr1423" */
/* line 446 "occam.lalr" */
  yySynAttribute.Tree = mCounted(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,mArray(mUnBound(Posn(yyAttrStackPtr [4-1])),yyAttrStackPtr [5-1].Tree)); 
} break;
case 769:
case 433: /* simpleproto : ANY .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 491), ");  printf("ANY  -> simpleproto \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 184; {
/* line 491 "/tmp/lalr1423" */
/* line 447 "occam.lalr" */
  yySynAttribute.Tree = mAny(Posn(yyAttrStackPtr [1-1])); 
} break;
case 770:
case 531: /* seqproto : simpleproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 494), ");  printf("simpleproto  -> seqproto \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 171; {
/* line 494 "/tmp/lalr1423" */
/* line 451 "occam.lalr" */
  yySynAttribute.Tree = mASeqPro(mNoSeqPro(),yyAttrStackPtr [1-1].Tree); 
} break;
case 771:
case 529: /* seqproto : seqproto SEMICOLON simpleproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 496), ");  printf("seqproto SEMICOLON simpleproto  -> seqproto \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 171; {
/* line 496 "/tmp/lalr1423" */
/* line 452 "occam.lalr" */
  yySynAttribute.Tree = mASeqPro(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 772:
case 533: /* tagprotolist : tagproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 499), ");  printf("tagproto  -> tagprotolist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 172; {
/* line 499 "/tmp/lalr1423" */
/* line 456 "occam.lalr" */
  yySynAttribute.Tree->ATagPro.Next = mNoTagPro(); 
} break;
case 773:
case 532: /* tagprotolist : tagprotolist sep tagproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 501), ");  printf("tagprotolist sep tagproto  -> tagprotolist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 172; {
/* line 501 "/tmp/lalr1423" */
/* line 457 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree ; yySynAttribute.Tree->ATagPro.Next = yyAttrStackPtr [1-1].Tree; 
} break;
case 774: /* tagproto : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 504), ");  printf("ID  -> tagproto \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 186; {
/* line 504 "/tmp/lalr1423" */
/* line 461 "occam.lalr" */
  yySynAttribute.Tree = mATagPro(NoTree,S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),mNoSeqPro()); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=mByte(); 
} break;
case 775: /* tagproto : ID SEMICOLON seqproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 506), ");  printf("ID SEMICOLON seqproto  -> tagproto \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 186; {
/* line 506 "/tmp/lalr1423" */
/* line 462 "occam.lalr" */
  yySynAttribute.Tree = mATagPro(NoTree,S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),ReverseTree(yyAttrStackPtr [3-1].Tree)); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=mByte(); 
} break;
case 776:
case 391: /* protocol : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 509), ");  printf("ID  -> protocol \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 187; {
/* line 509 "/tmp/lalr1423" */
/* line 466 "occam.lalr" */
 yySynAttribute.Tree = mNamed(Posn(yyAttrStackPtr [1-1]),LookupSymbol(yyAttrStackPtr [1-1].Scan)); 
} break;
case 777:
case 618: /* protocol : simpleproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 511), ");  printf("simpleproto  -> protocol \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 187; {
/* line 511 "/tmp/lalr1423" */
/* line 467 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 778: /* assignment : varlist ASSIGN explist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 514), ");  printf("varlist ASSIGN explist  -> assignment \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 128; {
/* line 514 "/tmp/lalr1423" */
/* line 471 "occam.lalr" */
 yySynAttribute.Tree = mAssign(Posn(yyAttrStackPtr [2-1]),mNoSpec(),ReverseTree(yyAttrStackPtr [1-1].Tree),ReverseTree(yyAttrStackPtr [3-1].Tree)); 
} break;
case 779: /* input : element QUERY ilist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 517), ");  printf("element QUERY ilist  -> input \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 129; {
/* line 517 "/tmp/lalr1423" */
/* line 475 "occam.lalr" */
  yySynAttribute.Tree = mInput(Posn(yyAttrStackPtr [2-1]),mNoSpec(),yyAttrStackPtr [1-1].Tree,ReverseTree(yyAttrStackPtr [3-1].Tree)); 
} break;
case 780:
case 585: /* after : element QUERY AFTER expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 520), ");  printf("element QUERY AFTER expr  -> after \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 130; {
/* line 520 "/tmp/lalr1423" */
/* line 478 "occam.lalr" */
  yySynAttribute.Tree = mAfter(Posn(yyAttrStackPtr [2-1]),mNoSpec(),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree); 
} break;
case 781: /* caseinput : element QUERY case sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 523), ");  printf("element QUERY case sep  -> caseinput \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 124; {
/* line 523 "/tmp/lalr1423" */
/* line 481 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [1-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,mNoCase()); 
} break;
case 782:
case 482: /* caseinput : element QUERY case sep BEGIN variantlist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 525), ");  printf("element QUERY case sep BEGIN variantlist END  -> caseinput \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 124; {
/* line 525 "/tmp/lalr1423" */
/* line 482 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [1-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,ReverseTree(yyAttrStackPtr [6-1].Tree)); 
} break;
case 783: /* casesingle : element QUERY case ilist sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 528), ");  printf("element QUERY case ilist sep  -> casesingle \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 125; {
/* line 528 "/tmp/lalr1423" */
/* line 485 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [2-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,mACase(mNoCase(),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree),mSkip(Posn(yyAttrStackPtr [2-1]),mNoSpec())));
} break;
case 784:
case 487: /* casesingleproc : element QUERY case ilist sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 531), ");  printf("element QUERY case ilist sep BEGIN process END  -> casesingleproc \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 161; {
/* line 531 "/tmp/lalr1423" */
/* line 488 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [2-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,mACase(mNoCase(),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree),yyAttrStackPtr [7-1].Tree));
} break;
case 785:
case 590: /* variantlist : variant .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 534), ");  printf("variant  -> variantlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 191; {
/* line 534 "/tmp/lalr1423" */
/* line 492 "occam.lalr" */
 yySynAttribute.Tree->ACase.Next = mNoCase(); CloseScope(); OpenScope(); 
} break;
case 786:
case 589: /* variantlist : variantlist variant .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 536), ");  printf("variantlist variant  -> variantlist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 191; {
/* line 536 "/tmp/lalr1423" */
/* line 493 "occam.lalr" */
 yySynAttribute.Scan =yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yySynAttribute.Tree->ACase.Next = yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 787:
case 481: /* variant : ilist sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 539), ");  printf("ilist sep BEGIN process END  -> variant \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 192; {
/* line 539 "/tmp/lalr1423" */
/* line 497 "occam.lalr" */
 yySynAttribute.Tree = mACase(NoTree,mNoSpec(),ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [4-1].Tree); 
} break;
case 788:
case 587: /* variant : specification sep variant .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 541), ");  printf("specification sep variant  -> variant \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 192; {
/* line 541 "/tmp/lalr1423" */
/* line 498 "occam.lalr" */
  yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->ACase.SpecList,yyAttrStackPtr [1-1].Tree);
} break;
case 789: /* output : element PLING olist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 544), ");  printf("element PLING olist  -> output \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 131; {
/* line 544 "/tmp/lalr1423" */
/* line 502 "occam.lalr" */
  yySynAttribute.Tree = mOutput(Posn(yyAttrStackPtr [2-1]),mNoSpec(),yyAttrStackPtr [1-1].Tree,ReverseTree(yyAttrStackPtr [3-1].Tree)); 
} break;
case 790:
case 593: /* olist : oitem .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 547), ");  printf("oitem  -> olist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 193; {
/* line 547 "/tmp/lalr1423" */
/* line 506 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 791:
case 592: /* olist : olist SEMICOLON oitem .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 549), ");  printf("olist SEMICOLON oitem  -> olist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 193; {
/* line 549 "/tmp/lalr1423" */
/* line 507 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 792: /* oitem : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 552), ");  printf("expr  -> oitem \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 194; {
/* line 552 "/tmp/lalr1423" */
/* line 510 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 793:
case 591: /* oitem : expr DCOLON expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 554), ");  printf("expr DCOLON expr  -> oitem \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 194; {
/* line 554 "/tmp/lalr1423" */
/* line 511 "occam.lalr" */
  yySynAttribute.Tree = mCountArray(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 794:
case 588: /* ilist : iitem .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 557), ");  printf("iitem  -> ilist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 190; {
/* line 557 "/tmp/lalr1423" */
/* line 514 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 795:
case 586: /* ilist : ilist SEMICOLON iitem .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 559), ");  printf("ilist SEMICOLON iitem  -> ilist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 190; {
/* line 559 "/tmp/lalr1423" */
/* line 515 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 796: /* iitem : element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 562), ");  printf("element  -> iitem \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 195; {
/* line 562 "/tmp/lalr1423" */
/* line 518 "occam.lalr" */
  yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 797: /* iitem : element DCOLON element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 564), ");  printf("element DCOLON element  -> iitem \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 195; {
/* line 564 "/tmp/lalr1423" */
/* line 519 "occam.lalr" */
  yySynAttribute.Tree = mCountArray(Posn(yyAttrStackPtr [1-1]),mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree),mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree)); 
} break;
case 798:
case 526: /* explist : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 567), ");  printf("expr  -> explist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 133; {
/* line 567 "/tmp/lalr1423" */
/* line 523 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 799:
case 520: /* explist : explist COMMA expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 569), ");  printf("explist COMMA expr  -> explist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 133; {
/* line 569 "/tmp/lalr1423" */
/* line 524 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 800:
case 570: /* isexplist : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 572), ");  printf("expr  -> isexplist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 178; {
/* line 572 "/tmp/lalr1423" */
/* line 527 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 801:
case 572: /* isexplist : isexplist COMMA expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 574), ");  printf("isexplist COMMA expr  -> isexplist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 178; {
/* line 574 "/tmp/lalr1423" */
/* line 528 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 802:
case 571: /* isexplist : isexplist DECLCOMMA expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 576), ");  printf("isexplist DECLCOMMA expr  -> isexplist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 178; {
/* line 576 "/tmp/lalr1423" */
/* line 529 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 803: /* varlist : element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 579), ");  printf("element  -> varlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 188; {
/* line 579 "/tmp/lalr1423" */
/* line 533 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(), mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree)); 
} break;
case 804: /* varlist : varlist COMMA element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 581), ");  printf("varlist COMMA element  -> varlist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 188; {
/* line 581 "/tmp/lalr1423" */
/* line 534 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree= mAnExpr(yyAttrStackPtr [1-1].Tree, mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree)); 
} break;
case 805:
case 582: /* typelist : primtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 584), ");  printf("primtype  -> typelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 175; {
/* line 584 "/tmp/lalr1423" */
/* line 538 "occam.lalr" */
  yySynAttribute.Tree = mAType(mNoType(),yyAttrStackPtr [1-1].Tree); 
} break;
case 806:
case 583: /* typelist : arrtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 586), ");  printf("arrtype  -> typelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 175; {
/* line 586 "/tmp/lalr1423" */
/* line 539 "occam.lalr" */
  yySynAttribute.Tree = mAType(mNoType(),yyAttrStackPtr [1-1].Tree); 
} break;
case 807:
case 568: /* typelist : typelist DECLCOMMA spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 588), ");  printf("typelist DECLCOMMA spectype  -> typelist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 175; {
/* line 588 "/tmp/lalr1423" */
/* line 540 "occam.lalr" */
  yySynAttribute.Tree = mAType(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 808:
case 569: /* typelist : typelist COMMA spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 590), ");  printf("typelist COMMA spectype  -> typelist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 175; {
/* line 590 "/tmp/lalr1423" */
/* line 541 "occam.lalr" */
  yySynAttribute.Tree = mAType(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 809: /* O_fparmlist : .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 593), ");  printf(" -> O_fparmlist \n");
}
#endif
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 174; {
/* line 593 "/tmp/lalr1423" */
/* line 545 "occam.lalr" */
 yySynAttribute.Tree = mNoFormal(); 
} break;
case 810:
case 577: /* O_fparmlist : fparmlist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 595), ");  printf("fparmlist  -> O_fparmlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 174; {
/* line 595 "/tmp/lalr1423" */
/* line 547 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 811: /* fparmlist : firstparm .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 598), ");  printf("firstparm  -> fparmlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 196; {
/* line 598 "/tmp/lalr1423" */
/* line 550 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = mNoFormal();
} break;
case 812:
case 580: /* fparmlist : firstparm COMMA fparmrest .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 600), ");  printf("firstparm COMMA fparmrest  -> fparmlist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 196; {
/* line 600 "/tmp/lalr1423" */
/* line 551 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = yyAttrStackPtr [3-1].Tree;
} break;
case 813: /* fparmrest : fparm .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 603), ");  printf("fparm  -> fparmrest \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 198; {
/* line 603 "/tmp/lalr1423" */
/* line 555 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = mNoFormal();
} break;
case 814:
case 581: /* fparmrest : fparm COMMA fparmrest .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 605), ");  printf("fparm COMMA fparmrest  -> fparmrest \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 198; {
/* line 605 "/tmp/lalr1423" */
/* line 556 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = yyAttrStackPtr [3-1].Tree;
} break;
case 815:
case 576: /* firstparm : spectype O_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 608), ");  printf("spectype O_id  -> firstparm \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 197; {
/* line 608 "/tmp/lalr1423" */
/* line 560 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByRef(),yyAttrStackPtr [1-1].Tree,S=Val(yyAttrStackPtr [2-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 816:
case 539: /* firstparm : VAL spectype O_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 610), ");  printf("VAL spectype O_id  -> firstparm \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 197; {
/* line 610 "/tmp/lalr1423" */
/* line 561 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByVal(),yyAttrStackPtr [2-1].Tree,S=Val(yyAttrStackPtr [3-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 817:
case 579: /* fparm : spectype O_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 613), ");  printf("spectype O_id  -> fparm \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 199; {
/* line 613 "/tmp/lalr1423" */
/* line 565 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByRef(),yyAttrStackPtr [1-1].Tree,S=Val(yyAttrStackPtr [2-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 818:
case 578: /* fparm : VAL spectype O_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 615), ");  printf("VAL spectype O_id  -> fparm \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 199; {
/* line 615 "/tmp/lalr1423" */
/* line 566 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByVal(),yyAttrStackPtr [2-1].Tree,S=Val(yyAttrStackPtr [3-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 819:
case 478: /* fparm : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 617), ");  printf("ID  -> fparm \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 199; {
/* line 617 "/tmp/lalr1423" */
/* line 567 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByUndef(),mUntyped(),S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 820: /* O_id : .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 620), ");  printf(" -> O_id \n");
}
#endif
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 200; {
/* line 620 "/tmp/lalr1423" */
/* line 570 "occam.lalr" */
 CHK_Mode(xxPrototype,Attribute.Position); Val(yySynAttribute).Symbol=NoSymbol; 
} break;
case 821:
case 462: /* O_id : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 622), ");  printf("ID  -> O_id \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 200; {
/* line 622 "/tmp/lalr1423" */
/* line 571 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan;  Val(yySynAttribute).Symbol=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident);
} break;
case 822:
case 404: /* element : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 625), ");  printf("ID  -> element \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 189; {
/* line 625 "/tmp/lalr1423" */
/* line 574 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIdentifier(Posn(yyAttrStackPtr [1-1]), LookupSymbol(yyAttrStackPtr [1-1].Scan),CurrentScope()); 
} break;
case 823:
case 400: /* element : element LSB subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 627), ");  printf("element LSB subscript RSB  -> element \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 189; {
/* line 627 "/tmp/lalr1423" */
/* line 575 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSubscript(Posn(yyAttrStackPtr [3-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 824:
case 428: /* element : LSB element FROM subscript FOR subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 629), ");  printf("LSB element FROM subscript FOR subscript RSB  -> element \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 189; {
/* line 629 "/tmp/lalr1423" */
/* line 576 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 825: /* elemental : element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 632), ");  printf("element  -> elemental \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 168; {
/* line 632 "/tmp/lalr1423" */
/* line 579 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 826:
case 527: /* elemental : table_element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 634), ");  printf("table_element  -> elemental \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 168; {
/* line 634 "/tmp/lalr1423" */
/* line 580 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 827:
case 517: /* subscript : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 637), ");  printf("expr  -> subscript \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 201; {
/* line 637 "/tmp/lalr1423" */
/* line 583 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 828:
case 427: /* table : LSB expr COMMA explist RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 640), ");  printf("LSB expr COMMA explist RSB  -> table \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 203; {
/* line 640 "/tmp/lalr1423" */
/* line 586 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTable(Posn(yyAttrStackPtr [1-1]),mAnExpr(ReverseTree(yyAttrStackPtr [4-1].Tree),yyAttrStackPtr [2-1].Tree),Depth,S=AddSymbol(NoIdent)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 829:
case 401: /* table : table LSB subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 642), ");  printf("table LSB subscript RSB  -> table \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 203; {
/* line 642 "/tmp/lalr1423" */
/* line 587 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableSubscript(Posn(yyAttrStackPtr [3-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 830:
case 429: /* table : LSB table_element FROM subscript FOR subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 644), ");  printf("LSB table_element FROM subscript FOR subscript RSB  -> table \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 203; {
/* line 644 "/tmp/lalr1423" */
/* line 588 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 831: /* table_element : table .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 647), ");  printf("table  -> table_element \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 202; {
/* line 647 "/tmp/lalr1423" */
/* line 591 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 832: /* table_element : sbexprlist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 649), ");  printf("sbexprlist  -> table_element \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 202; {
/* line 649 "/tmp/lalr1423" */
/* line 592 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableElementFromExprList(yyAttrStackPtr [1-1].Tree,Posn(yyAttrStackPtr [1-1]),Depth); 
} break;
case 833:
case 381: /* string_element : STR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 652), ");  printf("STR  -> string_element \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 205; {
/* line 652 "/tmp/lalr1423" */
/* line 595 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mString(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]).String,Depth,S=AddSymbol(NoIdent)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 834:
case 402: /* string_element : string_element LSB subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 654), ");  printf("string_element LSB subscript RSB  -> string_element \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 205; {
/* line 654 "/tmp/lalr1423" */
/* line 596 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mStringSubscript(Posn(yyAttrStackPtr [3-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 835:
case 503: /* string_element : LSB string_element FROM subscript FOR subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 656), ");  printf("LSB string_element FROM subscript FOR subscript RSB  -> string_element \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 205; {
/* line 656 "/tmp/lalr1423" */
/* line 597 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mStringRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 836:
case 519: /* expr : monop operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 659), ");  printf("monop operand  -> expr \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 134; {
/* line 659 "/tmp/lalr1423" */
/* line 600 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnary(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree); 
} break;
case 837:
case 521: /* expr : operand dyop operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 661), ");  printf("operand dyop operand  -> expr \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 134; {
/* line 661 "/tmp/lalr1423" */
/* line 601 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBinary(Posn(yyAttrStackPtr [2-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 838: /* expr : operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 663), ");  printf("operand  -> expr \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 134; {
/* line 663 "/tmp/lalr1423" */
/* line 602 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 839:
case 524: /* expr : conversion .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 665), ");  printf("conversion  -> expr \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 134; {
/* line 665 "/tmp/lalr1423" */
/* line 603 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 840: /* expr : boolexpr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 667), ");  printf("boolexpr  -> expr \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 134; {
/* line 667 "/tmp/lalr1423" */
/* line 604 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 841:
case 387: /* lp : LP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 670), ");  printf("LP  -> lp \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 211; {
/* line 670 "/tmp/lalr1423" */
/* line 607 "occam.lalr" */
 OpenScope(); OpenScope(); PushColumn(Posn(yyAttrStackPtr [1-1]).Column); PushTokenColumn(); 
} break;
case 842:
case 523: /* boolexpr : operand boolop operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 673), ");  printf("operand boolop operand  -> boolexpr \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 210; {
/* line 673 "/tmp/lalr1423" */
/* line 610 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBinary(Posn(yyAttrStackPtr [2-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 843:
case 525: /* boolexpr : boolexpr boolop operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 675), ");  printf("boolexpr boolop operand  -> boolexpr \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 210; {
/* line 675 "/tmp/lalr1423" */
/* line 611 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBinary(Posn(yyAttrStackPtr [2-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 844: /* operand : element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 678), ");  printf("element  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 207; {
/* line 678 "/tmp/lalr1423" */
/* line 614 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 845:
case 518: /* operand : table_element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 680), ");  printf("table_element  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 207; {
/* line 680 "/tmp/lalr1423" */
/* line 615 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 846: /* operand : string_element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 682), ");  printf("string_element  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 207; {
/* line 682 "/tmp/lalr1423" */
/* line 616 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 847:
case 522: /* operand : intliteral .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 684), ");  printf("intliteral  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 207; {
/* line 684 "/tmp/lalr1423" */
/* line 617 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 848:
case 384: /* operand : RNUMBER LP realtype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 686), ");  printf("RNUMBER LP realtype RP  -> operand \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 207; {
/* line 686 "/tmp/lalr1423" */
/* line 618 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree); 
} break;
case 849:
case 501: /* operand : lp expr RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 688), ");  printf("lp expr RP  -> operand \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 207; {
/* line 688 "/tmp/lalr1423" */
/* line 619 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; CloseScope(); CloseScope(); PopColumn(); PopColumn(); 
} break;
case 850:
case 502: /* operand : lp valof RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 690), ");  printf("lp valof RP  -> operand \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 207; {
/* line 690 "/tmp/lalr1423" */
/* line 620 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; CloseScope(); PopColumn(); 
} break;
case 851:
case 504: /* operand : ID LP explist RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 692), ");  printf("ID LP explist RP  -> operand \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 207; {
/* line 692 "/tmp/lalr1423" */
/* line 621 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mFuncCall(Posn(yyAttrStackPtr [1-1]), LookupSymbol(yyAttrStackPtr [1-1].Scan),ReverseTree(yyAttrStackPtr [3-1].Tree),Depth); 
} break;
case 852:
case 388: /* operand : ID LP RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 694), ");  printf("ID LP RP  -> operand \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 207; {
/* line 694 "/tmp/lalr1423" */
/* line 622 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mFuncCall(Posn(yyAttrStackPtr [1-1]), LookupSymbol(yyAttrStackPtr [1-1].Scan),mNoExpr(),Depth); 
} break;
case 853:
case 507: /* operand : MOSTPOS inttype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 696), ");  printf("MOSTPOS inttype  -> operand \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 207; {
/* line 696 "/tmp/lalr1423" */
/* line 623 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMostPos(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree); 
} break;
case 854:
case 506: /* operand : MOSTNEG inttype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 698), ");  printf("MOSTNEG inttype  -> operand \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 207; {
/* line 698 "/tmp/lalr1423" */
/* line 624 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMostNeg(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree); 
} break;
case 855:
case 386: /* monop : SUBTRACT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 701), ");  printf("SUBTRACT  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 206; {
/* line 701 "/tmp/lalr1423" */
/* line 627 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSubtract(); 
} break;
case 856:
case 394: /* monop : NOT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 703), ");  printf("NOT  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 206; {
/* line 703 "/tmp/lalr1423" */
/* line 628 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mNot(); 
} break;
case 857:
case 390: /* monop : BITNOT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 705), ");  printf("BITNOT  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 206; {
/* line 705 "/tmp/lalr1423" */
/* line 629 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitNot(); 
} break;
case 858:
case 397: /* monop : SIZE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 707), ");  printf("SIZE  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 206; {
/* line 707 "/tmp/lalr1423" */
/* line 630 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSize(); 
} break;
case 859:
case 385: /* monop : ADD .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 709), ");  printf("ADD  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 206; {
/* line 709 "/tmp/lalr1423" */
/* line 631 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAdd(); 
} break;
case 860:
case 393: /* monop : MINUS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 711), ");  printf("MINUS  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 206; {
/* line 711 "/tmp/lalr1423" */
/* line 632 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMinus(); 
} break;
case 861:
case 395: /* monop : PLUS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 713), ");  printf("PLUS  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 206; {
/* line 713 "/tmp/lalr1423" */
/* line 633 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPlus(); 
} break;
case 862:
case 405: /* dyop : LT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 716), ");  printf("LT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 716 "/tmp/lalr1423" */
/* line 636 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mLess(); 
} break;
case 863:
case 406: /* dyop : GT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 718), ");  printf("GT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 718 "/tmp/lalr1423" */
/* line 637 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mGreater(); 
} break;
case 864:
case 407: /* dyop : LE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 720), ");  printf("LE  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 720 "/tmp/lalr1423" */
/* line 638 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mLessEqual(); 
} break;
case 865:
case 408: /* dyop : GE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 722), ");  printf("GE  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 722 "/tmp/lalr1423" */
/* line 639 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mGreaterEqual(); 
} break;
case 866:
case 409: /* dyop : EQ .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 724), ");  printf("EQ  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 724 "/tmp/lalr1423" */
/* line 640 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mEqual(); 
} break;
case 867:
case 410: /* dyop : NE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 726), ");  printf("NE  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 726 "/tmp/lalr1423" */
/* line 641 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mNotEqual(); 
} break;
case 868:
case 411: /* dyop : ADD .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 728), ");  printf("ADD  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 728 "/tmp/lalr1423" */
/* line 642 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAdd(); 
} break;
case 869:
case 412: /* dyop : SUBTRACT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 730), ");  printf("SUBTRACT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 730 "/tmp/lalr1423" */
/* line 643 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSubtract(); 
} break;
case 870:
case 413: /* dyop : MULTIPLY .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 732), ");  printf("MULTIPLY  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 732 "/tmp/lalr1423" */
/* line 644 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMultiply(); 
} break;
case 871:
case 414: /* dyop : DIVIDE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 734), ");  printf("DIVIDE  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 734 "/tmp/lalr1423" */
/* line 645 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDivide(); 
} break;
case 872:
case 420: /* dyop : BITAND .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 736), ");  printf("BITAND  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 736 "/tmp/lalr1423" */
/* line 646 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitAnd(); 
} break;
case 873:
case 421: /* dyop : BITOR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 738), ");  printf("BITOR  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 738 "/tmp/lalr1423" */
/* line 647 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitOr(); 
} break;
case 874:
case 415: /* dyop : BITEOR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 740), ");  printf("BITEOR  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 740 "/tmp/lalr1423" */
/* line 648 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitEor(); 
} break;
case 875:
case 416: /* dyop : LSHIFT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 742), ");  printf("LSHIFT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 742 "/tmp/lalr1423" */
/* line 649 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mLeftShift(); 
} break;
case 876:
case 417: /* dyop : RSHIFT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 744), ");  printf("RSHIFT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 744 "/tmp/lalr1423" */
/* line 650 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRightShift(); 
} break;
case 877:
case 425: /* dyop : REM .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 746), ");  printf("REM  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 746 "/tmp/lalr1423" */
/* line 651 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRem(); 
} break;
case 878:
case 422: /* dyop : MINUS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 748), ");  printf("MINUS  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 748 "/tmp/lalr1423" */
/* line 652 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMinus(); 
} break;
case 879:
case 424: /* dyop : PLUS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 750), ");  printf("PLUS  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 750 "/tmp/lalr1423" */
/* line 653 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPlus(); 
} break;
case 880:
case 426: /* dyop : TIMES .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 752), ");  printf("TIMES  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 752 "/tmp/lalr1423" */
/* line 654 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTimes(); 
} break;
case 881:
case 418: /* dyop : AFTER .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 754), ");  printf("AFTER  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 754 "/tmp/lalr1423" */
/* line 655 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAfterOp(); 
} break;
case 882:
case 419: /* boolop : AND .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 757), ");  printf("AND  -> boolop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 757 "/tmp/lalr1423" */
/* line 658 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnd(); 
} break;
case 883:
case 423: /* boolop : OR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 759), ");  printf("OR  -> boolop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 759 "/tmp/lalr1423" */
/* line 659 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mOr(); 
} break;
case 884:
case 601: /* conversion : primtype operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 762), ");  printf("primtype operand  -> conversion \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 209; {
/* line 762 "/tmp/lalr1423" */
/* line 662 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConvert(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 885:
case 617: /* conversion : primtype ROUND operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 764), ");  printf("primtype ROUND operand  -> conversion \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 209; {
/* line 764 "/tmp/lalr1423" */
/* line 663 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRound(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 886:
case 600: /* conversion : primtype TRUNC operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 766), ");  printf("primtype TRUNC operand  -> conversion \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 209; {
/* line 766 "/tmp/lalr1423" */
/* line 664 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTrunc(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 887: /* intliteral : NUMBER .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 769), ");  printf("NUMBER  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 213; {
/* line 769 "/tmp/lalr1423" */
/* line 667 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mInt(),Val(yyAttrStackPtr [1-1]).Number,false),mInt()); 
} break;
case 888: /* intliteral : HEXNUMBER .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 771), ");  printf("HEXNUMBER  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 213; {
/* line 771 "/tmp/lalr1423" */
/* line 668 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mInt(),Val(yyAttrStackPtr [1-1]).Number,true),mInt()); 
} break;
case 889: /* intliteral : TRUE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 773), ");  printf("TRUE  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 213; {
/* line 773 "/tmp/lalr1423" */
/* line 669 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mBool(),true,false),mBool()); 
} break;
case 890: /* intliteral : FALSE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 775), ");  printf("FALSE  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 213; {
/* line 775 "/tmp/lalr1423" */
/* line 670 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mBool(),false,false),mBool()); 
} break;
case 891: /* intliteral : CHCON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 777), ");  printf("CHCON  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 213; {
/* line 777 "/tmp/lalr1423" */
/* line 671 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mByte(),Val(yyAttrStackPtr [1-1]).Char,true),mByte()); 
} break;
case 892:
case 378: /* intliteral : NUMBER LP inttype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 779), ");  printf("NUMBER LP inttype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 213; {
/* line 779 "/tmp/lalr1423" */
/* line 672 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,Val(yyAttrStackPtr [1-1]).Number,false),yyAttrStackPtr [3-1].Tree); 
} break;
case 893:
case 379: /* intliteral : HEXNUMBER LP inttype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 781), ");  printf("HEXNUMBER LP inttype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 213; {
/* line 781 "/tmp/lalr1423" */
/* line 673 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,Val(yyAttrStackPtr [1-1]).Number,true),yyAttrStackPtr [3-1].Tree); 
} break;
case 894:
case 380: /* intliteral : CHCON LP inttype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 783), ");  printf("CHCON LP inttype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 213; {
/* line 783 "/tmp/lalr1423" */
/* line 674 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,Val(yyAttrStackPtr [1-1]).Char,true),yyAttrStackPtr [3-1].Tree); 
} break;
case 895:
case 398: /* intliteral : TRUE LP inttype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 785), ");  printf("TRUE LP inttype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 213; {
/* line 785 "/tmp/lalr1423" */
/* line 675 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,true,false),yyAttrStackPtr [3-1].Tree); 
} break;
case 896:
case 392: /* intliteral : FALSE LP inttype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 787), ");  printf("FALSE LP inttype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 213; {
/* line 787 "/tmp/lalr1423" */
/* line 676 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,false,false),yyAttrStackPtr [3-1].Tree); 
} break;
case 897:
case 442: /* valoftok : VALOF .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 790), ");  printf("VALOF  -> valoftok \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 215; {
/* line 790 "/tmp/lalr1423" */
/* line 679 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 898:
case 479: /* result : RESULT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 793), ");  printf("RESULT  -> result \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 216; {
/* line 793 "/tmp/lalr1423" */
/* line 682 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); PopColumn(); 
} break;
case 899:
case 480: /* valof : valoftok sep BEGIN process result explist sep END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 796), ");  printf("valoftok sep BEGIN process result explist sep END  -> valof \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 177; {
/* line 796 "/tmp/lalr1423" */
/* line 685 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mValof(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [4-1].Tree,ReverseTree(yyAttrStackPtr [6-1].Tree),S=AddSymbol(NoIdent),Depth); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 900:
case 616: /* valof : specification sep valof .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 798), ");  printf("specification sep valof  -> valof \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 177; {
/* line 798 "/tmp/lalr1423" */
/* line 686 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->Valof.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 901:
case 508: /* spectype : primtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 801), ");  printf("primtype  -> spectype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 801 "/tmp/lalr1423" */
/* line 689 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 902:
case 509: /* spectype : arrtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 803), ");  printf("arrtype  -> spectype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 803 "/tmp/lalr1423" */
/* line 690 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 903:
case 619: /* primtype : CHAN OF protocol .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 806), ");  printf("CHAN OF protocol  -> primtype \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 162; {
/* line 806 "/tmp/lalr1423" */
/* line 694 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mChan(yyAttrStackPtr [3-1].Tree); last_type_was_chan=true; 
} break;
case 904:
case 510: /* primtype : PORT OF spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 809), ");  printf("PORT OF spectype  -> primtype \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 162; {
/* line 809 "/tmp/lalr1423" */
/* line 695 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mChan(mSimple(Posn(yyAttrStackPtr [3-1]),yyAttrStackPtr [3-1].Tree)); Message("PORT not supported",xxError,Posn(yyAttrStackPtr [1-1])); last_type_was_chan=true; 
} break;
case 905:
case 396: /* primtype : TIMER .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 810), ");  printf("TIMER  -> primtype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 162; {
/* line 810 "/tmp/lalr1423" */
/* line 696 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTimer(); last_type_was_chan=false; 
} break;
case 906:
case 514: /* primtype : numerictype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 812), ");  printf("numerictype  -> primtype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 162; {
/* line 812 "/tmp/lalr1423" */
/* line 697 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; last_type_was_chan=false;
} break;
case 907:
case 511: /* numerictype : inttype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 815), ");  printf("inttype  -> numerictype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 815 "/tmp/lalr1423" */
/* line 700 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 908:
case 513: /* numerictype : realtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 817), ");  printf("realtype  -> numerictype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 817 "/tmp/lalr1423" */
/* line 701 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 909:
case 372: /* inttype : BOOL .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 820), ");  printf("BOOL  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 185; {
/* line 820 "/tmp/lalr1423" */
/* line 704 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBool(); 
} break;
case 910:
case 373: /* inttype : BYTE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 822), ");  printf("BYTE  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 185; {
/* line 822 "/tmp/lalr1423" */
/* line 705 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mByte(); 
} break;
case 911:
case 374: /* inttype : INT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 824), ");  printf("INT  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 185; {
/* line 824 "/tmp/lalr1423" */
/* line 706 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mInt(); 
} break;
case 912:
case 375: /* inttype : INT16 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 826), ");  printf("INT16  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 185; {
/* line 826 "/tmp/lalr1423" */
/* line 707 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mInt16(); 
} break;
case 913:
case 376: /* inttype : INT32 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 828), ");  printf("INT32  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 185; {
/* line 828 "/tmp/lalr1423" */
/* line 708 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mInt32(); 
} break;
case 914:
case 377: /* inttype : INT64 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 831), ");  printf("INT64  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 185; {
/* line 831 "/tmp/lalr1423" */
/* line 709 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; if (IS_Mode(xxSupportINT64)) yySynAttribute.Tree = mInt64(); else { Message("No INT64 support therefore converting to INT32",xxWarning,Posn(yyAttrStackPtr [1-1])); yySynAttribute.Tree = mInt32(); } 
} break;
case 915:
case 382: /* realtype : REAL32 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 833), ");  printf("REAL32  -> realtype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 214; {
/* line 833 "/tmp/lalr1423" */
/* line 712 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mReal32(); 
} break;
case 916:
case 383: /* realtype : REAL64 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 835), ");  printf("REAL64  -> realtype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 214; {
/* line 835 "/tmp/lalr1423" */
/* line 713 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mReal64(); 
} break;
case 917:
case 512: /* arrtype : sbexprlist primtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 838), ");  printf("sbexprlist primtype  -> arrtype \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 164; {
/* line 838 "/tmp/lalr1423" */
/* line 716 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mArrayFromExprList(ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [2-1].Tree); 
} break;
case 918:
case 389: /* sbexpr : LSB RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 841), ");  printf("LSB RSB  -> sbexpr \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 218; {
/* line 841 "/tmp/lalr1423" */
/* line 719 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnBound(Posn(yyAttrStackPtr [1-1])); 
} break;
case 919:
case 399: /* sbexpr : LSB expr RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 843), ");  printf("LSB expr RSB  -> sbexpr \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 218; {
/* line 843 "/tmp/lalr1423" */
/* line 720 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree ; 
} break;
case 920:
case 516: /* sbexprlist : sbexpr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 846), ");  printf("sbexpr  -> sbexprlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 204; {
/* line 846 "/tmp/lalr1423" */
/* line 723 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(),yyAttrStackPtr [1-1].Tree) ; 
} break;
case 921:
case 515: /* sbexprlist : sbexprlist sbexpr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 848), ");  printf("sbexprlist sbexpr  -> sbexprlist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 204; {
/* line 848 "/tmp/lalr1423" */
/* line 724 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree); 
} break;
case 922:
case 562: /* boolean : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 851), ");  printf("expr  -> boolean \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 158; {
/* line 851 "/tmp/lalr1423" */
/* line 727 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
} break;
}

	       /* SPEC State = Next (Top (), Nonterminal); nonterminal transition */
	       yyState = * (yyNBasePtr [* yyStateStackPtr ++] + yyNonterminal);
	       * yyAttrStackPtr ++ = yySynAttribute;
	       if (yyState < yyFirstFinalState) goto ParseLoop; /* read nonterminal reduce ? */
	    } 

	 } else {					/* read */
	    yyStateStackPtr ++;
	    yyGetAttribute (yyAttrStackPtr ++, Attribute);
	    yyTerminal = GetToken ();

#ifdef YYDEBUG
if (yydebug)  /* SMW */
{
  printf("Reading a token: Next token is %d (%s)\n",yyTerminal,Parser_TokenName[yyTerminal]);
}
#endif

	    yyIsRepairing = false;
	 }
      }
   }

static void yyErrorRecovery
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange *	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      bool	yyTokensSkipped	;
      tSet	yyContinueSet	;
      tSet	yyRestartSet	;
      int	yyLength = 0	;
      char	yyContinueString [256];

   /* 1. report an error */
      ErrorMessage (xxSyntaxError, xxError, Attribute.Position);

   /* 2. report the set of expected terminal symbols */
      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      yyComputeContinuation (yyStateStack, yyStackSize, yyStackPtr, & yyContinueSet);
      yyContinueString [0] = '\0';
      while (! IsEmpty (& yyContinueSet)) {
	 char * yyTokenString = Parser_TokenName [Extract (& yyContinueSet)];
	 if ((yyLength += strlen (yyTokenString) + 1) >= 256) break;
	 (void) strcat (yyContinueString, yyTokenString);
	 (void) strcat (yyContinueString, " ");
      }
      ErrorMessageI (xxExpectedTokens, xxInformation, Attribute.Position,
	 xxString, yyContinueString);
      ReleaseSet (& yyContinueSet);

   /* 3. compute the set of terminal symbols for restart of the parse */
      MakeSet (& yyRestartSet, (short) yyLastTerminal);
      yyComputeRestartPoints (yyStateStack, yyStackSize, yyStackPtr, & yyRestartSet);

   /* 4. skip terminal symbols until a restart point is reached */
      yyTokensSkipped = false;
      while (! IsElement (* yyTerminal, & yyRestartSet)) {
	 * yyTerminal = GetToken ();
	 yyTokensSkipped = true;
      }
      ReleaseSet (& yyRestartSet);

   /* 5. report the restart point */
      if (yyTokensSkipped) {
	 ErrorMessage (xxRestartPoint, xxInformation, Attribute.Position);
      }
   }

/*
   compute the set of terminal symbols that can be accepted (read)
   in a given stack configuration (eventually after reduce actions)
*/

static void yyComputeContinuation
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet)
# else
   (yyStack, yyStackSize, yyStackPtr, yyContinueSet)
   yyStateRange *	yyStack		;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyContinueSet	;
# endif
   {
      register yySymbolRange	yyTerminal;
      register yyStateRange	yyState = yyStack [yyStackPtr];

      AssignEmpty (yyContinueSet);
      for (yyTerminal = yyFirstTerminal; yyTerminal <= yyLastTerminal; yyTerminal ++) {
	 if (yyNext (yyState, yyTerminal) != yyNoState &&
	    yyIsContinuation (yyTerminal, yyStack, yyStackSize, yyStackPtr)) {
	    Include (yyContinueSet, (short) yyTerminal);
	 }
      }
   }

/*
   check whether a given terminal symbol can be accepted (read)
   in a certain stack configuration (eventually after reduce actions)
*/

static bool yyIsContinuation
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));	/* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      yState = yyStack [yyStackPtr];
      for (;;) {
	 yyStack [yyStackPtr] = yState;
	 yState = yyNext (yState, yyTerminal);
	 if (yState == yyNoState) {
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return false;
	 }
	 if (yState <= yyLastReadTermState) {		/* read or read terminal reduce ? */
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return true;
	 }

	 for (;;) {					/* reduce */
	    if (yState == yyStopState) {
	       ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	       return true;
	    } else { 
	       yyStackPtr -= yyLength [yState - yyFirstReduceState];
	       yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	    }

	    yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	    if (yyStackPtr >= yyStackSize) {
	       ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    }
	    yyStackPtr ++;
	    if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	    yState = yyFinalToProd [yState - yyFirstReadTermState];	/* read nonterminal reduce */
	 }
      }
   }

/*
   compute a set of terminal symbols that can be used to restart
   parsing in a given stack configuration. we simulate parsing until
   end of file using a suffix program synthesized by the function
   Continuation. All symbols acceptable in the states reached during
   the simulation can be used to restart parsing.
*/

static void yyComputeRestartPoints
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet)
# else
   (yyStateStack, yyStackSize, yyStackPtr, yyRestartSet)
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyRestartSet	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
	       tSet		yyContinueSet	;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange)); /* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      AssignEmpty (yyRestartSet);
      yState = yyStack [yyStackPtr];

      for (;;) {
	 if (yyStackPtr >= yyStackSize) {
	    ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	 }
	 yyStack [yyStackPtr] = yState;
	 yyComputeContinuation (yyStack, yyStackSize, yyStackPtr, & yyContinueSet);
	 Union (yyRestartSet, & yyContinueSet);
	 yState = yyNext (yState, yyContinuation [yState]);

	 if (yState >= yyFirstFinalState) {		/* final state ? */
	    if (yState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStackPtr ++;
	       yState = yyFinalToProd [yState - yyFirstReadTermState];
	    }

	    for (;;) {					/* reduce */
	       if (yState == yyStopState) {
		  ReleaseSet (& yyContinueSet);
		  ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
		  return;
	       } else { 
		  yyStackPtr -= yyLength [yState - yyFirstReduceState];
		  yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	       }

	       yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	       yyStackPtr ++;
	       if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	       yState = yyFinalToProd [yState - yyFirstReadTermState]; /* read nonterminal reduce */
	    }
	 } else {					/* read */
	    yyStackPtr ++;
	 }
      }
   }

/* access the parse table:   Next : State x Symbol -> Action */

static yyStateRange yyNext
# if defined __STDC__ | defined __cplusplus
   (yyStateRange yyState, yySymbolRange yySymbol)
# else
   (yyState, yySymbol) yyStateRange yyState; yySymbolRange yySymbol;
# endif
   {
      register yyTCombType * yyTCombPtr;

      if (yySymbol <= yyLastTerminal) {
	 for (;;) {
	    yyTCombPtr = yyTBasePtr [yyState] + yySymbol;
	    if (yyTCombPtr->Check != yyState) {
	       if ((yyState = yyDefault [yyState]) == yyNoState) return yyNoState;
	    } else {
	       return yyTCombPtr->Next;
	    }
	 }
      } else {
	return * (yyNBasePtr [yyState] + yySymbol);
      }
   }

static void BeginParser ()
   {
/* line 26 "/tmp/lalr1423" */
/* line 40 "occam.lalr" */

  OpenScope();
  Vtrue.Number = true;
  Vfalse.Number = false;


   }

void CloseParser ()
   {
/* line 35 "/tmp/lalr1423" */
/* line 49 "occam.lalr" */

  CloseScope();

   }
