# include "Tree.h"
# define yyALLOC(ptr, size)	if ((ptr = (tTree) Tree_PoolFreePtr) >= (tTree) Tree_PoolMaxPtr) \
  ptr = Tree_Alloc (); \
  Tree_PoolFreePtr += size;
# define yyFREE(ptr, size)	
# ifdef __cplusplus
extern "C" {
# include <stdio.h>
# include "yyTree.w"
# include "System.h"
# include "General.h"
# include "Memory.h"
# include "DynArray.h"
# include "StringMem.h"
# include "Idents.h"
# include "Sets.h"
# include "Positions.h"
}
# else
# include <stdio.h>
# include "yyTree.w"
# include "System.h"
# include "General.h"
# include "Memory.h"
# include "DynArray.h"
# include "StringMem.h"
# include "Idents.h"
# include "Sets.h"
# include "Positions.h"
# endif

/* line 61 "" */
 
  int ExtnModes = 0;

  #undef  writetIdent
  #define writetIdent(a)  { if (a != NoIdent && a != 0) WriteIdent(yyf,a); else fputs("NoIdent",yyf); }

  #undef  writetSymbol
  #define writetSymbol(a) { if (Symbol(a).Id != NoIdent && Symbol(a).Id != 0) WriteIdent(yyf,Symbol(a).Id); else fputs("NoSymbol",yyf); }

  #undef  writetStringRef
  #define writetStringRef(a) { WriteStrRef(a); }

  #undef  writechar
  #define writechar(a)       { fprintf(yyf,"\'*#%02x\'",a);}

  #undef writetType  
  #define writetType(a)   { if (a) { /* fputs(Tree_NodeName[a->Kind],yyf); */ CodeType(a);}}

  #undef writetChain
  #define writetChain(a)       { if (a) fputs(Tree_NodeName[a->Kind],yyf); }

  #undef writetFrame
  #define writetFrame(a)       { if (a) fputs(Tree_NodeName[a->Kind],yyf); }

  #undef writetChoiceList
  #define writetChoiceList(a)  { if (a) fputs(Tree_NodeName[a->Kind],yyf); }

  #undef writetIfType
  #define writetIfType(a)      { if (a) fputs(Tree_NodeName[a->Kind],yyf); }

/* line 534 "" */

  /*{{{  tUsage UpdateUsage(tUsage old, tUsage new)*/
  tUsage UpdateUsage(tUsage old, tUsage new)
  {
    if (old==xxInput && new==xxOutput) return xxInOut;
    if (new==xxInput && old==xxOutput) return xxInOut;
    if (old==xxInput || old==xxOutput) return old;
    return(new);  
  }
  /*}}}*/

/* line 870 "" */

  #undef writepLinExpr
  #define writepLinExpr(a) WriteLinExpr(yyf,a);


static void yyExit () { Exit (1); }

void (* Tree_Exit) () = yyExit;

# define yyBlockSize 20480

typedef struct yysBlock {
 char yyBlock [yyBlockSize];
 struct yysBlock * yySuccessor;
} yytBlock, * yytBlockPtr;

tTree TreeRoot;
unsigned long Tree_HeapUsed = 0;

static yytBlockPtr yyBlockList	= (yytBlockPtr) NoTree;
char * Tree_PoolFreePtr	= (char *) NoTree;
char * Tree_PoolMaxPtr	= (char *) NoTree;
static unsigned short yyMaxSize	= 0;
unsigned short Tree_NodeSize [184 + 1] = { 0,
 sizeof (yStart),
 sizeof (ySpecList),
 sizeof (yNoSpec),
 sizeof (yASpec),
 sizeof (ySpec),
 sizeof (yDecl),
 sizeof (yIs),
 sizeof (yAVal),
 sizeof (yVal),
 sizeof (yValRetypes),
 sizeof (yRetypes),
 sizeof (yDefAPro),
 sizeof (yDefSeqPro),
 sizeof (yDefTagPro),
 sizeof (yDefAProc),
 sizeof (yDefProc),
 sizeof (yPrototypeProc),
 sizeof (yDefAFunc),
 sizeof (yDefFunc),
 sizeof (yDefIsFunc),
 sizeof (yPrototypeFunc),
 sizeof (yNullSpec),
 sizeof (yHCode),
 sizeof (yCallFrame),
 sizeof (yParFrame),
 sizeof (yFormals),
 sizeof (yNoFormal),
 sizeof (yAFormal),
 sizeof (yReplicator),
 sizeof (yTagProList),
 sizeof (yNoTagPro),
 sizeof (yATagPro),
 sizeof (yBy),
 sizeof (yByVal),
 sizeof (yByRef),
 sizeof (yByUndef),
 sizeof (yIdList),
 sizeof (yNoId),
 sizeof (yAnId),
 sizeof (yType),
 sizeof (yArray),
 sizeof (yChan),
 sizeof (yTimer),
 sizeof (yUntyped),
 sizeof (yPrimitive),
 sizeof (yNumeric),
 sizeof (yInteger),
 sizeof (yInt),
 sizeof (yInt16),
 sizeof (yInt32),
 sizeof (yInt64),
 sizeof (yReal),
 sizeof (yReal32),
 sizeof (yReal64),
 sizeof (yByte),
 sizeof (yBool),
 sizeof (yTypeList),
 sizeof (yNoType),
 sizeof (yAType),
 sizeof (yProtocol),
 sizeof (yAny),
 sizeof (yNamed),
 sizeof (ySimple),
 sizeof (yCounted),
 sizeof (ySeqProList),
 sizeof (yNoSeqPro),
 sizeof (yASeqPro),
 sizeof (yExpr),
 sizeof (yBinary),
 sizeof (yUnary),
 sizeof (yConst),
 sizeof (yValof),
 sizeof (yFuncCall),
 sizeof (yElementalExpr),
 sizeof (yDefault),
 sizeof (yConvert),
 sizeof (yRound),
 sizeof (yTrunc),
 sizeof (yMostPos),
 sizeof (yMostNeg),
 sizeof (yCountArray),
 sizeof (yUnBound),
 sizeof (yStringElement),
 sizeof (yString),
 sizeof (yStringSubscript),
 sizeof (yStringRange),
 sizeof (yElemental),
 sizeof (yTableElement),
 sizeof (yTable),
 sizeof (yTableSubscript),
 sizeof (yTableRange),
 sizeof (yElement),
 sizeof (yIdentifier),
 sizeof (yElementAccess),
 sizeof (ySubscript),
 sizeof (yRange),
 sizeof (yExprList),
 sizeof (yNoExpr),
 sizeof (yAnExpr),
 sizeof (yOp),
 sizeof (yRelOp),
 sizeof (yLess),
 sizeof (yGreater),
 sizeof (yLessEqual),
 sizeof (yGreaterEqual),
 sizeof (yEqual),
 sizeof (yNotEqual),
 sizeof (yMathsOp),
 sizeof (yAdd),
 sizeof (ySubtract),
 sizeof (yMultiply),
 sizeof (yDivide),
 sizeof (yRem),
 sizeof (yBitOp),
 sizeof (yBitAnd),
 sizeof (yBitOr),
 sizeof (yBitEor),
 sizeof (yShiftOp),
 sizeof (yLeftShift),
 sizeof (yRightShift),
 sizeof (yUniOp),
 sizeof (ySize),
 sizeof (yBitNot),
 sizeof (yNot),
 sizeof (yClockOp),
 sizeof (yPlus),
 sizeof (yMinus),
 sizeof (yTimes),
 sizeof (yLogOp),
 sizeof (yAnd),
 sizeof (yOr),
 sizeof (yAfterOp),
 sizeof (yProcess),
 sizeof (yAssign),
 sizeof (yAltType),
 sizeof (yAlt),
 sizeof (yAltRep),
 sizeof (yParType),
 sizeof (yPar),
 sizeof (yParRep),
 sizeof (yProcessor),
 sizeof (yIfType),
 sizeof (yIf),
 sizeof (yIfRep),
 sizeof (yInput),
 sizeof (yOutput),
 sizeof (yCaseIn),
 sizeof (yAfter),
 sizeof (ySeqRep),
 sizeof (ySeq),
 sizeof (yCase),
 sizeof (yWhile),
 sizeof (ySkip),
 sizeof (yStop),
 sizeof (yInstance),
 sizeof (yCCode),
 sizeof (yNullProcess),
 sizeof (yAltList),
 sizeof (yNoAlt),
 sizeof (yAnAlts),
 sizeof (yAnAlt),
 sizeof (yANewAlt),
 sizeof (yGuard),
 sizeof (yAltInput),
 sizeof (yAltTimer),
 sizeof (yAltCaseIn),
 sizeof (yNoInput),
 sizeof (yChoiceList),
 sizeof (yNoChoice),
 sizeof (yAChoices),
 sizeof (yAChoice),
 sizeof (yANewIf),
 sizeof (yProcList),
 sizeof (yNoProcess),
 sizeof (yAProcess),
 sizeof (yCaseList),
 sizeof (yNoCase),
 sizeof (yACase),
 sizeof (yAccessList),
 sizeof (yAnAccess),
 sizeof (yNoAccess),
 sizeof (yElementList),
 sizeof (yAnElement),
 sizeof (yNoElement),
};
char * Tree_NodeName [184 + 1] = {
 "NoTree",
 "Start",
 "SpecList",
 "NoSpec",
 "ASpec",
 "Spec",
 "Decl",
 "Is",
 "AVal",
 "Val",
 "ValRetypes",
 "Retypes",
 "DefAPro",
 "DefSeqPro",
 "DefTagPro",
 "DefAProc",
 "DefProc",
 "PrototypeProc",
 "DefAFunc",
 "DefFunc",
 "DefIsFunc",
 "PrototypeFunc",
 "NullSpec",
 "HCode",
 "CallFrame",
 "ParFrame",
 "Formals",
 "NoFormal",
 "AFormal",
 "Replicator",
 "TagProList",
 "NoTagPro",
 "ATagPro",
 "By",
 "ByVal",
 "ByRef",
 "ByUndef",
 "IdList",
 "NoId",
 "AnId",
 "Type",
 "Array",
 "Chan",
 "Timer",
 "Untyped",
 "Primitive",
 "Numeric",
 "Integer",
 "Int",
 "Int16",
 "Int32",
 "Int64",
 "Real",
 "Real32",
 "Real64",
 "Byte",
 "Bool",
 "TypeList",
 "NoType",
 "AType",
 "Protocol",
 "Any",
 "Named",
 "Simple",
 "Counted",
 "SeqProList",
 "NoSeqPro",
 "ASeqPro",
 "Expr",
 "Binary",
 "Unary",
 "Const",
 "Valof",
 "FuncCall",
 "ElementalExpr",
 "Default",
 "Convert",
 "Round",
 "Trunc",
 "MostPos",
 "MostNeg",
 "CountArray",
 "UnBound",
 "StringElement",
 "String",
 "StringSubscript",
 "StringRange",
 "Elemental",
 "TableElement",
 "Table",
 "TableSubscript",
 "TableRange",
 "Element",
 "Identifier",
 "ElementAccess",
 "Subscript",
 "Range",
 "ExprList",
 "NoExpr",
 "AnExpr",
 "Op",
 "RelOp",
 "Less",
 "Greater",
 "LessEqual",
 "GreaterEqual",
 "Equal",
 "NotEqual",
 "MathsOp",
 "Add",
 "Subtract",
 "Multiply",
 "Divide",
 "Rem",
 "BitOp",
 "BitAnd",
 "BitOr",
 "BitEor",
 "ShiftOp",
 "LeftShift",
 "RightShift",
 "UniOp",
 "Size",
 "BitNot",
 "Not",
 "ClockOp",
 "Plus",
 "Minus",
 "Times",
 "LogOp",
 "And",
 "Or",
 "AfterOp",
 "Process",
 "Assign",
 "AltType",
 "Alt",
 "AltRep",
 "ParType",
 "Par",
 "ParRep",
 "Processor",
 "IfType",
 "If",
 "IfRep",
 "Input",
 "Output",
 "CaseIn",
 "After",
 "SeqRep",
 "Seq",
 "Case",
 "While",
 "Skip",
 "Stop",
 "Instance",
 "CCode",
 "NullProcess",
 "AltList",
 "NoAlt",
 "AnAlts",
 "AnAlt",
 "ANewAlt",
 "Guard",
 "AltInput",
 "AltTimer",
 "AltCaseIn",
 "NoInput",
 "ChoiceList",
 "NoChoice",
 "AChoices",
 "AChoice",
 "ANewIf",
 "ProcList",
 "NoProcess",
 "AProcess",
 "CaseList",
 "NoCase",
 "ACase",
 "AccessList",
 "AnAccess",
 "NoAccess",
 "ElementList",
 "AnElement",
 "NoElement",
};
static Tree_tKind yyTypeRange [184 + 1] = { 0,
 kStart,
 kASpec,
 kNoSpec,
 kASpec,
 kParFrame,
 kDecl,
 kIs,
 kValRetypes,
 kVal,
 kValRetypes,
 kRetypes,
 kDefTagPro,
 kDefSeqPro,
 kDefTagPro,
 kPrototypeProc,
 kDefProc,
 kPrototypeProc,
 kPrototypeFunc,
 kDefFunc,
 kDefIsFunc,
 kPrototypeFunc,
 kNullSpec,
 kHCode,
 kCallFrame,
 kParFrame,
 kAFormal,
 kNoFormal,
 kAFormal,
 kReplicator,
 kATagPro,
 kNoTagPro,
 kATagPro,
 kByUndef,
 kByVal,
 kByRef,
 kByUndef,
 kAnId,
 kNoId,
 kAnId,
 kAType,
 kArray,
 kChan,
 kTimer,
 kUntyped,
 kBool,
 kReal64,
 kInt64,
 kInt,
 kInt16,
 kInt32,
 kInt64,
 kReal64,
 kReal32,
 kReal64,
 kByte,
 kBool,
 kAType,
 kNoType,
 kAType,
 kCounted,
 kAny,
 kNamed,
 kSimple,
 kCounted,
 kASeqPro,
 kNoSeqPro,
 kASeqPro,
 kStringRange,
 kBinary,
 kUnary,
 kConst,
 kValof,
 kFuncCall,
 kElementalExpr,
 kDefault,
 kConvert,
 kRound,
 kTrunc,
 kMostPos,
 kMostNeg,
 kCountArray,
 kUnBound,
 kStringRange,
 kString,
 kStringSubscript,
 kStringRange,
 kRange,
 kTableRange,
 kTable,
 kTableSubscript,
 kTableRange,
 kRange,
 kIdentifier,
 kRange,
 kSubscript,
 kRange,
 kAnExpr,
 kNoExpr,
 kAnExpr,
 kAfterOp,
 kNotEqual,
 kLess,
 kGreater,
 kLessEqual,
 kGreaterEqual,
 kEqual,
 kNotEqual,
 kRem,
 kAdd,
 kSubtract,
 kMultiply,
 kDivide,
 kRem,
 kBitEor,
 kBitAnd,
 kBitOr,
 kBitEor,
 kRightShift,
 kLeftShift,
 kRightShift,
 kNot,
 kSize,
 kBitNot,
 kNot,
 kTimes,
 kPlus,
 kMinus,
 kTimes,
 kOr,
 kAnd,
 kOr,
 kAfterOp,
 kNullProcess,
 kAssign,
 kAltRep,
 kAlt,
 kAltRep,
 kParRep,
 kPar,
 kParRep,
 kProcessor,
 kIfRep,
 kIf,
 kIfRep,
 kInput,
 kOutput,
 kCaseIn,
 kAfter,
 kSeqRep,
 kSeq,
 kCase,
 kWhile,
 kSkip,
 kStop,
 kInstance,
 kCCode,
 kNullProcess,
 kANewAlt,
 kNoAlt,
 kANewAlt,
 kAnAlt,
 kANewAlt,
 kNoInput,
 kAltInput,
 kAltTimer,
 kAltCaseIn,
 kNoInput,
 kANewIf,
 kNoChoice,
 kANewIf,
 kAChoice,
 kANewIf,
 kAProcess,
 kNoProcess,
 kAProcess,
 kACase,
 kNoCase,
 kACase,
 kNoAccess,
 kAnAccess,
 kNoAccess,
 kNoElement,
 kAnElement,
 kNoElement,
};

tTree Tree_Alloc ()
{
 register yytBlockPtr yyBlockPtr = yyBlockList;
 register int i;

 if (yyMaxSize == 0)
  for (i = 1; i <= 184; i ++) {
   Tree_NodeSize [i] = (Tree_NodeSize [i] + yyMaxAlign - 1) & yyAlignMasks [yyMaxAlign];
   yyMaxSize = Max (Tree_NodeSize [i], yyMaxSize);
  }
 yyBlockList = (yytBlockPtr) Alloc (sizeof (yytBlock));
 yyBlockList->yySuccessor = yyBlockPtr;
 Tree_PoolFreePtr = yyBlockList->yyBlock;
 Tree_PoolMaxPtr = Tree_PoolFreePtr + yyBlockSize - yyMaxSize + 1;
 Tree_HeapUsed += yyBlockSize;
 return (tTree) Tree_PoolFreePtr;
}

tTree MakeTree
# if defined __STDC__ | defined __cplusplus
 (Tree_tKind yyKind)
# else
 (yyKind) Tree_tKind yyKind;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [yyKind])
 yyt->Kind = yyKind;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

bool Tree_IsType
# if defined __STDC__ | defined __cplusplus
 (register tTree yyt, register Tree_tKind yyKind)
# else
 (yyt, yyKind) register tTree yyt; register Tree_tKind yyKind;
# endif
{
 return yyt != NoTree && yyKind <= yyt->Kind && yyt->Kind <= yyTypeRange [yyKind];
}


tTree mStart
# if defined __STDC__ | defined __cplusplus
(tTree pProcess)
# else
(pProcess)
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kStart])
 yyt->Kind = kStart;
 yyt->yyHead.yyMark = 0;
 yyt->Start.Process = pProcess;
 begintChain(yyt->Start.CGNext)
 begintSymbol(yyt->Start.OuterProc)
 return yyt;
}

tTree mSpecList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSpecList])
 yyt->Kind = kSpecList;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->SpecList.VS)
 beginint(yyt->SpecList.VIn)
 beginint(yyt->SpecList.VOut)
 beginint(yyt->SpecList.DCL)
 begintSymbol(yyt->SpecList.Parent)
 beginbool(yyt->SpecList.AtomicSpec)
 begintParUsage(yyt->SpecList.PUIn)
 begintParUsage(yyt->SpecList.PUOut)
 return yyt;
}

tTree mNoSpec
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoSpec])
 yyt->Kind = kNoSpec;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->NoSpec.VS)
 beginint(yyt->NoSpec.VIn)
 beginint(yyt->NoSpec.VOut)
 beginint(yyt->NoSpec.DCL)
 begintSymbol(yyt->NoSpec.Parent)
 beginbool(yyt->NoSpec.AtomicSpec)
 begintParUsage(yyt->NoSpec.PUIn)
 begintParUsage(yyt->NoSpec.PUOut)
 return yyt;
}

tTree mASpec
# if defined __STDC__ | defined __cplusplus
(tTree pSpec, tTree pNext)
# else
(pSpec, pNext)
tTree pSpec;
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kASpec])
 yyt->Kind = kASpec;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->ASpec.VS)
 beginint(yyt->ASpec.VIn)
 beginint(yyt->ASpec.VOut)
 beginint(yyt->ASpec.DCL)
 begintSymbol(yyt->ASpec.Parent)
 beginbool(yyt->ASpec.AtomicSpec)
 begintParUsage(yyt->ASpec.PUIn)
 begintParUsage(yyt->ASpec.PUOut)
 yyt->ASpec.Spec = pSpec;
 yyt->ASpec.Next = pNext;
 return yyt;
}

tTree mSpec
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSpec])
 yyt->Kind = kSpec;
 yyt->yyHead.yyMark = 0;
 yyt->Spec.Pos = pPos;
 beginint(yyt->Spec.VS)
 beginint(yyt->Spec.VIn)
 beginint(yyt->Spec.VOut)
 begintSymbol(yyt->Spec.Parent)
 beginbool(yyt->Spec.AtomicSpec)
 begintParUsage(yyt->Spec.PUIn)
 begintParUsage(yyt->Spec.PUOut)
 return yyt;
}

tTree mDecl
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType, tTree pIdList)
# else
(pPos, pType, pIdList)
tPosition pPos;
tTree pType;
tTree pIdList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDecl])
 yyt->Kind = kDecl;
 yyt->yyHead.yyMark = 0;
 yyt->Decl.Pos = pPos;
 beginint(yyt->Decl.VS)
 beginint(yyt->Decl.VIn)
 beginint(yyt->Decl.VOut)
 begintSymbol(yyt->Decl.Parent)
 beginbool(yyt->Decl.AtomicSpec)
 begintParUsage(yyt->Decl.PUIn)
 begintParUsage(yyt->Decl.PUOut)
 yyt->Decl.Type = pType;
 yyt->Decl.IdList = pIdList;
 return yyt;
}

tTree mIs
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType, tSymbol pSym, tTree pElemental)
# else
(pPos, pType, pSym, pElemental)
tPosition pPos;
tTree pType;
tSymbol pSym;
tTree pElemental;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kIs])
 yyt->Kind = kIs;
 yyt->yyHead.yyMark = 0;
 yyt->Is.Pos = pPos;
 beginint(yyt->Is.VS)
 beginint(yyt->Is.VIn)
 beginint(yyt->Is.VOut)
 begintSymbol(yyt->Is.Parent)
 beginbool(yyt->Is.AtomicSpec)
 begintParUsage(yyt->Is.PUIn)
 begintParUsage(yyt->Is.PUOut)
 yyt->Is.Type = pType;
 yyt->Is.Sym = pSym;
 yyt->Is.Elemental = pElemental;
 begintUsage(yyt->Is.U)
 return yyt;
}

tTree mAVal
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType, tSymbol pSym, tTree pExpr)
# else
(pPos, pType, pSym, pExpr)
tPosition pPos;
tTree pType;
tSymbol pSym;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAVal])
 yyt->Kind = kAVal;
 yyt->yyHead.yyMark = 0;
 yyt->AVal.Pos = pPos;
 beginint(yyt->AVal.VS)
 beginint(yyt->AVal.VIn)
 beginint(yyt->AVal.VOut)
 begintSymbol(yyt->AVal.Parent)
 beginbool(yyt->AVal.AtomicSpec)
 begintParUsage(yyt->AVal.PUIn)
 begintParUsage(yyt->AVal.PUOut)
 yyt->AVal.Type = pType;
 yyt->AVal.Sym = pSym;
 yyt->AVal.Expr = pExpr;
 return yyt;
}

tTree mVal
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType, tSymbol pSym, tTree pExpr)
# else
(pPos, pType, pSym, pExpr)
tPosition pPos;
tTree pType;
tSymbol pSym;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kVal])
 yyt->Kind = kVal;
 yyt->yyHead.yyMark = 0;
 yyt->Val.Pos = pPos;
 beginint(yyt->Val.VS)
 beginint(yyt->Val.VIn)
 beginint(yyt->Val.VOut)
 begintSymbol(yyt->Val.Parent)
 beginbool(yyt->Val.AtomicSpec)
 begintParUsage(yyt->Val.PUIn)
 begintParUsage(yyt->Val.PUOut)
 yyt->Val.Type = pType;
 yyt->Val.Sym = pSym;
 yyt->Val.Expr = pExpr;
 return yyt;
}

tTree mValRetypes
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType, tSymbol pSym, tTree pExpr)
# else
(pPos, pType, pSym, pExpr)
tPosition pPos;
tTree pType;
tSymbol pSym;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kValRetypes])
 yyt->Kind = kValRetypes;
 yyt->yyHead.yyMark = 0;
 yyt->ValRetypes.Pos = pPos;
 beginint(yyt->ValRetypes.VS)
 beginint(yyt->ValRetypes.VIn)
 beginint(yyt->ValRetypes.VOut)
 begintSymbol(yyt->ValRetypes.Parent)
 beginbool(yyt->ValRetypes.AtomicSpec)
 begintParUsage(yyt->ValRetypes.PUIn)
 begintParUsage(yyt->ValRetypes.PUOut)
 yyt->ValRetypes.Type = pType;
 yyt->ValRetypes.Sym = pSym;
 yyt->ValRetypes.Expr = pExpr;
 return yyt;
}

tTree mRetypes
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType, tSymbol pSym, tTree pElemental)
# else
(pPos, pType, pSym, pElemental)
tPosition pPos;
tTree pType;
tSymbol pSym;
tTree pElemental;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRetypes])
 yyt->Kind = kRetypes;
 yyt->yyHead.yyMark = 0;
 yyt->Retypes.Pos = pPos;
 beginint(yyt->Retypes.VS)
 beginint(yyt->Retypes.VIn)
 beginint(yyt->Retypes.VOut)
 begintSymbol(yyt->Retypes.Parent)
 beginbool(yyt->Retypes.AtomicSpec)
 begintParUsage(yyt->Retypes.PUIn)
 begintParUsage(yyt->Retypes.PUOut)
 yyt->Retypes.Type = pType;
 yyt->Retypes.Sym = pSym;
 yyt->Retypes.Elemental = pElemental;
 return yyt;
}

tTree mDefAPro
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefAPro])
 yyt->Kind = kDefAPro;
 yyt->yyHead.yyMark = 0;
 yyt->DefAPro.Pos = pPos;
 beginint(yyt->DefAPro.VS)
 beginint(yyt->DefAPro.VIn)
 beginint(yyt->DefAPro.VOut)
 begintSymbol(yyt->DefAPro.Parent)
 beginbool(yyt->DefAPro.AtomicSpec)
 begintParUsage(yyt->DefAPro.PUIn)
 begintParUsage(yyt->DefAPro.PUOut)
 return yyt;
}

tTree mDefSeqPro
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pSeqProList)
# else
(pPos, pSym, pSeqProList)
tPosition pPos;
tSymbol pSym;
tTree pSeqProList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefSeqPro])
 yyt->Kind = kDefSeqPro;
 yyt->yyHead.yyMark = 0;
 yyt->DefSeqPro.Pos = pPos;
 beginint(yyt->DefSeqPro.VS)
 beginint(yyt->DefSeqPro.VIn)
 beginint(yyt->DefSeqPro.VOut)
 begintSymbol(yyt->DefSeqPro.Parent)
 beginbool(yyt->DefSeqPro.AtomicSpec)
 begintParUsage(yyt->DefSeqPro.PUIn)
 begintParUsage(yyt->DefSeqPro.PUOut)
 yyt->DefSeqPro.Sym = pSym;
 yyt->DefSeqPro.SeqProList = pSeqProList;
 return yyt;
}

tTree mDefTagPro
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pTagProList)
# else
(pPos, pSym, pTagProList)
tPosition pPos;
tSymbol pSym;
tTree pTagProList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefTagPro])
 yyt->Kind = kDefTagPro;
 yyt->yyHead.yyMark = 0;
 yyt->DefTagPro.Pos = pPos;
 beginint(yyt->DefTagPro.VS)
 beginint(yyt->DefTagPro.VIn)
 beginint(yyt->DefTagPro.VOut)
 begintSymbol(yyt->DefTagPro.Parent)
 beginbool(yyt->DefTagPro.AtomicSpec)
 begintParUsage(yyt->DefTagPro.PUIn)
 begintParUsage(yyt->DefTagPro.PUOut)
 yyt->DefTagPro.Sym = pSym;
 yyt->DefTagPro.TagProList = pTagProList;
 return yyt;
}

tTree mDefAProc
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pFormals)
# else
(pPos, pSym, pFormals)
tPosition pPos;
tSymbol pSym;
tTree pFormals;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefAProc])
 yyt->Kind = kDefAProc;
 yyt->yyHead.yyMark = 0;
 yyt->DefAProc.Pos = pPos;
 beginint(yyt->DefAProc.VS)
 beginint(yyt->DefAProc.VIn)
 beginint(yyt->DefAProc.VOut)
 begintSymbol(yyt->DefAProc.Parent)
 beginbool(yyt->DefAProc.AtomicSpec)
 begintParUsage(yyt->DefAProc.PUIn)
 begintParUsage(yyt->DefAProc.PUOut)
 yyt->DefAProc.Sym = pSym;
 yyt->DefAProc.Formals = pFormals;
 begintUsage(yyt->DefAProc.U)
 begintChain(yyt->DefAProc.CGNext)
 return yyt;
}

tTree mDefProc
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pFormals, tTree pProcess)
# else
(pPos, pSym, pFormals, pProcess)
tPosition pPos;
tSymbol pSym;
tTree pFormals;
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefProc])
 yyt->Kind = kDefProc;
 yyt->yyHead.yyMark = 0;
 yyt->DefProc.Pos = pPos;
 beginint(yyt->DefProc.VS)
 beginint(yyt->DefProc.VIn)
 beginint(yyt->DefProc.VOut)
 begintSymbol(yyt->DefProc.Parent)
 beginbool(yyt->DefProc.AtomicSpec)
 begintParUsage(yyt->DefProc.PUIn)
 begintParUsage(yyt->DefProc.PUOut)
 yyt->DefProc.Sym = pSym;
 yyt->DefProc.Formals = pFormals;
 begintUsage(yyt->DefProc.U)
 begintChain(yyt->DefProc.CGNext)
 yyt->DefProc.Process = pProcess;
 beginbool(yyt->DefProc.ATOMIC)
 beginbool(yyt->DefProc.isPar)
 return yyt;
}

tTree mPrototypeProc
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pFormals, tIdent pModule, tLang pLang)
# else
(pPos, pSym, pFormals, pModule, pLang)
tPosition pPos;
tSymbol pSym;
tTree pFormals;
tIdent pModule;
tLang pLang;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kPrototypeProc])
 yyt->Kind = kPrototypeProc;
 yyt->yyHead.yyMark = 0;
 yyt->PrototypeProc.Pos = pPos;
 beginint(yyt->PrototypeProc.VS)
 beginint(yyt->PrototypeProc.VIn)
 beginint(yyt->PrototypeProc.VOut)
 begintSymbol(yyt->PrototypeProc.Parent)
 beginbool(yyt->PrototypeProc.AtomicSpec)
 begintParUsage(yyt->PrototypeProc.PUIn)
 begintParUsage(yyt->PrototypeProc.PUOut)
 yyt->PrototypeProc.Sym = pSym;
 yyt->PrototypeProc.Formals = pFormals;
 begintUsage(yyt->PrototypeProc.U)
 begintChain(yyt->PrototypeProc.CGNext)
 yyt->PrototypeProc.Module = pModule;
 yyt->PrototypeProc.Lang = pLang;
 return yyt;
}

tTree mDefAFunc
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pTypeList, tTree pFormals)
# else
(pPos, pSym, pTypeList, pFormals)
tPosition pPos;
tSymbol pSym;
tTree pTypeList;
tTree pFormals;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefAFunc])
 yyt->Kind = kDefAFunc;
 yyt->yyHead.yyMark = 0;
 yyt->DefAFunc.Pos = pPos;
 beginint(yyt->DefAFunc.VS)
 beginint(yyt->DefAFunc.VIn)
 beginint(yyt->DefAFunc.VOut)
 begintSymbol(yyt->DefAFunc.Parent)
 beginbool(yyt->DefAFunc.AtomicSpec)
 begintParUsage(yyt->DefAFunc.PUIn)
 begintParUsage(yyt->DefAFunc.PUOut)
 yyt->DefAFunc.Sym = pSym;
 yyt->DefAFunc.TypeList = pTypeList;
 yyt->DefAFunc.Formals = pFormals;
 begintUsage(yyt->DefAFunc.U)
 begintChain(yyt->DefAFunc.CGNext)
 return yyt;
}

tTree mDefFunc
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pTypeList, tTree pFormals, tTree pValof)
# else
(pPos, pSym, pTypeList, pFormals, pValof)
tPosition pPos;
tSymbol pSym;
tTree pTypeList;
tTree pFormals;
tTree pValof;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefFunc])
 yyt->Kind = kDefFunc;
 yyt->yyHead.yyMark = 0;
 yyt->DefFunc.Pos = pPos;
 beginint(yyt->DefFunc.VS)
 beginint(yyt->DefFunc.VIn)
 beginint(yyt->DefFunc.VOut)
 begintSymbol(yyt->DefFunc.Parent)
 beginbool(yyt->DefFunc.AtomicSpec)
 begintParUsage(yyt->DefFunc.PUIn)
 begintParUsage(yyt->DefFunc.PUOut)
 yyt->DefFunc.Sym = pSym;
 yyt->DefFunc.TypeList = pTypeList;
 yyt->DefFunc.Formals = pFormals;
 begintUsage(yyt->DefFunc.U)
 begintChain(yyt->DefFunc.CGNext)
 yyt->DefFunc.Valof = pValof;
 beginbool(yyt->DefFunc.ATOMIC)
 return yyt;
}

tTree mDefIsFunc
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pTypeList, tTree pFormals, tTree pExprList)
# else
(pPos, pSym, pTypeList, pFormals, pExprList)
tPosition pPos;
tSymbol pSym;
tTree pTypeList;
tTree pFormals;
tTree pExprList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefIsFunc])
 yyt->Kind = kDefIsFunc;
 yyt->yyHead.yyMark = 0;
 yyt->DefIsFunc.Pos = pPos;
 beginint(yyt->DefIsFunc.VS)
 beginint(yyt->DefIsFunc.VIn)
 beginint(yyt->DefIsFunc.VOut)
 begintSymbol(yyt->DefIsFunc.Parent)
 beginbool(yyt->DefIsFunc.AtomicSpec)
 begintParUsage(yyt->DefIsFunc.PUIn)
 begintParUsage(yyt->DefIsFunc.PUOut)
 yyt->DefIsFunc.Sym = pSym;
 yyt->DefIsFunc.TypeList = pTypeList;
 yyt->DefIsFunc.Formals = pFormals;
 begintUsage(yyt->DefIsFunc.U)
 begintChain(yyt->DefIsFunc.CGNext)
 yyt->DefIsFunc.ExprList = pExprList;
 beginbool(yyt->DefIsFunc.ATOMIC)
 return yyt;
}

tTree mPrototypeFunc
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pTypeList, tTree pFormals, tIdent pModule, tLang pLang)
# else
(pPos, pSym, pTypeList, pFormals, pModule, pLang)
tPosition pPos;
tSymbol pSym;
tTree pTypeList;
tTree pFormals;
tIdent pModule;
tLang pLang;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kPrototypeFunc])
 yyt->Kind = kPrototypeFunc;
 yyt->yyHead.yyMark = 0;
 yyt->PrototypeFunc.Pos = pPos;
 beginint(yyt->PrototypeFunc.VS)
 beginint(yyt->PrototypeFunc.VIn)
 beginint(yyt->PrototypeFunc.VOut)
 begintSymbol(yyt->PrototypeFunc.Parent)
 beginbool(yyt->PrototypeFunc.AtomicSpec)
 begintParUsage(yyt->PrototypeFunc.PUIn)
 begintParUsage(yyt->PrototypeFunc.PUOut)
 yyt->PrototypeFunc.Sym = pSym;
 yyt->PrototypeFunc.TypeList = pTypeList;
 yyt->PrototypeFunc.Formals = pFormals;
 begintUsage(yyt->PrototypeFunc.U)
 begintChain(yyt->PrototypeFunc.CGNext)
 yyt->PrototypeFunc.Module = pModule;
 yyt->PrototypeFunc.Lang = pLang;
 return yyt;
}

tTree mNullSpec
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNullSpec])
 yyt->Kind = kNullSpec;
 yyt->yyHead.yyMark = 0;
 yyt->NullSpec.Pos = pPos;
 beginint(yyt->NullSpec.VS)
 beginint(yyt->NullSpec.VIn)
 beginint(yyt->NullSpec.VOut)
 begintSymbol(yyt->NullSpec.Parent)
 beginbool(yyt->NullSpec.AtomicSpec)
 begintParUsage(yyt->NullSpec.PUIn)
 begintParUsage(yyt->NullSpec.PUOut)
 return yyt;
}

tTree mHCode
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tStringRef pCode, tSymbol pScope)
# else
(pPos, pCode, pScope)
tPosition pPos;
tStringRef pCode;
tSymbol pScope;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kHCode])
 yyt->Kind = kHCode;
 yyt->yyHead.yyMark = 0;
 yyt->HCode.Pos = pPos;
 beginint(yyt->HCode.VS)
 beginint(yyt->HCode.VIn)
 beginint(yyt->HCode.VOut)
 begintSymbol(yyt->HCode.Parent)
 beginbool(yyt->HCode.AtomicSpec)
 begintParUsage(yyt->HCode.PUIn)
 begintParUsage(yyt->HCode.PUOut)
 yyt->HCode.Code = pCode;
 yyt->HCode.Scope = pScope;
 begintChain(yyt->HCode.CGNext)
 return yyt;
}

tTree mCallFrame
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tIdent pId, tSymbol pSym)
# else
(pPos, pId, pSym)
tPosition pPos;
tIdent pId;
tSymbol pSym;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCallFrame])
 yyt->Kind = kCallFrame;
 yyt->yyHead.yyMark = 0;
 yyt->CallFrame.Pos = pPos;
 beginint(yyt->CallFrame.VS)
 beginint(yyt->CallFrame.VIn)
 beginint(yyt->CallFrame.VOut)
 begintSymbol(yyt->CallFrame.Parent)
 beginbool(yyt->CallFrame.AtomicSpec)
 begintParUsage(yyt->CallFrame.PUIn)
 begintParUsage(yyt->CallFrame.PUOut)
 yyt->CallFrame.Id = pId;
 yyt->CallFrame.Sym = pSym;
 return yyt;
}

tTree mParFrame
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tIdent pTId, tIdent pFId, tSymbol pSym, int pRep)
# else
(pPos, pTId, pFId, pSym, pRep)
tPosition pPos;
tIdent pTId;
tIdent pFId;
tSymbol pSym;
int pRep;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kParFrame])
 yyt->Kind = kParFrame;
 yyt->yyHead.yyMark = 0;
 yyt->ParFrame.Pos = pPos;
 beginint(yyt->ParFrame.VS)
 beginint(yyt->ParFrame.VIn)
 beginint(yyt->ParFrame.VOut)
 begintSymbol(yyt->ParFrame.Parent)
 beginbool(yyt->ParFrame.AtomicSpec)
 begintParUsage(yyt->ParFrame.PUIn)
 begintParUsage(yyt->ParFrame.PUOut)
 yyt->ParFrame.TId = pTId;
 yyt->ParFrame.FId = pFId;
 yyt->ParFrame.Sym = pSym;
 yyt->ParFrame.Rep = pRep;
 return yyt;
}

tTree mFormals
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFormals])
 yyt->Kind = kFormals;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Formals.VIn)
 beginint(yyt->Formals.VOut)
 beginbool(yyt->Formals.InPrototype)
 begintSymbol(yyt->Formals.Parent)
 beginbool(yyt->Formals.AtomicSpec)
 begintParUsage(yyt->Formals.PUIn)
 begintParUsage(yyt->Formals.PUOut)
 return yyt;
}

tTree mNoFormal
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoFormal])
 yyt->Kind = kNoFormal;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->NoFormal.VIn)
 beginint(yyt->NoFormal.VOut)
 beginbool(yyt->NoFormal.InPrototype)
 begintSymbol(yyt->NoFormal.Parent)
 beginbool(yyt->NoFormal.AtomicSpec)
 begintParUsage(yyt->NoFormal.PUIn)
 begintParUsage(yyt->NoFormal.PUOut)
 return yyt;
}

tTree mAFormal
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pBy, tTree pType, tSymbol pSym)
# else
(pNext, pPos, pBy, pType, pSym)
tTree pNext;
tPosition pPos;
tTree pBy;
tTree pType;
tSymbol pSym;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAFormal])
 yyt->Kind = kAFormal;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->AFormal.VIn)
 beginint(yyt->AFormal.VOut)
 beginbool(yyt->AFormal.InPrototype)
 begintSymbol(yyt->AFormal.Parent)
 beginbool(yyt->AFormal.AtomicSpec)
 begintParUsage(yyt->AFormal.PUIn)
 begintParUsage(yyt->AFormal.PUOut)
 yyt->AFormal.Next = pNext;
 yyt->AFormal.Pos = pPos;
 yyt->AFormal.By = pBy;
 yyt->AFormal.Type = pType;
 yyt->AFormal.Sym = pSym;
 begintUsage(yyt->AFormal.U)
 return yyt;
}

tTree mReplicator
# if defined __STDC__ | defined __cplusplus
(tSymbol pSym, tTree pFrom, tTree pFor)
# else
(pSym, pFrom, pFor)
tSymbol pSym;
tTree pFrom;
tTree pFor;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kReplicator])
 yyt->Kind = kReplicator;
 yyt->yyHead.yyMark = 0;
 yyt->Replicator.Sym = pSym;
 yyt->Replicator.From = pFrom;
 yyt->Replicator.For = pFor;
 beginint(yyt->Replicator.VIn)
 beginint(yyt->Replicator.VOut)
 begintSymbol(yyt->Replicator.Parent)
 beginbool(yyt->Replicator.AtomicSpec)
 begintParUsage(yyt->Replicator.PUIn)
 begintParUsage(yyt->Replicator.PUOut)
 beginbool(yyt->Replicator.SE)
 beginpLinExpr(yyt->Replicator.FromLE)
 beginpLinExpr(yyt->Replicator.ForLE)
 return yyt;
}

tTree mTagProList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTagProList])
 yyt->Kind = kTagProList;
 yyt->yyHead.yyMark = 0;
 begintParUsage(yyt->TagProList.PUIn)
 begintParUsage(yyt->TagProList.PUOut)
 return yyt;
}

tTree mNoTagPro
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoTagPro])
 yyt->Kind = kNoTagPro;
 yyt->yyHead.yyMark = 0;
 begintParUsage(yyt->NoTagPro.PUIn)
 begintParUsage(yyt->NoTagPro.PUOut)
 return yyt;
}

tTree mATagPro
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tSymbol pSym, tTree pSeqProList)
# else
(pNext, pSym, pSeqProList)
tTree pNext;
tSymbol pSym;
tTree pSeqProList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kATagPro])
 yyt->Kind = kATagPro;
 yyt->yyHead.yyMark = 0;
 begintParUsage(yyt->ATagPro.PUIn)
 begintParUsage(yyt->ATagPro.PUOut)
 yyt->ATagPro.Next = pNext;
 yyt->ATagPro.Sym = pSym;
 yyt->ATagPro.SeqProList = pSeqProList;
 return yyt;
}

tTree mBy
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBy])
 yyt->Kind = kBy;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mByVal
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kByVal])
 yyt->Kind = kByVal;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mByRef
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kByRef])
 yyt->Kind = kByRef;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mByUndef
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kByUndef])
 yyt->Kind = kByUndef;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mIdList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kIdList])
 yyt->Kind = kIdList;
 yyt->yyHead.yyMark = 0;
 begintSymbol(yyt->IdList.Parent)
 beginbool(yyt->IdList.AtomicSpec)
 return yyt;
}

tTree mNoId
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoId])
 yyt->Kind = kNoId;
 yyt->yyHead.yyMark = 0;
 begintSymbol(yyt->NoId.Parent)
 beginbool(yyt->NoId.AtomicSpec)
 return yyt;
}

tTree mAnId
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tSymbol pSym)
# else
(pNext, pSym)
tTree pNext;
tSymbol pSym;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAnId])
 yyt->Kind = kAnId;
 yyt->yyHead.yyMark = 0;
 begintSymbol(yyt->AnId.Parent)
 beginbool(yyt->AnId.AtomicSpec)
 yyt->AnId.Next = pNext;
 yyt->AnId.Sym = pSym;
 begintUsage(yyt->AnId.U)
 return yyt;
}

tTree mType
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kType])
 yyt->Kind = kType;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Type.VIn)
 beginint(yyt->Type.VOut)
 beginint(yyt->Type.D)
 begintParUsage(yyt->Type.PUIn)
 begintParUsage(yyt->Type.PUOut)
 return yyt;
}

tTree mArray
# if defined __STDC__ | defined __cplusplus
(tTree pExpr, tTree pType)
# else
(pExpr, pType)
tTree pExpr;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kArray])
 yyt->Kind = kArray;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Array.VIn)
 beginint(yyt->Array.VOut)
 beginint(yyt->Array.D)
 begintParUsage(yyt->Array.PUIn)
 begintParUsage(yyt->Array.PUOut)
 yyt->Array.Expr = pExpr;
 yyt->Array.Type = pType;
 beginbool(yyt->Array.SE)
 beginpLinExpr(yyt->Array.LE)
 return yyt;
}

tTree mChan
# if defined __STDC__ | defined __cplusplus
(tTree pProtocol)
# else
(pProtocol)
tTree pProtocol;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kChan])
 yyt->Kind = kChan;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Chan.VIn)
 beginint(yyt->Chan.VOut)
 beginint(yyt->Chan.D)
 begintParUsage(yyt->Chan.PUIn)
 begintParUsage(yyt->Chan.PUOut)
 yyt->Chan.Protocol = pProtocol;
 return yyt;
}

tTree mTimer
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTimer])
 yyt->Kind = kTimer;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Timer.VIn)
 beginint(yyt->Timer.VOut)
 beginint(yyt->Timer.D)
 begintParUsage(yyt->Timer.PUIn)
 begintParUsage(yyt->Timer.PUOut)
 return yyt;
}

tTree mUntyped
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kUntyped])
 yyt->Kind = kUntyped;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Untyped.VIn)
 beginint(yyt->Untyped.VOut)
 beginint(yyt->Untyped.D)
 begintParUsage(yyt->Untyped.PUIn)
 begintParUsage(yyt->Untyped.PUOut)
 return yyt;
}

tTree mPrimitive
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kPrimitive])
 yyt->Kind = kPrimitive;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Primitive.VIn)
 beginint(yyt->Primitive.VOut)
 beginint(yyt->Primitive.D)
 begintParUsage(yyt->Primitive.PUIn)
 begintParUsage(yyt->Primitive.PUOut)
 return yyt;
}

tTree mNumeric
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNumeric])
 yyt->Kind = kNumeric;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Numeric.VIn)
 beginint(yyt->Numeric.VOut)
 beginint(yyt->Numeric.D)
 begintParUsage(yyt->Numeric.PUIn)
 begintParUsage(yyt->Numeric.PUOut)
 return yyt;
}

tTree mInteger
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kInteger])
 yyt->Kind = kInteger;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Integer.VIn)
 beginint(yyt->Integer.VOut)
 beginint(yyt->Integer.D)
 begintParUsage(yyt->Integer.PUIn)
 begintParUsage(yyt->Integer.PUOut)
 return yyt;
}

tTree mInt
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kInt])
 yyt->Kind = kInt;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Int.VIn)
 beginint(yyt->Int.VOut)
 beginint(yyt->Int.D)
 begintParUsage(yyt->Int.PUIn)
 begintParUsage(yyt->Int.PUOut)
 return yyt;
}

tTree mInt16
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kInt16])
 yyt->Kind = kInt16;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Int16.VIn)
 beginint(yyt->Int16.VOut)
 beginint(yyt->Int16.D)
 begintParUsage(yyt->Int16.PUIn)
 begintParUsage(yyt->Int16.PUOut)
 return yyt;
}

tTree mInt32
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kInt32])
 yyt->Kind = kInt32;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Int32.VIn)
 beginint(yyt->Int32.VOut)
 beginint(yyt->Int32.D)
 begintParUsage(yyt->Int32.PUIn)
 begintParUsage(yyt->Int32.PUOut)
 return yyt;
}

tTree mInt64
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kInt64])
 yyt->Kind = kInt64;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Int64.VIn)
 beginint(yyt->Int64.VOut)
 beginint(yyt->Int64.D)
 begintParUsage(yyt->Int64.PUIn)
 begintParUsage(yyt->Int64.PUOut)
 return yyt;
}

tTree mReal
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kReal])
 yyt->Kind = kReal;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Real.VIn)
 beginint(yyt->Real.VOut)
 beginint(yyt->Real.D)
 begintParUsage(yyt->Real.PUIn)
 begintParUsage(yyt->Real.PUOut)
 return yyt;
}

tTree mReal32
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kReal32])
 yyt->Kind = kReal32;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Real32.VIn)
 beginint(yyt->Real32.VOut)
 beginint(yyt->Real32.D)
 begintParUsage(yyt->Real32.PUIn)
 begintParUsage(yyt->Real32.PUOut)
 return yyt;
}

tTree mReal64
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kReal64])
 yyt->Kind = kReal64;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Real64.VIn)
 beginint(yyt->Real64.VOut)
 beginint(yyt->Real64.D)
 begintParUsage(yyt->Real64.PUIn)
 begintParUsage(yyt->Real64.PUOut)
 return yyt;
}

tTree mByte
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kByte])
 yyt->Kind = kByte;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Byte.VIn)
 beginint(yyt->Byte.VOut)
 beginint(yyt->Byte.D)
 begintParUsage(yyt->Byte.PUIn)
 begintParUsage(yyt->Byte.PUOut)
 return yyt;
}

tTree mBool
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBool])
 yyt->Kind = kBool;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->Bool.VIn)
 beginint(yyt->Bool.VOut)
 beginint(yyt->Bool.D)
 begintParUsage(yyt->Bool.PUIn)
 begintParUsage(yyt->Bool.PUOut)
 return yyt;
}

tTree mTypeList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTypeList])
 yyt->Kind = kTypeList;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->TypeList.VIn)
 beginint(yyt->TypeList.VOut)
 beginint(yyt->TypeList.D)
 begintParUsage(yyt->TypeList.PUIn)
 begintParUsage(yyt->TypeList.PUOut)
 return yyt;
}

tTree mNoType
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoType])
 yyt->Kind = kNoType;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->NoType.VIn)
 beginint(yyt->NoType.VOut)
 beginint(yyt->NoType.D)
 begintParUsage(yyt->NoType.PUIn)
 begintParUsage(yyt->NoType.PUOut)
 return yyt;
}

tTree mAType
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pType)
# else
(pNext, pType)
tTree pNext;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAType])
 yyt->Kind = kAType;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->AType.VIn)
 beginint(yyt->AType.VOut)
 beginint(yyt->AType.D)
 begintParUsage(yyt->AType.PUIn)
 begintParUsage(yyt->AType.PUOut)
 yyt->AType.Next = pNext;
 yyt->AType.Type = pType;
 return yyt;
}

tTree mProtocol
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kProtocol])
 yyt->Kind = kProtocol;
 yyt->yyHead.yyMark = 0;
 yyt->Protocol.Pos = pPos;
 begintParUsage(yyt->Protocol.PUIn)
 begintParUsage(yyt->Protocol.PUOut)
 return yyt;
}

tTree mAny
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAny])
 yyt->Kind = kAny;
 yyt->yyHead.yyMark = 0;
 yyt->Any.Pos = pPos;
 begintParUsage(yyt->Any.PUIn)
 begintParUsage(yyt->Any.PUOut)
 return yyt;
}

tTree mNamed
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym)
# else
(pPos, pSym)
tPosition pPos;
tSymbol pSym;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNamed])
 yyt->Kind = kNamed;
 yyt->yyHead.yyMark = 0;
 yyt->Named.Pos = pPos;
 begintParUsage(yyt->Named.PUIn)
 begintParUsage(yyt->Named.PUOut)
 yyt->Named.Sym = pSym;
 return yyt;
}

tTree mSimple
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType)
# else
(pPos, pType)
tPosition pPos;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSimple])
 yyt->Kind = kSimple;
 yyt->yyHead.yyMark = 0;
 yyt->Simple.Pos = pPos;
 begintParUsage(yyt->Simple.PUIn)
 begintParUsage(yyt->Simple.PUOut)
 yyt->Simple.Type = pType;
 return yyt;
}

tTree mCounted
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pLength, tTree pType)
# else
(pPos, pLength, pType)
tPosition pPos;
tTree pLength;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCounted])
 yyt->Kind = kCounted;
 yyt->yyHead.yyMark = 0;
 yyt->Counted.Pos = pPos;
 begintParUsage(yyt->Counted.PUIn)
 begintParUsage(yyt->Counted.PUOut)
 yyt->Counted.Length = pLength;
 yyt->Counted.Type = pType;
 return yyt;
}

tTree mSeqProList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSeqProList])
 yyt->Kind = kSeqProList;
 yyt->yyHead.yyMark = 0;
 begintParUsage(yyt->SeqProList.PUIn)
 begintParUsage(yyt->SeqProList.PUOut)
 return yyt;
}

tTree mNoSeqPro
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoSeqPro])
 yyt->Kind = kNoSeqPro;
 yyt->yyHead.yyMark = 0;
 begintParUsage(yyt->NoSeqPro.PUIn)
 begintParUsage(yyt->NoSeqPro.PUOut)
 return yyt;
}

tTree mASeqPro
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pProtocol)
# else
(pNext, pProtocol)
tTree pNext;
tTree pProtocol;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kASeqPro])
 yyt->Kind = kASeqPro;
 yyt->yyHead.yyMark = 0;
 begintParUsage(yyt->ASeqPro.PUIn)
 begintParUsage(yyt->ASeqPro.PUOut)
 yyt->ASeqPro.Next = pNext;
 yyt->ASeqPro.Protocol = pProtocol;
 return yyt;
}

tTree mExpr
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kExpr])
 yyt->Kind = kExpr;
 yyt->yyHead.yyMark = 0;
 yyt->Expr.Pos = pPos;
 begintType(yyt->Expr.SynType)
 beginint(yyt->Expr.VIn)
 beginint(yyt->Expr.VOut)
 beginbool(yyt->Expr.C)
 begintValue(yyt->Expr.CV)
 begintSymbol(yyt->Expr.Parent)
 begintParUsage(yyt->Expr.PUIn)
 begintParUsage(yyt->Expr.PUOut)
 beginbool(yyt->Expr.LV)
 return yyt;
}

tTree mBinary
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pLop, tTree pRop, tTree pOp)
# else
(pPos, pLop, pRop, pOp)
tPosition pPos;
tTree pLop;
tTree pRop;
tTree pOp;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBinary])
 yyt->Kind = kBinary;
 yyt->yyHead.yyMark = 0;
 yyt->Binary.Pos = pPos;
 begintType(yyt->Binary.SynType)
 beginint(yyt->Binary.VIn)
 beginint(yyt->Binary.VOut)
 beginbool(yyt->Binary.C)
 begintValue(yyt->Binary.CV)
 begintSymbol(yyt->Binary.Parent)
 begintParUsage(yyt->Binary.PUIn)
 begintParUsage(yyt->Binary.PUOut)
 beginbool(yyt->Binary.LV)
 yyt->Binary.Lop = pLop;
 yyt->Binary.Rop = pRop;
 yyt->Binary.Op = pOp;
 return yyt;
}

tTree mUnary
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pExpr, tTree pOp)
# else
(pPos, pExpr, pOp)
tPosition pPos;
tTree pExpr;
tTree pOp;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kUnary])
 yyt->Kind = kUnary;
 yyt->yyHead.yyMark = 0;
 yyt->Unary.Pos = pPos;
 begintType(yyt->Unary.SynType)
 beginint(yyt->Unary.VIn)
 beginint(yyt->Unary.VOut)
 beginbool(yyt->Unary.C)
 begintValue(yyt->Unary.CV)
 begintSymbol(yyt->Unary.Parent)
 begintParUsage(yyt->Unary.PUIn)
 begintParUsage(yyt->Unary.PUOut)
 beginbool(yyt->Unary.LV)
 yyt->Unary.Expr = pExpr;
 yyt->Unary.Op = pOp;
 return yyt;
}

tTree mConst
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tValue pValue, tTree pType)
# else
(pPos, pValue, pType)
tPosition pPos;
tValue pValue;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConst])
 yyt->Kind = kConst;
 yyt->yyHead.yyMark = 0;
 yyt->Const.Pos = pPos;
 begintType(yyt->Const.SynType)
 beginint(yyt->Const.VIn)
 beginint(yyt->Const.VOut)
 beginbool(yyt->Const.C)
 begintValue(yyt->Const.CV)
 begintSymbol(yyt->Const.Parent)
 begintParUsage(yyt->Const.PUIn)
 begintParUsage(yyt->Const.PUOut)
 beginbool(yyt->Const.LV)
 yyt->Const.Value = pValue;
 yyt->Const.Type = pType;
 return yyt;
}

tTree mValof
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pProcess, tTree pExprList, tSymbol pSym, int pVS)
# else
(pPos, pSpecList, pProcess, pExprList, pSym, pVS)
tPosition pPos;
tTree pSpecList;
tTree pProcess;
tTree pExprList;
tSymbol pSym;
int pVS;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kValof])
 yyt->Kind = kValof;
 yyt->yyHead.yyMark = 0;
 yyt->Valof.Pos = pPos;
 begintType(yyt->Valof.SynType)
 beginint(yyt->Valof.VIn)
 beginint(yyt->Valof.VOut)
 beginbool(yyt->Valof.C)
 begintValue(yyt->Valof.CV)
 begintSymbol(yyt->Valof.Parent)
 begintParUsage(yyt->Valof.PUIn)
 begintParUsage(yyt->Valof.PUOut)
 beginbool(yyt->Valof.LV)
 yyt->Valof.SpecList = pSpecList;
 yyt->Valof.Process = pProcess;
 yyt->Valof.ExprList = pExprList;
 yyt->Valof.Sym = pSym;
 yyt->Valof.VS = pVS;
 return yyt;
}

tTree mFuncCall
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tTree pExprList, int pDepth)
# else
(pPos, pSym, pExprList, pDepth)
tPosition pPos;
tSymbol pSym;
tTree pExprList;
int pDepth;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFuncCall])
 yyt->Kind = kFuncCall;
 yyt->yyHead.yyMark = 0;
 yyt->FuncCall.Pos = pPos;
 begintType(yyt->FuncCall.SynType)
 beginint(yyt->FuncCall.VIn)
 beginint(yyt->FuncCall.VOut)
 beginbool(yyt->FuncCall.C)
 begintValue(yyt->FuncCall.CV)
 begintSymbol(yyt->FuncCall.Parent)
 begintParUsage(yyt->FuncCall.PUIn)
 begintParUsage(yyt->FuncCall.PUOut)
 beginbool(yyt->FuncCall.LV)
 yyt->FuncCall.Sym = pSym;
 yyt->FuncCall.ExprList = pExprList;
 yyt->FuncCall.Depth = pDepth;
 begintFrame(yyt->FuncCall.Frame)
 return yyt;
}

tTree mElementalExpr
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pElemental)
# else
(pPos, pElemental)
tPosition pPos;
tTree pElemental;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElementalExpr])
 yyt->Kind = kElementalExpr;
 yyt->yyHead.yyMark = 0;
 yyt->ElementalExpr.Pos = pPos;
 begintType(yyt->ElementalExpr.SynType)
 beginint(yyt->ElementalExpr.VIn)
 beginint(yyt->ElementalExpr.VOut)
 beginbool(yyt->ElementalExpr.C)
 begintValue(yyt->ElementalExpr.CV)
 begintSymbol(yyt->ElementalExpr.Parent)
 begintParUsage(yyt->ElementalExpr.PUIn)
 begintParUsage(yyt->ElementalExpr.PUOut)
 beginbool(yyt->ElementalExpr.LV)
 yyt->ElementalExpr.Elemental = pElemental;
 beginbool(yyt->ElementalExpr.PAR)
 return yyt;
}

tTree mDefault
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefault])
 yyt->Kind = kDefault;
 yyt->yyHead.yyMark = 0;
 yyt->Default.Pos = pPos;
 begintType(yyt->Default.SynType)
 beginint(yyt->Default.VIn)
 beginint(yyt->Default.VOut)
 beginbool(yyt->Default.C)
 begintValue(yyt->Default.CV)
 begintSymbol(yyt->Default.Parent)
 begintParUsage(yyt->Default.PUIn)
 begintParUsage(yyt->Default.PUOut)
 beginbool(yyt->Default.LV)
 return yyt;
}

tTree mConvert
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType, tTree pExpr)
# else
(pPos, pType, pExpr)
tPosition pPos;
tTree pType;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConvert])
 yyt->Kind = kConvert;
 yyt->yyHead.yyMark = 0;
 yyt->Convert.Pos = pPos;
 begintType(yyt->Convert.SynType)
 beginint(yyt->Convert.VIn)
 beginint(yyt->Convert.VOut)
 beginbool(yyt->Convert.C)
 begintValue(yyt->Convert.CV)
 begintSymbol(yyt->Convert.Parent)
 begintParUsage(yyt->Convert.PUIn)
 begintParUsage(yyt->Convert.PUOut)
 beginbool(yyt->Convert.LV)
 yyt->Convert.Type = pType;
 yyt->Convert.Expr = pExpr;
 return yyt;
}

tTree mRound
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType, tTree pExpr)
# else
(pPos, pType, pExpr)
tPosition pPos;
tTree pType;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRound])
 yyt->Kind = kRound;
 yyt->yyHead.yyMark = 0;
 yyt->Round.Pos = pPos;
 begintType(yyt->Round.SynType)
 beginint(yyt->Round.VIn)
 beginint(yyt->Round.VOut)
 beginbool(yyt->Round.C)
 begintValue(yyt->Round.CV)
 begintSymbol(yyt->Round.Parent)
 begintParUsage(yyt->Round.PUIn)
 begintParUsage(yyt->Round.PUOut)
 beginbool(yyt->Round.LV)
 yyt->Round.Type = pType;
 yyt->Round.Expr = pExpr;
 return yyt;
}

tTree mTrunc
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType, tTree pExpr)
# else
(pPos, pType, pExpr)
tPosition pPos;
tTree pType;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTrunc])
 yyt->Kind = kTrunc;
 yyt->yyHead.yyMark = 0;
 yyt->Trunc.Pos = pPos;
 begintType(yyt->Trunc.SynType)
 beginint(yyt->Trunc.VIn)
 beginint(yyt->Trunc.VOut)
 beginbool(yyt->Trunc.C)
 begintValue(yyt->Trunc.CV)
 begintSymbol(yyt->Trunc.Parent)
 begintParUsage(yyt->Trunc.PUIn)
 begintParUsage(yyt->Trunc.PUOut)
 beginbool(yyt->Trunc.LV)
 yyt->Trunc.Type = pType;
 yyt->Trunc.Expr = pExpr;
 return yyt;
}

tTree mMostPos
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType)
# else
(pPos, pType)
tPosition pPos;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMostPos])
 yyt->Kind = kMostPos;
 yyt->yyHead.yyMark = 0;
 yyt->MostPos.Pos = pPos;
 begintType(yyt->MostPos.SynType)
 beginint(yyt->MostPos.VIn)
 beginint(yyt->MostPos.VOut)
 beginbool(yyt->MostPos.C)
 begintValue(yyt->MostPos.CV)
 begintSymbol(yyt->MostPos.Parent)
 begintParUsage(yyt->MostPos.PUIn)
 begintParUsage(yyt->MostPos.PUOut)
 beginbool(yyt->MostPos.LV)
 yyt->MostPos.Type = pType;
 return yyt;
}

tTree mMostNeg
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pType)
# else
(pPos, pType)
tPosition pPos;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMostNeg])
 yyt->Kind = kMostNeg;
 yyt->yyHead.yyMark = 0;
 yyt->MostNeg.Pos = pPos;
 begintType(yyt->MostNeg.SynType)
 beginint(yyt->MostNeg.VIn)
 beginint(yyt->MostNeg.VOut)
 beginbool(yyt->MostNeg.C)
 begintValue(yyt->MostNeg.CV)
 begintSymbol(yyt->MostNeg.Parent)
 begintParUsage(yyt->MostNeg.PUIn)
 begintParUsage(yyt->MostNeg.PUOut)
 beginbool(yyt->MostNeg.LV)
 yyt->MostNeg.Type = pType;
 return yyt;
}

tTree mCountArray
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pLength, tTree pExpr)
# else
(pPos, pLength, pExpr)
tPosition pPos;
tTree pLength;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCountArray])
 yyt->Kind = kCountArray;
 yyt->yyHead.yyMark = 0;
 yyt->CountArray.Pos = pPos;
 begintType(yyt->CountArray.SynType)
 beginint(yyt->CountArray.VIn)
 beginint(yyt->CountArray.VOut)
 beginbool(yyt->CountArray.C)
 begintValue(yyt->CountArray.CV)
 begintSymbol(yyt->CountArray.Parent)
 begintParUsage(yyt->CountArray.PUIn)
 begintParUsage(yyt->CountArray.PUOut)
 beginbool(yyt->CountArray.LV)
 yyt->CountArray.Length = pLength;
 yyt->CountArray.Expr = pExpr;
 return yyt;
}

tTree mUnBound
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kUnBound])
 yyt->Kind = kUnBound;
 yyt->yyHead.yyMark = 0;
 yyt->UnBound.Pos = pPos;
 begintType(yyt->UnBound.SynType)
 beginint(yyt->UnBound.VIn)
 beginint(yyt->UnBound.VOut)
 beginbool(yyt->UnBound.C)
 begintValue(yyt->UnBound.CV)
 begintSymbol(yyt->UnBound.Parent)
 begintParUsage(yyt->UnBound.PUIn)
 begintParUsage(yyt->UnBound.PUOut)
 beginbool(yyt->UnBound.LV)
 return yyt;
}

tTree mStringElement
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kStringElement])
 yyt->Kind = kStringElement;
 yyt->yyHead.yyMark = 0;
 yyt->StringElement.Pos = pPos;
 begintType(yyt->StringElement.SynType)
 beginint(yyt->StringElement.VIn)
 beginint(yyt->StringElement.VOut)
 beginbool(yyt->StringElement.C)
 begintValue(yyt->StringElement.CV)
 begintSymbol(yyt->StringElement.Parent)
 begintParUsage(yyt->StringElement.PUIn)
 begintParUsage(yyt->StringElement.PUOut)
 beginbool(yyt->StringElement.LV)
 begintConstArray(yyt->StringElement.CA)
 return yyt;
}

tTree mString
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tStringRef pValue, int pDepth, tSymbol pSym)
# else
(pPos, pValue, pDepth, pSym)
tPosition pPos;
tStringRef pValue;
int pDepth;
tSymbol pSym;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kString])
 yyt->Kind = kString;
 yyt->yyHead.yyMark = 0;
 yyt->String.Pos = pPos;
 begintType(yyt->String.SynType)
 beginint(yyt->String.VIn)
 beginint(yyt->String.VOut)
 beginbool(yyt->String.C)
 begintValue(yyt->String.CV)
 begintSymbol(yyt->String.Parent)
 begintParUsage(yyt->String.PUIn)
 begintParUsage(yyt->String.PUOut)
 beginbool(yyt->String.LV)
 begintConstArray(yyt->String.CA)
 yyt->String.Value = pValue;
 yyt->String.Depth = pDepth;
 yyt->String.Sym = pSym;
 return yyt;
}

tTree mStringSubscript
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pNext, tTree pExpr)
# else
(pPos, pNext, pExpr)
tPosition pPos;
tTree pNext;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kStringSubscript])
 yyt->Kind = kStringSubscript;
 yyt->yyHead.yyMark = 0;
 yyt->StringSubscript.Pos = pPos;
 begintType(yyt->StringSubscript.SynType)
 beginint(yyt->StringSubscript.VIn)
 beginint(yyt->StringSubscript.VOut)
 beginbool(yyt->StringSubscript.C)
 begintValue(yyt->StringSubscript.CV)
 begintSymbol(yyt->StringSubscript.Parent)
 begintParUsage(yyt->StringSubscript.PUIn)
 begintParUsage(yyt->StringSubscript.PUOut)
 beginbool(yyt->StringSubscript.LV)
 begintConstArray(yyt->StringSubscript.CA)
 yyt->StringSubscript.Next = pNext;
 yyt->StringSubscript.Expr = pExpr;
 return yyt;
}

tTree mStringRange
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pNext, tTree pFrom, tTree pFor)
# else
(pPos, pNext, pFrom, pFor)
tPosition pPos;
tTree pNext;
tTree pFrom;
tTree pFor;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kStringRange])
 yyt->Kind = kStringRange;
 yyt->yyHead.yyMark = 0;
 yyt->StringRange.Pos = pPos;
 begintType(yyt->StringRange.SynType)
 beginint(yyt->StringRange.VIn)
 beginint(yyt->StringRange.VOut)
 beginbool(yyt->StringRange.C)
 begintValue(yyt->StringRange.CV)
 begintSymbol(yyt->StringRange.Parent)
 begintParUsage(yyt->StringRange.PUIn)
 begintParUsage(yyt->StringRange.PUOut)
 beginbool(yyt->StringRange.LV)
 begintConstArray(yyt->StringRange.CA)
 yyt->StringRange.Next = pNext;
 yyt->StringRange.From = pFrom;
 yyt->StringRange.For = pFor;
 return yyt;
}

tTree mElemental
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElemental])
 yyt->Kind = kElemental;
 yyt->yyHead.yyMark = 0;
 yyt->Elemental.Pos = pPos;
 begintType(yyt->Elemental.SynType)
 beginint(yyt->Elemental.W)
 beginint(yyt->Elemental.VIn)
 beginint(yyt->Elemental.VOut)
 beginbool(yyt->Elemental.C)
 begintValue(yyt->Elemental.CV)
 begintConstArray(yyt->Elemental.CA)
 begintUsage(yyt->Elemental.U)
 begintSymbol(yyt->Elemental.Parent)
 begintParUsage(yyt->Elemental.PUIn)
 begintParUsage(yyt->Elemental.PUOut)
 beginbool(yyt->Elemental.LV)
 beginbool(yyt->Elemental.SE)
 return yyt;
}

tTree mTableElement
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTableElement])
 yyt->Kind = kTableElement;
 yyt->yyHead.yyMark = 0;
 yyt->TableElement.Pos = pPos;
 begintType(yyt->TableElement.SynType)
 beginint(yyt->TableElement.W)
 beginint(yyt->TableElement.VIn)
 beginint(yyt->TableElement.VOut)
 beginbool(yyt->TableElement.C)
 begintValue(yyt->TableElement.CV)
 begintConstArray(yyt->TableElement.CA)
 begintUsage(yyt->TableElement.U)
 begintSymbol(yyt->TableElement.Parent)
 begintParUsage(yyt->TableElement.PUIn)
 begintParUsage(yyt->TableElement.PUOut)
 beginbool(yyt->TableElement.LV)
 beginbool(yyt->TableElement.SE)
 return yyt;
}

tTree mTable
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pExprList, int pDepth, tSymbol pSym)
# else
(pPos, pExprList, pDepth, pSym)
tPosition pPos;
tTree pExprList;
int pDepth;
tSymbol pSym;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTable])
 yyt->Kind = kTable;
 yyt->yyHead.yyMark = 0;
 yyt->Table.Pos = pPos;
 begintType(yyt->Table.SynType)
 beginint(yyt->Table.W)
 beginint(yyt->Table.VIn)
 beginint(yyt->Table.VOut)
 beginbool(yyt->Table.C)
 begintValue(yyt->Table.CV)
 begintConstArray(yyt->Table.CA)
 begintUsage(yyt->Table.U)
 begintSymbol(yyt->Table.Parent)
 begintParUsage(yyt->Table.PUIn)
 begintParUsage(yyt->Table.PUOut)
 beginbool(yyt->Table.LV)
 beginbool(yyt->Table.SE)
 yyt->Table.ExprList = pExprList;
 yyt->Table.Depth = pDepth;
 yyt->Table.Sym = pSym;
 beginpLinExpr(yyt->Table.LE)
 return yyt;
}

tTree mTableSubscript
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pNext, tTree pExpr)
# else
(pPos, pNext, pExpr)
tPosition pPos;
tTree pNext;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTableSubscript])
 yyt->Kind = kTableSubscript;
 yyt->yyHead.yyMark = 0;
 yyt->TableSubscript.Pos = pPos;
 begintType(yyt->TableSubscript.SynType)
 beginint(yyt->TableSubscript.W)
 beginint(yyt->TableSubscript.VIn)
 beginint(yyt->TableSubscript.VOut)
 beginbool(yyt->TableSubscript.C)
 begintValue(yyt->TableSubscript.CV)
 begintConstArray(yyt->TableSubscript.CA)
 begintUsage(yyt->TableSubscript.U)
 begintSymbol(yyt->TableSubscript.Parent)
 begintParUsage(yyt->TableSubscript.PUIn)
 begintParUsage(yyt->TableSubscript.PUOut)
 beginbool(yyt->TableSubscript.LV)
 beginbool(yyt->TableSubscript.SE)
 yyt->TableSubscript.Next = pNext;
 yyt->TableSubscript.Expr = pExpr;
 beginpLinExpr(yyt->TableSubscript.LE)
 return yyt;
}

tTree mTableRange
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pNext, tTree pFrom, tTree pFor)
# else
(pPos, pNext, pFrom, pFor)
tPosition pPos;
tTree pNext;
tTree pFrom;
tTree pFor;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTableRange])
 yyt->Kind = kTableRange;
 yyt->yyHead.yyMark = 0;
 yyt->TableRange.Pos = pPos;
 begintType(yyt->TableRange.SynType)
 beginint(yyt->TableRange.W)
 beginint(yyt->TableRange.VIn)
 beginint(yyt->TableRange.VOut)
 beginbool(yyt->TableRange.C)
 begintValue(yyt->TableRange.CV)
 begintConstArray(yyt->TableRange.CA)
 begintUsage(yyt->TableRange.U)
 begintSymbol(yyt->TableRange.Parent)
 begintParUsage(yyt->TableRange.PUIn)
 begintParUsage(yyt->TableRange.PUOut)
 beginbool(yyt->TableRange.LV)
 beginbool(yyt->TableRange.SE)
 yyt->TableRange.Next = pNext;
 yyt->TableRange.From = pFrom;
 yyt->TableRange.For = pFor;
 beginpLinExpr(yyt->TableRange.FromLE)
 beginpLinExpr(yyt->TableRange.ForLE)
 return yyt;
}

tTree mElement
# if defined __STDC__ | defined __cplusplus
(tPosition pPos)
# else
(pPos)
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElement])
 yyt->Kind = kElement;
 yyt->yyHead.yyMark = 0;
 yyt->Element.Pos = pPos;
 begintType(yyt->Element.SynType)
 beginint(yyt->Element.W)
 beginint(yyt->Element.VIn)
 beginint(yyt->Element.VOut)
 beginbool(yyt->Element.C)
 begintValue(yyt->Element.CV)
 begintConstArray(yyt->Element.CA)
 begintUsage(yyt->Element.U)
 begintSymbol(yyt->Element.Parent)
 begintParUsage(yyt->Element.PUIn)
 begintParUsage(yyt->Element.PUOut)
 beginbool(yyt->Element.LV)
 beginbool(yyt->Element.SE)
 return yyt;
}

tTree mIdentifier
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tSymbol pSym, tSymbol pScope)
# else
(pPos, pSym, pScope)
tPosition pPos;
tSymbol pSym;
tSymbol pScope;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kIdentifier])
 yyt->Kind = kIdentifier;
 yyt->yyHead.yyMark = 0;
 yyt->Identifier.Pos = pPos;
 begintType(yyt->Identifier.SynType)
 beginint(yyt->Identifier.W)
 beginint(yyt->Identifier.VIn)
 beginint(yyt->Identifier.VOut)
 beginbool(yyt->Identifier.C)
 begintValue(yyt->Identifier.CV)
 begintConstArray(yyt->Identifier.CA)
 begintUsage(yyt->Identifier.U)
 begintSymbol(yyt->Identifier.Parent)
 begintParUsage(yyt->Identifier.PUIn)
 begintParUsage(yyt->Identifier.PUOut)
 beginbool(yyt->Identifier.LV)
 beginbool(yyt->Identifier.SE)
 yyt->Identifier.Sym = pSym;
 yyt->Identifier.Scope = pScope;
 return yyt;
}

tTree mElementAccess
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pNext)
# else
(pPos, pNext)
tPosition pPos;
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElementAccess])
 yyt->Kind = kElementAccess;
 yyt->yyHead.yyMark = 0;
 yyt->ElementAccess.Pos = pPos;
 begintType(yyt->ElementAccess.SynType)
 beginint(yyt->ElementAccess.W)
 beginint(yyt->ElementAccess.VIn)
 beginint(yyt->ElementAccess.VOut)
 beginbool(yyt->ElementAccess.C)
 begintValue(yyt->ElementAccess.CV)
 begintConstArray(yyt->ElementAccess.CA)
 begintUsage(yyt->ElementAccess.U)
 begintSymbol(yyt->ElementAccess.Parent)
 begintParUsage(yyt->ElementAccess.PUIn)
 begintParUsage(yyt->ElementAccess.PUOut)
 beginbool(yyt->ElementAccess.LV)
 beginbool(yyt->ElementAccess.SE)
 yyt->ElementAccess.Next = pNext;
 return yyt;
}

tTree mSubscript
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pNext, tTree pExpr)
# else
(pPos, pNext, pExpr)
tPosition pPos;
tTree pNext;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSubscript])
 yyt->Kind = kSubscript;
 yyt->yyHead.yyMark = 0;
 yyt->Subscript.Pos = pPos;
 begintType(yyt->Subscript.SynType)
 beginint(yyt->Subscript.W)
 beginint(yyt->Subscript.VIn)
 beginint(yyt->Subscript.VOut)
 beginbool(yyt->Subscript.C)
 begintValue(yyt->Subscript.CV)
 begintConstArray(yyt->Subscript.CA)
 begintUsage(yyt->Subscript.U)
 begintSymbol(yyt->Subscript.Parent)
 begintParUsage(yyt->Subscript.PUIn)
 begintParUsage(yyt->Subscript.PUOut)
 beginbool(yyt->Subscript.LV)
 beginbool(yyt->Subscript.SE)
 yyt->Subscript.Next = pNext;
 yyt->Subscript.Expr = pExpr;
 beginbool(yyt->Subscript.CB)
 beginpLinExpr(yyt->Subscript.LE)
 return yyt;
}

tTree mRange
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pNext, tTree pFrom, tTree pFor)
# else
(pPos, pNext, pFrom, pFor)
tPosition pPos;
tTree pNext;
tTree pFrom;
tTree pFor;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRange])
 yyt->Kind = kRange;
 yyt->yyHead.yyMark = 0;
 yyt->Range.Pos = pPos;
 begintType(yyt->Range.SynType)
 beginint(yyt->Range.W)
 beginint(yyt->Range.VIn)
 beginint(yyt->Range.VOut)
 beginbool(yyt->Range.C)
 begintValue(yyt->Range.CV)
 begintConstArray(yyt->Range.CA)
 begintUsage(yyt->Range.U)
 begintSymbol(yyt->Range.Parent)
 begintParUsage(yyt->Range.PUIn)
 begintParUsage(yyt->Range.PUOut)
 beginbool(yyt->Range.LV)
 beginbool(yyt->Range.SE)
 yyt->Range.Next = pNext;
 yyt->Range.From = pFrom;
 yyt->Range.For = pFor;
 beginbool(yyt->Range.CLB)
 beginbool(yyt->Range.CUB)
 beginpLinExpr(yyt->Range.FromLE)
 beginpLinExpr(yyt->Range.ForLE)
 return yyt;
}

tTree mExprList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kExprList])
 yyt->Kind = kExprList;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->ExprList.SynType)
 beginint(yyt->ExprList.VIn)
 beginint(yyt->ExprList.VOut)
 beginbool(yyt->ExprList.C)
 beginbool(yyt->ExprList.TR)
 begintSymbol(yyt->ExprList.Parent)
 begintParUsage(yyt->ExprList.PUIn)
 begintParUsage(yyt->ExprList.PUOut)
 beginbool(yyt->ExprList.PAR)
 beginbool(yyt->ExprList.LV)
 return yyt;
}

tTree mNoExpr
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoExpr])
 yyt->Kind = kNoExpr;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->NoExpr.SynType)
 beginint(yyt->NoExpr.VIn)
 beginint(yyt->NoExpr.VOut)
 beginbool(yyt->NoExpr.C)
 beginbool(yyt->NoExpr.TR)
 begintSymbol(yyt->NoExpr.Parent)
 begintParUsage(yyt->NoExpr.PUIn)
 begintParUsage(yyt->NoExpr.PUOut)
 beginbool(yyt->NoExpr.PAR)
 beginbool(yyt->NoExpr.LV)
 return yyt;
}

tTree mAnExpr
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pExpr)
# else
(pNext, pExpr)
tTree pNext;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAnExpr])
 yyt->Kind = kAnExpr;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->AnExpr.SynType)
 beginint(yyt->AnExpr.VIn)
 beginint(yyt->AnExpr.VOut)
 beginbool(yyt->AnExpr.C)
 beginbool(yyt->AnExpr.TR)
 begintSymbol(yyt->AnExpr.Parent)
 begintParUsage(yyt->AnExpr.PUIn)
 begintParUsage(yyt->AnExpr.PUOut)
 beginbool(yyt->AnExpr.PAR)
 beginbool(yyt->AnExpr.LV)
 yyt->AnExpr.Next = pNext;
 yyt->AnExpr.Expr = pExpr;
 return yyt;
}

tTree mOp
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kOp])
 yyt->Kind = kOp;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mRelOp
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRelOp])
 yyt->Kind = kRelOp;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mLess
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLess])
 yyt->Kind = kLess;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mGreater
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kGreater])
 yyt->Kind = kGreater;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mLessEqual
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLessEqual])
 yyt->Kind = kLessEqual;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mGreaterEqual
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kGreaterEqual])
 yyt->Kind = kGreaterEqual;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mEqual
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kEqual])
 yyt->Kind = kEqual;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mNotEqual
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNotEqual])
 yyt->Kind = kNotEqual;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mMathsOp
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMathsOp])
 yyt->Kind = kMathsOp;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mAdd
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAdd])
 yyt->Kind = kAdd;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mSubtract
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSubtract])
 yyt->Kind = kSubtract;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mMultiply
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMultiply])
 yyt->Kind = kMultiply;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mDivide
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDivide])
 yyt->Kind = kDivide;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mRem
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRem])
 yyt->Kind = kRem;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mBitOp
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBitOp])
 yyt->Kind = kBitOp;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mBitAnd
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBitAnd])
 yyt->Kind = kBitAnd;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mBitOr
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBitOr])
 yyt->Kind = kBitOr;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mBitEor
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBitEor])
 yyt->Kind = kBitEor;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mShiftOp
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kShiftOp])
 yyt->Kind = kShiftOp;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mLeftShift
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLeftShift])
 yyt->Kind = kLeftShift;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mRightShift
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRightShift])
 yyt->Kind = kRightShift;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mUniOp
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kUniOp])
 yyt->Kind = kUniOp;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mSize
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSize])
 yyt->Kind = kSize;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mBitNot
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBitNot])
 yyt->Kind = kBitNot;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mNot
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNot])
 yyt->Kind = kNot;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mClockOp
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kClockOp])
 yyt->Kind = kClockOp;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mPlus
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kPlus])
 yyt->Kind = kPlus;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mMinus
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMinus])
 yyt->Kind = kMinus;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mTimes
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTimes])
 yyt->Kind = kTimes;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mLogOp
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLogOp])
 yyt->Kind = kLogOp;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mAnd
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAnd])
 yyt->Kind = kAnd;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mOr
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kOr])
 yyt->Kind = kOr;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mAfterOp
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAfterOp])
 yyt->Kind = kAfterOp;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mProcess
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList)
# else
(pPos, pSpecList)
tPosition pPos;
tTree pSpecList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kProcess])
 yyt->Kind = kProcess;
 yyt->yyHead.yyMark = 0;
 yyt->Process.Pos = pPos;
 yyt->Process.SpecList = pSpecList;
 beginint(yyt->Process.VS)
 beginint(yyt->Process.VIn)
 beginint(yyt->Process.VOut)
 beginbool(yyt->Process.ATOMIC)
 beginint(yyt->Process.SLC)
 beginbool(yyt->Process.TLA)
 begintSymbol(yyt->Process.Parent)
 begintParUsage(yyt->Process.PUIn)
 begintParUsage(yyt->Process.PUOut)
 return yyt;
}

tTree mAssign
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pLval, tTree pRval)
# else
(pPos, pSpecList, pLval, pRval)
tPosition pPos;
tTree pSpecList;
tTree pLval;
tTree pRval;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAssign])
 yyt->Kind = kAssign;
 yyt->yyHead.yyMark = 0;
 yyt->Assign.Pos = pPos;
 yyt->Assign.SpecList = pSpecList;
 beginint(yyt->Assign.VS)
 beginint(yyt->Assign.VIn)
 beginint(yyt->Assign.VOut)
 beginbool(yyt->Assign.ATOMIC)
 beginint(yyt->Assign.SLC)
 beginbool(yyt->Assign.TLA)
 begintSymbol(yyt->Assign.Parent)
 begintParUsage(yyt->Assign.PUIn)
 begintParUsage(yyt->Assign.PUOut)
 yyt->Assign.Lval = pLval;
 yyt->Assign.Rval = pRval;
 return yyt;
}

tTree mAltType
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, bool pPri)
# else
(pPos, pSpecList, pPri)
tPosition pPos;
tTree pSpecList;
bool pPri;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAltType])
 yyt->Kind = kAltType;
 yyt->yyHead.yyMark = 0;
 yyt->AltType.Pos = pPos;
 yyt->AltType.SpecList = pSpecList;
 beginint(yyt->AltType.VS)
 beginint(yyt->AltType.VIn)
 beginint(yyt->AltType.VOut)
 beginbool(yyt->AltType.ATOMIC)
 beginint(yyt->AltType.SLC)
 beginbool(yyt->AltType.TLA)
 begintSymbol(yyt->AltType.Parent)
 begintParUsage(yyt->AltType.PUIn)
 begintParUsage(yyt->AltType.PUOut)
 yyt->AltType.Pri = pPri;
 beginint(yyt->AltType.ARC)
 return yyt;
}

tTree mAlt
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, bool pPri, tTree pAltList)
# else
(pPos, pSpecList, pPri, pAltList)
tPosition pPos;
tTree pSpecList;
bool pPri;
tTree pAltList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAlt])
 yyt->Kind = kAlt;
 yyt->yyHead.yyMark = 0;
 yyt->Alt.Pos = pPos;
 yyt->Alt.SpecList = pSpecList;
 beginint(yyt->Alt.VS)
 beginint(yyt->Alt.VIn)
 beginint(yyt->Alt.VOut)
 beginbool(yyt->Alt.ATOMIC)
 beginint(yyt->Alt.SLC)
 beginbool(yyt->Alt.TLA)
 begintSymbol(yyt->Alt.Parent)
 begintParUsage(yyt->Alt.PUIn)
 begintParUsage(yyt->Alt.PUOut)
 yyt->Alt.Pri = pPri;
 beginint(yyt->Alt.ARC)
 yyt->Alt.AltList = pAltList;
 return yyt;
}

tTree mAltRep
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, bool pPri, tTree pReplicator, tTree pAltList)
# else
(pPos, pSpecList, pPri, pReplicator, pAltList)
tPosition pPos;
tTree pSpecList;
bool pPri;
tTree pReplicator;
tTree pAltList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAltRep])
 yyt->Kind = kAltRep;
 yyt->yyHead.yyMark = 0;
 yyt->AltRep.Pos = pPos;
 yyt->AltRep.SpecList = pSpecList;
 beginint(yyt->AltRep.VS)
 beginint(yyt->AltRep.VIn)
 beginint(yyt->AltRep.VOut)
 beginbool(yyt->AltRep.ATOMIC)
 beginint(yyt->AltRep.SLC)
 beginbool(yyt->AltRep.TLA)
 begintSymbol(yyt->AltRep.Parent)
 begintParUsage(yyt->AltRep.PUIn)
 begintParUsage(yyt->AltRep.PUOut)
 yyt->AltRep.Pri = pPri;
 beginint(yyt->AltRep.ARC)
 yyt->AltRep.Replicator = pReplicator;
 yyt->AltRep.AltList = pAltList;
 return yyt;
}

tTree mParType
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tParType pPType)
# else
(pPos, pSpecList, pPType)
tPosition pPos;
tTree pSpecList;
tParType pPType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kParType])
 yyt->Kind = kParType;
 yyt->yyHead.yyMark = 0;
 yyt->ParType.Pos = pPos;
 yyt->ParType.SpecList = pSpecList;
 beginint(yyt->ParType.VS)
 beginint(yyt->ParType.VIn)
 beginint(yyt->ParType.VOut)
 beginbool(yyt->ParType.ATOMIC)
 beginint(yyt->ParType.SLC)
 beginbool(yyt->ParType.TLA)
 begintSymbol(yyt->ParType.Parent)
 begintParUsage(yyt->ParType.PUIn)
 begintParUsage(yyt->ParType.PUOut)
 yyt->ParType.PType = pPType;
 return yyt;
}

tTree mPar
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tParType pPType, tTree pProcList)
# else
(pPos, pSpecList, pPType, pProcList)
tPosition pPos;
tTree pSpecList;
tParType pPType;
tTree pProcList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kPar])
 yyt->Kind = kPar;
 yyt->yyHead.yyMark = 0;
 yyt->Par.Pos = pPos;
 yyt->Par.SpecList = pSpecList;
 beginint(yyt->Par.VS)
 beginint(yyt->Par.VIn)
 beginint(yyt->Par.VOut)
 beginbool(yyt->Par.ATOMIC)
 beginint(yyt->Par.SLC)
 beginbool(yyt->Par.TLA)
 begintSymbol(yyt->Par.Parent)
 begintParUsage(yyt->Par.PUIn)
 begintParUsage(yyt->Par.PUOut)
 yyt->Par.PType = pPType;
 yyt->Par.ProcList = pProcList;
 return yyt;
}

tTree mParRep
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tParType pPType, tTree pReplicator, tTree pProcess, tSymbol pSym)
# else
(pPos, pSpecList, pPType, pReplicator, pProcess, pSym)
tPosition pPos;
tTree pSpecList;
tParType pPType;
tTree pReplicator;
tTree pProcess;
tSymbol pSym;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kParRep])
 yyt->Kind = kParRep;
 yyt->yyHead.yyMark = 0;
 yyt->ParRep.Pos = pPos;
 yyt->ParRep.SpecList = pSpecList;
 beginint(yyt->ParRep.VS)
 beginint(yyt->ParRep.VIn)
 beginint(yyt->ParRep.VOut)
 beginbool(yyt->ParRep.ATOMIC)
 beginint(yyt->ParRep.SLC)
 beginbool(yyt->ParRep.TLA)
 begintSymbol(yyt->ParRep.Parent)
 begintParUsage(yyt->ParRep.PUIn)
 begintParUsage(yyt->ParRep.PUOut)
 yyt->ParRep.PType = pPType;
 yyt->ParRep.Replicator = pReplicator;
 yyt->ParRep.Process = pProcess;
 yyt->ParRep.Sym = pSym;
 return yyt;
}

tTree mProcessor
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pExpr, tIdent pName, tTree pProcess)
# else
(pPos, pSpecList, pExpr, pName, pProcess)
tPosition pPos;
tTree pSpecList;
tTree pExpr;
tIdent pName;
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kProcessor])
 yyt->Kind = kProcessor;
 yyt->yyHead.yyMark = 0;
 yyt->Processor.Pos = pPos;
 yyt->Processor.SpecList = pSpecList;
 beginint(yyt->Processor.VS)
 beginint(yyt->Processor.VIn)
 beginint(yyt->Processor.VOut)
 beginbool(yyt->Processor.ATOMIC)
 beginint(yyt->Processor.SLC)
 beginbool(yyt->Processor.TLA)
 begintSymbol(yyt->Processor.Parent)
 begintParUsage(yyt->Processor.PUIn)
 begintParUsage(yyt->Processor.PUOut)
 yyt->Processor.Expr = pExpr;
 yyt->Processor.Name = pName;
 yyt->Processor.Process = pProcess;
 return yyt;
}

tTree mIfType
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList)
# else
(pPos, pSpecList)
tPosition pPos;
tTree pSpecList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kIfType])
 yyt->Kind = kIfType;
 yyt->yyHead.yyMark = 0;
 yyt->IfType.Pos = pPos;
 yyt->IfType.SpecList = pSpecList;
 beginint(yyt->IfType.VS)
 beginint(yyt->IfType.VIn)
 beginint(yyt->IfType.VOut)
 beginbool(yyt->IfType.ATOMIC)
 beginint(yyt->IfType.SLC)
 beginbool(yyt->IfType.TLA)
 begintSymbol(yyt->IfType.Parent)
 begintParUsage(yyt->IfType.PUIn)
 begintParUsage(yyt->IfType.PUOut)
 begintChoiceList(yyt->IfType.BackChoiceList)
 begintIfType(yyt->IfType.BackIfType)
 return yyt;
}

tTree mIf
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pChoiceList)
# else
(pPos, pSpecList, pChoiceList)
tPosition pPos;
tTree pSpecList;
tTree pChoiceList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kIf])
 yyt->Kind = kIf;
 yyt->yyHead.yyMark = 0;
 yyt->If.Pos = pPos;
 yyt->If.SpecList = pSpecList;
 beginint(yyt->If.VS)
 beginint(yyt->If.VIn)
 beginint(yyt->If.VOut)
 beginbool(yyt->If.ATOMIC)
 beginint(yyt->If.SLC)
 beginbool(yyt->If.TLA)
 begintSymbol(yyt->If.Parent)
 begintParUsage(yyt->If.PUIn)
 begintParUsage(yyt->If.PUOut)
 begintChoiceList(yyt->If.BackChoiceList)
 begintIfType(yyt->If.BackIfType)
 yyt->If.ChoiceList = pChoiceList;
 return yyt;
}

tTree mIfRep
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pReplicator, tTree pChoiceList)
# else
(pPos, pSpecList, pReplicator, pChoiceList)
tPosition pPos;
tTree pSpecList;
tTree pReplicator;
tTree pChoiceList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kIfRep])
 yyt->Kind = kIfRep;
 yyt->yyHead.yyMark = 0;
 yyt->IfRep.Pos = pPos;
 yyt->IfRep.SpecList = pSpecList;
 beginint(yyt->IfRep.VS)
 beginint(yyt->IfRep.VIn)
 beginint(yyt->IfRep.VOut)
 beginbool(yyt->IfRep.ATOMIC)
 beginint(yyt->IfRep.SLC)
 beginbool(yyt->IfRep.TLA)
 begintSymbol(yyt->IfRep.Parent)
 begintParUsage(yyt->IfRep.PUIn)
 begintParUsage(yyt->IfRep.PUOut)
 begintChoiceList(yyt->IfRep.BackChoiceList)
 begintIfType(yyt->IfRep.BackIfType)
 yyt->IfRep.Replicator = pReplicator;
 yyt->IfRep.ChoiceList = pChoiceList;
 return yyt;
}

tTree mInput
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pElement, tTree pExprList)
# else
(pPos, pSpecList, pElement, pExprList)
tPosition pPos;
tTree pSpecList;
tTree pElement;
tTree pExprList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kInput])
 yyt->Kind = kInput;
 yyt->yyHead.yyMark = 0;
 yyt->Input.Pos = pPos;
 yyt->Input.SpecList = pSpecList;
 beginint(yyt->Input.VS)
 beginint(yyt->Input.VIn)
 beginint(yyt->Input.VOut)
 beginbool(yyt->Input.ATOMIC)
 beginint(yyt->Input.SLC)
 beginbool(yyt->Input.TLA)
 begintSymbol(yyt->Input.Parent)
 begintParUsage(yyt->Input.PUIn)
 begintParUsage(yyt->Input.PUOut)
 yyt->Input.Element = pElement;
 yyt->Input.ExprList = pExprList;
 return yyt;
}

tTree mOutput
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pElement, tTree pExprList)
# else
(pPos, pSpecList, pElement, pExprList)
tPosition pPos;
tTree pSpecList;
tTree pElement;
tTree pExprList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kOutput])
 yyt->Kind = kOutput;
 yyt->yyHead.yyMark = 0;
 yyt->Output.Pos = pPos;
 yyt->Output.SpecList = pSpecList;
 beginint(yyt->Output.VS)
 beginint(yyt->Output.VIn)
 beginint(yyt->Output.VOut)
 beginbool(yyt->Output.ATOMIC)
 beginint(yyt->Output.SLC)
 beginbool(yyt->Output.TLA)
 begintSymbol(yyt->Output.Parent)
 begintParUsage(yyt->Output.PUIn)
 begintParUsage(yyt->Output.PUOut)
 yyt->Output.Element = pElement;
 yyt->Output.ExprList = pExprList;
 return yyt;
}

tTree mCaseIn
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pElement, tTree pCaseList)
# else
(pPos, pSpecList, pElement, pCaseList)
tPosition pPos;
tTree pSpecList;
tTree pElement;
tTree pCaseList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCaseIn])
 yyt->Kind = kCaseIn;
 yyt->yyHead.yyMark = 0;
 yyt->CaseIn.Pos = pPos;
 yyt->CaseIn.SpecList = pSpecList;
 beginint(yyt->CaseIn.VS)
 beginint(yyt->CaseIn.VIn)
 beginint(yyt->CaseIn.VOut)
 beginbool(yyt->CaseIn.ATOMIC)
 beginint(yyt->CaseIn.SLC)
 beginbool(yyt->CaseIn.TLA)
 begintSymbol(yyt->CaseIn.Parent)
 begintParUsage(yyt->CaseIn.PUIn)
 begintParUsage(yyt->CaseIn.PUOut)
 yyt->CaseIn.Element = pElement;
 yyt->CaseIn.CaseList = pCaseList;
 return yyt;
}

tTree mAfter
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pElement, tTree pExpr)
# else
(pPos, pSpecList, pElement, pExpr)
tPosition pPos;
tTree pSpecList;
tTree pElement;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAfter])
 yyt->Kind = kAfter;
 yyt->yyHead.yyMark = 0;
 yyt->After.Pos = pPos;
 yyt->After.SpecList = pSpecList;
 beginint(yyt->After.VS)
 beginint(yyt->After.VIn)
 beginint(yyt->After.VOut)
 beginbool(yyt->After.ATOMIC)
 beginint(yyt->After.SLC)
 beginbool(yyt->After.TLA)
 begintSymbol(yyt->After.Parent)
 begintParUsage(yyt->After.PUIn)
 begintParUsage(yyt->After.PUOut)
 yyt->After.Element = pElement;
 yyt->After.Expr = pExpr;
 return yyt;
}

tTree mSeqRep
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pReplicator, tTree pProcess)
# else
(pPos, pSpecList, pReplicator, pProcess)
tPosition pPos;
tTree pSpecList;
tTree pReplicator;
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSeqRep])
 yyt->Kind = kSeqRep;
 yyt->yyHead.yyMark = 0;
 yyt->SeqRep.Pos = pPos;
 yyt->SeqRep.SpecList = pSpecList;
 beginint(yyt->SeqRep.VS)
 beginint(yyt->SeqRep.VIn)
 beginint(yyt->SeqRep.VOut)
 beginbool(yyt->SeqRep.ATOMIC)
 beginint(yyt->SeqRep.SLC)
 beginbool(yyt->SeqRep.TLA)
 begintSymbol(yyt->SeqRep.Parent)
 begintParUsage(yyt->SeqRep.PUIn)
 begintParUsage(yyt->SeqRep.PUOut)
 yyt->SeqRep.Replicator = pReplicator;
 yyt->SeqRep.Process = pProcess;
 return yyt;
}

tTree mSeq
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pProcList)
# else
(pPos, pSpecList, pProcList)
tPosition pPos;
tTree pSpecList;
tTree pProcList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSeq])
 yyt->Kind = kSeq;
 yyt->yyHead.yyMark = 0;
 yyt->Seq.Pos = pPos;
 yyt->Seq.SpecList = pSpecList;
 beginint(yyt->Seq.VS)
 beginint(yyt->Seq.VIn)
 beginint(yyt->Seq.VOut)
 beginbool(yyt->Seq.ATOMIC)
 beginint(yyt->Seq.SLC)
 beginbool(yyt->Seq.TLA)
 begintSymbol(yyt->Seq.Parent)
 begintParUsage(yyt->Seq.PUIn)
 begintParUsage(yyt->Seq.PUOut)
 yyt->Seq.ProcList = pProcList;
 return yyt;
}

tTree mCase
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pSelector, tTree pChoiceList)
# else
(pPos, pSpecList, pSelector, pChoiceList)
tPosition pPos;
tTree pSpecList;
tTree pSelector;
tTree pChoiceList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCase])
 yyt->Kind = kCase;
 yyt->yyHead.yyMark = 0;
 yyt->Case.Pos = pPos;
 yyt->Case.SpecList = pSpecList;
 beginint(yyt->Case.VS)
 beginint(yyt->Case.VIn)
 beginint(yyt->Case.VOut)
 beginbool(yyt->Case.ATOMIC)
 beginint(yyt->Case.SLC)
 beginbool(yyt->Case.TLA)
 begintSymbol(yyt->Case.Parent)
 begintParUsage(yyt->Case.PUIn)
 begintParUsage(yyt->Case.PUOut)
 yyt->Case.Selector = pSelector;
 yyt->Case.ChoiceList = pChoiceList;
 return yyt;
}

tTree mWhile
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tTree pExpr, tTree pProcess)
# else
(pPos, pSpecList, pExpr, pProcess)
tPosition pPos;
tTree pSpecList;
tTree pExpr;
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kWhile])
 yyt->Kind = kWhile;
 yyt->yyHead.yyMark = 0;
 yyt->While.Pos = pPos;
 yyt->While.SpecList = pSpecList;
 beginint(yyt->While.VS)
 beginint(yyt->While.VIn)
 beginint(yyt->While.VOut)
 beginbool(yyt->While.ATOMIC)
 beginint(yyt->While.SLC)
 beginbool(yyt->While.TLA)
 begintSymbol(yyt->While.Parent)
 begintParUsage(yyt->While.PUIn)
 begintParUsage(yyt->While.PUOut)
 yyt->While.Expr = pExpr;
 yyt->While.Process = pProcess;
 return yyt;
}

tTree mSkip
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList)
# else
(pPos, pSpecList)
tPosition pPos;
tTree pSpecList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSkip])
 yyt->Kind = kSkip;
 yyt->yyHead.yyMark = 0;
 yyt->Skip.Pos = pPos;
 yyt->Skip.SpecList = pSpecList;
 beginint(yyt->Skip.VS)
 beginint(yyt->Skip.VIn)
 beginint(yyt->Skip.VOut)
 beginbool(yyt->Skip.ATOMIC)
 beginint(yyt->Skip.SLC)
 beginbool(yyt->Skip.TLA)
 begintSymbol(yyt->Skip.Parent)
 begintParUsage(yyt->Skip.PUIn)
 begintParUsage(yyt->Skip.PUOut)
 return yyt;
}

tTree mStop
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList)
# else
(pPos, pSpecList)
tPosition pPos;
tTree pSpecList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kStop])
 yyt->Kind = kStop;
 yyt->yyHead.yyMark = 0;
 yyt->Stop.Pos = pPos;
 yyt->Stop.SpecList = pSpecList;
 beginint(yyt->Stop.VS)
 beginint(yyt->Stop.VIn)
 beginint(yyt->Stop.VOut)
 beginbool(yyt->Stop.ATOMIC)
 beginint(yyt->Stop.SLC)
 beginbool(yyt->Stop.TLA)
 begintSymbol(yyt->Stop.Parent)
 begintParUsage(yyt->Stop.PUIn)
 begintParUsage(yyt->Stop.PUOut)
 return yyt;
}

tTree mInstance
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tSymbol pSym, tTree pExprList, tSymbol pScope)
# else
(pPos, pSpecList, pSym, pExprList, pScope)
tPosition pPos;
tTree pSpecList;
tSymbol pSym;
tTree pExprList;
tSymbol pScope;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kInstance])
 yyt->Kind = kInstance;
 yyt->yyHead.yyMark = 0;
 yyt->Instance.Pos = pPos;
 yyt->Instance.SpecList = pSpecList;
 beginint(yyt->Instance.VS)
 beginint(yyt->Instance.VIn)
 beginint(yyt->Instance.VOut)
 beginbool(yyt->Instance.ATOMIC)
 beginint(yyt->Instance.SLC)
 beginbool(yyt->Instance.TLA)
 begintSymbol(yyt->Instance.Parent)
 begintParUsage(yyt->Instance.PUIn)
 begintParUsage(yyt->Instance.PUOut)
 yyt->Instance.Sym = pSym;
 yyt->Instance.ExprList = pExprList;
 yyt->Instance.Scope = pScope;
 begintFrame(yyt->Instance.Frame)
 return yyt;
}

tTree mCCode
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList, tStringRef pCode, tSymbol pScope)
# else
(pPos, pSpecList, pCode, pScope)
tPosition pPos;
tTree pSpecList;
tStringRef pCode;
tSymbol pScope;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCCode])
 yyt->Kind = kCCode;
 yyt->yyHead.yyMark = 0;
 yyt->CCode.Pos = pPos;
 yyt->CCode.SpecList = pSpecList;
 beginint(yyt->CCode.VS)
 beginint(yyt->CCode.VIn)
 beginint(yyt->CCode.VOut)
 beginbool(yyt->CCode.ATOMIC)
 beginint(yyt->CCode.SLC)
 beginbool(yyt->CCode.TLA)
 begintSymbol(yyt->CCode.Parent)
 begintParUsage(yyt->CCode.PUIn)
 begintParUsage(yyt->CCode.PUOut)
 yyt->CCode.Code = pCode;
 yyt->CCode.Scope = pScope;
 return yyt;
}

tTree mNullProcess
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pSpecList)
# else
(pPos, pSpecList)
tPosition pPos;
tTree pSpecList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNullProcess])
 yyt->Kind = kNullProcess;
 yyt->yyHead.yyMark = 0;
 yyt->NullProcess.Pos = pPos;
 yyt->NullProcess.SpecList = pSpecList;
 beginint(yyt->NullProcess.VS)
 beginint(yyt->NullProcess.VIn)
 beginint(yyt->NullProcess.VOut)
 beginbool(yyt->NullProcess.ATOMIC)
 beginint(yyt->NullProcess.SLC)
 beginbool(yyt->NullProcess.TLA)
 begintSymbol(yyt->NullProcess.Parent)
 begintParUsage(yyt->NullProcess.PUIn)
 begintParUsage(yyt->NullProcess.PUOut)
 return yyt;
}

tTree mAltList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAltList])
 yyt->Kind = kAltList;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->AltList.VS)
 beginint(yyt->AltList.VIn)
 beginint(yyt->AltList.VOut)
 beginint(yyt->AltList.SLC)
 beginint(yyt->AltList.ARC)
 begintSymbol(yyt->AltList.Parent)
 begintParUsage(yyt->AltList.PUIn)
 begintParUsage(yyt->AltList.PUOut)
 return yyt;
}

tTree mNoAlt
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoAlt])
 yyt->Kind = kNoAlt;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->NoAlt.VS)
 beginint(yyt->NoAlt.VIn)
 beginint(yyt->NoAlt.VOut)
 beginint(yyt->NoAlt.SLC)
 beginint(yyt->NoAlt.ARC)
 begintSymbol(yyt->NoAlt.Parent)
 begintParUsage(yyt->NoAlt.PUIn)
 begintParUsage(yyt->NoAlt.PUOut)
 return yyt;
}

tTree mAnAlts
# if defined __STDC__ | defined __cplusplus
(tTree pSpecList, tTree pNext)
# else
(pSpecList, pNext)
tTree pSpecList;
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAnAlts])
 yyt->Kind = kAnAlts;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->AnAlts.VS)
 beginint(yyt->AnAlts.VIn)
 beginint(yyt->AnAlts.VOut)
 beginint(yyt->AnAlts.SLC)
 beginint(yyt->AnAlts.ARC)
 begintSymbol(yyt->AnAlts.Parent)
 begintParUsage(yyt->AnAlts.PUIn)
 begintParUsage(yyt->AnAlts.PUOut)
 yyt->AnAlts.SpecList = pSpecList;
 yyt->AnAlts.Next = pNext;
 return yyt;
}

tTree mAnAlt
# if defined __STDC__ | defined __cplusplus
(tTree pSpecList, tTree pNext, tTree pGuard)
# else
(pSpecList, pNext, pGuard)
tTree pSpecList;
tTree pNext;
tTree pGuard;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAnAlt])
 yyt->Kind = kAnAlt;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->AnAlt.VS)
 beginint(yyt->AnAlt.VIn)
 beginint(yyt->AnAlt.VOut)
 beginint(yyt->AnAlt.SLC)
 beginint(yyt->AnAlt.ARC)
 begintSymbol(yyt->AnAlt.Parent)
 begintParUsage(yyt->AnAlt.PUIn)
 begintParUsage(yyt->AnAlt.PUOut)
 yyt->AnAlt.SpecList = pSpecList;
 yyt->AnAlt.Next = pNext;
 yyt->AnAlt.Guard = pGuard;
 beginint(yyt->AnAlt.Label)
 return yyt;
}

tTree mANewAlt
# if defined __STDC__ | defined __cplusplus
(tTree pSpecList, tTree pNext, tTree pAltType)
# else
(pSpecList, pNext, pAltType)
tTree pSpecList;
tTree pNext;
tTree pAltType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kANewAlt])
 yyt->Kind = kANewAlt;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->ANewAlt.VS)
 beginint(yyt->ANewAlt.VIn)
 beginint(yyt->ANewAlt.VOut)
 beginint(yyt->ANewAlt.SLC)
 beginint(yyt->ANewAlt.ARC)
 begintSymbol(yyt->ANewAlt.Parent)
 begintParUsage(yyt->ANewAlt.PUIn)
 begintParUsage(yyt->ANewAlt.PUOut)
 yyt->ANewAlt.SpecList = pSpecList;
 yyt->ANewAlt.Next = pNext;
 yyt->ANewAlt.AltType = pAltType;
 return yyt;
}

tTree mGuard
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pExpr)
# else
(pPos, pExpr)
tPosition pPos;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kGuard])
 yyt->Kind = kGuard;
 yyt->yyHead.yyMark = 0;
 yyt->Guard.Pos = pPos;
 yyt->Guard.Expr = pExpr;
 beginint(yyt->Guard.VS)
 beginint(yyt->Guard.VIn)
 beginint(yyt->Guard.VOut)
 beginint(yyt->Guard.SLC)
 begintSymbol(yyt->Guard.Parent)
 begintParUsage(yyt->Guard.PUIn)
 begintParUsage(yyt->Guard.PUOut)
 return yyt;
}

tTree mAltInput
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pExpr, tTree pInput, tTree pProcess)
# else
(pPos, pExpr, pInput, pProcess)
tPosition pPos;
tTree pExpr;
tTree pInput;
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAltInput])
 yyt->Kind = kAltInput;
 yyt->yyHead.yyMark = 0;
 yyt->AltInput.Pos = pPos;
 yyt->AltInput.Expr = pExpr;
 beginint(yyt->AltInput.VS)
 beginint(yyt->AltInput.VIn)
 beginint(yyt->AltInput.VOut)
 beginint(yyt->AltInput.SLC)
 begintSymbol(yyt->AltInput.Parent)
 begintParUsage(yyt->AltInput.PUIn)
 begintParUsage(yyt->AltInput.PUOut)
 yyt->AltInput.Input = pInput;
 yyt->AltInput.Process = pProcess;
 return yyt;
}

tTree mAltTimer
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pExpr, tTree pAfter, tTree pProcess)
# else
(pPos, pExpr, pAfter, pProcess)
tPosition pPos;
tTree pExpr;
tTree pAfter;
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAltTimer])
 yyt->Kind = kAltTimer;
 yyt->yyHead.yyMark = 0;
 yyt->AltTimer.Pos = pPos;
 yyt->AltTimer.Expr = pExpr;
 beginint(yyt->AltTimer.VS)
 beginint(yyt->AltTimer.VIn)
 beginint(yyt->AltTimer.VOut)
 beginint(yyt->AltTimer.SLC)
 begintSymbol(yyt->AltTimer.Parent)
 begintParUsage(yyt->AltTimer.PUIn)
 begintParUsage(yyt->AltTimer.PUOut)
 yyt->AltTimer.After = pAfter;
 yyt->AltTimer.Process = pProcess;
 return yyt;
}

tTree mAltCaseIn
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pExpr, tTree pCaseIn)
# else
(pPos, pExpr, pCaseIn)
tPosition pPos;
tTree pExpr;
tTree pCaseIn;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAltCaseIn])
 yyt->Kind = kAltCaseIn;
 yyt->yyHead.yyMark = 0;
 yyt->AltCaseIn.Pos = pPos;
 yyt->AltCaseIn.Expr = pExpr;
 beginint(yyt->AltCaseIn.VS)
 beginint(yyt->AltCaseIn.VIn)
 beginint(yyt->AltCaseIn.VOut)
 beginint(yyt->AltCaseIn.SLC)
 begintSymbol(yyt->AltCaseIn.Parent)
 begintParUsage(yyt->AltCaseIn.PUIn)
 begintParUsage(yyt->AltCaseIn.PUOut)
 yyt->AltCaseIn.CaseIn = pCaseIn;
 return yyt;
}

tTree mNoInput
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tTree pExpr, tTree pProcess)
# else
(pPos, pExpr, pProcess)
tPosition pPos;
tTree pExpr;
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoInput])
 yyt->Kind = kNoInput;
 yyt->yyHead.yyMark = 0;
 yyt->NoInput.Pos = pPos;
 yyt->NoInput.Expr = pExpr;
 beginint(yyt->NoInput.VS)
 beginint(yyt->NoInput.VIn)
 beginint(yyt->NoInput.VOut)
 beginint(yyt->NoInput.SLC)
 begintSymbol(yyt->NoInput.Parent)
 begintParUsage(yyt->NoInput.PUIn)
 begintParUsage(yyt->NoInput.PUOut)
 yyt->NoInput.Process = pProcess;
 return yyt;
}

tTree mChoiceList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kChoiceList])
 yyt->Kind = kChoiceList;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->ChoiceList.SynType)
 beginint(yyt->ChoiceList.VS)
 beginint(yyt->ChoiceList.VIn)
 beginint(yyt->ChoiceList.VOut)
 beginbool(yyt->ChoiceList.ATOMIC)
 beginint(yyt->ChoiceList.SLC)
 begintSymbol(yyt->ChoiceList.Parent)
 begintParUsage(yyt->ChoiceList.PUIn)
 begintParUsage(yyt->ChoiceList.PUOut)
 return yyt;
}

tTree mNoChoice
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoChoice])
 yyt->Kind = kNoChoice;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->NoChoice.SynType)
 beginint(yyt->NoChoice.VS)
 beginint(yyt->NoChoice.VIn)
 beginint(yyt->NoChoice.VOut)
 beginbool(yyt->NoChoice.ATOMIC)
 beginint(yyt->NoChoice.SLC)
 begintSymbol(yyt->NoChoice.Parent)
 begintParUsage(yyt->NoChoice.PUIn)
 begintParUsage(yyt->NoChoice.PUOut)
 return yyt;
}

tTree mAChoices
# if defined __STDC__ | defined __cplusplus
(tTree pSpecList, tTree pNext)
# else
(pSpecList, pNext)
tTree pSpecList;
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAChoices])
 yyt->Kind = kAChoices;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->AChoices.SynType)
 beginint(yyt->AChoices.VS)
 beginint(yyt->AChoices.VIn)
 beginint(yyt->AChoices.VOut)
 beginbool(yyt->AChoices.ATOMIC)
 beginint(yyt->AChoices.SLC)
 begintSymbol(yyt->AChoices.Parent)
 begintParUsage(yyt->AChoices.PUIn)
 begintParUsage(yyt->AChoices.PUOut)
 yyt->AChoices.SpecList = pSpecList;
 yyt->AChoices.Next = pNext;
 return yyt;
}

tTree mAChoice
# if defined __STDC__ | defined __cplusplus
(tTree pSpecList, tTree pNext, tTree pExprList, tTree pProcess)
# else
(pSpecList, pNext, pExprList, pProcess)
tTree pSpecList;
tTree pNext;
tTree pExprList;
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAChoice])
 yyt->Kind = kAChoice;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->AChoice.SynType)
 beginint(yyt->AChoice.VS)
 beginint(yyt->AChoice.VIn)
 beginint(yyt->AChoice.VOut)
 beginbool(yyt->AChoice.ATOMIC)
 beginint(yyt->AChoice.SLC)
 begintSymbol(yyt->AChoice.Parent)
 begintParUsage(yyt->AChoice.PUIn)
 begintParUsage(yyt->AChoice.PUOut)
 yyt->AChoice.SpecList = pSpecList;
 yyt->AChoice.Next = pNext;
 yyt->AChoice.ExprList = pExprList;
 yyt->AChoice.Process = pProcess;
 beginint(yyt->AChoice.Label)
 return yyt;
}

tTree mANewIf
# if defined __STDC__ | defined __cplusplus
(tTree pSpecList, tTree pNext, tTree pIfType)
# else
(pSpecList, pNext, pIfType)
tTree pSpecList;
tTree pNext;
tTree pIfType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kANewIf])
 yyt->Kind = kANewIf;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->ANewIf.SynType)
 beginint(yyt->ANewIf.VS)
 beginint(yyt->ANewIf.VIn)
 beginint(yyt->ANewIf.VOut)
 beginbool(yyt->ANewIf.ATOMIC)
 beginint(yyt->ANewIf.SLC)
 begintSymbol(yyt->ANewIf.Parent)
 begintParUsage(yyt->ANewIf.PUIn)
 begintParUsage(yyt->ANewIf.PUOut)
 yyt->ANewIf.SpecList = pSpecList;
 yyt->ANewIf.Next = pNext;
 yyt->ANewIf.IfType = pIfType;
 return yyt;
}

tTree mProcList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kProcList])
 yyt->Kind = kProcList;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->ProcList.VS)
 beginint(yyt->ProcList.VIn)
 beginint(yyt->ProcList.VOut)
 beginbool(yyt->ProcList.ATOMIC)
 beginint(yyt->ProcList.SLC)
 begintSymbol(yyt->ProcList.Parent)
 begintParUsage(yyt->ProcList.PUIn)
 begintParUsage(yyt->ProcList.PUOut)
 beginbool(yyt->ProcList.PAR)
 begintPosition(yyt->ProcList.Pos)
 return yyt;
}

tTree mNoProcess
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoProcess])
 yyt->Kind = kNoProcess;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->NoProcess.VS)
 beginint(yyt->NoProcess.VIn)
 beginint(yyt->NoProcess.VOut)
 beginbool(yyt->NoProcess.ATOMIC)
 beginint(yyt->NoProcess.SLC)
 begintSymbol(yyt->NoProcess.Parent)
 begintParUsage(yyt->NoProcess.PUIn)
 begintParUsage(yyt->NoProcess.PUOut)
 beginbool(yyt->NoProcess.PAR)
 begintPosition(yyt->NoProcess.Pos)
 return yyt;
}

tTree mAProcess
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pProcess, tSymbol pSym)
# else
(pNext, pProcess, pSym)
tTree pNext;
tTree pProcess;
tSymbol pSym;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAProcess])
 yyt->Kind = kAProcess;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->AProcess.VS)
 beginint(yyt->AProcess.VIn)
 beginint(yyt->AProcess.VOut)
 beginbool(yyt->AProcess.ATOMIC)
 beginint(yyt->AProcess.SLC)
 begintSymbol(yyt->AProcess.Parent)
 begintParUsage(yyt->AProcess.PUIn)
 begintParUsage(yyt->AProcess.PUOut)
 beginbool(yyt->AProcess.PAR)
 begintPosition(yyt->AProcess.Pos)
 yyt->AProcess.Next = pNext;
 yyt->AProcess.Process = pProcess;
 yyt->AProcess.Sym = pSym;
 return yyt;
}

tTree mCaseList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCaseList])
 yyt->Kind = kCaseList;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->CaseList.VS)
 beginint(yyt->CaseList.VIn)
 beginint(yyt->CaseList.VOut)
 beginint(yyt->CaseList.SLC)
 begintSymbol(yyt->CaseList.Parent)
 begintParUsage(yyt->CaseList.PUIn)
 begintParUsage(yyt->CaseList.PUOut)
 return yyt;
}

tTree mNoCase
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoCase])
 yyt->Kind = kNoCase;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->NoCase.VS)
 beginint(yyt->NoCase.VIn)
 beginint(yyt->NoCase.VOut)
 beginint(yyt->NoCase.SLC)
 begintSymbol(yyt->NoCase.Parent)
 begintParUsage(yyt->NoCase.PUIn)
 begintParUsage(yyt->NoCase.PUOut)
 return yyt;
}

tTree mACase
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pSpecList, tTree pExprList, tTree pProcess)
# else
(pNext, pSpecList, pExprList, pProcess)
tTree pNext;
tTree pSpecList;
tTree pExprList;
tTree pProcess;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACase])
 yyt->Kind = kACase;
 yyt->yyHead.yyMark = 0;
 beginint(yyt->ACase.VS)
 beginint(yyt->ACase.VIn)
 beginint(yyt->ACase.VOut)
 beginint(yyt->ACase.SLC)
 begintSymbol(yyt->ACase.Parent)
 begintParUsage(yyt->ACase.PUIn)
 begintParUsage(yyt->ACase.PUOut)
 yyt->ACase.Next = pNext;
 yyt->ACase.SpecList = pSpecList;
 yyt->ACase.ExprList = pExprList;
 yyt->ACase.Process = pProcess;
 beginint(yyt->ACase.Label)
 return yyt;
}

tTree mAccessList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAccessList])
 yyt->Kind = kAccessList;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mAnAccess
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tSymbol pSym, tTree pElementList)
# else
(pNext, pSym, pElementList)
tTree pNext;
tSymbol pSym;
tTree pElementList;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAnAccess])
 yyt->Kind = kAnAccess;
 yyt->yyHead.yyMark = 0;
 yyt->AnAccess.Next = pNext;
 yyt->AnAccess.Sym = pSym;
 yyt->AnAccess.ElementList = pElementList;
 return yyt;
}

tTree mNoAccess
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoAccess])
 yyt->Kind = kNoAccess;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mElementList
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElementList])
 yyt->Kind = kElementList;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mAnElement
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pElement)
# else
(pNext, pElement)
tTree pNext;
tTree pElement;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAnElement])
 yyt->Kind = kAnElement;
 yyt->yyHead.yyMark = 0;
 yyt->AnElement.Next = pNext;
 yyt->AnElement.Element = pElement;
 return yyt;
}

tTree mNoElement
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoElement])
 yyt->Kind = kNoElement;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

typedef tTree * yyPtrtTree;

extern FILE *yyf;

static void yyMark
# if defined __STDC__ | defined __cplusplus
 (register tTree yyt)
# else
 (yyt) register tTree yyt;
# endif
{
 for (;;) {
  if (yyt == NoTree || ++ yyt->yyHead.yyMark > 1) return;

  switch (yyt->Kind) {
case kStart:
yyt = yyt->Start.Process; break;
case kASpec:
yyMark (yyt->ASpec.Spec);
yyt = yyt->ASpec.Next; break;
case kDecl:
yyMark (yyt->Decl.Type);
yyt = yyt->Decl.IdList; break;
case kIs:
yyMark (yyt->Is.Type);
yyt = yyt->Is.Elemental; break;
case kAVal:
yyMark (yyt->AVal.Type);
yyt = yyt->AVal.Expr; break;
case kVal:
yyMark (yyt->Val.Type);
yyt = yyt->Val.Expr; break;
case kValRetypes:
yyMark (yyt->ValRetypes.Type);
yyt = yyt->ValRetypes.Expr; break;
case kRetypes:
yyMark (yyt->Retypes.Type);
yyt = yyt->Retypes.Elemental; break;
case kDefSeqPro:
yyt = yyt->DefSeqPro.SeqProList; break;
case kDefTagPro:
yyt = yyt->DefTagPro.TagProList; break;
case kDefAProc:
yyt = yyt->DefAProc.Formals; break;
case kDefProc:
yyMark (yyt->DefProc.Formals);
yyt = yyt->DefProc.Process; break;
case kPrototypeProc:
yyt = yyt->PrototypeProc.Formals; break;
case kDefAFunc:
yyMark (yyt->DefAFunc.TypeList);
yyt = yyt->DefAFunc.Formals; break;
case kDefFunc:
yyMark (yyt->DefFunc.TypeList);
yyMark (yyt->DefFunc.Formals);
yyt = yyt->DefFunc.Valof; break;
case kDefIsFunc:
yyMark (yyt->DefIsFunc.TypeList);
yyMark (yyt->DefIsFunc.Formals);
yyt = yyt->DefIsFunc.ExprList; break;
case kPrototypeFunc:
yyMark (yyt->PrototypeFunc.TypeList);
yyt = yyt->PrototypeFunc.Formals; break;
case kAFormal:
yyMark (yyt->AFormal.Next);
yyMark (yyt->AFormal.By);
yyt = yyt->AFormal.Type; break;
case kReplicator:
yyMark (yyt->Replicator.From);
yyt = yyt->Replicator.For; break;
case kATagPro:
yyMark (yyt->ATagPro.SeqProList);
yyt = yyt->ATagPro.Next; break;
case kAnId:
yyt = yyt->AnId.Next; break;
case kArray:
yyMark (yyt->Array.Expr);
yyt = yyt->Array.Type; break;
case kChan:
yyt = yyt->Chan.Protocol; break;
case kAType:
yyMark (yyt->AType.Type);
yyt = yyt->AType.Next; break;
case kSimple:
yyt = yyt->Simple.Type; break;
case kCounted:
yyMark (yyt->Counted.Length);
yyt = yyt->Counted.Type; break;
case kASeqPro:
yyMark (yyt->ASeqPro.Protocol);
yyt = yyt->ASeqPro.Next; break;
case kBinary:
yyMark (yyt->Binary.Lop);
yyMark (yyt->Binary.Rop);
yyt = yyt->Binary.Op; break;
case kUnary:
yyMark (yyt->Unary.Expr);
yyt = yyt->Unary.Op; break;
case kConst:
yyt = yyt->Const.Type; break;
case kValof:
yyMark (yyt->Valof.SpecList);
yyMark (yyt->Valof.Process);
yyt = yyt->Valof.ExprList; break;
case kFuncCall:
yyt = yyt->FuncCall.ExprList; break;
case kElementalExpr:
yyt = yyt->ElementalExpr.Elemental; break;
case kConvert:
yyMark (yyt->Convert.Type);
yyt = yyt->Convert.Expr; break;
case kRound:
yyMark (yyt->Round.Type);
yyt = yyt->Round.Expr; break;
case kTrunc:
yyMark (yyt->Trunc.Type);
yyt = yyt->Trunc.Expr; break;
case kMostPos:
yyt = yyt->MostPos.Type; break;
case kMostNeg:
yyt = yyt->MostNeg.Type; break;
case kCountArray:
yyMark (yyt->CountArray.Length);
yyt = yyt->CountArray.Expr; break;
case kStringSubscript:
yyMark (yyt->StringSubscript.Next);
yyt = yyt->StringSubscript.Expr; break;
case kStringRange:
yyMark (yyt->StringRange.Next);
yyMark (yyt->StringRange.From);
yyt = yyt->StringRange.For; break;
case kTable:
yyt = yyt->Table.ExprList; break;
case kTableSubscript:
yyMark (yyt->TableSubscript.Next);
yyt = yyt->TableSubscript.Expr; break;
case kTableRange:
yyMark (yyt->TableRange.Next);
yyMark (yyt->TableRange.From);
yyt = yyt->TableRange.For; break;
case kElementAccess:
yyt = yyt->ElementAccess.Next; break;
case kSubscript:
yyMark (yyt->Subscript.Next);
yyt = yyt->Subscript.Expr; break;
case kRange:
yyMark (yyt->Range.Next);
yyMark (yyt->Range.From);
yyt = yyt->Range.For; break;
case kAnExpr:
yyMark (yyt->AnExpr.Expr);
yyt = yyt->AnExpr.Next; break;
case kProcess:
yyt = yyt->Process.SpecList; break;
case kAssign:
yyMark (yyt->Assign.SpecList);
yyMark (yyt->Assign.Lval);
yyt = yyt->Assign.Rval; break;
case kAltType:
yyt = yyt->AltType.SpecList; break;
case kAlt:
yyMark (yyt->Alt.SpecList);
yyt = yyt->Alt.AltList; break;
case kAltRep:
yyMark (yyt->AltRep.SpecList);
yyMark (yyt->AltRep.Replicator);
yyt = yyt->AltRep.AltList; break;
case kParType:
yyt = yyt->ParType.SpecList; break;
case kPar:
yyMark (yyt->Par.SpecList);
yyt = yyt->Par.ProcList; break;
case kParRep:
yyMark (yyt->ParRep.SpecList);
yyMark (yyt->ParRep.Replicator);
yyt = yyt->ParRep.Process; break;
case kProcessor:
yyMark (yyt->Processor.SpecList);
yyMark (yyt->Processor.Expr);
yyt = yyt->Processor.Process; break;
case kIfType:
yyt = yyt->IfType.SpecList; break;
case kIf:
yyMark (yyt->If.SpecList);
yyt = yyt->If.ChoiceList; break;
case kIfRep:
yyMark (yyt->IfRep.SpecList);
yyMark (yyt->IfRep.Replicator);
yyt = yyt->IfRep.ChoiceList; break;
case kInput:
yyMark (yyt->Input.SpecList);
yyMark (yyt->Input.Element);
yyt = yyt->Input.ExprList; break;
case kOutput:
yyMark (yyt->Output.SpecList);
yyMark (yyt->Output.Element);
yyt = yyt->Output.ExprList; break;
case kCaseIn:
yyMark (yyt->CaseIn.SpecList);
yyMark (yyt->CaseIn.Element);
yyt = yyt->CaseIn.CaseList; break;
case kAfter:
yyMark (yyt->After.SpecList);
yyMark (yyt->After.Element);
yyt = yyt->After.Expr; break;
case kSeqRep:
yyMark (yyt->SeqRep.SpecList);
yyMark (yyt->SeqRep.Replicator);
yyt = yyt->SeqRep.Process; break;
case kSeq:
yyMark (yyt->Seq.SpecList);
yyt = yyt->Seq.ProcList; break;
case kCase:
yyMark (yyt->Case.SpecList);
yyMark (yyt->Case.Selector);
yyt = yyt->Case.ChoiceList; break;
case kWhile:
yyMark (yyt->While.SpecList);
yyMark (yyt->While.Expr);
yyt = yyt->While.Process; break;
case kSkip:
yyt = yyt->Skip.SpecList; break;
case kStop:
yyt = yyt->Stop.SpecList; break;
case kInstance:
yyMark (yyt->Instance.SpecList);
yyt = yyt->Instance.ExprList; break;
case kCCode:
yyt = yyt->CCode.SpecList; break;
case kNullProcess:
yyt = yyt->NullProcess.SpecList; break;
case kAnAlts:
yyMark (yyt->AnAlts.SpecList);
yyt = yyt->AnAlts.Next; break;
case kAnAlt:
yyMark (yyt->AnAlt.SpecList);
yyMark (yyt->AnAlt.Guard);
yyt = yyt->AnAlt.Next; break;
case kANewAlt:
yyMark (yyt->ANewAlt.SpecList);
yyMark (yyt->ANewAlt.AltType);
yyt = yyt->ANewAlt.Next; break;
case kGuard:
yyt = yyt->Guard.Expr; break;
case kAltInput:
yyMark (yyt->AltInput.Expr);
yyMark (yyt->AltInput.Input);
yyt = yyt->AltInput.Process; break;
case kAltTimer:
yyMark (yyt->AltTimer.Expr);
yyMark (yyt->AltTimer.After);
yyt = yyt->AltTimer.Process; break;
case kAltCaseIn:
yyMark (yyt->AltCaseIn.Expr);
yyt = yyt->AltCaseIn.CaseIn; break;
case kNoInput:
yyMark (yyt->NoInput.Expr);
yyt = yyt->NoInput.Process; break;
case kAChoices:
yyMark (yyt->AChoices.SpecList);
yyt = yyt->AChoices.Next; break;
case kAChoice:
yyMark (yyt->AChoice.SpecList);
yyMark (yyt->AChoice.ExprList);
yyMark (yyt->AChoice.Process);
yyt = yyt->AChoice.Next; break;
case kANewIf:
yyMark (yyt->ANewIf.SpecList);
yyMark (yyt->ANewIf.IfType);
yyt = yyt->ANewIf.Next; break;
case kAProcess:
yyMark (yyt->AProcess.Process);
yyt = yyt->AProcess.Next; break;
case kACase:
yyMark (yyt->ACase.SpecList);
yyMark (yyt->ACase.ExprList);
yyMark (yyt->ACase.Process);
yyt = yyt->ACase.Next; break;
case kAnAccess:
yyMark (yyt->AnAccess.Next);
yyt = yyt->AnAccess.ElementList; break;
case kAnElement:
yyMark (yyt->AnElement.Next);
yyt = yyt->AnElement.Element; break;
  default: return;
  }
 }
}

# define yyInitTreeStoreSize 32
# define yyMapToTree(yyLabel) yyTreeStorePtr [yyLabel]

static unsigned long yyTreeStoreSize = yyInitTreeStoreSize;
static tTree yyTreeStore [yyInitTreeStoreSize];
static tTree * yyTreeStorePtr = yyTreeStore;
static int yyLabelCount;
static short yyRecursionLevel = 0;

static Tree_tLabel yyMapToLabel
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyLabelCount; yyi ++) if (yyTreeStorePtr [yyi] == yyt) return yyi;
 if (++ yyLabelCount == yyTreeStoreSize)
  ExtendArray ((char * *) & yyTreeStorePtr, & yyTreeStoreSize, sizeof (tTree));
 yyTreeStorePtr [yyLabelCount] = yyt;
 return yyLabelCount;
}

static void yyWriteTree ();

static void yyWriteNl () { (void) putc ('\n', yyf); }

static void yyWriteSelector
# if defined __STDC__ | defined __cplusplus
 (char * yys)
# else
 (yys) char * yys;
# endif
{
 register int yyi = 16 - strlen (yys);
 (void) fputs (yys, yyf);
 while (yyi -- > 0) (void) putc (' ', yyf);
 (void) fputs (" = ", yyf);
}

static void yyWriteHex
# if defined __STDC__ | defined __cplusplus
 (unsigned char * yyx, int yysize)
# else
 (yyx, yysize) unsigned char * yyx; int yysize;
# endif
{ register int yyi; for (yyi = 0; yyi < yysize; yyi ++) (void) fprintf (yyf, "%02x ", yyx [yyi]); }

static void yyWriteAdr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 if (yyt == NoTree) (void) fputs ("NoTree", yyf);
 else yyWriteHex ((unsigned char *) & yyt, sizeof (yyt));
 yyWriteNl ();
}

static void yWriteNodeStart
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Process"); yyWriteAdr (yyt->Start.Process);
 yyWriteSelector ("CGNext"); writetChain (yyt->Start.CGNext) yyWriteNl ();
 yyWriteSelector ("OuterProc"); writetSymbol (yyt->Start.OuterProc) yyWriteNl ();
}

static void yWriteNodeSpecList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("VS"); writeint (yyt->SpecList.VS) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->SpecList.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->SpecList.VOut) yyWriteNl ();
 yyWriteSelector ("DCL"); writeint (yyt->SpecList.DCL) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->SpecList.Parent) yyWriteNl ();
 yyWriteSelector ("AtomicSpec"); writebool (yyt->SpecList.AtomicSpec) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->SpecList.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->SpecList.PUOut) yyWriteNl ();
}

static void yWriteNodeNoSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpecList (yyt); 
}

static void yWriteNodeASpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpecList (yyt); 
 yyWriteSelector ("Spec"); yyWriteAdr (yyt->ASpec.Spec);
 yyWriteSelector ("Next"); yyWriteAdr (yyt->ASpec.Next);
}

static void yWriteNodeSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Pos"); writetPosition (yyt->Spec.Pos) yyWriteNl ();
 yyWriteSelector ("VS"); writeint (yyt->Spec.VS) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->Spec.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->Spec.VOut) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->Spec.Parent) yyWriteNl ();
 yyWriteSelector ("AtomicSpec"); writebool (yyt->Spec.AtomicSpec) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->Spec.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->Spec.PUOut) yyWriteNl ();
}

static void yWriteNodeDecl
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Decl.Type);
 yyWriteSelector ("IdList"); yyWriteAdr (yyt->Decl.IdList);
}

static void yWriteNodeIs
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Is.Type);
 yyWriteSelector ("Sym"); writetSymbol (yyt->Is.Sym) yyWriteNl ();
 yyWriteSelector ("Elemental"); yyWriteAdr (yyt->Is.Elemental);
 yyWriteSelector ("U"); writetUsage (yyt->Is.U) yyWriteNl ();
}

static void yWriteNodeAVal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->AVal.Type);
 yyWriteSelector ("Sym"); writetSymbol (yyt->AVal.Sym) yyWriteNl ();
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->AVal.Expr);
}

static void yWriteNodeVal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAVal (yyt); 
}

static void yWriteNodeValRetypes
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAVal (yyt); 
}

static void yWriteNodeRetypes
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Retypes.Type);
 yyWriteSelector ("Sym"); writetSymbol (yyt->Retypes.Sym) yyWriteNl ();
 yyWriteSelector ("Elemental"); yyWriteAdr (yyt->Retypes.Elemental);
}

static void yWriteNodeDefAPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
}

static void yWriteNodeDefSeqPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDefAPro (yyt); 
 yyWriteSelector ("Sym"); writetSymbol (yyt->DefSeqPro.Sym) yyWriteNl ();
 yyWriteSelector ("SeqProList"); yyWriteAdr (yyt->DefSeqPro.SeqProList);
}

static void yWriteNodeDefTagPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDefAPro (yyt); 
 yyWriteSelector ("Sym"); writetSymbol (yyt->DefTagPro.Sym) yyWriteNl ();
 yyWriteSelector ("TagProList"); yyWriteAdr (yyt->DefTagPro.TagProList);
}

static void yWriteNodeDefAProc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
 yyWriteSelector ("Sym"); writetSymbol (yyt->DefAProc.Sym) yyWriteNl ();
 yyWriteSelector ("Formals"); yyWriteAdr (yyt->DefAProc.Formals);
 yyWriteSelector ("U"); writetUsage (yyt->DefAProc.U) yyWriteNl ();
 yyWriteSelector ("CGNext"); writetChain (yyt->DefAProc.CGNext) yyWriteNl ();
}

static void yWriteNodeDefProc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDefAProc (yyt); 
 yyWriteSelector ("Process"); yyWriteAdr (yyt->DefProc.Process);
 yyWriteSelector ("ATOMIC"); writebool (yyt->DefProc.ATOMIC) yyWriteNl ();
 yyWriteSelector ("isPar"); writebool (yyt->DefProc.isPar) yyWriteNl ();
}

static void yWriteNodePrototypeProc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDefAProc (yyt); 
 yyWriteSelector ("Module"); writetIdent (yyt->PrototypeProc.Module) yyWriteNl ();
 yyWriteSelector ("Lang"); writetLang (yyt->PrototypeProc.Lang) yyWriteNl ();
}

static void yWriteNodeDefAFunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
 yyWriteSelector ("Sym"); writetSymbol (yyt->DefAFunc.Sym) yyWriteNl ();
 yyWriteSelector ("TypeList"); yyWriteAdr (yyt->DefAFunc.TypeList);
 yyWriteSelector ("Formals"); yyWriteAdr (yyt->DefAFunc.Formals);
 yyWriteSelector ("U"); writetUsage (yyt->DefAFunc.U) yyWriteNl ();
 yyWriteSelector ("CGNext"); writetChain (yyt->DefAFunc.CGNext) yyWriteNl ();
}

static void yWriteNodeDefFunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDefAFunc (yyt); 
 yyWriteSelector ("Valof"); yyWriteAdr (yyt->DefFunc.Valof);
 yyWriteSelector ("ATOMIC"); writebool (yyt->DefFunc.ATOMIC) yyWriteNl ();
}

static void yWriteNodeDefIsFunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDefAFunc (yyt); 
 yyWriteSelector ("ExprList"); yyWriteAdr (yyt->DefIsFunc.ExprList);
 yyWriteSelector ("ATOMIC"); writebool (yyt->DefIsFunc.ATOMIC) yyWriteNl ();
}

static void yWriteNodePrototypeFunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDefAFunc (yyt); 
 yyWriteSelector ("Module"); writetIdent (yyt->PrototypeFunc.Module) yyWriteNl ();
 yyWriteSelector ("Lang"); writetLang (yyt->PrototypeFunc.Lang) yyWriteNl ();
}

static void yWriteNodeNullSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
}

static void yWriteNodeHCode
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
 yyWriteSelector ("Code"); writetStringRef (yyt->HCode.Code) yyWriteNl ();
 yyWriteSelector ("Scope"); writetSymbol (yyt->HCode.Scope) yyWriteNl ();
 yyWriteSelector ("CGNext"); writetChain (yyt->HCode.CGNext) yyWriteNl ();
}

static void yWriteNodeCallFrame
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
 yyWriteSelector ("Id"); writetIdent (yyt->CallFrame.Id) yyWriteNl ();
 yyWriteSelector ("Sym"); writetSymbol (yyt->CallFrame.Sym) yyWriteNl ();
}

static void yWriteNodeParFrame
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSpec (yyt); 
 yyWriteSelector ("TId"); writetIdent (yyt->ParFrame.TId) yyWriteNl ();
 yyWriteSelector ("FId"); writetIdent (yyt->ParFrame.FId) yyWriteNl ();
 yyWriteSelector ("Sym"); writetSymbol (yyt->ParFrame.Sym) yyWriteNl ();
 yyWriteSelector ("Rep"); writeint (yyt->ParFrame.Rep) yyWriteNl ();
}

static void yWriteNodeFormals
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("VIn"); writeint (yyt->Formals.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->Formals.VOut) yyWriteNl ();
 yyWriteSelector ("InPrototype"); writebool (yyt->Formals.InPrototype) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->Formals.Parent) yyWriteNl ();
 yyWriteSelector ("AtomicSpec"); writebool (yyt->Formals.AtomicSpec) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->Formals.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->Formals.PUOut) yyWriteNl ();
}

static void yWriteNodeNoFormal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFormals (yyt); 
}

static void yWriteNodeAFormal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFormals (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->AFormal.Next);
 yyWriteSelector ("Pos"); writetPosition (yyt->AFormal.Pos) yyWriteNl ();
 yyWriteSelector ("By"); yyWriteAdr (yyt->AFormal.By);
 yyWriteSelector ("Type"); yyWriteAdr (yyt->AFormal.Type);
 yyWriteSelector ("Sym"); writetSymbol (yyt->AFormal.Sym) yyWriteNl ();
 yyWriteSelector ("U"); writetUsage (yyt->AFormal.U) yyWriteNl ();
}

static void yWriteNodeReplicator
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Sym"); writetSymbol (yyt->Replicator.Sym) yyWriteNl ();
 yyWriteSelector ("From"); yyWriteAdr (yyt->Replicator.From);
 yyWriteSelector ("For"); yyWriteAdr (yyt->Replicator.For);
 yyWriteSelector ("VIn"); writeint (yyt->Replicator.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->Replicator.VOut) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->Replicator.Parent) yyWriteNl ();
 yyWriteSelector ("AtomicSpec"); writebool (yyt->Replicator.AtomicSpec) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->Replicator.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->Replicator.PUOut) yyWriteNl ();
 yyWriteSelector ("SE"); writebool (yyt->Replicator.SE) yyWriteNl ();
 yyWriteSelector ("FromLE"); writepLinExpr (yyt->Replicator.FromLE) yyWriteNl ();
 yyWriteSelector ("ForLE"); writepLinExpr (yyt->Replicator.ForLE) yyWriteNl ();
}

static void yWriteNodeTagProList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("PUIn"); writetParUsage (yyt->TagProList.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->TagProList.PUOut) yyWriteNl ();
}

static void yWriteNodeNoTagPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTagProList (yyt); 
}

static void yWriteNodeATagPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTagProList (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->ATagPro.Next);
 yyWriteSelector ("Sym"); writetSymbol (yyt->ATagPro.Sym) yyWriteNl ();
 yyWriteSelector ("SeqProList"); yyWriteAdr (yyt->ATagPro.SeqProList);
}

static void yWriteNodeIdList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Parent"); writetSymbol (yyt->IdList.Parent) yyWriteNl ();
 yyWriteSelector ("AtomicSpec"); writebool (yyt->IdList.AtomicSpec) yyWriteNl ();
}

static void yWriteNodeNoId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeIdList (yyt); 
}

static void yWriteNodeAnId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeIdList (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->AnId.Next);
 yyWriteSelector ("Sym"); writetSymbol (yyt->AnId.Sym) yyWriteNl ();
 yyWriteSelector ("U"); writetUsage (yyt->AnId.U) yyWriteNl ();
}

static void yWriteNodeType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("VIn"); writeint (yyt->Type.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->Type.VOut) yyWriteNl ();
 yyWriteSelector ("D"); writeint (yyt->Type.D) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->Type.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->Type.PUOut) yyWriteNl ();
}

static void yWriteNodeArray
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Array.Expr);
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Array.Type);
 yyWriteSelector ("SE"); writebool (yyt->Array.SE) yyWriteNl ();
 yyWriteSelector ("LE"); writepLinExpr (yyt->Array.LE) yyWriteNl ();
}

static void yWriteNodeChan
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
 yyWriteSelector ("Protocol"); yyWriteAdr (yyt->Chan.Protocol);
}

static void yWriteNodeTimer
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
}

static void yWriteNodeUntyped
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
}

static void yWriteNodePrimitive
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
}

static void yWriteNodeNumeric
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodePrimitive (yyt); 
}

static void yWriteNodeInteger
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeNumeric (yyt); 
}

static void yWriteNodeInt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeInteger (yyt); 
}

static void yWriteNodeInt16
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeInteger (yyt); 
}

static void yWriteNodeInt32
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeInteger (yyt); 
}

static void yWriteNodeInt64
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeInteger (yyt); 
}

static void yWriteNodeReal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeNumeric (yyt); 
}

static void yWriteNodeReal32
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeReal (yyt); 
}

static void yWriteNodeReal64
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeReal (yyt); 
}

static void yWriteNodeByte
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodePrimitive (yyt); 
}

static void yWriteNodeBool
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodePrimitive (yyt); 
}

static void yWriteNodeTypeList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
}

static void yWriteNodeNoType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTypeList (yyt); 
}

static void yWriteNodeAType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTypeList (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->AType.Next);
 yyWriteSelector ("Type"); yyWriteAdr (yyt->AType.Type);
}

static void yWriteNodeProtocol
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Pos"); writetPosition (yyt->Protocol.Pos) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->Protocol.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->Protocol.PUOut) yyWriteNl ();
}

static void yWriteNodeAny
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProtocol (yyt); 
}

static void yWriteNodeNamed
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProtocol (yyt); 
 yyWriteSelector ("Sym"); writetSymbol (yyt->Named.Sym) yyWriteNl ();
}

static void yWriteNodeSimple
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProtocol (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Simple.Type);
}

static void yWriteNodeCounted
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProtocol (yyt); 
 yyWriteSelector ("Length"); yyWriteAdr (yyt->Counted.Length);
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Counted.Type);
}

static void yWriteNodeSeqProList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("PUIn"); writetParUsage (yyt->SeqProList.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->SeqProList.PUOut) yyWriteNl ();
}

static void yWriteNodeNoSeqPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSeqProList (yyt); 
}

static void yWriteNodeASeqPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSeqProList (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->ASeqPro.Next);
 yyWriteSelector ("Protocol"); yyWriteAdr (yyt->ASeqPro.Protocol);
}

static void yWriteNodeExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Pos"); writetPosition (yyt->Expr.Pos) yyWriteNl ();
 yyWriteSelector ("SynType"); writetType (yyt->Expr.SynType) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->Expr.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->Expr.VOut) yyWriteNl ();
 yyWriteSelector ("C"); writebool (yyt->Expr.C) yyWriteNl ();
 yyWriteSelector ("CV"); writetValue (yyt->Expr.CV) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->Expr.Parent) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->Expr.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->Expr.PUOut) yyWriteNl ();
 yyWriteSelector ("LV"); writebool (yyt->Expr.LV) yyWriteNl ();
}

static void yWriteNodeBinary
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Lop"); yyWriteAdr (yyt->Binary.Lop);
 yyWriteSelector ("Rop"); yyWriteAdr (yyt->Binary.Rop);
 yyWriteSelector ("Op"); yyWriteAdr (yyt->Binary.Op);
}

static void yWriteNodeUnary
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Unary.Expr);
 yyWriteSelector ("Op"); yyWriteAdr (yyt->Unary.Op);
}

static void yWriteNodeConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Value"); writetValue (yyt->Const.Value) yyWriteNl ();
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Const.Type);
}

static void yWriteNodeValof
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("SpecList"); yyWriteAdr (yyt->Valof.SpecList);
 yyWriteSelector ("Process"); yyWriteAdr (yyt->Valof.Process);
 yyWriteSelector ("ExprList"); yyWriteAdr (yyt->Valof.ExprList);
 yyWriteSelector ("Sym"); writetSymbol (yyt->Valof.Sym) yyWriteNl ();
 yyWriteSelector ("VS"); writeint (yyt->Valof.VS) yyWriteNl ();
}

static void yWriteNodeFuncCall
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Sym"); writetSymbol (yyt->FuncCall.Sym) yyWriteNl ();
 yyWriteSelector ("ExprList"); yyWriteAdr (yyt->FuncCall.ExprList);
 yyWriteSelector ("Depth"); writeint (yyt->FuncCall.Depth) yyWriteNl ();
 yyWriteSelector ("Frame"); writetFrame (yyt->FuncCall.Frame) yyWriteNl ();
}

static void yWriteNodeElementalExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Elemental"); yyWriteAdr (yyt->ElementalExpr.Elemental);
 yyWriteSelector ("PAR"); writebool (yyt->ElementalExpr.PAR) yyWriteNl ();
}

static void yWriteNodeDefault
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
}

static void yWriteNodeConvert
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Convert.Type);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Convert.Expr);
}

static void yWriteNodeRound
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Round.Type);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Round.Expr);
}

static void yWriteNodeTrunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Trunc.Type);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Trunc.Expr);
}

static void yWriteNodeMostPos
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->MostPos.Type);
}

static void yWriteNodeMostNeg
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->MostNeg.Type);
}

static void yWriteNodeCountArray
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Length"); yyWriteAdr (yyt->CountArray.Length);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->CountArray.Expr);
}

static void yWriteNodeUnBound
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
}

static void yWriteNodeStringElement
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("CA"); writetConstArray (yyt->StringElement.CA) yyWriteNl ();
}

static void yWriteNodeString
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStringElement (yyt); 
 yyWriteSelector ("Value"); writetStringRef (yyt->String.Value) yyWriteNl ();
 yyWriteSelector ("Depth"); writeint (yyt->String.Depth) yyWriteNl ();
 yyWriteSelector ("Sym"); writetSymbol (yyt->String.Sym) yyWriteNl ();
}

static void yWriteNodeStringSubscript
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStringElement (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->StringSubscript.Next);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->StringSubscript.Expr);
}

static void yWriteNodeStringRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStringElement (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->StringRange.Next);
 yyWriteSelector ("From"); yyWriteAdr (yyt->StringRange.From);
 yyWriteSelector ("For"); yyWriteAdr (yyt->StringRange.For);
}

static void yWriteNodeElemental
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Pos"); writetPosition (yyt->Elemental.Pos) yyWriteNl ();
 yyWriteSelector ("SynType"); writetType (yyt->Elemental.SynType) yyWriteNl ();
 yyWriteSelector ("W"); writeint (yyt->Elemental.W) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->Elemental.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->Elemental.VOut) yyWriteNl ();
 yyWriteSelector ("C"); writebool (yyt->Elemental.C) yyWriteNl ();
 yyWriteSelector ("CV"); writetValue (yyt->Elemental.CV) yyWriteNl ();
 yyWriteSelector ("CA"); writetConstArray (yyt->Elemental.CA) yyWriteNl ();
 yyWriteSelector ("U"); writetUsage (yyt->Elemental.U) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->Elemental.Parent) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->Elemental.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->Elemental.PUOut) yyWriteNl ();
 yyWriteSelector ("LV"); writebool (yyt->Elemental.LV) yyWriteNl ();
 yyWriteSelector ("SE"); writebool (yyt->Elemental.SE) yyWriteNl ();
}

static void yWriteNodeTableElement
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElemental (yyt); 
}

static void yWriteNodeTable
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTableElement (yyt); 
 yyWriteSelector ("ExprList"); yyWriteAdr (yyt->Table.ExprList);
 yyWriteSelector ("Depth"); writeint (yyt->Table.Depth) yyWriteNl ();
 yyWriteSelector ("Sym"); writetSymbol (yyt->Table.Sym) yyWriteNl ();
 yyWriteSelector ("LE"); writepLinExpr (yyt->Table.LE) yyWriteNl ();
}

static void yWriteNodeTableSubscript
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTableElement (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->TableSubscript.Next);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->TableSubscript.Expr);
 yyWriteSelector ("LE"); writepLinExpr (yyt->TableSubscript.LE) yyWriteNl ();
}

static void yWriteNodeTableRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTableElement (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->TableRange.Next);
 yyWriteSelector ("From"); yyWriteAdr (yyt->TableRange.From);
 yyWriteSelector ("For"); yyWriteAdr (yyt->TableRange.For);
 yyWriteSelector ("FromLE"); writepLinExpr (yyt->TableRange.FromLE) yyWriteNl ();
 yyWriteSelector ("ForLE"); writepLinExpr (yyt->TableRange.ForLE) yyWriteNl ();
}

static void yWriteNodeElement
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElemental (yyt); 
}

static void yWriteNodeIdentifier
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElement (yyt); 
 yyWriteSelector ("Sym"); writetSymbol (yyt->Identifier.Sym) yyWriteNl ();
 yyWriteSelector ("Scope"); writetSymbol (yyt->Identifier.Scope) yyWriteNl ();
}

static void yWriteNodeElementAccess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElement (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->ElementAccess.Next);
}

static void yWriteNodeSubscript
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElementAccess (yyt); 
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Subscript.Expr);
 yyWriteSelector ("CB"); writebool (yyt->Subscript.CB) yyWriteNl ();
 yyWriteSelector ("LE"); writepLinExpr (yyt->Subscript.LE) yyWriteNl ();
}

static void yWriteNodeRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElementAccess (yyt); 
 yyWriteSelector ("From"); yyWriteAdr (yyt->Range.From);
 yyWriteSelector ("For"); yyWriteAdr (yyt->Range.For);
 yyWriteSelector ("CLB"); writebool (yyt->Range.CLB) yyWriteNl ();
 yyWriteSelector ("CUB"); writebool (yyt->Range.CUB) yyWriteNl ();
 yyWriteSelector ("FromLE"); writepLinExpr (yyt->Range.FromLE) yyWriteNl ();
 yyWriteSelector ("ForLE"); writepLinExpr (yyt->Range.ForLE) yyWriteNl ();
}

static void yWriteNodeExprList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("SynType"); writetType (yyt->ExprList.SynType) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->ExprList.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->ExprList.VOut) yyWriteNl ();
 yyWriteSelector ("C"); writebool (yyt->ExprList.C) yyWriteNl ();
 yyWriteSelector ("TR"); writebool (yyt->ExprList.TR) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->ExprList.Parent) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->ExprList.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->ExprList.PUOut) yyWriteNl ();
 yyWriteSelector ("PAR"); writebool (yyt->ExprList.PAR) yyWriteNl ();
 yyWriteSelector ("LV"); writebool (yyt->ExprList.LV) yyWriteNl ();
}

static void yWriteNodeNoExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExprList (yyt); 
}

static void yWriteNodeAnExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExprList (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->AnExpr.Next);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->AnExpr.Expr);
}

static void yWriteNodeProcess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Pos"); writetPosition (yyt->Process.Pos) yyWriteNl ();
 yyWriteSelector ("SpecList"); yyWriteAdr (yyt->Process.SpecList);
 yyWriteSelector ("VS"); writeint (yyt->Process.VS) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->Process.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->Process.VOut) yyWriteNl ();
 yyWriteSelector ("ATOMIC"); writebool (yyt->Process.ATOMIC) yyWriteNl ();
 yyWriteSelector ("SLC"); writeint (yyt->Process.SLC) yyWriteNl ();
 yyWriteSelector ("TLA"); writebool (yyt->Process.TLA) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->Process.Parent) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->Process.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->Process.PUOut) yyWriteNl ();
}

static void yWriteNodeAssign
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Lval"); yyWriteAdr (yyt->Assign.Lval);
 yyWriteSelector ("Rval"); yyWriteAdr (yyt->Assign.Rval);
}

static void yWriteNodeAltType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Pri"); writebool (yyt->AltType.Pri) yyWriteNl ();
 yyWriteSelector ("ARC"); writeint (yyt->AltType.ARC) yyWriteNl ();
}

static void yWriteNodeAlt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAltType (yyt); 
 yyWriteSelector ("AltList"); yyWriteAdr (yyt->Alt.AltList);
}

static void yWriteNodeAltRep
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAltType (yyt); 
 yyWriteSelector ("Replicator"); yyWriteAdr (yyt->AltRep.Replicator);
 yyWriteSelector ("AltList"); yyWriteAdr (yyt->AltRep.AltList);
}

static void yWriteNodeParType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("PType"); writetParType (yyt->ParType.PType) yyWriteNl ();
}

static void yWriteNodePar
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeParType (yyt); 
 yyWriteSelector ("ProcList"); yyWriteAdr (yyt->Par.ProcList);
}

static void yWriteNodeParRep
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeParType (yyt); 
 yyWriteSelector ("Replicator"); yyWriteAdr (yyt->ParRep.Replicator);
 yyWriteSelector ("Process"); yyWriteAdr (yyt->ParRep.Process);
 yyWriteSelector ("Sym"); writetSymbol (yyt->ParRep.Sym) yyWriteNl ();
}

static void yWriteNodeProcessor
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Processor.Expr);
 yyWriteSelector ("Name"); writetIdent (yyt->Processor.Name) yyWriteNl ();
 yyWriteSelector ("Process"); yyWriteAdr (yyt->Processor.Process);
}

static void yWriteNodeIfType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("BackChoiceList"); writetChoiceList (yyt->IfType.BackChoiceList) yyWriteNl ();
 yyWriteSelector ("BackIfType"); writetIfType (yyt->IfType.BackIfType) yyWriteNl ();
}

static void yWriteNodeIf
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeIfType (yyt); 
 yyWriteSelector ("ChoiceList"); yyWriteAdr (yyt->If.ChoiceList);
}

static void yWriteNodeIfRep
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeIfType (yyt); 
 yyWriteSelector ("Replicator"); yyWriteAdr (yyt->IfRep.Replicator);
 yyWriteSelector ("ChoiceList"); yyWriteAdr (yyt->IfRep.ChoiceList);
}

static void yWriteNodeInput
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Element"); yyWriteAdr (yyt->Input.Element);
 yyWriteSelector ("ExprList"); yyWriteAdr (yyt->Input.ExprList);
}

static void yWriteNodeOutput
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Element"); yyWriteAdr (yyt->Output.Element);
 yyWriteSelector ("ExprList"); yyWriteAdr (yyt->Output.ExprList);
}

static void yWriteNodeCaseIn
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Element"); yyWriteAdr (yyt->CaseIn.Element);
 yyWriteSelector ("CaseList"); yyWriteAdr (yyt->CaseIn.CaseList);
}

static void yWriteNodeAfter
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Element"); yyWriteAdr (yyt->After.Element);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->After.Expr);
}

static void yWriteNodeSeqRep
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Replicator"); yyWriteAdr (yyt->SeqRep.Replicator);
 yyWriteSelector ("Process"); yyWriteAdr (yyt->SeqRep.Process);
}

static void yWriteNodeSeq
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("ProcList"); yyWriteAdr (yyt->Seq.ProcList);
}

static void yWriteNodeCase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Selector"); yyWriteAdr (yyt->Case.Selector);
 yyWriteSelector ("ChoiceList"); yyWriteAdr (yyt->Case.ChoiceList);
}

static void yWriteNodeWhile
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->While.Expr);
 yyWriteSelector ("Process"); yyWriteAdr (yyt->While.Process);
}

static void yWriteNodeSkip
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
}

static void yWriteNodeStop
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
}

static void yWriteNodeInstance
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Sym"); writetSymbol (yyt->Instance.Sym) yyWriteNl ();
 yyWriteSelector ("ExprList"); yyWriteAdr (yyt->Instance.ExprList);
 yyWriteSelector ("Scope"); writetSymbol (yyt->Instance.Scope) yyWriteNl ();
 yyWriteSelector ("Frame"); writetFrame (yyt->Instance.Frame) yyWriteNl ();
}

static void yWriteNodeCCode
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
 yyWriteSelector ("Code"); writetStringRef (yyt->CCode.Code) yyWriteNl ();
 yyWriteSelector ("Scope"); writetSymbol (yyt->CCode.Scope) yyWriteNl ();
}

static void yWriteNodeNullProcess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcess (yyt); 
}

static void yWriteNodeAltList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("VS"); writeint (yyt->AltList.VS) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->AltList.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->AltList.VOut) yyWriteNl ();
 yyWriteSelector ("SLC"); writeint (yyt->AltList.SLC) yyWriteNl ();
 yyWriteSelector ("ARC"); writeint (yyt->AltList.ARC) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->AltList.Parent) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->AltList.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->AltList.PUOut) yyWriteNl ();
}

static void yWriteNodeNoAlt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAltList (yyt); 
}

static void yWriteNodeAnAlts
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAltList (yyt); 
 yyWriteSelector ("SpecList"); yyWriteAdr (yyt->AnAlts.SpecList);
 yyWriteSelector ("Next"); yyWriteAdr (yyt->AnAlts.Next);
}

static void yWriteNodeAnAlt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAnAlts (yyt); 
 yyWriteSelector ("Guard"); yyWriteAdr (yyt->AnAlt.Guard);
 yyWriteSelector ("Label"); writeint (yyt->AnAlt.Label) yyWriteNl ();
}

static void yWriteNodeANewAlt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAnAlts (yyt); 
 yyWriteSelector ("AltType"); yyWriteAdr (yyt->ANewAlt.AltType);
}

static void yWriteNodeGuard
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Pos"); writetPosition (yyt->Guard.Pos) yyWriteNl ();
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Guard.Expr);
 yyWriteSelector ("VS"); writeint (yyt->Guard.VS) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->Guard.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->Guard.VOut) yyWriteNl ();
 yyWriteSelector ("SLC"); writeint (yyt->Guard.SLC) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->Guard.Parent) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->Guard.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->Guard.PUOut) yyWriteNl ();
}

static void yWriteNodeAltInput
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeGuard (yyt); 
 yyWriteSelector ("Input"); yyWriteAdr (yyt->AltInput.Input);
 yyWriteSelector ("Process"); yyWriteAdr (yyt->AltInput.Process);
}

static void yWriteNodeAltTimer
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeGuard (yyt); 
 yyWriteSelector ("After"); yyWriteAdr (yyt->AltTimer.After);
 yyWriteSelector ("Process"); yyWriteAdr (yyt->AltTimer.Process);
}

static void yWriteNodeAltCaseIn
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeGuard (yyt); 
 yyWriteSelector ("CaseIn"); yyWriteAdr (yyt->AltCaseIn.CaseIn);
}

static void yWriteNodeNoInput
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeGuard (yyt); 
 yyWriteSelector ("Process"); yyWriteAdr (yyt->NoInput.Process);
}

static void yWriteNodeChoiceList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("SynType"); writetType (yyt->ChoiceList.SynType) yyWriteNl ();
 yyWriteSelector ("VS"); writeint (yyt->ChoiceList.VS) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->ChoiceList.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->ChoiceList.VOut) yyWriteNl ();
 yyWriteSelector ("ATOMIC"); writebool (yyt->ChoiceList.ATOMIC) yyWriteNl ();
 yyWriteSelector ("SLC"); writeint (yyt->ChoiceList.SLC) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->ChoiceList.Parent) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->ChoiceList.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->ChoiceList.PUOut) yyWriteNl ();
}

static void yWriteNodeNoChoice
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeChoiceList (yyt); 
}

static void yWriteNodeAChoices
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeChoiceList (yyt); 
 yyWriteSelector ("SpecList"); yyWriteAdr (yyt->AChoices.SpecList);
 yyWriteSelector ("Next"); yyWriteAdr (yyt->AChoices.Next);
}

static void yWriteNodeAChoice
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAChoices (yyt); 
 yyWriteSelector ("ExprList"); yyWriteAdr (yyt->AChoice.ExprList);
 yyWriteSelector ("Process"); yyWriteAdr (yyt->AChoice.Process);
 yyWriteSelector ("Label"); writeint (yyt->AChoice.Label) yyWriteNl ();
}

static void yWriteNodeANewIf
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeAChoices (yyt); 
 yyWriteSelector ("IfType"); yyWriteAdr (yyt->ANewIf.IfType);
}

static void yWriteNodeProcList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("VS"); writeint (yyt->ProcList.VS) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->ProcList.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->ProcList.VOut) yyWriteNl ();
 yyWriteSelector ("ATOMIC"); writebool (yyt->ProcList.ATOMIC) yyWriteNl ();
 yyWriteSelector ("SLC"); writeint (yyt->ProcList.SLC) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->ProcList.Parent) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->ProcList.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->ProcList.PUOut) yyWriteNl ();
 yyWriteSelector ("PAR"); writebool (yyt->ProcList.PAR) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->ProcList.Pos) yyWriteNl ();
}

static void yWriteNodeNoProcess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcList (yyt); 
}

static void yWriteNodeAProcess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeProcList (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->AProcess.Next);
 yyWriteSelector ("Process"); yyWriteAdr (yyt->AProcess.Process);
 yyWriteSelector ("Sym"); writetSymbol (yyt->AProcess.Sym) yyWriteNl ();
}

static void yWriteNodeCaseList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("VS"); writeint (yyt->CaseList.VS) yyWriteNl ();
 yyWriteSelector ("VIn"); writeint (yyt->CaseList.VIn) yyWriteNl ();
 yyWriteSelector ("VOut"); writeint (yyt->CaseList.VOut) yyWriteNl ();
 yyWriteSelector ("SLC"); writeint (yyt->CaseList.SLC) yyWriteNl ();
 yyWriteSelector ("Parent"); writetSymbol (yyt->CaseList.Parent) yyWriteNl ();
 yyWriteSelector ("PUIn"); writetParUsage (yyt->CaseList.PUIn) yyWriteNl ();
 yyWriteSelector ("PUOut"); writetParUsage (yyt->CaseList.PUOut) yyWriteNl ();
}

static void yWriteNodeNoCase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeCaseList (yyt); 
}

static void yWriteNodeACase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeCaseList (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->ACase.Next);
 yyWriteSelector ("SpecList"); yyWriteAdr (yyt->ACase.SpecList);
 yyWriteSelector ("ExprList"); yyWriteAdr (yyt->ACase.ExprList);
 yyWriteSelector ("Process"); yyWriteAdr (yyt->ACase.Process);
 yyWriteSelector ("Label"); writeint (yyt->ACase.Label) yyWriteNl ();
}

static void yWriteNodeAnAccess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Next"); yyWriteAdr (yyt->AnAccess.Next);
 yyWriteSelector ("Sym"); writetSymbol (yyt->AnAccess.Sym) yyWriteNl ();
 yyWriteSelector ("ElementList"); yyWriteAdr (yyt->AnAccess.ElementList);
}

static void yWriteNodeAnElement
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Next"); yyWriteAdr (yyt->AnElement.Next);
 yyWriteSelector ("Element"); yyWriteAdr (yyt->AnElement.Element);
}

void WriteTreeNode
# if defined __STDC__ | defined __cplusplus
 (FILE * yyyf, tTree yyt)
# else
 (yyyf, yyt) FILE * yyyf; tTree yyt;
# endif
{
 yyf = yyyf;
 if (yyt == NoTree) { (void) fputs ("NoTree\n", yyf); return; }

 switch (yyt->Kind) {
case kStart: (void) fputs (Tree_NodeName [kStart], yyf); (void) fputc ('\n', yyf);
 yWriteNodeStart (yyt); break;
case kSpecList: (void) fputs (Tree_NodeName [kSpecList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSpecList (yyt); break;
case kNoSpec: (void) fputs (Tree_NodeName [kNoSpec], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoSpec (yyt); break;
case kASpec: (void) fputs (Tree_NodeName [kASpec], yyf); (void) fputc ('\n', yyf);
 yWriteNodeASpec (yyt); break;
case kSpec: (void) fputs (Tree_NodeName [kSpec], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSpec (yyt); break;
case kDecl: (void) fputs (Tree_NodeName [kDecl], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDecl (yyt); break;
case kIs: (void) fputs (Tree_NodeName [kIs], yyf); (void) fputc ('\n', yyf);
 yWriteNodeIs (yyt); break;
case kAVal: (void) fputs (Tree_NodeName [kAVal], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAVal (yyt); break;
case kVal: (void) fputs (Tree_NodeName [kVal], yyf); (void) fputc ('\n', yyf);
 yWriteNodeVal (yyt); break;
case kValRetypes: (void) fputs (Tree_NodeName [kValRetypes], yyf); (void) fputc ('\n', yyf);
 yWriteNodeValRetypes (yyt); break;
case kRetypes: (void) fputs (Tree_NodeName [kRetypes], yyf); (void) fputc ('\n', yyf);
 yWriteNodeRetypes (yyt); break;
case kDefAPro: (void) fputs (Tree_NodeName [kDefAPro], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefAPro (yyt); break;
case kDefSeqPro: (void) fputs (Tree_NodeName [kDefSeqPro], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefSeqPro (yyt); break;
case kDefTagPro: (void) fputs (Tree_NodeName [kDefTagPro], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefTagPro (yyt); break;
case kDefAProc: (void) fputs (Tree_NodeName [kDefAProc], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefAProc (yyt); break;
case kDefProc: (void) fputs (Tree_NodeName [kDefProc], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefProc (yyt); break;
case kPrototypeProc: (void) fputs (Tree_NodeName [kPrototypeProc], yyf); (void) fputc ('\n', yyf);
 yWriteNodePrototypeProc (yyt); break;
case kDefAFunc: (void) fputs (Tree_NodeName [kDefAFunc], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefAFunc (yyt); break;
case kDefFunc: (void) fputs (Tree_NodeName [kDefFunc], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefFunc (yyt); break;
case kDefIsFunc: (void) fputs (Tree_NodeName [kDefIsFunc], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefIsFunc (yyt); break;
case kPrototypeFunc: (void) fputs (Tree_NodeName [kPrototypeFunc], yyf); (void) fputc ('\n', yyf);
 yWriteNodePrototypeFunc (yyt); break;
case kNullSpec: (void) fputs (Tree_NodeName [kNullSpec], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNullSpec (yyt); break;
case kHCode: (void) fputs (Tree_NodeName [kHCode], yyf); (void) fputc ('\n', yyf);
 yWriteNodeHCode (yyt); break;
case kCallFrame: (void) fputs (Tree_NodeName [kCallFrame], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCallFrame (yyt); break;
case kParFrame: (void) fputs (Tree_NodeName [kParFrame], yyf); (void) fputc ('\n', yyf);
 yWriteNodeParFrame (yyt); break;
case kFormals: (void) fputs (Tree_NodeName [kFormals], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFormals (yyt); break;
case kNoFormal: (void) fputs (Tree_NodeName [kNoFormal], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoFormal (yyt); break;
case kAFormal: (void) fputs (Tree_NodeName [kAFormal], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAFormal (yyt); break;
case kReplicator: (void) fputs (Tree_NodeName [kReplicator], yyf); (void) fputc ('\n', yyf);
 yWriteNodeReplicator (yyt); break;
case kTagProList: (void) fputs (Tree_NodeName [kTagProList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTagProList (yyt); break;
case kNoTagPro: (void) fputs (Tree_NodeName [kNoTagPro], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoTagPro (yyt); break;
case kATagPro: (void) fputs (Tree_NodeName [kATagPro], yyf); (void) fputc ('\n', yyf);
 yWriteNodeATagPro (yyt); break;
case kBy: (void) fputs (Tree_NodeName [kBy], yyf); (void) fputc ('\n', yyf);
 break;
case kByVal: (void) fputs (Tree_NodeName [kByVal], yyf); (void) fputc ('\n', yyf);
 break;
case kByRef: (void) fputs (Tree_NodeName [kByRef], yyf); (void) fputc ('\n', yyf);
 break;
case kByUndef: (void) fputs (Tree_NodeName [kByUndef], yyf); (void) fputc ('\n', yyf);
 break;
case kIdList: (void) fputs (Tree_NodeName [kIdList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeIdList (yyt); break;
case kNoId: (void) fputs (Tree_NodeName [kNoId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoId (yyt); break;
case kAnId: (void) fputs (Tree_NodeName [kAnId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAnId (yyt); break;
case kType: (void) fputs (Tree_NodeName [kType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeType (yyt); break;
case kArray: (void) fputs (Tree_NodeName [kArray], yyf); (void) fputc ('\n', yyf);
 yWriteNodeArray (yyt); break;
case kChan: (void) fputs (Tree_NodeName [kChan], yyf); (void) fputc ('\n', yyf);
 yWriteNodeChan (yyt); break;
case kTimer: (void) fputs (Tree_NodeName [kTimer], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTimer (yyt); break;
case kUntyped: (void) fputs (Tree_NodeName [kUntyped], yyf); (void) fputc ('\n', yyf);
 yWriteNodeUntyped (yyt); break;
case kPrimitive: (void) fputs (Tree_NodeName [kPrimitive], yyf); (void) fputc ('\n', yyf);
 yWriteNodePrimitive (yyt); break;
case kNumeric: (void) fputs (Tree_NodeName [kNumeric], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNumeric (yyt); break;
case kInteger: (void) fputs (Tree_NodeName [kInteger], yyf); (void) fputc ('\n', yyf);
 yWriteNodeInteger (yyt); break;
case kInt: (void) fputs (Tree_NodeName [kInt], yyf); (void) fputc ('\n', yyf);
 yWriteNodeInt (yyt); break;
case kInt16: (void) fputs (Tree_NodeName [kInt16], yyf); (void) fputc ('\n', yyf);
 yWriteNodeInt16 (yyt); break;
case kInt32: (void) fputs (Tree_NodeName [kInt32], yyf); (void) fputc ('\n', yyf);
 yWriteNodeInt32 (yyt); break;
case kInt64: (void) fputs (Tree_NodeName [kInt64], yyf); (void) fputc ('\n', yyf);
 yWriteNodeInt64 (yyt); break;
case kReal: (void) fputs (Tree_NodeName [kReal], yyf); (void) fputc ('\n', yyf);
 yWriteNodeReal (yyt); break;
case kReal32: (void) fputs (Tree_NodeName [kReal32], yyf); (void) fputc ('\n', yyf);
 yWriteNodeReal32 (yyt); break;
case kReal64: (void) fputs (Tree_NodeName [kReal64], yyf); (void) fputc ('\n', yyf);
 yWriteNodeReal64 (yyt); break;
case kByte: (void) fputs (Tree_NodeName [kByte], yyf); (void) fputc ('\n', yyf);
 yWriteNodeByte (yyt); break;
case kBool: (void) fputs (Tree_NodeName [kBool], yyf); (void) fputc ('\n', yyf);
 yWriteNodeBool (yyt); break;
case kTypeList: (void) fputs (Tree_NodeName [kTypeList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTypeList (yyt); break;
case kNoType: (void) fputs (Tree_NodeName [kNoType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoType (yyt); break;
case kAType: (void) fputs (Tree_NodeName [kAType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAType (yyt); break;
case kProtocol: (void) fputs (Tree_NodeName [kProtocol], yyf); (void) fputc ('\n', yyf);
 yWriteNodeProtocol (yyt); break;
case kAny: (void) fputs (Tree_NodeName [kAny], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAny (yyt); break;
case kNamed: (void) fputs (Tree_NodeName [kNamed], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNamed (yyt); break;
case kSimple: (void) fputs (Tree_NodeName [kSimple], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSimple (yyt); break;
case kCounted: (void) fputs (Tree_NodeName [kCounted], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCounted (yyt); break;
case kSeqProList: (void) fputs (Tree_NodeName [kSeqProList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSeqProList (yyt); break;
case kNoSeqPro: (void) fputs (Tree_NodeName [kNoSeqPro], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoSeqPro (yyt); break;
case kASeqPro: (void) fputs (Tree_NodeName [kASeqPro], yyf); (void) fputc ('\n', yyf);
 yWriteNodeASeqPro (yyt); break;
case kExpr: (void) fputs (Tree_NodeName [kExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeExpr (yyt); break;
case kBinary: (void) fputs (Tree_NodeName [kBinary], yyf); (void) fputc ('\n', yyf);
 yWriteNodeBinary (yyt); break;
case kUnary: (void) fputs (Tree_NodeName [kUnary], yyf); (void) fputc ('\n', yyf);
 yWriteNodeUnary (yyt); break;
case kConst: (void) fputs (Tree_NodeName [kConst], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConst (yyt); break;
case kValof: (void) fputs (Tree_NodeName [kValof], yyf); (void) fputc ('\n', yyf);
 yWriteNodeValof (yyt); break;
case kFuncCall: (void) fputs (Tree_NodeName [kFuncCall], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFuncCall (yyt); break;
case kElementalExpr: (void) fputs (Tree_NodeName [kElementalExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElementalExpr (yyt); break;
case kDefault: (void) fputs (Tree_NodeName [kDefault], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefault (yyt); break;
case kConvert: (void) fputs (Tree_NodeName [kConvert], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConvert (yyt); break;
case kRound: (void) fputs (Tree_NodeName [kRound], yyf); (void) fputc ('\n', yyf);
 yWriteNodeRound (yyt); break;
case kTrunc: (void) fputs (Tree_NodeName [kTrunc], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTrunc (yyt); break;
case kMostPos: (void) fputs (Tree_NodeName [kMostPos], yyf); (void) fputc ('\n', yyf);
 yWriteNodeMostPos (yyt); break;
case kMostNeg: (void) fputs (Tree_NodeName [kMostNeg], yyf); (void) fputc ('\n', yyf);
 yWriteNodeMostNeg (yyt); break;
case kCountArray: (void) fputs (Tree_NodeName [kCountArray], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCountArray (yyt); break;
case kUnBound: (void) fputs (Tree_NodeName [kUnBound], yyf); (void) fputc ('\n', yyf);
 yWriteNodeUnBound (yyt); break;
case kStringElement: (void) fputs (Tree_NodeName [kStringElement], yyf); (void) fputc ('\n', yyf);
 yWriteNodeStringElement (yyt); break;
case kString: (void) fputs (Tree_NodeName [kString], yyf); (void) fputc ('\n', yyf);
 yWriteNodeString (yyt); break;
case kStringSubscript: (void) fputs (Tree_NodeName [kStringSubscript], yyf); (void) fputc ('\n', yyf);
 yWriteNodeStringSubscript (yyt); break;
case kStringRange: (void) fputs (Tree_NodeName [kStringRange], yyf); (void) fputc ('\n', yyf);
 yWriteNodeStringRange (yyt); break;
case kElemental: (void) fputs (Tree_NodeName [kElemental], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElemental (yyt); break;
case kTableElement: (void) fputs (Tree_NodeName [kTableElement], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTableElement (yyt); break;
case kTable: (void) fputs (Tree_NodeName [kTable], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTable (yyt); break;
case kTableSubscript: (void) fputs (Tree_NodeName [kTableSubscript], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTableSubscript (yyt); break;
case kTableRange: (void) fputs (Tree_NodeName [kTableRange], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTableRange (yyt); break;
case kElement: (void) fputs (Tree_NodeName [kElement], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElement (yyt); break;
case kIdentifier: (void) fputs (Tree_NodeName [kIdentifier], yyf); (void) fputc ('\n', yyf);
 yWriteNodeIdentifier (yyt); break;
case kElementAccess: (void) fputs (Tree_NodeName [kElementAccess], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElementAccess (yyt); break;
case kSubscript: (void) fputs (Tree_NodeName [kSubscript], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSubscript (yyt); break;
case kRange: (void) fputs (Tree_NodeName [kRange], yyf); (void) fputc ('\n', yyf);
 yWriteNodeRange (yyt); break;
case kExprList: (void) fputs (Tree_NodeName [kExprList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeExprList (yyt); break;
case kNoExpr: (void) fputs (Tree_NodeName [kNoExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoExpr (yyt); break;
case kAnExpr: (void) fputs (Tree_NodeName [kAnExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAnExpr (yyt); break;
case kOp: (void) fputs (Tree_NodeName [kOp], yyf); (void) fputc ('\n', yyf);
 break;
case kRelOp: (void) fputs (Tree_NodeName [kRelOp], yyf); (void) fputc ('\n', yyf);
 break;
case kLess: (void) fputs (Tree_NodeName [kLess], yyf); (void) fputc ('\n', yyf);
 break;
case kGreater: (void) fputs (Tree_NodeName [kGreater], yyf); (void) fputc ('\n', yyf);
 break;
case kLessEqual: (void) fputs (Tree_NodeName [kLessEqual], yyf); (void) fputc ('\n', yyf);
 break;
case kGreaterEqual: (void) fputs (Tree_NodeName [kGreaterEqual], yyf); (void) fputc ('\n', yyf);
 break;
case kEqual: (void) fputs (Tree_NodeName [kEqual], yyf); (void) fputc ('\n', yyf);
 break;
case kNotEqual: (void) fputs (Tree_NodeName [kNotEqual], yyf); (void) fputc ('\n', yyf);
 break;
case kMathsOp: (void) fputs (Tree_NodeName [kMathsOp], yyf); (void) fputc ('\n', yyf);
 break;
case kAdd: (void) fputs (Tree_NodeName [kAdd], yyf); (void) fputc ('\n', yyf);
 break;
case kSubtract: (void) fputs (Tree_NodeName [kSubtract], yyf); (void) fputc ('\n', yyf);
 break;
case kMultiply: (void) fputs (Tree_NodeName [kMultiply], yyf); (void) fputc ('\n', yyf);
 break;
case kDivide: (void) fputs (Tree_NodeName [kDivide], yyf); (void) fputc ('\n', yyf);
 break;
case kRem: (void) fputs (Tree_NodeName [kRem], yyf); (void) fputc ('\n', yyf);
 break;
case kBitOp: (void) fputs (Tree_NodeName [kBitOp], yyf); (void) fputc ('\n', yyf);
 break;
case kBitAnd: (void) fputs (Tree_NodeName [kBitAnd], yyf); (void) fputc ('\n', yyf);
 break;
case kBitOr: (void) fputs (Tree_NodeName [kBitOr], yyf); (void) fputc ('\n', yyf);
 break;
case kBitEor: (void) fputs (Tree_NodeName [kBitEor], yyf); (void) fputc ('\n', yyf);
 break;
case kShiftOp: (void) fputs (Tree_NodeName [kShiftOp], yyf); (void) fputc ('\n', yyf);
 break;
case kLeftShift: (void) fputs (Tree_NodeName [kLeftShift], yyf); (void) fputc ('\n', yyf);
 break;
case kRightShift: (void) fputs (Tree_NodeName [kRightShift], yyf); (void) fputc ('\n', yyf);
 break;
case kUniOp: (void) fputs (Tree_NodeName [kUniOp], yyf); (void) fputc ('\n', yyf);
 break;
case kSize: (void) fputs (Tree_NodeName [kSize], yyf); (void) fputc ('\n', yyf);
 break;
case kBitNot: (void) fputs (Tree_NodeName [kBitNot], yyf); (void) fputc ('\n', yyf);
 break;
case kNot: (void) fputs (Tree_NodeName [kNot], yyf); (void) fputc ('\n', yyf);
 break;
case kClockOp: (void) fputs (Tree_NodeName [kClockOp], yyf); (void) fputc ('\n', yyf);
 break;
case kPlus: (void) fputs (Tree_NodeName [kPlus], yyf); (void) fputc ('\n', yyf);
 break;
case kMinus: (void) fputs (Tree_NodeName [kMinus], yyf); (void) fputc ('\n', yyf);
 break;
case kTimes: (void) fputs (Tree_NodeName [kTimes], yyf); (void) fputc ('\n', yyf);
 break;
case kLogOp: (void) fputs (Tree_NodeName [kLogOp], yyf); (void) fputc ('\n', yyf);
 break;
case kAnd: (void) fputs (Tree_NodeName [kAnd], yyf); (void) fputc ('\n', yyf);
 break;
case kOr: (void) fputs (Tree_NodeName [kOr], yyf); (void) fputc ('\n', yyf);
 break;
case kAfterOp: (void) fputs (Tree_NodeName [kAfterOp], yyf); (void) fputc ('\n', yyf);
 break;
case kProcess: (void) fputs (Tree_NodeName [kProcess], yyf); (void) fputc ('\n', yyf);
 yWriteNodeProcess (yyt); break;
case kAssign: (void) fputs (Tree_NodeName [kAssign], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAssign (yyt); break;
case kAltType: (void) fputs (Tree_NodeName [kAltType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAltType (yyt); break;
case kAlt: (void) fputs (Tree_NodeName [kAlt], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAlt (yyt); break;
case kAltRep: (void) fputs (Tree_NodeName [kAltRep], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAltRep (yyt); break;
case kParType: (void) fputs (Tree_NodeName [kParType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeParType (yyt); break;
case kPar: (void) fputs (Tree_NodeName [kPar], yyf); (void) fputc ('\n', yyf);
 yWriteNodePar (yyt); break;
case kParRep: (void) fputs (Tree_NodeName [kParRep], yyf); (void) fputc ('\n', yyf);
 yWriteNodeParRep (yyt); break;
case kProcessor: (void) fputs (Tree_NodeName [kProcessor], yyf); (void) fputc ('\n', yyf);
 yWriteNodeProcessor (yyt); break;
case kIfType: (void) fputs (Tree_NodeName [kIfType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeIfType (yyt); break;
case kIf: (void) fputs (Tree_NodeName [kIf], yyf); (void) fputc ('\n', yyf);
 yWriteNodeIf (yyt); break;
case kIfRep: (void) fputs (Tree_NodeName [kIfRep], yyf); (void) fputc ('\n', yyf);
 yWriteNodeIfRep (yyt); break;
case kInput: (void) fputs (Tree_NodeName [kInput], yyf); (void) fputc ('\n', yyf);
 yWriteNodeInput (yyt); break;
case kOutput: (void) fputs (Tree_NodeName [kOutput], yyf); (void) fputc ('\n', yyf);
 yWriteNodeOutput (yyt); break;
case kCaseIn: (void) fputs (Tree_NodeName [kCaseIn], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCaseIn (yyt); break;
case kAfter: (void) fputs (Tree_NodeName [kAfter], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAfter (yyt); break;
case kSeqRep: (void) fputs (Tree_NodeName [kSeqRep], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSeqRep (yyt); break;
case kSeq: (void) fputs (Tree_NodeName [kSeq], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSeq (yyt); break;
case kCase: (void) fputs (Tree_NodeName [kCase], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCase (yyt); break;
case kWhile: (void) fputs (Tree_NodeName [kWhile], yyf); (void) fputc ('\n', yyf);
 yWriteNodeWhile (yyt); break;
case kSkip: (void) fputs (Tree_NodeName [kSkip], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSkip (yyt); break;
case kStop: (void) fputs (Tree_NodeName [kStop], yyf); (void) fputc ('\n', yyf);
 yWriteNodeStop (yyt); break;
case kInstance: (void) fputs (Tree_NodeName [kInstance], yyf); (void) fputc ('\n', yyf);
 yWriteNodeInstance (yyt); break;
case kCCode: (void) fputs (Tree_NodeName [kCCode], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCCode (yyt); break;
case kNullProcess: (void) fputs (Tree_NodeName [kNullProcess], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNullProcess (yyt); break;
case kAltList: (void) fputs (Tree_NodeName [kAltList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAltList (yyt); break;
case kNoAlt: (void) fputs (Tree_NodeName [kNoAlt], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoAlt (yyt); break;
case kAnAlts: (void) fputs (Tree_NodeName [kAnAlts], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAnAlts (yyt); break;
case kAnAlt: (void) fputs (Tree_NodeName [kAnAlt], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAnAlt (yyt); break;
case kANewAlt: (void) fputs (Tree_NodeName [kANewAlt], yyf); (void) fputc ('\n', yyf);
 yWriteNodeANewAlt (yyt); break;
case kGuard: (void) fputs (Tree_NodeName [kGuard], yyf); (void) fputc ('\n', yyf);
 yWriteNodeGuard (yyt); break;
case kAltInput: (void) fputs (Tree_NodeName [kAltInput], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAltInput (yyt); break;
case kAltTimer: (void) fputs (Tree_NodeName [kAltTimer], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAltTimer (yyt); break;
case kAltCaseIn: (void) fputs (Tree_NodeName [kAltCaseIn], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAltCaseIn (yyt); break;
case kNoInput: (void) fputs (Tree_NodeName [kNoInput], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoInput (yyt); break;
case kChoiceList: (void) fputs (Tree_NodeName [kChoiceList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeChoiceList (yyt); break;
case kNoChoice: (void) fputs (Tree_NodeName [kNoChoice], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoChoice (yyt); break;
case kAChoices: (void) fputs (Tree_NodeName [kAChoices], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAChoices (yyt); break;
case kAChoice: (void) fputs (Tree_NodeName [kAChoice], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAChoice (yyt); break;
case kANewIf: (void) fputs (Tree_NodeName [kANewIf], yyf); (void) fputc ('\n', yyf);
 yWriteNodeANewIf (yyt); break;
case kProcList: (void) fputs (Tree_NodeName [kProcList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeProcList (yyt); break;
case kNoProcess: (void) fputs (Tree_NodeName [kNoProcess], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoProcess (yyt); break;
case kAProcess: (void) fputs (Tree_NodeName [kAProcess], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAProcess (yyt); break;
case kCaseList: (void) fputs (Tree_NodeName [kCaseList], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCaseList (yyt); break;
case kNoCase: (void) fputs (Tree_NodeName [kNoCase], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoCase (yyt); break;
case kACase: (void) fputs (Tree_NodeName [kACase], yyf); (void) fputc ('\n', yyf);
 yWriteNodeACase (yyt); break;
case kAccessList: (void) fputs (Tree_NodeName [kAccessList], yyf); (void) fputc ('\n', yyf);
 break;
case kAnAccess: (void) fputs (Tree_NodeName [kAnAccess], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAnAccess (yyt); break;
case kNoAccess: (void) fputs (Tree_NodeName [kNoAccess], yyf); (void) fputc ('\n', yyf);
 break;
case kElementList: (void) fputs (Tree_NodeName [kElementList], yyf); (void) fputc ('\n', yyf);
 break;
case kAnElement: (void) fputs (Tree_NodeName [kAnElement], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAnElement (yyt); break;
case kNoElement: (void) fputs (Tree_NodeName [kNoElement], yyf); (void) fputc ('\n', yyf);
 break;
 default: ;
 }
}

static short yyIndentLevel;

void WriteTree
# if defined __STDC__ | defined __cplusplus
 (FILE * yyyf, tTree yyt)
# else
 (yyyf, yyt) FILE * yyyf; tTree yyt;
# endif
{
 short yySaveLevel = yyIndentLevel;
 yyf = yyyf;
 if (yyRecursionLevel ++ == 0) yyLabelCount = 0;
 yyMark (yyt);
 yyIndentLevel = 0;
 yyWriteTree (yyt);
 yyIndentLevel = yySaveLevel;
 yyRecursionLevel --;
}

static void yyIndentSelector
# if defined __STDC__ | defined __cplusplus
 (char * yys)
# else
 (yys) char * yys;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyIndentLevel; yyi ++) (void) putc (' ', yyf);
 yyWriteSelector (yys);
}

static void yyIndentSelectorTree
# if defined __STDC__ | defined __cplusplus
 (char * yys, tTree yyt)
# else
 (yys, yyt) char * yys; tTree yyt;
# endif
{ yyIndentSelector (yys); writetTree (yyt) }

static void yWriteStart
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kStart], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("CGNext"); writetChain (yyt->Start.CGNext) yyWriteNl ();
 yyIndentSelector ("OuterProc"); writetSymbol (yyt->Start.OuterProc) yyWriteNl ();
}

static void yWriteSpecList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSpecList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->SpecList.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->SpecList.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->SpecList.VOut) yyWriteNl ();
 yyIndentSelector ("DCL"); writeint (yyt->SpecList.DCL) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->SpecList.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->SpecList.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->SpecList.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->SpecList.PUOut) yyWriteNl ();
}

static void yWriteNoSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoSpec], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->NoSpec.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->NoSpec.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NoSpec.VOut) yyWriteNl ();
 yyIndentSelector ("DCL"); writeint (yyt->NoSpec.DCL) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NoSpec.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->NoSpec.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoSpec.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoSpec.PUOut) yyWriteNl ();
}

static void yWriteASpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kASpec], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->ASpec.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ASpec.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ASpec.VOut) yyWriteNl ();
 yyIndentSelector ("DCL"); writeint (yyt->ASpec.DCL) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ASpec.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->ASpec.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ASpec.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ASpec.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Spec", yyt->ASpec.Spec);
}

static void yWriteSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSpec], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Spec.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Spec.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Spec.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Spec.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Spec.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->Spec.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Spec.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Spec.PUOut) yyWriteNl ();
}

static void yWriteDecl
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDecl], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Decl.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Decl.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Decl.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Decl.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Decl.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->Decl.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Decl.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Decl.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->Decl.Type);
}

static void yWriteIs
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kIs], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Is.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Is.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Is.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Is.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Is.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->Is.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Is.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Is.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->Is.Type);
 yyIndentSelector ("Sym"); writetSymbol (yyt->Is.Sym) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->Is.U) yyWriteNl ();
}

static void yWriteAVal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAVal], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->AVal.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->AVal.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AVal.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AVal.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AVal.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->AVal.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AVal.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AVal.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->AVal.Type);
 yyIndentSelector ("Sym"); writetSymbol (yyt->AVal.Sym) yyWriteNl ();
}

static void yWriteVal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kVal], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Val.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Val.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Val.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Val.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Val.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->Val.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Val.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Val.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->Val.Type);
 yyIndentSelector ("Sym"); writetSymbol (yyt->Val.Sym) yyWriteNl ();
}

static void yWriteValRetypes
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kValRetypes], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->ValRetypes.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->ValRetypes.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ValRetypes.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ValRetypes.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ValRetypes.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->ValRetypes.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ValRetypes.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ValRetypes.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->ValRetypes.Type);
 yyIndentSelector ("Sym"); writetSymbol (yyt->ValRetypes.Sym) yyWriteNl ();
}

static void yWriteRetypes
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kRetypes], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Retypes.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Retypes.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Retypes.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Retypes.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Retypes.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->Retypes.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Retypes.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Retypes.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->Retypes.Type);
 yyIndentSelector ("Sym"); writetSymbol (yyt->Retypes.Sym) yyWriteNl ();
}

static void yWriteDefAPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefAPro], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->DefAPro.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->DefAPro.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->DefAPro.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->DefAPro.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->DefAPro.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->DefAPro.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->DefAPro.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->DefAPro.PUOut) yyWriteNl ();
}

static void yWriteDefSeqPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefSeqPro], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->DefSeqPro.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->DefSeqPro.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->DefSeqPro.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->DefSeqPro.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->DefSeqPro.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->DefSeqPro.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->DefSeqPro.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->DefSeqPro.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->DefSeqPro.Sym) yyWriteNl ();
}

static void yWriteDefTagPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefTagPro], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->DefTagPro.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->DefTagPro.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->DefTagPro.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->DefTagPro.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->DefTagPro.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->DefTagPro.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->DefTagPro.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->DefTagPro.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->DefTagPro.Sym) yyWriteNl ();
}

static void yWriteDefAProc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefAProc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->DefAProc.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->DefAProc.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->DefAProc.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->DefAProc.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->DefAProc.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->DefAProc.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->DefAProc.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->DefAProc.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->DefAProc.Sym) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->DefAProc.U) yyWriteNl ();
 yyIndentSelector ("CGNext"); writetChain (yyt->DefAProc.CGNext) yyWriteNl ();
}

static void yWriteDefProc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefProc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->DefProc.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->DefProc.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->DefProc.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->DefProc.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->DefProc.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->DefProc.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->DefProc.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->DefProc.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->DefProc.Sym) yyWriteNl ();
 yyIndentSelectorTree ("Formals", yyt->DefProc.Formals);
 yyIndentSelector ("U"); writetUsage (yyt->DefProc.U) yyWriteNl ();
 yyIndentSelector ("CGNext"); writetChain (yyt->DefProc.CGNext) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->DefProc.ATOMIC) yyWriteNl ();
 yyIndentSelector ("isPar"); writebool (yyt->DefProc.isPar) yyWriteNl ();
}

static void yWritePrototypeProc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kPrototypeProc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->PrototypeProc.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->PrototypeProc.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->PrototypeProc.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->PrototypeProc.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->PrototypeProc.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->PrototypeProc.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->PrototypeProc.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->PrototypeProc.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->PrototypeProc.Sym) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->PrototypeProc.U) yyWriteNl ();
 yyIndentSelector ("CGNext"); writetChain (yyt->PrototypeProc.CGNext) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->PrototypeProc.Module) yyWriteNl ();
 yyIndentSelector ("Lang"); writetLang (yyt->PrototypeProc.Lang) yyWriteNl ();
}

static void yWriteDefAFunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefAFunc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->DefAFunc.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->DefAFunc.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->DefAFunc.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->DefAFunc.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->DefAFunc.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->DefAFunc.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->DefAFunc.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->DefAFunc.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->DefAFunc.Sym) yyWriteNl ();
 yyIndentSelectorTree ("TypeList", yyt->DefAFunc.TypeList);
 yyIndentSelector ("U"); writetUsage (yyt->DefAFunc.U) yyWriteNl ();
 yyIndentSelector ("CGNext"); writetChain (yyt->DefAFunc.CGNext) yyWriteNl ();
}

static void yWriteDefFunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefFunc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->DefFunc.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->DefFunc.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->DefFunc.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->DefFunc.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->DefFunc.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->DefFunc.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->DefFunc.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->DefFunc.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->DefFunc.Sym) yyWriteNl ();
 yyIndentSelectorTree ("TypeList", yyt->DefFunc.TypeList);
 yyIndentSelectorTree ("Formals", yyt->DefFunc.Formals);
 yyIndentSelector ("U"); writetUsage (yyt->DefFunc.U) yyWriteNl ();
 yyIndentSelector ("CGNext"); writetChain (yyt->DefFunc.CGNext) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->DefFunc.ATOMIC) yyWriteNl ();
}

static void yWriteDefIsFunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefIsFunc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->DefIsFunc.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->DefIsFunc.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->DefIsFunc.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->DefIsFunc.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->DefIsFunc.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->DefIsFunc.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->DefIsFunc.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->DefIsFunc.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->DefIsFunc.Sym) yyWriteNl ();
 yyIndentSelectorTree ("TypeList", yyt->DefIsFunc.TypeList);
 yyIndentSelectorTree ("Formals", yyt->DefIsFunc.Formals);
 yyIndentSelector ("U"); writetUsage (yyt->DefIsFunc.U) yyWriteNl ();
 yyIndentSelector ("CGNext"); writetChain (yyt->DefIsFunc.CGNext) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->DefIsFunc.ATOMIC) yyWriteNl ();
}

static void yWritePrototypeFunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kPrototypeFunc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->PrototypeFunc.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->PrototypeFunc.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->PrototypeFunc.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->PrototypeFunc.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->PrototypeFunc.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->PrototypeFunc.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->PrototypeFunc.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->PrototypeFunc.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->PrototypeFunc.Sym) yyWriteNl ();
 yyIndentSelectorTree ("TypeList", yyt->PrototypeFunc.TypeList);
 yyIndentSelector ("U"); writetUsage (yyt->PrototypeFunc.U) yyWriteNl ();
 yyIndentSelector ("CGNext"); writetChain (yyt->PrototypeFunc.CGNext) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->PrototypeFunc.Module) yyWriteNl ();
 yyIndentSelector ("Lang"); writetLang (yyt->PrototypeFunc.Lang) yyWriteNl ();
}

static void yWriteNullSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNullSpec], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->NullSpec.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->NullSpec.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->NullSpec.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NullSpec.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NullSpec.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->NullSpec.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NullSpec.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NullSpec.PUOut) yyWriteNl ();
}

static void yWriteHCode
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kHCode], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->HCode.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->HCode.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->HCode.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->HCode.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->HCode.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->HCode.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->HCode.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->HCode.PUOut) yyWriteNl ();
 yyIndentSelector ("Code"); writetStringRef (yyt->HCode.Code) yyWriteNl ();
 yyIndentSelector ("Scope"); writetSymbol (yyt->HCode.Scope) yyWriteNl ();
 yyIndentSelector ("CGNext"); writetChain (yyt->HCode.CGNext) yyWriteNl ();
}

static void yWriteCallFrame
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCallFrame], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->CallFrame.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->CallFrame.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->CallFrame.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->CallFrame.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->CallFrame.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->CallFrame.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->CallFrame.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->CallFrame.PUOut) yyWriteNl ();
 yyIndentSelector ("Id"); writetIdent (yyt->CallFrame.Id) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->CallFrame.Sym) yyWriteNl ();
}

static void yWriteParFrame
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kParFrame], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->ParFrame.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->ParFrame.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ParFrame.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ParFrame.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ParFrame.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->ParFrame.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ParFrame.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ParFrame.PUOut) yyWriteNl ();
 yyIndentSelector ("TId"); writetIdent (yyt->ParFrame.TId) yyWriteNl ();
 yyIndentSelector ("FId"); writetIdent (yyt->ParFrame.FId) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->ParFrame.Sym) yyWriteNl ();
 yyIndentSelector ("Rep"); writeint (yyt->ParFrame.Rep) yyWriteNl ();
}

static void yWriteFormals
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFormals], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Formals.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Formals.VOut) yyWriteNl ();
 yyIndentSelector ("InPrototype"); writebool (yyt->Formals.InPrototype) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Formals.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->Formals.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Formals.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Formals.PUOut) yyWriteNl ();
}

static void yWriteNoFormal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoFormal], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->NoFormal.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NoFormal.VOut) yyWriteNl ();
 yyIndentSelector ("InPrototype"); writebool (yyt->NoFormal.InPrototype) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NoFormal.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->NoFormal.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoFormal.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoFormal.PUOut) yyWriteNl ();
}

static void yWriteAFormal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAFormal], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->AFormal.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AFormal.VOut) yyWriteNl ();
 yyIndentSelector ("InPrototype"); writebool (yyt->AFormal.InPrototype) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AFormal.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->AFormal.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AFormal.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AFormal.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Next", yyt->AFormal.Next);
 yyIndentSelector ("Pos"); writetPosition (yyt->AFormal.Pos) yyWriteNl ();
 yyIndentSelectorTree ("By", yyt->AFormal.By);
 yyIndentSelector ("Sym"); writetSymbol (yyt->AFormal.Sym) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->AFormal.U) yyWriteNl ();
}

static void yWriteReplicator
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kReplicator], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Sym"); writetSymbol (yyt->Replicator.Sym) yyWriteNl ();
 yyIndentSelectorTree ("From", yyt->Replicator.From);
 yyIndentSelector ("VIn"); writeint (yyt->Replicator.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Replicator.VOut) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Replicator.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->Replicator.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Replicator.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Replicator.PUOut) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->Replicator.SE) yyWriteNl ();
 yyIndentSelector ("FromLE"); writepLinExpr (yyt->Replicator.FromLE) yyWriteNl ();
 yyIndentSelector ("ForLE"); writepLinExpr (yyt->Replicator.ForLE) yyWriteNl ();
}

static void yWriteTagProList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTagProList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("PUIn"); writetParUsage (yyt->TagProList.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->TagProList.PUOut) yyWriteNl ();
}

static void yWriteNoTagPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoTagPro], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoTagPro.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoTagPro.PUOut) yyWriteNl ();
}

static void yWriteATagPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kATagPro], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ATagPro.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ATagPro.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->ATagPro.Sym) yyWriteNl ();
 yyIndentSelectorTree ("SeqProList", yyt->ATagPro.SeqProList);
}

static void yWriteIdList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kIdList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Parent"); writetSymbol (yyt->IdList.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->IdList.AtomicSpec) yyWriteNl ();
}

static void yWriteNoId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Parent"); writetSymbol (yyt->NoId.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->NoId.AtomicSpec) yyWriteNl ();
}

static void yWriteAnId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAnId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Parent"); writetSymbol (yyt->AnId.Parent) yyWriteNl ();
 yyIndentSelector ("AtomicSpec"); writebool (yyt->AnId.AtomicSpec) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->AnId.Sym) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->AnId.U) yyWriteNl ();
}

static void yWriteType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Type.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Type.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Type.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Type.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Type.PUOut) yyWriteNl ();
}

static void yWriteArray
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kArray], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Array.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Array.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Array.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Array.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Array.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->Array.Expr);
 yyIndentSelector ("SE"); writebool (yyt->Array.SE) yyWriteNl ();
 yyIndentSelector ("LE"); writepLinExpr (yyt->Array.LE) yyWriteNl ();
}

static void yWriteChan
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kChan], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Chan.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Chan.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Chan.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Chan.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Chan.PUOut) yyWriteNl ();
}

static void yWriteTimer
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTimer], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Timer.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Timer.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Timer.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Timer.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Timer.PUOut) yyWriteNl ();
}

static void yWriteUntyped
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kUntyped], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Untyped.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Untyped.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Untyped.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Untyped.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Untyped.PUOut) yyWriteNl ();
}

static void yWritePrimitive
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kPrimitive], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Primitive.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Primitive.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Primitive.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Primitive.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Primitive.PUOut) yyWriteNl ();
}

static void yWriteNumeric
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNumeric], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Numeric.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Numeric.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Numeric.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Numeric.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Numeric.PUOut) yyWriteNl ();
}

static void yWriteInteger
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kInteger], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Integer.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Integer.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Integer.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Integer.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Integer.PUOut) yyWriteNl ();
}

static void yWriteInt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kInt], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Int.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Int.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Int.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Int.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Int.PUOut) yyWriteNl ();
}

static void yWriteInt16
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kInt16], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Int16.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Int16.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Int16.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Int16.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Int16.PUOut) yyWriteNl ();
}

static void yWriteInt32
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kInt32], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Int32.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Int32.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Int32.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Int32.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Int32.PUOut) yyWriteNl ();
}

static void yWriteInt64
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kInt64], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Int64.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Int64.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Int64.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Int64.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Int64.PUOut) yyWriteNl ();
}

static void yWriteReal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kReal], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Real.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Real.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Real.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Real.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Real.PUOut) yyWriteNl ();
}

static void yWriteReal32
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kReal32], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Real32.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Real32.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Real32.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Real32.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Real32.PUOut) yyWriteNl ();
}

static void yWriteReal64
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kReal64], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Real64.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Real64.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Real64.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Real64.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Real64.PUOut) yyWriteNl ();
}

static void yWriteByte
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kByte], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Byte.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Byte.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Byte.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Byte.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Byte.PUOut) yyWriteNl ();
}

static void yWriteBool
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kBool], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->Bool.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Bool.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->Bool.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Bool.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Bool.PUOut) yyWriteNl ();
}

static void yWriteTypeList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTypeList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->TypeList.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->TypeList.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->TypeList.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->TypeList.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->TypeList.PUOut) yyWriteNl ();
}

static void yWriteNoType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->NoType.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NoType.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->NoType.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoType.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoType.PUOut) yyWriteNl ();
}

static void yWriteAType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VIn"); writeint (yyt->AType.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AType.VOut) yyWriteNl ();
 yyIndentSelector ("D"); writeint (yyt->AType.D) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AType.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AType.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->AType.Type);
}

static void yWriteProtocol
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kProtocol], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Protocol.Pos) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Protocol.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Protocol.PUOut) yyWriteNl ();
}

static void yWriteAny
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAny], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Any.Pos) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Any.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Any.PUOut) yyWriteNl ();
}

static void yWriteNamed
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNamed], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Named.Pos) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Named.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Named.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->Named.Sym) yyWriteNl ();
}

static void yWriteSimple
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSimple], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Simple.Pos) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Simple.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Simple.PUOut) yyWriteNl ();
}

static void yWriteCounted
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCounted], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Counted.Pos) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Counted.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Counted.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Length", yyt->Counted.Length);
}

static void yWriteSeqProList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSeqProList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("PUIn"); writetParUsage (yyt->SeqProList.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->SeqProList.PUOut) yyWriteNl ();
}

static void yWriteNoSeqPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoSeqPro], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoSeqPro.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoSeqPro.PUOut) yyWriteNl ();
}

static void yWriteASeqPro
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kASeqPro], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ASeqPro.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ASeqPro.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Protocol", yyt->ASeqPro.Protocol);
}

static void yWriteExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Expr.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Expr.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Expr.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Expr.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Expr.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Expr.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Expr.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Expr.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Expr.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Expr.LV) yyWriteNl ();
}

static void yWriteBinary
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kBinary], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Binary.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Binary.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Binary.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Binary.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Binary.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Binary.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Binary.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Binary.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Binary.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Binary.LV) yyWriteNl ();
 yyIndentSelectorTree ("Lop", yyt->Binary.Lop);
 yyIndentSelectorTree ("Rop", yyt->Binary.Rop);
}

static void yWriteUnary
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kUnary], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Unary.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Unary.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Unary.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Unary.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Unary.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Unary.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Unary.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Unary.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Unary.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Unary.LV) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->Unary.Expr);
}

static void yWriteConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConst], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Const.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Const.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Const.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Const.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Const.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Const.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Const.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Const.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Const.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Const.LV) yyWriteNl ();
 yyIndentSelector ("Value"); writetValue (yyt->Const.Value) yyWriteNl ();
}

static void yWriteValof
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kValof], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Valof.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Valof.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Valof.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Valof.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Valof.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Valof.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Valof.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Valof.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Valof.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Valof.LV) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Valof.SpecList);
 yyIndentSelectorTree ("Process", yyt->Valof.Process);
 yyIndentSelector ("Sym"); writetSymbol (yyt->Valof.Sym) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Valof.VS) yyWriteNl ();
}

static void yWriteFuncCall
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFuncCall], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->FuncCall.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->FuncCall.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->FuncCall.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->FuncCall.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->FuncCall.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->FuncCall.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->FuncCall.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->FuncCall.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->FuncCall.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->FuncCall.LV) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->FuncCall.Sym) yyWriteNl ();
 yyIndentSelector ("Depth"); writeint (yyt->FuncCall.Depth) yyWriteNl ();
 yyIndentSelector ("Frame"); writetFrame (yyt->FuncCall.Frame) yyWriteNl ();
}

static void yWriteElementalExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElementalExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->ElementalExpr.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->ElementalExpr.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ElementalExpr.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ElementalExpr.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->ElementalExpr.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->ElementalExpr.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ElementalExpr.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ElementalExpr.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ElementalExpr.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->ElementalExpr.LV) yyWriteNl ();
 yyIndentSelector ("PAR"); writebool (yyt->ElementalExpr.PAR) yyWriteNl ();
}

static void yWriteDefault
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefault], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Default.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Default.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Default.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Default.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Default.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Default.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Default.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Default.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Default.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Default.LV) yyWriteNl ();
}

static void yWriteConvert
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConvert], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Convert.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Convert.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Convert.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Convert.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Convert.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Convert.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Convert.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Convert.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Convert.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Convert.LV) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->Convert.Type);
}

static void yWriteRound
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kRound], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Round.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Round.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Round.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Round.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Round.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Round.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Round.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Round.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Round.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Round.LV) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->Round.Type);
}

static void yWriteTrunc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTrunc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Trunc.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Trunc.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Trunc.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Trunc.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Trunc.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Trunc.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Trunc.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Trunc.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Trunc.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Trunc.LV) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->Trunc.Type);
}

static void yWriteMostPos
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kMostPos], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->MostPos.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->MostPos.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->MostPos.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->MostPos.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->MostPos.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->MostPos.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->MostPos.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->MostPos.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->MostPos.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->MostPos.LV) yyWriteNl ();
}

static void yWriteMostNeg
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kMostNeg], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->MostNeg.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->MostNeg.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->MostNeg.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->MostNeg.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->MostNeg.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->MostNeg.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->MostNeg.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->MostNeg.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->MostNeg.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->MostNeg.LV) yyWriteNl ();
}

static void yWriteCountArray
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCountArray], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->CountArray.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->CountArray.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->CountArray.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->CountArray.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->CountArray.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->CountArray.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->CountArray.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->CountArray.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->CountArray.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->CountArray.LV) yyWriteNl ();
 yyIndentSelectorTree ("Length", yyt->CountArray.Length);
}

static void yWriteUnBound
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kUnBound], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->UnBound.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->UnBound.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->UnBound.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->UnBound.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->UnBound.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->UnBound.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->UnBound.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->UnBound.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->UnBound.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->UnBound.LV) yyWriteNl ();
}

static void yWriteStringElement
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kStringElement], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->StringElement.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->StringElement.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->StringElement.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->StringElement.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->StringElement.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->StringElement.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->StringElement.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->StringElement.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->StringElement.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->StringElement.LV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->StringElement.CA) yyWriteNl ();
}

static void yWriteString
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kString], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->String.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->String.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->String.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->String.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->String.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->String.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->String.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->String.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->String.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->String.LV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->String.CA) yyWriteNl ();
 yyIndentSelector ("Value"); writetStringRef (yyt->String.Value) yyWriteNl ();
 yyIndentSelector ("Depth"); writeint (yyt->String.Depth) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->String.Sym) yyWriteNl ();
}

static void yWriteStringSubscript
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kStringSubscript], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->StringSubscript.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->StringSubscript.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->StringSubscript.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->StringSubscript.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->StringSubscript.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->StringSubscript.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->StringSubscript.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->StringSubscript.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->StringSubscript.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->StringSubscript.LV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->StringSubscript.CA) yyWriteNl ();
 yyIndentSelectorTree ("Next", yyt->StringSubscript.Next);
}

static void yWriteStringRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kStringRange], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->StringRange.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->StringRange.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->StringRange.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->StringRange.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->StringRange.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->StringRange.CV) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->StringRange.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->StringRange.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->StringRange.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->StringRange.LV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->StringRange.CA) yyWriteNl ();
 yyIndentSelectorTree ("Next", yyt->StringRange.Next);
 yyIndentSelectorTree ("From", yyt->StringRange.From);
}

static void yWriteElemental
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElemental], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Elemental.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Elemental.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->Elemental.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Elemental.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Elemental.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Elemental.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Elemental.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->Elemental.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->Elemental.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Elemental.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Elemental.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Elemental.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Elemental.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->Elemental.SE) yyWriteNl ();
}

static void yWriteTableElement
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTableElement], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->TableElement.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->TableElement.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->TableElement.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->TableElement.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->TableElement.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->TableElement.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->TableElement.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->TableElement.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->TableElement.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->TableElement.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->TableElement.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->TableElement.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->TableElement.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->TableElement.SE) yyWriteNl ();
}

static void yWriteTable
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTable], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Table.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Table.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->Table.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Table.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Table.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Table.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Table.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->Table.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->Table.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Table.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Table.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Table.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Table.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->Table.SE) yyWriteNl ();
 yyIndentSelector ("Depth"); writeint (yyt->Table.Depth) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->Table.Sym) yyWriteNl ();
 yyIndentSelector ("LE"); writepLinExpr (yyt->Table.LE) yyWriteNl ();
}

static void yWriteTableSubscript
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTableSubscript], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->TableSubscript.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->TableSubscript.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->TableSubscript.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->TableSubscript.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->TableSubscript.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->TableSubscript.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->TableSubscript.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->TableSubscript.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->TableSubscript.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->TableSubscript.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->TableSubscript.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->TableSubscript.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->TableSubscript.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->TableSubscript.SE) yyWriteNl ();
 yyIndentSelectorTree ("Next", yyt->TableSubscript.Next);
 yyIndentSelector ("LE"); writepLinExpr (yyt->TableSubscript.LE) yyWriteNl ();
}

static void yWriteTableRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTableRange], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->TableRange.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->TableRange.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->TableRange.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->TableRange.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->TableRange.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->TableRange.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->TableRange.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->TableRange.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->TableRange.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->TableRange.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->TableRange.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->TableRange.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->TableRange.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->TableRange.SE) yyWriteNl ();
 yyIndentSelectorTree ("Next", yyt->TableRange.Next);
 yyIndentSelectorTree ("From", yyt->TableRange.From);
 yyIndentSelector ("FromLE"); writepLinExpr (yyt->TableRange.FromLE) yyWriteNl ();
 yyIndentSelector ("ForLE"); writepLinExpr (yyt->TableRange.ForLE) yyWriteNl ();
}

static void yWriteElement
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElement], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Element.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Element.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->Element.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Element.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Element.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Element.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Element.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->Element.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->Element.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Element.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Element.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Element.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Element.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->Element.SE) yyWriteNl ();
}

static void yWriteIdentifier
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kIdentifier], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Identifier.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Identifier.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->Identifier.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Identifier.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Identifier.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Identifier.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Identifier.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->Identifier.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->Identifier.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Identifier.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Identifier.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Identifier.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Identifier.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->Identifier.SE) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->Identifier.Sym) yyWriteNl ();
 yyIndentSelector ("Scope"); writetSymbol (yyt->Identifier.Scope) yyWriteNl ();
}

static void yWriteElementAccess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElementAccess], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->ElementAccess.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->ElementAccess.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->ElementAccess.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ElementAccess.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ElementAccess.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->ElementAccess.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->ElementAccess.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->ElementAccess.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->ElementAccess.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ElementAccess.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ElementAccess.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ElementAccess.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->ElementAccess.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->ElementAccess.SE) yyWriteNl ();
}

static void yWriteSubscript
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSubscript], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Subscript.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Subscript.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->Subscript.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Subscript.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Subscript.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Subscript.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Subscript.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->Subscript.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->Subscript.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Subscript.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Subscript.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Subscript.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Subscript.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->Subscript.SE) yyWriteNl ();
 yyIndentSelectorTree ("Next", yyt->Subscript.Next);
 yyIndentSelector ("CB"); writebool (yyt->Subscript.CB) yyWriteNl ();
 yyIndentSelector ("LE"); writepLinExpr (yyt->Subscript.LE) yyWriteNl ();
}

static void yWriteRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kRange], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Range.Pos) yyWriteNl ();
 yyIndentSelector ("SynType"); writetType (yyt->Range.SynType) yyWriteNl ();
 yyIndentSelector ("W"); writeint (yyt->Range.W) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Range.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Range.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->Range.C) yyWriteNl ();
 yyIndentSelector ("CV"); writetValue (yyt->Range.CV) yyWriteNl ();
 yyIndentSelector ("CA"); writetConstArray (yyt->Range.CA) yyWriteNl ();
 yyIndentSelector ("U"); writetUsage (yyt->Range.U) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Range.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Range.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Range.PUOut) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->Range.LV) yyWriteNl ();
 yyIndentSelector ("SE"); writebool (yyt->Range.SE) yyWriteNl ();
 yyIndentSelectorTree ("Next", yyt->Range.Next);
 yyIndentSelectorTree ("From", yyt->Range.From);
 yyIndentSelector ("CLB"); writebool (yyt->Range.CLB) yyWriteNl ();
 yyIndentSelector ("CUB"); writebool (yyt->Range.CUB) yyWriteNl ();
 yyIndentSelector ("FromLE"); writepLinExpr (yyt->Range.FromLE) yyWriteNl ();
 yyIndentSelector ("ForLE"); writepLinExpr (yyt->Range.ForLE) yyWriteNl ();
}

static void yWriteExprList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kExprList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("SynType"); writetType (yyt->ExprList.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ExprList.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ExprList.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->ExprList.C) yyWriteNl ();
 yyIndentSelector ("TR"); writebool (yyt->ExprList.TR) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ExprList.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ExprList.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ExprList.PUOut) yyWriteNl ();
 yyIndentSelector ("PAR"); writebool (yyt->ExprList.PAR) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->ExprList.LV) yyWriteNl ();
}

static void yWriteNoExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("SynType"); writetType (yyt->NoExpr.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->NoExpr.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NoExpr.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->NoExpr.C) yyWriteNl ();
 yyIndentSelector ("TR"); writebool (yyt->NoExpr.TR) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NoExpr.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoExpr.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoExpr.PUOut) yyWriteNl ();
 yyIndentSelector ("PAR"); writebool (yyt->NoExpr.PAR) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->NoExpr.LV) yyWriteNl ();
}

static void yWriteAnExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAnExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("SynType"); writetType (yyt->AnExpr.SynType) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AnExpr.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AnExpr.VOut) yyWriteNl ();
 yyIndentSelector ("C"); writebool (yyt->AnExpr.C) yyWriteNl ();
 yyIndentSelector ("TR"); writebool (yyt->AnExpr.TR) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AnExpr.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AnExpr.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AnExpr.PUOut) yyWriteNl ();
 yyIndentSelector ("PAR"); writebool (yyt->AnExpr.PAR) yyWriteNl ();
 yyIndentSelector ("LV"); writebool (yyt->AnExpr.LV) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->AnExpr.Expr);
}

static void yWriteProcess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kProcess], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Process.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Process.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Process.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Process.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Process.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Process.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Process.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Process.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Process.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Process.PUOut) yyWriteNl ();
}

static void yWriteAssign
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAssign], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Assign.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Assign.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->Assign.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Assign.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Assign.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Assign.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Assign.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Assign.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Assign.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Assign.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Assign.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Lval", yyt->Assign.Lval);
}

static void yWriteAltType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAltType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->AltType.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->AltType.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AltType.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AltType.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->AltType.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AltType.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->AltType.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AltType.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AltType.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AltType.PUOut) yyWriteNl ();
 yyIndentSelector ("Pri"); writebool (yyt->AltType.Pri) yyWriteNl ();
 yyIndentSelector ("ARC"); writeint (yyt->AltType.ARC) yyWriteNl ();
}

static void yWriteAlt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAlt], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Alt.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Alt.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->Alt.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Alt.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Alt.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Alt.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Alt.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Alt.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Alt.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Alt.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Alt.PUOut) yyWriteNl ();
 yyIndentSelector ("Pri"); writebool (yyt->Alt.Pri) yyWriteNl ();
 yyIndentSelector ("ARC"); writeint (yyt->Alt.ARC) yyWriteNl ();
}

static void yWriteAltRep
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAltRep], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->AltRep.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->AltRep.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->AltRep.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AltRep.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AltRep.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->AltRep.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AltRep.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->AltRep.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AltRep.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AltRep.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AltRep.PUOut) yyWriteNl ();
 yyIndentSelector ("Pri"); writebool (yyt->AltRep.Pri) yyWriteNl ();
 yyIndentSelector ("ARC"); writeint (yyt->AltRep.ARC) yyWriteNl ();
 yyIndentSelectorTree ("Replicator", yyt->AltRep.Replicator);
}

static void yWriteParType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kParType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->ParType.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->ParType.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ParType.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ParType.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->ParType.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->ParType.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->ParType.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ParType.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ParType.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ParType.PUOut) yyWriteNl ();
 yyIndentSelector ("PType"); writetParType (yyt->ParType.PType) yyWriteNl ();
}

static void yWritePar
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kPar], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Par.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Par.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->Par.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Par.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Par.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Par.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Par.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Par.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Par.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Par.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Par.PUOut) yyWriteNl ();
 yyIndentSelector ("PType"); writetParType (yyt->Par.PType) yyWriteNl ();
}

static void yWriteParRep
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kParRep], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->ParRep.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->ParRep.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->ParRep.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ParRep.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ParRep.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->ParRep.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->ParRep.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->ParRep.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ParRep.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ParRep.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ParRep.PUOut) yyWriteNl ();
 yyIndentSelector ("PType"); writetParType (yyt->ParRep.PType) yyWriteNl ();
 yyIndentSelectorTree ("Replicator", yyt->ParRep.Replicator);
 yyIndentSelector ("Sym"); writetSymbol (yyt->ParRep.Sym) yyWriteNl ();
}

static void yWriteProcessor
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kProcessor], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Processor.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Processor.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->Processor.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Processor.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Processor.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Processor.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Processor.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Processor.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Processor.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Processor.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Processor.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->Processor.Expr);
 yyIndentSelector ("Name"); writetIdent (yyt->Processor.Name) yyWriteNl ();
}

static void yWriteIfType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kIfType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->IfType.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->IfType.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->IfType.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->IfType.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->IfType.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->IfType.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->IfType.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->IfType.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->IfType.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->IfType.PUOut) yyWriteNl ();
 yyIndentSelector ("BackChoiceList"); writetChoiceList (yyt->IfType.BackChoiceList) yyWriteNl ();
 yyIndentSelector ("BackIfType"); writetIfType (yyt->IfType.BackIfType) yyWriteNl ();
}

static void yWriteIf
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kIf], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->If.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->If.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->If.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->If.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->If.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->If.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->If.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->If.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->If.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->If.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->If.PUOut) yyWriteNl ();
 yyIndentSelector ("BackChoiceList"); writetChoiceList (yyt->If.BackChoiceList) yyWriteNl ();
 yyIndentSelector ("BackIfType"); writetIfType (yyt->If.BackIfType) yyWriteNl ();
}

static void yWriteIfRep
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kIfRep], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->IfRep.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->IfRep.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->IfRep.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->IfRep.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->IfRep.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->IfRep.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->IfRep.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->IfRep.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->IfRep.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->IfRep.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->IfRep.PUOut) yyWriteNl ();
 yyIndentSelector ("BackChoiceList"); writetChoiceList (yyt->IfRep.BackChoiceList) yyWriteNl ();
 yyIndentSelector ("BackIfType"); writetIfType (yyt->IfRep.BackIfType) yyWriteNl ();
 yyIndentSelectorTree ("Replicator", yyt->IfRep.Replicator);
}

static void yWriteInput
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kInput], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Input.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Input.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->Input.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Input.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Input.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Input.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Input.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Input.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Input.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Input.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Input.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Element", yyt->Input.Element);
}

static void yWriteOutput
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kOutput], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Output.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Output.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->Output.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Output.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Output.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Output.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Output.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Output.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Output.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Output.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Output.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Element", yyt->Output.Element);
}

static void yWriteCaseIn
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCaseIn], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->CaseIn.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->CaseIn.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->CaseIn.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->CaseIn.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->CaseIn.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->CaseIn.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->CaseIn.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->CaseIn.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->CaseIn.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->CaseIn.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->CaseIn.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Element", yyt->CaseIn.Element);
}

static void yWriteAfter
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAfter], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->After.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->After.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->After.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->After.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->After.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->After.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->After.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->After.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->After.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->After.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->After.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Element", yyt->After.Element);
}

static void yWriteSeqRep
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSeqRep], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->SeqRep.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->SeqRep.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->SeqRep.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->SeqRep.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->SeqRep.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->SeqRep.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->SeqRep.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->SeqRep.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->SeqRep.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->SeqRep.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->SeqRep.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Replicator", yyt->SeqRep.Replicator);
}

static void yWriteSeq
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSeq], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Seq.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Seq.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->Seq.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Seq.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Seq.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Seq.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Seq.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Seq.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Seq.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Seq.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Seq.PUOut) yyWriteNl ();
}

static void yWriteCase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCase], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Case.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Case.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->Case.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Case.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Case.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Case.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Case.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Case.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Case.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Case.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Case.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Selector", yyt->Case.Selector);
}

static void yWriteWhile
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kWhile], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->While.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->While.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->While.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->While.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->While.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->While.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->While.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->While.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->While.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->While.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->While.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->While.Expr);
}

static void yWriteSkip
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSkip], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Skip.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Skip.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Skip.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Skip.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Skip.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Skip.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Skip.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Skip.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Skip.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Skip.PUOut) yyWriteNl ();
}

static void yWriteStop
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kStop], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Stop.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Stop.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Stop.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Stop.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Stop.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Stop.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Stop.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Stop.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Stop.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Stop.PUOut) yyWriteNl ();
}

static void yWriteInstance
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kInstance], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Instance.Pos) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->Instance.SpecList);
 yyIndentSelector ("VS"); writeint (yyt->Instance.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Instance.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Instance.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->Instance.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Instance.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->Instance.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Instance.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Instance.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Instance.PUOut) yyWriteNl ();
 yyIndentSelector ("Sym"); writetSymbol (yyt->Instance.Sym) yyWriteNl ();
 yyIndentSelector ("Scope"); writetSymbol (yyt->Instance.Scope) yyWriteNl ();
 yyIndentSelector ("Frame"); writetFrame (yyt->Instance.Frame) yyWriteNl ();
}

static void yWriteCCode
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCCode], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->CCode.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->CCode.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->CCode.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->CCode.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->CCode.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->CCode.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->CCode.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->CCode.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->CCode.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->CCode.PUOut) yyWriteNl ();
 yyIndentSelector ("Code"); writetStringRef (yyt->CCode.Code) yyWriteNl ();
 yyIndentSelector ("Scope"); writetSymbol (yyt->CCode.Scope) yyWriteNl ();
}

static void yWriteNullProcess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNullProcess], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->NullProcess.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->NullProcess.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->NullProcess.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NullProcess.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->NullProcess.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->NullProcess.SLC) yyWriteNl ();
 yyIndentSelector ("TLA"); writebool (yyt->NullProcess.TLA) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NullProcess.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NullProcess.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NullProcess.PUOut) yyWriteNl ();
}

static void yWriteAltList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAltList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->AltList.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AltList.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AltList.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AltList.SLC) yyWriteNl ();
 yyIndentSelector ("ARC"); writeint (yyt->AltList.ARC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AltList.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AltList.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AltList.PUOut) yyWriteNl ();
}

static void yWriteNoAlt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoAlt], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->NoAlt.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->NoAlt.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NoAlt.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->NoAlt.SLC) yyWriteNl ();
 yyIndentSelector ("ARC"); writeint (yyt->NoAlt.ARC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NoAlt.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoAlt.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoAlt.PUOut) yyWriteNl ();
}

static void yWriteAnAlts
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAnAlts], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->AnAlts.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AnAlts.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AnAlts.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AnAlts.SLC) yyWriteNl ();
 yyIndentSelector ("ARC"); writeint (yyt->AnAlts.ARC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AnAlts.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AnAlts.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AnAlts.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->AnAlts.SpecList);
}

static void yWriteAnAlt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAnAlt], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->AnAlt.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AnAlt.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AnAlt.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AnAlt.SLC) yyWriteNl ();
 yyIndentSelector ("ARC"); writeint (yyt->AnAlt.ARC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AnAlt.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AnAlt.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AnAlt.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->AnAlt.SpecList);
 yyIndentSelectorTree ("Guard", yyt->AnAlt.Guard);
 yyIndentSelector ("Label"); writeint (yyt->AnAlt.Label) yyWriteNl ();
}

static void yWriteANewAlt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kANewAlt], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->ANewAlt.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ANewAlt.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ANewAlt.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->ANewAlt.SLC) yyWriteNl ();
 yyIndentSelector ("ARC"); writeint (yyt->ANewAlt.ARC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ANewAlt.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ANewAlt.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ANewAlt.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->ANewAlt.SpecList);
 yyIndentSelectorTree ("AltType", yyt->ANewAlt.AltType);
}

static void yWriteGuard
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kGuard], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->Guard.Pos) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->Guard.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->Guard.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->Guard.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->Guard.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->Guard.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->Guard.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->Guard.PUOut) yyWriteNl ();
}

static void yWriteAltInput
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAltInput], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->AltInput.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->AltInput.Expr);
 yyIndentSelector ("VS"); writeint (yyt->AltInput.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AltInput.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AltInput.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AltInput.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AltInput.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AltInput.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AltInput.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("Input", yyt->AltInput.Input);
}

static void yWriteAltTimer
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAltTimer], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->AltTimer.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->AltTimer.Expr);
 yyIndentSelector ("VS"); writeint (yyt->AltTimer.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AltTimer.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AltTimer.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AltTimer.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AltTimer.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AltTimer.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AltTimer.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("After", yyt->AltTimer.After);
}

static void yWriteAltCaseIn
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAltCaseIn], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->AltCaseIn.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->AltCaseIn.Expr);
 yyIndentSelector ("VS"); writeint (yyt->AltCaseIn.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AltCaseIn.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AltCaseIn.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AltCaseIn.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AltCaseIn.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AltCaseIn.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AltCaseIn.PUOut) yyWriteNl ();
}

static void yWriteNoInput
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoInput], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Pos"); writetPosition (yyt->NoInput.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->NoInput.Expr);
 yyIndentSelector ("VS"); writeint (yyt->NoInput.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->NoInput.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NoInput.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->NoInput.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NoInput.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoInput.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoInput.PUOut) yyWriteNl ();
}

static void yWriteChoiceList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kChoiceList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("SynType"); writetType (yyt->ChoiceList.SynType) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->ChoiceList.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ChoiceList.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ChoiceList.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->ChoiceList.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->ChoiceList.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ChoiceList.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ChoiceList.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ChoiceList.PUOut) yyWriteNl ();
}

static void yWriteNoChoice
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoChoice], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("SynType"); writetType (yyt->NoChoice.SynType) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->NoChoice.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->NoChoice.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NoChoice.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->NoChoice.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->NoChoice.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NoChoice.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoChoice.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoChoice.PUOut) yyWriteNl ();
}

static void yWriteAChoices
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAChoices], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("SynType"); writetType (yyt->AChoices.SynType) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->AChoices.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AChoices.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AChoices.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->AChoices.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AChoices.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AChoices.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AChoices.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AChoices.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->AChoices.SpecList);
}

static void yWriteAChoice
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAChoice], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("SynType"); writetType (yyt->AChoice.SynType) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->AChoice.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AChoice.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AChoice.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->AChoice.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AChoice.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AChoice.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AChoice.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AChoice.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->AChoice.SpecList);
 yyIndentSelectorTree ("ExprList", yyt->AChoice.ExprList);
 yyIndentSelectorTree ("Process", yyt->AChoice.Process);
 yyIndentSelector ("Label"); writeint (yyt->AChoice.Label) yyWriteNl ();
}

static void yWriteANewIf
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kANewIf], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("SynType"); writetType (yyt->ANewIf.SynType) yyWriteNl ();
 yyIndentSelector ("VS"); writeint (yyt->ANewIf.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ANewIf.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ANewIf.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->ANewIf.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->ANewIf.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ANewIf.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ANewIf.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ANewIf.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->ANewIf.SpecList);
 yyIndentSelectorTree ("IfType", yyt->ANewIf.IfType);
}

static void yWriteProcList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kProcList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->ProcList.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ProcList.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ProcList.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->ProcList.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->ProcList.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ProcList.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ProcList.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ProcList.PUOut) yyWriteNl ();
 yyIndentSelector ("PAR"); writebool (yyt->ProcList.PAR) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->ProcList.Pos) yyWriteNl ();
}

static void yWriteNoProcess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoProcess], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->NoProcess.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->NoProcess.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NoProcess.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->NoProcess.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->NoProcess.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NoProcess.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoProcess.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoProcess.PUOut) yyWriteNl ();
 yyIndentSelector ("PAR"); writebool (yyt->NoProcess.PAR) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->NoProcess.Pos) yyWriteNl ();
}

static void yWriteAProcess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAProcess], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->AProcess.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->AProcess.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->AProcess.VOut) yyWriteNl ();
 yyIndentSelector ("ATOMIC"); writebool (yyt->AProcess.ATOMIC) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->AProcess.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->AProcess.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->AProcess.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->AProcess.PUOut) yyWriteNl ();
 yyIndentSelector ("PAR"); writebool (yyt->AProcess.PAR) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->AProcess.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Process", yyt->AProcess.Process);
 yyIndentSelector ("Sym"); writetSymbol (yyt->AProcess.Sym) yyWriteNl ();
}

static void yWriteCaseList
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCaseList], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->CaseList.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->CaseList.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->CaseList.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->CaseList.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->CaseList.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->CaseList.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->CaseList.PUOut) yyWriteNl ();
}

static void yWriteNoCase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoCase], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->NoCase.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->NoCase.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->NoCase.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->NoCase.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->NoCase.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->NoCase.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->NoCase.PUOut) yyWriteNl ();
}

static void yWriteACase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kACase], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("VS"); writeint (yyt->ACase.VS) yyWriteNl ();
 yyIndentSelector ("VIn"); writeint (yyt->ACase.VIn) yyWriteNl ();
 yyIndentSelector ("VOut"); writeint (yyt->ACase.VOut) yyWriteNl ();
 yyIndentSelector ("SLC"); writeint (yyt->ACase.SLC) yyWriteNl ();
 yyIndentSelector ("Parent"); writetSymbol (yyt->ACase.Parent) yyWriteNl ();
 yyIndentSelector ("PUIn"); writetParUsage (yyt->ACase.PUIn) yyWriteNl ();
 yyIndentSelector ("PUOut"); writetParUsage (yyt->ACase.PUOut) yyWriteNl ();
 yyIndentSelectorTree ("SpecList", yyt->ACase.SpecList);
 yyIndentSelectorTree ("ExprList", yyt->ACase.ExprList);
 yyIndentSelectorTree ("Process", yyt->ACase.Process);
 yyIndentSelector ("Label"); writeint (yyt->ACase.Label) yyWriteNl ();
}

static void yWriteAnAccess
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAnAccess], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("Next", yyt->AnAccess.Next);
 yyIndentSelector ("Sym"); writetSymbol (yyt->AnAccess.Sym) yyWriteNl ();
}

static void yWriteAnElement
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAnElement], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("Next", yyt->AnElement.Next);
}

static void yyWriteTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{ unsigned short yyLevel = yyIndentLevel;
 for (;;) {
  if (yyt == NoTree) { (void) fputs (" NoTree\n", yyf); goto yyExit;
  } else if (yyt->yyHead.yyMark == 0) { (void) fprintf (yyf, "^%d\n", yyMapToLabel (yyt)); goto yyExit;
  } else if (yyt->yyHead.yyMark > 1) {
   register int yyi;
   (void) fprintf (yyf, "\n%06d:", yyMapToLabel (yyt));
   for (yyi = 8; yyi <= yyIndentLevel; yyi ++) (void) putc (' ', yyf);
  } else (void) putc (' ', yyf);
  yyt->yyHead.yyMark = 0;
  yyIndentLevel += 2;

  switch (yyt->Kind) {
case kStart: yWriteStart (yyt); yyIndentSelector ("Process"); yyt = yyt->Start.Process; break;
case kSpecList: yWriteSpecList (yyt); goto yyExit;
case kNoSpec: yWriteNoSpec (yyt); goto yyExit;
case kASpec: yWriteASpec (yyt); yyIndentSelector ("Next"); yyt = yyt->ASpec.Next; break;
case kSpec: yWriteSpec (yyt); goto yyExit;
case kDecl: yWriteDecl (yyt); yyIndentSelector ("IdList"); yyt = yyt->Decl.IdList; break;
case kIs: yWriteIs (yyt); yyIndentSelector ("Elemental"); yyt = yyt->Is.Elemental; break;
case kAVal: yWriteAVal (yyt); yyIndentSelector ("Expr"); yyt = yyt->AVal.Expr; break;
case kVal: yWriteVal (yyt); yyIndentSelector ("Expr"); yyt = yyt->Val.Expr; break;
case kValRetypes: yWriteValRetypes (yyt); yyIndentSelector ("Expr"); yyt = yyt->ValRetypes.Expr; break;
case kRetypes: yWriteRetypes (yyt); yyIndentSelector ("Elemental"); yyt = yyt->Retypes.Elemental; break;
case kDefAPro: yWriteDefAPro (yyt); goto yyExit;
case kDefSeqPro: yWriteDefSeqPro (yyt); yyIndentSelector ("SeqProList"); yyt = yyt->DefSeqPro.SeqProList; break;
case kDefTagPro: yWriteDefTagPro (yyt); yyIndentSelector ("TagProList"); yyt = yyt->DefTagPro.TagProList; break;
case kDefAProc: yWriteDefAProc (yyt); yyIndentSelector ("Formals"); yyt = yyt->DefAProc.Formals; break;
case kDefProc: yWriteDefProc (yyt); yyIndentSelector ("Process"); yyt = yyt->DefProc.Process; break;
case kPrototypeProc: yWritePrototypeProc (yyt); yyIndentSelector ("Formals"); yyt = yyt->PrototypeProc.Formals; break;
case kDefAFunc: yWriteDefAFunc (yyt); yyIndentSelector ("Formals"); yyt = yyt->DefAFunc.Formals; break;
case kDefFunc: yWriteDefFunc (yyt); yyIndentSelector ("Valof"); yyt = yyt->DefFunc.Valof; break;
case kDefIsFunc: yWriteDefIsFunc (yyt); yyIndentSelector ("ExprList"); yyt = yyt->DefIsFunc.ExprList; break;
case kPrototypeFunc: yWritePrototypeFunc (yyt); yyIndentSelector ("Formals"); yyt = yyt->PrototypeFunc.Formals; break;
case kNullSpec: yWriteNullSpec (yyt); goto yyExit;
case kHCode: yWriteHCode (yyt); goto yyExit;
case kCallFrame: yWriteCallFrame (yyt); goto yyExit;
case kParFrame: yWriteParFrame (yyt); goto yyExit;
case kFormals: yWriteFormals (yyt); goto yyExit;
case kNoFormal: yWriteNoFormal (yyt); goto yyExit;
case kAFormal: yWriteAFormal (yyt); yyIndentSelector ("Type"); yyt = yyt->AFormal.Type; break;
case kReplicator: yWriteReplicator (yyt); yyIndentSelector ("For"); yyt = yyt->Replicator.For; break;
case kTagProList: yWriteTagProList (yyt); goto yyExit;
case kNoTagPro: yWriteNoTagPro (yyt); goto yyExit;
case kATagPro: yWriteATagPro (yyt); yyIndentSelector ("Next"); yyt = yyt->ATagPro.Next; break;
case kBy: (void) fputs (Tree_NodeName [kBy], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kByVal: (void) fputs (Tree_NodeName [kByVal], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kByRef: (void) fputs (Tree_NodeName [kByRef], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kByUndef: (void) fputs (Tree_NodeName [kByUndef], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kIdList: yWriteIdList (yyt); goto yyExit;
case kNoId: yWriteNoId (yyt); goto yyExit;
case kAnId: yWriteAnId (yyt); yyIndentSelector ("Next"); yyt = yyt->AnId.Next; break;
case kType: yWriteType (yyt); goto yyExit;
case kArray: yWriteArray (yyt); yyIndentSelector ("Type"); yyt = yyt->Array.Type; break;
case kChan: yWriteChan (yyt); yyIndentSelector ("Protocol"); yyt = yyt->Chan.Protocol; break;
case kTimer: yWriteTimer (yyt); goto yyExit;
case kUntyped: yWriteUntyped (yyt); goto yyExit;
case kPrimitive: yWritePrimitive (yyt); goto yyExit;
case kNumeric: yWriteNumeric (yyt); goto yyExit;
case kInteger: yWriteInteger (yyt); goto yyExit;
case kInt: yWriteInt (yyt); goto yyExit;
case kInt16: yWriteInt16 (yyt); goto yyExit;
case kInt32: yWriteInt32 (yyt); goto yyExit;
case kInt64: yWriteInt64 (yyt); goto yyExit;
case kReal: yWriteReal (yyt); goto yyExit;
case kReal32: yWriteReal32 (yyt); goto yyExit;
case kReal64: yWriteReal64 (yyt); goto yyExit;
case kByte: yWriteByte (yyt); goto yyExit;
case kBool: yWriteBool (yyt); goto yyExit;
case kTypeList: yWriteTypeList (yyt); goto yyExit;
case kNoType: yWriteNoType (yyt); goto yyExit;
case kAType: yWriteAType (yyt); yyIndentSelector ("Next"); yyt = yyt->AType.Next; break;
case kProtocol: yWriteProtocol (yyt); goto yyExit;
case kAny: yWriteAny (yyt); goto yyExit;
case kNamed: yWriteNamed (yyt); goto yyExit;
case kSimple: yWriteSimple (yyt); yyIndentSelector ("Type"); yyt = yyt->Simple.Type; break;
case kCounted: yWriteCounted (yyt); yyIndentSelector ("Type"); yyt = yyt->Counted.Type; break;
case kSeqProList: yWriteSeqProList (yyt); goto yyExit;
case kNoSeqPro: yWriteNoSeqPro (yyt); goto yyExit;
case kASeqPro: yWriteASeqPro (yyt); yyIndentSelector ("Next"); yyt = yyt->ASeqPro.Next; break;
case kExpr: yWriteExpr (yyt); goto yyExit;
case kBinary: yWriteBinary (yyt); yyIndentSelector ("Op"); yyt = yyt->Binary.Op; break;
case kUnary: yWriteUnary (yyt); yyIndentSelector ("Op"); yyt = yyt->Unary.Op; break;
case kConst: yWriteConst (yyt); yyIndentSelector ("Type"); yyt = yyt->Const.Type; break;
case kValof: yWriteValof (yyt); yyIndentSelector ("ExprList"); yyt = yyt->Valof.ExprList; break;
case kFuncCall: yWriteFuncCall (yyt); yyIndentSelector ("ExprList"); yyt = yyt->FuncCall.ExprList; break;
case kElementalExpr: yWriteElementalExpr (yyt); yyIndentSelector ("Elemental"); yyt = yyt->ElementalExpr.Elemental; break;
case kDefault: yWriteDefault (yyt); goto yyExit;
case kConvert: yWriteConvert (yyt); yyIndentSelector ("Expr"); yyt = yyt->Convert.Expr; break;
case kRound: yWriteRound (yyt); yyIndentSelector ("Expr"); yyt = yyt->Round.Expr; break;
case kTrunc: yWriteTrunc (yyt); yyIndentSelector ("Expr"); yyt = yyt->Trunc.Expr; break;
case kMostPos: yWriteMostPos (yyt); yyIndentSelector ("Type"); yyt = yyt->MostPos.Type; break;
case kMostNeg: yWriteMostNeg (yyt); yyIndentSelector ("Type"); yyt = yyt->MostNeg.Type; break;
case kCountArray: yWriteCountArray (yyt); yyIndentSelector ("Expr"); yyt = yyt->CountArray.Expr; break;
case kUnBound: yWriteUnBound (yyt); goto yyExit;
case kStringElement: yWriteStringElement (yyt); goto yyExit;
case kString: yWriteString (yyt); goto yyExit;
case kStringSubscript: yWriteStringSubscript (yyt); yyIndentSelector ("Expr"); yyt = yyt->StringSubscript.Expr; break;
case kStringRange: yWriteStringRange (yyt); yyIndentSelector ("For"); yyt = yyt->StringRange.For; break;
case kElemental: yWriteElemental (yyt); goto yyExit;
case kTableElement: yWriteTableElement (yyt); goto yyExit;
case kTable: yWriteTable (yyt); yyIndentSelector ("ExprList"); yyt = yyt->Table.ExprList; break;
case kTableSubscript: yWriteTableSubscript (yyt); yyIndentSelector ("Expr"); yyt = yyt->TableSubscript.Expr; break;
case kTableRange: yWriteTableRange (yyt); yyIndentSelector ("For"); yyt = yyt->TableRange.For; break;
case kElement: yWriteElement (yyt); goto yyExit;
case kIdentifier: yWriteIdentifier (yyt); goto yyExit;
case kElementAccess: yWriteElementAccess (yyt); yyIndentSelector ("Next"); yyt = yyt->ElementAccess.Next; break;
case kSubscript: yWriteSubscript (yyt); yyIndentSelector ("Expr"); yyt = yyt->Subscript.Expr; break;
case kRange: yWriteRange (yyt); yyIndentSelector ("For"); yyt = yyt->Range.For; break;
case kExprList: yWriteExprList (yyt); goto yyExit;
case kNoExpr: yWriteNoExpr (yyt); goto yyExit;
case kAnExpr: yWriteAnExpr (yyt); yyIndentSelector ("Next"); yyt = yyt->AnExpr.Next; break;
case kOp: (void) fputs (Tree_NodeName [kOp], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kRelOp: (void) fputs (Tree_NodeName [kRelOp], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kLess: (void) fputs (Tree_NodeName [kLess], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kGreater: (void) fputs (Tree_NodeName [kGreater], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kLessEqual: (void) fputs (Tree_NodeName [kLessEqual], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kGreaterEqual: (void) fputs (Tree_NodeName [kGreaterEqual], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kEqual: (void) fputs (Tree_NodeName [kEqual], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kNotEqual: (void) fputs (Tree_NodeName [kNotEqual], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kMathsOp: (void) fputs (Tree_NodeName [kMathsOp], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kAdd: (void) fputs (Tree_NodeName [kAdd], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSubtract: (void) fputs (Tree_NodeName [kSubtract], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kMultiply: (void) fputs (Tree_NodeName [kMultiply], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kDivide: (void) fputs (Tree_NodeName [kDivide], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kRem: (void) fputs (Tree_NodeName [kRem], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kBitOp: (void) fputs (Tree_NodeName [kBitOp], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kBitAnd: (void) fputs (Tree_NodeName [kBitAnd], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kBitOr: (void) fputs (Tree_NodeName [kBitOr], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kBitEor: (void) fputs (Tree_NodeName [kBitEor], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kShiftOp: (void) fputs (Tree_NodeName [kShiftOp], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kLeftShift: (void) fputs (Tree_NodeName [kLeftShift], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kRightShift: (void) fputs (Tree_NodeName [kRightShift], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kUniOp: (void) fputs (Tree_NodeName [kUniOp], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSize: (void) fputs (Tree_NodeName [kSize], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kBitNot: (void) fputs (Tree_NodeName [kBitNot], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kNot: (void) fputs (Tree_NodeName [kNot], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kClockOp: (void) fputs (Tree_NodeName [kClockOp], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kPlus: (void) fputs (Tree_NodeName [kPlus], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kMinus: (void) fputs (Tree_NodeName [kMinus], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kTimes: (void) fputs (Tree_NodeName [kTimes], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kLogOp: (void) fputs (Tree_NodeName [kLogOp], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kAnd: (void) fputs (Tree_NodeName [kAnd], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kOr: (void) fputs (Tree_NodeName [kOr], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kAfterOp: (void) fputs (Tree_NodeName [kAfterOp], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kProcess: yWriteProcess (yyt); yyIndentSelector ("SpecList"); yyt = yyt->Process.SpecList; break;
case kAssign: yWriteAssign (yyt); yyIndentSelector ("Rval"); yyt = yyt->Assign.Rval; break;
case kAltType: yWriteAltType (yyt); yyIndentSelector ("SpecList"); yyt = yyt->AltType.SpecList; break;
case kAlt: yWriteAlt (yyt); yyIndentSelector ("AltList"); yyt = yyt->Alt.AltList; break;
case kAltRep: yWriteAltRep (yyt); yyIndentSelector ("AltList"); yyt = yyt->AltRep.AltList; break;
case kParType: yWriteParType (yyt); yyIndentSelector ("SpecList"); yyt = yyt->ParType.SpecList; break;
case kPar: yWritePar (yyt); yyIndentSelector ("ProcList"); yyt = yyt->Par.ProcList; break;
case kParRep: yWriteParRep (yyt); yyIndentSelector ("Process"); yyt = yyt->ParRep.Process; break;
case kProcessor: yWriteProcessor (yyt); yyIndentSelector ("Process"); yyt = yyt->Processor.Process; break;
case kIfType: yWriteIfType (yyt); yyIndentSelector ("SpecList"); yyt = yyt->IfType.SpecList; break;
case kIf: yWriteIf (yyt); yyIndentSelector ("ChoiceList"); yyt = yyt->If.ChoiceList; break;
case kIfRep: yWriteIfRep (yyt); yyIndentSelector ("ChoiceList"); yyt = yyt->IfRep.ChoiceList; break;
case kInput: yWriteInput (yyt); yyIndentSelector ("ExprList"); yyt = yyt->Input.ExprList; break;
case kOutput: yWriteOutput (yyt); yyIndentSelector ("ExprList"); yyt = yyt->Output.ExprList; break;
case kCaseIn: yWriteCaseIn (yyt); yyIndentSelector ("CaseList"); yyt = yyt->CaseIn.CaseList; break;
case kAfter: yWriteAfter (yyt); yyIndentSelector ("Expr"); yyt = yyt->After.Expr; break;
case kSeqRep: yWriteSeqRep (yyt); yyIndentSelector ("Process"); yyt = yyt->SeqRep.Process; break;
case kSeq: yWriteSeq (yyt); yyIndentSelector ("ProcList"); yyt = yyt->Seq.ProcList; break;
case kCase: yWriteCase (yyt); yyIndentSelector ("ChoiceList"); yyt = yyt->Case.ChoiceList; break;
case kWhile: yWriteWhile (yyt); yyIndentSelector ("Process"); yyt = yyt->While.Process; break;
case kSkip: yWriteSkip (yyt); yyIndentSelector ("SpecList"); yyt = yyt->Skip.SpecList; break;
case kStop: yWriteStop (yyt); yyIndentSelector ("SpecList"); yyt = yyt->Stop.SpecList; break;
case kInstance: yWriteInstance (yyt); yyIndentSelector ("ExprList"); yyt = yyt->Instance.ExprList; break;
case kCCode: yWriteCCode (yyt); yyIndentSelector ("SpecList"); yyt = yyt->CCode.SpecList; break;
case kNullProcess: yWriteNullProcess (yyt); yyIndentSelector ("SpecList"); yyt = yyt->NullProcess.SpecList; break;
case kAltList: yWriteAltList (yyt); goto yyExit;
case kNoAlt: yWriteNoAlt (yyt); goto yyExit;
case kAnAlts: yWriteAnAlts (yyt); yyIndentSelector ("Next"); yyt = yyt->AnAlts.Next; break;
case kAnAlt: yWriteAnAlt (yyt); yyIndentSelector ("Next"); yyt = yyt->AnAlt.Next; break;
case kANewAlt: yWriteANewAlt (yyt); yyIndentSelector ("Next"); yyt = yyt->ANewAlt.Next; break;
case kGuard: yWriteGuard (yyt); yyIndentSelector ("Expr"); yyt = yyt->Guard.Expr; break;
case kAltInput: yWriteAltInput (yyt); yyIndentSelector ("Process"); yyt = yyt->AltInput.Process; break;
case kAltTimer: yWriteAltTimer (yyt); yyIndentSelector ("Process"); yyt = yyt->AltTimer.Process; break;
case kAltCaseIn: yWriteAltCaseIn (yyt); yyIndentSelector ("CaseIn"); yyt = yyt->AltCaseIn.CaseIn; break;
case kNoInput: yWriteNoInput (yyt); yyIndentSelector ("Process"); yyt = yyt->NoInput.Process; break;
case kChoiceList: yWriteChoiceList (yyt); goto yyExit;
case kNoChoice: yWriteNoChoice (yyt); goto yyExit;
case kAChoices: yWriteAChoices (yyt); yyIndentSelector ("Next"); yyt = yyt->AChoices.Next; break;
case kAChoice: yWriteAChoice (yyt); yyIndentSelector ("Next"); yyt = yyt->AChoice.Next; break;
case kANewIf: yWriteANewIf (yyt); yyIndentSelector ("Next"); yyt = yyt->ANewIf.Next; break;
case kProcList: yWriteProcList (yyt); goto yyExit;
case kNoProcess: yWriteNoProcess (yyt); goto yyExit;
case kAProcess: yWriteAProcess (yyt); yyIndentSelector ("Next"); yyt = yyt->AProcess.Next; break;
case kCaseList: yWriteCaseList (yyt); goto yyExit;
case kNoCase: yWriteNoCase (yyt); goto yyExit;
case kACase: yWriteACase (yyt); yyIndentSelector ("Next"); yyt = yyt->ACase.Next; break;
case kAccessList: (void) fputs (Tree_NodeName [kAccessList], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kAnAccess: yWriteAnAccess (yyt); yyIndentSelector ("ElementList"); yyt = yyt->AnAccess.ElementList; break;
case kNoAccess: (void) fputs (Tree_NodeName [kNoAccess], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kElementList: (void) fputs (Tree_NodeName [kElementList], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kAnElement: yWriteAnElement (yyt); yyIndentSelector ("Element"); yyt = yyt->AnElement.Element; break;
case kNoElement: (void) fputs (Tree_NodeName [kNoElement], yyf); (void) fputc ('\n', yyf); goto yyExit;
  default: goto yyExit;
  }
 }
yyExit:
 yyIndentLevel = yyLevel;
}

# define yyNil	0374
# define yyNoLabel	0375
# define yyLabelDef	0376
# define yyLabelUse	0377

tTree ReverseTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyOld)
# else
 (yyOld) tTree yyOld;
# endif
{
 register tTree yyNew, yyNext, yyTail;
 yyNew = yyOld;
 yyTail = yyOld;
 for (;;) {
  switch (yyOld->Kind) {
case kASpec: yyNext = yyOld->ASpec.Next; yyOld->ASpec.Next = yyNew; break;
case kATagPro: yyNext = yyOld->ATagPro.Next; yyOld->ATagPro.Next = yyNew; break;
case kAnId: yyNext = yyOld->AnId.Next; yyOld->AnId.Next = yyNew; break;
case kAType: yyNext = yyOld->AType.Next; yyOld->AType.Next = yyNew; break;
case kASeqPro: yyNext = yyOld->ASeqPro.Next; yyOld->ASeqPro.Next = yyNew; break;
case kAnExpr: yyNext = yyOld->AnExpr.Next; yyOld->AnExpr.Next = yyNew; break;
case kAnAlts: yyNext = yyOld->AnAlts.Next; yyOld->AnAlts.Next = yyNew; break;
case kAnAlt: yyNext = yyOld->AnAlt.Next; yyOld->AnAlt.Next = yyNew; break;
case kANewAlt: yyNext = yyOld->ANewAlt.Next; yyOld->ANewAlt.Next = yyNew; break;
case kAChoices: yyNext = yyOld->AChoices.Next; yyOld->AChoices.Next = yyNew; break;
case kAChoice: yyNext = yyOld->AChoice.Next; yyOld->AChoice.Next = yyNew; break;
case kANewIf: yyNext = yyOld->ANewIf.Next; yyOld->ANewIf.Next = yyNew; break;
case kAProcess: yyNext = yyOld->AProcess.Next; yyOld->AProcess.Next = yyNew; break;
case kACase: yyNext = yyOld->ACase.Next; yyOld->ACase.Next = yyNew; break;
  default: goto yyExit;
  }
  yyNew = yyOld;
  yyOld = yyNext;
 }
yyExit:
 switch (yyTail->Kind) {
case kASpec: yyTail->ASpec.Next = yyOld; break;
case kATagPro: yyTail->ATagPro.Next = yyOld; break;
case kAnId: yyTail->AnId.Next = yyOld; break;
case kAType: yyTail->AType.Next = yyOld; break;
case kASeqPro: yyTail->ASeqPro.Next = yyOld; break;
case kAnExpr: yyTail->AnExpr.Next = yyOld; break;
case kAnAlts: yyTail->AnAlts.Next = yyOld; break;
case kAnAlt: yyTail->AnAlt.Next = yyOld; break;
case kANewAlt: yyTail->ANewAlt.Next = yyOld; break;
case kAChoices: yyTail->AChoices.Next = yyOld; break;
case kAChoice: yyTail->AChoice.Next = yyOld; break;
case kANewIf: yyTail->ANewIf.Next = yyOld; break;
case kAProcess: yyTail->AProcess.Next = yyOld; break;
case kACase: yyTail->ACase.Next = yyOld; break;
 default: ;
 }
 return yyNew;
}

static bool yyCheckTree ARGS((tTree yyt));

bool CheckTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyMark (yyt);
 return yyCheckTree (yyt);
}

static bool yyCheckChild
# if defined __STDC__ | defined __cplusplus
 (tTree yyParent, tTree yyyChild, Tree_tKind yyType, char * yySelector)
# else
 (yyParent, yyyChild, yyType, yySelector)
 tTree yyParent, yyyChild;
 Tree_tKind yyType;
 char * yySelector;
# endif
{
 bool yySuccess = Tree_IsType (yyyChild, yyType);
 if (! yySuccess) {
  (void) fputs ("CheckTree: parent = ", stderr);
  WriteTreeNode (stderr, yyParent);
  (void) fprintf (stderr, "\nselector: %s child = ", yySelector);
  WriteTreeNode (stderr, yyyChild);
  (void) fputc ('\n', stderr);
 }
 return yyCheckTree (yyyChild) && yySuccess;
}

static bool yyCheckTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 bool yyResult;
 if (yyt == NoTree) return false;
 else if (yyt->yyHead.yyMark == 0) return true;
 yyt->yyHead.yyMark = 0;

 yyResult = true;
 switch (yyt->Kind) {
case kStart:
yyResult = yyCheckChild (yyt, yyt->Start.Process, kProcess, "Process") && yyResult;
break;
case kASpec:
yyResult = yyCheckChild (yyt, yyt->ASpec.Spec, kSpec, "Spec") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ASpec.Next, kSpecList, "Next") && yyResult;
break;
case kDecl:
yyResult = yyCheckChild (yyt, yyt->Decl.Type, kType, "Type") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Decl.IdList, kIdList, "IdList") && yyResult;
break;
case kIs:
yyResult = yyCheckChild (yyt, yyt->Is.Type, kType, "Type") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Is.Elemental, kElemental, "Elemental") && yyResult;
break;
case kAVal:
yyResult = yyCheckChild (yyt, yyt->AVal.Type, kType, "Type") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AVal.Expr, kExpr, "Expr") && yyResult;
break;
case kVal:
yyResult = yyCheckChild (yyt, yyt->Val.Type, kType, "Type") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Val.Expr, kExpr, "Expr") && yyResult;
break;
case kValRetypes:
yyResult = yyCheckChild (yyt, yyt->ValRetypes.Type, kType, "Type") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ValRetypes.Expr, kExpr, "Expr") && yyResult;
break;
case kRetypes:
yyResult = yyCheckChild (yyt, yyt->Retypes.Type, kType, "Type") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Retypes.Elemental, kElemental, "Elemental") && yyResult;
break;
case kDefSeqPro:
yyResult = yyCheckChild (yyt, yyt->DefSeqPro.SeqProList, kSeqProList, "SeqProList") && yyResult;
break;
case kDefTagPro:
yyResult = yyCheckChild (yyt, yyt->DefTagPro.TagProList, kTagProList, "TagProList") && yyResult;
break;
case kDefAProc:
yyResult = yyCheckChild (yyt, yyt->DefAProc.Formals, kFormals, "Formals") && yyResult;
break;
case kDefProc:
yyResult = yyCheckChild (yyt, yyt->DefProc.Formals, kFormals, "Formals") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DefProc.Process, kProcess, "Process") && yyResult;
break;
case kPrototypeProc:
yyResult = yyCheckChild (yyt, yyt->PrototypeProc.Formals, kFormals, "Formals") && yyResult;
break;
case kDefAFunc:
yyResult = yyCheckChild (yyt, yyt->DefAFunc.TypeList, kTypeList, "TypeList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DefAFunc.Formals, kFormals, "Formals") && yyResult;
break;
case kDefFunc:
yyResult = yyCheckChild (yyt, yyt->DefFunc.TypeList, kTypeList, "TypeList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DefFunc.Formals, kFormals, "Formals") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DefFunc.Valof, kValof, "Valof") && yyResult;
break;
case kDefIsFunc:
yyResult = yyCheckChild (yyt, yyt->DefIsFunc.TypeList, kTypeList, "TypeList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DefIsFunc.Formals, kFormals, "Formals") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DefIsFunc.ExprList, kExprList, "ExprList") && yyResult;
break;
case kPrototypeFunc:
yyResult = yyCheckChild (yyt, yyt->PrototypeFunc.TypeList, kTypeList, "TypeList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->PrototypeFunc.Formals, kFormals, "Formals") && yyResult;
break;
case kAFormal:
yyResult = yyCheckChild (yyt, yyt->AFormal.Next, kFormals, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AFormal.By, kBy, "By") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AFormal.Type, kType, "Type") && yyResult;
break;
case kReplicator:
yyResult = yyCheckChild (yyt, yyt->Replicator.From, kExpr, "From") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Replicator.For, kExpr, "For") && yyResult;
break;
case kATagPro:
yyResult = yyCheckChild (yyt, yyt->ATagPro.Next, kTagProList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ATagPro.SeqProList, kSeqProList, "SeqProList") && yyResult;
break;
case kAnId:
yyResult = yyCheckChild (yyt, yyt->AnId.Next, kIdList, "Next") && yyResult;
break;
case kArray:
yyResult = yyCheckChild (yyt, yyt->Array.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Array.Type, kType, "Type") && yyResult;
break;
case kChan:
yyResult = yyCheckChild (yyt, yyt->Chan.Protocol, kProtocol, "Protocol") && yyResult;
break;
case kAType:
yyResult = yyCheckChild (yyt, yyt->AType.Next, kTypeList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AType.Type, kType, "Type") && yyResult;
break;
case kSimple:
yyResult = yyCheckChild (yyt, yyt->Simple.Type, kType, "Type") && yyResult;
break;
case kCounted:
yyResult = yyCheckChild (yyt, yyt->Counted.Length, kType, "Length") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Counted.Type, kType, "Type") && yyResult;
break;
case kASeqPro:
yyResult = yyCheckChild (yyt, yyt->ASeqPro.Next, kSeqProList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ASeqPro.Protocol, kProtocol, "Protocol") && yyResult;
break;
case kBinary:
yyResult = yyCheckChild (yyt, yyt->Binary.Lop, kExpr, "Lop") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Binary.Rop, kExpr, "Rop") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Binary.Op, kOp, "Op") && yyResult;
break;
case kUnary:
yyResult = yyCheckChild (yyt, yyt->Unary.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Unary.Op, kOp, "Op") && yyResult;
break;
case kConst:
yyResult = yyCheckChild (yyt, yyt->Const.Type, kType, "Type") && yyResult;
break;
case kValof:
yyResult = yyCheckChild (yyt, yyt->Valof.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Valof.Process, kProcess, "Process") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Valof.ExprList, kExprList, "ExprList") && yyResult;
break;
case kFuncCall:
yyResult = yyCheckChild (yyt, yyt->FuncCall.ExprList, kExprList, "ExprList") && yyResult;
break;
case kElementalExpr:
yyResult = yyCheckChild (yyt, yyt->ElementalExpr.Elemental, kElemental, "Elemental") && yyResult;
break;
case kConvert:
yyResult = yyCheckChild (yyt, yyt->Convert.Type, kType, "Type") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Convert.Expr, kExpr, "Expr") && yyResult;
break;
case kRound:
yyResult = yyCheckChild (yyt, yyt->Round.Type, kType, "Type") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Round.Expr, kExpr, "Expr") && yyResult;
break;
case kTrunc:
yyResult = yyCheckChild (yyt, yyt->Trunc.Type, kType, "Type") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Trunc.Expr, kExpr, "Expr") && yyResult;
break;
case kMostPos:
yyResult = yyCheckChild (yyt, yyt->MostPos.Type, kType, "Type") && yyResult;
break;
case kMostNeg:
yyResult = yyCheckChild (yyt, yyt->MostNeg.Type, kType, "Type") && yyResult;
break;
case kCountArray:
yyResult = yyCheckChild (yyt, yyt->CountArray.Length, kExpr, "Length") && yyResult;
yyResult = yyCheckChild (yyt, yyt->CountArray.Expr, kExpr, "Expr") && yyResult;
break;
case kStringSubscript:
yyResult = yyCheckChild (yyt, yyt->StringSubscript.Next, kStringElement, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->StringSubscript.Expr, kExpr, "Expr") && yyResult;
break;
case kStringRange:
yyResult = yyCheckChild (yyt, yyt->StringRange.Next, kStringElement, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->StringRange.From, kExpr, "From") && yyResult;
yyResult = yyCheckChild (yyt, yyt->StringRange.For, kExpr, "For") && yyResult;
break;
case kTable:
yyResult = yyCheckChild (yyt, yyt->Table.ExprList, kExprList, "ExprList") && yyResult;
break;
case kTableSubscript:
yyResult = yyCheckChild (yyt, yyt->TableSubscript.Next, kTableElement, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->TableSubscript.Expr, kExpr, "Expr") && yyResult;
break;
case kTableRange:
yyResult = yyCheckChild (yyt, yyt->TableRange.Next, kTableElement, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->TableRange.From, kExpr, "From") && yyResult;
yyResult = yyCheckChild (yyt, yyt->TableRange.For, kExpr, "For") && yyResult;
break;
case kElementAccess:
yyResult = yyCheckChild (yyt, yyt->ElementAccess.Next, kElement, "Next") && yyResult;
break;
case kSubscript:
yyResult = yyCheckChild (yyt, yyt->Subscript.Next, kElement, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Subscript.Expr, kExpr, "Expr") && yyResult;
break;
case kRange:
yyResult = yyCheckChild (yyt, yyt->Range.Next, kElement, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Range.From, kExpr, "From") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Range.For, kExpr, "For") && yyResult;
break;
case kAnExpr:
yyResult = yyCheckChild (yyt, yyt->AnExpr.Next, kExprList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AnExpr.Expr, kExpr, "Expr") && yyResult;
break;
case kProcess:
yyResult = yyCheckChild (yyt, yyt->Process.SpecList, kSpecList, "SpecList") && yyResult;
break;
case kAssign:
yyResult = yyCheckChild (yyt, yyt->Assign.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Assign.Lval, kExprList, "Lval") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Assign.Rval, kExprList, "Rval") && yyResult;
break;
case kAltType:
yyResult = yyCheckChild (yyt, yyt->AltType.SpecList, kSpecList, "SpecList") && yyResult;
break;
case kAlt:
yyResult = yyCheckChild (yyt, yyt->Alt.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Alt.AltList, kAltList, "AltList") && yyResult;
break;
case kAltRep:
yyResult = yyCheckChild (yyt, yyt->AltRep.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AltRep.Replicator, kReplicator, "Replicator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AltRep.AltList, kAltList, "AltList") && yyResult;
break;
case kParType:
yyResult = yyCheckChild (yyt, yyt->ParType.SpecList, kSpecList, "SpecList") && yyResult;
break;
case kPar:
yyResult = yyCheckChild (yyt, yyt->Par.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Par.ProcList, kProcList, "ProcList") && yyResult;
break;
case kParRep:
yyResult = yyCheckChild (yyt, yyt->ParRep.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ParRep.Replicator, kReplicator, "Replicator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ParRep.Process, kProcess, "Process") && yyResult;
break;
case kProcessor:
yyResult = yyCheckChild (yyt, yyt->Processor.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Processor.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Processor.Process, kProcess, "Process") && yyResult;
break;
case kIfType:
yyResult = yyCheckChild (yyt, yyt->IfType.SpecList, kSpecList, "SpecList") && yyResult;
break;
case kIf:
yyResult = yyCheckChild (yyt, yyt->If.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->If.ChoiceList, kChoiceList, "ChoiceList") && yyResult;
break;
case kIfRep:
yyResult = yyCheckChild (yyt, yyt->IfRep.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->IfRep.Replicator, kReplicator, "Replicator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->IfRep.ChoiceList, kChoiceList, "ChoiceList") && yyResult;
break;
case kInput:
yyResult = yyCheckChild (yyt, yyt->Input.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Input.Element, kElement, "Element") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Input.ExprList, kExprList, "ExprList") && yyResult;
break;
case kOutput:
yyResult = yyCheckChild (yyt, yyt->Output.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Output.Element, kElement, "Element") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Output.ExprList, kExprList, "ExprList") && yyResult;
break;
case kCaseIn:
yyResult = yyCheckChild (yyt, yyt->CaseIn.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->CaseIn.Element, kElement, "Element") && yyResult;
yyResult = yyCheckChild (yyt, yyt->CaseIn.CaseList, kCaseList, "CaseList") && yyResult;
break;
case kAfter:
yyResult = yyCheckChild (yyt, yyt->After.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->After.Element, kElement, "Element") && yyResult;
yyResult = yyCheckChild (yyt, yyt->After.Expr, kExpr, "Expr") && yyResult;
break;
case kSeqRep:
yyResult = yyCheckChild (yyt, yyt->SeqRep.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->SeqRep.Replicator, kReplicator, "Replicator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->SeqRep.Process, kProcess, "Process") && yyResult;
break;
case kSeq:
yyResult = yyCheckChild (yyt, yyt->Seq.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Seq.ProcList, kProcList, "ProcList") && yyResult;
break;
case kCase:
yyResult = yyCheckChild (yyt, yyt->Case.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Case.Selector, kExpr, "Selector") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Case.ChoiceList, kChoiceList, "ChoiceList") && yyResult;
break;
case kWhile:
yyResult = yyCheckChild (yyt, yyt->While.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->While.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->While.Process, kProcess, "Process") && yyResult;
break;
case kSkip:
yyResult = yyCheckChild (yyt, yyt->Skip.SpecList, kSpecList, "SpecList") && yyResult;
break;
case kStop:
yyResult = yyCheckChild (yyt, yyt->Stop.SpecList, kSpecList, "SpecList") && yyResult;
break;
case kInstance:
yyResult = yyCheckChild (yyt, yyt->Instance.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Instance.ExprList, kExprList, "ExprList") && yyResult;
break;
case kCCode:
yyResult = yyCheckChild (yyt, yyt->CCode.SpecList, kSpecList, "SpecList") && yyResult;
break;
case kNullProcess:
yyResult = yyCheckChild (yyt, yyt->NullProcess.SpecList, kSpecList, "SpecList") && yyResult;
break;
case kAnAlts:
yyResult = yyCheckChild (yyt, yyt->AnAlts.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AnAlts.Next, kAltList, "Next") && yyResult;
break;
case kAnAlt:
yyResult = yyCheckChild (yyt, yyt->AnAlt.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AnAlt.Next, kAltList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AnAlt.Guard, kGuard, "Guard") && yyResult;
break;
case kANewAlt:
yyResult = yyCheckChild (yyt, yyt->ANewAlt.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ANewAlt.Next, kAltList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ANewAlt.AltType, kAltType, "AltType") && yyResult;
break;
case kGuard:
yyResult = yyCheckChild (yyt, yyt->Guard.Expr, kExpr, "Expr") && yyResult;
break;
case kAltInput:
yyResult = yyCheckChild (yyt, yyt->AltInput.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AltInput.Input, kInput, "Input") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AltInput.Process, kProcess, "Process") && yyResult;
break;
case kAltTimer:
yyResult = yyCheckChild (yyt, yyt->AltTimer.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AltTimer.After, kAfter, "After") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AltTimer.Process, kProcess, "Process") && yyResult;
break;
case kAltCaseIn:
yyResult = yyCheckChild (yyt, yyt->AltCaseIn.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AltCaseIn.CaseIn, kCaseIn, "CaseIn") && yyResult;
break;
case kNoInput:
yyResult = yyCheckChild (yyt, yyt->NoInput.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->NoInput.Process, kProcess, "Process") && yyResult;
break;
case kAChoices:
yyResult = yyCheckChild (yyt, yyt->AChoices.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AChoices.Next, kChoiceList, "Next") && yyResult;
break;
case kAChoice:
yyResult = yyCheckChild (yyt, yyt->AChoice.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AChoice.Next, kChoiceList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AChoice.ExprList, kExprList, "ExprList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AChoice.Process, kProcess, "Process") && yyResult;
break;
case kANewIf:
yyResult = yyCheckChild (yyt, yyt->ANewIf.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ANewIf.Next, kChoiceList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ANewIf.IfType, kIfType, "IfType") && yyResult;
break;
case kAProcess:
yyResult = yyCheckChild (yyt, yyt->AProcess.Next, kProcList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AProcess.Process, kProcess, "Process") && yyResult;
break;
case kACase:
yyResult = yyCheckChild (yyt, yyt->ACase.Next, kCaseList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ACase.SpecList, kSpecList, "SpecList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ACase.ExprList, kExprList, "ExprList") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ACase.Process, kProcess, "Process") && yyResult;
break;
case kAnAccess:
yyResult = yyCheckChild (yyt, yyt->AnAccess.Next, kAccessList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AnAccess.ElementList, kElementList, "ElementList") && yyResult;
break;
case kAnElement:
yyResult = yyCheckChild (yyt, yyt->AnElement.Next, kElementList, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->AnElement.Element, kElement, "Element") && yyResult;
break;
 default: ;
 }
 return yyResult;
}

# define yyyWrite	1
# define yyyRead	2
# define yyyQuit	3

static char yyyString [32], yyCh;
static int yyLength, yyState;

static bool yyyIsEqual
# if defined __STDC__ | defined __cplusplus
 (char * yya)
# else
 (yya) char * yya;
# endif
{
 register int yyi;
 if (yyLength >= 0 && yyyString [yyLength] == ' ') {
  if (yyLength != strlen (yya)) return false;
  for (yyi = 0; yyi < yyLength; yyi ++)
   if (yyyString [yyi] != yya [yyi]) return false;
 } else {
  if (yyLength >= strlen (yya)) return false;
  for (yyi = 0; yyi <= yyLength; yyi ++)
   if (yyyString [yyi] != yya [yyi]) return false;
 }
 return true;
}

void QueryTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyState = yyyWrite;
 for (;;) {
  switch (yyState) {
  case yyyQuit : return;
  case yyyWrite: WriteTreeNode (stdout, yyt); yyState = yyyRead;
  case yyyRead : (void) printf ("? "); yyLength = -1; yyCh = getc (stdin);
   while (yyCh != '\n' && yyCh > 0)
    { yyyString [++ yyLength] = yyCh; yyCh = getc (stdin); }
   if (yyCh < 0) { (void) fputs ("QueryTree: eof reached\n", stderr);
    yyState = yyyQuit; return; }
   if      (yyyIsEqual ("parent")) { yyState = yyyWrite; return; }
   else if (yyyIsEqual ("quit"  )) { yyState = yyyQuit ; return; }
   else if (yyt != NoTree) {
    switch (yyt->Kind) {
case kStart: if (false) ;
else if (yyyIsEqual ("Process")) QueryTree (yyt->Start.Process);
break;
case kASpec: if (false) ;
else if (yyyIsEqual ("Spec")) QueryTree (yyt->ASpec.Spec);
else if (yyyIsEqual ("Next")) QueryTree (yyt->ASpec.Next);
break;
case kDecl: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->Decl.Type);
else if (yyyIsEqual ("IdList")) QueryTree (yyt->Decl.IdList);
break;
case kIs: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->Is.Type);
else if (yyyIsEqual ("Elemental")) QueryTree (yyt->Is.Elemental);
break;
case kAVal: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->AVal.Type);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->AVal.Expr);
break;
case kVal: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->Val.Type);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Val.Expr);
break;
case kValRetypes: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->ValRetypes.Type);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->ValRetypes.Expr);
break;
case kRetypes: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->Retypes.Type);
else if (yyyIsEqual ("Elemental")) QueryTree (yyt->Retypes.Elemental);
break;
case kDefSeqPro: if (false) ;
else if (yyyIsEqual ("SeqProList")) QueryTree (yyt->DefSeqPro.SeqProList);
break;
case kDefTagPro: if (false) ;
else if (yyyIsEqual ("TagProList")) QueryTree (yyt->DefTagPro.TagProList);
break;
case kDefAProc: if (false) ;
else if (yyyIsEqual ("Formals")) QueryTree (yyt->DefAProc.Formals);
break;
case kDefProc: if (false) ;
else if (yyyIsEqual ("Formals")) QueryTree (yyt->DefProc.Formals);
else if (yyyIsEqual ("Process")) QueryTree (yyt->DefProc.Process);
break;
case kPrototypeProc: if (false) ;
else if (yyyIsEqual ("Formals")) QueryTree (yyt->PrototypeProc.Formals);
break;
case kDefAFunc: if (false) ;
else if (yyyIsEqual ("TypeList")) QueryTree (yyt->DefAFunc.TypeList);
else if (yyyIsEqual ("Formals")) QueryTree (yyt->DefAFunc.Formals);
break;
case kDefFunc: if (false) ;
else if (yyyIsEqual ("TypeList")) QueryTree (yyt->DefFunc.TypeList);
else if (yyyIsEqual ("Formals")) QueryTree (yyt->DefFunc.Formals);
else if (yyyIsEqual ("Valof")) QueryTree (yyt->DefFunc.Valof);
break;
case kDefIsFunc: if (false) ;
else if (yyyIsEqual ("TypeList")) QueryTree (yyt->DefIsFunc.TypeList);
else if (yyyIsEqual ("Formals")) QueryTree (yyt->DefIsFunc.Formals);
else if (yyyIsEqual ("ExprList")) QueryTree (yyt->DefIsFunc.ExprList);
break;
case kPrototypeFunc: if (false) ;
else if (yyyIsEqual ("TypeList")) QueryTree (yyt->PrototypeFunc.TypeList);
else if (yyyIsEqual ("Formals")) QueryTree (yyt->PrototypeFunc.Formals);
break;
case kAFormal: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->AFormal.Next);
else if (yyyIsEqual ("By")) QueryTree (yyt->AFormal.By);
else if (yyyIsEqual ("Type")) QueryTree (yyt->AFormal.Type);
break;
case kReplicator: if (false) ;
else if (yyyIsEqual ("From")) QueryTree (yyt->Replicator.From);
else if (yyyIsEqual ("For")) QueryTree (yyt->Replicator.For);
break;
case kATagPro: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ATagPro.Next);
else if (yyyIsEqual ("SeqProList")) QueryTree (yyt->ATagPro.SeqProList);
break;
case kAnId: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->AnId.Next);
break;
case kArray: if (false) ;
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Array.Expr);
else if (yyyIsEqual ("Type")) QueryTree (yyt->Array.Type);
break;
case kChan: if (false) ;
else if (yyyIsEqual ("Protocol")) QueryTree (yyt->Chan.Protocol);
break;
case kAType: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->AType.Next);
else if (yyyIsEqual ("Type")) QueryTree (yyt->AType.Type);
break;
case kSimple: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->Simple.Type);
break;
case kCounted: if (false) ;
else if (yyyIsEqual ("Length")) QueryTree (yyt->Counted.Length);
else if (yyyIsEqual ("Type")) QueryTree (yyt->Counted.Type);
break;
case kASeqPro: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ASeqPro.Next);
else if (yyyIsEqual ("Protocol")) QueryTree (yyt->ASeqPro.Protocol);
break;
case kBinary: if (false) ;
else if (yyyIsEqual ("Lop")) QueryTree (yyt->Binary.Lop);
else if (yyyIsEqual ("Rop")) QueryTree (yyt->Binary.Rop);
else if (yyyIsEqual ("Op")) QueryTree (yyt->Binary.Op);
break;
case kUnary: if (false) ;
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Unary.Expr);
else if (yyyIsEqual ("Op")) QueryTree (yyt->Unary.Op);
break;
case kConst: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->Const.Type);
break;
case kValof: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Valof.SpecList);
else if (yyyIsEqual ("Process")) QueryTree (yyt->Valof.Process);
else if (yyyIsEqual ("ExprList")) QueryTree (yyt->Valof.ExprList);
break;
case kFuncCall: if (false) ;
else if (yyyIsEqual ("ExprList")) QueryTree (yyt->FuncCall.ExprList);
break;
case kElementalExpr: if (false) ;
else if (yyyIsEqual ("Elemental")) QueryTree (yyt->ElementalExpr.Elemental);
break;
case kConvert: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->Convert.Type);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Convert.Expr);
break;
case kRound: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->Round.Type);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Round.Expr);
break;
case kTrunc: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->Trunc.Type);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Trunc.Expr);
break;
case kMostPos: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->MostPos.Type);
break;
case kMostNeg: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->MostNeg.Type);
break;
case kCountArray: if (false) ;
else if (yyyIsEqual ("Length")) QueryTree (yyt->CountArray.Length);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->CountArray.Expr);
break;
case kStringSubscript: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->StringSubscript.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->StringSubscript.Expr);
break;
case kStringRange: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->StringRange.Next);
else if (yyyIsEqual ("From")) QueryTree (yyt->StringRange.From);
else if (yyyIsEqual ("For")) QueryTree (yyt->StringRange.For);
break;
case kTable: if (false) ;
else if (yyyIsEqual ("ExprList")) QueryTree (yyt->Table.ExprList);
break;
case kTableSubscript: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->TableSubscript.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->TableSubscript.Expr);
break;
case kTableRange: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->TableRange.Next);
else if (yyyIsEqual ("From")) QueryTree (yyt->TableRange.From);
else if (yyyIsEqual ("For")) QueryTree (yyt->TableRange.For);
break;
case kElementAccess: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ElementAccess.Next);
break;
case kSubscript: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Subscript.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Subscript.Expr);
break;
case kRange: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Range.Next);
else if (yyyIsEqual ("From")) QueryTree (yyt->Range.From);
else if (yyyIsEqual ("For")) QueryTree (yyt->Range.For);
break;
case kAnExpr: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->AnExpr.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->AnExpr.Expr);
break;
case kProcess: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Process.SpecList);
break;
case kAssign: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Assign.SpecList);
else if (yyyIsEqual ("Lval")) QueryTree (yyt->Assign.Lval);
else if (yyyIsEqual ("Rval")) QueryTree (yyt->Assign.Rval);
break;
case kAltType: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->AltType.SpecList);
break;
case kAlt: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Alt.SpecList);
else if (yyyIsEqual ("AltList")) QueryTree (yyt->Alt.AltList);
break;
case kAltRep: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->AltRep.SpecList);
else if (yyyIsEqual ("Replicator")) QueryTree (yyt->AltRep.Replicator);
else if (yyyIsEqual ("AltList")) QueryTree (yyt->AltRep.AltList);
break;
case kParType: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->ParType.SpecList);
break;
case kPar: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Par.SpecList);
else if (yyyIsEqual ("ProcList")) QueryTree (yyt->Par.ProcList);
break;
case kParRep: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->ParRep.SpecList);
else if (yyyIsEqual ("Replicator")) QueryTree (yyt->ParRep.Replicator);
else if (yyyIsEqual ("Process")) QueryTree (yyt->ParRep.Process);
break;
case kProcessor: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Processor.SpecList);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Processor.Expr);
else if (yyyIsEqual ("Process")) QueryTree (yyt->Processor.Process);
break;
case kIfType: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->IfType.SpecList);
break;
case kIf: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->If.SpecList);
else if (yyyIsEqual ("ChoiceList")) QueryTree (yyt->If.ChoiceList);
break;
case kIfRep: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->IfRep.SpecList);
else if (yyyIsEqual ("Replicator")) QueryTree (yyt->IfRep.Replicator);
else if (yyyIsEqual ("ChoiceList")) QueryTree (yyt->IfRep.ChoiceList);
break;
case kInput: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Input.SpecList);
else if (yyyIsEqual ("Element")) QueryTree (yyt->Input.Element);
else if (yyyIsEqual ("ExprList")) QueryTree (yyt->Input.ExprList);
break;
case kOutput: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Output.SpecList);
else if (yyyIsEqual ("Element")) QueryTree (yyt->Output.Element);
else if (yyyIsEqual ("ExprList")) QueryTree (yyt->Output.ExprList);
break;
case kCaseIn: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->CaseIn.SpecList);
else if (yyyIsEqual ("Element")) QueryTree (yyt->CaseIn.Element);
else if (yyyIsEqual ("CaseList")) QueryTree (yyt->CaseIn.CaseList);
break;
case kAfter: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->After.SpecList);
else if (yyyIsEqual ("Element")) QueryTree (yyt->After.Element);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->After.Expr);
break;
case kSeqRep: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->SeqRep.SpecList);
else if (yyyIsEqual ("Replicator")) QueryTree (yyt->SeqRep.Replicator);
else if (yyyIsEqual ("Process")) QueryTree (yyt->SeqRep.Process);
break;
case kSeq: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Seq.SpecList);
else if (yyyIsEqual ("ProcList")) QueryTree (yyt->Seq.ProcList);
break;
case kCase: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Case.SpecList);
else if (yyyIsEqual ("Selector")) QueryTree (yyt->Case.Selector);
else if (yyyIsEqual ("ChoiceList")) QueryTree (yyt->Case.ChoiceList);
break;
case kWhile: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->While.SpecList);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->While.Expr);
else if (yyyIsEqual ("Process")) QueryTree (yyt->While.Process);
break;
case kSkip: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Skip.SpecList);
break;
case kStop: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Stop.SpecList);
break;
case kInstance: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->Instance.SpecList);
else if (yyyIsEqual ("ExprList")) QueryTree (yyt->Instance.ExprList);
break;
case kCCode: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->CCode.SpecList);
break;
case kNullProcess: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->NullProcess.SpecList);
break;
case kAnAlts: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->AnAlts.SpecList);
else if (yyyIsEqual ("Next")) QueryTree (yyt->AnAlts.Next);
break;
case kAnAlt: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->AnAlt.SpecList);
else if (yyyIsEqual ("Next")) QueryTree (yyt->AnAlt.Next);
else if (yyyIsEqual ("Guard")) QueryTree (yyt->AnAlt.Guard);
break;
case kANewAlt: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->ANewAlt.SpecList);
else if (yyyIsEqual ("Next")) QueryTree (yyt->ANewAlt.Next);
else if (yyyIsEqual ("AltType")) QueryTree (yyt->ANewAlt.AltType);
break;
case kGuard: if (false) ;
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Guard.Expr);
break;
case kAltInput: if (false) ;
else if (yyyIsEqual ("Expr")) QueryTree (yyt->AltInput.Expr);
else if (yyyIsEqual ("Input")) QueryTree (yyt->AltInput.Input);
else if (yyyIsEqual ("Process")) QueryTree (yyt->AltInput.Process);
break;
case kAltTimer: if (false) ;
else if (yyyIsEqual ("Expr")) QueryTree (yyt->AltTimer.Expr);
else if (yyyIsEqual ("After")) QueryTree (yyt->AltTimer.After);
else if (yyyIsEqual ("Process")) QueryTree (yyt->AltTimer.Process);
break;
case kAltCaseIn: if (false) ;
else if (yyyIsEqual ("Expr")) QueryTree (yyt->AltCaseIn.Expr);
else if (yyyIsEqual ("CaseIn")) QueryTree (yyt->AltCaseIn.CaseIn);
break;
case kNoInput: if (false) ;
else if (yyyIsEqual ("Expr")) QueryTree (yyt->NoInput.Expr);
else if (yyyIsEqual ("Process")) QueryTree (yyt->NoInput.Process);
break;
case kAChoices: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->AChoices.SpecList);
else if (yyyIsEqual ("Next")) QueryTree (yyt->AChoices.Next);
break;
case kAChoice: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->AChoice.SpecList);
else if (yyyIsEqual ("Next")) QueryTree (yyt->AChoice.Next);
else if (yyyIsEqual ("ExprList")) QueryTree (yyt->AChoice.ExprList);
else if (yyyIsEqual ("Process")) QueryTree (yyt->AChoice.Process);
break;
case kANewIf: if (false) ;
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->ANewIf.SpecList);
else if (yyyIsEqual ("Next")) QueryTree (yyt->ANewIf.Next);
else if (yyyIsEqual ("IfType")) QueryTree (yyt->ANewIf.IfType);
break;
case kAProcess: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->AProcess.Next);
else if (yyyIsEqual ("Process")) QueryTree (yyt->AProcess.Process);
break;
case kACase: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ACase.Next);
else if (yyyIsEqual ("SpecList")) QueryTree (yyt->ACase.SpecList);
else if (yyyIsEqual ("ExprList")) QueryTree (yyt->ACase.ExprList);
else if (yyyIsEqual ("Process")) QueryTree (yyt->ACase.Process);
break;
case kAnAccess: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->AnAccess.Next);
else if (yyyIsEqual ("ElementList")) QueryTree (yyt->AnAccess.ElementList);
break;
case kAnElement: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->AnElement.Next);
else if (yyyIsEqual ("Element")) QueryTree (yyt->AnElement.Element);
break;
    default: ;
    }
   }
  }
 }
}

void BeginTree ()
{
}

void CloseTree ()
{
}
