# include "TypeChk.h"
# include "yyTypeChk.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"

# define yyInline
# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

/* line 52 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */


  #include "Positions.h"
  #include <stdlib.h>
  #include <math.h>

  #undef MAX
  #define MAX(a,b) ((a > b) ? a : b)

  /*{{{  static void RetypeConst(int ss,tConstArray src, int ds, tConstArray dest)*/
  /* Retype a ConstArray section -
  
     ConstArray values are stored in compiler-endianness, to allow direct
     casting for constant folding/output
  
     To retype, is the endianness of the compiler/target architectures differ,
     we must perform two stages.
  
     1. Copy source to temporary, performing source type endianness swap
        This leaves temporary in target machine endianness
     2. Copy temporary to destination, performing destination type endianness swap
        This converts temporary into correct types, in compiler endianness
  */
  
  void RetypeConst(int ss,tConstArray src, int ds, tConstArray dest)
  {
    int sz = (ds > ss) ? ds : ss;
    int i;
    int val = 1;
    bool Compiler_is_LittleEndian = (((char *)&val)[0]) == 1;
    unsigned char tmp[8];
  
    if ((!IS_Mode(xxLittleEndian) && Compiler_is_LittleEndian)
        ||(IS_Mode(xxLittleEndian) && !Compiler_is_LittleEndian))
    {
      switch(ss)
      {
        case 8: for(i = 0; i < sz; ++i) tmp[i] = src[i ^ 7]; break;
        case 4: for(i = 0; i < sz; ++i) tmp[i] = src[i ^ 3]; break;
        case 2: for(i = 0; i < sz; ++i) tmp[i] = src[i ^ 1]; break;
        case 1: for(i = 0; i < sz; ++i) tmp[i] = src[i    ]; break;
      }
  
      switch(ds)
      {
        case 8: for(i = 0; i < sz; ++i) dest[i] = tmp[i ^ 7]; break;
        case 4: for(i = 0; i < sz; ++i) dest[i] = tmp[i ^ 3]; break;
        case 2: for(i = 0; i < sz; ++i) dest[i] = tmp[i ^ 1]; break;
        case 1: for(i = 0; i < sz; ++i) dest[i] = tmp[i    ]; break;
      }
    }
    else
    {
      for(i = 0; i < sz; ++i) dest[i] = src[i];
    }
  }
  
  /*}}}*/


static void yyExit () { Exit (1); }

void (* TypeChk_Exit) () = yyExit;

extern FILE *yyf;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module TypeChk, routine %s failed\n", yyFunction);
 TypeChk_Exit ();
}

void TypeFormals ARGS((tTree yyP1));
void TypeDecl ARGS((tTree yyP3, tTree yyP2));
tTree TypeAbbrev ARGS((tTree yyP6, tTree yyP5, tPosition yyP4));
tTree TypeSubscript ARGS((tTree yyP9, tTree yyP8, tPosition yyP7));
tTree TypeRange ARGS((tTree yyP13, tTree yyP12, tTree yyP11, tPosition yyP10));
tTree TypeBinary ARGS((tTree yyP17, tTree yyP16, tTree yyP15, tPosition yyP14));
tTree TypeUnary ARGS((tTree yyP20, tTree yyP19, tPosition yyP18));
static tTree TypeExprSubList ARGS((tTree yyP21));
tTree TypeExprList ARGS((tTree yyP22));
tTree TypeTable ARGS((tTree yyP24, tTree yyP23));
tTree StripTypeList ARGS((tTree yyP25));
void TypeCheckAssign ARGS((tTree yyP28, tTree yyP27, tPosition yyP26));
static void TypeCheckAssignList ARGS((tTree yyP31, tTree yyP30, tPosition yyP29));
static void TypeCheckAssignFn ARGS((tTree yyP34, tTree yyP33, tPosition yyP32));
void TypeCheckResults ARGS((tTree yyP37, tTree yyP36, tPosition yyP35));
void TypeCheckParameters ARGS((tTree yyP41, tTree yyP40, tPosition yyP39, int yyP38));
void UpdateElementalUsage ARGS((tTree yyP43, tUsage yyP42));
void TypeCheckIfList ARGS((tTree yyP44));
void TypeCheckTimerInput ARGS((tTree yyP46, tPosition yyP45));
void TypeCheckInputProtocol ARGS((tTree yyP49, tTree yyP48, tPosition yyP47));
static void TypeCheckSimpleProtocol ARGS((tTree yyP51, tTree yyP50));
void TypeCheckOutputProtocol ARGS((tTree yyP54, tTree yyP53, tPosition yyP52));
void TypeCheckCaseInputs ARGS((tTree yyP57, tTree yyP56, tPosition yyP55));
static void TypeCheckCaseOutput ARGS((tTree yyP60, tTree yyP59, tPosition yyP58));
static void TypeCheckInputSeqProtocol ARGS((tTree yyP63, tTree yyP62, tPosition yyP61));
static void TypeCheckOutputSeqProtocol ARGS((tTree yyP66, tTree yyP65, tPosition yyP64));
void TypeCheckCaseList ARGS((tTree yyP69, tTree yyP68, bool yyP67));
void TypeCheckRetypes ARGS((tTree yyP72, tTree yyP71, tPosition yyP70));
static void DoTypeCheckRetypes ARGS((int yyP77, tTree yyP76, int yyP75, tTree yyP74, tPosition yyP73));
static bool SameType ARGS((tTree yyP79, tTree yyP78));
static bool CheckValidTag ARGS((tTree yyP81, tSymbol yyP80));
static bool SameProtocol ARGS((tTree yyP83, tTree yyP82));
bool CheckWritable ARGS((tTree yyP84));
bool CheckWritableExprList ARGS((tTree yyP85));
bool CheckForVals ARGS((tTree yyP86));
bool CheckValofScope ARGS((tTree yyP88, int yyP87));
bool CheckIsType ARGS((tTree yyP90, Tree_tKind yyP89));
bool IsChanOrTimerType ARGS((tTree yyP91));
bool IsChanType ARGS((tTree yyP92));
bool IsTimerType ARGS((tTree yyP93));
bool IsArrayType ARGS((tTree yyP94));
static bool CheckChoicesDiffer ARGS((tTree yyP96, tTree yyP95));
static bool CheckExprDiffers ARGS((tTree yyP99, tTree yyP98, tTree yyP97));
bool CheckValidDeclType ARGS((tTree yyP100));
bool CheckEvalBiOp ARGS((tTree yyP102, tTree yyP101));
static bool CheckEvalBiIntOp ARGS((tTree yyP103));
static bool CheckEvalBiRealOp ARGS((tTree yyP104));
bool CheckEvalUniOp ARGS((tTree yyP107, tTree yyP106, tTree yyP105));
tValue EvalBiExpr ARGS((tPosition yyP112, tTree yyP111, tValue yyP110, tTree yyP109, tValue yyP108));
static tInt EvalBiIntOp ARGS((tPosition yyP117, tTree yyP116, tInt yyP115, tTree yyP114, tInt yyP113));
static int EvalBiBoolOp ARGS((tPosition yyP122, tTree yyP121, tInt yyP120, tTree yyP119, tInt yyP118));
static double EvalBiRealMathsOp ARGS((tPosition yyP127, tTree yyP126, double yyP125, tTree yyP124, double yyP123));
static int EvalBiRealRelOp ARGS((tPosition yyP132, tTree yyP131, double yyP130, tTree yyP129, double yyP128));
tValue EvalUniExpr ARGS((tTree yyP135, tTree yyP134, tTree yyP133));
bool CheckConstConvert ARGS((tTree yyP136));
tValue EvalConstConvert ARGS((tPosition yyP139, tTree yyP138, tTree yyP137));
tValue CheckConst ARGS((tPosition yyP143, tTree yyP142, tInt yyP141, bool yyP140));
bool CheckConstRoundTrunc ARGS((tTree yyP145, tTree yyP144));
tValue EvalConstTrunc ARGS((tPosition yyP149, tTree yyP148, tTree yyP147, tValue yyP146));
tValue EvalConstRound ARGS((tPosition yyP153, tTree yyP152, tTree yyP151, tValue yyP150));
bool CheckConstId ARGS((tTree yyP154));
tValue EvalConstId ARGS((tTree yyP155));
tInt TestIntOVF ARGS((tPosition yyP158, tTree yyP157, tInt yyP156));
tInt SignExtendInt ARGS((tTree yyP160, tInt yyP159));
static int CountTags ARGS((tSymbol yyP161));
static tInt EvalIntBits ARGS((tTree yyP162));
static tInt EvalIntMask ARGS((tTree yyP163));
tInt EvalMostPos ARGS((tTree yyP164));
tInt EvalMostNeg ARGS((tTree yyP165));
tValue EvalConstSubscript ARGS((tTree yyP168, int yyP167, tConstArray yyP166));
tConstArray ConstArrayFromString ARGS((tTree yyP170, tStringRef yyP169));
tConstArray ConstArrayFromExprList ARGS((tTree yyP172, tTree yyP171));
tConstArray ConstArrayFromDecl ARGS((tTree yyP174, tTree yyP173));
static void FillConstArray ARGS((tTree yyP177, tTree yyP176, tConstArray yyP175));
tConstArray RangeConstArray ARGS((tTree yyP180, tConstArray yyP179, int yyP178));
tConstArray SubscriptConstArray ARGS((tTree yyP183, tConstArray yyP182, int yyP181));
static tConstArray GetConstArray ARGS((tTree EX));
tValue ReadConstArray ARGS((tTree yyP185, tConstArray yyP184));
void WriteConstArray ARGS((tTree yyP188, tValue yyP187, tConstArray yyP186));
static tConstArray NewConstArray ARGS((int yyP189));
static void RangeCheckSubscript ARGS((tTree yyP191, tTree yyP190));
static void RangeCheckSlice ARGS((tTree yyP194, tTree yyP193, tTree yyP192));
tTree MakeConstInt ARGS((int yyP196, tPosition yyP195));
static tTree MakeAddExpr ARGS((tTree yyP198, tTree yyP197));
static int CountList ARGS((tTree yyP200, tTree yyP199));
static int SizeType ARGS((tTree yyP203, tPosition yyP202, bool yyP201, tTree * yyP204));
int CalcTypeSize ARGS((tTree yyP205));
tTree ReduceElement ARGS((tTree yyP207, tTree yyP206));
tTree ReduceElemental ARGS((tTree yyP208));
tTree ArrayPrimType ARGS((tTree yyP209));
void MarkNonAtomicIf ARGS((tTree IF));
static void MarkNonAtomicIfList ARGS((tTree IF));

void TypeFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP1)
# else
(yyP1)
 register tTree yyP1;
# endif
{
/* line 149 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 static tTree by=NULL; static tTree type=NULL; 
  if (yyP1->Kind == kNoFormal) {
/* line 150 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP1->Kind == kAFormal) {
  if (yyP1->AFormal.By->Kind == kByUndef) {
  if (yyP1->AFormal.Type->Kind == kUntyped) {
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP1->AFormal.By = by;
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP1->AFormal.Type = type;
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolType (yyP1->AFormal.Sym) = type;
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeFormals (yyP1->AFormal.Next);
  }
   return;

  }
  }
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   by = yyP1->AFormal.By;
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   type = yyP1->AFormal.Type;
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolType (yyP1->AFormal.Sym) = yyP1->AFormal.Type;
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeFormals (yyP1->AFormal.Next);
  }
   return;

  }
;
}

void TypeDecl
# if defined __STDC__ | defined __cplusplus
(register tTree yyP3, register tTree yyP2)
# else
(yyP3, yyP2)
 register tTree yyP3;
 register tTree yyP2;
# endif
{
  if (yyP2->Kind == kNoId) {
/* line 156 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP2->Kind == kAnId) {
/* line 157 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 157 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolType (yyP2->AnId.Sym) = yyP3;
/* line 157 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeDecl (yyP3, yyP2->AnId.Next);
  }
   return;

  }
;
}

tTree TypeAbbrev
# if defined __STDC__ | defined __cplusplus
(register tTree yyP6, register tTree yyP5, register tPosition yyP4)
# else
(yyP6, yyP5, yyP4)
 register tTree yyP6;
 register tTree yyP5;
 register tPosition yyP4;
# endif
{
  if (yyP6->Kind == kUntyped) {
/* line 161 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP5;

  }
  if (Tree_IsType (yyP6, kPrimitive)) {
  if (Tree_IsType (yyP5, kPrimitive)) {
/* line 162 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 162 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP6 -> Kind == yyP5 -> Kind))) goto yyL2;
  }
   return yyP6;
yyL2:;

  }
  }
  if (yyP6->Kind == kByte) {
  if (yyP5->Kind == kByte) {
/* line 163 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP6;

  }
  }
  if (yyP6->Kind == kBool) {
  if (yyP5->Kind == kBool) {
/* line 164 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP6;

  }
  }
  if (yyP6->Kind == kChan) {
  if (yyP5->Kind == kChan) {
/* line 165 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 165 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameProtocol (yyP6->Chan.Protocol, yyP5->Chan.Protocol))) goto yyL5;
  }
   return yyP6;
yyL5:;

  }
  }
  if (yyP6->Kind == kArray) {
  if (yyP6->Array.Expr->Kind == kUnBound) {
  if (yyP5->Kind == kArray) {
  if (yyP5->Array.Expr->Kind == kUnBound) {
/* line 166 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 166 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
   return yyP6;

  }
  }
  }
  if (yyP5->Kind == kArray) {
/* line 167 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 167 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (yyP6->Array.Expr, kUnBound)))) goto yyL7;
  {
/* line 167 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Expr = yyP5->Array.Expr;
/* line 167 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
  }
   return yyP6;
yyL7:;

/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP6->Array.Expr)))) goto yyL8;
  {
/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP5->Array.Expr)))) goto yyL8;
  {
/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP6->Array.Expr) == ValConstInt (yyP5->Array.Expr)))) goto yyL8;
  {
/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
  }
  }
  }
   return yyP6;
yyL8:;

/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP6->Array.Expr)))) goto yyL9;
  {
/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP5->Array.Expr)))) goto yyL9;
  {
/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Array size mismatch in abbreviation", xxError, yyP4);
/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
  }
  }
   return yyP6;
yyL9:;

/* line 170 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 170 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
   return yyP6;

  }
  }
/* line 171 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 171 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in abbreviation", xxError, yyP4);
  }
   return yyP6;

}

tTree TypeSubscript
# if defined __STDC__ | defined __cplusplus
(register tTree yyP9, register tTree yyP8, register tPosition yyP7)
# else
(yyP9, yyP8, yyP7)
 register tTree yyP9;
 register tTree yyP8;
 register tPosition yyP7;
# endif
{
  if (yyP8->Kind == kArray) {
/* line 176 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 176 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   RangeCheckSubscript (yyP9, yyP8->Array.Expr);
  }
   return yyP8->Array.Type;

  }
/* line 177 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 177 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Subscripted non-array type", xxError, yyP7);
  }
   return yyP8;

}

tTree TypeRange
# if defined __STDC__ | defined __cplusplus
(register tTree yyP13, register tTree yyP12, register tTree yyP11, register tPosition yyP10)
# else
(yyP13, yyP12, yyP11, yyP10)
 register tTree yyP13;
 register tTree yyP12;
 register tTree yyP11;
 register tPosition yyP10;
# endif
{
  if (yyP11->Kind == kArray) {
/* line 181 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
/* line 181 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   RangeCheckSlice (yyP13, yyP12, yyP11->Array.Expr);
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kArray)
    yyV1->Array.Expr = yyP12;
    yyV1->Array.Type = yyP11->Array.Type;
   return yyV1;
  }
 }

  }
/* line 182 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 182 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Took slice of non-array type", xxError, yyP10);
  }
   return yyP11;

}

tTree TypeBinary
# if defined __STDC__ | defined __cplusplus
(register tTree yyP17, register tTree yyP16, register tTree yyP15, register tPosition yyP14)
# else
(yyP17, yyP16, yyP15, yyP14)
 register tTree yyP17;
 register tTree yyP16;
 register tTree yyP15;
 register tPosition yyP14;
# endif
{
  if (yyP17->Kind == kBool) {
  if (Tree_IsType (yyP16, kLogOp)) {
  if (yyP15->Kind == kBool) {
/* line 186 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }

  }
  }
  if (Tree_IsType (yyP16, kRelOp)) {
  if (yyP15->Kind == kBool) {
/* line 187 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }

  }
  }
  }
  if (yyP17->Kind == kByte) {
  if (Tree_IsType (yyP16, kRelOp)) {
  if (yyP15->Kind == kByte) {
/* line 188 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }

  }
  }
  }
  if (Tree_IsType (yyP17, kInteger)) {
  if (yyP16->Kind == kAfterOp) {
  if (Tree_IsType (yyP15, kInteger)) {
/* line 189 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
/* line 189 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL4;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }
yyL4:;

  }
  }
  }
  if (Tree_IsType (yyP17, kNumeric)) {
  if (Tree_IsType (yyP16, kRelOp)) {
  if (Tree_IsType (yyP15, kNumeric)) {
/* line 190 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
/* line 190 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL5;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }
yyL5:;

  }
  }
  if (Tree_IsType (yyP16, kMathsOp)) {
  if (Tree_IsType (yyP15, kNumeric)) {
/* line 191 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 191 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL6;
  }
   return yyP17;
yyL6:;

  }
  }
  }
  if (Tree_IsType (yyP17, kInteger)) {
  if (Tree_IsType (yyP16, kBitOp)) {
  if (Tree_IsType (yyP15, kInteger)) {
/* line 192 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 192 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL7;
  }
   return yyP17;
yyL7:;

  }
  }
  if (Tree_IsType (yyP16, kClockOp)) {
  if (Tree_IsType (yyP15, kInteger)) {
/* line 193 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 193 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL8;
  }
   return yyP17;
yyL8:;

  }
  }
  if (Tree_IsType (yyP16, kShiftOp)) {
  if (yyP15->Kind == kInt) {
/* line 194 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP17;

  }
  }
  }
/* line 196 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 196 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in binary operation", xxError, yyP14);
  }
   return yyP17;

}

tTree TypeUnary
# if defined __STDC__ | defined __cplusplus
(register tTree yyP20, register tTree yyP19, register tPosition yyP18)
# else
(yyP20, yyP19, yyP18)
 register tTree yyP20;
 register tTree yyP19;
 register tPosition yyP18;
# endif
{

  switch (yyP20->Kind) {
  case kSubtract:
  if (Tree_IsType (yyP19, kNumeric)) {
/* line 200 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kMinus:
  if (Tree_IsType (yyP19, kNumeric)) {
/* line 201 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kAdd:
  if (Tree_IsType (yyP19, kNumeric)) {
/* line 202 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kPlus:
  if (Tree_IsType (yyP19, kNumeric)) {
/* line 203 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kNot:
  if (yyP19->Kind == kBool) {
/* line 204 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kSize:
  if (yyP19->Kind == kArray) {
/* line 205 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kInt)
   return yyV1;
  }
 }

  }
  break;
  case kBitNot:
  if (Tree_IsType (yyP19, kInteger)) {
/* line 206 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  }

/* line 208 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 208 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in unary operation", xxError, yyP18);
  }
   return yyP19;

}

static tTree TypeExprSubList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP21)
# else
(yyP21)
 register tTree yyP21;
# endif
{
  if (yyP21->Kind == kNoExpr) {
/* line 212 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoType)
   return yyV1;
  }
 }

  }
  if (yyP21->Kind == kAnExpr) {
/* line 213 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAType)
    yyV1->AType.Next = TypeExprSubList (yyP21->AnExpr.Next);
    yyV1->AType.Type = ExprType (yyP21->AnExpr.Expr);
   return yyV1;
  }
 }

  }
 yyAbort ("TypeExprSubList");
}

tTree TypeExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP22)
# else
(yyP22)
 register tTree yyP22;
# endif
{
  if (yyP22->Kind == kNoExpr) {
/* line 217 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoType)
   return yyV1;
  }
 }

  }
  if (yyP22->Kind == kAnExpr) {
  if (yyP22->AnExpr.Next->Kind == kNoExpr) {
/* line 218 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return ExprType (yyP22->AnExpr.Expr);

  }
/* line 219 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAType)
    yyV1->AType.Next = TypeExprSubList (yyP22->AnExpr.Next);
    yyV1->AType.Type = ExprType (yyP22->AnExpr.Expr);
   return yyV1;
  }
 }

  }
 yyAbort ("TypeExprList");
}

tTree TypeTable
# if defined __STDC__ | defined __cplusplus
(register tTree yyP24, register tTree yyP23)
# else
(yyP24, yyP23)
 register tTree yyP24;
 register tTree yyP23;
# endif
{
  if (yyP24->Kind == kAnExpr) {
/* line 223 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kArray)
    yyV1->Array.Expr = MakeConstInt (CountList (yyP24->AnExpr.Next, yyP23), yyP24->AnExpr.Expr->Expr.Pos);
    yyV1->Array.Type = yyP23;
   return yyV1;
  }
 }

  }
 yyAbort ("TypeTable");
}

tTree StripTypeList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP25)
# else
(yyP25)
 register tTree yyP25;
# endif
{
  if (yyP25->Kind == kAType) {
  if (yyP25->AType.Next->Kind == kNoType) {
/* line 228 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP25->AType.Type;

  }
  }
/* line 229 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP25;

}

void TypeCheckAssign
# if defined __STDC__ | defined __cplusplus
(register tTree yyP28, register tTree yyP27, register tPosition yyP26)
# else
(yyP28, yyP27, yyP26)
 register tTree yyP28;
 register tTree yyP27;
 register tPosition yyP26;
# endif
{
  if (yyP28->Kind == kAnExpr) {
  if (yyP28->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP27->Kind == kAnExpr) {
/* line 235 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 235 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (ExprType (yyP27->AnExpr.Expr), kAType)))) goto yyL1;
  {
/* line 236 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP28, ExprType (yyP27->AnExpr.Expr), yyP28->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL1:;

  }
  }
  }
/* line 237 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 237 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP28, yyP27, yyP26);
  }
   return;

;
}

static void TypeCheckAssignList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP31, register tTree yyP30, register tPosition yyP29)
# else
(yyP31, yyP30, yyP29)
 register tTree yyP31;
 register tTree yyP30;
 register tPosition yyP29;
# endif
{
  if (yyP31->Kind == kNoExpr) {
  if (yyP30->Kind == kNoExpr) {
/* line 241 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 242 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 242 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many expressions on assignment RHS", xxError, yyP29);
  }
   return;

  }
  if (yyP30->Kind == kNoExpr) {
/* line 243 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 243 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few expressions on assignment RHS", xxError, yyP29);
  }
   return;

  }
  if (yyP31->Kind == kAnExpr) {
  if (yyP31->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP30->Kind == kAnExpr) {
/* line 244 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 244 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsChanOrTimerType (ElementType (yyP31->AnExpr.Expr))))) goto yyL4;
  {
/* line 245 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cannot assign to channel or timer", xxError, yyP31->AnExpr.Expr->ElementalExpr.Pos);
/* line 246 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP31->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL4:;

/* line 247 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 247 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP31->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL5;
  {
/* line 247 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (ExprType (yyP31->AnExpr.Expr), ExprType (yyP30->AnExpr.Expr))))) goto yyL5;
  {
/* line 248 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP31->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
  }
   return;
yyL5:;

/* line 249 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 249 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP31->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL6;
  {
/* line 250 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch during assignment", xxError, yyP31->AnExpr.Expr->ElementalExpr.Pos);
/* line 251 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP31->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL6:;

/* line 252 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 253 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cannot make assignment to variable", xxError, yyP31->AnExpr.Expr->ElementalExpr.Pos);
/* line 254 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP31->AnExpr.Expr->ElementalExpr.Pos);
  }
   return;

  }
  }
  if (yyP30->Kind == kAnExpr) {
/* line 255 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 256 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("LHS must be an assignable variable", xxError, yyP29);
/* line 257 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP29);
  }
   return;

  }
  }
;
}

static void TypeCheckAssignFn
# if defined __STDC__ | defined __cplusplus
(register tTree yyP34, register tTree yyP33, register tPosition yyP32)
# else
(yyP34, yyP33, yyP32)
 register tTree yyP34;
 register tTree yyP33;
 register tPosition yyP32;
# endif
{
  if (yyP34->Kind == kNoExpr) {
  if (yyP33->Kind == kNoType) {
/* line 261 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 262 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 262 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few variables to assign to from function", xxError, yyP32);
  }
   return;

  }
  if (yyP33->Kind == kNoType) {
/* line 263 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 263 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many variables to assign to from function", xxError, yyP32);
  }
   return;

  }
  if (yyP34->Kind == kAnExpr) {
  if (yyP34->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP33->Kind == kAType) {
/* line 264 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 264 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP34->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 264 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (ExprType (yyP34->AnExpr.Expr), yyP33->AType.Type))) goto yyL4;
  {
/* line 265 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP34->AnExpr.Next, yyP33->AType.Next, yyP34->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
  }
   return;
yyL4:;

/* line 266 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 266 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP34->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL5;
  {
/* line 267 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch during function assignment", xxError, yyP34->AnExpr.Expr->ElementalExpr.Pos);
/* line 268 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP34->AnExpr.Next, yyP33->AType.Next, yyP34->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL5:;

/* line 269 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 270 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cannot make assignment to variable", xxError, yyP34->AnExpr.Expr->ElementalExpr.Pos);
/* line 271 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP34->AnExpr.Next, yyP33->AType.Next, yyP34->AnExpr.Expr->ElementalExpr.Pos);
  }
   return;

  }
  }
  }
;
}

void TypeCheckResults
# if defined __STDC__ | defined __cplusplus
(register tTree yyP37, register tTree yyP36, register tPosition yyP35)
# else
(yyP37, yyP36, yyP35)
 register tTree yyP37;
 register tTree yyP36;
 register tPosition yyP35;
# endif
{
  if (yyP37->Kind == kNoType) {
  if (yyP36->Kind == kNoExpr) {
/* line 275 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 276 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 276 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many expressions in result list", xxError, yyP35);
  }
   return;

  }
  if (yyP36->Kind == kNoExpr) {
/* line 277 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 277 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few expressions in result list", xxError, yyP35);
  }
   return;

  }
  if (yyP37->Kind == kAType) {
  if (yyP36->Kind == kAnExpr) {
/* line 278 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 278 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (yyP37->AType.Type, ExprType (yyP36->AnExpr.Expr))))) goto yyL4;
  {
/* line 278 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckResults (yyP37->AType.Next, yyP36->AnExpr.Next, yyP36->AnExpr.Expr->Expr.Pos);
  }
  }
   return;
yyL4:;

/* line 279 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 279 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in result list", xxError, yyP36->AnExpr.Expr->Expr.Pos);
/* line 279 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckResults (yyP37->AType.Next, yyP36->AnExpr.Next, yyP36->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

void TypeCheckParameters
# if defined __STDC__ | defined __cplusplus
(register tTree yyP41, register tTree yyP40, register tPosition yyP39, register int yyP38)
# else
(yyP41, yyP40, yyP39, yyP38)
 register tTree yyP41;
 register tTree yyP40;
 register tPosition yyP39;
 register int yyP38;
# endif
{
  if (yyP41->Kind == kNoFormal) {
  if (yyP40->Kind == kNoExpr) {
/* line 283 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 284 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 284 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many parameters", xxError, yyP39);
  }
   return;

  }
  if (yyP40->Kind == kNoExpr) {
/* line 285 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 285 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few parameters", xxError, yyP39);
  }
   return;

  }
  if (yyP41->Kind == kAFormal) {
  if (yyP41->AFormal.By->Kind == kByRef) {
  if (yyP40->Kind == kAnExpr) {
  if (yyP40->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP40->AnExpr.Expr->ElementalExpr.Elemental->Kind == kTable) {
/* line 286 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 286 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP40->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 286 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP41->AFormal.Type, ExprType (yyP40->AnExpr.Expr)))) goto yyL4;
  {
/* line 287 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP40->AnExpr.Expr->ElementalExpr.Elemental, yyP41 -> AFormal . U);
/* line 288 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
  }
  }
   return;
yyL4:;

  }
  if (Tree_IsType (yyP40->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 290 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 290 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP40->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL5;
  {
/* line 290 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP41->AFormal.Type, ExprType (yyP40->AnExpr.Expr)))) goto yyL5;
  {
/* line 291 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (!CheckValofScope(yyP40->AnExpr.Expr->ElementalExpr.Elemental,yyP38)) Message("Attempted to pass free variable by reference within VALOF",xxError,yyP39); 
/* line 292 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP40->AnExpr.Expr->ElementalExpr.Elemental, yyP41 -> AFormal . U);
/* line 293 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
  }
  }
   return;
yyL5:;

  }
  }
/* line 298 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 298 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP41->AFormal.Type, ExprType (yyP40->AnExpr.Expr)))) goto yyL7;
  {
/* line 299 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Actual parameter cannot be passed by reference", xxError, yyP39);
/* line 300 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
  }
   return;
yyL7:;

  }
  }
  if (yyP41->AFormal.By->Kind == kByVal) {
  if (yyP40->Kind == kAnExpr) {
/* line 295 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 295 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP41->AFormal.Type, ExprType (yyP40->AnExpr.Expr)))) goto yyL6;
  {
/* line 296 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
  }
   return;
yyL6:;

  }
  }
  if (yyP40->Kind == kAnExpr) {
/* line 302 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 303 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Actual parameter does not match formal description", xxError, yyP40->AnExpr.Expr->Expr.Pos);
/* line 304 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
   return;

  }
  }
;
}

void UpdateElementalUsage
# if defined __STDC__ | defined __cplusplus
(register tTree yyP43, tUsage yyP42)
# else
(yyP43, yyP42)
 register tTree yyP43;
 tUsage yyP42;
# endif
{
/* line 309 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tUsage tmp; 

  switch (yyP43->Kind) {
  case kIdentifier:
/* line 310 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 310 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP43->Identifier.Sym), kAFormal)))) goto yyL1;
  {
/* line 311 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Identifier . U = yyP42;
/* line 312 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolKind (yyP43->Identifier.Sym) -> AFormal . U = UpdateUsage (SymbolKind (yyP43->Identifier.Sym) -> AFormal . U, yyP42);
/* line 313 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (SymbolKind(yyP43->Identifier.Sym)->AFormal.U==xxInOut) Message("Passed channel used for both input and output",xxError,yyP43->Identifier.Pos); 
  }
  }
   return;
yyL1:;

/* line 315 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 315 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP43->Identifier.Sym), kIs)))) goto yyL2;
  {
/* line 316 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Identifier . U = yyP42;
/* line 317 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolKind (yyP43->Identifier.Sym) -> Is . U = UpdateUsage (SymbolKind (yyP43->Identifier.Sym) -> Is . U, yyP42);
/* line 318 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   tmp = SymbolKind (yyP43->Identifier.Sym) -> Is . U;
/* line 319 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (tmp==xxInput||tmp==xxOutput||tmp==xxInOut) UpdateElementalUsage(SymbolKind(yyP43->Identifier.Sym)->Is.Elemental,yyP42);
/* line 320 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (SymbolKind(yyP43->Identifier.Sym)->Is.U==xxInOut) Message("Abbreviated channel used for both input and output",xxError,yyP43->Identifier.Pos); 
  }
  }
   return;
yyL2:;

/* line 322 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 322 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP43->Identifier.Sym), kAnId)))) goto yyL3;
  {
/* line 323 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Identifier . U = yyP42;
/* line 324 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolKind (yyP43->Identifier.Sym) -> AnId . U = UpdateUsage (SymbolKind (yyP43->Identifier.Sym) -> AnId . U, yyP42);
  }
  }
   return;
yyL3:;

  break;
  case kRange:
/* line 326 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 326 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Range . U = yyP42;
/* line 326 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->Range.Next, yyP42);
  }
   return;

  case kSubscript:
/* line 327 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 327 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Subscript . U = yyP42;
/* line 327 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->Subscript.Next, yyP42);
  }
   return;

  case kTableRange:
/* line 328 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 328 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> TableRange . U = yyP42;
/* line 328 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->TableRange.Next, yyP42);
  }
   return;

  case kTableSubscript:
/* line 329 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 329 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> TableSubscript . U = yyP42;
/* line 329 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->TableSubscript.Next, yyP42);
  }
   return;

  case kTable:
/* line 330 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 330 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Table . U = yyP42;
/* line 330 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->Table.ExprList, yyP42);
  }
   return;

  case kAnExpr:
  if (yyP43->AnExpr.Expr->Kind == kElementalExpr) {
/* line 331 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 331 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->AnExpr.Expr->ElementalExpr.Elemental, yyP42);
/* line 331 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->AnExpr.Next, yyP42);
  }
   return;

  }
/* line 332 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 332 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->AnExpr.Next, yyP42);
  }
   return;

  }

;
}

void TypeCheckIfList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP44)
# else
(yyP44)
 register tTree yyP44;
# endif
{
  if (yyP44->Kind == kNoChoice) {
/* line 336 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP44->Kind == kAChoice) {
  if (yyP44->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP44->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
/* line 337 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 337 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (ExprType (yyP44->AChoice.ExprList->AnExpr.Expr), kBool)))) goto yyL2;
  {
/* line 337 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->AChoice.Next);
  }
  }
   return;
yyL2:;

/* line 338 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 338 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Conditional not of type BOOL", xxError, yyP44->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
/* line 338 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->AChoice.Next);
  }
   return;

  }
  }
  }
  if (yyP44->Kind == kANewIf) {
  if (yyP44->ANewIf.IfType->Kind == kIf) {
/* line 339 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 339 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->ANewIf.IfType->If.ChoiceList);
/* line 339 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->ANewIf.Next);
  }
   return;

  }
  if (yyP44->ANewIf.IfType->Kind == kIfRep) {
/* line 340 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 340 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->ANewIf.IfType->IfRep.ChoiceList);
/* line 340 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->ANewIf.Next);
  }
   return;

  }
  }
;
}

void TypeCheckTimerInput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP46, register tPosition yyP45)
# else
(yyP46, yyP45)
 register tTree yyP46;
 register tPosition yyP45;
# endif
{
  if (yyP46->Kind == kAnExpr) {
  if (yyP46->AnExpr.Next->Kind == kNoExpr) {
  if (yyP46->AnExpr.Expr->Kind == kElementalExpr) {
/* line 344 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 344 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP46->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL1;
  {
/* line 344 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (ExprType (yyP46->AnExpr.Expr), kInt)))) goto yyL1;
  }
  }
   return;
yyL1:;

  }
/* line 345 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 345 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Timer input not to writable INT variable", xxError, yyP46->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
/* line 346 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 346 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Only single input allowed from TIMER", xxError, yyP45);
  }
   return;

  }
  if (yyP46->Kind == kNoExpr) {
/* line 347 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 347 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Missing variable for timer input", xxError, yyP45);
  }
   return;

  }
;
}

void TypeCheckInputProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP49, register tTree yyP48, register tPosition yyP47)
# else
(yyP49, yyP48, yyP47)
 register tTree yyP49;
 register tTree yyP48;
 register tPosition yyP47;
# endif
{
  if (yyP49->Kind == kAny) {
  if (yyP48->Kind == kAnExpr) {
  if (yyP48->AnExpr.Next->Kind == kNoExpr) {
  if (yyP48->AnExpr.Expr->Kind == kElementalExpr) {
/* line 351 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 351 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL1;
  }
   return;
yyL1:;

  }
  if (yyP48->AnExpr.Expr->Kind == kCountArray) {
  if (yyP48->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP48->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 353 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 354 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Length->ElementalExpr.Elemental)))) goto yyL3;
  {
/* line 354 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental)))) goto yyL3;
  {
/* line 354 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental -> Element . SynType -> Kind == kArray))) goto yyL3;
  }
  }
  }
   return;
yyL3:;

  }
  }
  }
/* line 357 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 357 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Input variable not writable", xxError, yyP48->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  if (yyP48->AnExpr.Expr->Kind == kElementalExpr) {
/* line 352 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 352 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL2;
  {
/* line 352 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputProtocol (yyP49, yyP48->AnExpr.Next, yyP48->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL2:;

  }
  if (yyP48->AnExpr.Expr->Kind == kCountArray) {
  if (yyP48->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP48->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 355 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 356 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Length->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 356 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 356 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental -> Element . SynType -> Kind == kArray))) goto yyL4;
  {
/* line 356 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputProtocol (yyP49, yyP48->AnExpr.Next, yyP48->AnExpr.Expr->CountArray.Pos);
  }
  }
  }
  }
   return;
yyL4:;

  }
  }
  }
/* line 358 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 358 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Input variable not writable", xxError, yyP48->AnExpr.Expr->Expr.Pos);
/* line 358 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputProtocol (yyP49, yyP48->AnExpr.Next, yyP48->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP48->Kind == kNoExpr) {
/* line 360 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 360 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("No expression list present for channel input", xxError, yyP47);
  }
   return;

  }
  if (yyP49->Kind == kNamed) {
/* line 362 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 362 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP49->Named.Sym), kDefSeqPro)))) goto yyL8;
  {
/* line 362 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (SymbolKind (yyP49->Named.Sym) -> DefSeqPro . SeqProList, yyP48, yyP47);
  }
  }
   return;
yyL8:;

/* line 363 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 363 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Invalid form of variant protocol input", xxError, yyP47);
  }
   return;

  }
  if (yyP48->Kind == kAnExpr) {
  if (yyP48->AnExpr.Next->Kind == kNoExpr) {
  if (yyP48->AnExpr.Expr->Kind == kElementalExpr) {
/* line 364 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 364 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL10;
  {
/* line 364 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP49, yyP48->AnExpr.Expr);
  }
  }
   return;
yyL10:;

  }
  if (yyP48->AnExpr.Expr->Kind == kCountArray) {
  if (yyP48->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP48->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 365 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 365 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Length->ElementalExpr.Elemental)))) goto yyL11;
  {
/* line 365 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental)))) goto yyL11;
  {
/* line 365 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP49, yyP48->AnExpr.Expr);
  }
  }
  }
   return;
yyL11:;

  }
  }
  }
/* line 366 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 366 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Input item not assignable", xxError, yyP48->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
/* line 367 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 367 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many inputs for a channel with a simple protocol", xxError, yyP48->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
;
}

static void TypeCheckSimpleProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP51, register tTree yyP50)
# else
(yyP51, yyP50)
 register tTree yyP51;
 register tTree yyP50;
# endif
{
  if (yyP51->Kind == kSimple) {
  if (yyP50->Kind == kCountArray) {
/* line 372 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 372 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Protocol does not expect a counted array", xxError, yyP50->CountArray.Pos);
  }
   return;

  }
/* line 373 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 373 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP51->Simple.Type, ExprType (yyP50)))) goto yyL2;
  }
   return;
yyL2:;

/* line 374 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 374 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Variable is not of correct type for protocol", xxError, yyP50->Expr.Pos);
  }
   return;

  }
  if (yyP51->Kind == kCounted) {
  if (yyP50->Kind == kCountArray) {
/* line 375 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 375 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (yyP51->Counted.Length, ExprType (yyP50->CountArray.Length))))) goto yyL4;
  {
/* line 375 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (yyP51->Counted.Type, ExprType (yyP50->CountArray.Expr))))) goto yyL4;
  }
  }
   return;
yyL4:;

/* line 376 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 376 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Counted array expression types do not match protocol", xxError, yyP50->CountArray.Pos);
  }
   return;

  }
/* line 377 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 377 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (yyP51->Counted.Type, ExprType (yyP50))))) goto yyL6;
  }
   return;
yyL6:;

/* line 378 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 378 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Output expression does not match protocol", xxError, yyP50->Expr.Pos);
  }
   return;

  }
;
}

void TypeCheckOutputProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP54, register tTree yyP53, register tPosition yyP52)
# else
(yyP54, yyP53, yyP52)
 register tTree yyP54;
 register tTree yyP53;
 register tPosition yyP52;
# endif
{
  if (yyP54->Kind == kAny) {
  if (yyP53->Kind == kAnExpr) {
  if (yyP53->AnExpr.Next->Kind == kNoExpr) {
/* line 385 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 386 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 387 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckOutputProtocol (yyP54, yyP53->AnExpr.Next, yyP53->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP53->Kind == kNoExpr) {
/* line 389 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 390 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("No expression list present for channel output", xxError, yyP52);
  }
   return;

  }
  if (yyP54->Kind == kNamed) {
/* line 392 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 392 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP54->Named.Sym), kDefSeqPro)))) goto yyL4;
  {
/* line 393 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckOutputSeqProtocol (SymbolKind (yyP54->Named.Sym) -> DefSeqPro . SeqProList, yyP53, yyP52);
  }
  }
   return;
yyL4:;

/* line 395 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 395 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP54->Named.Sym), kDefTagPro)))) goto yyL5;
  {
/* line 396 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseOutput (SymbolKind (yyP54->Named.Sym) -> DefTagPro . TagProList, yyP53, yyP52);
  }
  }
   return;
yyL5:;

/* line 398 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 399 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Not a valid named", xxError, yyP52);
  }
   return;

  }
  if (yyP53->Kind == kAnExpr) {
  if (yyP53->AnExpr.Next->Kind == kNoExpr) {
/* line 401 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 402 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP54, yyP53->AnExpr.Expr);
  }
   return;

  }
/* line 404 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 405 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many outputs for a channel with a simple protocol", xxError, yyP53->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
;
}

void TypeCheckCaseInputs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP57, register tTree yyP56, register tPosition yyP55)
# else
(yyP57, yyP56, yyP55)
 register tTree yyP57;
 register tTree yyP56;
 register tPosition yyP55;
# endif
{
  if (yyP56->Kind == kNoCase) {
/* line 410 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP56->Kind == kACase) {
  if (yyP56->ACase.ExprList->Kind == kAnExpr) {
  if (yyP56->ACase.ExprList->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP56->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 411 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 411 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((CheckValidTag (yyP57, yyP56->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym)))) goto yyL2;
  {
/* line 411 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (SymbolKind (yyP56->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym) -> ATagPro . SeqProList, yyP56->ACase.ExprList->AnExpr.Next, yyP55);
/* line 411 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseInputs (yyP57, yyP56->ACase.Next, yyP55);
  }
  }
   return;
yyL2:;

  }
  }
/* line 412 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 412 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Variant tag is not valid for this protocol", xxError, yyP56->ACase.ExprList->AnExpr.Expr->Expr.Pos);
/* line 412 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseInputs (yyP57, yyP56->ACase.Next, yyP55);
  }
   return;

  }
  if (yyP56->ACase.ExprList->Kind == kNoExpr) {
/* line 413 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 413 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cased input missing variant protocol", xxError, yyP55);
/* line 413 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseInputs (yyP57, yyP56->ACase.Next, yyP55);
  }
   return;

  }
  }
;
}

static void TypeCheckCaseOutput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP60, register tTree yyP59, register tPosition yyP58)
# else
(yyP60, yyP59, yyP58)
 register tTree yyP60;
 register tTree yyP59;
 register tPosition yyP58;
# endif
{
  if (yyP59->Kind == kAnExpr) {
  if (yyP59->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP59->AnExpr.Expr->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 417 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 417 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((CheckValidTag (yyP60, yyP59->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym)))) goto yyL1;
  {
/* line 418 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckOutputSeqProtocol (SymbolKind (yyP59->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym) -> ATagPro . SeqProList, yyP59->AnExpr.Next, yyP58);
  }
  }
   return;
yyL1:;

  }
  }
/* line 420 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 421 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Variant tag is not valid for this protocol", xxError, yyP59->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  if (yyP59->Kind == kNoExpr) {
/* line 423 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 424 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cased output missing variant protocol", xxError, yyP58);
  }
   return;

  }
;
}

static void TypeCheckInputSeqProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP63, register tTree yyP62, register tPosition yyP61)
# else
(yyP63, yyP62, yyP61)
 register tTree yyP63;
 register tTree yyP62;
 register tPosition yyP61;
# endif
{
  if (yyP63->Kind == kNoSeqPro) {
  if (yyP62->Kind == kNoExpr) {
/* line 429 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP62->Kind == kAnExpr) {
/* line 430 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 430 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many input expressions for channel protocol", xxError, yyP62->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP62->Kind == kNoExpr) {
/* line 431 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 431 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few input expressions for channel protocol", xxError, yyP61);
  }
   return;

  }
  if (yyP63->Kind == kASeqPro) {
  if (yyP62->Kind == kAnExpr) {
  if (yyP62->AnExpr.Expr->Kind == kElementalExpr) {
/* line 432 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 432 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP62->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 432 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP63->ASeqPro.Protocol, yyP62->AnExpr.Expr);
/* line 432 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (yyP63->ASeqPro.Next, yyP62->AnExpr.Next, yyP62->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL4:;

  }
  if (yyP62->AnExpr.Expr->Kind == kCountArray) {
/* line 433 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 433 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP63->ASeqPro.Protocol, yyP62->AnExpr.Expr);
/* line 433 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (yyP63->ASeqPro.Next, yyP62->AnExpr.Next, yyP62->AnExpr.Expr->CountArray.Pos);
  }
   return;

  }
/* line 434 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 434 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Not an assignable expression", xxError, yyP62->AnExpr.Expr->Expr.Pos);
/* line 434 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (yyP63->ASeqPro.Next, yyP62->AnExpr.Next, yyP62->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

static void TypeCheckOutputSeqProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP66, register tTree yyP65, register tPosition yyP64)
# else
(yyP66, yyP65, yyP64)
 register tTree yyP66;
 register tTree yyP65;
 register tPosition yyP64;
# endif
{
  if (yyP66->Kind == kNoSeqPro) {
  if (yyP65->Kind == kNoExpr) {
/* line 438 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP65->Kind == kAnExpr) {
/* line 439 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 439 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many output expressions for channel protocol", xxError, yyP65->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP65->Kind == kNoExpr) {
/* line 440 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 440 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few output expressions for channel protocol", xxError, yyP64);
  }
   return;

  }
  if (yyP66->Kind == kASeqPro) {
  if (yyP65->Kind == kAnExpr) {
/* line 441 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 441 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP66->ASeqPro.Protocol, yyP65->AnExpr.Expr);
/* line 441 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckOutputSeqProtocol (yyP66->ASeqPro.Next, yyP65->AnExpr.Next, yyP65->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

void TypeCheckCaseList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP69, register tTree yyP68, register bool yyP67)
# else
(yyP69, yyP68, yyP67)
 register tTree yyP69;
 register tTree yyP68;
 register bool yyP67;
# endif
{
  if (yyP68->Kind == kNoChoice) {
/* line 445 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP68->Kind == kAChoice) {
  if (yyP68->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP68->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
  if (yyP68->AChoice.ExprList->AnExpr.Expr->Kind == kDefault) {
  if (equalbool (yyP67, false)) {
/* line 446 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 446 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseList (yyP69, yyP68->AChoice.Next, true);
  }
   return;

  }
/* line 447 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 447 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Multiple ELSE options in selection", xxError, yyP68->AChoice.ExprList->AnExpr.Expr->Default.Pos);
  }
   return;

  }
  }
/* line 448 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 449 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 CountList(yyP68->AChoice.ExprList,yyP69);
/* line 450 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseList (yyP69, yyP68->AChoice.Next, yyP67);
/* line 451 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (!ConstFlag(yyP68->AChoice.ExprList->ExprList))
        Message("CASE options must be constant",xxError,yyP68->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
      if (!(CheckIsType(ExprListType(yyP68->AChoice.ExprList),kInteger)||CheckIsType(ExprListType(yyP68->AChoice.ExprList),kByte)||CheckIsType(ExprListType(yyP68->AChoice.ExprList),kBool)))
        Message("CASE options must be integer or BYTE (or BOOL)",xxError,yyP68->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
      else 
        if (!CheckChoicesDiffer(yyP68->AChoice.ExprList,yyP68->AChoice.Next)) Message("CASE options must be distinct",xxError,yyP68->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

void TypeCheckRetypes
# if defined __STDC__ | defined __cplusplus
(register tTree yyP72, register tTree yyP71, register tPosition yyP70)
# else
(yyP72, yyP71, yyP70)
 register tTree yyP72;
 register tTree yyP71;
 register tPosition yyP70;
# endif
{
/* line 460 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 int LS,RS; 
/* line 461 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  tTree yyV2;
  {
/* line 461 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   LS = SizeType (yyP72, yyP70, true, & yyV1);
/* line 461 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   RS = SizeType (yyP71, yyP70, false, & yyV2);
/* line 461 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   DoTypeCheckRetypes (LS, yyV1, RS, yyV2, yyP70);
  }
   return;
 }

;
}

static void DoTypeCheckRetypes
# if defined __STDC__ | defined __cplusplus
(register int yyP77, register tTree yyP76, register int yyP75, register tTree yyP74, register tPosition yyP73)
# else
(yyP77, yyP76, yyP75, yyP74, yyP73)
 register int yyP77;
 register tTree yyP76;
 register int yyP75;
 register tTree yyP74;
 register tPosition yyP73;
# endif
{
  if (equalint (yyP75, - 1)) {
/* line 464 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 465 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 465 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP74 != NoTree))) goto yyL2;
  }
   return;
yyL2:;

  if (yyP76 == NULL) {
  if (yyP74 == NULL) {
/* line 466 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 466 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP77 == yyP75))) goto yyL3;
  }
   return;
yyL3:;

/* line 467 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 467 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Size of retype does not match expression size", xxError, yyP73);
  }
   return;

  }
  }
  if (yyP74 == NULL) {
/* line 468 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 468 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (((yyP75 % yyP77) == 0))) goto yyL5;
  {
/* line 468 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP76 -> Array . Expr = MakeConstInt (yyP75 / yyP77, yyP73);
  }
  }
   return;
yyL5:;

/* line 469 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 469 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Size of retype cannot match expression size", xxError, yyP73);
  }
   return;

  }
;
}

static bool SameType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP79, register tTree yyP78)
# else
(yyP79, yyP78)
 register tTree yyP79;
 register tTree yyP78;
# endif
{

  switch (yyP79->Kind) {
  case kInt16:
  if (yyP78->Kind == kInt16) {
/* line 476 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kInt32:
  if (yyP78->Kind == kInt32) {
/* line 477 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kInt64:
  if (yyP78->Kind == kInt64) {
/* line 478 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kInt:
  if (yyP78->Kind == kInt) {
/* line 479 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kBool:
  if (yyP78->Kind == kBool) {
/* line 480 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kReal32:
  if (yyP78->Kind == kReal32) {
/* line 481 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kReal64:
  if (yyP78->Kind == kReal64) {
/* line 482 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kByte:
  if (yyP78->Kind == kByte) {
/* line 483 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kTimer:
  if (yyP78->Kind == kTimer) {
/* line 484 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kChan:
  if (yyP78->Kind == kChan) {
/* line 485 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 485 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameProtocol (yyP79->Chan.Protocol, yyP78->Chan.Protocol))) goto yyL10;
  }
   return true;
yyL10:;

  }
  break;
  case kArray:
  if (yyP79->Array.Expr->Kind == kUnBound) {
  if (yyP78->Kind == kArray) {
/* line 486 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 486 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP79->Array.Type, yyP78->Array.Type))) goto yyL11;
  }
   return true;
yyL11:;

/* line 487 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 487 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;
  }

  }
  }
  if (yyP78->Kind == kArray) {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP79->Array.Expr)))) goto yyL13;
  {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP78->Array.Expr)))) goto yyL13;
  {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP79->Array.Expr) == ValConstInt (yyP78->Array.Expr)))) goto yyL13;
  {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP79->Array.Type, yyP78->Array.Type))) goto yyL13;
  }
  }
  }
  }
   return true;
yyL13:;

/* line 489 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 489 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP78->Array.Expr)))) goto yyL14;
  {
/* line 489 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP79->Array.Type, yyP78->Array.Type))) goto yyL14;
  }
  }
   return true;
yyL14:;

/* line 490 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 490 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP79->Array.Expr)))) goto yyL15;
  {
/* line 490 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP79->Array.Type, yyP78->Array.Type))) goto yyL15;
  }
  }
   return true;
yyL15:;

  }
  break;
  }

  return false;
}

static bool CheckValidTag
# if defined __STDC__ | defined __cplusplus
(register tTree yyP81, tSymbol yyP80)
# else
(yyP81, yyP80)
 register tTree yyP81;
 tSymbol yyP80;
# endif
{
  if (yyP81->Kind == kATagPro) {
/* line 494 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 494 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP81->ATagPro.Sym == yyP80))) goto yyL1;
  }
   return true;
yyL1:;

/* line 495 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 495 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValidTag (yyP81->ATagPro.Next, yyP80))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

static bool SameProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP83, register tTree yyP82)
# else
(yyP83, yyP82)
 register tTree yyP83;
 register tTree yyP82;
# endif
{
  if (yyP83->Kind == kAny) {
/* line 499 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP82->Kind == kAny) {
/* line 500 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP83->Kind == kNamed) {
  if (yyP82->Kind == kNamed) {
/* line 501 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 501 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP83->Named.Sym == yyP82->Named.Sym))) goto yyL3;
  }
   return true;
yyL3:;

  }
  }
  if (yyP83->Kind == kSimple) {
  if (yyP82->Kind == kSimple) {
/* line 502 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 502 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP83->Simple.Type, yyP82->Simple.Type))) goto yyL4;
  }
   return true;
yyL4:;

  }
  }
  if (yyP83->Kind == kCounted) {
  if (yyP82->Kind == kCounted) {
/* line 503 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 503 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP83->Counted.Length, yyP82->Counted.Length))) goto yyL5;
  {
/* line 503 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP83->Counted.Type, yyP82->Counted.Type))) goto yyL5;
  }
  }
   return true;
yyL5:;

  }
  }
  return false;
}

bool CheckWritable
# if defined __STDC__ | defined __cplusplus
(register tTree yyP84)
# else
(yyP84)
 register tTree yyP84;
# endif
{
  if (yyP84->Kind == kAnId) {
/* line 507 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP84->Kind == kAFormal) {
  if (yyP84->AFormal.By->Kind == kByRef) {
/* line 508 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  }
  if (yyP84->Kind == kIs) {
/* line 509 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP84->Kind == kRetypes) {
/* line 510 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool CheckWritableExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP85)
# else
(yyP85)
 register tTree yyP85;
# endif
{
  if (yyP85->Kind == kNoExpr) {
/* line 515 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP85->Kind == kAnExpr) {
  if (yyP85->AnExpr.Expr->Kind == kElementalExpr) {
/* line 516 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return CheckWritableExprList (yyP85->AnExpr.Next) && Writable (yyP85->AnExpr.Expr->ElementalExpr.Elemental);

  }
/* line 517 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;

  }
 yyAbort ("CheckWritableExprList");
}

bool CheckForVals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP86)
# else
(yyP86)
 register tTree yyP86;
# endif
{
  if (yyP86->Kind == kNoFormal) {
/* line 521 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP86->Kind == kAFormal) {
  if (yyP86->AFormal.By->Kind == kByVal) {
/* line 522 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 522 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckForVals (yyP86->AFormal.Next))) goto yyL2;
  }
   return true;
yyL2:;

  }
  }
  return false;
}

bool CheckValofScope
# if defined __STDC__ | defined __cplusplus
(register tTree yyP88, register int yyP87)
# else
(yyP88, yyP87)
 register tTree yyP88;
 register int yyP87;
# endif
{
  if (yyP88->Kind == kNoExpr) {
/* line 526 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP88->Kind == kAnExpr) {
  if (yyP88->AnExpr.Expr->Kind == kElementalExpr) {
/* line 527 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 527 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP88->AnExpr.Expr->ElementalExpr.Elemental, yyP87))) goto yyL2;
  {
/* line 527 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP88->AnExpr.Next, yyP87))) goto yyL2;
  }
  }
   return true;
yyL2:;

/* line 528 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 528 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;
  }

  }
  if (yyP88->AnExpr.Expr->Kind == kCountArray) {
  if (yyP88->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP88->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 529 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 529 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP88->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental, yyP87))) goto yyL4;
  {
/* line 529 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP88->AnExpr.Next, yyP87))) goto yyL4;
  }
  }
   return true;
yyL4:;

/* line 530 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 530 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;
  }

  }
  }
  }
/* line 531 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 531 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP88->AnExpr.Next, yyP87))) goto yyL6;
  }
   return true;
yyL6:;

  }
  if (yyP88->Kind == kRange) {
/* line 532 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 532 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP88->Range.Next, yyP87))) goto yyL7;
  }
   return true;
yyL7:;

  }
  if (yyP88->Kind == kSubscript) {
/* line 533 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 533 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP88->Subscript.Next, yyP87))) goto yyL8;
  }
   return true;
yyL8:;

  }
  if (yyP88->Kind == kIdentifier) {
/* line 534 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 534 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Symbol (yyP88->Identifier.Sym) . Depth >= yyP87))) goto yyL9;
  }
   return true;
yyL9:;

  }
  return false;
}

bool CheckIsType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP90, Tree_tKind yyP89)
# else
(yyP90, yyP89)
 register tTree yyP90;
 Tree_tKind yyP89;
# endif
{
/* line 538 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 538 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (yyP90, yyP89)))) goto yyL1;
  }
   return true;
yyL1:;

  return false;
}

bool IsChanOrTimerType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP91)
# else
(yyP91)
 register tTree yyP91;
# endif
{
  if (yyP91->Kind == kArray) {
/* line 542 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 542 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsChanOrTimerType (yyP91->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP91->Kind == kChan) {
/* line 544 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP91->Kind == kTimer) {
/* line 546 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsChanType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP92)
# else
(yyP92)
 register tTree yyP92;
# endif
{
  if (yyP92->Kind == kArray) {
/* line 551 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 551 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsChanType (yyP92->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP92->Kind == kChan) {
/* line 553 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsTimerType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP93)
# else
(yyP93)
 register tTree yyP93;
# endif
{
  if (yyP93->Kind == kArray) {
/* line 559 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 559 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsTimerType (yyP93->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP93->Kind == kTimer) {
/* line 561 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsArrayType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP94)
# else
(yyP94)
 register tTree yyP94;
# endif
{
  if (yyP94->Kind == kArray) {
/* line 567 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

static bool CheckChoicesDiffer
# if defined __STDC__ | defined __cplusplus
(register tTree yyP96, register tTree yyP95)
# else
(yyP96, yyP95)
 register tTree yyP96;
 register tTree yyP95;
# endif
{
  if (yyP96->Kind == kNoExpr) {
/* line 572 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP96->Kind == kAnExpr) {
/* line 573 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 573 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP96->AnExpr.Expr, yyP96->AnExpr.Next, yyP95))) goto yyL2;
  {
/* line 573 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckChoicesDiffer (yyP96->AnExpr.Next, yyP95))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  return false;
}

static bool CheckExprDiffers
# if defined __STDC__ | defined __cplusplus
(register tTree yyP99, register tTree yyP98, register tTree yyP97)
# else
(yyP99, yyP98, yyP97)
 register tTree yyP99;
 register tTree yyP98;
 register tTree yyP97;
# endif
{
  if (yyP98->Kind == kNoExpr) {
  if (yyP97->Kind == kNoChoice) {
/* line 577 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP97->Kind == kAChoice) {
/* line 578 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 578 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP99, yyP97->AChoice.ExprList, yyP97->AChoice.Next))) goto yyL2;
  }
   return true;
yyL2:;

  }
  }
  if (yyP98->Kind == kAnExpr) {
/* line 579 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 579 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP99)))) goto yyL3;
  }
   return true;
yyL3:;

/* line 580 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 580 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP98->AnExpr.Expr)))) goto yyL4;
  {
/* line 580 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP99, yyP98->AnExpr.Next, yyP97))) goto yyL4;
  }
  }
   return true;
yyL4:;

/* line 581 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 581 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP99) != ValConstInt (yyP98->AnExpr.Expr)))) goto yyL5;
  {
/* line 581 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP99, yyP98->AnExpr.Next, yyP97))) goto yyL5;
  }
  }
   return true;
yyL5:;

  }
  return false;
}

bool CheckValidDeclType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP100)
# else
(yyP100)
 register tTree yyP100;
# endif
{
  if (yyP100->Kind == kArray) {
/* line 585 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 585 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP100->Array.Expr)))) goto yyL1;
  {
/* line 585 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP100->Array.Expr) > 0))) goto yyL1;
  {
/* line 585 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValidDeclType (yyP100->Array.Type))) goto yyL1;
  }
  }
  }
   return true;
yyL1:;

/* line 586 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 586 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;
  }

  }
/* line 587 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

}

bool CheckEvalBiOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP102, register tTree yyP101)
# else
(yyP102, yyP101)
 register tTree yyP102;
 register tTree yyP101;
# endif
{
  if (Tree_IsType (yyP101, kInteger)) {
/* line 593 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 593 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckEvalBiIntOp (yyP102))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (Tree_IsType (yyP101, kReal)) {
/* line 595 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 595 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckEvalBiRealOp (yyP102))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (Tree_IsType (yyP102, kRelOp)) {
  if (yyP101->Kind == kByte) {
/* line 597 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP101->Kind == kBool) {
/* line 600 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  }
  if (Tree_IsType (yyP102, kLogOp)) {
  if (yyP101->Kind == kBool) {
/* line 599 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  }
  if (yyP102->Kind == kAfterOp) {
  if (yyP101->Kind == kBool) {
/* line 601 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  }
  return false;
}

static bool CheckEvalBiIntOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP103)
# else
(yyP103)
 register tTree yyP103;
# endif
{
  if (Tree_IsType (yyP103, kMathsOp)) {
/* line 604 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP103, kClockOp)) {
/* line 605 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP103, kRelOp)) {
/* line 606 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP103, kBitOp)) {
/* line 607 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP103, kShiftOp)) {
/* line 608 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP103->Kind == kAfterOp) {
/* line 609 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

static bool CheckEvalBiRealOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP104)
# else
(yyP104)
 register tTree yyP104;
# endif
{
  if (Tree_IsType (yyP104, kMathsOp)) {
/* line 612 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP104, kRelOp)) {
/* line 613 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool CheckEvalUniOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP107, register tTree yyP106, register tTree yyP105)
# else
(yyP107, yyP106, yyP105)
 register tTree yyP107;
 register tTree yyP106;
 register tTree yyP105;
# endif
{
  if (Tree_IsType (yyP107, kInteger)) {
  if (yyP106->Kind == kBitNot) {
/* line 619 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 619 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP105)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP106->Kind == kSubtract) {
/* line 621 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 621 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP105)))) goto yyL3;
  }
   return true;
yyL3:;

  }
  if (yyP106->Kind == kMinus) {
/* line 622 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 622 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP105)))) goto yyL4;
  }
   return true;
yyL4:;

  }
  if (yyP106->Kind == kPlus) {
/* line 623 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 623 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP105)))) goto yyL5;
  }
   return true;
yyL5:;

  }
  if (yyP106->Kind == kAdd) {
/* line 624 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 624 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP105)))) goto yyL6;
  }
   return true;
yyL6:;

  }
  }
  if (yyP107->Kind == kBool) {
  if (yyP106->Kind == kNot) {
/* line 620 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 620 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP105)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  }
  if (Tree_IsType (yyP107, kReal)) {
  if (yyP106->Kind == kSubtract) {
/* line 625 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 625 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP105)))) goto yyL7;
  }
   return true;
yyL7:;

  }
  if (yyP106->Kind == kAdd) {
/* line 626 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 626 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP105)))) goto yyL8;
  }
   return true;
yyL8:;

  }
  }
  if (yyP107->Kind == kArray) {
  if (yyP106->Kind == kSize) {
/* line 627 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 627 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP107->Array.Expr)))) goto yyL9;
  }
   return true;
yyL9:;

  }
  }
  return false;
}

tValue EvalBiExpr
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP112, register tTree yyP111, tValue yyP110, register tTree yyP109, tValue yyP108)
# else
(yyP112, yyP111, yyP110, yyP109, yyP108)
 register tPosition yyP112;
 register tTree yyP111;
 tValue yyP110;
 register tTree yyP109;
 tValue yyP108;
# endif
{
/* line 632 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP111, kInteger)) {
/* line 634 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 634 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = EvalBiIntOp (yyP112, yyP111, yyP110 . Number, yyP109, yyP108 . Number);
  }
   return Res;

  }
  if (yyP111->Kind == kByte) {
/* line 635 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 635 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = EvalBiIntOp (yyP112, yyP111, yyP110 . Number, yyP109, yyP108 . Number);
  }
   return Res;

  }
  if (yyP111->Kind == kBool) {
/* line 636 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 636 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = EvalBiBoolOp (yyP112, yyP111, yyP110 . Number, yyP109, yyP108 . Number);
  }
   return Res;

  }
  if (Tree_IsType (yyP111, kReal)) {
  if (Tree_IsType (yyP109, kMathsOp)) {
/* line 637 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 637 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n = EvalBiRealMathsOp (yyP112, yyP111, yyP110 . RNumber . n, yyP109, yyP108 . RNumber . n);
/* line 637 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = MAX (yyP110 . RNumber . p, yyP108 . RNumber . p);
  }
   return Res;

  }
  if (Tree_IsType (yyP109, kRelOp)) {
/* line 638 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 638 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = EvalBiRealRelOp (yyP112, yyP111, yyP110 . RNumber . n, yyP109, yyP108 . RNumber . n);
  }
   return Res;

  }
  }
 yyAbort ("EvalBiExpr");
}

static tInt EvalBiIntOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP117, register tTree yyP116, tInt yyP115, register tTree yyP114, tInt yyP113)
# else
(yyP117, yyP116, yyP115, yyP114, yyP113)
 register tPosition yyP117;
 register tTree yyP116;
 tInt yyP115;
 register tTree yyP114;
 tInt yyP113;
# endif
{
/* line 642 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tInt res; 

  switch (yyP114->Kind) {
  case kAdd:
/* line 644 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP117, yyP116, yyP115 + yyP113);

  case kSubtract:
/* line 645 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP117, yyP116, yyP115 - yyP113);

  case kMultiply:
/* line 646 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP117, yyP116, yyP115 * yyP113);

  case kDivide:
/* line 648 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 648 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP113 != 0))) goto yyL4;
  }
   return TestIntOVF (yyP117, yyP116, yyP115 / yyP113);
yyL4:;

/* line 649 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP117, mUntyped (), 1);

  case kRem:
/* line 650 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 650 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP113 != 0))) goto yyL6;
  }
   return TestIntOVF (yyP117, yyP116, yyP115 % yyP113);
yyL6:;

/* line 651 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP117, mUntyped (), 1);

  case kEqual:
/* line 653 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP115 == yyP113;

  case kNotEqual:
/* line 654 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP115 != yyP113;

  case kLess:
/* line 655 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP115 < yyP113;

  case kGreater:
/* line 656 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP115 > yyP113;

  case kLessEqual:
/* line 657 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP115 <= yyP113;

  case kGreaterEqual:
/* line 658 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP115 >= yyP113;

  case kBitAnd:
/* line 660 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP115 & yyP113;

  case kBitOr:
/* line 661 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP115 | yyP113;

  case kBitEor:
/* line 662 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 662 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = yyP115^yyP113;
  }
   return res;

  case kShiftOp:
  case kLeftShift:
  case kRightShift:
/* line 664 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 664 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP113 == 0))) goto yyL17;
  }
   return yyP115;
yyL17:;

/* line 665 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 665 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP113 >= EvalIntBits (yyP116)))) goto yyL18;
  {
/* line 665 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Shift by invalid value for Integer size. Result is always zero", xxWarning, yyP117);
  }
  }
   return 0;
yyL18:;

/* line 666 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 666 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP113 < 0))) goto yyL19;
  {
/* line 666 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Shift by invalid (negative) value", xxError, yyP117);
  }
  }
   return 0;
yyL19:;

  break;
  }

  if (yyP114->Kind == kLeftShift) {
/* line 668 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 668 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = (yyP115<<yyP113) & EvalIntMask(yyP116); 
  }
   return res;

  }
  if (yyP114->Kind == kRightShift) {
/* line 669 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 669 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = (yyP115 >> 1) & EvalMostPos(yyP116); 
/* line 669 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP113 == 1))) goto yyL21;
  }
   return res;
yyL21:;

/* line 670 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 670 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = res >>(yyP113-1); 
  }
   return res;

  }
  if (yyP114->Kind == kPlus) {
/* line 672 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return (yyP115 + yyP113) & EvalIntMask (yyP116);

  }
  if (yyP114->Kind == kMinus) {
/* line 673 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return (yyP115 - yyP113) & EvalIntMask (yyP116);

  }
  if (yyP114->Kind == kTimes) {
/* line 674 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return (yyP115 * yyP113) & EvalIntMask (yyP116);

  }
  if (yyP114->Kind == kAfterOp) {
/* line 676 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 676 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = (SignExtendInt(yyP116,(yyP115-yyP113)&EvalIntMask(yyP116)) > 0); 
  }
   return res;

  }
 yyAbort ("EvalBiIntOp");
}

static int EvalBiBoolOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP122, register tTree yyP121, tInt yyP120, register tTree yyP119, tInt yyP118)
# else
(yyP122, yyP121, yyP120, yyP119, yyP118)
 register tPosition yyP122;
 register tTree yyP121;
 tInt yyP120;
 register tTree yyP119;
 tInt yyP118;
# endif
{

  switch (yyP119->Kind) {
  case kEqual:
/* line 683 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP120 == yyP118;

  case kNotEqual:
/* line 684 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP120 != yyP118;

  case kLess:
/* line 685 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP120 < yyP118;

  case kGreater:
/* line 686 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP120 > yyP118;

  case kLessEqual:
/* line 687 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP120 <= yyP118;

  case kGreaterEqual:
/* line 688 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP120 >= yyP118;

  case kAnd:
/* line 690 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP120 && yyP118;

  case kOr:
/* line 691 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP120 || yyP118;

  }

 yyAbort ("EvalBiBoolOp");
}

static double EvalBiRealMathsOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP127, register tTree yyP126, register double yyP125, register tTree yyP124, register double yyP123)
# else
(yyP127, yyP126, yyP125, yyP124, yyP123)
 register tPosition yyP127;
 register tTree yyP126;
 register double yyP125;
 register tTree yyP124;
 register double yyP123;
# endif
{
/* line 696 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 double Res = 0; 
  if (yyP124->Kind == kAdd) {
/* line 698 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP125 + yyP123;

  }
  if (yyP124->Kind == kSubtract) {
/* line 699 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP125 - yyP123;

  }
  if (yyP124->Kind == kMultiply) {
/* line 700 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP125 * yyP123;

  }
  if (yyP124->Kind == kDivide) {
/* line 701 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 701 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP123 != 0))) goto yyL4;
  }
   return yyP125 / yyP123;
yyL4:;

/* line 702 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 702 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 TestIntOVF(yyP127,mUntyped(),1); 
  }
   return Res;

  }
  if (yyP124->Kind == kRem) {
/* line 703 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 703 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP123 != 0))) goto yyL6;
  {
/* line 703 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res = yyP125-(yyP123*(int)(yyP125/yyP123)); 
  }
  }
   return Res;
yyL6:;

/* line 704 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 704 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 TestIntOVF(yyP127,mUntyped(),1); 
  }
   return Res;

  }
 yyAbort ("EvalBiRealMathsOp");
}

static int EvalBiRealRelOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP132, register tTree yyP131, register double yyP130, register tTree yyP129, register double yyP128)
# else
(yyP132, yyP131, yyP130, yyP129, yyP128)
 register tPosition yyP132;
 register tTree yyP131;
 register double yyP130;
 register tTree yyP129;
 register double yyP128;
# endif
{
  if (yyP129->Kind == kEqual) {
/* line 710 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP130 == yyP128;

  }
  if (yyP129->Kind == kNotEqual) {
/* line 711 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP130 != yyP128;

  }
  if (yyP129->Kind == kLess) {
/* line 712 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP130 < yyP128;

  }
  if (yyP129->Kind == kGreater) {
/* line 713 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP130 > yyP128;

  }
  if (yyP129->Kind == kLessEqual) {
/* line 714 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP130 <= yyP128;

  }
  if (yyP129->Kind == kGreaterEqual) {
/* line 715 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP130 >= yyP128;

  }
 yyAbort ("EvalBiRealRelOp");
}

tValue EvalUniExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP135, register tTree yyP134, register tTree yyP133)
# else
(yyP135, yyP134, yyP133)
 register tTree yyP135;
 register tTree yyP134;
 register tTree yyP133;
# endif
{
/* line 722 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP135, kInteger)) {
  if (yyP134->Kind == kBitNot) {
/* line 724 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 724 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ~ ValConstInt (yyP133);
  }
   return Res;

  }
  if (yyP134->Kind == kSubtract) {
/* line 725 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 725 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = - ValConstInt (yyP133);
  }
   return Res;

  }
  if (yyP134->Kind == kMinus) {
/* line 726 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 726 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = - ValConstInt (yyP133);
  }
   return Res;

  }
  if (yyP134->Kind == kPlus) {
/* line 727 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 727 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ValConstInt (yyP133);
  }
   return Res;

  }
  if (yyP134->Kind == kAdd) {
/* line 728 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 728 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ValConstInt (yyP133);
  }
   return Res;

  }
  }
  if (yyP135->Kind == kBool) {
  if (yyP134->Kind == kNot) {
/* line 730 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 730 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ! (ValConstInt (yyP133));
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP135, kReal)) {
  if (yyP134->Kind == kSubtract) {
/* line 731 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 731 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n = - ValConstExpr (yyP133) . RNumber . n;
/* line 731 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = ValConstExpr (yyP133) . RNumber . p;
  }
   return Res;

  }
  if (yyP134->Kind == kAdd) {
/* line 732 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 732 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n = - ValConstExpr (yyP133) . RNumber . n;
/* line 732 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = ValConstExpr (yyP133) . RNumber . p;
  }
   return Res;

  }
  }
  if (yyP135->Kind == kArray) {
  if (yyP134->Kind == kSize) {
/* line 734 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 734 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ValConstInt (yyP135->Array.Expr);
  }
   return Res;

  }
  }
 yyAbort ("EvalUniExpr");
}

bool CheckConstConvert
# if defined __STDC__ | defined __cplusplus
(register tTree yyP136)
# else
(yyP136)
 register tTree yyP136;
# endif
{
  if (Tree_IsType (yyP136, kInteger)) {
/* line 742 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP136->Kind == kBool) {
/* line 743 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP136->Kind == kByte) {
/* line 744 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

tValue EvalConstConvert
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP139, register tTree yyP138, register tTree yyP137)
# else
(yyP139, yyP138, yyP137)
 register tPosition yyP139;
 register tTree yyP138;
 register tTree yyP137;
# endif
{
/* line 748 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
/* line 750 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 750 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = TestIntOVF (yyP139, yyP138, ValConstInt (yyP137));
  }
   return Res;

}

tValue CheckConst
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP143, register tTree yyP142, tInt yyP141, register bool yyP140)
# else
(yyP143, yyP142, yyP141, yyP140)
 register tPosition yyP143;
 register tTree yyP142;
 tInt yyP141;
 register bool yyP140;
# endif
{
/* line 754 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
/* line 756 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 756 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP140 == false))) goto yyL1;
  {
/* line 756 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP143,yyP142,yyP141); 
  }
  }
   return Res;
yyL1:;

/* line 757 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 757 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.Number = SignExtendInt(yyP142,yyP141); 
  }
   return Res;

}

bool CheckConstRoundTrunc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP145, register tTree yyP144)
# else
(yyP145, yyP144)
 register tTree yyP145;
 register tTree yyP144;
# endif
{
  if (Tree_IsType (yyP145, kReal)) {
/* line 763 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP144, kReal)) {
/* line 764 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

tValue EvalConstTrunc
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP149, register tTree yyP148, register tTree yyP147, tValue yyP146)
# else
(yyP149, yyP148, yyP147, yyP146)
 register tPosition yyP149;
 register tTree yyP148;
 register tTree yyP147;
 tValue yyP146;
# endif
{
/* line 783 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP148, kReal)) {
  if (Tree_IsType (yyP147, kReal)) {
/* line 785 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 785 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.RNumber.n = floor(yyP146.RNumber.n); Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n)); 
  }
   return Res;

  }
  if (Tree_IsType (yyP147, kInteger)) {
/* line 787 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 787 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.RNumber.n = (double)yyP146.Number; Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n)); 
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP148, kInteger)) {
  if (Tree_IsType (yyP147, kReal)) {
/* line 786 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 786 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP149,yyP148,(tInt)yyP146.RNumber.n); 
  }
   return Res;

  }
  }
 yyAbort ("EvalConstTrunc");
}

tValue EvalConstRound
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP153, register tTree yyP152, register tTree yyP151, tValue yyP150)
# else
(yyP153, yyP152, yyP151, yyP150)
 register tPosition yyP153;
 register tTree yyP152;
 register tTree yyP151;
 tValue yyP150;
# endif
{
/* line 807 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP152, kReal)) {
  if (Tree_IsType (yyP151, kReal)) {
/* line 809 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 809 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.RNumber.n = floor(yyP150.RNumber.n + 0.5); Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n));; 
  }
   return Res;

  }
  if (Tree_IsType (yyP151, kInteger)) {
/* line 811 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 811 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.RNumber.n = (double)yyP150.Number; Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n));; 
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP152, kInteger)) {
  if (Tree_IsType (yyP151, kReal)) {
/* line 810 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 810 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP153,yyP152,(tInt)(yyP150.RNumber.n + 0.5)); 
  }
   return Res;

  }
  }
 yyAbort ("EvalConstRound");
}

bool CheckConstId
# if defined __STDC__ | defined __cplusplus
(register tTree yyP154)
# else
(yyP154)
 register tTree yyP154;
# endif
{
  if (Tree_IsType (yyP154, kAVal)) {
/* line 818 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 818 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP154->AVal.Expr)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP154->Kind == kATagPro) {
/* line 819 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

tValue EvalConstId
# if defined __STDC__ | defined __cplusplus
(register tTree yyP155)
# else
(yyP155)
 register tTree yyP155;
# endif
{
/* line 823 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (yyP155->Kind == kVal) {
/* line 825 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return ValConstExpr (yyP155->Val.Expr);

  }
  if (yyP155->Kind == kValRetypes) {
/* line 827 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 827 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (yyP155->ValRetypes.Type)))) goto yyL2;
  }
   return ValConstExpr (yyP155->ValRetypes.Expr);
yyL2:;

/* line 829 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 829 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP155->ValRetypes.Expr))))) goto yyL3;
  {
/* line 830 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 
    unsigned char tmp[8];
    tConstArray D = (tConstArray)tmp;
    int SS = CalcTypeSize(ArrayPrimType(ExprType(yyP155->ValRetypes.Expr)));
    int DS = CalcTypeSize(yyP155->ValRetypes.Type);

    RetypeConst(SS,GetConstArray(yyP155->ValRetypes.Expr),DS,D);
    Res = ReadConstArray(yyP155->ValRetypes.Type,D);
  
  }
  }
   return Res;
yyL3:;

/* line 840 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 841 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 
    unsigned char tmp1[8],tmp2[8];
    tConstArray D = (tConstArray)tmp1;
    tConstArray S = (tConstArray)tmp2;
    int SS = CalcTypeSize(ArrayPrimType(ExprType(yyP155->ValRetypes.Expr)));
    int DS = CalcTypeSize(yyP155->ValRetypes.Type);

    WriteConstArray(ExprType(yyP155->ValRetypes.Expr),ValConstExpr(yyP155->ValRetypes.Expr),S);
    RetypeConst(SS,S,DS,D);
    Res = ReadConstArray(yyP155->ValRetypes.Type,D);
  
  }
   return Res;

  }
  if (yyP155->Kind == kATagPro) {
/* line 854 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 854 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = CountTags (yyP155->ATagPro.Sym);
  }
   return Res;

  }
 yyAbort ("EvalConstId");
}

tInt TestIntOVF
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP158, register tTree yyP157, tInt yyP156)
# else
(yyP158, yyP157, yyP156)
 register tPosition yyP158;
 register tTree yyP157;
 tInt yyP156;
# endif
{
  if (yyP157->Kind == kInt64) {
/* line 862 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP156;

  }
  if (yyP157->Kind == kInt) {
/* line 863 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 863 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP156 >= MOSTNEGINT && yyP156 <= MOSTPOSINT))) goto yyL2;
  }
   return yyP156;
yyL2:;

  }
  if (yyP157->Kind == kInt32) {
/* line 864 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 864 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP156 >= MOSTNEGINT32 && yyP156 <= MOSTPOSINT32))) goto yyL3;
  }
   return yyP156;
yyL3:;

  }
  if (yyP157->Kind == kInt16) {
/* line 865 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 865 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP156 >= MOSTNEGINT16 && yyP156 <= MOSTPOSINT16))) goto yyL4;
  }
   return yyP156;
yyL4:;

  }
  if (yyP157->Kind == kByte) {
/* line 866 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 866 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP156 & (~ BYTEMASK)) == 0)) goto yyL5;
  }
   return yyP156;
yyL5:;

  }
  if (yyP157->Kind == kBool) {
/* line 867 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 867 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP156 & (~ BOOLMASK)) == 0)) goto yyL6;
  }
   return yyP156;
yyL6:;

  }
/* line 869 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 869 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP156 = 0;
/* line 869 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Overflow when evaluating constant expression", xxError, yyP158);
  }
   return yyP156;

}

tInt SignExtendInt
# if defined __STDC__ | defined __cplusplus
(register tTree yyP160, tInt yyP159)
# else
(yyP160, yyP159)
 register tTree yyP160;
 tInt yyP159;
# endif
{
  if (yyP160->Kind == kInt64) {
/* line 874 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP159;

  }
  if (yyP160->Kind == kInt) {
/* line 875 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 875 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xx16bitINT)))) goto yyL2;
  {
/* line 875 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP159 & (~ INTMASK)) == 0)) goto yyL2;
  {
/* line 875 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 yyP159 = (tInt)((short)yyP159); 
  }
  }
  }
   return yyP159;
yyL2:;

/* line 876 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 876 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP159 & (~ INTMASK)) == 0)) goto yyL3;
  {
/* line 876 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 yyP159 = ((int)yyP159); 
  }
  }
   return yyP159;
yyL3:;

  }
  if (yyP160->Kind == kInt32) {
/* line 877 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 877 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP159 & (~ INT32MASK)) == 0)) goto yyL4;
  {
/* line 877 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 yyP159 = ((int)yyP159); 
  }
  }
   return yyP159;
yyL4:;

  }
  if (yyP160->Kind == kInt16) {
/* line 878 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 878 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP159 & (~ INT16MASK)) == 0)) goto yyL5;
  {
/* line 878 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 yyP159 = ((short)yyP159); 
  }
  }
   return yyP159;
yyL5:;

  }
  if (yyP160->Kind == kByte) {
/* line 879 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 879 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP159 & (~ BYTEMASK)) == 0)) goto yyL6;
  }
   return yyP159;
yyL6:;

  }
  if (yyP160->Kind == kBool) {
/* line 880 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 880 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP159 & (~ BOOLMASK)) == 0)) goto yyL7;
  }
   return yyP159;
yyL7:;

  }
/* line 882 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP159;

}

static int CountTags
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP161)
# else
(yyP161)
 tSymbol yyP161;
# endif
{
/* line 887 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 887 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! Tree_IsType (SymbolKind (yyP161 - 1), kATagPro)))) goto yyL1;
  }
   return 0;
yyL1:;

/* line 888 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 1 + CountTags (yyP161 - 1);

}

static tInt EvalIntBits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP162)
# else
(yyP162)
 register tTree yyP162;
# endif
{
  if (yyP162->Kind == kInt) {
/* line 893 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 32;

  }
  if (yyP162->Kind == kInt16) {
/* line 894 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 16;

  }
  if (yyP162->Kind == kInt32) {
/* line 895 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 32;

  }
  if (yyP162->Kind == kInt64) {
/* line 896 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 64;

  }
 yyAbort ("EvalIntBits");
}

static tInt EvalIntMask
# if defined __STDC__ | defined __cplusplus
(register tTree yyP163)
# else
(yyP163)
 register tTree yyP163;
# endif
{
  if (yyP163->Kind == kInt) {
/* line 900 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return INTMASK;

  }
  if (yyP163->Kind == kInt16) {
/* line 901 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return INT16MASK;

  }
  if (yyP163->Kind == kInt32) {
/* line 902 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return INT32MASK;

  }
  if (yyP163->Kind == kInt64) {
/* line 903 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return INT64MASK;

  }
 yyAbort ("EvalIntMask");
}

tInt EvalMostPos
# if defined __STDC__ | defined __cplusplus
(register tTree yyP164)
# else
(yyP164)
 register tTree yyP164;
# endif
{
  if (yyP164->Kind == kInt) {
/* line 907 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTPOSINT;

  }
  if (yyP164->Kind == kInt16) {
/* line 908 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTPOSINT16;

  }
  if (yyP164->Kind == kInt32) {
/* line 909 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTPOSINT32;

  }
  if (yyP164->Kind == kInt64) {
/* line 910 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTPOSINT64;

  }
 yyAbort ("EvalMostPos");
}

tInt EvalMostNeg
# if defined __STDC__ | defined __cplusplus
(register tTree yyP165)
# else
(yyP165)
 register tTree yyP165;
# endif
{
  if (yyP165->Kind == kInt) {
/* line 914 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTNEGINT;

  }
  if (yyP165->Kind == kInt16) {
/* line 915 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTNEGINT16;

  }
  if (yyP165->Kind == kInt32) {
/* line 916 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTNEGINT32;

  }
  if (yyP165->Kind == kInt64) {
/* line 917 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTNEGINT64;

  }
 yyAbort ("EvalMostNeg");
}

tValue EvalConstSubscript
# if defined __STDC__ | defined __cplusplus
(register tTree yyP168, register int yyP167, tConstArray yyP166)
# else
(yyP168, yyP167, yyP166)
 register tTree yyP168;
 register int yyP167;
 tConstArray yyP166;
# endif
{
/* line 922 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; tTree E; 
  if (yyP168->Kind == kReal32) {
/* line 924 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 924 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n =  ((float *)yyP166)[yyP167] ;
/* line 924 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = 0;
  }
   return Res;

  }
  if (yyP168->Kind == kReal64) {
/* line 925 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 925 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n =  ((double *)yyP166)[yyP167] ;
/* line 925 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = 0;
  }
   return Res;

  }
  if (Tree_IsType (yyP168, kPrimitive)) {
/* line 926 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 927 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      switch(CalcTypeSize(yyP168))
      {
        case 1:  Res.Number = ((unsigned char *)yyP166)[yyP167]; break;
        case 2:  Res.Number = ((short *)yyP166)[yyP167]; break;
        case 4:  Res.Number = ((int *)yyP166)[yyP167]; break;
        case 8:  Res.Number = ((tInt *)yyP166)[yyP167]; break;
      }
    
  }
   return Res;

  }
 yyAbort ("EvalConstSubscript");
}

tConstArray ConstArrayFromString
# if defined __STDC__ | defined __cplusplus
(register tTree yyP170, register tStringRef yyP169)
# else
(yyP170, yyP169)
 register tTree yyP170;
 register tStringRef yyP169;
# endif
{
/* line 941 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tConstArray CA; 
/* line 943 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 943 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   CA = NewConstArray (LengthSt (yyP169));
/* line 944 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 StGetString(yyP169,CA); 
  }
   return CA;

}

tConstArray ConstArrayFromExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP172, register tTree yyP171)
# else
(yyP172, yyP171)
 register tTree yyP172;
 register tTree yyP171;
# endif
{
/* line 948 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tConstArray CA; 
  if (yyP172->Kind == kArray) {
/* line 950 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 950 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   CA = NewConstArray (CalcTypeSize (yyP172));
/* line 950 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   FillConstArray (yyP172->Array.Type, yyP171, CA);
  }
   return CA;

  }
 yyAbort ("ConstArrayFromExprList");
}

tConstArray ConstArrayFromDecl
# if defined __STDC__ | defined __cplusplus
(register tTree yyP174, register tTree yyP173)
# else
(yyP174, yyP173)
 register tTree yyP174;
 register tTree yyP173;
# endif
{
/* line 957 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tConstArray CA; 
  if (yyP173->Kind == kVal) {
  if (yyP173->Val.Expr->Kind == kElementalExpr) {
/* line 959 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 959 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP173->Val.Expr))))) goto yyL1;
  }
   return  yyP173->Val.Expr->ElementalExpr.Elemental->Elemental.CA ;
yyL1:;

  }
  if (Tree_IsType (yyP173->Val.Expr, kStringElement)) {
/* line 960 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 960 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP173->Val.Expr))))) goto yyL2;
  }
   return  yyP173->Val.Expr->StringElement.CA ;
yyL2:;

  }
  }
  if (yyP174->Kind == kArray) {
  if (yyP173->Kind == kValRetypes) {
  if (yyP173->ValRetypes.Expr->Kind == kElementalExpr) {
/* line 962 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 962 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP173->ValRetypes.Expr))))) goto yyL3;
  {
/* line 963 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      { tConstArray S,D;
        int SS = CalcTypeSize(ArrayPrimType(ExprType(yyP173->ValRetypes.Expr)));
        int DS = CalcTypeSize(ArrayPrimType(yyP174));
        int sz = CalcTypeSize(yyP174);
        int psz = CalcTypeSize(ArrayPrimType(yyP174));
        int count = sz/psz;

        CA = NewConstArray(sz);
        S = GetConstArray(yyP173->ValRetypes.Expr);
        D = CA;

        while(count-- > 0)
        {
          RetypeConst(SS,S,DS,D);
          D += DS; S += DS;
        }
      }
    
  }
  }
   return CA;
yyL3:;

  }
/* line 984 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 985 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      { tConstArray S,D;
        int SS = CalcTypeSize(ExprType(yyP173->ValRetypes.Expr));
        int DS = CalcTypeSize(ArrayPrimType(yyP174));

        CA = NewConstArray(CalcTypeSize(yyP174));
        S = CA; D = CA;
        WriteConstArray(ExprType(yyP173->ValRetypes.Expr),ValConstExpr(yyP173->ValRetypes.Expr),CA);
        RetypeConst(SS,S,DS,D);
      }
    
  }
   return CA;

  }
  }
/* line 998 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 998 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyWrite ("ConstArrayFromDecl-");
/* line 998 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   WriteTreeNode (yyf, yyP173);
  }
   return 0;

}

static void FillConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP177, register tTree yyP176, tConstArray yyP175)
# else
(yyP177, yyP176, yyP175)
 register tTree yyP177;
 register tTree yyP176;
 tConstArray yyP175;
# endif
{
  if (yyP177->Kind == kArray) {
  if (yyP176->Kind == kAnExpr) {
  if (yyP176->AnExpr.Expr->Kind == kElementalExpr) {
/* line 1002 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1003 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      int sz=CalcTypeSize(yyP177);

      memcpy(yyP175,yyP176->AnExpr.Expr->ElementalExpr.Elemental->Elemental.CA,sz);
      FillConstArray(yyP177,yyP176->AnExpr.Next,yyP175+sz);
    
  }
   return;

  }
  if (Tree_IsType (yyP176->AnExpr.Expr, kStringElement)) {
/* line 1011 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1012 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      int sz=CalcTypeSize(yyP177);

      memcpy(yyP175,yyP176->AnExpr.Expr->StringElement.CA,sz);
      FillConstArray(yyP177,yyP176->AnExpr.Next,yyP175+sz);
    
  }
   return;

  }
  }
  }
  if (Tree_IsType (yyP177, kPrimitive)) {
  if (yyP176->Kind == kAnExpr) {
/* line 1020 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1021 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      WriteConstArray(yyP177,ValConstExpr(yyP176->AnExpr.Expr),yyP175);
      FillConstArray(yyP177,yyP176->AnExpr.Next,yyP175+CalcTypeSize(yyP177));
    
  }
   return;

  }
  }
;
}

tConstArray RangeConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP180, tConstArray yyP179, register int yyP178)
# else
(yyP180, yyP179, yyP178)
 register tTree yyP180;
 tConstArray yyP179;
 register int yyP178;
# endif
{
  if (yyP180->Kind == kArray) {
/* line 1029 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1029 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP179 = yyP179 +  (yyP178*CalcTypeSize(yyP180->Array.Type));
/* line 1030 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */


    
  }
   return yyP179;

  }
 yyAbort ("RangeConstArray");
}

tConstArray SubscriptConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP183, tConstArray yyP182, register int yyP181)
# else
(yyP183, yyP182, yyP181)
 register tTree yyP183;
 tConstArray yyP182;
 register int yyP181;
# endif
{
/* line 1038 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1038 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP182 = yyP182 + (yyP181*CalcTypeSize(yyP183));
/* line 1039 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */


    
  }
   return yyP182;

}

static tConstArray GetConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree EX)
# else
(EX)
 register tTree EX;
# endif
{
  if (EX->Kind == kElementalExpr) {
/* line 1047 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1047 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (EX))))) goto yyL1;
  }
   return EX->ElementalExpr.Elemental -> Elemental . CA;
yyL1:;

  }
  if (Tree_IsType (EX, kStringElement)) {
/* line 1048 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1048 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (EX))))) goto yyL2;
  }
   return EX -> StringElement . CA;
yyL2:;

  }
/* line 1049 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1049 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Error in ExprConstArray()", xxFatal, EX->Expr.Pos);
  }
   return (tConstArray)NULL;

}

tValue ReadConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP185, tConstArray yyP184)
# else
(yyP185, yyP184)
 register tTree yyP185;
 tConstArray yyP184;
# endif
{
/* line 1053 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue V; 

  switch (yyP185->Kind) {
  case kByte:
/* line 1055 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1055 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((unsigned char *)yyP184); 
  }
   return V;

  case kBool:
/* line 1056 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1056 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((unsigned char *)yyP184); 
  }
   return V;

  case kInt:
/* line 1058 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1058 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xx16bitINT)))) goto yyL3;
  {
/* line 1058 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((short *)yyP184); 
  }
  }
   return V;
yyL3:;

/* line 1061 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1061 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((int *)yyP184) ; 
  }
   return V;

  case kInt16:
/* line 1059 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1059 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((short *)yyP184); 
  }
   return V;

  case kInt32:
/* line 1062 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1062 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((int *)yyP184) ; 
  }
   return V;

  case kReal32:
/* line 1063 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1063 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.RNumber.n=  *((float *)yyP184); V.RNumber.p = 7; 
  }
   return V;

  case kInt64:
/* line 1065 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1065 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((tInt *)yyP184) ; 
  }
   return V;

  case kReal64:
/* line 1066 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1066 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.RNumber.n= *((double *)yyP184); V.RNumber.p = 14; 
  }
   return V;

  }

 yyAbort ("ReadConstArray");
}

void WriteConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP188, tValue yyP187, tConstArray yyP186)
# else
(yyP188, yyP187, yyP186)
 register tTree yyP188;
 tValue yyP187;
 tConstArray yyP186;
# endif
{

  switch (yyP188->Kind) {
  case kByte:
/* line 1070 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1070 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((char *)yyP186) = yyP187.Number; 
  }
   return;

  case kBool:
/* line 1071 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1071 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((char *)yyP186) = yyP187.Number; 
  }
   return;

  case kInt:
/* line 1073 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1073 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xx16bitINT)))) goto yyL3;
  {
/* line 1073 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((short *)yyP186) = yyP187.Number; 
  }
  }
   return;
yyL3:;

/* line 1076 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1076 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((int *)yyP186) = yyP187.Number; 
  }
   return;

  case kInt16:
/* line 1074 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1074 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((short *)yyP186) = yyP187.Number; 
  }
   return;

  case kInt32:
/* line 1077 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1077 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((int *)yyP186) = yyP187.Number; 
  }
   return;

  case kReal32:
/* line 1078 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1078 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 *((float *)yyP186) = yyP187.RNumber.n; 
  }
   return;

  case kInt64:
/* line 1080 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1080 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((tInt *)yyP186) = yyP187.Number; 
  }
   return;

  case kReal64:
/* line 1081 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1081 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 *((double *)yyP186) = yyP187.RNumber.n; 
  }
   return;

  }

;
}

static tConstArray NewConstArray
# if defined __STDC__ | defined __cplusplus
(register int yyP189)
# else
(yyP189)
 register int yyP189;
# endif
{
/* line 1086 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tConstArray CA; 
/* line 1088 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1089 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

    if (!(CA = (tConstArray)malloc(yyP189))) Message("Out of heap allocating array",xxError,NoPosition);
  
  }
   return CA;

}

static void RangeCheckSubscript
# if defined __STDC__ | defined __cplusplus
(register tTree yyP191, register tTree yyP190)
# else
(yyP191, yyP190)
 register tTree yyP191;
 register tTree yyP190;
# endif
{
/* line 1097 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1097 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP191)))) goto yyL1;
  {
/* line 1097 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP190)))) goto yyL1;
  {
/* line 1097 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP191) >= 0))) goto yyL1;
  {
/* line 1097 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP191) < ValConstInt (yyP190)))) goto yyL1;
  }
  }
  }
  }
   return;
yyL1:;

/* line 1098 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1098 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP191)))) goto yyL2;
  {
/* line 1098 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP190)))) goto yyL2;
  {
/* line 1098 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Subscript out of range", xxError, yyP191->Expr.Pos);
  }
  }
  }
   return;
yyL2:;

/* line 1099 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1099 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP191)))) goto yyL3;
  {
/* line 1099 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP191) >= 0))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 1100 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1100 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP191)))) goto yyL4;
  {
/* line 1100 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Subscript out of range", xxError, yyP191->Expr.Pos);
  }
  }
   return;
yyL4:;

/* line 1101 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

;
}

static void RangeCheckSlice
# if defined __STDC__ | defined __cplusplus
(register tTree yyP194, register tTree yyP193, register tTree yyP192)
# else
(yyP194, yyP193, yyP192)
 register tTree yyP194;
 register tTree yyP193;
 register tTree yyP192;
# endif
{
/* line 1105 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1105 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP194)))) goto yyL1;
  {
/* line 1105 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP193)))) goto yyL1;
  {
/* line 1105 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP192)))) goto yyL1;
  {
/* line 1106 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP194) >= 0))) goto yyL1;
  {
/* line 1106 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP193) >= 0))) goto yyL1;
  {
/* line 1106 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (((ValConstInt (yyP194) + ValConstInt (yyP193)) <= ValConstInt (yyP192)))) goto yyL1;
  }
  }
  }
  }
  }
  }
   return;
yyL1:;

/* line 1107 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1107 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP194)))) goto yyL2;
  {
/* line 1107 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP193)))) goto yyL2;
  {
/* line 1107 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP192)))) goto yyL2;
  {
/* line 1108 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Array slice exceeds array bounds", xxError, yyP194->Expr.Pos);
  }
  }
  }
  }
   return;
yyL2:;

/* line 1109 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1109 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   RangeCheckSubscript (yyP194, yyP192);
  }
   return;

;
}

tTree MakeConstInt
# if defined __STDC__ | defined __cplusplus
(register int yyP196, register tPosition yyP195)
# else
(yyP196, yyP195)
 register int yyP196;
 register tPosition yyP195;
# endif
{
/* line 1114 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tTree T; tValue TMP; 
/* line 1115 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1115 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TMP . Number = yyP196;
/* line 1115 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   T = mConst (yyP195, TMP, mInt ());
/* line 1115 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ExprType (T) = mInt ();
/* line 1115 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ConstFlag (T -> Expr) = true;
/* line 1115 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ValConstInt (T) = yyP196;
  }
   return T;

}

static tTree MakeAddExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP198, register tTree yyP197)
# else
(yyP198, yyP197)
 register tTree yyP198;
 register tTree yyP197;
# endif
{
/* line 1118 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tTree T; 
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP198)))) goto yyL1;
  {
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP197)))) goto yyL1;
  {
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   T = mBinary (yyP198->Expr.Pos, yyP198, yyP197, mAdd ());
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ExprType (T) = ExprType (yyP198);
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ConstFlag (T -> Expr) = true;
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ValConstInt (T) = ValConstInt (yyP198) + ValConstInt (yyP197);
  }
  }
  }
   return T;
yyL1:;

/* line 1120 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1120 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   T = mBinary (yyP198->Expr.Pos, yyP198, yyP197, mAdd ());
/* line 1120 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ExprType (T) = ExprType (yyP198);
/* line 1120 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ConstFlag (T -> Expr) = false;
  }
   return T;

}

static int CountList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP200, register tTree yyP199)
# else
(yyP200, yyP199)
 register tTree yyP200;
 register tTree yyP199;
# endif
{
  if (yyP200->Kind == kAnExpr) {
/* line 1125 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1125 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP199, ExprType (yyP200->AnExpr.Expr)))) goto yyL1;
  }
   return CountList (yyP200->AnExpr.Next, yyP199) + 1;
yyL1:;

/* line 1127 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1127 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in expression list", xxError, yyP200->AnExpr.Expr->Expr.Pos);
  }
   return CountList (yyP200->AnExpr.Next, yyP199) + 1;

  }
  if (yyP200->Kind == kNoExpr) {
/* line 1126 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 1;

  }
 yyAbort ("CountList");
}

static int SizeType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP203, register tPosition yyP202, register bool yyP201, register tTree * yyP204)
# else
(yyP203, yyP202, yyP201, yyP204)
 register tTree yyP203;
 register tPosition yyP202;
 register bool yyP201;
 register tTree * yyP204;
# endif
{
/* line 1131 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 int V; 

  switch (yyP203->Kind) {
  case kArray:
  if (yyP203->Array.Expr->Kind == kUnBound) {
 {
  tTree yyV1;
  if (equalbool (yyP201, true)) {
/* line 1132 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1133 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   V = SizeType (yyP203->Array.Type, yyP202, true, & yyV1);
/* line 1134 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (yyV1!=NoTree) Message("Too many unspecified dimensions to retype",xxError,yyP202); 
  }
   * yyP204 = yyP203;
  {
   return V;
  }

  }
 }
  }
/* line 1136 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  {
/* line 1136 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP203->Array.Expr)))) goto yyL2;
  {
/* line 1136 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SizeType (yyP203->Array.Type, yyP202, yyP201, & yyV1))) goto yyL2;
  }
  }
   * yyP204 = yyV1;
  {
   return - 1;
  }
 }
yyL2:;

/* line 1137 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  {
/* line 1137 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   V = SizeType (yyP203->Array.Type, yyP202, yyP201, & yyV1);
  }
   * yyP204 = yyV1;
  {
   return (V<0)?V:V*ValConstInt(yyP203->Array.Expr);
  }
 }

  case kInt:
/* line 1138 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP204 = NULL;
   return IS_Mode(xx16bitINT) ? 2 : 4 ;

  case kInt16:
/* line 1139 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP204 = NULL;
   return 2;

  case kInt32:
/* line 1140 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP204 = NULL;
   return 4;

  case kInt64:
/* line 1141 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP204 = NULL;
   return 8;

  case kReal32:
/* line 1142 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP204 = NULL;
   return 4;

  case kReal64:
/* line 1143 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP204 = NULL;
   return 8;

  case kBool:
/* line 1144 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP204 = NULL;
   return 1;

  case kByte:
/* line 1145 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP204 = NULL;
   return 1;

  case kChan:
/* line 1146 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP204 = NULL;
   return sizeof(void*);

  }

/* line 1147 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1147 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cannot perform retype involving this base type", xxError, yyP202);
  }
   * yyP204 = NULL;
   return - 1;

}

int CalcTypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP205)
# else
(yyP205)
 register tTree yyP205;
# endif
{

  switch (yyP205->Kind) {
  case kArray:
/* line 1151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP205->Array.Expr)))) goto yyL1;
  }
   return  ValConstInt(yyP205->Array.Expr) * CalcTypeSize(yyP205->Array.Type) ;
yyL1:;

  break;
  case kInt:
/* line 1152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return IS_Mode(xx16bitINT) ? 2 : 4 ;

  case kInt16:
/* line 1153 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 2;

  case kInt32:
/* line 1154 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 4;

  case kInt64:
/* line 1155 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 8;

  case kReal32:
/* line 1156 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 4;

  case kReal64:
/* line 1157 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 8;

  case kBool:
/* line 1158 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 1;

  case kByte:
/* line 1159 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 1;

  }

/* line 1160 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1160 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Internal Error - ConstArray Evaluation", xxError, NoPosition);
  }
   return - 1;

}

tTree ReduceElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP207, register tTree yyP206)
# else
(yyP207, yyP206)
 register tTree yyP207;
 register tTree yyP206;
# endif
{
  if (yyP207->Kind == kIdentifier) {
/* line 1168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP207;

  }
  if (yyP207->Kind == kRange) {
  if (yyP206 == NULL) {
/* line 1169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP207->Range.Next = ReduceElement (yyP207->Range.Next, yyP207);
  }
   return yyP207;

  }
  if (yyP206->Kind == kRange) {
/* line 1170 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1170 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP206->Range.From = MakeAddExpr (yyP206->Range.From, yyP207->Range.From);
  }
   return ReduceElement (yyP207->Range.Next, yyP206);

  }
  if (yyP206->Kind == kSubscript) {
/* line 1171 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1171 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP206->Subscript.Expr = MakeAddExpr (yyP206->Subscript.Expr, yyP207->Range.From);
  }
   return ReduceElement (yyP207->Range.Next, yyP206);

  }
  }
  if (yyP207->Kind == kSubscript) {
/* line 1172 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1172 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP207->Subscript.Next = ReduceElement (yyP207->Subscript.Next, yyP207);
  }
   return yyP207;

  }
 yyAbort ("ReduceElement");
}

tTree ReduceElemental
# if defined __STDC__ | defined __cplusplus
(register tTree yyP208)
# else
(yyP208)
 register tTree yyP208;
# endif
{
  if (Tree_IsType (yyP208, kElement)) {
/* line 1177 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return ReduceElement (yyP208, NoTree);

  }
  if (Tree_IsType (yyP208, kTableElement)) {
/* line 1179 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP208;

  }
 yyAbort ("ReduceElemental");
}

tTree ArrayPrimType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP209)
# else
(yyP209)
 register tTree yyP209;
# endif
{
  if (yyP209->Kind == kArray) {
/* line 1185 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return ArrayPrimType (yyP209->Array.Type);

  }
  if (Tree_IsType (yyP209, kPrimitive)) {
/* line 1186 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP209;

  }
 yyAbort ("ArrayPrimType");
}

void MarkNonAtomicIf
# if defined __STDC__ | defined __cplusplus
(register tTree IF)
# else
(IF)
 register tTree IF;
# endif
{
  if (IF->Kind == kIf) {
/* line 1194 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1195 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
IF->If.ATOMIC = false; 
/* line 1196 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->If.ChoiceList);
  }
   return;

  }
  if (IF->Kind == kIfRep) {
/* line 1199 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1200 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
IF->IfRep.ATOMIC = false; 
/* line 1201 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->IfRep.ChoiceList);
  }
   return;

  }
;
}

static void MarkNonAtomicIfList
# if defined __STDC__ | defined __cplusplus
(register tTree IF)
# else
(IF)
 register tTree IF;
# endif
{
  if (IF->Kind == kAChoice) {
/* line 1206 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1207 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
IF->AChoice.ATOMIC = false; 
/* line 1208 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->AChoice.Next);
  }
   return;

  }
  if (IF->Kind == kANewIf) {
/* line 1211 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1212 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
IF->ANewIf.ATOMIC = false; 
/* line 1213 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIf (IF->ANewIf.IfType);
/* line 1214 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->ANewIf.Next);
  }
   return;

  }
  if (IF->Kind == kNoChoice) {
/* line 1217 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
;
}

void BeginTypeChk ()
{
}

void CloseTypeChk ()
{
}
